module io.file {
   type(Filename) =
      kernel:file_type(Filename).

   open_read(Filename, Stream) :-
      kernel:io_open_read(Filename, X),
      io.stream:of_kernel_in(X, Stream).

   read(Filename, F) :-
      open_read(Filename, Stream),
      F:do(Stream),
      Stream:close.

   open_write(Filename, Stream) :-
      kernel:io_open_write(Filename, X),
      io.stream:of_kernel_out(X, Stream).

   write(Filename, F) :-
      open_write(Filename, Stream),
      F:do(Stream),
      Stream:close.

   delete(Filename) :-
      kernel:file_delete(Filename).
}
