emop_call(M, _P, Pos) :-
   var(M),
   throw(error(instanciation_error(emop_call / 3), Pos)).
%emop_call(_, P, Pos) :-
%   functor(P, F, N),
%   print(stderr, F / N - Pos),
%   nl(stderr),
%   fail.
emop_call('$module'(_Id, List, _), P, Pos) :-
   !,
   emop_call_multi(List, P, Pos).
emop_call(Atom, P, Pos) :-
   g_read(Atom, M),
   !,
   Cut = '$cut',
   emop_call_to(M, P, Pos, Cut).

emop_call_multi([M], P, Pos) :-
   !,
   !,
   Cut = '$cut',
   emop_call_to(M, P, Pos, Cut).
emop_call_multi(List, P, Pos) :-
   emop_call_filter(List, P, List0),
   !,
   (
      List0 = []
   ->
      functor(P, F, N),
      throw(error(unknown_predicate(F / N), Pos))
   ;
      !,
      Cut = '$cut',
      emop_call_list(List0, P, Pos, Cut)
   ).
emop_call_multi(Invalid, _P, _Pos) :-
   throw(invalid(Invalid)).
   
emop_call(M, P) :-
   emop_call(M, P, dummy).

emop_call_list([M | Tail], P, Pos, Cut) :-
   (
      emop_call_list(Tail, P, Pos, Cut)
   ;
      emop_call_to(M, P, Pos, Cut)
   ).

emop_call_filter([], _, []).
emop_call_filter([H | T], P, List) :-
   functor(H, M, _),
   atom_concat(M, '$has_predicate', A),
   functor(C, A, 1),
   setarg(1, C, P),
   (
      call(C)
   ->
      List = [H | Tail]
   ;
      List = Tail
   ),
   emop_call_filter(T, P, Tail).

portray('$module'(Id, List, Terms)) :-
   M = '$module'(Id, List, Terms),
   get_print_stream(S),
   catch(
      (
         emop_call('io.stream', of_kernel_out(S, Ms), 'portray'),
         emop_call(M, 'portray'(Ms), 'portray')
      ),
      _,
      format(S, '<module[~d]>', [Id])
   ).
':-'('dynamic'('/'('<module>:control.iter$dynamic', 4))).
':-'('dynamic'('/'('<module>:control.iter@0$dynamic', 4))).
':-'('<module>:control.iter'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:control.iter:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:control.iter'('findall'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:control.iter:findall'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:control.iter'('fold'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:control.iter:fold'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:control.iter'('foreach'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:control.iter:foreach'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:control.iter'(__36t, __36env, __36pos, __36CutLevel), '<module>:control.iter$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:control.iter$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:control.iter$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:control.iter$has_predicate'('findall'(_____2, _____1)), 'true').
':-'('<module>:control.iter$has_predicate'('fold'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:control.iter$has_predicate'('foreach'(_____2, _____1)), 'true').
':-'('<module>:control.iter:$sgn'(__36sgn, 'env', __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/control/iter.mpl',0,0,0)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/control/iter.mpl',21,0,0)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','('true', '<module>:control.iter:atom_fresh_[3383]'(_atom__fresh___913384_93, __36Pb, __36Pe)), '<module>:control.iter:atom_fresh_[3385]'(_atom__fresh___913386_93, __36Pb, __36Pe)), '<module>:control.iter:atom_fresh_[3387]'(_atom__fresh___913388_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913388_93, '.'(_atom__fresh___913386_93, '.'(_atom__fresh___913384_93, '[]'))))))))).
':-'('<module>:control.iter:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:control.iter:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:control.iter:atom_fresh_[3383]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(foreach, 2, predicate, suspended([var('M1'),var('M2')],[call(atom('data.list'),iter,[none,var('M2')])]), __36pos))).
':-'('<module>:control.iter:atom_fresh_[3385]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fold, 4, predicate, suspended([var('V'),var('G'),var('M'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:control.iter:atom_fresh_[3387]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(findall, 2, predicate, suspended([var('M'),var('L')],[call(atom(kernel),iter_findall,[var('M'),var('L')])]), __36pos))).
':-'('<module>:control.iter:findall'(_M, _L, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___5)), '<module>:kernel:iter_findall$direct'(_M, _L, ___5))).
':-'('<module>:control.iter:findall$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:control.iter:findall'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:control.iter:fold'(_V, _G, _M, ___14, 'env', __36CutLevel), ','(','('true', ';'('->'('var'(___6), ','('g_inc'('$module_count', ___7), '='(___6, '$module'(___7, '.'('<module>:control.iter@0'('env'(___6, _M)), '[]'), '.'(___6, '[]'))))), ','('='(___6, '$module'(___7, ___8, _)), ','('='('.'(___9, ___10), ___8), ','('setarg'(1, ___8, '<module>:control.iter@0'('env'(___6, _M))), 'setarg'(2, ___8, '.'(___9, ___10))))))), ','(','('g_read'('control.iter', '<module>:control.iter'(___13)), '<module>:control.iter:findall$direct'(_G, ___12, ___13)), 'emop_call'(___6, 'do'(___12, _V, ___14), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/control/iter.mpl\", line 8, from character 5 to 7')))).
':-'('<module>:control.iter:fold$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:control.iter:fold'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:control.iter:foreach'(_M1, _M2, 'env', __36CutLevel), ','(','('g_read'('control.iter', '<module>:control.iter'(___17)), '<module>:control.iter:findall$direct'(_M1, ___16, ___17)), ','('g_read'('data.list', '<module>:data.list'(___18)), '<module>:data.list:iter$direct'(___16, _M2, ___18)))).
':-'('<module>:control.iter:foreach$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:control.iter:foreach'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:control.iter@0'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:control.iter@0:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:control.iter@0'('do'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:control.iter@0:do'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:control.iter@0'(__36t, __36env, __36pos, __36CutLevel), '<module>:control.iter@0$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:control.iter@0$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:control.iter@0$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:control.iter@0$has_predicate'('do'(_____3, _____2, _____1)), 'true').
':-'('<module>:control.iter@0:$sgn'(__36sgn, 'env'(___11, _M), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/control/iter.mpl',95,4,76)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/control/iter.mpl',107,4,76)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:control.iter@0:atom_fresh_[3389]'(_atom__fresh___913390_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913390_93, '[]'))))))).
':-'('<module>:control.iter@0:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:control.iter@0:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:control.iter@0:atom_fresh_[3389]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 3, predicate, suspended([none,var('V'),var('V')],[call(scope,true,[])]), __36pos))).
':-'('<module>:control.iter@0:do'('[]', _V, _V, 'env'(___11, _M), __36CutLevel), 'true').
':-'('<module>:control.iter@0:do'('.'(_H, _T), _V, ___22, 'env'(___11, _M), __36CutLevel), ','('emop_call'(_M, 'do'(_V, _H, ___21), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/control/iter.mpl\", line 7, from character 31 to 33'), 'emop_call'(___11, 'do'(_T, ___21, ___22), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/control/iter.mpl\", line 7, from character 23 to 25'))).
':-'('<module>:control.iter@0:do$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:control.iter@0:do'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('control.iter@init', ','('true', 'g_link'('control.iter', '<module>:control.iter'('env')))).
':-'('dynamic'('/'('<module>:data.atom$dynamic', 4))).
':-'('dynamic'('/'('<module>:data.atom@1$dynamic', 4))).
':-'('dynamic'('/'('<module>:data.atom@0$dynamic', 4))).
':-'('<module>:data.atom'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.atom:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.atom'('=>'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.atom:=>'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.atom'('check'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.atom:check'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.atom'('length'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.atom:length'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.atom'('concat'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.atom:concat'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.atom'('new'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.atom:new'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.atom'('new_backtrackable'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.atom:new_backtrackable'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.atom'('string'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.atom:string'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.atom'('stream'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.atom:stream'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.atom'('sub'(_____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.atom:sub'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.atom'('suffix'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.atom:suffix'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.atom'('remove_suffix'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.atom:remove_suffix'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.atom'('format'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.atom:format'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.atom'('join'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.atom:join'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.atom'('split'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.atom:split'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.atom'('split_from'(_____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.atom:split_from'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.atom'('split_at_delim_left'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.atom:split_at_delim_left'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.atom'('split_at_delim_left_from'(_____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.atom:split_at_delim_left_from'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.atom'('split_at_delim_right'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.atom:split_at_delim_right'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.atom'('split_at_delim_right_from'(_____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.atom:split_at_delim_right_from'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.atom'('subst'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.atom:subst'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.atom'('number'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.atom:number'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.atom'(__36t, __36env, __36pos, __36CutLevel), '<module>:data.atom$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:data.atom$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:data.atom$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:data.atom$has_predicate'('=>'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.atom$has_predicate'('check'(_____1)), 'true').
':-'('<module>:data.atom$has_predicate'('length'(_____2, _____1)), 'true').
':-'('<module>:data.atom$has_predicate'('concat'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.atom$has_predicate'('new'(_____1)), 'true').
':-'('<module>:data.atom$has_predicate'('new_backtrackable'(_____1)), 'true').
':-'('<module>:data.atom$has_predicate'('string'(_____2, _____1)), 'true').
':-'('<module>:data.atom$has_predicate'('stream'(_____2, _____1)), 'true').
':-'('<module>:data.atom$has_predicate'('sub'(_____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:data.atom$has_predicate'('suffix'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.atom$has_predicate'('remove_suffix'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.atom$has_predicate'('format'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.atom$has_predicate'('join'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.atom$has_predicate'('split'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.atom$has_predicate'('split_from'(_____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:data.atom$has_predicate'('split_at_delim_left'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:data.atom$has_predicate'('split_at_delim_left_from'(_____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:data.atom$has_predicate'('split_at_delim_right'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:data.atom$has_predicate'('split_at_delim_right_from'(_____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:data.atom$has_predicate'('subst'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.atom$has_predicate'('number'(_____2, _____1)), 'true').
':-'('<module>:data.atom:$sgn'(__36sgn, 'env', __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/atom.mpl',0,0,0)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/atom.mpl',20,0,0)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','('true', '<module>:data.atom:atom_fresh_[1598]'(_atom__fresh___911599_93, __36Pb, __36Pe)), '<module>:data.atom:atom_fresh_[1600]'(_atom__fresh___911601_93, __36Pb, __36Pe)), '<module>:data.atom:atom_fresh_[1602]'(_atom__fresh___911603_93, __36Pb, __36Pe)), '<module>:data.atom:atom_fresh_[1604]'(_atom__fresh___911605_93, __36Pb, __36Pe)), '<module>:data.atom:atom_fresh_[1606]'(_atom__fresh___911607_93, __36Pb, __36Pe)), '<module>:data.atom:atom_fresh_[1608]'(_atom__fresh___911609_93, __36Pb, __36Pe)), '<module>:data.atom:atom_fresh_[1610]'(_atom__fresh___911611_93, __36Pb, __36Pe)), '<module>:data.atom:atom_fresh_[1612]'(_atom__fresh___911613_93, __36Pb, __36Pe)), '<module>:data.atom:atom_fresh_[1614]'(_atom__fresh___911615_93, __36Pb, __36Pe)), '<module>:data.atom:atom_fresh_[1616]'(_atom__fresh___911617_93, __36Pb, __36Pe)), '<module>:data.atom:atom_fresh_[1618]'(_atom__fresh___911619_93, __36Pb, __36Pe)), '<module>:data.atom:atom_fresh_[1620]'(_atom__fresh___911621_93, __36Pb, __36Pe)), '<module>:data.atom:atom_fresh_[1622]'(_atom__fresh___911623_93, __36Pb, __36Pe)), '<module>:data.atom:atom_fresh_[1624]'(_atom__fresh___911625_93, __36Pb, __36Pe)), '<module>:data.atom:atom_fresh_[1626]'(_atom__fresh___911627_93, __36Pb, __36Pe)), '<module>:data.atom:atom_fresh_[1628]'(_atom__fresh___911629_93, __36Pb, __36Pe)), '<module>:data.atom:atom_fresh_[1630]'(_atom__fresh___911631_93, __36Pb, __36Pe)), '<module>:data.atom:atom_fresh_[1632]'(_atom__fresh___911633_93, __36Pb, __36Pe)), '<module>:data.atom:atom_fresh_[1634]'(_atom__fresh___911635_93, __36Pb, __36Pe)), '<module>:data.atom:atom_fresh_[1636]'(_atom__fresh___911637_93, __36Pb, __36Pe)), '<module>:data.atom:atom_fresh_[1638]'(_atom__fresh___911639_93, __36Pb, __36Pe)), '<module>:data.atom:atom_fresh_[1640]'(_atom__fresh___911641_93, __36Pb, __36Pe)), '<module>:data.atom:atom_fresh_[1642]'(_atom__fresh___911643_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___911643_93, '.'(_atom__fresh___911641_93, '.'(_atom__fresh___911639_93, '.'(_atom__fresh___911637_93, '.'(_atom__fresh___911635_93, '.'(_atom__fresh___911633_93, '.'(_atom__fresh___911631_93, '.'(_atom__fresh___911629_93, '.'(_atom__fresh___911627_93, '.'(_atom__fresh___911625_93, '.'(_atom__fresh___911623_93, '.'(_atom__fresh___911621_93, '.'(_atom__fresh___911619_93, '.'(_atom__fresh___911617_93, '.'(_atom__fresh___911615_93, '.'(_atom__fresh___911613_93, '.'(_atom__fresh___911611_93, '.'(_atom__fresh___911609_93, '.'(_atom__fresh___911607_93, '.'(_atom__fresh___911605_93, '.'(_atom__fresh___911603_93, '.'(_atom__fresh___911601_93, '.'(_atom__fresh___911599_93, '[]'))))))))))))))))))))))))))))).
':-'('<module>:data.atom:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.atom:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.atom:=>'(___4, ___5, ___6, 'env', __36CutLevel), '=..'(___6, '.'('=>', '.'(___4, '.'(___5, '[]'))))).
':-'('<module>:data.atom:=>$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.atom:=>'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.atom:atom_fresh_[1598]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(number, 2, predicate, suspended([var('Atom'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:data.atom:atom_fresh_[1600]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(subst, 3, predicate, '[]', __36pos))).
':-'('<module>:data.atom:atom_fresh_[1602]'(__36s, __36Pb, __36Pe), '='(__36s, 'syntax'('.'('callable'('=>', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('<', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'(':', 'escaped', 'none', __36Pb, __36Pe), '[]'))), __36Pb, __36Pe))).
':-'('<module>:data.atom:atom_fresh_[1604]'(__36s, __36Pb, __36Pe), '='(__36s, 'syntax'('.'('callable'('infix', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('=>', 'escaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe))).
':-'('<module>:data.atom:atom_fresh_[1606]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(split_at_delim_right_from, 5, predicate, '[]', __36pos))).
':-'('<module>:data.atom:atom_fresh_[1608]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(split_at_delim_right, 4, predicate, suspended([var('Atom'),var('Delim'),var('Left'),var('Right')],[call(scope,length,[var('Atom'),var('Length')]),call(scope,split_at_delim_right_from,[none,var('Atom'),var('Delim'),var('Left'),var('Right')])]), __36pos))).
':-'('<module>:data.atom:atom_fresh_[1610]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(split_at_delim_left_from, 5, predicate, '[]', __36pos))).
':-'('<module>:data.atom:atom_fresh_[1612]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(split_at_delim_left, 4, predicate, suspended([var('Atom'),var('Delim'),var('Left'),var('Right')],[call(scope,split_at_delim_left_from,[none,var('Atom'),var('Delim'),var('Left'),var('Right')])]), __36pos))).
':-'('<module>:data.atom:atom_fresh_[1614]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(split_from, 5, predicate, '[]', __36pos))).
':-'('<module>:data.atom:atom_fresh_[1616]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(split, 3, predicate, suspended([var('Atom'),var('Delim'),var('Atoms')],[call(scope,split_from,[none,none,var('Atom'),var('Delim'),var('Atoms')])]), __36pos))).
':-'('<module>:data.atom:atom_fresh_[1618]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(join, 3, predicate, suspended([var('Atoms'),var('Delim'),var('Atom')],[call(atom('data.atom'),string,[var('Delim'),var('DelimStr')]),module('Convert',[symbol(do,2,predicate,suspended([var('Atom'),var('String')],[call(atom('data.atom'),string,[var('Atom'),var('String')])]),file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/atom.mpl',3468,121,3442),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/atom.mpl',3516,122,3471)))]),call(atom('data.list'),join,[none,var('DelimStr'),var('String')]),call(atom('data.string'),atom,[var('String'),var('Atom')])]), __36pos))).
':-'('<module>:data.atom:atom_fresh_[1620]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(format, 3, predicate, suspended([var('Format'),var('Args'),var('Atom')],[call(atom(kernel),atom_format,[var('Format'),var('Args'),var('Atom')])]), __36pos))).
':-'('<module>:data.atom:atom_fresh_[1622]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(remove_suffix, 3, predicate, '[]', __36pos))).
':-'('<module>:data.atom:atom_fresh_[1624]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(suffix, 3, predicate, suspended([var('Atom'),var('Length'),var('Suffix')],[call(scope,sub,[var('Atom'),var('_'),var('Length'),none,var('Suffix')])]), __36pos))).
':-'('<module>:data.atom:atom_fresh_[1626]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(sub, 5, predicate, suspended([var('Atom'),var('Before'),var('Length'),var('After'),var('SubAtom')],[call(atom(kernel),atom_sub,[var('Atom'),var('Before'),var('Length'),var('After'),var('SubAtom')])]), __36pos))).
':-'('<module>:data.atom:atom_fresh_[1628]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(stream, 2, predicate, suspended([var('Atom'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:data.atom:atom_fresh_[1630]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(string, 2, predicate, suspended([var('Atom'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:data.atom:atom_fresh_[1632]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(new_backtrackable, 1, predicate, suspended([var('Atom')],[call(atom(kernel),atom_new_backtrackable,[var('Atom')])]), __36pos))).
':-'('<module>:data.atom:atom_fresh_[1634]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(new, 1, predicate, suspended([var('Atom')],[call(atom(kernel),atom_new,[var('Atom')])]), __36pos))).
':-'('<module>:data.atom:atom_fresh_[1636]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(concat, 3, predicate, suspended([var('A'),var('B'),var('R')],[call(atom(kernel),atom_concat,[var('A'),var('B'),var('R')])]), __36pos))).
':-'('<module>:data.atom:atom_fresh_[1638]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(length, 2, predicate, suspended([var('Atom'),var('Length')],[call(atom(kernel),atom_length,[var('Atom'),var('Length')])]), __36pos))).
':-'('<module>:data.atom:atom_fresh_[1640]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(check, 1, predicate, suspended([var('Atom')],[call(atom(kernel),atom_check,[var('Atom')])]), __36pos))).
':-'('<module>:data.atom:atom_fresh_[1642]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(=>, 3, constructor, none, __36pos))).
':-'('<module>:data.atom:check'(_Atom, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___8)), '<module>:kernel:atom_check$direct'(_Atom, ___8))).
':-'('<module>:data.atom:check$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.atom:check'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.atom:concat'(_A, _B, _R, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___12)), '<module>:kernel:atom_concat$direct'(_A, _B, _R, ___12))).
':-'('<module>:data.atom:concat$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.atom:concat'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.atom:format'(_Format, _Args, _Atom, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___30)), '<module>:kernel:atom_format$direct'(_Format, _Args, _Atom, ___30))).
':-'('<module>:data.atom:format$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.atom:format'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.atom:join'(_Atoms, _Delim, _Atom, 'env', __36CutLevel), ','(','('g_read'('data.atom', '<module>:data.atom'(___32)), '<module>:data.atom:string$direct'(_Delim, _DelimStr, ___32)), ','(','('true', ';'('->'('var'(_Convert), ','('g_inc'('$module_count', ___33), '='(_Convert, '$module'(___33, '.'('<module>:data.atom@0'('env'(_Convert)), '[]'), '.'(_Convert, '[]'))))), ','('='(_Convert, '$module'(___33, ___34, _)), ','('='('.'(___35, ___36), ___34), ','('setarg'(1, ___34, '<module>:data.atom@0'('env'(_Convert))), 'setarg'(2, ___34, '.'(___35, ___36))))))), ','(','(','('g_read'('data.list', '<module>:data.list'(___41)), '<module>:data.list:iter$direct'(_Atoms, _Convert, ___40, ___41)), ','('g_read'('data.list', '<module>:data.list'(___42)), '<module>:data.list:join$direct'(___40, _DelimStr, _String, ___42))), ','('g_read'('data.string', '<module>:data.string'(___44)), '<module>:data.string:atom$direct'(_String, _Atom, ___44)))))).
':-'('<module>:data.atom:join$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.atom:join'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.atom:length'(_Atom, _Length, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___10)), '<module>:kernel:atom_length$direct'(_Atom, _Length, ___10))).
':-'('<module>:data.atom:length$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.atom:length'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.atom:new'(_Atom, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___14)), '<module>:kernel:atom_new$direct'(_Atom, ___14))).
':-'('<module>:data.atom:new$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.atom:new'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.atom:new_backtrackable'(_Atom, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___16)), '<module>:kernel:atom_new_backtrackable$direct'(_Atom, ___16))).
':-'('<module>:data.atom:new_backtrackable$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.atom:new_backtrackable'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.atom:number'(_Atom, ___108, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___109)), '<module>:kernel:atom_to_number$direct'(_Atom, ___108, ___109))).
':-'('<module>:data.atom:number$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.atom:number'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.atom:remove_suffix'(_Atom, _Suffix, _SubAtom, 'env', __36CutLevel), ';'('->'(','('g_read'('data.atom', '<module>:data.atom'(___28)), '<module>:data.atom:concat$direct'(_SubAtom, _Suffix, _Atom, ___28)), 'true'), '='(_Atom, _SubAtom))).
':-'('<module>:data.atom:remove_suffix$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.atom:remove_suffix'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.atom:split'(_Atom, _Delim, _Atoms, 'env', __36CutLevel), ','('g_read'('data.atom', '<module>:data.atom'(___45)), '<module>:data.atom:split_from$direct'(0, 0, _Atom, _Delim, _Atoms, ___45))).
':-'('<module>:data.atom:split$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.atom:split'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.atom:split_at_delim_left'(_Atom, _Delim, _Left, _Right, 'env', __36CutLevel), ','('g_read'('data.atom', '<module>:data.atom'(___62)), '<module>:data.atom:split_at_delim_left_from$direct'(0, _Atom, _Delim, _Left, _Right, ___62))).
':-'('<module>:data.atom:split_at_delim_left$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.atom:split_at_delim_left'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.atom:split_at_delim_left_from'(_Index, _Atom, _Delim, _Left, _Right, 'env', __36CutLevel), ','(','('g_read'('data.atom', '<module>:data.atom'(___63)), '<module>:data.atom:length$direct'(_Atom, _Length, ___63)), ';'('->'(','('g_read'('data.number', '<module>:data.number'(___65)), '<module>:data.number:<$direct'(_Index, _Length, ___65)), ','(','('g_read'('data.number', '<module>:data.number'(___67)), '<module>:data.number:succ$direct'(_Index, _SuccIndex, ___67)), ';'('->'(','('g_read'('data.atom', '<module>:data.atom'(___68)), '<module>:data.atom:sub$direct'(_Atom, _Index, 1, _, _Delim, ___68)), ','(','('g_read'('data.atom', '<module>:data.atom'(___69)), '<module>:data.atom:sub$direct'(_Atom, 0, _Index, _, _Left, ___69)), ','('g_read'('data.atom', '<module>:data.atom'(___70)), '<module>:data.atom:sub$direct'(_Atom, _SuccIndex, _, 0, _Right, ___70)))), ','('g_read'('data.atom', '<module>:data.atom'(___71)), '<module>:data.atom:split_at_delim_left_from$direct'(_SuccIndex, _Atom, _Delim, _Left, _Right, ___71))))), 'fail'))).
':-'('<module>:data.atom:split_at_delim_left_from$direct'(_____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.atom:split_at_delim_left_from'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.atom:split_at_delim_right'(_Atom, _Delim, _Left, _Right, 'env', __36CutLevel), ','(','('g_read'('data.atom', '<module>:data.atom'(___72)), '<module>:data.atom:length$direct'(_Atom, _Length, ___72)), ','(','('g_read'('data.number', '<module>:data.number'(___75)), '<module>:data.number:pred$direct'(_Length, ___74, ___75)), ','('g_read'('data.atom', '<module>:data.atom'(___76)), '<module>:data.atom:split_at_delim_right_from$direct'(___74, _Atom, _Delim, _Left, _Right, ___76))))).
':-'('<module>:data.atom:split_at_delim_right$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.atom:split_at_delim_right'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.atom:split_at_delim_right_from'(_Index, _Atom, _Delim, _Left, _Right, 'env', __36CutLevel), ';'('->'(','('g_read'('data.number', '<module>:data.number'(___78)), '<module>:data.number:>=$direct'(_Index, 0, ___78)), ';'('->'(','('g_read'('data.atom', '<module>:data.atom'(___79)), '<module>:data.atom:sub$direct'(_Atom, _Index, 1, _, _Delim, ___79)), ','(','('g_read'('data.atom', '<module>:data.atom'(___80)), '<module>:data.atom:sub$direct'(_Atom, 0, _Index, _, _Left, ___80)), ','(','('g_read'('data.number', '<module>:data.number'(___83)), '<module>:data.number:succ$direct'(_Index, ___82, ___83)), ','('g_read'('data.atom', '<module>:data.atom'(___84)), '<module>:data.atom:sub$direct'(_Atom, ___82, _, 0, _Right, ___84))))), ','(','('g_read'('data.number', '<module>:data.number'(___87)), '<module>:data.number:pred$direct'(_Index, ___86, ___87)), ','('g_read'('data.atom', '<module>:data.atom'(___88)), '<module>:data.atom:split_at_delim_right_from$direct'(___86, _Atom, _Delim, _Left, _Right, ___88))))), 'fail')).
':-'('<module>:data.atom:split_at_delim_right_from$direct'(_____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.atom:split_at_delim_right_from'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.atom:split_from'(_Origin, _Index, _Atom, _Delim, _Atoms, 'env', __36CutLevel), ','(','('g_read'('data.atom', '<module>:data.atom'(___46)), '<module>:data.atom:length$direct'(_Atom, _Length, ___46)), ';'('->'(','('g_read'('data.number', '<module>:data.number'(___48)), '<module>:data.number:<$direct'(_Index, _Length, ___48)), ','(','('g_read'('data.number', '<module>:data.number'(___50)), '<module>:data.number:succ$direct'(_Index, _SuccIndex, ___50)), ';'('->'(','('g_read'('data.atom', '<module>:data.atom'(___51)), '<module>:data.atom:sub$direct'(_Atom, _Index, 1, _, _Delim, ___51)), ','(','(','('g_read'('data.number', '<module>:data.number'(___54)), '<module>:data.number:-$direct'(_Index, _Origin, ___53, ___54)), ','('g_read'('data.atom', '<module>:data.atom'(___55)), '<module>:data.atom:sub$direct'(_Atom, _Origin, ___53, _, _C, ___55))), ','('='(_Atoms, '.'(_C, _Tail)), ','('g_read'('data.atom', '<module>:data.atom'(___57)), '<module>:data.atom:split_from$direct'(_SuccIndex, _SuccIndex, _Atom, _Delim, _Tail, ___57))))), ','('g_read'('data.atom', '<module>:data.atom'(___58)), '<module>:data.atom:split_from$direct'(_Origin, _SuccIndex, _Atom, _Delim, _Atoms, ___58))))), ','(','('g_read'('data.atom', '<module>:data.atom'(___59)), '<module>:data.atom:sub$direct'(_Atom, _Origin, _, 0, _C, ___59)), '='(_Atoms, '.'(_C, '[]')))))).
':-'('<module>:data.atom:split_from$direct'(_____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.atom:split_from'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.atom:stream'(_Atom, ___23, 'env', __36CutLevel), ','(','('g_read'('data.atom', '<module>:data.atom'(___22)), '<module>:data.atom:string$direct'(_Atom, ___21, ___22)), ','('g_read'('data.list', '<module>:data.list'(___24)), '<module>:data.list:stream$direct'(___21, ___23, ___24)))).
':-'('<module>:data.atom:stream$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.atom:stream'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.atom:string'(_Atom, ___18, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___19)), '<module>:kernel:atom_to_string$direct'(_Atom, ___18, ___19))).
':-'('<module>:data.atom:string$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.atom:string'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.atom:sub'(_Atom, _Before, _Length, _After, _SubAtom, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___26)), '<module>:kernel:atom_sub$direct'(_Atom, _Before, _Length, _After, _SubAtom, ___26))).
':-'('<module>:data.atom:sub$direct'(_____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.atom:sub'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.atom:subst'(_Src, _Table, _Tgt, 'env', __36CutLevel), ','('='(_Tgt, ___105), ','(','(','(','('g_read'('data.atom', '<module>:data.atom'(___93)), '<module>:data.atom:string$direct'(_Src, ___92, ___93)), ','(','('true', ';'('->'('var'(___95), ','('g_inc'('$module_count', ___96), '='(___95, '$module'(___96, '.'('<module>:data.atom@1'('env'(___95)), '[]'), '.'(___95, '[]'))))), ','('='(___95, '$module'(___96, ___97, _)), ','('='('.'(___98, ___99), ___97), ','('setarg'(1, ___97, '<module>:data.atom@1'('env'(___95))), 'setarg'(2, ___97, '.'(___98, ___99))))))), ','('g_read'('data.list', '<module>:data.list'(___102)), '<module>:data.list:iter$direct'(_Table, ___95, ___101, ___102)))), ','('g_read'('data.list', '<module>:data.list'(___104)), '<module>:data.list:subst$direct'(___92, ___101, ___103, ___104))), ','('g_read'('data.string', '<module>:data.string'(___106)), '<module>:data.string:atom$direct'(___103, ___105, ___106))))).
':-'('<module>:data.atom:subst$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.atom:subst'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.atom:suffix'(_Atom, _Length, _Suffix, 'env', __36CutLevel), ','('g_read'('data.atom', '<module>:data.atom'(___27)), '<module>:data.atom:sub$direct'(_Atom, _, _Length, 0, _Suffix, ___27))).
':-'('<module>:data.atom:suffix$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.atom:suffix'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.atom@0'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.atom@0:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.atom@0'('do'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.atom@0:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.atom@0'(__36t, __36env, __36pos, __36CutLevel), '<module>:data.atom@0$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:data.atom@0$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:data.atom@0$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:data.atom@0$has_predicate'('do'(_____2, _____1)), 'true').
':-'('<module>:data.atom@0:$sgn'(__36sgn, 'env'(___37), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/atom.mpl',3422,120,3416)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/atom.mpl',3441,120,3416)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:data.atom@0:atom_fresh_[1646]'(_atom__fresh___911647_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___911647_93, '[]'))))))).
':-'('<module>:data.atom@0:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.atom@0:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.atom@0:atom_fresh_[1646]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 2, predicate, suspended([var('Atom'),var('String')],[call(atom('data.atom'),string,[var('Atom'),var('String')])]), __36pos))).
':-'('<module>:data.atom@0:do'(_Atom, _String, 'env'(___37), __36CutLevel), ','('g_read'('data.atom', '<module>:data.atom'(___119)), '<module>:data.atom:string$direct'(_Atom, _String, ___119))).
':-'('<module>:data.atom@0:do$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.atom@0:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.atom@1'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.atom@1:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.atom@1'('do'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.atom@1:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.atom@1'(__36t, __36env, __36pos, __36CutLevel), '<module>:data.atom@1$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:data.atom@1$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:data.atom@1$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:data.atom@1$has_predicate'('do'(_____2, _____1)), 'true').
':-'('<module>:data.atom@1:$sgn'(__36sgn, 'env'(___100), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/atom.mpl',7870,269,7843)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/atom.mpl',7886,269,7843)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:data.atom@1:atom_fresh_[1644]'(_atom__fresh___911645_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___911645_93, '[]'))))))).
':-'('<module>:data.atom@1:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.atom@1:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.atom@1:atom_fresh_[1644]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 2, predicate, suspended([none,none],[call(scope,true,[])]), __36pos))).
':-'('<module>:data.atom@1:do'('=>'(_From, _To), '=>'(___112, ___115), 'env'(___100), __36CutLevel), ','(','('g_read'('data.atom', '<module>:data.atom'(___113)), '<module>:data.atom:string$direct'(_From, ___112, ___113)), ','('g_read'('data.atom', '<module>:data.atom'(___116)), '<module>:data.atom:string$direct'(_To, ___115, ___116)))).
':-'('<module>:data.atom@1:do$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.atom@1:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('data.atom@init', ','('true', 'g_link'('data.atom', '<module>:data.atom'('env')))).
':-'('dynamic'('/'('<module>:data.char$dynamic', 4))).
':-'('<module>:data.char'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.char:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.char'('+'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.char:+'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.char'('*'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.char:*'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.char'('-'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.char:-'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.char'('..'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.char:..'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.char'('<'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.char:<'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.char'('<'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.char:<'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.char'('=<'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.char:=<'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.char'('=<'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.char:=<'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.char'('>'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.char:>'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.char'('>'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.char:>'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.char'('>='(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.char:>='(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.char'('>='(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.char:>='(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.char'('succ'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.char:succ'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.char'('check'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.char:check'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.char'('code'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.char:code'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.char'('decimal_digit'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.char:decimal_digit'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.char'('octal_digit'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.char:octal_digit'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.char'('hexadecimal_digit'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.char:hexadecimal_digit'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.char'('bit'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.char:bit'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.char'('escape'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.char:escape'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.char'('read_escape'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.char:read_escape'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.char'(__36t, __36env, __36pos, __36CutLevel), '<module>:data.char$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:data.char$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:data.char$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:data.char$has_predicate'('+'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.char$has_predicate'('*'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.char$has_predicate'('-'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.char$has_predicate'('..'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.char$has_predicate'('<'(_____2, _____1)), 'true').
':-'('<module>:data.char$has_predicate'('<'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.char$has_predicate'('=<'(_____2, _____1)), 'true').
':-'('<module>:data.char$has_predicate'('=<'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.char$has_predicate'('>'(_____2, _____1)), 'true').
':-'('<module>:data.char$has_predicate'('>'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.char$has_predicate'('>='(_____2, _____1)), 'true').
':-'('<module>:data.char$has_predicate'('>='(_____3, _____2, _____1)), 'true').
':-'('<module>:data.char$has_predicate'('succ'(_____2, _____1)), 'true').
':-'('<module>:data.char$has_predicate'('check'(_____1)), 'true').
':-'('<module>:data.char$has_predicate'('code'(_____2, _____1)), 'true').
':-'('<module>:data.char$has_predicate'('decimal_digit'(_____2, _____1)), 'true').
':-'('<module>:data.char$has_predicate'('octal_digit'(_____2, _____1)), 'true').
':-'('<module>:data.char$has_predicate'('hexadecimal_digit'(_____2, _____1)), 'true').
':-'('<module>:data.char$has_predicate'('bit'(_____2, _____1)), 'true').
':-'('<module>:data.char$has_predicate'('escape'(_____2, _____1)), 'true').
':-'('<module>:data.char$has_predicate'('read_escape'(_____2, _____1)), 'true').
':-'('<module>:data.char:$sgn'(__36sgn, 'env', __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/char.mpl',0,0,0)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/char.mpl',18,0,0)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','('true', '<module>:data.char:atom_fresh_[1932]'(_atom__fresh___911933_93, __36Pb, __36Pe)), '<module>:data.char:atom_fresh_[1934]'(_atom__fresh___911935_93, __36Pb, __36Pe)), '<module>:data.char:atom_fresh_[1936]'(_atom__fresh___911937_93, __36Pb, __36Pe)), '<module>:data.char:atom_fresh_[1938]'(_atom__fresh___911939_93, __36Pb, __36Pe)), '<module>:data.char:atom_fresh_[1940]'(_atom__fresh___911941_93, __36Pb, __36Pe)), '<module>:data.char:atom_fresh_[1942]'(_atom__fresh___911943_93, __36Pb, __36Pe)), '<module>:data.char:atom_fresh_[1944]'(_atom__fresh___911945_93, __36Pb, __36Pe)), '<module>:data.char:atom_fresh_[1946]'(_atom__fresh___911947_93, __36Pb, __36Pe)), '<module>:data.char:atom_fresh_[1948]'(_atom__fresh___911949_93, __36Pb, __36Pe)), '<module>:data.char:atom_fresh_[1950]'(_atom__fresh___911951_93, __36Pb, __36Pe)), '<module>:data.char:atom_fresh_[1952]'(_atom__fresh___911953_93, __36Pb, __36Pe)), '<module>:data.char:atom_fresh_[1954]'(_atom__fresh___911955_93, __36Pb, __36Pe)), '<module>:data.char:atom_fresh_[1956]'(_atom__fresh___911957_93, __36Pb, __36Pe)), '<module>:data.char:atom_fresh_[1958]'(_atom__fresh___911959_93, __36Pb, __36Pe)), '<module>:data.char:atom_fresh_[1960]'(_atom__fresh___911961_93, __36Pb, __36Pe)), '<module>:data.char:atom_fresh_[1962]'(_atom__fresh___911963_93, __36Pb, __36Pe)), '<module>:data.char:atom_fresh_[1964]'(_atom__fresh___911965_93, __36Pb, __36Pe)), '<module>:data.char:atom_fresh_[1966]'(_atom__fresh___911967_93, __36Pb, __36Pe)), '<module>:data.char:atom_fresh_[1968]'(_atom__fresh___911969_93, __36Pb, __36Pe)), '<module>:data.char:atom_fresh_[1970]'(_atom__fresh___911971_93, __36Pb, __36Pe)), '<module>:data.char:atom_fresh_[1972]'(_atom__fresh___911973_93, __36Pb, __36Pe)), '<module>:data.char:atom_fresh_[1974]'(_atom__fresh___911975_93, __36Pb, __36Pe)), '<module>:data.char:atom_fresh_[1976]'(_atom__fresh___911977_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___911977_93, '.'(_atom__fresh___911975_93, '.'(_atom__fresh___911973_93, '.'(_atom__fresh___911971_93, '.'(_atom__fresh___911969_93, '.'(_atom__fresh___911967_93, '.'(_atom__fresh___911965_93, '.'(_atom__fresh___911963_93, '.'(_atom__fresh___911961_93, '.'(_atom__fresh___911959_93, '.'(_atom__fresh___911957_93, '.'(_atom__fresh___911955_93, '.'(_atom__fresh___911953_93, '.'(_atom__fresh___911951_93, '.'(_atom__fresh___911949_93, '.'(_atom__fresh___911947_93, '.'(_atom__fresh___911945_93, '.'(_atom__fresh___911943_93, '.'(_atom__fresh___911941_93, '.'(_atom__fresh___911939_93, '.'(_atom__fresh___911937_93, '.'(_atom__fresh___911935_93, '.'(_atom__fresh___911933_93, '[]'))))))))))))))))))))))))))))).
':-'('<module>:data.char:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.char:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.char:*'(___7, ___8, ___9, 'env', __36CutLevel), '=..'(___9, '.'('*', '.'(___7, '.'(___8, '[]'))))).
':-'('<module>:data.char:*$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.char:*'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.char:+'(___4, ___5, ___6, 'env', __36CutLevel), '=..'(___6, '.'('+', '.'(___4, '.'(___5, '[]'))))).
':-'('<module>:data.char:+$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.char:+'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.char:-'(___10, ___11, ___12, 'env', __36CutLevel), '=..'(___12, '.'('-', '.'(___10, '.'(___11, '[]'))))).
':-'('<module>:data.char:-$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.char:-'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.char:..'(_I, _J, ___13, 'env', __36CutLevel), ';'('->'(','('g_read'('data.char', '<module>:data.char'(___15)), '<module>:data.char:<$direct'(_I, _J, ___15)), ','('='(___13, '.'(_I, ___18)), ','(','('g_read'('data.char', '<module>:data.char'(___17)), '<module>:data.char:succ$direct'(_I, ___16, ___17)), ','('g_read'('data.char', '<module>:data.char'(___19)), '<module>:data.char:..$direct'(___16, _J, ___18, ___19))))), ','('='(___13, ___14), ';'('->'('='(_I, _J), '='(___14, '.'(_I, '[]'))), '='(___14, '[]'))))).
':-'('<module>:data.char:..$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.char:..'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.char:<'(_A, _B, 'env', __36CutLevel), ','(','(','('g_read'('data.char', '<module>:data.char'(___26)), '<module>:data.char:code$direct'(_A, ___25, ___26)), ','('g_read'('data.char', '<module>:data.char'(___28)), '<module>:data.char:code$direct'(_B, ___27, ___28))), ','('g_read'('data.number', '<module>:data.number'(___29)), '<module>:data.number:<$direct'(___25, ___27, ___29)))).
':-'('<module>:data.char:<'(_A, _B, ___35, 'env', __36CutLevel), ','(','(','('g_read'('data.char', '<module>:data.char'(___32)), '<module>:data.char:code$direct'(_A, ___31, ___32)), ','('g_read'('data.char', '<module>:data.char'(___34)), '<module>:data.char:code$direct'(_B, ___33, ___34))), ','('g_read'('data.number', '<module>:data.number'(___36)), '<module>:data.number:<$direct'(___31, ___33, ___35, ___36)))).
':-'('<module>:data.char:<$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.char:<'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.char:<$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.char:<'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.char:=<'(_A, _B, 'env', __36CutLevel), ','(','(','('g_read'('data.char', '<module>:data.char'(___39)), '<module>:data.char:code$direct'(_A, ___38, ___39)), ','('g_read'('data.char', '<module>:data.char'(___41)), '<module>:data.char:code$direct'(_B, ___40, ___41))), ','('g_read'('data.number', '<module>:data.number'(___42)), '<module>:data.number:=<$direct'(___38, ___40, ___42)))).
':-'('<module>:data.char:=<'(_A, _B, ___48, 'env', __36CutLevel), ','(','(','('g_read'('data.char', '<module>:data.char'(___45)), '<module>:data.char:code$direct'(_A, ___44, ___45)), ','('g_read'('data.char', '<module>:data.char'(___47)), '<module>:data.char:code$direct'(_B, ___46, ___47))), ','('g_read'('data.number', '<module>:data.number'(___49)), '<module>:data.number:=<$direct'(___44, ___46, ___48, ___49)))).
':-'('<module>:data.char:=<$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.char:=<'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.char:=<$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.char:=<'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.char:>'(_A, _B, 'env', __36CutLevel), ','(','(','('g_read'('data.char', '<module>:data.char'(___52)), '<module>:data.char:code$direct'(_A, ___51, ___52)), ','('g_read'('data.char', '<module>:data.char'(___54)), '<module>:data.char:code$direct'(_B, ___53, ___54))), ','('g_read'('data.number', '<module>:data.number'(___55)), '<module>:data.number:>$direct'(___51, ___53, ___55)))).
':-'('<module>:data.char:>'(_A, _B, ___61, 'env', __36CutLevel), ','(','(','('g_read'('data.char', '<module>:data.char'(___58)), '<module>:data.char:code$direct'(_A, ___57, ___58)), ','('g_read'('data.char', '<module>:data.char'(___60)), '<module>:data.char:code$direct'(_B, ___59, ___60))), ','('g_read'('data.number', '<module>:data.number'(___62)), '<module>:data.number:>$direct'(___57, ___59, ___61, ___62)))).
':-'('<module>:data.char:>$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.char:>'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.char:>$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.char:>'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.char:>='(_A, _B, 'env', __36CutLevel), ','(','(','('g_read'('data.char', '<module>:data.char'(___65)), '<module>:data.char:code$direct'(_A, ___64, ___65)), ','('g_read'('data.char', '<module>:data.char'(___67)), '<module>:data.char:code$direct'(_B, ___66, ___67))), ','('g_read'('data.number', '<module>:data.number'(___68)), '<module>:data.number:>=$direct'(___64, ___66, ___68)))).
':-'('<module>:data.char:>='(_A, _B, ___74, 'env', __36CutLevel), ','(','(','('g_read'('data.char', '<module>:data.char'(___71)), '<module>:data.char:code$direct'(_A, ___70, ___71)), ','('g_read'('data.char', '<module>:data.char'(___73)), '<module>:data.char:code$direct'(_B, ___72, ___73))), ','('g_read'('data.number', '<module>:data.number'(___75)), '<module>:data.number:>=$direct'(___70, ___72, ___74, ___75)))).
':-'('<module>:data.char:>=$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.char:>='(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.char:>=$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.char:>='(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.char:atom_fresh_[1932]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(read_escape, 2, predicate, '[]', __36pos))).
':-'('<module>:data.char:atom_fresh_[1934]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(escape, 2, predicate, '[]', __36pos))).
':-'('<module>:data.char:atom_fresh_[1936]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(bit, 2, predicate, '[]', __36pos))).
':-'('<module>:data.char:atom_fresh_[1938]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(hexadecimal_digit, 2, predicate, '[]', __36pos))).
':-'('<module>:data.char:atom_fresh_[1940]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(octal_digit, 2, predicate, '[]', __36pos))).
':-'('<module>:data.char:atom_fresh_[1942]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(decimal_digit, 2, predicate, '[]', __36pos))).
':-'('<module>:data.char:atom_fresh_[1944]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(code, 2, predicate, suspended([var('Char'),var('Code')],[call(atom(kernel),char_to_code,[var('Char'),var('Code')])]), __36pos))).
':-'('<module>:data.char:atom_fresh_[1946]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(check, 1, predicate, suspended([var('X')],[call(atom('data.atom'),check,[var('X')]),call(atom('data.atom'),length,[var('X'),none])]), __36pos))).
':-'('<module>:data.char:atom_fresh_[1948]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(succ, 2, predicate, suspended([var('I'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:data.char:atom_fresh_[1950]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(>=, 3, predicate, suspended([var('A'),var('B'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:data.char:atom_fresh_[1952]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(>=, 2, predicate, '[]', __36pos))).
':-'('<module>:data.char:atom_fresh_[1954]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(>, 3, predicate, suspended([var('A'),var('B'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:data.char:atom_fresh_[1956]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(>, 2, predicate, '[]', __36pos))).
':-'('<module>:data.char:atom_fresh_[1958]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(=<, 3, predicate, suspended([var('A'),var('B'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:data.char:atom_fresh_[1960]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(=<, 2, predicate, '[]', __36pos))).
':-'('<module>:data.char:atom_fresh_[1962]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(<, 3, predicate, suspended([var('A'),var('B'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:data.char:atom_fresh_[1964]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(<, 2, predicate, '[]', __36pos))).
':-'('<module>:data.char:atom_fresh_[1966]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(.., 3, predicate, suspended([var('I'),var('J'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:data.char:atom_fresh_[1968]'(__36s, __36Pb, __36Pe), '='(__36s, 'syntax'('.'('callable'('=', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('<', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('..', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('<', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('+', 'escaped', 'none', __36Pb, __36Pe), '[]'))))), __36Pb, __36Pe))).
':-'('<module>:data.char:atom_fresh_[1970]'(__36s, __36Pb, __36Pe), '='(__36s, 'syntax'('.'('callable'('infix', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('..', 'escaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe))).
':-'('<module>:data.char:atom_fresh_[1972]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(-, 3, constructor, none, __36pos))).
':-'('<module>:data.char:atom_fresh_[1974]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(*, 3, constructor, none, __36pos))).
':-'('<module>:data.char:atom_fresh_[1976]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(+, 3, constructor, none, __36pos))).
':-'('<module>:data.char:bit'(_Char, _Value, 'env', __36CutLevel), ','(','('g_read'('data.atom', '<module>:data.atom'(___160)), '<module>:data.atom:check$direct'(_Char, ___160)), '->'(','(','('g_read'('data.term', '<module>:data.term'(___163)), '<module>:data.term:>=$direct'(_Char, '0', ___163)), ','('g_read'('data.term', '<module>:data.term'(___166)), '<module>:data.term:=<$direct'(_Char, '1', ___166))), ','('='(_Value, ___171), ','(','('g_read'('data.char', '<module>:data.char'(___170)), '<module>:data.char:code$direct'(_Char, ___169, ___170)), ','('g_read'('data.number', '<module>:data.number'(___172)), '<module>:data.number:-$direct'(___169, 48, ___171, ___172))))))).
':-'('<module>:data.char:bit$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.char:bit'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.char:check'(_X, 'env', __36CutLevel), ','(','('g_read'('data.atom', '<module>:data.atom'(___86)), '<module>:data.atom:check$direct'(_X, ___86)), ','('g_read'('data.atom', '<module>:data.atom'(___88)), '<module>:data.atom:length$direct'(_X, 1, ___88)))).
':-'('<module>:data.char:check$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.char:check'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.char:code'(_Char, _Code, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___90)), '<module>:kernel:char_to_code$direct'(_Char, _Code, ___90))).
':-'('<module>:data.char:code$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.char:code'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.char:decimal_digit'(_Char, _Value, 'env', __36CutLevel), ','(','('g_read'('data.atom', '<module>:data.atom'(___92)), '<module>:data.atom:check$direct'(_Char, ___92)), '->'(','(','('g_read'('data.term', '<module>:data.term'(___95)), '<module>:data.term:>=$direct'(_Char, '0', ___95)), ','('g_read'('data.term', '<module>:data.term'(___98)), '<module>:data.term:=<$direct'(_Char, '9', ___98))), ','('='(_Value, ___103), ','(','('g_read'('data.char', '<module>:data.char'(___102)), '<module>:data.char:code$direct'(_Char, ___101, ___102)), ','('g_read'('data.number', '<module>:data.number'(___104)), '<module>:data.number:-$direct'(___101, 48, ___103, ___104))))))).
':-'('<module>:data.char:decimal_digit$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.char:decimal_digit'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.char:escape'('\n', '\\n', 'env', __36CutLevel), ','('true', ','('='(__36CutLevel, '$cut'), '!'))).
':-'('<module>:data.char:escape'('\r', '\\r', 'env', __36CutLevel), ','('true', ','('='(__36CutLevel, '$cut'), '!'))).
':-'('<module>:data.char:escape'('\t', '\\t', 'env', __36CutLevel), ','('true', ','('='(__36CutLevel, '$cut'), '!'))).
':-'('<module>:data.char:escape'('\b', '\\b', 'env', __36CutLevel), ','('true', ','('='(__36CutLevel, '$cut'), '!'))).
':-'('<module>:data.char:escape'('\\', '\\\\', 'env', __36CutLevel), ','('true', ','('='(__36CutLevel, '$cut'), '!'))).
':-'('<module>:data.char:escape'('\'', '\\\'', 'env', __36CutLevel), ','('true', ','('='(__36CutLevel, '$cut'), '!'))).
':-'('<module>:data.char:escape'('\"', '\\\"', 'env', __36CutLevel), ','('true', ','('='(__36CutLevel, '$cut'), '!'))).
':-'('<module>:data.char:escape'(_C, _C, 'env', __36CutLevel), 'true').
':-'('<module>:data.char:escape$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.char:escape'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.char:hexadecimal_digit'(_Char, _Value, 'env', __36CutLevel), ','(','('g_read'('data.atom', '<module>:data.atom'(___120)), '<module>:data.atom:check$direct'(_Char, ___120)), ';'('->'(','(','('g_read'('data.term', '<module>:data.term'(___123)), '<module>:data.term:>=$direct'(_Char, '0', ___123)), ','('g_read'('data.term', '<module>:data.term'(___126)), '<module>:data.term:=<$direct'(_Char, '9', ___126))), ','('='(_Value, ___131), ','(','('g_read'('data.char', '<module>:data.char'(___130)), '<module>:data.char:code$direct'(_Char, ___129, ___130)), ','('g_read'('data.number', '<module>:data.number'(___132)), '<module>:data.number:-$direct'(___129, 48, ___131, ___132))))), ';'('->'(','(','('g_read'('data.term', '<module>:data.term'(___135)), '<module>:data.term:>=$direct'(_Char, 'a', ___135)), ','('g_read'('data.term', '<module>:data.term'(___138)), '<module>:data.term:=<$direct'(_Char, 'f', ___138))), ','('='(_Value, ___144), ','(','('g_read'('data.char', '<module>:data.char'(___142)), '<module>:data.char:code$direct'(_Char, ___141, ___142)), ','('g_read'('data.number', '<module>:data.number'(___145)), '<module>:data.number:+$direct'('-'(___141, 97), 10, ___144, ___145))))), '->'(','(','('g_read'('data.term', '<module>:data.term'(___148)), '<module>:data.term:>=$direct'(_Char, 'A', ___148)), ','('g_read'('data.term', '<module>:data.term'(___151)), '<module>:data.term:=<$direct'(_Char, 'F', ___151))), ','('='(_Value, ___157), ','(','('g_read'('data.char', '<module>:data.char'(___155)), '<module>:data.char:code$direct'(_Char, ___154, ___155)), ','('g_read'('data.number', '<module>:data.number'(___158)), '<module>:data.number:+$direct'('-'(___154, 65), 10, ___157, ___158))))))))).
':-'('<module>:data.char:hexadecimal_digit$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.char:hexadecimal_digit'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.char:octal_digit'(_Char, _Value, 'env', __36CutLevel), ','(','('g_read'('data.atom', '<module>:data.atom'(___106)), '<module>:data.atom:check$direct'(_Char, ___106)), '->'(','(','('g_read'('data.term', '<module>:data.term'(___109)), '<module>:data.term:>=$direct'(_Char, '0', ___109)), ','('g_read'('data.term', '<module>:data.term'(___112)), '<module>:data.term:=<$direct'(_Char, '7', ___112))), ','('='(_Value, ___117), ','(','('g_read'('data.char', '<module>:data.char'(___116)), '<module>:data.char:code$direct'(_Char, ___115, ___116)), ','('g_read'('data.number', '<module>:data.number'(___118)), '<module>:data.number:-$direct'(___115, 48, ___117, ___118))))))).
':-'('<module>:data.char:octal_digit$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.char:octal_digit'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.char:read_escape'(_Stream, _C, 'env', __36CutLevel), ','('emop_call'(_Stream, 'read'(_H), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/char.mpl\", line 180, from character 13 to 17'), ';'('->'('='(_H, 'n'), '='(_C, '\n')), ';'('->'('='(_H, 'r'), '='(_C, '\r')), ';'('->'('='(_H, 't'), '='(_C, '\t')), ';'('->'('='(_H, 'b'), '='(_C, '\b')), ';'('->'('='(_H, '\''), '='(_C, '\'')), ';'('->'('='(_H, '\"'), '='(_C, '\"')), ';'('->'('='(_H, '`'), '='(_C, '`')), ';'('->'('='(_H, '\\'), '='(_C, '\\')), ';'('->'('='(_H, 'x'), ','(','('emop_call'(_Stream, 'read'(___205), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/char.mpl\", line 216, from character 46 to 50'), ','('g_read'('data.char', '<module>:data.char'(___206)), '<module>:data.char:hexadecimal_digit$direct'(___205, _High, ___206))), ';'('->'(','('emop_call'(_Stream, 'read'(___208), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/char.mpl\", line 218, from character 49 to 53'), ','('g_read'('data.char', '<module>:data.char'(___209)), '<module>:data.char:hexadecimal_digit$direct'(___208, _Low, ___209))), ','('='(_C, ___213), ','('g_read'('data.number', '<module>:data.number'(___214)), '<module>:data.number:char$direct'('+'('*'(_High, 16), _Low), ___213, ___214)))), ','('='(_C, ___216), ','('g_read'('data.number', '<module>:data.number'(___217)), '<module>:data.number:char$direct'(_High, ___216, ___217)))))), '->'(','('g_read'('data.char', '<module>:data.char'(___219)), '<module>:data.char:decimal_digit$direct'(_C, _D1, ___219)), ';'('->'(','('emop_call'(_Stream, 'read'(___221), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/char.mpl\", line 228, from character 45 to 49'), ','('g_read'('data.char', '<module>:data.char'(___222)), '<module>:data.char:decimal_digit$direct'(___221, _D2, ___222))), ';'('->'(','('emop_call'(_Stream, 'read'(___224), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/char.mpl\", line 231, from character 48 to 52'), ','('g_read'('data.char', '<module>:data.char'(___225)), '<module>:data.char:decimal_digit$direct'(___224, _D3, ___225))), ','('='(_C, ___231), ','('g_read'('data.number', '<module>:data.number'(___232)), '<module>:data.number:char$direct'('+'('*'('+'('*'(_D1, 10), _D2), 10), _D3), ___231, ___232)))), ','('='(_C, ___236), ','('g_read'('data.number', '<module>:data.number'(___237)), '<module>:data.number:char$direct'('+'('*'(_D1, 10), _D2), ___236, ___237))))), ','('='(_C, ___239), ','('g_read'('data.number', '<module>:data.number'(___240)), '<module>:data.number:char$direct'(_D1, ___239, ___240)))))))))))))))).
':-'('<module>:data.char:read_escape$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.char:read_escape'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.char:succ'(_I, ___83, 'env', __36CutLevel), ','(','(','(','('g_read'('data.char', '<module>:data.char'(___78)), '<module>:data.char:code$direct'(_I, ___77, ___78)), ','('g_read'('data.number', '<module>:data.number'(___80)), '<module>:data.number:succ$direct'(___77, ___79, ___80))), ','('g_read'('data.number', '<module>:data.number'(___82)), '<module>:data.number:mod$direct'(___79, 256, ___81, ___82))), ','('g_read'('data.number', '<module>:data.number'(___84)), '<module>:data.number:char$direct'(___81, ___83, ___84)))).
':-'('<module>:data.char:succ$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.char:succ'(_____2, _____1, __36env, __36CutLevel))).
':-'('data.char@init', ','('true', 'g_link'('data.char', '<module>:data.char'('env')))).
':-'('dynamic'('/'('<module>:data.list$dynamic', 4))).
':-'('dynamic'('/'('<module>:data.list@5$dynamic', 4))).
':-'('dynamic'('/'('<module>:data.list@4$dynamic', 4))).
':-'('dynamic'('/'('<module>:data.list@3$dynamic', 4))).
':-'('dynamic'('/'('<module>:data.list@2$dynamic', 4))).
':-'('dynamic'('/'('<module>:data.list@1$dynamic', 4))).
':-'('dynamic'('/'('<module>:data.list@0$dynamic', 4))).
':-'('<module>:data.list'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.list:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.list'('=>'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.list:=>'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list'('length'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.list:length'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list'('member'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.list:member'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list'('member_last'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.list:member_last'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list'('add_to_left'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.list:add_to_left'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list'('append'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.list:append'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list'('++'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.list:++'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list'('*'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.list:*'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list'('flatten'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.list:flatten'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list'('join'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.list:join'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list'('join_with_prefix'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.list:join_with_prefix'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list'('reverse'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.list:reverse'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list'('reverse_append'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.list:reverse_append'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list'('iter'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.list:iter'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list'('iteri'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.list:iteri'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list'('iteri_from'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.list:iteri_from'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list'('iter'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.list:iter'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list'('iteri'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.list:iteri'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list'('iteri_from'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.list:iteri_from'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list'('map'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.list:map'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list'('mapi'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.list:mapi'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list'('iter'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.list:iter'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list'('reverse_iter'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.list:reverse_iter'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list'('morph'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.list:morph'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list'('fold_left'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.list:fold_left'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list'('fold_right'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.list:fold_right'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list'('iter_fold'(_____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.list:iter_fold'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list'('zip'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.list:zip'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list'('accumulate'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.list:accumulate'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list'('accumulate_sublists'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.list:accumulate_sublists'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list'('init'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.list:init'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list'('split_at_delim_left'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.list:split_at_delim_left'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list'('split'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.list:split'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list'('merge'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.list:merge'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list'('merge_sort'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.list:merge_sort'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list'('split'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.list:split'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list'('quick_sort'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.list:quick_sort'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list'('longuest_prefix'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.list:longuest_prefix'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list'('subst'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.list:subst'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list'('delete'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.list:delete'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list'('select'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.list:select'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list'('member_partial'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.list:member_partial'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list'('nth1'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.list:nth1'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list'('index1'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.list:index1'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list'('stream'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.list:stream'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list'('random_item'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.list:random_item'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list'(__36t, __36env, __36pos, __36CutLevel), '<module>:data.list$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:data.list$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:data.list$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:data.list$has_predicate'('=>'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.list$has_predicate'('length'(_____2, _____1)), 'true').
':-'('<module>:data.list$has_predicate'('member'(_____2, _____1)), 'true').
':-'('<module>:data.list$has_predicate'('member_last'(_____2, _____1)), 'true').
':-'('<module>:data.list$has_predicate'('add_to_left'(_____2, _____1)), 'true').
':-'('<module>:data.list$has_predicate'('append'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.list$has_predicate'('++'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.list$has_predicate'('*'(_____2, _____1)), 'true').
':-'('<module>:data.list$has_predicate'('flatten'(_____2, _____1)), 'true').
':-'('<module>:data.list$has_predicate'('join'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.list$has_predicate'('join_with_prefix'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.list$has_predicate'('reverse'(_____2, _____1)), 'true').
':-'('<module>:data.list$has_predicate'('reverse_append'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.list$has_predicate'('iter'(_____2, _____1)), 'true').
':-'('<module>:data.list$has_predicate'('iteri'(_____2, _____1)), 'true').
':-'('<module>:data.list$has_predicate'('iteri_from'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.list$has_predicate'('iter'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.list$has_predicate'('iteri'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.list$has_predicate'('iteri_from'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:data.list$has_predicate'('map'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.list$has_predicate'('mapi'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.list$has_predicate'('iter'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:data.list$has_predicate'('reverse_iter'(_____2, _____1)), 'true').
':-'('<module>:data.list$has_predicate'('morph'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.list$has_predicate'('fold_left'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:data.list$has_predicate'('fold_right'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:data.list$has_predicate'('iter_fold'(_____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:data.list$has_predicate'('zip'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.list$has_predicate'('accumulate'(_____2, _____1)), 'true').
':-'('<module>:data.list$has_predicate'('accumulate_sublists'(_____2, _____1)), 'true').
':-'('<module>:data.list$has_predicate'('init'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:data.list$has_predicate'('split_at_delim_left'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:data.list$has_predicate'('split'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.list$has_predicate'('merge'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:data.list$has_predicate'('merge_sort'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.list$has_predicate'('split'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:data.list$has_predicate'('quick_sort'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.list$has_predicate'('longuest_prefix'(_____2, _____1)), 'true').
':-'('<module>:data.list$has_predicate'('subst'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.list$has_predicate'('delete'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.list$has_predicate'('select'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.list$has_predicate'('member_partial'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.list$has_predicate'('nth1'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.list$has_predicate'('index1'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.list$has_predicate'('stream'(_____2, _____1)), 'true').
':-'('<module>:data.list$has_predicate'('random_item'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.list:$sgn'(__36sgn, 'env', __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/list.mpl',0,0,0)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/list.mpl',18,0,0)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','('true', '<module>:data.list:atom_fresh_[1648]'(_atom__fresh___911649_93, __36Pb, __36Pe)), '<module>:data.list:atom_fresh_[1650]'(_atom__fresh___911651_93, __36Pb, __36Pe)), '<module>:data.list:atom_fresh_[1652]'(_atom__fresh___911653_93, __36Pb, __36Pe)), '<module>:data.list:atom_fresh_[1654]'(_atom__fresh___911655_93, __36Pb, __36Pe)), '<module>:data.list:atom_fresh_[1656]'(_atom__fresh___911657_93, __36Pb, __36Pe)), '<module>:data.list:atom_fresh_[1658]'(_atom__fresh___911659_93, __36Pb, __36Pe)), '<module>:data.list:atom_fresh_[1660]'(_atom__fresh___911661_93, __36Pb, __36Pe)), '<module>:data.list:atom_fresh_[1662]'(_atom__fresh___911663_93, __36Pb, __36Pe)), '<module>:data.list:atom_fresh_[1664]'(_atom__fresh___911665_93, __36Pb, __36Pe)), '<module>:data.list:atom_fresh_[1666]'(_atom__fresh___911667_93, __36Pb, __36Pe)), '<module>:data.list:atom_fresh_[1668]'(_atom__fresh___911669_93, __36Pb, __36Pe)), '<module>:data.list:atom_fresh_[1670]'(_atom__fresh___911671_93, __36Pb, __36Pe)), '<module>:data.list:atom_fresh_[1672]'(_atom__fresh___911673_93, __36Pb, __36Pe)), '<module>:data.list:atom_fresh_[1674]'(_atom__fresh___911675_93, __36Pb, __36Pe)), '<module>:data.list:atom_fresh_[1676]'(_atom__fresh___911677_93, __36Pb, __36Pe)), '<module>:data.list:atom_fresh_[1678]'(_atom__fresh___911679_93, __36Pb, __36Pe)), '<module>:data.list:atom_fresh_[1680]'(_atom__fresh___911681_93, __36Pb, __36Pe)), '<module>:data.list:atom_fresh_[1682]'(_atom__fresh___911683_93, __36Pb, __36Pe)), '<module>:data.list:atom_fresh_[1684]'(_atom__fresh___911685_93, __36Pb, __36Pe)), '<module>:data.list:atom_fresh_[1686]'(_atom__fresh___911687_93, __36Pb, __36Pe)), '<module>:data.list:atom_fresh_[1688]'(_atom__fresh___911689_93, __36Pb, __36Pe)), '<module>:data.list:atom_fresh_[1690]'(_atom__fresh___911691_93, __36Pb, __36Pe)), '<module>:data.list:atom_fresh_[1692]'(_atom__fresh___911693_93, __36Pb, __36Pe)), '<module>:data.list:atom_fresh_[1694]'(_atom__fresh___911695_93, __36Pb, __36Pe)), '<module>:data.list:atom_fresh_[1696]'(_atom__fresh___911697_93, __36Pb, __36Pe)), '<module>:data.list:atom_fresh_[1698]'(_atom__fresh___911699_93, __36Pb, __36Pe)), '<module>:data.list:atom_fresh_[1700]'(_atom__fresh___911701_93, __36Pb, __36Pe)), '<module>:data.list:atom_fresh_[1702]'(_atom__fresh___911703_93, __36Pb, __36Pe)), '<module>:data.list:atom_fresh_[1704]'(_atom__fresh___911705_93, __36Pb, __36Pe)), '<module>:data.list:atom_fresh_[1706]'(_atom__fresh___911707_93, __36Pb, __36Pe)), '<module>:data.list:atom_fresh_[1708]'(_atom__fresh___911709_93, __36Pb, __36Pe)), '<module>:data.list:atom_fresh_[1710]'(_atom__fresh___911711_93, __36Pb, __36Pe)), '<module>:data.list:atom_fresh_[1712]'(_atom__fresh___911713_93, __36Pb, __36Pe)), '<module>:data.list:atom_fresh_[1714]'(_atom__fresh___911715_93, __36Pb, __36Pe)), '<module>:data.list:atom_fresh_[1716]'(_atom__fresh___911717_93, __36Pb, __36Pe)), '<module>:data.list:atom_fresh_[1718]'(_atom__fresh___911719_93, __36Pb, __36Pe)), '<module>:data.list:atom_fresh_[1720]'(_atom__fresh___911721_93, __36Pb, __36Pe)), '<module>:data.list:atom_fresh_[1722]'(_atom__fresh___911723_93, __36Pb, __36Pe)), '<module>:data.list:atom_fresh_[1724]'(_atom__fresh___911725_93, __36Pb, __36Pe)), '<module>:data.list:atom_fresh_[1726]'(_atom__fresh___911727_93, __36Pb, __36Pe)), '<module>:data.list:atom_fresh_[1728]'(_atom__fresh___911729_93, __36Pb, __36Pe)), '<module>:data.list:atom_fresh_[1730]'(_atom__fresh___911731_93, __36Pb, __36Pe)), '<module>:data.list:atom_fresh_[1732]'(_atom__fresh___911733_93, __36Pb, __36Pe)), '<module>:data.list:atom_fresh_[1734]'(_atom__fresh___911735_93, __36Pb, __36Pe)), '<module>:data.list:atom_fresh_[1736]'(_atom__fresh___911737_93, __36Pb, __36Pe)), '<module>:data.list:atom_fresh_[1738]'(_atom__fresh___911739_93, __36Pb, __36Pe)), '<module>:data.list:atom_fresh_[1740]'(_atom__fresh___911741_93, __36Pb, __36Pe)), '<module>:data.list:atom_fresh_[1742]'(_atom__fresh___911743_93, __36Pb, __36Pe)), '<module>:data.list:atom_fresh_[1744]'(_atom__fresh___911745_93, __36Pb, __36Pe)), '<module>:data.list:atom_fresh_[1746]'(_atom__fresh___911747_93, __36Pb, __36Pe)), '<module>:data.list:atom_fresh_[1748]'(_atom__fresh___911749_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___911749_93, '.'(_atom__fresh___911747_93, '.'(_atom__fresh___911745_93, '.'(_atom__fresh___911743_93, '.'(_atom__fresh___911741_93, '.'(_atom__fresh___911739_93, '.'(_atom__fresh___911737_93, '.'(_atom__fresh___911735_93, '.'(_atom__fresh___911733_93, '.'(_atom__fresh___911731_93, '.'(_atom__fresh___911729_93, '.'(_atom__fresh___911727_93, '.'(_atom__fresh___911725_93, '.'(_atom__fresh___911723_93, '.'(_atom__fresh___911721_93, '.'(_atom__fresh___911719_93, '.'(_atom__fresh___911717_93, '.'(_atom__fresh___911715_93, '.'(_atom__fresh___911713_93, '.'(_atom__fresh___911711_93, '.'(_atom__fresh___911709_93, '.'(_atom__fresh___911707_93, '.'(_atom__fresh___911705_93, '.'(_atom__fresh___911703_93, '.'(_atom__fresh___911701_93, '.'(_atom__fresh___911699_93, '.'(_atom__fresh___911697_93, '.'(_atom__fresh___911695_93, '.'(_atom__fresh___911693_93, '.'(_atom__fresh___911691_93, '.'(_atom__fresh___911689_93, '.'(_atom__fresh___911687_93, '.'(_atom__fresh___911685_93, '.'(_atom__fresh___911683_93, '.'(_atom__fresh___911681_93, '.'(_atom__fresh___911679_93, '.'(_atom__fresh___911677_93, '.'(_atom__fresh___911675_93, '.'(_atom__fresh___911673_93, '.'(_atom__fresh___911671_93, '.'(_atom__fresh___911669_93, '.'(_atom__fresh___911667_93, '.'(_atom__fresh___911665_93, '.'(_atom__fresh___911663_93, '.'(_atom__fresh___911661_93, '.'(_atom__fresh___911659_93, '.'(_atom__fresh___911657_93, '.'(_atom__fresh___911655_93, '.'(_atom__fresh___911653_93, '.'(_atom__fresh___911651_93, '.'(_atom__fresh___911649_93, '[]'))))))))))))))))))))))))))))))))))))))))))))))))))))))))).
':-'('<module>:data.list:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.list:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.list:*'(_X, _Y, 'env', __36CutLevel), ','('='(_Y, ___26), ';'('='(___26, '[]'), ','('='(___27, _X), ','('='(___29, _X), ','('='(___28, ___33), ','(','('='(___26, ___31), ','('g_read'('data.list', '<module>:data.list'(___32)), '<module>:data.list:++$direct'(___27, ___28, ___31, ___32))), ','('g_read'('data.list', '<module>:data.list'(___34)), '<module>:data.list:*$direct'(___29, ___33, ___34))))))))).
':-'('<module>:data.list:*$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.list:*'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list:++'(_A, _B, ___24, 'env', __36CutLevel), ','('g_read'('data.list', '<module>:data.list'(___25)), '<module>:data.list:append$direct'(_A, _B, ___24, ___25))).
':-'('<module>:data.list:++$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.list:++'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list:=>'(___4, ___5, ___6, 'env', __36CutLevel), '=..'(___6, '.'('=>', '.'(___4, '.'(___5, '[]'))))).
':-'('<module>:data.list:=>$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.list:=>'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list:accumulate'(_Generator, _List, 'env', __36CutLevel), ';'('->'('emop_call'(_Generator, 'get'(_H), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/list.mpl\", line 302, from character 19 to 22'), ','('='(_List, '.'(_H, _T)), ','('g_read'('data.list', '<module>:data.list'(___131)), '<module>:data.list:accumulate$direct'(_Generator, _T, ___131)))), '='(_List, '[]'))).
':-'('<module>:data.list:accumulate$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.list:accumulate'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list:accumulate_sublists'(_Generator, _List, 'env', __36CutLevel), ';'('->'('emop_call'(_Generator, 'get'(_H), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/list.mpl\", line 312, from character 19 to 22'), ','(','('g_read'('data.list', '<module>:data.list'(___133)), '<module>:data.list:append$direct'(_H, _T, _List, ___133)), ','('g_read'('data.list', '<module>:data.list'(___134)), '<module>:data.list:accumulate_sublists$direct'(_Generator, _T, ___134)))), '='(_List, '[]'))).
':-'('<module>:data.list:accumulate_sublists$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.list:accumulate_sublists'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list:add_to_left'(_Item, _List, 'env', __36CutLevel), ','('='(_List, '.'(_Head, _Tail)), ','(','('g_read'('data.term', '<module>:data.term'(___17)), '<module>:data.term:setarg1$direct'(1, _List, _Item, ___17)), ','('g_read'('data.term', '<module>:data.term'(___19)), '<module>:data.term:setarg1$direct'(2, _List, '.'(_Head, _Tail), ___19))))).
':-'('<module>:data.list:add_to_left$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.list:add_to_left'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list:append'('[]', _L, _L, 'env', __36CutLevel), 'true').
':-'('<module>:data.list:append'('.'(_H, _T0), _L, '.'(_H, _T1), 'env', __36CutLevel), ','('g_read'('data.list', '<module>:data.list'(___23)), '<module>:data.list:append$direct'(_T0, _L, _T1, ___23))).
':-'('<module>:data.list:append$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.list:append'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list:atom_fresh_[1648]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(random_item, 3, predicate, suspended([var('Generator'),var('List'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:data.list:atom_fresh_[1650]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(stream, 2, predicate, suspended([var('List'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:data.list:atom_fresh_[1652]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(index1, 3, predicate, suspended([var('X'),var('L'),var('N')],[call(scope,nth1,[var('N'),var('L'),var('X')])]), __36pos))).
':-'('<module>:data.list:atom_fresh_[1654]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(nth1, 3, predicate, suspended([var('N'),var('L'),var('X')],[call(atom(kernel),list_nth1,[var('N'),var('L'),var('X')])]), __36pos))).
':-'('<module>:data.list:atom_fresh_[1656]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(member_partial, 3, predicate, '[]', __36pos))).
':-'('<module>:data.list:atom_fresh_[1658]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(select, 3, predicate, '[]', __36pos))).
':-'('<module>:data.list:atom_fresh_[1660]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(delete, 3, predicate, '[]', __36pos))).
':-'('<module>:data.list:atom_fresh_[1662]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(subst, 3, predicate, '[]', __36pos))).
':-'('<module>:data.list:atom_fresh_[1664]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(longuest_prefix, 2, predicate, suspended([none,none],[call(scope,longuest_prefix,[var('T0'),var('T1')])]), __36pos))).
':-'('<module>:data.list:atom_fresh_[1666]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(quick_sort, 3, predicate, '[]', __36pos))).
':-'('<module>:data.list:atom_fresh_[1668]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(split, 4, predicate, '[]', __36pos))).
':-'('<module>:data.list:atom_fresh_[1670]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(merge_sort, 3, predicate, '[]', __36pos))).
':-'('<module>:data.list:atom_fresh_[1672]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(merge, 4, predicate, '[]', __36pos))).
':-'('<module>:data.list:atom_fresh_[1674]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(split, 3, predicate, '[]', __36pos))).
':-'('<module>:data.list:atom_fresh_[1676]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(split_at_delim_left, 4, predicate, '[]', __36pos))).
':-'('<module>:data.list:atom_fresh_[1678]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(init, 4, predicate, '[]', __36pos))).
':-'('<module>:data.list:atom_fresh_[1680]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(accumulate_sublists, 2, predicate, '[]', __36pos))).
':-'('<module>:data.list:atom_fresh_[1682]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(accumulate, 2, predicate, '[]', __36pos))).
':-'('<module>:data.list:atom_fresh_[1684]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(zip, 3, predicate, suspended([none,none,none],[call(scope,true,[])]), __36pos))).
':-'('<module>:data.list:atom_fresh_[1686]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(iter_fold, 5, predicate, suspended([none,none,var('Value'),var('_'),var('Value')],[call(scope,true,[])]), __36pos))).
':-'('<module>:data.list:atom_fresh_[1688]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fold_right, 4, predicate, suspended([none,var('Value'),var('_'),var('Value')],[call(scope,true,[])]), __36pos))).
':-'('<module>:data.list:atom_fresh_[1690]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fold_left, 4, predicate, suspended([none,var('Value'),var('_'),var('Value')],[call(scope,true,[])]), __36pos))).
':-'('<module>:data.list:atom_fresh_[1692]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(morph, 3, predicate, '[]', __36pos))).
':-'('<module>:data.list:atom_fresh_[1694]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(reverse_iter, 2, predicate, '[]', __36pos))).
':-'('<module>:data.list:atom_fresh_[1696]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(iter, 4, predicate, '[]', __36pos))).
':-'('<module>:data.list:atom_fresh_[1698]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(mapi, 3, predicate, suspended([var('L'),var('F'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:data.list:atom_fresh_[1700]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(map, 3, predicate, suspended([var('L'),var('F'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:data.list:atom_fresh_[1702]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(iteri_from, 4, predicate, '[]', __36pos))).
':-'('<module>:data.list:atom_fresh_[1704]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(iteri, 3, predicate, suspended([var('L'),var('F'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:data.list:atom_fresh_[1706]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(iter, 3, predicate, '[]', __36pos))).
':-'('<module>:data.list:atom_fresh_[1708]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(iteri_from, 3, predicate, '[]', __36pos))).
':-'('<module>:data.list:atom_fresh_[1710]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(iteri, 2, predicate, suspended([var('L'),var('F')],[call(scope,iteri_from,[var('L'),none,var('F')])]), __36pos))).
':-'('<module>:data.list:atom_fresh_[1712]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(iter, 2, predicate, '[]', __36pos))).
':-'('<module>:data.list:atom_fresh_[1714]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(reverse_append, 3, predicate, '[]', __36pos))).
':-'('<module>:data.list:atom_fresh_[1716]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(reverse, 2, predicate, suspended([var('L0'),var('L1')],[call(scope,reverse_append,[var('L0'),none,var('L1')])]), __36pos))).
':-'('<module>:data.list:atom_fresh_[1718]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(join_with_prefix, 3, predicate, '[]', __36pos))).
':-'('<module>:data.list:atom_fresh_[1720]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(join, 3, predicate, '[]', __36pos))).
':-'('<module>:data.list:atom_fresh_[1722]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(flatten, 2, predicate, '[]', __36pos))).
':-'('<module>:data.list:atom_fresh_[1724]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(*, 2, predicate, '[]', __36pos))).
':-'('<module>:data.list:atom_fresh_[1726]'(__36s, __36Pb, __36Pe), '='(__36s, 'syntax'('.'('callable'('++', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('<', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('postfix', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('*', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('<', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'(':', 'escaped', 'none', __36Pb, __36Pe), '[]')))))), __36Pb, __36Pe))).
':-'('<module>:data.list:atom_fresh_[1728]'(__36s, __36Pb, __36Pe), '='(__36s, 'syntax'('.'('callable'('postfix', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('*', 'escaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe))).
':-'('<module>:data.list:atom_fresh_[1730]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(++, 3, predicate, suspended([var('A'),var('B'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:data.list:atom_fresh_[1732]'(__36s, __36Pb, __36Pe), '='(__36s, 'syntax'('.'('callable'('prefix', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('|', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('<', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('++', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('<', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'(':', 'escaped', 'none', __36Pb, __36Pe), '[]')))))), __36Pb, __36Pe))).
':-'('<module>:data.list:atom_fresh_[1734]'(__36s, __36Pb, __36Pe), '='(__36s, 'syntax'('.'('callable'('infix', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('right', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('associative', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('++', 'escaped', 'none', __36Pb, __36Pe), '[]')))), __36Pb, __36Pe))).
':-'('<module>:data.list:atom_fresh_[1736]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(append, 3, predicate, '[]', __36pos))).
':-'('<module>:data.list:atom_fresh_[1738]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(add_to_left, 2, predicate, '[]', __36pos))).
':-'('<module>:data.list:atom_fresh_[1740]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(member_last, 2, predicate, suspended([var('H'),none],[call(scope,member_last,[var('H'),var('T')])]), __36pos))).
':-'('<module>:data.list:atom_fresh_[1742]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(member, 2, predicate, '[]', __36pos))).
':-'('<module>:data.list:atom_fresh_[1744]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(length, 2, predicate, suspended([var('List'),var('N')],[call(atom(kernel),list_length,[var('List'),var('N')])]), __36pos))).
':-'('<module>:data.list:atom_fresh_[1746]'(__36s, __36Pb, __36Pe), '='(__36s, 'syntax'('.'('callable'('infix', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('=>', 'escaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe))).
':-'('<module>:data.list:atom_fresh_[1748]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(=>, 3, constructor, none, __36pos))).
':-'('<module>:data.list:delete'('[]', _, '[]', 'env', __36CutLevel), 'true').
':-'('<module>:data.list:delete'('.'(_H, _T), _X, _L, 'env', __36CutLevel), ','(';'('->'('='(_X, _H), '='(_L, _U)), '='(_L, '.'(_H, _U))), ','('g_read'('data.list', '<module>:data.list'(___224)), '<module>:data.list:delete$direct'(_T, _X, _U, ___224)))).
':-'('<module>:data.list:delete$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.list:delete'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list:flatten'('[]', '[]', 'env', __36CutLevel), 'true').
':-'('<module>:data.list:flatten'('.'(_H, _T), _L, 'env', __36CutLevel), ','(','('g_read'('data.list', '<module>:data.list'(___38)), '<module>:data.list:append$direct'(_H, _LT, _L, ___38)), ','('g_read'('data.list', '<module>:data.list'(___39)), '<module>:data.list:flatten$direct'(_T, _LT, ___39)))).
':-'('<module>:data.list:flatten$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.list:flatten'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list:fold_left'('[]', _Value, _, _Value, 'env', __36CutLevel), 'true').
':-'('<module>:data.list:fold_left'('.'(_H, _T), _Value, _F, ___105, 'env', __36CutLevel), ','('emop_call'(_F, 'do'(_H, _Value, ___104), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/list.mpl\", line 249, from character 61 to 63'), ','('g_read'('data.list', '<module>:data.list'(___106)), '<module>:data.list:fold_left$direct'(_T, ___104, _F, ___105, ___106)))).
':-'('<module>:data.list:fold_left$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.list:fold_left'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list:fold_right'('[]', _Value, _, _Value, 'env', __36CutLevel), 'true').
':-'('<module>:data.list:fold_right'('.'(_H, _T), _Value, _F, ___112, 'env', __36CutLevel), ','(','('g_read'('data.list', '<module>:data.list'(___111)), '<module>:data.list:fold_right$direct'(_T, _Value, _F, ___110, ___111)), 'emop_call'(_F, 'do'(_H, ___110, ___112), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/list.mpl\", line 264, from character 37 to 39'))).
':-'('<module>:data.list:fold_right$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.list:fold_right'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list:index1'(_X, _L, _N, 'env', __36CutLevel), ','('g_read'('data.list', '<module>:data.list'(___238)), '<module>:data.list:nth1$direct'(_N, _L, _X, ___238))).
':-'('<module>:data.list:index1$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.list:index1'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list:init'(_I, _J, _Init, _List, 'env', __36CutLevel), ';'('->'(','('g_read'('data.number', '<module>:data.number'(___137)), '<module>:data.number:=<$direct'(_I, _J, ___137)), ','(','('='(_List, '.'(___138, _Tail)), 'emop_call'(_Init, 'get'(_I, ___138), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/list.mpl\", line 340, from character 22 to 25')), ','(','('g_read'('data.number', '<module>:data.number'(___142)), '<module>:data.number:succ$direct'(_I, ___141, ___142)), ','('g_read'('data.list', '<module>:data.list'(___143)), '<module>:data.list:init$direct'(___141, _J, _Init, _Tail, ___143))))), '='(_List, '[]'))).
':-'('<module>:data.list:init$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.list:init'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list:iter'('[]', _, 'env', __36CutLevel), 'true').
':-'('<module>:data.list:iter'('.'(_H, _T), _F, 'env', __36CutLevel), ','('emop_call'(_F, 'do'(_H), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/list.mpl\", line 136, from character 8 to 10'), ','('g_read'('data.list', '<module>:data.list'(___59)), '<module>:data.list:iter$direct'(_T, _F, ___59)))).
':-'('<module>:data.list:iter'('[]', _, '[]', 'env', __36CutLevel), 'true').
':-'('<module>:data.list:iter'('.'(_H0, _T0), _F, '.'(_H1, _T1), 'env', __36CutLevel), ','('emop_call'(_F, 'do'(_H0, _H1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/list.mpl\", line 163, from character 8 to 10'), ','('g_read'('data.list', '<module>:data.list'(___71)), '<module>:data.list:iter$direct'(_T0, _F, _T1, ___71)))).
':-'('<module>:data.list:iter'('[]', '[]', '[]', _, 'env', __36CutLevel), 'true').
':-'('<module>:data.list:iter'('.'(_H0, _T0), '.'(_H1, _T1), '.'(_H2, _T2), _F, 'env', __36CutLevel), ','('emop_call'(_F, 'do'(_H0, _H1, _H2), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/list.mpl\", line 196, from character 8 to 10'), ','('g_read'('data.list', '<module>:data.list'(___92)), '<module>:data.list:iter$direct'(_T0, _T1, _T2, _F, ___92)))).
':-'('<module>:data.list:iter$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.list:iter'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list:iter$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.list:iter'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list:iter$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.list:iter'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list:iter_fold'('[]', '[]', _Value, _, _Value, 'env', __36CutLevel), 'true').
':-'('<module>:data.list:iter_fold'('.'(_H0, _T0), '.'(_H1, _T1), _Value, _F, ___119, 'env', __36CutLevel), ','('emop_call'(_F, 'do'(_H0, _H1, _Value, ___118), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/list.mpl\", line 284, from character 38 to 40'), ','('g_read'('data.list', '<module>:data.list'(___120)), '<module>:data.list:iter_fold$direct'(_T0, _T1, ___118, _F, ___119, ___120)))).
':-'('<module>:data.list:iter_fold$direct'(_____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.list:iter_fold'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list:iteri'(_L, _F, 'env', __36CutLevel), ','('g_read'('data.list', '<module>:data.list'(___60)), '<module>:data.list:iteri_from$direct'(_L, 1, _F, ___60))).
':-'('<module>:data.list:iteri'(_L, _F, ___72, 'env', __36CutLevel), ','('g_read'('data.list', '<module>:data.list'(___73)), '<module>:data.list:iteri_from$direct'(_L, 1, _F, ___72, ___73))).
':-'('<module>:data.list:iteri$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.list:iteri'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list:iteri$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.list:iteri'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list:iteri_from'('[]', _, _, 'env', __36CutLevel), 'true').
':-'('<module>:data.list:iteri_from'('.'(_H, _T), _N, _F, 'env', __36CutLevel), ','('emop_call'(_F, 'do'(_H, _N), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/list.mpl\", line 144, from character 8 to 10'), ','(','('g_read'('data.number', '<module>:data.number'(___65)), '<module>:data.number:succ$direct'(_N, ___64, ___65)), ','('g_read'('data.list', '<module>:data.list'(___66)), '<module>:data.list:iteri_from$direct'(_T, ___64, _F, ___66))))).
':-'('<module>:data.list:iteri_from'('[]', _, _, '[]', 'env', __36CutLevel), 'true').
':-'('<module>:data.list:iteri_from'('.'(_H0, _T0), _N, _F, '.'(_H1, _T1), 'env', __36CutLevel), ','('emop_call'(_F, 'do'(_H0, _N, _H1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/list.mpl\", line 170, from character 8 to 10'), ','(','('g_read'('data.number', '<module>:data.number'(___80)), '<module>:data.number:succ$direct'(_N, ___79, ___80)), ','('g_read'('data.list', '<module>:data.list'(___81)), '<module>:data.list:iteri_from$direct'(_T0, ___79, _F, _T1, ___81))))).
':-'('<module>:data.list:iteri_from$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.list:iteri_from'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list:iteri_from$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.list:iteri_from'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list:join'('[]', _, '[]', 'env', __36CutLevel), 'true').
':-'('<module>:data.list:join'('.'(_H, _T), _Delim, _L, 'env', __36CutLevel), ','(','('g_read'('data.list', '<module>:data.list'(___43)), '<module>:data.list:append$direct'(_H, _LT, _L, ___43)), ','('g_read'('data.list', '<module>:data.list'(___44)), '<module>:data.list:join_with_prefix$direct'(_T, _Delim, _LT, ___44)))).
':-'('<module>:data.list:join$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.list:join'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list:join_with_prefix'('[]', _, '[]', 'env', __36CutLevel), 'true').
':-'('<module>:data.list:join_with_prefix'('.'(_H, _T), _Delim, _L, 'env', __36CutLevel), ','(','('g_read'('data.list', '<module>:data.list'(___48)), '<module>:data.list:append$direct'(_Delim, _L0, _L, ___48)), ','(','('g_read'('data.list', '<module>:data.list'(___49)), '<module>:data.list:append$direct'(_H, _L1, _L0, ___49)), ','('g_read'('data.list', '<module>:data.list'(___50)), '<module>:data.list:join_with_prefix$direct'(_T, _Delim, _L1, ___50))))).
':-'('<module>:data.list:join_with_prefix$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.list:join_with_prefix'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list:length'(_List, _N, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___8)), '<module>:kernel:list_length$direct'(_List, _N, ___8))).
':-'('<module>:data.list:length$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.list:length'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list:longuest_prefix'('.'(_H, _T0), '.'(_H, _T1), 'env', __36CutLevel), ','('g_read'('data.list', '<module>:data.list'(___210)), '<module>:data.list:longuest_prefix$direct'(_T0, _T1, ___210))).
':-'('<module>:data.list:longuest_prefix'('[]', _, 'env', __36CutLevel), 'true').
':-'('<module>:data.list:longuest_prefix$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.list:longuest_prefix'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list:map'(_L, _F, ___82, 'env', __36CutLevel), ','('g_read'('data.list', '<module>:data.list'(___83)), '<module>:data.list:iter$direct'(_L, _F, ___82, ___83))).
':-'('<module>:data.list:map$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.list:map'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list:mapi'(_L, _F, ___84, 'env', __36CutLevel), ','('g_read'('data.list', '<module>:data.list'(___85)), '<module>:data.list:iteri$direct'(_L, _F, ___84, ___85))).
':-'('<module>:data.list:mapi$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.list:mapi'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list:member'(_H, '.'(_H, _), 'env', __36CutLevel), 'true').
':-'('<module>:data.list:member'(_H, '.'(_, _T), 'env', __36CutLevel), ','('g_read'('data.list', '<module>:data.list'(___11)), '<module>:data.list:member$direct'(_H, _T, ___11))).
':-'('<module>:data.list:member$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.list:member'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list:member_last'(_H, '.'(_, _T), 'env', __36CutLevel), ','('g_read'('data.list', '<module>:data.list'(___13)), '<module>:data.list:member_last$direct'(_H, _T, ___13))).
':-'('<module>:data.list:member_last'(_H, '.'(_H, _), 'env', __36CutLevel), 'true').
':-'('<module>:data.list:member_last$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.list:member_last'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list:member_partial'(_X, _L, _New, 'env', __36CutLevel), ';'('->'(','('g_read'('data.var', '<module>:data.var'(___230)), '<module>:data.var:check$direct'(_L, ___230)), ','('='(_New, 'true'), '='(_L, '.'(_X, _)))), ';'('->'('='(_L, '.'(_X, _)), 'true'), ','('='(_L, '.'(_, _T)), ','('g_read'('data.list', '<module>:data.list'(___235)), '<module>:data.list:member_partial$direct'(_X, _T, _New, ___235)))))).
':-'('<module>:data.list:member_partial$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.list:member_partial'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list:merge'(_L0, _L1, _Preorder, _L, 'env', __36CutLevel), ';'('->'('='(_L0, '.'(_H0, _T0)), ';'('->'('='(_L1, '.'(_H1, _T1)), ','('emop_call'(_Preorder, 'compare'(_H0, _H1, _R), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/list.mpl\", line 404, from character 21 to 28'), ';'('->'('='(_R, '>'), ','('='(_L, '.'(_H1, _T)), ','('g_read'('data.list', '<module>:data.list'(___158)), '<module>:data.list:merge$direct'(_L0, _T1, _Preorder, _T, ___158)))), ','('='(_L, '.'(_H0, _T)), ','('g_read'('data.list', '<module>:data.list'(___160)), '<module>:data.list:merge$direct'(_T0, _L1, _Preorder, _T, ___160)))))), ','('='(_L1, '[]'), '='(_L, _L0)))), ','('='(_L0, '[]'), '='(_L, _L1)))).
':-'('<module>:data.list:merge$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.list:merge'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list:merge_sort'(_List, _Preorder, _Sorted, 'env', __36CutLevel), ';'('->'(';'('='(_List, '[]'), '='(_List, '.'(_, '[]'))), '='(_Sorted, _List)), ','(','('='(_Singletons, ___173), ','(','('true', ';'('->'('var'(___167), ','('g_inc'('$module_count', ___168), '='(___167, '$module'(___168, '.'('<module>:data.list@0'('env'(___167)), '[]'), '.'(___167, '[]'))))), ','('='(___167, '$module'(___168, ___169, _)), ','('='('.'(___170, ___171), ___169), ','('setarg'(1, ___169, '<module>:data.list@0'('env'(___167))), 'setarg'(2, ___169, '.'(___170, ___171))))))), ','('g_read'('data.list', '<module>:data.list'(___174)), '<module>:data.list:iter$direct'(_List, ___167, ___173, ___174)))), ','(','('true', ';'('->'('var'(_Merge), ','('g_inc'('$module_count', ___175), '='(_Merge, '$module'(___175, '.'('<module>:data.list@1'('env'(_Merge, _Preorder)), '[]'), '.'(_Merge, '[]'))))), ','('='(_Merge, '$module'(___175, ___176, _)), ','('='('.'(___177, ___178), ___176), ','('setarg'(1, ___176, '<module>:data.list@1'('env'(_Merge, _Preorder))), 'setarg'(2, ___176, '.'(___177, ___178))))))), ','(','('true', ';'('->'('var'(_Aux), ','('g_inc'('$module_count', ___180), '='(_Aux, '$module'(___180, '.'('<module>:data.list@2'('env'(_Aux, _Merge, _Sorted)), '[]'), '.'(_Aux, '[]'))))), ','('='(_Aux, '$module'(___180, ___181, _)), ','('='('.'(___182, ___183), ___181), ','('setarg'(1, ___181, '<module>:data.list@2'('env'(_Aux, _Merge, _Sorted))), 'setarg'(2, ___181, '.'(___182, ___183))))))), 'emop_call'(_Aux, 'do'(_Singletons), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/list.mpl\", line 477, from character 13 to 15')))))).
':-'('<module>:data.list:merge_sort$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.list:merge_sort'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list:morph'('[]', _, '[]', 'env', __36CutLevel), 'true').
':-'('<module>:data.list:morph'('.'(_H, _T), _F, _List, 'env', __36CutLevel), ','('emop_call'(_F, 'do'(_H, _P), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/list.mpl\", line 232, from character 8 to 10'), ','(','('g_read'('data.list', '<module>:data.list'(___99)), '<module>:data.list:append$direct'(_P, _Tail, _List, ___99)), ','('g_read'('data.list', '<module>:data.list'(___100)), '<module>:data.list:morph$direct'(_T, _F, _Tail, ___100))))).
':-'('<module>:data.list:morph$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.list:morph'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list:nth1'(_N, _L, _X, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___237)), '<module>:kernel:list_nth1$direct'(_N, _L, _X, ___237))).
':-'('<module>:data.list:nth1$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.list:nth1'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list:quick_sort'(_List, _Preorder, _Sorted, 'env', __36CutLevel), ';'('->'(';'('='(_List, '[]'), '='(_List, '.'(_, '[]'))), '='(_Sorted, _List)), ','('='(_List, '.'(_P, _T)), ','(','(','('true', ';'('->'('var'(___197), ','('g_inc'('$module_count', ___198), '='(___197, '$module'(___198, '.'('<module>:data.list@3'('env'(___197, _Preorder, _P)), '[]'), '.'(___197, '[]'))))), ','('='(___197, '$module'(___198, ___199, _)), ','('='('.'(___200, ___201), ___199), ','('setarg'(1, ___199, '<module>:data.list@3'('env'(___197, _Preorder, _P))), 'setarg'(2, ___199, '.'(___200, ___201))))))), ','('g_read'('data.list', '<module>:data.list'(___203)), '<module>:data.list:split$direct'(_T, _List0, _List1, ___197, ___203))), ','(','('g_read'('data.list', '<module>:data.list'(___204)), '<module>:data.list:quick_sort$direct'(_List0, _Preorder, _Sorted0, ___204)), ','(','('g_read'('data.list', '<module>:data.list'(___205)), '<module>:data.list:quick_sort$direct'(_List1, _Preorder, _Sorted1, ___205)), ','('g_read'('data.list', '<module>:data.list'(___207)), '<module>:data.list:append$direct'(_Sorted0, '.'(_P, _Sorted1), _Sorted, ___207)))))))).
':-'('<module>:data.list:quick_sort$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.list:quick_sort'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list:random_item'(_Generator, _List, ___251, 'env', __36CutLevel), ','(','(','('g_read'('data.list', '<module>:data.list'(___249)), '<module>:data.list:length$direct'(_List, ___248, ___249)), 'emop_call'(_Generator, 'random'(1, ___248, ___250), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/list.mpl\", line 635, from character 21 to 27')), ','('g_read'('data.list', '<module>:data.list'(___252)), '<module>:data.list:nth1$direct'(___250, _List, ___251, ___252)))).
':-'('<module>:data.list:random_item$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.list:random_item'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list:reverse'(_L0, _L1, 'env', __36CutLevel), ','('g_read'('data.list', '<module>:data.list'(___52)), '<module>:data.list:reverse_append$direct'(_L0, '[]', _L1, ___52))).
':-'('<module>:data.list:reverse$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.list:reverse'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list:reverse_append'('[]', _L, _L, 'env', __36CutLevel), 'true').
':-'('<module>:data.list:reverse_append'('.'(_H, _T), _L, _R, 'env', __36CutLevel), ','('g_read'('data.list', '<module>:data.list'(___56)), '<module>:data.list:reverse_append$direct'(_T, '.'(_H, _L), _R, ___56))).
':-'('<module>:data.list:reverse_append$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.list:reverse_append'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list:reverse_iter'('[]', _, 'env', __36CutLevel), 'true').
':-'('<module>:data.list:reverse_iter'('.'(_H, _T), _F, 'env', __36CutLevel), ','(','('g_read'('data.list', '<module>:data.list'(___95)), '<module>:data.list:reverse_iter$direct'(_T, _F, ___95)), 'emop_call'(_F, 'do'(_H), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/list.mpl\", line 212, from character 8 to 10'))).
':-'('<module>:data.list:reverse_iter$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.list:reverse_iter'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list:select'(_X, '.'(_X, _T), _T, 'env', __36CutLevel), 'true').
':-'('<module>:data.list:select'(_X, '.'(_Y, _T), '.'(_Y, _U), 'env', __36CutLevel), ','('g_read'('data.list', '<module>:data.list'(___228)), '<module>:data.list:select$direct'(_X, _T, _U, ___228))).
':-'('<module>:data.list:select$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.list:select'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list:split'(_L, _Delim, _LL, 'env', __36CutLevel), ';'('->'(','('g_read'('data.list', '<module>:data.list'(___149)), '<module>:data.list:split_at_delim_left$direct'(_L, _Delim, _H, _T, ___149)), ','('='(_LL, '.'(_H, _TL)), ','('g_read'('data.list', '<module>:data.list'(___151)), '<module>:data.list:split$direct'(_T, _Delim, _TL, ___151)))), '='(_LL, '.'(_L, '[]')))).
':-'('<module>:data.list:split'('[]', '[]', '[]', _, 'env', __36CutLevel), 'true').
':-'('<module>:data.list:split'('.'(_H, _T), _ListTrue, _ListFail, _Select, 'env', __36CutLevel), ';'('->'('emop_call'(_Select, 'do'(_H), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/list.mpl\", line 497, from character 16 to 18'), ','('='(_ListTrue, '.'(_H, _TT)), ','('g_read'('data.list', '<module>:data.list'(___190)), '<module>:data.list:split$direct'(_T, _TT, _ListFail, _Select, ___190)))), ','('='(_ListFail, '.'(_H, _TF)), ','('g_read'('data.list', '<module>:data.list'(___192)), '<module>:data.list:split$direct'(_T, _ListTrue, _TF, _Select, ___192))))).
':-'('<module>:data.list:split$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.list:split'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list:split$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.list:split'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list:split_at_delim_left'('.'(_H, _T), _Delim, _L0, _L1, 'env', __36CutLevel), ';'('->'('='(_H, _Delim), ','('='(_L0, '[]'), '='(_L1, _T))), ','('='(_L0, '.'(_H, _T0)), ','('g_read'('data.list', '<module>:data.list'(___148)), '<module>:data.list:split_at_delim_left$direct'(_T, _Delim, _T0, _L1, ___148))))).
':-'('<module>:data.list:split_at_delim_left$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.list:split_at_delim_left'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list:stream'(_List, ___242, 'env', __36CutLevel), ','(','('='(_Contents, ___240), ','('g_read'('data.ref.backtrackable', '<module>:data.ref.backtrackable'(___241)), '<module>:data.ref.backtrackable:new$direct'(_List, ___240, ___241))), ','('true', ';'('->'('var'(___242), ','('g_inc'('$module_count', ___243), '='(___242, '$module'(___243, '.'('<module>:data.list@5'('env'(___242, _Contents, _List)), '[]'), '.'(___242, '[]'))))), ','('='(___242, '$module'(___243, ___244, _)), ','('='('.'(___245, ___246), ___244), ','('setarg'(1, ___244, '<module>:data.list@5'('env'(___242, _Contents, _List))), 'setarg'(2, ___244, '.'(___245, ___246))))))))).
':-'('<module>:data.list:stream$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.list:stream'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list:subst'(_Src, _Table, _Tgt, 'env', __36CutLevel), ';'('->'('='(_Src, '[]'), '='(_Tgt, '[]')), ','(','('true', ';'('->'('var'(___214), ','('g_inc'('$module_count', ___215), '='(___214, '$module'(___215, '.'('<module>:data.list@4'('env'(___214, _Table)), '[]'), '.'(___214, '[]'))))), ','('='(___214, '$module'(___215, ___216, _)), ','('='('.'(___217, ___218), ___216), ','('setarg'(1, ___216, '<module>:data.list@4'('env'(___214, _Table))), 'setarg'(2, ___216, '.'(___217, ___218))))))), 'emop_call'(___214, 'find'(_Table, _Src, _Tgt), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/list.mpl\", line 582, from character 11 to 15')))).
':-'('<module>:data.list:subst$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.list:subst'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list:zip'('[]', '[]', '[]', 'env', __36CutLevel), 'true').
':-'('<module>:data.list:zip'('.'(_X, _Xs), '.'(_Y, _Ys), '.'(','(_X, _Y), ___127), 'env', __36CutLevel), ','('g_read'('data.list', '<module>:data.list'(___128)), '<module>:data.list:zip$direct'(_Xs, _Ys, ___127, ___128))).
':-'('<module>:data.list:zip$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.list:zip'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list@0'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.list@0:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.list@0'('do'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.list@0:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list@0'(__36t, __36env, __36pos, __36CutLevel), '<module>:data.list@0$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:data.list@0$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:data.list@0$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:data.list@0$has_predicate'('do'(_____2, _____1)), 'true').
':-'('<module>:data.list@0:$sgn'(__36sgn, 'env'(___172), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/list.mpl',14663,446,14629)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/list.mpl',14678,446,14629)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:data.list@0:atom_fresh_[1760]'(_atom__fresh___911761_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___911761_93, '[]'))))))).
':-'('<module>:data.list@0:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.list@0:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.list@0:atom_fresh_[1760]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 2, predicate, suspended([var('X'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:data.list@0:do'(_X, '.'(_X, '[]'), 'env'(___172), __36CutLevel), 'true').
':-'('<module>:data.list@0:do$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.list@0:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list@1'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.list@1:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.list@1'('do'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.list@1:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list@1'(__36t, __36env, __36pos, __36CutLevel), '<module>:data.list@1$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:data.list@1$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:data.list@1$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:data.list@1$has_predicate'('do'(_____2, _____1)), 'true').
':-'('<module>:data.list@1:$sgn'(__36sgn, 'env'(___179, _Preorder), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/list.mpl',14725,449,14716)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/list.mpl',14750,449,14716)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:data.list@1:atom_fresh_[1758]'(_atom__fresh___911759_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___911759_93, '[]'))))))).
':-'('<module>:data.list@1:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.list@1:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.list@1:atom_fresh_[1758]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 2, predicate, '[]', __36pos))).
':-'('<module>:data.list@1:do'(_L0, _L1, 'env'(___179, _Preorder), __36CutLevel), ';'('->'(';'('='(_L0, '[]'), '='(_L0, '.'(_, '[]'))), '='(_L1, _L0)), '->'('='(_L0, '.'(_A, '.'(_B, _T0))), ','(','('='(_L1, '.'(___275, _T1)), ','('g_read'('data.list', '<module>:data.list'(___276)), '<module>:data.list:merge$direct'(_A, _B, _Preorder, ___275, ___276))), 'emop_call'(___179, 'do'(_T0, _T1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/list.mpl\", line 464, from character 18 to 20'))))).
':-'('<module>:data.list@1:do$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.list@1:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list@2'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.list@2:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.list@2'('do'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.list@2:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.list@2'(__36t, __36env, __36pos, __36CutLevel), '<module>:data.list@2$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:data.list@2$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:data.list@2$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:data.list@2$has_predicate'('do'(_____1)), 'true').
':-'('<module>:data.list@2:$sgn'(__36sgn, 'env'(___184, _Merge, _Sorted), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/list.mpl',15160,466,15151)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/list.mpl',15188,466,15151)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:data.list@2:atom_fresh_[1756]'(_atom__fresh___911757_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___911757_93, '[]'))))))).
':-'('<module>:data.list@2:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.list@2:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.list@2:atom_fresh_[1756]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 1, predicate, '[]', __36pos))).
':-'('<module>:data.list@2:do'(_LL, 'env'(___184, _Merge, _Sorted), __36CutLevel), ';'('->'('='(_LL, '.'(_Sorted0, '[]')), '='(_Sorted, _Sorted0)), ','('emop_call'(_Merge, 'do'(_LL, ___268), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/list.mpl\", line 474, from character 27 to 29'), 'emop_call'(___184, 'do'(___268), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/list.mpl\", line 474, from character 18 to 20')))).
':-'('<module>:data.list@2:do$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.list@2:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.list@3'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.list@3:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.list@3'('do'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.list@3:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.list@3'(__36t, __36env, __36pos, __36CutLevel), '<module>:data.list@3$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:data.list@3$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:data.list@3$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:data.list@3$has_predicate'('do'(_____1)), 'true').
':-'('<module>:data.list@3:$sgn'(__36sgn, 'env'(___202, _Preorder, _P), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/list.mpl',17373,530,17364)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/list.mpl',17411,530,17364)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:data.list@3:atom_fresh_[1754]'(_atom__fresh___911755_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___911755_93, '[]'))))))).
':-'('<module>:data.list@3:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.list@3:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.list@3:atom_fresh_[1754]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 1, predicate, suspended([var('X')],[call(var('Preorder'),compare,[var('X'),var('P'),none])]), __36pos))).
':-'('<module>:data.list@3:do'(_X, 'env'(___202, _Preorder, _P), __36CutLevel), 'emop_call'(_Preorder, 'compare'(_X, _P, '<'), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/list.mpl\", line 533, from character 24 to 31')).
':-'('<module>:data.list@3:do$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.list@3:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.list@4'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.list@4:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.list@4'('find'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.list@4:find'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list@4'(__36t, __36env, __36pos, __36CutLevel), '<module>:data.list@4$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:data.list@4$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:data.list@4$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:data.list@4$has_predicate'('find'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.list@4:$sgn'(__36sgn, 'env'(___219, _Table), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/list.mpl',18560,569,18551)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/list.mpl',18576,569,18551)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:data.list@4:atom_fresh_[1752]'(_atom__fresh___911753_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___911753_93, '[]'))))))).
':-'('<module>:data.list@4:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.list@4:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.list@4:atom_fresh_[1752]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(find, 3, predicate, suspended([none,none,none],[call(scope,subst,[var('SrcTail'),var('Table'),var('TgtTail')])]), __36pos))).
':-'('<module>:data.list@4:find'('[]', '.'(_H, _SrcTail), '.'(_H, _TgtTail), 'env'(___219, _Table), __36CutLevel), ','('g_read'('data.list', '<module>:data.list'(___259)), '<module>:data.list:subst$direct'(_SrcTail, _Table, _TgtTail, ___259))).
':-'('<module>:data.list@4:find'('.'('=>'(_From, _To), _TableTail), _Src, _Tgt, 'env'(___219, _Table), __36CutLevel), ';'('->'(','('g_read'('data.list', '<module>:data.list'(___262)), '<module>:data.list:append$direct'(_From, _SrcTail, _Src, ___262)), ','(','('g_read'('data.list', '<module>:data.list'(___263)), '<module>:data.list:append$direct'(_To, _TgtTail, _Tgt, ___263)), ','('g_read'('data.list', '<module>:data.list'(___264)), '<module>:data.list:subst$direct'(_SrcTail, _Table, _TgtTail, ___264)))), 'emop_call'(___219, 'find'(_TableTail, _Src, _Tgt), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/list.mpl\", line 580, from character 18 to 22'))).
':-'('<module>:data.list@4:find$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.list@4:find'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.list@5'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.list@5:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.list@5'('read'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.list@5:read'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.list@5'(__36t, __36env, __36pos, __36CutLevel), '<module>:data.list@5$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:data.list@5$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:data.list@5$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:data.list@5$has_predicate'('read'(_____1)), 'true').
':-'('<module>:data.list@5:$sgn'(__36sgn, 'env'(___247, _Contents, _List), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/list.mpl',19696,622,19690)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/list.mpl',19704,622,19690)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:data.list@5:atom_fresh_[1750]'(_atom__fresh___911751_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___911751_93, '[]'))))))).
':-'('<module>:data.list@5:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.list@5:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.list@5:atom_fresh_[1750]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(read, 1, predicate, '[]', __36pos))).
':-'('<module>:data.list@5:read'(_H, 'env'(___247, _Contents, _List), __36CutLevel), ';'('->'(','('='(___253, '.'(_H, _T)), 'emop_call'(_Contents, 'get'(___253), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/list.mpl\", line 626, from character 24 to 27')), 'emop_call'(_Contents, 'set'(_T), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/list.mpl\", line 628, from character 24 to 27')), '='(_H, 'end_of_file'))).
':-'('<module>:data.list@5:read$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.list@5:read'(_____1, __36env, __36CutLevel))).
':-'('data.list@init', ','('true', 'g_link'('data.list', '<module>:data.list'('env')))).
':-'('dynamic'('/'('<module>:data.number$dynamic', 4))).
':-'('<module>:data.number'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.number:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.number'('check'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.number:check'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.number'('>='(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.number:>='(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.number'('>='(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.number:>='(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.number'('>'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.number:>'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.number'('>'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.number:>'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.number'('=<'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.number:=<'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.number'('=<'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.number:=<'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.number'('<'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.number:<'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.number'('<'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.number:<'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.number'('pred'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.number:pred'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.number'('succ'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.number:succ'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.number'('+'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.number:+'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.number'('-'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.number:-'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.number'('+'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.number:+'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.number'('-'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.number:-'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.number'('*'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.number:*'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.number'('/'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.number:/'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.number'('quo'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.number:quo'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.number'('mod'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.number:mod'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.number'('|++'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.number:|++'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.number'('|++'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.number:|++'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.number'('++|'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.number:++|'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.number'('|--'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.number:|--'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.number'('|--'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.number:|--'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.number'('--|'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.number:--|'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.number'('atom'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.number:atom'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.number'('iter'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.number:iter'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.number'('..'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.number:..'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.number'('char'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.number:char'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.number'('random'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.number:random'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.number'('random'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.number:random'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.number'('!'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.number:!'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.number'(__36t, __36env, __36pos, __36CutLevel), '<module>:data.number$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:data.number$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:data.number$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:data.number$has_predicate'('check'(_____1)), 'true').
':-'('<module>:data.number$has_predicate'('>='(_____2, _____1)), 'true').
':-'('<module>:data.number$has_predicate'('>='(_____3, _____2, _____1)), 'true').
':-'('<module>:data.number$has_predicate'('>'(_____2, _____1)), 'true').
':-'('<module>:data.number$has_predicate'('>'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.number$has_predicate'('=<'(_____2, _____1)), 'true').
':-'('<module>:data.number$has_predicate'('=<'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.number$has_predicate'('<'(_____2, _____1)), 'true').
':-'('<module>:data.number$has_predicate'('<'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.number$has_predicate'('pred'(_____2, _____1)), 'true').
':-'('<module>:data.number$has_predicate'('succ'(_____2, _____1)), 'true').
':-'('<module>:data.number$has_predicate'('+'(_____2, _____1)), 'true').
':-'('<module>:data.number$has_predicate'('-'(_____2, _____1)), 'true').
':-'('<module>:data.number$has_predicate'('+'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.number$has_predicate'('-'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.number$has_predicate'('*'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.number$has_predicate'('/'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.number$has_predicate'('quo'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.number$has_predicate'('mod'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.number$has_predicate'('|++'(_____1)), 'true').
':-'('<module>:data.number$has_predicate'('|++'(_____2, _____1)), 'true').
':-'('<module>:data.number$has_predicate'('++|'(_____2, _____1)), 'true').
':-'('<module>:data.number$has_predicate'('|--'(_____1)), 'true').
':-'('<module>:data.number$has_predicate'('|--'(_____2, _____1)), 'true').
':-'('<module>:data.number$has_predicate'('--|'(_____2, _____1)), 'true').
':-'('<module>:data.number$has_predicate'('atom'(_____2, _____1)), 'true').
':-'('<module>:data.number$has_predicate'('iter'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.number$has_predicate'('..'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.number$has_predicate'('char'(_____2, _____1)), 'true').
':-'('<module>:data.number$has_predicate'('random'(_____2, _____1)), 'true').
':-'('<module>:data.number$has_predicate'('random'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:data.number$has_predicate'('!'(_____2, _____1)), 'true').
':-'('<module>:data.number:!'(_N, ___122, 'env', __36CutLevel), ','(','(','('g_read'('data.number', '<module>:data.number'(___117)), '<module>:data.number:>$direct'(_N, 2, ___117)), ','('true', ','('='(__36CutLevel, '$cut'), '!'))), ','(','(','('g_read'('data.number', '<module>:data.number'(___119)), '<module>:data.number:-$direct'(_N, 1, ___118, ___119)), ','('g_read'('data.number', '<module>:data.number'(___121)), '<module>:data.number:!$direct'(___118, ___120, ___121))), ','('g_read'('data.number', '<module>:data.number'(___123)), '<module>:data.number:*$direct'(_N, ___120, ___122, ___123))))).
':-'('<module>:data.number:!'(_, 1, 'env', __36CutLevel), 'true').
':-'('<module>:data.number:!$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.number:!'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.number:$sgn'(__36sgn, 'env', __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/number.mpl',0,0,0)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/number.mpl',22,0,0)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','('true', '<module>:data.number:atom_fresh_[1514]'(_atom__fresh___911515_93, __36Pb, __36Pe)), '<module>:data.number:atom_fresh_[1516]'(_atom__fresh___911517_93, __36Pb, __36Pe)), '<module>:data.number:atom_fresh_[1518]'(_atom__fresh___911519_93, __36Pb, __36Pe)), '<module>:data.number:atom_fresh_[1520]'(_atom__fresh___911521_93, __36Pb, __36Pe)), '<module>:data.number:atom_fresh_[1522]'(_atom__fresh___911523_93, __36Pb, __36Pe)), '<module>:data.number:atom_fresh_[1524]'(_atom__fresh___911525_93, __36Pb, __36Pe)), '<module>:data.number:atom_fresh_[1526]'(_atom__fresh___911527_93, __36Pb, __36Pe)), '<module>:data.number:atom_fresh_[1528]'(_atom__fresh___911529_93, __36Pb, __36Pe)), '<module>:data.number:atom_fresh_[1530]'(_atom__fresh___911531_93, __36Pb, __36Pe)), '<module>:data.number:atom_fresh_[1532]'(_atom__fresh___911533_93, __36Pb, __36Pe)), '<module>:data.number:atom_fresh_[1534]'(_atom__fresh___911535_93, __36Pb, __36Pe)), '<module>:data.number:atom_fresh_[1536]'(_atom__fresh___911537_93, __36Pb, __36Pe)), '<module>:data.number:atom_fresh_[1538]'(_atom__fresh___911539_93, __36Pb, __36Pe)), '<module>:data.number:atom_fresh_[1540]'(_atom__fresh___911541_93, __36Pb, __36Pe)), '<module>:data.number:atom_fresh_[1542]'(_atom__fresh___911543_93, __36Pb, __36Pe)), '<module>:data.number:atom_fresh_[1544]'(_atom__fresh___911545_93, __36Pb, __36Pe)), '<module>:data.number:atom_fresh_[1546]'(_atom__fresh___911547_93, __36Pb, __36Pe)), '<module>:data.number:atom_fresh_[1548]'(_atom__fresh___911549_93, __36Pb, __36Pe)), '<module>:data.number:atom_fresh_[1550]'(_atom__fresh___911551_93, __36Pb, __36Pe)), '<module>:data.number:atom_fresh_[1552]'(_atom__fresh___911553_93, __36Pb, __36Pe)), '<module>:data.number:atom_fresh_[1554]'(_atom__fresh___911555_93, __36Pb, __36Pe)), '<module>:data.number:atom_fresh_[1556]'(_atom__fresh___911557_93, __36Pb, __36Pe)), '<module>:data.number:atom_fresh_[1558]'(_atom__fresh___911559_93, __36Pb, __36Pe)), '<module>:data.number:atom_fresh_[1560]'(_atom__fresh___911561_93, __36Pb, __36Pe)), '<module>:data.number:atom_fresh_[1562]'(_atom__fresh___911563_93, __36Pb, __36Pe)), '<module>:data.number:atom_fresh_[1564]'(_atom__fresh___911565_93, __36Pb, __36Pe)), '<module>:data.number:atom_fresh_[1566]'(_atom__fresh___911567_93, __36Pb, __36Pe)), '<module>:data.number:atom_fresh_[1568]'(_atom__fresh___911569_93, __36Pb, __36Pe)), '<module>:data.number:atom_fresh_[1570]'(_atom__fresh___911571_93, __36Pb, __36Pe)), '<module>:data.number:atom_fresh_[1572]'(_atom__fresh___911573_93, __36Pb, __36Pe)), '<module>:data.number:atom_fresh_[1574]'(_atom__fresh___911575_93, __36Pb, __36Pe)), '<module>:data.number:atom_fresh_[1576]'(_atom__fresh___911577_93, __36Pb, __36Pe)), '<module>:data.number:atom_fresh_[1578]'(_atom__fresh___911579_93, __36Pb, __36Pe)), '<module>:data.number:atom_fresh_[1580]'(_atom__fresh___911581_93, __36Pb, __36Pe)), '<module>:data.number:atom_fresh_[1582]'(_atom__fresh___911583_93, __36Pb, __36Pe)), '<module>:data.number:atom_fresh_[1584]'(_atom__fresh___911585_93, __36Pb, __36Pe)), '<module>:data.number:atom_fresh_[1586]'(_atom__fresh___911587_93, __36Pb, __36Pe)), '<module>:data.number:atom_fresh_[1588]'(_atom__fresh___911589_93, __36Pb, __36Pe)), '<module>:data.number:atom_fresh_[1590]'(_atom__fresh___911591_93, __36Pb, __36Pe)), '<module>:data.number:atom_fresh_[1592]'(_atom__fresh___911593_93, __36Pb, __36Pe)), '<module>:data.number:atom_fresh_[1594]'(_atom__fresh___911595_93, __36Pb, __36Pe)), '<module>:data.number:atom_fresh_[1596]'(_atom__fresh___911597_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___911597_93, '.'(_atom__fresh___911595_93, '.'(_atom__fresh___911593_93, '.'(_atom__fresh___911591_93, '.'(_atom__fresh___911589_93, '.'(_atom__fresh___911587_93, '.'(_atom__fresh___911585_93, '.'(_atom__fresh___911583_93, '.'(_atom__fresh___911581_93, '.'(_atom__fresh___911579_93, '.'(_atom__fresh___911577_93, '.'(_atom__fresh___911575_93, '.'(_atom__fresh___911573_93, '.'(_atom__fresh___911571_93, '.'(_atom__fresh___911569_93, '.'(_atom__fresh___911567_93, '.'(_atom__fresh___911565_93, '.'(_atom__fresh___911563_93, '.'(_atom__fresh___911561_93, '.'(_atom__fresh___911559_93, '.'(_atom__fresh___911557_93, '.'(_atom__fresh___911555_93, '.'(_atom__fresh___911553_93, '.'(_atom__fresh___911551_93, '.'(_atom__fresh___911549_93, '.'(_atom__fresh___911547_93, '.'(_atom__fresh___911545_93, '.'(_atom__fresh___911543_93, '.'(_atom__fresh___911541_93, '.'(_atom__fresh___911539_93, '.'(_atom__fresh___911537_93, '.'(_atom__fresh___911535_93, '.'(_atom__fresh___911533_93, '.'(_atom__fresh___911531_93, '.'(_atom__fresh___911529_93, '.'(_atom__fresh___911527_93, '.'(_atom__fresh___911525_93, '.'(_atom__fresh___911523_93, '.'(_atom__fresh___911521_93, '.'(_atom__fresh___911519_93, '.'(_atom__fresh___911517_93, '.'(_atom__fresh___911515_93, '[]')))))))))))))))))))))))))))))))))))))))))))))))).
':-'('<module>:data.number:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.number:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.number:*'(_A, _B, _C, 'env', __36CutLevel), ';'('->'(','('g_read'('kernel', '<module>:kernel'(___61)), '<module>:kernel:number_check$direct'(_C, ___61)), ';'('->'(','('g_read'('kernel', '<module>:kernel'(___63)), '<module>:kernel:number_check$direct'(_B, ___63)), ','('g_read'('kernel', '<module>:kernel'(___65)), '<module>:kernel:number_div$direct'(_C, _B, _A, ___65))), ','('g_read'('kernel', '<module>:kernel'(___67)), '<module>:kernel:number_div$direct'(_C, _A, _B, ___67)))), ','('g_read'('kernel', '<module>:kernel'(___69)), '<module>:kernel:number_mul$direct'(_A, _B, _C, ___69)))).
':-'('<module>:data.number:*$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.number:*'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.number:+'(_A, _A, 'env', __36CutLevel), 'true').
':-'('<module>:data.number:+'(_A, _B, _C, 'env', __36CutLevel), ';'('->'(','('g_read'('kernel', '<module>:kernel'(___41)), '<module>:kernel:number_check$direct'(_C, ___41)), ';'('->'(','('g_read'('kernel', '<module>:kernel'(___43)), '<module>:kernel:number_check$direct'(_B, ___43)), ','('g_read'('kernel', '<module>:kernel'(___45)), '<module>:kernel:number_sub$direct'(_C, _B, _A, ___45))), ','('g_read'('kernel', '<module>:kernel'(___47)), '<module>:kernel:number_sub$direct'(_C, _A, _B, ___47)))), ','('g_read'('kernel', '<module>:kernel'(___49)), '<module>:kernel:number_add$direct'(_A, _B, _C, ___49)))).
':-'('<module>:data.number:+$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.number:+'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.number:+$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.number:+'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.number:++|'(_A, _W, 'env', __36CutLevel), ','('emop_call'(_A, 'get'(_V), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/number.mpl\", line 270, from character 8 to 11'), ','(','('g_read'('data.number', '<module>:data.number'(___91)), '<module>:data.number:succ$direct'(_V, _W, ___91)), 'emop_call'(_A, 'set'(_W), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/number.mpl\", line 272, from character 8 to 11')))).
':-'('<module>:data.number:++|$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.number:++|'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.number:-'(_A, _B, 'env', __36CutLevel), ';'('->'(','('g_read'('kernel', '<module>:kernel'(___35)), '<module>:kernel:number_check$direct'(_B, ___35)), ','('g_read'('kernel', '<module>:kernel'(___37)), '<module>:kernel:number_opp$direct'(_B, _A, ___37))), ','('g_read'('kernel', '<module>:kernel'(___39)), '<module>:kernel:number_opp$direct'(_A, _B, ___39)))).
':-'('<module>:data.number:-'(_A, _B, _C, 'env', __36CutLevel), ';'('->'(','('g_read'('kernel', '<module>:kernel'(___51)), '<module>:kernel:number_check$direct'(_C, ___51)), ';'('->'(','('g_read'('kernel', '<module>:kernel'(___53)), '<module>:kernel:number_check$direct'(_B, ___53)), ','('g_read'('kernel', '<module>:kernel'(___55)), '<module>:kernel:number_add$direct'(_C, _B, _A, ___55))), ','('g_read'('kernel', '<module>:kernel'(___57)), '<module>:kernel:number_add$direct'(_C, _A, _B, ___57)))), ','('g_read'('kernel', '<module>:kernel'(___59)), '<module>:kernel:number_sub$direct'(_A, _B, _C, ___59)))).
':-'('<module>:data.number:-$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.number:-'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.number:-$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.number:-'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.number:--|'(_A, _V, 'env', __36CutLevel), ','('emop_call'(_A, 'get'(_V), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/number.mpl\", line 308, from character 8 to 11'), ','(','('g_read'('data.number', '<module>:data.number'(___97)), '<module>:data.number:pred$direct'(_V, _W, ___97)), 'emop_call'(_A, 'set'(_W), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/number.mpl\", line 310, from character 8 to 11')))).
':-'('<module>:data.number:--|$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.number:--|'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.number:..'(_I, _J, ___107, 'env', __36CutLevel), ';'('->'(','('g_read'('data.number', '<module>:data.number'(___108)), '<module>:data.number:=<$direct'(_I, _J, ___108)), ','('='(___107, '.'(_I, ___111)), ','(','('g_read'('data.number', '<module>:data.number'(___110)), '<module>:data.number:succ$direct'(_I, ___109, ___110)), ','('g_read'('data.number', '<module>:data.number'(___112)), '<module>:data.number:..$direct'(___109, _J, ___111, ___112))))), '='(___107, '[]'))).
':-'('<module>:data.number:..$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.number:..'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.number:/'(_A, _B, _C, 'env', __36CutLevel), ';'('->'(','('g_read'('kernel', '<module>:kernel'(___71)), '<module>:kernel:number_check$direct'(_C, ___71)), ';'('->'(','('g_read'('kernel', '<module>:kernel'(___73)), '<module>:kernel:number_check$direct'(_B, ___73)), ','('g_read'('kernel', '<module>:kernel'(___75)), '<module>:kernel:number_mul$direct'(_C, _B, _A, ___75))), ','('g_read'('kernel', '<module>:kernel'(___77)), '<module>:kernel:number_mul$direct'(_C, _A, _B, ___77)))), ','('g_read'('kernel', '<module>:kernel'(___79)), '<module>:kernel:number_div$direct'(_A, _B, _C, ___79)))).
':-'('<module>:data.number:/$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.number:/'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.number:<'(_A, _B, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___19)), '<module>:kernel:number_lt$direct'(_A, _B, ___19))).
':-'('<module>:data.number:<'(_A, _B, _B, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___21)), '<module>:kernel:number_lt$direct'(_A, _B, ___21))).
':-'('<module>:data.number:<$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.number:<'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.number:<$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.number:<'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.number:=<'(_A, _B, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___15)), '<module>:kernel:number_le$direct'(_A, _B, ___15))).
':-'('<module>:data.number:=<'(_A, _B, _B, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___17)), '<module>:kernel:number_le$direct'(_A, _B, ___17))).
':-'('<module>:data.number:=<$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.number:=<'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.number:=<$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.number:=<'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.number:>'(_A, _B, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___11)), '<module>:kernel:number_gt$direct'(_A, _B, ___11))).
':-'('<module>:data.number:>'(_A, _B, _B, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___13)), '<module>:kernel:number_gt$direct'(_A, _B, ___13))).
':-'('<module>:data.number:>$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.number:>'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.number:>$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.number:>'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.number:>='(_A, _B, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___7)), '<module>:kernel:number_ge$direct'(_A, _B, ___7))).
':-'('<module>:data.number:>='(_A, _B, _B, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___9)), '<module>:kernel:number_ge$direct'(_A, _B, ___9))).
':-'('<module>:data.number:>=$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.number:>='(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.number:>=$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.number:>='(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.number:atom'(_N, _A, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___99)), '<module>:kernel:number_to_atom$direct'(_N, _A, ___99))).
':-'('<module>:data.number:atom$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.number:atom'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.number:atom_fresh_[1514]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(!, 2, predicate, suspended([var('N'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:data.number:atom_fresh_[1516]'(__36s, __36Pb, __36Pe), '='(__36s, 'syntax'('.'('callable'('prefix', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('-', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('<', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('!', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('<', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'(':', 'escaped', 'none', __36Pb, __36Pe), '[]')))))), __36Pb, __36Pe))).
':-'('<module>:data.number:atom_fresh_[1518]'(__36s, __36Pb, __36Pe), '='(__36s, 'syntax'('.'('callable'('postfix', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('!', 'escaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe))).
':-'('<module>:data.number:atom_fresh_[1520]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(random, 4, predicate, suspended([var('Generator'),var('Base'),var('Max'),var('Value')],[call(var('Generator'),random,[var('Base'),var('Max'),var('Value')])]), __36pos))).
':-'('<module>:data.number:atom_fresh_[1522]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(random, 2, predicate, suspended([var('Generator'),var('Value')],[call(var('Generator'),random,[var('Value')])]), __36pos))).
':-'('<module>:data.number:atom_fresh_[1524]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(char, 2, predicate, suspended([var('Code'),var('Char')],[call(atom(kernel),number_char,[var('Code'),var('Char')])]), __36pos))).
':-'('<module>:data.number:atom_fresh_[1526]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(.., 3, predicate, suspended([var('I'),var('J'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:data.number:atom_fresh_[1528]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(iter, 3, predicate, '[]', __36pos))).
':-'('<module>:data.number:atom_fresh_[1530]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(atom, 2, predicate, suspended([var('N'),var('A')],[call(atom(kernel),number_to_atom,[var('N'),var('A')])]), __36pos))).
':-'('<module>:data.number:atom_fresh_[1532]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'('--|', 2, predicate, suspended([var('A'),var('V')],[call(var('A'),get,[var('V')]),call(atom('data.number'),pred,[var('V'),var('W')]),call(var('A'),set,[var('W')])]), __36pos))).
':-'('<module>:data.number:atom_fresh_[1534]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'('|--', 2, predicate, suspended([var('A'),var('V')],[call(var('A'),get,[var('V')]),call(atom('data.number'),pred,[var('V'),var('W')]),call(var('A'),set,[var('W')])]), __36pos))).
':-'('<module>:data.number:atom_fresh_[1536]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'('|--', 1, predicate, suspended([var('A')],[call(var('A'),get,[var('V')]),call(atom('data.number'),pred,[var('V'),var('W')]),call(var('A'),set,[var('W')])]), __36pos))).
':-'('<module>:data.number:atom_fresh_[1538]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'('++|', 2, predicate, suspended([var('A'),var('W')],[call(var('A'),get,[var('V')]),call(atom('data.number'),succ,[var('V'),var('W')]),call(var('A'),set,[var('W')])]), __36pos))).
':-'('<module>:data.number:atom_fresh_[1540]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'('|++', 2, predicate, suspended([var('A'),var('V')],[call(var('A'),get,[var('V')]),call(atom('data.number'),succ,[var('V'),var('W')]),call(var('A'),set,[var('W')])]), __36pos))).
':-'('<module>:data.number:atom_fresh_[1542]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'('|++', 1, predicate, suspended([var('A')],[call(var('A'),get,[var('V')]),call(atom('data.number'),succ,[var('V'),var('W')]),call(var('A'),set,[var('W')])]), __36pos))).
':-'('<module>:data.number:atom_fresh_[1544]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(mod, 3, predicate, suspended([var('A'),var('B'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:data.number:atom_fresh_[1546]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(quo, 3, predicate, suspended([var('A'),var('B'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:data.number:atom_fresh_[1548]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(/, 3, predicate, '[]', __36pos))).
':-'('<module>:data.number:atom_fresh_[1550]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(*, 3, predicate, '[]', __36pos))).
':-'('<module>:data.number:atom_fresh_[1552]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(-, 3, predicate, '[]', __36pos))).
':-'('<module>:data.number:atom_fresh_[1554]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(+, 3, predicate, '[]', __36pos))).
':-'('<module>:data.number:atom_fresh_[1556]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(-, 2, predicate, '[]', __36pos))).
':-'('<module>:data.number:atom_fresh_[1558]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(+, 2, predicate, suspended([var('A'),var('A')],[call(scope,true,[])]), __36pos))).
':-'('<module>:data.number:atom_fresh_[1560]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(succ, 2, predicate, '[]', __36pos))).
':-'('<module>:data.number:atom_fresh_[1562]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(pred, 2, predicate, '[]', __36pos))).
':-'('<module>:data.number:atom_fresh_[1564]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(<, 3, predicate, suspended([var('A'),var('B'),var('B')],[call(atom(kernel),number_lt,[var('A'),var('B')])]), __36pos))).
':-'('<module>:data.number:atom_fresh_[1566]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(<, 2, predicate, suspended([var('A'),var('B')],[call(atom(kernel),number_lt,[var('A'),var('B')])]), __36pos))).
':-'('<module>:data.number:atom_fresh_[1568]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(=<, 3, predicate, suspended([var('A'),var('B'),var('B')],[call(atom(kernel),number_le,[var('A'),var('B')])]), __36pos))).
':-'('<module>:data.number:atom_fresh_[1570]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(=<, 2, predicate, suspended([var('A'),var('B')],[call(atom(kernel),number_le,[var('A'),var('B')])]), __36pos))).
':-'('<module>:data.number:atom_fresh_[1572]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(>, 3, predicate, suspended([var('A'),var('B'),var('B')],[call(atom(kernel),number_gt,[var('A'),var('B')])]), __36pos))).
':-'('<module>:data.number:atom_fresh_[1574]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(>, 2, predicate, suspended([var('A'),var('B')],[call(atom(kernel),number_gt,[var('A'),var('B')])]), __36pos))).
':-'('<module>:data.number:atom_fresh_[1576]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(>=, 3, predicate, suspended([var('A'),var('B'),var('B')],[call(atom(kernel),number_ge,[var('A'),var('B')])]), __36pos))).
':-'('<module>:data.number:atom_fresh_[1578]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(>=, 2, predicate, suspended([var('A'),var('B')],[call(atom(kernel),number_ge,[var('A'),var('B')])]), __36pos))).
':-'('<module>:data.number:atom_fresh_[1580]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(check, 1, predicate, suspended([var('X')],[call(atom(kernel),number_check,[var('X')])]), __36pos))).
':-'('<module>:data.number:atom_fresh_[1582]'(__36s, __36Pb, __36Pe), '='(__36s, 'syntax'('.'('callable'('=', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('<', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('..', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('<', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('+', 'escaped', 'none', __36Pb, __36Pe), '[]'))))), __36Pb, __36Pe))).
':-'('<module>:data.number:atom_fresh_[1584]'(__36s, __36Pb, __36Pe), '='(__36s, 'syntax'('.'('callable'('infix', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('..', 'escaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe))).
':-'('<module>:data.number:atom_fresh_[1586]'(__36s, __36Pb, __36Pe), '='(__36s, 'syntax'('.'('callable'('prefix', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('-', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('<', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('prefix', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('++', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('=', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('prefix', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('--', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('=', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('postfix', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('++', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('=', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('postfix', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('--', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('<', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'(':', 'escaped', 'none', __36Pb, __36Pe), '[]')))))))))))))))), __36Pb, __36Pe))).
':-'('<module>:data.number:atom_fresh_[1588]'(__36s, __36Pb, __36Pe), '='(__36s, 'syntax'('.'('callable'('>>', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('<', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('infix', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('+', 'escaped', 'none', __36Pb, __36Pe), '[]')))), __36Pb, __36Pe))).
':-'('<module>:data.number:atom_fresh_[1590]'(__36s, __36Pb, __36Pe), '='(__36s, 'syntax'('.'('callable'('postfix', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('--', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('as', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('|--', 'escaped', 'none', __36Pb, __36Pe), '[]')))), __36Pb, __36Pe))).
':-'('<module>:data.number:atom_fresh_[1592]'(__36s, __36Pb, __36Pe), '='(__36s, 'syntax'('.'('callable'('postfix', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('++', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('as', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('|++', 'escaped', 'none', __36Pb, __36Pe), '[]')))), __36Pb, __36Pe))).
':-'('<module>:data.number:atom_fresh_[1594]'(__36s, __36Pb, __36Pe), '='(__36s, 'syntax'('.'('callable'('prefix', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('--', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('as', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('--|', 'escaped', 'none', __36Pb, __36Pe), '[]')))), __36Pb, __36Pe))).
':-'('<module>:data.number:atom_fresh_[1596]'(__36s, __36Pb, __36Pe), '='(__36s, 'syntax'('.'('callable'('prefix', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('++', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('as', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('++|', 'escaped', 'none', __36Pb, __36Pe), '[]')))), __36Pb, __36Pe))).
':-'('<module>:data.number:char'(_Code, _Char, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___116)), '<module>:kernel:number_char$direct'(_Code, _Char, ___116))).
':-'('<module>:data.number:char$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.number:char'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.number:check'(_X, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___5)), '<module>:kernel:number_check$direct'(_X, ___5))).
':-'('<module>:data.number:check$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.number:check'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.number:iter'(_I, _J, _F, 'env', __36CutLevel), ';'('->'(','('g_read'('data.number', '<module>:data.number'(___101)), '<module>:data.number:=<$direct'(_I, _J, ___101)), ','('emop_call'(_F, 'do'(_I), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/number.mpl\", line 339, from character 11 to 13'), ','(','('g_read'('data.number', '<module>:data.number'(___105)), '<module>:data.number:succ$direct'(_I, ___104, ___105)), ','('g_read'('data.number', '<module>:data.number'(___106)), '<module>:data.number:iter$direct'(___104, _J, _F, ___106))))), 'true')).
':-'('<module>:data.number:iter$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.number:iter'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.number:mod'(_A, _B, ___84, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___85)), '<module>:kernel:number_mod$direct'(_A, _B, ___84, ___85))).
':-'('<module>:data.number:mod$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.number:mod'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.number:pred'(_A, _B, 'env', __36CutLevel), ';'('->'(','('g_read'('kernel', '<module>:kernel'(___23)), '<module>:kernel:number_check$direct'(_B, ___23)), ','('g_read'('kernel', '<module>:kernel'(___25)), '<module>:kernel:number_succ$direct'(_B, _A, ___25))), ','('g_read'('kernel', '<module>:kernel'(___27)), '<module>:kernel:number_pred$direct'(_A, _B, ___27)))).
':-'('<module>:data.number:pred$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.number:pred'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.number:quo'(_A, _B, ___81, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___82)), '<module>:kernel:number_quo$direct'(_A, _B, ___81, ___82))).
':-'('<module>:data.number:quo$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.number:quo'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.number:random'(_Generator, _Value, 'env', __36CutLevel), 'emop_call'(_Generator, 'random'(_Value), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/number.mpl\", line 374, from character 16 to 22')).
':-'('<module>:data.number:random'(_Generator, _Base, _Max, _Value, 'env', __36CutLevel), 'emop_call'(_Generator, 'random'(_Base, _Max, _Value), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/number.mpl\", line 377, from character 16 to 22')).
':-'('<module>:data.number:random$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.number:random'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.number:random$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.number:random'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.number:succ'(_A, _B, 'env', __36CutLevel), ';'('->'(','('g_read'('kernel', '<module>:kernel'(___29)), '<module>:kernel:number_check$direct'(_B, ___29)), ','('g_read'('kernel', '<module>:kernel'(___31)), '<module>:kernel:number_pred$direct'(_B, _A, ___31))), ','('g_read'('kernel', '<module>:kernel'(___33)), '<module>:kernel:number_succ$direct'(_A, _B, ___33)))).
':-'('<module>:data.number:succ$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.number:succ'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.number:|++'(_A, 'env', __36CutLevel), ','('emop_call'(_A, 'get'(_V), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/number.mpl\", line 244, from character 8 to 11'), ','(','('g_read'('data.number', '<module>:data.number'(___87)), '<module>:data.number:succ$direct'(_V, _W, ___87)), 'emop_call'(_A, 'set'(_W), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/number.mpl\", line 246, from character 8 to 11')))).
':-'('<module>:data.number:|++'(_A, _V, 'env', __36CutLevel), ','('emop_call'(_A, 'get'(_V), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/number.mpl\", line 257, from character 8 to 11'), ','(','('g_read'('data.number', '<module>:data.number'(___89)), '<module>:data.number:succ$direct'(_V, _W, ___89)), 'emop_call'(_A, 'set'(_W), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/number.mpl\", line 259, from character 8 to 11')))).
':-'('<module>:data.number:|++$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.number:|++'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.number:|++$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.number:|++'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.number:|--'(_A, 'env', __36CutLevel), ','('emop_call'(_A, 'get'(_V), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/number.mpl\", line 282, from character 8 to 11'), ','(','('g_read'('data.number', '<module>:data.number'(___93)), '<module>:data.number:pred$direct'(_V, _W, ___93)), 'emop_call'(_A, 'set'(_W), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/number.mpl\", line 284, from character 8 to 11')))).
':-'('<module>:data.number:|--'(_A, _V, 'env', __36CutLevel), ','('emop_call'(_A, 'get'(_V), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/number.mpl\", line 295, from character 8 to 11'), ','(','('g_read'('data.number', '<module>:data.number'(___95)), '<module>:data.number:pred$direct'(_V, _W, ___95)), 'emop_call'(_A, 'set'(_W), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/number.mpl\", line 297, from character 8 to 11')))).
':-'('<module>:data.number:|--$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.number:|--'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.number:|--$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.number:|--'(_____2, _____1, __36env, __36CutLevel))).
':-'('data.number@init', ','('true', 'g_link'('data.number', '<module>:data.number'('env')))).
':-'('dynamic'('/'('<module>:data.path$dynamic', 4))).
':-'('dynamic'('/'('<module>:data.path@0$dynamic', 4))).
':-'('<module>:data.path'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.path:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.path'('delimiter'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.path:delimiter'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.path'('separator'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.path:separator'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.path'('concat'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.path:concat'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.path'('join'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.path:join'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.path'('split'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.path:split'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.path'('base'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.path:base'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.path'('filename'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.path:filename'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.path'('split_suffix'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.path:split_suffix'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.path'('suffix'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.path:suffix'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.path'('chop_suffix'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.path:chop_suffix'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.path'('is_absolute'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.path:is_absolute'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.path'('trailing_path_delimiter'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.path:trailing_path_delimiter'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.path'(__36t, __36env, __36pos, __36CutLevel), '<module>:data.path$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:data.path$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:data.path$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:data.path$has_predicate'('delimiter'(_____1)), 'true').
':-'('<module>:data.path$has_predicate'('separator'(_____1)), 'true').
':-'('<module>:data.path$has_predicate'('concat'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.path$has_predicate'('join'(_____2, _____1)), 'true').
':-'('<module>:data.path$has_predicate'('split'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.path$has_predicate'('base'(_____2, _____1)), 'true').
':-'('<module>:data.path$has_predicate'('filename'(_____2, _____1)), 'true').
':-'('<module>:data.path$has_predicate'('split_suffix'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.path$has_predicate'('suffix'(_____2, _____1)), 'true').
':-'('<module>:data.path$has_predicate'('chop_suffix'(_____2, _____1)), 'true').
':-'('<module>:data.path$has_predicate'('is_absolute'(_____1)), 'true').
':-'('<module>:data.path$has_predicate'('trailing_path_delimiter'(_____2, _____1)), 'true').
':-'('<module>:data.path:$sgn'(__36sgn, 'env', __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/path.mpl',0,0,0)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/path.mpl',20,0,0)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','(','(','(','(','(','(','(','(','(','('true', '<module>:data.path:atom_fresh_[2847]'(_atom__fresh___912848_93, __36Pb, __36Pe)), '<module>:data.path:atom_fresh_[2849]'(_atom__fresh___912850_93, __36Pb, __36Pe)), '<module>:data.path:atom_fresh_[2851]'(_atom__fresh___912852_93, __36Pb, __36Pe)), '<module>:data.path:atom_fresh_[2853]'(_atom__fresh___912854_93, __36Pb, __36Pe)), '<module>:data.path:atom_fresh_[2855]'(_atom__fresh___912856_93, __36Pb, __36Pe)), '<module>:data.path:atom_fresh_[2857]'(_atom__fresh___912858_93, __36Pb, __36Pe)), '<module>:data.path:atom_fresh_[2859]'(_atom__fresh___912860_93, __36Pb, __36Pe)), '<module>:data.path:atom_fresh_[2861]'(_atom__fresh___912862_93, __36Pb, __36Pe)), '<module>:data.path:atom_fresh_[2863]'(_atom__fresh___912864_93, __36Pb, __36Pe)), '<module>:data.path:atom_fresh_[2865]'(_atom__fresh___912866_93, __36Pb, __36Pe)), '<module>:data.path:atom_fresh_[2867]'(_atom__fresh___912868_93, __36Pb, __36Pe)), '<module>:data.path:atom_fresh_[2869]'(_atom__fresh___912870_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___912870_93, '.'(_atom__fresh___912868_93, '.'(_atom__fresh___912866_93, '.'(_atom__fresh___912864_93, '.'(_atom__fresh___912862_93, '.'(_atom__fresh___912860_93, '.'(_atom__fresh___912858_93, '.'(_atom__fresh___912856_93, '.'(_atom__fresh___912854_93, '.'(_atom__fresh___912852_93, '.'(_atom__fresh___912850_93, '.'(_atom__fresh___912848_93, '[]')))))))))))))))))).
':-'('<module>:data.path:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.path:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.path:atom_fresh_[2847]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(trailing_path_delimiter, 2, predicate, '[]', __36pos))).
':-'('<module>:data.path:atom_fresh_[2849]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(is_absolute, 1, predicate, suspended([var('Path')],[call(scope,delimiter,[var('Delim')]),call(atom('data.atom'),sub,[var('Path'),none,none,var('_'),var('Delim')])]), __36pos))).
':-'('<module>:data.path:atom_fresh_[2851]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(chop_suffix, 2, predicate, suspended([var('Path'),var('Base')],[call(atom('data.path'),split_suffix,[var('Path'),var('Base'),var('_')])]), __36pos))).
':-'('<module>:data.path:atom_fresh_[2853]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(suffix, 2, predicate, suspended([var('Path'),var('Suffix')],[call(atom('data.path'),split_suffix,[var('Path'),var('_'),var('Suffix')])]), __36pos))).
':-'('<module>:data.path:atom_fresh_[2855]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(split_suffix, 3, predicate, '[]', __36pos))).
':-'('<module>:data.path:atom_fresh_[2857]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(filename, 2, predicate, suspended([var('Path'),var('Filename')],[call(scope,split,[var('Path'),var('_'),var('Filename')])]), __36pos))).
':-'('<module>:data.path:atom_fresh_[2859]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(base, 2, predicate, suspended([var('Path'),var('Base')],[call(scope,split,[var('Path'),var('Base'),var('_')])]), __36pos))).
':-'('<module>:data.path:atom_fresh_[2861]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(split, 3, predicate, '[]', __36pos))).
':-'('<module>:data.path:atom_fresh_[2863]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(join, 2, predicate, suspended([var('Paths'),var('Path')],[call(scope,delimiter,[var('Delim')]),call(atom('data.atom'),join,[var('Paths'),var('Delim'),var('Path')])]), __36pos))).
':-'('<module>:data.path:atom_fresh_[2865]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(concat, 3, predicate, '[]', __36pos))).
':-'('<module>:data.path:atom_fresh_[2867]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(separator, 1, predicate, suspended([none],[call(scope,true,[])]), __36pos))).
':-'('<module>:data.path:atom_fresh_[2869]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(delimiter, 1, predicate, suspended([none],[call(scope,true,[])]), __36pos))).
':-'('<module>:data.path:base'(_Path, _Base, 'env', __36CutLevel), ','('g_read'('data.path', '<module>:data.path'(___24)), '<module>:data.path:split$direct'(_Path, _Base, _, ___24))).
':-'('<module>:data.path:base$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.path:base'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.path:chop_suffix'(_Path, _Base, 'env', __36CutLevel), ','('g_read'('data.path', '<module>:data.path'(___42)), '<module>:data.path:split_suffix$direct'(_Path, _Base, _, ___42))).
':-'('<module>:data.path:chop_suffix$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.path:chop_suffix'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.path:concat'(_A, _B, _R, 'env', __36CutLevel), ','(','('g_read'('data.path', '<module>:data.path'(___8)), '<module>:data.path:delimiter$direct'(_Delim, ___8)), ';'('->'(','('g_read'('data.path', '<module>:data.path'(___9)), '<module>:data.path:is_absolute$direct'(_B, ___9)), '='(_R, _B)), ';'('->'(','('g_read'('data.atom', '<module>:data.atom'(___11)), '<module>:data.atom:sub$direct'(_A, _, 1, 0, _Delim, ___11)), ','('g_read'('data.atom', '<module>:data.atom'(___13)), '<module>:data.atom:concat$direct'(_A, _B, _R, ___13))), ','(','('g_read'('data.atom', '<module>:data.atom'(___15)), '<module>:data.atom:concat$direct'(_A, _Delim, _A0, ___15)), ','('g_read'('data.atom', '<module>:data.atom'(___16)), '<module>:data.atom:concat$direct'(_A0, _B, _R, ___16))))))).
':-'('<module>:data.path:concat$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.path:concat'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.path:delimiter'('/', 'env', __36CutLevel), 'true').
':-'('<module>:data.path:delimiter$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.path:delimiter'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.path:filename'(_Path, _Filename, 'env', __36CutLevel), ','('g_read'('data.path', '<module>:data.path'(___25)), '<module>:data.path:split$direct'(_Path, _, _Filename, ___25))).
':-'('<module>:data.path:filename$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.path:filename'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.path:is_absolute'(_Path, 'env', __36CutLevel), ','(','('g_read'('data.path', '<module>:data.path'(___43)), '<module>:data.path:delimiter$direct'(_Delim, ___43)), ','('g_read'('data.atom', '<module>:data.atom'(___45)), '<module>:data.atom:sub$direct'(_Path, 0, 1, _, _Delim, ___45)))).
':-'('<module>:data.path:is_absolute$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.path:is_absolute'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.path:join'(_Paths, _Path, 'env', __36CutLevel), ','(','('g_read'('data.path', '<module>:data.path'(___17)), '<module>:data.path:delimiter$direct'(_Delim, ___17)), ','('g_read'('data.atom', '<module>:data.atom'(___19)), '<module>:data.atom:join$direct'(_Paths, _Delim, _Path, ___19)))).
':-'('<module>:data.path:join$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.path:join'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.path:separator'(___6, 'env', __36CutLevel), ','('g_read'('sys.os', '<module>:sys.os'(___7)), '<module>:sys.os:path_separator$direct'(___6, ___7))).
':-'('<module>:data.path:separator$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.path:separator'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.path:split'(_Path, _Base, _Filename, 'env', __36CutLevel), ','(','('g_read'('data.path', '<module>:data.path'(___20)), '<module>:data.path:delimiter$direct'(_Delim, ___20)), ';'('->'(','('g_read'('data.atom', '<module>:data.atom'(___22)), '<module>:data.atom:split_at_delim_right$direct'(_Path, _Delim, _Base, _Filename, ___22)), 'true'), ','('='(_Base, ''), '='(_Filename, _Path))))).
':-'('<module>:data.path:split$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.path:split'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.path:split_suffix'(_Path, _Base, _Suffix, 'env', __36CutLevel), ','(','('g_read'('data.path', '<module>:data.path'(___26)), '<module>:data.path:delimiter$direct'(_Delim, ___26)), ','(','('true', ';'('->'('var'(_Aux), ','('g_inc'('$module_count', ___27), '='(_Aux, '$module'(___27, '.'('<module>:data.path@0'('env'(_Aux, _Delim, _Path, _Base, _Suffix)), '[]'), '.'(_Aux, '[]'))))), ','('='(_Aux, '$module'(___27, ___28, _)), ','('='('.'(___29, ___30), ___28), ','('setarg'(1, ___28, '<module>:data.path@0'('env'(_Aux, _Delim, _Path, _Base, _Suffix))), 'setarg'(2, ___28, '.'(___29, ___30))))))), ';'('->'(','(','(','('g_read'('data.atom', '<module>:data.atom'(___35)), '<module>:data.atom:length$direct'(_Path, ___34, ___35)), ','('g_read'('data.number', '<module>:data.number'(___37)), '<module>:data.number:pred$direct'(___34, ___36, ___37))), 'emop_call'(_Aux, 'split'(___36), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/path.mpl\", line 117, from character 13 to 18')), 'true'), ','('='(_Base, _Path), '='(_Suffix, '')))))).
':-'('<module>:data.path:split_suffix$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.path:split_suffix'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.path:suffix'(_Path, _Suffix, 'env', __36CutLevel), ','('g_read'('data.path', '<module>:data.path'(___40)), '<module>:data.path:split_suffix$direct'(_Path, _, _Suffix, ___40))).
':-'('<module>:data.path:suffix$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.path:suffix'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.path:trailing_path_delimiter'(_Without, _With, 'env', __36CutLevel), ';'('->'(','(','('g_read'('data.atom', '<module>:data.atom'(___47)), '<module>:data.atom:check$direct'(_Without, ___47)), '\\+'(','('g_read'('data.atom', '<module>:data.atom'(___50)), '<module>:data.atom:concat$direct'(_, '/', _Without, ___50)))), ','('g_read'('data.atom', '<module>:data.atom'(___53)), '<module>:data.atom:concat$direct'(_Without, '/', _With, ___53))), ';'('->'(','(','('g_read'('data.atom', '<module>:data.atom'(___55)), '<module>:data.atom:check$direct'(_With, ___55)), ','('g_read'('data.atom', '<module>:data.atom'(___58)), '<module>:data.atom:concat$direct'(_Without, '/', _With, ___58))), 'true'), '='(_With, _Without)))).
':-'('<module>:data.path:trailing_path_delimiter$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.path:trailing_path_delimiter'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.path@0'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.path@0:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.path@0'('split'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.path@0:split'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.path@0'(__36t, __36env, __36pos, __36CutLevel), '<module>:data.path@0$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:data.path@0$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:data.path@0$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:data.path@0$has_predicate'('split'(_____1)), 'true').
':-'('<module>:data.path@0:$sgn'(__36sgn, 'env'(___31, _Delim, _Path, _Base, _Suffix), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/path.mpl',2827,101,2821)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/path.mpl',2867,101,2821)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:data.path@0:atom_fresh_[2871]'(_atom__fresh___912872_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___912872_93, '[]'))))))).
':-'('<module>:data.path@0:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.path@0:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.path@0:atom_fresh_[2871]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(split, 1, predicate, '[]', __36pos))).
':-'('<module>:data.path@0:split'(_Index, 'env'(___31, _Delim, _Path, _Base, _Suffix), __36CutLevel), ','(','('g_read'('data.number', '<module>:data.number'(___60)), '<module>:data.number:>=$direct'(_Index, 0, ___60)), ','(','('g_read'('data.atom', '<module>:data.atom'(___62)), '<module>:data.atom:sub$direct'(_Path, _Index, 1, _, _C, ___62)), ';'('->'('='(_C, '.'), ','(','('g_read'('data.atom', '<module>:data.atom'(___65)), '<module>:data.atom:sub$direct'(_Path, 0, _Index, _, _Base, ___65)), ','(','('g_read'('data.number', '<module>:data.number'(___69)), '<module>:data.number:succ$direct'(_Index, ___68, ___69)), ','('g_read'('data.atom', '<module>:data.atom'(___70)), '<module>:data.atom:sub$direct'(_Path, ___68, _, 0, _Suffix, ___70))))), ','('\\='(_C, _Delim), ','(','('g_read'('data.number', '<module>:data.number'(___73)), '<module>:data.number:pred$direct'(_Index, ___72, ___73)), 'emop_call'(___31, 'split'(___72), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/path.mpl\", line 113, from character 20 to 25'))))))).
':-'('<module>:data.path@0:split$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.path@0:split'(_____1, __36env, __36CutLevel))).
':-'('data.path@init', ','('true', 'g_link'('data.path', '<module>:data.path'('env')))).
':-'('dynamic'('/'('<module>:data.random$dynamic', 4))).
':-'('<module>:data.random'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.random:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.random'('init', __36env, _, __36CutLevel), ','('!', '<module>:data.random:init'(__36env, __36CutLevel))).
':-'('<module>:data.random'('get_seed'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.random:get_seed'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.random'('set_seed'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.random:set_seed'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.random'('random'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.random:random'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.random'('random'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.random:random'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.random'(__36t, __36env, __36pos, __36CutLevel), '<module>:data.random$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:data.random$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:data.random$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:data.random$has_predicate'('init'), 'true').
':-'('<module>:data.random$has_predicate'('get_seed'(_____1)), 'true').
':-'('<module>:data.random$has_predicate'('set_seed'(_____1)), 'true').
':-'('<module>:data.random$has_predicate'('random'(_____1)), 'true').
':-'('<module>:data.random$has_predicate'('random'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.random:$sgn'(__36sgn, 'env', __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/random.mpl',0,0,0)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/random.mpl',20,0,0)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','(','(','('true', '<module>:data.random:atom_fresh_[2829]'(_atom__fresh___912830_93, __36Pb, __36Pe)), '<module>:data.random:atom_fresh_[2831]'(_atom__fresh___912832_93, __36Pb, __36Pe)), '<module>:data.random:atom_fresh_[2833]'(_atom__fresh___912834_93, __36Pb, __36Pe)), '<module>:data.random:atom_fresh_[2835]'(_atom__fresh___912836_93, __36Pb, __36Pe)), '<module>:data.random:atom_fresh_[2837]'(_atom__fresh___912838_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___912838_93, '.'(_atom__fresh___912836_93, '.'(_atom__fresh___912834_93, '.'(_atom__fresh___912832_93, '.'(_atom__fresh___912830_93, '[]'))))))))))).
':-'('<module>:data.random:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.random:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.random:atom_fresh_[2829]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(random, 3, predicate, suspended([var('Base'),var('Max'),var('Int')],[call(atom(kernel),random_random,[var('Base'),var('Max'),var('Int')])]), __36pos))).
':-'('<module>:data.random:atom_fresh_[2831]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(random, 1, predicate, suspended([var('Value')],[call(atom(kernel),random_random,[var('Value')])]), __36pos))).
':-'('<module>:data.random:atom_fresh_[2833]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(set_seed, 1, predicate, suspended([var('Value')],[call(atom(kernel),random_set_seed,[var('Value')])]), __36pos))).
':-'('<module>:data.random:atom_fresh_[2835]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(get_seed, 1, predicate, suspended([var('Value')],[call(atom(kernel),random_get_seed,[var('Value')])]), __36pos))).
':-'('<module>:data.random:atom_fresh_[2837]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(init, 0, predicate, [], __36pos))).
':-'('<module>:data.random:get_seed'(_Value, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___7)), '<module>:kernel:random_get_seed$direct'(_Value, ___7))).
':-'('<module>:data.random:get_seed$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.random:get_seed'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.random:init'('env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___5)), '<module>:kernel:random_randomize$direct'(___5))).
':-'('<module>:data.random:init$direct'(__36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.random:init'(__36env, __36CutLevel))).
':-'('<module>:data.random:random'(_Value, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___11)), '<module>:kernel:random_random$direct'(_Value, ___11))).
':-'('<module>:data.random:random'(_Base, _Max, _Int, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___13)), '<module>:kernel:random_random$direct'(_Base, _Max, _Int, ___13))).
':-'('<module>:data.random:random$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.random:random'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.random:random$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.random:random'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.random:set_seed'(_Value, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___9)), '<module>:kernel:random_set_seed$direct'(_Value, ___9))).
':-'('<module>:data.random:set_seed$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.random:set_seed'(_____1, __36env, __36CutLevel))).
':-'('data.random@init', ','('true', 'g_link'('data.random', '<module>:data.random'('env')))).
':-'('dynamic'('/'('<module>:data.record$dynamic', 4))).
':-'('dynamic'('/'('<module>:data.record@0$dynamic', 4))).
':-'('dynamic'('/'('<module>:data.record@2$dynamic', 4))).
':-'('dynamic'('/'('<module>:data.record@1$dynamic', 4))).
':-'('<module>:data.record'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.record:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.record'('=>'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.record:=>'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.record'('{}'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.record:{}'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.record'('{}'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.record:{}'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.record'(__36t, __36env, __36pos, __36CutLevel), '<module>:data.record$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:data.record$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:data.record$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:data.record$has_predicate'('=>'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.record$has_predicate'('{}'(_____1)), 'true').
':-'('<module>:data.record$has_predicate'('{}'(_____2, _____1)), 'true').
':-'('<module>:data.record:$sgn'(__36sgn, 'env', __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/record.mpl',0,0,0)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/record.mpl',22,0,0)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','(','(','('true', '<module>:data.record:atom_fresh_[2759]'(_atom__fresh___912760_93, __36Pb, __36Pe)), '<module>:data.record:atom_fresh_[2761]'(_atom__fresh___912762_93, __36Pb, __36Pe)), '<module>:data.record:atom_fresh_[2763]'(_atom__fresh___912764_93, __36Pb, __36Pe)), '<module>:data.record:atom_fresh_[2765]'(_atom__fresh___912766_93, __36Pb, __36Pe)), '<module>:data.record:atom_fresh_[2767]'(_atom__fresh___912768_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___912768_93, '.'(_atom__fresh___912766_93, '.'(_atom__fresh___912764_93, '.'(_atom__fresh___912762_93, '.'(_atom__fresh___912760_93, '[]'))))))))))).
':-'('<module>:data.record:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.record:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.record:=>'(___4, ___5, ___6, 'env', __36CutLevel), '=..'(___6, '.'('=>', '.'(___4, '.'(___5, '[]'))))).
':-'('<module>:data.record:=>$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.record:=>'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.record:atom_fresh_[2759]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'({}, 2, predicate, suspended([var('Initial_contents'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:data.record:atom_fresh_[2761]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'({}, 1, predicate, suspended([none],[call(scope,true,[])]), __36pos))).
':-'('<module>:data.record:atom_fresh_[2763]'(__36s, __36Pb, __36Pe), '='(__36s, 'syntax'('.'('callable'('=>', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('<', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'(':', 'escaped', 'none', __36Pb, __36Pe), '[]'))), __36Pb, __36Pe))).
':-'('<module>:data.record:atom_fresh_[2765]'(__36s, __36Pb, __36Pe), '='(__36s, 'syntax'('.'('callable'('infix', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('=>', 'escaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe))).
':-'('<module>:data.record:atom_fresh_[2767]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(=>, 3, constructor, none, __36pos))).
':-'('<module>:data.record:{}'(___9, 'env', __36CutLevel), ','(','('g_read'('kernel', '<module>:kernel'(___8)), '<module>:kernel:record_new$direct'(_X, ___8)), ','('true', ';'('->'('var'(___9), ','('g_inc'('$module_count', ___10), '='(___9, '$module'(___10, '.'('<module>:data.record@0'('env'(___9, _X)), '[]'), '.'(___9, '[]'))))), ','('='(___9, '$module'(___10, ___11, _)), ','('='('.'(___12, ___13), ___11), ','('setarg'(1, ___11, '<module>:data.record@0'('env'(___9, _X))), 'setarg'(2, ___11, '.'(___12, ___13))))))))).
':-'('<module>:data.record:{}'(_Initial__contents, _Record, 'env', __36CutLevel), ','(','('='(_Record, ___16), ','('g_read'('data.record', '<module>:data.record'(___17)), '<module>:data.record:{}$direct'(___16, ___17))), 'emop_call'(_Record, '{}'(_Initial__contents), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/record.mpl\", line 63, from character 14 to 15'))).
':-'('<module>:data.record:{}$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.record:{}'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.record:{}$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.record:{}'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.record@0'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.record@0:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.record@0'('{}', __36env, _, __36CutLevel), ','('!', '<module>:data.record@0:{}'(__36env, __36CutLevel))).
':-'('<module>:data.record@0'('{}'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.record@0:{}'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.record@0'('{}'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.record@0:{}'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.record@0'('keys'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.record@0:keys'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.record@0'('iter'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.record@0:iter'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.record@0'('list'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.record@0:list'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.record@0'('copy'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.record@0:copy'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.record@0'('pretty'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.record@0:pretty'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.record@0'(__36t, __36env, __36pos, __36CutLevel), '<module>:data.record@0$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:data.record@0$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:data.record@0$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:data.record@0$has_predicate'('{}'), 'true').
':-'('<module>:data.record@0$has_predicate'('{}'(_____1)), 'true').
':-'('<module>:data.record@0$has_predicate'('{}'(_____2, _____1)), 'true').
':-'('<module>:data.record@0$has_predicate'('keys'(_____1)), 'true').
':-'('<module>:data.record@0$has_predicate'('iter'(_____1)), 'true').
':-'('<module>:data.record@0$has_predicate'('list'(_____1)), 'true').
':-'('<module>:data.record@0$has_predicate'('copy'(_____1)), 'true').
':-'('<module>:data.record@0$has_predicate'('pretty'(_____1)), 'true').
':-'('<module>:data.record@0:$sgn'(__36sgn, 'env'(___14, _X), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/record.mpl',202,13,196)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/record.mpl',214,13,196)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','(','(','(','(','(','('true', '<module>:data.record@0:atom_fresh_[2769]'(_atom__fresh___912770_93, __36Pb, __36Pe)), '<module>:data.record@0:atom_fresh_[2771]'(_atom__fresh___912772_93, __36Pb, __36Pe)), '<module>:data.record@0:atom_fresh_[2773]'(_atom__fresh___912774_93, __36Pb, __36Pe)), '<module>:data.record@0:atom_fresh_[2775]'(_atom__fresh___912776_93, __36Pb, __36Pe)), '<module>:data.record@0:atom_fresh_[2777]'(_atom__fresh___912778_93, __36Pb, __36Pe)), '<module>:data.record@0:atom_fresh_[2779]'(_atom__fresh___912780_93, __36Pb, __36Pe)), '<module>:data.record@0:atom_fresh_[2781]'(_atom__fresh___912782_93, __36Pb, __36Pe)), '<module>:data.record@0:atom_fresh_[2783]'(_atom__fresh___912784_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___912784_93, '.'(_atom__fresh___912782_93, '.'(_atom__fresh___912780_93, '.'(_atom__fresh___912778_93, '.'(_atom__fresh___912776_93, '.'(_atom__fresh___912774_93, '.'(_atom__fresh___912772_93, '.'(_atom__fresh___912770_93, '[]')))))))))))))).
':-'('<module>:data.record@0:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.record@0:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.record@0:atom_fresh_[2769]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(pretty, 1, predicate, suspended([none],[call(scope,true,[])]), __36pos))).
':-'('<module>:data.record@0:atom_fresh_[2771]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(copy, 1, predicate, suspended([none],[call(scope,true,[])]), __36pos))).
':-'('<module>:data.record@0:atom_fresh_[2773]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(list, 1, predicate, suspended([var('List')],[module('F',[symbol(do,2,predicate,suspended([var('Key'),none],[call(scope,true,[])]),file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/record.mpl',824,47,801),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/record.mpl',841,47,801)))]),call(atom('data.list'),iter,[none,var('F'),var('List')])]), __36pos))).
':-'('<module>:data.record@0:atom_fresh_[2775]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(iter, 1, predicate, suspended([var('F')],[module('F0',[symbol(do,1,predicate,suspended([var('Key')],[call(var('F'),do,[var('Key'),none])]),file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/record.mpl',660,40,637),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/record.mpl',698,41,663)))]),call(atom('data.list'),iter,[none,var('F0')])]), __36pos))).
':-'('<module>:data.record@0:atom_fresh_[2777]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(keys, 1, predicate, suspended([var('List')],[call(atom(kernel),record_keys,[var('X'),var('List')])]), __36pos))).
':-'('<module>:data.record@0:atom_fresh_[2779]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'({}, 2, predicate, suspended([var('Key'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:data.record@0:atom_fresh_[2781]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'({}, 1, predicate, '[]', __36pos))).
':-'('<module>:data.record@0:atom_fresh_[2783]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'({}, 0, predicate, [], __36pos))).
':-'('<module>:data.record@0:copy'(___46, 'env'(___14, _X), __36CutLevel), ','('emop_call'(___14, 'list'(___45), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/record.mpl\", line 52, from character 33 to 37'), ','('g_read'('data.record', '<module>:data.record'(___47)), '<module>:data.record:{}$direct'(___45, ___46, ___47)))).
':-'('<module>:data.record@0:copy$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.record@0:copy'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.record@0:iter'(_F, 'env'(___14, _X), __36CutLevel), ','(','('true', ';'('->'('var'(_F0), ','('g_inc'('$module_count', ___28), '='(_F0, '$module'(___28, '.'('<module>:data.record@1'('env'(_F0, _F, ___14)), '[]'), '.'(_F0, '[]'))))), ','('='(_F0, '$module'(___28, ___29, _)), ','('='('.'(___30, ___31), ___29), ','('setarg'(1, ___29, '<module>:data.record@1'('env'(_F0, _F, ___14))), 'setarg'(2, ___29, '.'(___30, ___31))))))), ','('emop_call'(___14, 'keys'(___34), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/record.mpl\", line 44, from character 29 to 33'), ','('g_read'('data.list', '<module>:data.list'(___35)), '<module>:data.list:iter$direct'(___34, _F0, ___35))))).
':-'('<module>:data.record@0:iter$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.record@0:iter'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.record@0:keys'(_List, 'env'(___14, _X), __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___27)), '<module>:kernel:record_keys$direct'(_X, _List, ___27))).
':-'('<module>:data.record@0:keys$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.record@0:keys'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.record@0:list'(_List, 'env'(___14, _X), __36CutLevel), ','(','('true', ';'('->'('var'(_F), ','('g_inc'('$module_count', ___36), '='(_F, '$module'(___36, '.'('<module>:data.record@2'('env'(_F, _X, _F, _List, ___14)), '[]'), '.'(_F, '[]'))))), ','('='(_F, '$module'(___36, ___37, _)), ','('='('.'(___38, ___39), ___37), ','('setarg'(1, ___37, '<module>:data.record@2'('env'(_F, _X, _F, _List, ___14))), 'setarg'(2, ___37, '.'(___38, ___39))))))), ','('emop_call'(___14, 'keys'(___42), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/record.mpl\", line 50, from character 29 to 33'), ','('g_read'('data.list', '<module>:data.list'(___43)), '<module>:data.list:iter$direct'(___42, _F, _List, ___43))))).
':-'('<module>:data.record@0:list$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.record@0:list'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.record@0:pretty'('\'data.record\':'(___49), 'env'(___14, _X), __36CutLevel), ','('emop_call'(___14, 'list'(___48), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/record.mpl\", line 54, from character 39 to 43'), 'emop_call'(___14, '{}'(___48, ___49), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/record.mpl\", line 54, from character 37 to 38'))).
':-'('<module>:data.record@0:pretty$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.record@0:pretty'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.record@0:{}'('env'(___14, _X), __36CutLevel), 'true').
':-'('<module>:data.record@0:{}'('[]', 'env'(___14, _X), __36CutLevel), 'true').
':-'('<module>:data.record@0:{}'('.'(_A, _B), 'env'(___14, _X), __36CutLevel), ','('emop_call'(___14, '{}'(_A), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/record.mpl\", line 21, from character 15 to 16'), 'emop_call'(___14, '{}'(_B), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/record.mpl\", line 22, from character 15 to 16'))).
':-'('<module>:data.record@0:{}'(','(_A, _B), 'env'(___14, _X), __36CutLevel), ','('emop_call'(___14, '{}'(_A), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/record.mpl\", line 27, from character 15 to 16'), 'emop_call'(___14, '{}'(_B), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/record.mpl\", line 28, from character 15 to 16'))).
':-'('<module>:data.record@0:{}'('=>'(_Key, _Value), 'env'(___14, _X), __36CutLevel), ','('='(___22, _Value), 'emop_call'(___14, '{}'(_Key, ___22), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/record.mpl\", line 32, from character 12 to 13'))).
':-'('<module>:data.record@0:{}'(_Key, ___24, 'env'(___14, _X), __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___25)), '<module>:kernel:record_get$direct'(_X, _Key, ___24, ___25))).
':-'('<module>:data.record@0:{}$direct'(__36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.record@0:{}'(__36env, __36CutLevel))).
':-'('<module>:data.record@0:{}$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.record@0:{}'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.record@0:{}$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.record@0:{}'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.record@1'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.record@1:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.record@1'('do'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.record@1:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.record@1'(__36t, __36env, __36pos, __36CutLevel), '<module>:data.record@1$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:data.record@1$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:data.record@1$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:data.record@1$has_predicate'('do'(_____1)), 'true').
':-'('<module>:data.record@1:$sgn'(__36sgn, 'env'(___32, _F, ___14), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/record.mpl',621,39,609)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/record.mpl',636,39,609)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:data.record@1:atom_fresh_[2787]'(_atom__fresh___912788_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___912788_93, '[]'))))))).
':-'('<module>:data.record@1:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.record@1:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.record@1:atom_fresh_[2787]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 1, predicate, suspended([var('Key')],[call(var('F'),do,[var('Key'),none])]), __36pos))).
':-'('<module>:data.record@1:do'(_Key, 'env'(___32, _F, ___14), __36CutLevel), ','('emop_call'(___14, '{}'(_Key, ___53), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/record.mpl\", line 42, from character 28 to 29'), 'emop_call'(_F, 'do'(_Key, ___53), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/record.mpl\", line 42, from character 20 to 22'))).
':-'('<module>:data.record@1:do$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.record@1:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.record@2'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.record@2:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.record@2'('do'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.record@2:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.record@2'(__36t, __36env, __36pos, __36CutLevel), '<module>:data.record@2$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:data.record@2$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:data.record@2$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:data.record@2$has_predicate'('do'(_____2, _____1)), 'true').
':-'('<module>:data.record@2:$sgn'(__36sgn, 'env'(___40, _X, _F, _List, ___14), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/record.mpl',790,46,778)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/record.mpl',800,46,778)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:data.record@2:atom_fresh_[2785]'(_atom__fresh___912786_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___912786_93, '[]'))))))).
':-'('<module>:data.record@2:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.record@2:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.record@2:atom_fresh_[2785]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 2, predicate, suspended([var('Key'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:data.record@2:do'(_Key, '=>'(_Key, ___51), 'env'(___40, _X, _F, _List, ___14), __36CutLevel), 'emop_call'(___14, '{}'(_Key, ___51), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/record.mpl\", line 48, from character 33 to 34')).
':-'('<module>:data.record@2:do$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.record@2:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('data.record@init', ','('true', 'g_link'('data.record', '<module>:data.record'('env')))).
':-'('dynamic'('/'('<module>:data.ref.backtrackable$dynamic', 4))).
':-'('dynamic'('/'('<module>:data.ref.backtrackable@0$dynamic', 4))).
':-'('<module>:data.ref.backtrackable'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.ref.backtrackable:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.ref.backtrackable'('new'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.ref.backtrackable:new'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.ref.backtrackable'('new'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.ref.backtrackable:new'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.ref.backtrackable'(__36t, __36env, __36pos, __36CutLevel), '<module>:data.ref.backtrackable$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:data.ref.backtrackable$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:data.ref.backtrackable$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:data.ref.backtrackable$has_predicate'('new'(_____2, _____1)), 'true').
':-'('<module>:data.ref.backtrackable$has_predicate'('new'(_____1)), 'true').
':-'('<module>:data.ref.backtrackable:$sgn'(__36sgn, 'env', __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/ref/backtrackable.mpl',0,0,0)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/ref/backtrackable.mpl',33,0,0)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','('true', '<module>:data.ref.backtrackable:atom_fresh_[1792]'(_atom__fresh___911793_93, __36Pb, __36Pe)), '<module>:data.ref.backtrackable:atom_fresh_[1794]'(_atom__fresh___911795_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___911795_93, '.'(_atom__fresh___911793_93, '[]')))))))).
':-'('<module>:data.ref.backtrackable:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.ref.backtrackable:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.ref.backtrackable:atom_fresh_[1792]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(new, 1, predicate, suspended([none],[call(scope,true,[])]), __36pos))).
':-'('<module>:data.ref.backtrackable:atom_fresh_[1794]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(new, 2, predicate, suspended([var('Initial'),var('Ref')],[call(atom(kernel),ref_backtrackable_new,[var('Initial'),var('X')]),module('Ref',[symbol(get,1,predicate,suspended([var('V')],[call(atom(kernel),ref_backtrackable_get,[var('X'),var('V')])]),file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/ref/backtrackable.mpl',152,4,136),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/ref/backtrackable.mpl',204,5,155))),symbol(set,1,predicate,suspended([var('V')],[call(atom(kernel),ref_backtrackable_set,[var('X'),var('V')])]),file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/ref/backtrackable.mpl',222,7,206),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/ref/backtrackable.mpl',274,8,225))),symbol(portray,1,predicate,suspended([var('S')],[call(var('S'),format,[none,none])]),file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/ref/backtrackable.mpl',296,10,276),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/ref/backtrackable.mpl',362,11,299)))])]), __36pos))).
':-'('<module>:data.ref.backtrackable:new'(___12, 'env', __36CutLevel), ','('g_read'('data.ref.backtrackable', '<module>:data.ref.backtrackable'(___13)), '<module>:data.ref.backtrackable:new$direct'(_, ___12, ___13))).
':-'('<module>:data.ref.backtrackable:new'(_Initial, _Ref, 'env', __36CutLevel), ','(','('g_read'('kernel', '<module>:kernel'(___5)), '<module>:kernel:ref_backtrackable_new$direct'(_Initial, _X, ___5)), ','('true', ';'('->'('var'(_Ref), ','('g_inc'('$module_count', ___6), '='(_Ref, '$module'(___6, '.'('<module>:data.ref.backtrackable@0'('env'(_Ref, _Ref, _X)), '[]'), '.'(_Ref, '[]'))))), ','('='(_Ref, '$module'(___6, ___7, _)), ','('='('.'(___8, ___9), ___7), ','('setarg'(1, ___7, '<module>:data.ref.backtrackable@0'('env'(_Ref, _Ref, _X))), 'setarg'(2, ___7, '.'(___8, ___9))))))))).
':-'('<module>:data.ref.backtrackable:new$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.ref.backtrackable:new'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.ref.backtrackable:new$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.ref.backtrackable:new'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.ref.backtrackable@0'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.ref.backtrackable@0:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.ref.backtrackable@0'('get'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.ref.backtrackable@0:get'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.ref.backtrackable@0'('set'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.ref.backtrackable@0:set'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.ref.backtrackable@0'('portray'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.ref.backtrackable@0:portray'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.ref.backtrackable@0'(__36t, __36env, __36pos, __36CutLevel), '<module>:data.ref.backtrackable@0$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:data.ref.backtrackable@0$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:data.ref.backtrackable@0$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:data.ref.backtrackable@0$has_predicate'('get'(_____1)), 'true').
':-'('<module>:data.ref.backtrackable@0$has_predicate'('set'(_____1)), 'true').
':-'('<module>:data.ref.backtrackable@0$has_predicate'('portray'(_____1)), 'true').
':-'('<module>:data.ref.backtrackable@0:$sgn'(__36sgn, 'env'(___10, _Ref, _X), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/ref/backtrackable.mpl',114,3,108)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/ref/backtrackable.mpl',135,3,108)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','('true', '<module>:data.ref.backtrackable@0:atom_fresh_[1796]'(_atom__fresh___911797_93, __36Pb, __36Pe)), '<module>:data.ref.backtrackable@0:atom_fresh_[1798]'(_atom__fresh___911799_93, __36Pb, __36Pe)), '<module>:data.ref.backtrackable@0:atom_fresh_[1800]'(_atom__fresh___911801_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___911801_93, '.'(_atom__fresh___911799_93, '.'(_atom__fresh___911797_93, '[]'))))))))).
':-'('<module>:data.ref.backtrackable@0:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.ref.backtrackable@0:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.ref.backtrackable@0:atom_fresh_[1796]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(portray, 1, predicate, suspended([var('S')],[call(var('S'),format,[none,none])]), __36pos))).
':-'('<module>:data.ref.backtrackable@0:atom_fresh_[1798]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(set, 1, predicate, suspended([var('V')],[call(atom(kernel),ref_backtrackable_set,[var('X'),var('V')])]), __36pos))).
':-'('<module>:data.ref.backtrackable@0:atom_fresh_[1800]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(get, 1, predicate, suspended([var('V')],[call(atom(kernel),ref_backtrackable_get,[var('X'),var('V')])]), __36pos))).
':-'('<module>:data.ref.backtrackable@0:get'(_V, 'env'(___10, _Ref, _X), __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___15)), '<module>:kernel:ref_backtrackable_get$direct'(_X, _V, ___15))).
':-'('<module>:data.ref.backtrackable@0:get$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.ref.backtrackable@0:get'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.ref.backtrackable@0:portray'(_S, 'env'(___10, _Ref, _X), __36CutLevel), ','('emop_call'(_Ref, 'get'(___19), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/ref/backtrackable.mpl\", line 12, from character 57 to 60'), 'emop_call'(_S, 'format'('data.ref.backtrackable:(~p)', '.'(___19, '[]')), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/ref/backtrackable.mpl\", line 12, from character 14 to 20'))).
':-'('<module>:data.ref.backtrackable@0:portray$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.ref.backtrackable@0:portray'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.ref.backtrackable@0:set'(_V, 'env'(___10, _Ref, _X), __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___17)), '<module>:kernel:ref_backtrackable_set$direct'(_X, _V, ___17))).
':-'('<module>:data.ref.backtrackable@0:set$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.ref.backtrackable@0:set'(_____1, __36env, __36CutLevel))).
':-'('data.ref.backtrackable@init', ','('true', 'g_link'('data.ref.backtrackable', '<module>:data.ref.backtrackable'('env')))).
':-'('dynamic'('/'('<module>:data.ref.non_backtrackable$dynamic', 4))).
':-'('dynamic'('/'('<module>:data.ref.non_backtrackable@0$dynamic', 4))).
':-'('<module>:data.ref.non_backtrackable'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.ref.non_backtrackable:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.ref.non_backtrackable'('new'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.ref.non_backtrackable:new'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.ref.non_backtrackable'(__36t, __36env, __36pos, __36CutLevel), '<module>:data.ref.non_backtrackable$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:data.ref.non_backtrackable$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:data.ref.non_backtrackable$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:data.ref.non_backtrackable$has_predicate'('new'(_____2, _____1)), 'true').
':-'('<module>:data.ref.non_backtrackable:$sgn'(__36sgn, 'env', __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/ref/non_backtrackable.mpl',0,0,0)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/ref/non_backtrackable.mpl',37,0,0)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:data.ref.non_backtrackable:atom_fresh_[1506]'(_atom__fresh___911507_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___911507_93, '[]'))))))).
':-'('<module>:data.ref.non_backtrackable:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.ref.non_backtrackable:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.ref.non_backtrackable:atom_fresh_[1506]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(new, 2, predicate, suspended([var('Initial'),var('Ref')],[call(atom(kernel),ref_non_backtrackable_new,[var('Initial'),var('X')]),module('Ref',[symbol(get,1,predicate,suspended([var('V')],[call(atom(kernel),ref_non_backtrackable_get,[var('X'),var('V')])]),file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/ref/non_backtrackable.mpl',160,4,144),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/ref/non_backtrackable.mpl',216,5,163))),symbol(set,1,predicate,suspended([var('V')],[call(atom(kernel),ref_non_backtrackable_set,[var('X'),var('V')])]),file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/ref/non_backtrackable.mpl',234,7,218),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/ref/non_backtrackable.mpl',290,8,237))),symbol(portray,1,predicate,suspended([var('S')],[call(var('S'),format,[none,none])]),file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/ref/non_backtrackable.mpl',312,10,292),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/ref/non_backtrackable.mpl',382,11,315)))])]), __36pos))).
':-'('<module>:data.ref.non_backtrackable:new'(_Initial, _Ref, 'env', __36CutLevel), ','(','('g_read'('kernel', '<module>:kernel'(___5)), '<module>:kernel:ref_non_backtrackable_new$direct'(_Initial, _X, ___5)), ','('true', ';'('->'('var'(_Ref), ','('g_inc'('$module_count', ___6), '='(_Ref, '$module'(___6, '.'('<module>:data.ref.non_backtrackable@0'('env'(_Ref, _Ref, _X)), '[]'), '.'(_Ref, '[]'))))), ','('='(_Ref, '$module'(___6, ___7, _)), ','('='('.'(___8, ___9), ___7), ','('setarg'(1, ___7, '<module>:data.ref.non_backtrackable@0'('env'(_Ref, _Ref, _X))), 'setarg'(2, ___7, '.'(___8, ___9))))))))).
':-'('<module>:data.ref.non_backtrackable:new$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.ref.non_backtrackable:new'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.ref.non_backtrackable@0'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.ref.non_backtrackable@0:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.ref.non_backtrackable@0'('get'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.ref.non_backtrackable@0:get'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.ref.non_backtrackable@0'('set'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.ref.non_backtrackable@0:set'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.ref.non_backtrackable@0'('portray'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.ref.non_backtrackable@0:portray'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.ref.non_backtrackable@0'(__36t, __36env, __36pos, __36CutLevel), '<module>:data.ref.non_backtrackable@0$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:data.ref.non_backtrackable@0$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:data.ref.non_backtrackable@0$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:data.ref.non_backtrackable@0$has_predicate'('get'(_____1)), 'true').
':-'('<module>:data.ref.non_backtrackable@0$has_predicate'('set'(_____1)), 'true').
':-'('<module>:data.ref.non_backtrackable@0$has_predicate'('portray'(_____1)), 'true').
':-'('<module>:data.ref.non_backtrackable@0:$sgn'(__36sgn, 'env'(___10, _Ref, _X), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/ref/non_backtrackable.mpl',122,3,116)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/ref/non_backtrackable.mpl',143,3,116)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','('true', '<module>:data.ref.non_backtrackable@0:atom_fresh_[1508]'(_atom__fresh___911509_93, __36Pb, __36Pe)), '<module>:data.ref.non_backtrackable@0:atom_fresh_[1510]'(_atom__fresh___911511_93, __36Pb, __36Pe)), '<module>:data.ref.non_backtrackable@0:atom_fresh_[1512]'(_atom__fresh___911513_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___911513_93, '.'(_atom__fresh___911511_93, '.'(_atom__fresh___911509_93, '[]'))))))))).
':-'('<module>:data.ref.non_backtrackable@0:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.ref.non_backtrackable@0:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.ref.non_backtrackable@0:atom_fresh_[1508]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(portray, 1, predicate, suspended([var('S')],[call(var('S'),format,[none,none])]), __36pos))).
':-'('<module>:data.ref.non_backtrackable@0:atom_fresh_[1510]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(set, 1, predicate, suspended([var('V')],[call(atom(kernel),ref_non_backtrackable_set,[var('X'),var('V')])]), __36pos))).
':-'('<module>:data.ref.non_backtrackable@0:atom_fresh_[1512]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(get, 1, predicate, suspended([var('V')],[call(atom(kernel),ref_non_backtrackable_get,[var('X'),var('V')])]), __36pos))).
':-'('<module>:data.ref.non_backtrackable@0:get'(_V, 'env'(___10, _Ref, _X), __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___12)), '<module>:kernel:ref_non_backtrackable_get$direct'(_X, _V, ___12))).
':-'('<module>:data.ref.non_backtrackable@0:get$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.ref.non_backtrackable@0:get'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.ref.non_backtrackable@0:portray'(_S, 'env'(___10, _Ref, _X), __36CutLevel), ','('emop_call'(_Ref, 'get'(___16), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/ref/non_backtrackable.mpl\", line 12, from character 61 to 64'), 'emop_call'(_S, 'format'('data.ref.non_backtrackable:(~p)', '.'(___16, '[]')), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/ref/non_backtrackable.mpl\", line 12, from character 14 to 20'))).
':-'('<module>:data.ref.non_backtrackable@0:portray$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.ref.non_backtrackable@0:portray'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.ref.non_backtrackable@0:set'(_V, 'env'(___10, _Ref, _X), __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___14)), '<module>:kernel:ref_non_backtrackable_set$direct'(_X, _V, ___14))).
':-'('<module>:data.ref.non_backtrackable@0:set$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.ref.non_backtrackable@0:set'(_____1, __36env, __36CutLevel))).
':-'('data.ref.non_backtrackable@init', ','('true', 'g_link'('data.ref.non_backtrackable', '<module>:data.ref.non_backtrackable'('env')))).
':-'('dynamic'('/'('<module>:data.ref$dynamic', 4))).
':-'('<module>:data.ref'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.ref:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.ref'('<-'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.ref:<-'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.ref'('?'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.ref:?'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.ref'(__36t, __36env, __36pos, __36CutLevel), '<module>:data.ref$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:data.ref$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:data.ref$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:data.ref$has_predicate'('<-'(_____2, _____1)), 'true').
':-'('<module>:data.ref$has_predicate'('?'(_____2, _____1)), 'true').
':-'('<module>:data.ref:$sgn'(__36sgn, 'env', __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/ref.mpl',0,0,0)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/ref.mpl',17,0,0)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','(','(','(','('true', '<module>:data.ref:atom_fresh_[4331]'(_atom__fresh___914332_93, __36Pb, __36Pe)), '<module>:data.ref:atom_fresh_[4333]'(_atom__fresh___914334_93, __36Pb, __36Pe)), '<module>:data.ref:atom_fresh_[4335]'(_atom__fresh___914336_93, __36Pb, __36Pe)), '<module>:data.ref:atom_fresh_[4337]'(_atom__fresh___914338_93, __36Pb, __36Pe)), '<module>:data.ref:atom_fresh_[4339]'(_atom__fresh___914340_93, __36Pb, __36Pe)), '<module>:data.ref:atom_fresh_[4341]'(_atom__fresh___914342_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___914342_93, '.'(_atom__fresh___914340_93, '.'(_atom__fresh___914338_93, '.'(_atom__fresh___914336_93, '.'(_atom__fresh___914334_93, '.'(_atom__fresh___914332_93, '[]')))))))))))).
':-'('<module>:data.ref:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.ref:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.ref:<-'(_X, _V, 'env', __36CutLevel), 'emop_call'(_X, 'set'(_V), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/ref.mpl\", line 7, from character 8 to 11')).
':-'('<module>:data.ref:<-$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.ref:<-'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.ref:?'(_X, ___4, 'env', __36CutLevel), 'emop_call'(_X, 'get'(___4), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/ref.mpl\", line 13, from character 14 to 17')).
':-'('<module>:data.ref:?$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.ref:?'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.ref:atom_fresh_[4331]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(?, 2, predicate, suspended([var('X'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:data.ref:atom_fresh_[4333]'(__36s, __36Pb, __36Pe), '='(__36s, 'syntax'('.'('callable'('prefix', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('-', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('<', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('?', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('<', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'(':', 'escaped', 'none', __36Pb, __36Pe), '[]')))))), __36Pb, __36Pe))).
':-'('<module>:data.ref:atom_fresh_[4335]'(__36s, __36Pb, __36Pe), '='(__36s, 'syntax'('.'('callable'('prefix', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('?', 'escaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe))).
':-'('<module>:data.ref:atom_fresh_[4337]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(<-, 2, predicate, suspended([var('X'),var('V')],[call(var('X'),set,[var('V')])]), __36pos))).
':-'('<module>:data.ref:atom_fresh_[4339]'(__36s, __36Pb, __36Pe), '='(__36s, 'syntax'('.'('callable'('<-', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('=', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('=', 'escaped', 'none', __36Pb, __36Pe), '[]'))), __36Pb, __36Pe))).
':-'('<module>:data.ref:atom_fresh_[4341]'(__36s, __36Pb, __36Pe), '='(__36s, 'syntax'('.'('callable'('infix', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('<-', 'escaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe))).
':-'('data.ref@init', ','('true', 'g_link'('data.ref', '<module>:data.ref'('env')))).
':-'('dynamic'('/'('<module>:data.stream$dynamic', 4))).
':-'('dynamic'('/'('<module>:data.stream@0$dynamic', 4))).
':-'('<module>:data.stream'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.stream:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.stream'('end_of_file'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.stream:end_of_file'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.stream'('input_stream'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.stream:input_stream'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.stream'(__36t, __36env, __36pos, __36CutLevel), '<module>:data.stream$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:data.stream$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:data.stream$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:data.stream$has_predicate'('end_of_file'(_____1)), 'true').
':-'('<module>:data.stream$has_predicate'('input_stream'(_____1)), 'true').
':-'('<module>:data.stream:$sgn'(__36sgn, 'env', __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/stream.mpl',0,0,0)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/stream.mpl',20,0,0)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','('true', '<module>:data.stream:atom_fresh_[1978]'(_atom__fresh___911979_93, __36Pb, __36Pe)), '<module>:data.stream:atom_fresh_[1980]'(_atom__fresh___911981_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___911981_93, '.'(_atom__fresh___911979_93, '[]')))))))).
':-'('<module>:data.stream:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.stream:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.stream:atom_fresh_[1978]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(input_stream, 1, predicate, '[]', __36pos))).
':-'('<module>:data.stream:atom_fresh_[1980]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(end_of_file, 1, constructor, none, __36pos))).
':-'('<module>:data.stream:end_of_file'(___4, 'env', __36CutLevel), '=..'(___4, '.'('end_of_file', '[]'))).
':-'('<module>:data.stream:end_of_file$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.stream:end_of_file'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.stream:input_stream'(___5, 'env', __36CutLevel), ','('true', ';'('->'('var'(___5), ','('g_inc'('$module_count', ___6), '='(___5, '$module'(___6, '.'('<module>:data.stream@0'('env'(___5)), '[]'), '.'(___5, '[]'))))), ','('='(___5, '$module'(___6, ___7, _)), ','('='('.'(___8, ___9), ___7), ','('setarg'(1, ___7, '<module>:data.stream@0'('env'(___5))), 'setarg'(2, ___7, '.'(___8, ___9)))))))).
':-'('<module>:data.stream:input_stream$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.stream:input_stream'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.stream@0'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.stream@0:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.stream@0'('string'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.stream@0:string'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.stream@0'('atom'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.stream@0:atom'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.stream@0'(__36t, __36env, __36pos, __36CutLevel), '<module>:data.stream@0$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:data.stream@0$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:data.stream@0$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:data.stream@0$has_predicate'('string'(_____1)), 'true').
':-'('<module>:data.stream@0$has_predicate'('atom'(_____1)), 'true').
':-'('<module>:data.stream@0:$sgn'(__36sgn, 'env'(___10), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/stream.mpl',71,3,53)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/stream.mpl',79,3,53)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','('true', '<module>:data.stream@0:atom_fresh_[1982]'(_atom__fresh___911983_93, __36Pb, __36Pe)), '<module>:data.stream@0:atom_fresh_[1984]'(_atom__fresh___911985_93, __36Pb, __36Pe)), '<module>:data.stream@0:atom_fresh_[1986]'(_atom__fresh___911987_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___911987_93, '.'(_atom__fresh___911985_93, '.'(_atom__fresh___911983_93, '[]'))))))))).
':-'('<module>:data.stream@0:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.stream@0:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.stream@0:atom'(___16, 'env'(___10), __36CutLevel), ','('emop_call'(___10, 'string'(___15), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/stream.mpl\", line 18, from character 30 to 36'), ','('g_read'('data.string', '<module>:data.string'(___17)), '<module>:data.string:atom$direct'(___15, ___16, ___17)))).
':-'('<module>:data.stream@0:atom$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.stream@0:atom'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.stream@0:atom_fresh_[1982]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(atom, 1, predicate, suspended([none],[call(scope,true,[])]), __36pos))).
':-'('<module>:data.stream@0:atom_fresh_[1984]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(string, 1, predicate, '[]', __36pos))).
':-'('<module>:data.stream@0:atom_fresh_[1986]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(read, 1, abstract, none, __36pos))).
':-'('<module>:data.stream@0:string'(_L, 'env'(___10), __36CutLevel), ','('emop_call'(___10, 'read'(_C), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/stream.mpl\", line 8, from character 9 to 13'), ';'('->'('='(_C, 'end_of_file'), '='(_L, '[]')), ','('='(_L, '.'(_C, _Tail)), 'emop_call'(___10, 'string'(_Tail), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/stream.mpl\", line 15, from character 12 to 18'))))).
':-'('<module>:data.stream@0:string$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.stream@0:string'(_____1, __36env, __36CutLevel))).
':-'('data.stream@init', ','('true', 'g_link'('data.stream', '<module>:data.stream'('env')))).
':-'('dynamic'('/'('<module>:data.string$dynamic', 4))).
':-'('<module>:data.string'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.string:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.string'('atom'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.string:atom'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.string'('number'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.string:number'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.string'(__36t, __36env, __36pos, __36CutLevel), '<module>:data.string$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:data.string$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:data.string$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:data.string$has_predicate'('atom'(_____2, _____1)), 'true').
':-'('<module>:data.string$has_predicate'('number'(_____2, _____1)), 'true').
':-'('<module>:data.string:$sgn'(__36sgn, 'env', __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/string.mpl',0,0,0)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/string.mpl',22,0,0)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','('true', '<module>:data.string:atom_fresh_[1802]'(_atom__fresh___911803_93, __36Pb, __36Pe)), '<module>:data.string:atom_fresh_[1804]'(_atom__fresh___911805_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___911805_93, '.'(_atom__fresh___911803_93, '[]')))))))).
':-'('<module>:data.string:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.string:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.string:atom'(_String, _Atom, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___5)), '<module>:kernel:string_to_atom$direct'(_String, _Atom, ___5))).
':-'('<module>:data.string:atom$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.string:atom'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.string:atom_fresh_[1802]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(number, 2, predicate, suspended([var('String'),var('Number')],[call(atom(kernel),string_to_number,[var('String'),var('Number')])]), __36pos))).
':-'('<module>:data.string:atom_fresh_[1804]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(atom, 2, predicate, suspended([var('String'),var('Atom')],[call(atom(kernel),string_to_atom,[var('String'),var('Atom')])]), __36pos))).
':-'('<module>:data.string:number'(_String, _Number, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___7)), '<module>:kernel:string_to_number$direct'(_String, _Number, ___7))).
':-'('<module>:data.string:number$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.string:number'(_____2, _____1, __36env, __36CutLevel))).
':-'('data.string@init', ','('true', 'g_link'('data.string', '<module>:data.string'('env')))).
':-'('dynamic'('/'('<module>:data.term$dynamic', 4))).
':-'('<module>:data.term'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.term:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.term'('check'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.term:check'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.term'('compare'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.term:compare'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.term'('>='(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.term:>='(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.term'('>'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.term:>'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.term'('=<'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.term:=<'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.term'('<'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.term:<'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.term'('decomposition'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.term:decomposition'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.term'('make'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.term:make'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.term'('functor'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.term:functor'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.term'('new'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.term:new'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.term'('arg0'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.term:arg0'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.term'('arg1'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.term:arg1'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.term'('setarg0'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.term:setarg0'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.term'('setarg1'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.term:setarg1'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.term'('copy'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.term:copy'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.term'(__36t, __36env, __36pos, __36CutLevel), '<module>:data.term$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:data.term$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:data.term$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:data.term$has_predicate'('check'(_____1)), 'true').
':-'('<module>:data.term$has_predicate'('compare'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.term$has_predicate'('>='(_____2, _____1)), 'true').
':-'('<module>:data.term$has_predicate'('>'(_____2, _____1)), 'true').
':-'('<module>:data.term$has_predicate'('=<'(_____2, _____1)), 'true').
':-'('<module>:data.term$has_predicate'('<'(_____2, _____1)), 'true').
':-'('<module>:data.term$has_predicate'('decomposition'(_____2, _____1)), 'true').
':-'('<module>:data.term$has_predicate'('make'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.term$has_predicate'('functor'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.term$has_predicate'('new'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.term$has_predicate'('arg0'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.term$has_predicate'('arg1'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.term$has_predicate'('setarg0'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.term$has_predicate'('setarg1'(_____3, _____2, _____1)), 'true').
':-'('<module>:data.term$has_predicate'('copy'(_____2, _____1)), 'true').
':-'('<module>:data.term:$sgn'(__36sgn, 'env', __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/term.mpl',0,0,0)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/term.mpl',20,0,0)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','('true', '<module>:data.term:atom_fresh_[1762]'(_atom__fresh___911763_93, __36Pb, __36Pe)), '<module>:data.term:atom_fresh_[1764]'(_atom__fresh___911765_93, __36Pb, __36Pe)), '<module>:data.term:atom_fresh_[1766]'(_atom__fresh___911767_93, __36Pb, __36Pe)), '<module>:data.term:atom_fresh_[1768]'(_atom__fresh___911769_93, __36Pb, __36Pe)), '<module>:data.term:atom_fresh_[1770]'(_atom__fresh___911771_93, __36Pb, __36Pe)), '<module>:data.term:atom_fresh_[1772]'(_atom__fresh___911773_93, __36Pb, __36Pe)), '<module>:data.term:atom_fresh_[1774]'(_atom__fresh___911775_93, __36Pb, __36Pe)), '<module>:data.term:atom_fresh_[1776]'(_atom__fresh___911777_93, __36Pb, __36Pe)), '<module>:data.term:atom_fresh_[1778]'(_atom__fresh___911779_93, __36Pb, __36Pe)), '<module>:data.term:atom_fresh_[1780]'(_atom__fresh___911781_93, __36Pb, __36Pe)), '<module>:data.term:atom_fresh_[1782]'(_atom__fresh___911783_93, __36Pb, __36Pe)), '<module>:data.term:atom_fresh_[1784]'(_atom__fresh___911785_93, __36Pb, __36Pe)), '<module>:data.term:atom_fresh_[1786]'(_atom__fresh___911787_93, __36Pb, __36Pe)), '<module>:data.term:atom_fresh_[1788]'(_atom__fresh___911789_93, __36Pb, __36Pe)), '<module>:data.term:atom_fresh_[1790]'(_atom__fresh___911791_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___911791_93, '.'(_atom__fresh___911789_93, '.'(_atom__fresh___911787_93, '.'(_atom__fresh___911785_93, '.'(_atom__fresh___911783_93, '.'(_atom__fresh___911781_93, '.'(_atom__fresh___911779_93, '.'(_atom__fresh___911777_93, '.'(_atom__fresh___911775_93, '.'(_atom__fresh___911773_93, '.'(_atom__fresh___911771_93, '.'(_atom__fresh___911769_93, '.'(_atom__fresh___911767_93, '.'(_atom__fresh___911765_93, '.'(_atom__fresh___911763_93, '[]'))))))))))))))))))))).
':-'('<module>:data.term:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.term:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.term:<'(_A, _B, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___15)), '<module>:kernel:term_lt$direct'(_A, _B, ___15))).
':-'('<module>:data.term:<$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.term:<'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.term:=<'(_A, _B, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___13)), '<module>:kernel:term_le$direct'(_A, _B, ___13))).
':-'('<module>:data.term:=<$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.term:=<'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.term:>'(_A, _B, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___11)), '<module>:kernel:term_gt$direct'(_A, _B, ___11))).
':-'('<module>:data.term:>$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.term:>'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.term:>='(_A, _B, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___9)), '<module>:kernel:term_ge$direct'(_A, _B, ___9))).
':-'('<module>:data.term:>=$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.term:>='(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.term:arg0'(_I, _Term, _Arg, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___26)), '<module>:kernel:term_arg0$direct'(_I, _Term, _Arg, ___26))).
':-'('<module>:data.term:arg0$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.term:arg0'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.term:arg1'(_I, _Term, _Arg, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___28)), '<module>:kernel:term_arg1$direct'(_I, _Term, _Arg, ___28))).
':-'('<module>:data.term:arg1$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.term:arg1'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.term:atom_fresh_[1762]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(copy, 2, predicate, suspended([var('Term0'),var('Term1')],[call(atom(kernel),term_copy,[var('Term0'),var('Term1')])]), __36pos))).
':-'('<module>:data.term:atom_fresh_[1764]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(setarg1, 3, predicate, suspended([var('I'),var('Term'),var('Arg')],[call(atom(kernel),term_setarg1,[var('I'),var('Term'),var('Arg')])]), __36pos))).
':-'('<module>:data.term:atom_fresh_[1766]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(setarg0, 3, predicate, suspended([var('I'),var('Term'),var('Arg')],[call(atom(kernel),term_setarg0,[var('I'),var('Term'),var('Arg')])]), __36pos))).
':-'('<module>:data.term:atom_fresh_[1768]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(arg1, 3, predicate, suspended([var('I'),var('Term'),var('Arg')],[call(atom(kernel),term_arg1,[var('I'),var('Term'),var('Arg')])]), __36pos))).
':-'('<module>:data.term:atom_fresh_[1770]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(arg0, 3, predicate, suspended([var('I'),var('Term'),var('Arg')],[call(atom(kernel),term_arg0,[var('I'),var('Term'),var('Arg')])]), __36pos))).
':-'('<module>:data.term:atom_fresh_[1772]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(new, 3, predicate, suspended([var('F'),var('N'),var('Term')],[call(atom('data.term'),functor,[var('Term'),var('F'),var('N')])]), __36pos))).
':-'('<module>:data.term:atom_fresh_[1774]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(functor, 3, predicate, suspended([var('Term'),var('F'),var('N')],[call(atom(kernel),term_functor,[var('Term'),var('F'),var('N')])]), __36pos))).
':-'('<module>:data.term:atom_fresh_[1776]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(make, 3, predicate, suspended([var('F'),var('Args'),var('Term')],[call(atom('data.term'),decomposition,[var('Term'),none])]), __36pos))).
':-'('<module>:data.term:atom_fresh_[1778]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(decomposition, 2, predicate, suspended([var('Term'),var('List')],[call(atom(kernel),term_decomposition,[var('Term'),var('List')])]), __36pos))).
':-'('<module>:data.term:atom_fresh_[1780]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(<, 2, predicate, suspended([var('A'),var('B')],[call(atom(kernel),term_lt,[var('A'),var('B')])]), __36pos))).
':-'('<module>:data.term:atom_fresh_[1782]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(=<, 2, predicate, suspended([var('A'),var('B')],[call(atom(kernel),term_le,[var('A'),var('B')])]), __36pos))).
':-'('<module>:data.term:atom_fresh_[1784]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(>, 2, predicate, suspended([var('A'),var('B')],[call(atom(kernel),term_gt,[var('A'),var('B')])]), __36pos))).
':-'('<module>:data.term:atom_fresh_[1786]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(>=, 2, predicate, suspended([var('A'),var('B')],[call(atom(kernel),term_ge,[var('A'),var('B')])]), __36pos))).
':-'('<module>:data.term:atom_fresh_[1788]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(compare, 3, predicate, suspended([var('A'),var('B'),var('R')],[call(atom(kernel),term_compare,[var('A'),var('B'),var('R')])]), __36pos))).
':-'('<module>:data.term:atom_fresh_[1790]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(check, 1, predicate, suspended([var('X')],[call(atom(kernel),term_check,[var('X')])]), __36pos))).
':-'('<module>:data.term:check'(_X, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___5)), '<module>:kernel:term_check$direct'(_X, ___5))).
':-'('<module>:data.term:check$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.term:check'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.term:compare'(_A, _B, _R, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___7)), '<module>:kernel:term_compare$direct'(_A, _B, _R, ___7))).
':-'('<module>:data.term:compare$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.term:compare'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.term:copy'(_Term0, _Term1, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___34)), '<module>:kernel:term_copy$direct'(_Term0, _Term1, ___34))).
':-'('<module>:data.term:copy$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.term:copy'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.term:decomposition'(_Term, _List, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___17)), '<module>:kernel:term_decomposition$direct'(_Term, _List, ___17))).
':-'('<module>:data.term:decomposition$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.term:decomposition'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.term:functor'(_Term, _F, _N, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___22)), '<module>:kernel:term_functor$direct'(_Term, _F, _N, ___22))).
':-'('<module>:data.term:functor$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.term:functor'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.term:make'(_F, _Args, _Term, 'env', __36CutLevel), ','('g_read'('data.term', '<module>:data.term'(___20)), '<module>:data.term:decomposition$direct'(_Term, '.'(_F, _Args), ___20))).
':-'('<module>:data.term:make$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.term:make'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.term:new'(_F, _N, _Term, 'env', __36CutLevel), ','('g_read'('data.term', '<module>:data.term'(___24)), '<module>:data.term:functor$direct'(_Term, _F, _N, ___24))).
':-'('<module>:data.term:new$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.term:new'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.term:setarg0'(_I, _Term, _Arg, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___30)), '<module>:kernel:term_setarg0$direct'(_I, _Term, _Arg, ___30))).
':-'('<module>:data.term:setarg0$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.term:setarg0'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.term:setarg1'(_I, _Term, _Arg, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___32)), '<module>:kernel:term_setarg1$direct'(_I, _Term, _Arg, ___32))).
':-'('<module>:data.term:setarg1$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.term:setarg1'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('data.term@init', ','('true', 'g_link'('data.term', '<module>:data.term'('env')))).
':-'('dynamic'('/'('<module>:data.var$dynamic', 4))).
':-'('<module>:data.var'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.var:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.var'('check'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.var:check'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.var'('pure'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:data.var:pure'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.var'('name_query_vars'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:data.var:name_query_vars'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.var'(__36t, __36env, __36pos, __36CutLevel), '<module>:data.var$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:data.var$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:data.var$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:data.var$has_predicate'('check'(_____1)), 'true').
':-'('<module>:data.var$has_predicate'('pure'(_____1)), 'true').
':-'('<module>:data.var$has_predicate'('name_query_vars'(_____2, _____1)), 'true').
':-'('<module>:data.var:$sgn'(__36sgn, 'env', __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/var.mpl',0,0,0)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/data/var.mpl',19,0,0)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','('true', '<module>:data.var:atom_fresh_[1080]'(_atom__fresh___911081_93, __36Pb, __36Pe)), '<module>:data.var:atom_fresh_[1082]'(_atom__fresh___911083_93, __36Pb, __36Pe)), '<module>:data.var:atom_fresh_[1084]'(_atom__fresh___911085_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___911085_93, '.'(_atom__fresh___911083_93, '.'(_atom__fresh___911081_93, '[]'))))))))).
':-'('<module>:data.var:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.var:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.var:atom_fresh_[1080]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(name_query_vars, 2, predicate, suspended([var('List'),var('Rest')],[call(atom(kernel),var_name_query_vars,[var('List'),var('Rest')])]), __36pos))).
':-'('<module>:data.var:atom_fresh_[1082]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(pure, 1, predicate, suspended([var('Var')],[call(atom(kernel),var_pure,[var('Var')])]), __36pos))).
':-'('<module>:data.var:atom_fresh_[1084]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(check, 1, predicate, suspended([var('Var')],[call(atom(kernel),var_check,[var('Var')])]), __36pos))).
':-'('<module>:data.var:check'(_Var, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___5)), '<module>:kernel:var_check$direct'(_Var, ___5))).
':-'('<module>:data.var:check$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.var:check'(_____1, __36env, __36CutLevel))).
':-'('<module>:data.var:name_query_vars'(_List, _Rest, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___9)), '<module>:kernel:var_name_query_vars$direct'(_List, _Rest, ___9))).
':-'('<module>:data.var:name_query_vars$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.var:name_query_vars'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:data.var:pure'(_Var, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___7)), '<module>:kernel:var_pure$direct'(_Var, ___7))).
':-'('<module>:data.var:pure$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:data.var:pure'(_____1, __36env, __36CutLevel))).
':-'('data.var@init', ','('true', 'g_link'('data.var', '<module>:data.var'('env')))).
':-'('dynamic'('/'('<module>:emop.compile$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.compile@19$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.compile@18$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.compile@21$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.compile@20$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.compile@17$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.compile@16$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.compile@15$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.compile@23$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.compile@22$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.compile@14$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.compile@13$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.compile@12$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.compile@24$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.compile@11$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.compile@10$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.compile@9$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.compile@8$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.compile@7$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.compile@25$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.compile@6$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.compile@5$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.compile@4$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.compile@3$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.compile@2$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.compile@1$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.compile@0$dynamic', 4))).
':-'('<module>:emop.compile'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('directive'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:directive'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('dep'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:dep'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('expand_error'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:expand_error'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('file'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:file'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('callable'(_____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:callable'(_____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('empty'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:empty'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('operator'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:operator'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('unescaped'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:unescaped'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('parsing_error'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:parsing_error'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('error'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:error'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('lexing_error'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:lexing_error'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('write'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:write'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('failure'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:failure'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('clause'(_____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:clause'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('pos'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:pos'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('call'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:call'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('mod'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:mod'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('some'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:some'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('emop_call'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:emop_call'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('file'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:file'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('file'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:file'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('true'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:true'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('none'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:none'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('error'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:error'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('cmdline'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:cmdline'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('name'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:name'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('main'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:main'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('g_read'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:g_read'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('g_assign'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:g_assign'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('number'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:number'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('callable'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:callable'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('initialization'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:initialization'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('catch'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:catch'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('g_inc'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:g_inc'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('var'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:var'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('emop_call'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:emop_call'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('flush_output'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:flush_output'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('print'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:print'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('runtime'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:runtime'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('build_dir'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:build_dir'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('set_build_dir'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:set_build_dir'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('temp_dir'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:temp_dir'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('use_cache'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:use_cache'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('set_use_cache'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:set_use_cache'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('do_not_build_with_warning', __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:do_not_build_with_warning'(__36env, __36CutLevel))).
':-'('<module>:emop.compile'('set_do_not_build_with_warning'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:set_do_not_build_with_warning'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('verbose', __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:verbose'(__36env, __36CutLevel))).
':-'('<module>:emop.compile'('set_verbose'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:set_verbose'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('deps', __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:deps'(__36env, __36CutLevel))).
':-'('<module>:emop.compile'('set_deps'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:set_deps'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('wam_patch', __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:wam_patch'(__36env, __36CutLevel))).
':-'('<module>:emop.compile'('set_wam_patch'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:set_wam_patch'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('size'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:size'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('prolog_options'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:prolog_options'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('log'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:log'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('gplc'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:gplc'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('patch_wam'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:patch_wam'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('default_init_call'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:default_init_call'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('compile'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:compile'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('compile'(_____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:compile'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('build'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:build'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('depend'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:depend'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('link'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:link'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('interface'(_____7, _____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:interface'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('read_interface'(_____10, _____9, _____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:read_interface'(_____10, _____9, _____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('temp_filename'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:temp_filename'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('build_filename'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:build_filename'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('filename_pl'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:filename_pl'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('filename_link_pl'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:filename_link_pl'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('filename_link_wam'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:filename_link_wam'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('filename_mpi'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:filename_mpi'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('filename_unpatched_wam'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:filename_unpatched_wam'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('filename_wam'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:filename_wam'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('filename_o'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:filename_o'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('try_open'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:try_open'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('lookup_file'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:lookup_file'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('lookup'(_____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:lookup'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('module_filename'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:module_filename'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('lib_dir'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:lib_dir'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('paths'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:paths'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('read_interface_expand'(_____10, _____9, _____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:read_interface_expand'(_____10, _____9, _____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('split_fid'(_____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:split_fid'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('generate_init_goal'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:generate_init_goal'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('assert_call_redirect'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:assert_call_redirect'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('generate_static'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:generate_static'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('generate_call_redirect'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:generate_call_redirect'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('solve_deps'(_____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:solve_deps'(_____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('require'(_____7, _____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:require'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('consult'(_____7, _____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:consult'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('consult_dyn'(_____7, _____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:consult_dyn'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('find_fid'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:find_fid'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('reconsult'(_____7, _____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:reconsult'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('check_user_defined'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:check_user_defined'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('load_ast'(_____7, _____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:load_ast'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('import'(_____10, _____9, _____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:import'(_____10, _____9, _____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('clauses_to_prolog'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:clauses_to_prolog'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('generate_object_file'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:generate_object_file'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('symbol'(_____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:symbol'(_____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('initial_scope'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:initial_scope'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('prolog_to_object'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:prolog_to_object'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('prolog_to_patched_wam'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:prolog_to_patched_wam'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('prolog_to_wam'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:prolog_to_wam'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'('compile_file'(_____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile:compile_file'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.compile$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.compile$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.compile$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('directive'(_____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('dep'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('expand_error'(_____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('file'(_____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('callable'(_____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('empty'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('operator'(_____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('unescaped'(_____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('parsing_error'(_____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('error'(_____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('lexing_error'(_____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('write'(_____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('failure'(_____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('clause'(_____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('pos'(_____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('call'(_____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('mod'(_____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('some'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('emop_call'(_____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('file'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('file'(_____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('true'(_____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('none'(_____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('error'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('cmdline'(_____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('name'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('main'(_____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('g_read'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('g_assign'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('number'(_____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('callable'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('initialization'(_____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('catch'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('g_inc'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('var'(_____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('emop_call'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('flush_output'(_____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('print'(_____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('runtime'(_____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('build_dir'(_____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('set_build_dir'(_____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('temp_dir'(_____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('use_cache'(_____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('set_use_cache'(_____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('do_not_build_with_warning'), 'true').
':-'('<module>:emop.compile$has_predicate'('set_do_not_build_with_warning'(_____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('verbose'), 'true').
':-'('<module>:emop.compile$has_predicate'('set_verbose'(_____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('deps'), 'true').
':-'('<module>:emop.compile$has_predicate'('set_deps'(_____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('wam_patch'), 'true').
':-'('<module>:emop.compile$has_predicate'('set_wam_patch'(_____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('size'(_____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('prolog_options'(_____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('log'(_____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('gplc'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('patch_wam'(_____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('default_init_call'(_____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('compile'(_____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('compile'(_____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('build'(_____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('depend'(_____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('link'(_____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('interface'(_____7, _____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('read_interface'(_____10, _____9, _____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('temp_filename'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('build_filename'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('filename_pl'(_____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('filename_link_pl'(_____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('filename_link_wam'(_____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('filename_mpi'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('filename_unpatched_wam'(_____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('filename_wam'(_____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('filename_o'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('try_open'(_____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('lookup_file'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('lookup'(_____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('module_filename'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('lib_dir'(_____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('paths'(_____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('read_interface_expand'(_____10, _____9, _____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('split_fid'(_____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('generate_init_goal'(_____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('assert_call_redirect'(_____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('generate_static'(_____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('generate_call_redirect'(_____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('solve_deps'(_____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('require'(_____7, _____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('consult'(_____7, _____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('consult_dyn'(_____7, _____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('find_fid'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('reconsult'(_____7, _____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('check_user_defined'(_____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('load_ast'(_____7, _____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('import'(_____10, _____9, _____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('clauses_to_prolog'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('generate_object_file'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('symbol'(_____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('initial_scope'(_____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('prolog_to_object'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('prolog_to_patched_wam'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('prolog_to_wam'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.compile$has_predicate'('compile_file'(_____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.compile:$init0'('env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), 'true').
':-'('<module>:emop.compile:$sgn'(__36sgn, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl',0,0,0)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl',212,0,0)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','('true', '<module>:emop.compile:atom_fresh_[1998]'(_atom__fresh___911999_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2000]'(_atom__fresh___912001_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2002]'(_atom__fresh___912003_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2004]'(_atom__fresh___912005_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2006]'(_atom__fresh___912007_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2008]'(_atom__fresh___912009_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2010]'(_atom__fresh___912011_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2012]'(_atom__fresh___912013_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2014]'(_atom__fresh___912015_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2016]'(_atom__fresh___912017_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2018]'(_atom__fresh___912019_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2020]'(_atom__fresh___912021_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2022]'(_atom__fresh___912023_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2024]'(_atom__fresh___912025_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2026]'(_atom__fresh___912027_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2028]'(_atom__fresh___912029_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2030]'(_atom__fresh___912031_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2032]'(_atom__fresh___912033_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2034]'(_atom__fresh___912035_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2036]'(_atom__fresh___912037_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2038]'(_atom__fresh___912039_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2040]'(_atom__fresh___912041_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2042]'(_atom__fresh___912043_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2044]'(_atom__fresh___912045_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2046]'(_atom__fresh___912047_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2048]'(_atom__fresh___912049_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2050]'(_atom__fresh___912051_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2052]'(_atom__fresh___912053_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2054]'(_atom__fresh___912055_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2056]'(_atom__fresh___912057_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2058]'(_atom__fresh___912059_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2060]'(_atom__fresh___912061_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2062]'(_atom__fresh___912063_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2064]'(_atom__fresh___912065_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2066]'(_atom__fresh___912067_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2068]'(_atom__fresh___912069_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2070]'(_atom__fresh___912071_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2072]'(_atom__fresh___912073_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2074]'(_atom__fresh___912075_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2076]'(_atom__fresh___912077_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2078]'(_atom__fresh___912079_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2080]'(_atom__fresh___912081_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2082]'(_atom__fresh___912083_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2084]'(_atom__fresh___912085_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2086]'(_atom__fresh___912087_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2088]'(_atom__fresh___912089_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2090]'(_atom__fresh___912091_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2092]'(_atom__fresh___912093_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2094]'(_atom__fresh___912095_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2096]'(_atom__fresh___912097_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2098]'(_atom__fresh___912099_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2100]'(_atom__fresh___912101_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2102]'(_atom__fresh___912103_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2104]'(_atom__fresh___912105_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2106]'(_atom__fresh___912107_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2108]'(_atom__fresh___912109_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2110]'(_atom__fresh___912111_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2112]'(_atom__fresh___912113_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2114]'(_atom__fresh___912115_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2116]'(_atom__fresh___912117_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2118]'(_atom__fresh___912119_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2120]'(_atom__fresh___912121_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2122]'(_atom__fresh___912123_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2124]'(_atom__fresh___912125_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2126]'(_atom__fresh___912127_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2128]'(_atom__fresh___912129_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2130]'(_atom__fresh___912131_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2132]'(_atom__fresh___912133_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2134]'(_atom__fresh___912135_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2136]'(_atom__fresh___912137_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2138]'(_atom__fresh___912139_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2140]'(_atom__fresh___912141_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2142]'(_atom__fresh___912143_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2144]'(_atom__fresh___912145_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2146]'(_atom__fresh___912147_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2148]'(_atom__fresh___912149_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2150]'(_atom__fresh___912151_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2152]'(_atom__fresh___912153_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2154]'(_atom__fresh___912155_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2156]'(_atom__fresh___912157_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2158]'(_atom__fresh___912159_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2160]'(_atom__fresh___912161_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2162]'(_atom__fresh___912163_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2164]'(_atom__fresh___912165_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2166]'(_atom__fresh___912167_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2168]'(_atom__fresh___912169_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2170]'(_atom__fresh___912171_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2172]'(_atom__fresh___912173_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2174]'(_atom__fresh___912175_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2176]'(_atom__fresh___912177_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2178]'(_atom__fresh___912179_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2180]'(_atom__fresh___912181_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2182]'(_atom__fresh___912183_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2184]'(_atom__fresh___912185_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2186]'(_atom__fresh___912187_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2188]'(_atom__fresh___912189_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2190]'(_atom__fresh___912191_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2192]'(_atom__fresh___912193_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2194]'(_atom__fresh___912195_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2196]'(_atom__fresh___912197_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2198]'(_atom__fresh___912199_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2200]'(_atom__fresh___912201_93, __36Pb, __36Pe)), '<module>:emop.compile:atom_fresh_[2202]'(_atom__fresh___912203_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___912203_93, '.'(_atom__fresh___912201_93, '.'(_atom__fresh___912199_93, '.'(_atom__fresh___912197_93, '.'(_atom__fresh___912195_93, '.'(_atom__fresh___912193_93, '.'(_atom__fresh___912191_93, '.'(_atom__fresh___912189_93, '.'(_atom__fresh___912187_93, '.'(_atom__fresh___912185_93, '.'(_atom__fresh___912183_93, '.'(_atom__fresh___912181_93, '.'(_atom__fresh___912179_93, '.'(_atom__fresh___912177_93, '.'(_atom__fresh___912175_93, '.'(_atom__fresh___912173_93, '.'(_atom__fresh___912171_93, '.'(_atom__fresh___912169_93, '.'(_atom__fresh___912167_93, '.'(_atom__fresh___912165_93, '.'(_atom__fresh___912163_93, '.'(_atom__fresh___912161_93, '.'(_atom__fresh___912159_93, '.'(_atom__fresh___912157_93, '.'(_atom__fresh___912155_93, '.'(_atom__fresh___912153_93, '.'(_atom__fresh___912151_93, '.'(_atom__fresh___912149_93, '.'(_atom__fresh___912147_93, '.'(_atom__fresh___912145_93, '.'(_atom__fresh___912143_93, '.'(_atom__fresh___912141_93, '.'(_atom__fresh___912139_93, '.'(_atom__fresh___912137_93, '.'(_atom__fresh___912135_93, '.'(_atom__fresh___912133_93, '.'(_atom__fresh___912131_93, '.'(_atom__fresh___912129_93, '.'(_atom__fresh___912127_93, '.'(_atom__fresh___912125_93, '.'(_atom__fresh___912123_93, '.'(_atom__fresh___912121_93, '.'(_atom__fresh___912119_93, '.'(_atom__fresh___912117_93, '.'(_atom__fresh___912115_93, '.'(_atom__fresh___912113_93, '.'(_atom__fresh___912111_93, '.'(_atom__fresh___912109_93, '.'(_atom__fresh___912107_93, '.'(_atom__fresh___912105_93, '.'(_atom__fresh___912103_93, '.'(_atom__fresh___912101_93, '.'(_atom__fresh___912099_93, '.'(_atom__fresh___912097_93, '.'(_atom__fresh___912095_93, '.'(_atom__fresh___912093_93, '.'(_atom__fresh___912091_93, '.'(_atom__fresh___912089_93, '.'(_atom__fresh___912087_93, '.'(_atom__fresh___912085_93, '.'(_atom__fresh___912083_93, '.'(_atom__fresh___912081_93, '.'(_atom__fresh___912079_93, '.'(_atom__fresh___912077_93, '.'(_atom__fresh___912075_93, '.'(_atom__fresh___912073_93, '.'(_atom__fresh___912071_93, '.'(_atom__fresh___912069_93, '.'(_atom__fresh___912067_93, '.'(_atom__fresh___912065_93, '.'(_atom__fresh___912063_93, '.'(_atom__fresh___912061_93, '.'(_atom__fresh___912059_93, '.'(_atom__fresh___912057_93, '.'(_atom__fresh___912055_93, '.'(_atom__fresh___912053_93, '.'(_atom__fresh___912051_93, '.'(_atom__fresh___912049_93, '.'(_atom__fresh___912047_93, '.'(_atom__fresh___912045_93, '.'(_atom__fresh___912043_93, '.'(_atom__fresh___912041_93, '.'(_atom__fresh___912039_93, '.'(_atom__fresh___912037_93, '.'(_atom__fresh___912035_93, '.'(_atom__fresh___912033_93, '.'(_atom__fresh___912031_93, '.'(_atom__fresh___912029_93, '.'(_atom__fresh___912027_93, '.'(_atom__fresh___912025_93, '.'(_atom__fresh___912023_93, '.'(_atom__fresh___912021_93, '.'(_atom__fresh___912019_93, '.'(_atom__fresh___912017_93, '.'(_atom__fresh___912015_93, '.'(_atom__fresh___912013_93, '.'(_atom__fresh___912011_93, '.'(_atom__fresh___912009_93, '.'(_atom__fresh___912007_93, '.'(_atom__fresh___912005_93, '.'(_atom__fresh___912003_93, '.'(_atom__fresh___912001_93, '.'(_atom__fresh___911999_93, '[]'))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))).
':-'('<module>:emop.compile:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:assert_call_redirect'(_ModuleList, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), ';'(','(','('g_read'('data.list', '<module>:data.list'(___575)), '<module>:data.list:member$direct'(_LocalId, _ModuleList, ___575)), ','(','('='(_ModTerm, ___579), ','('g_read'('data.term', '<module>:data.term'(___580)), '<module>:data.term:make$direct'(_LocalId, '.'(_Env, '[]'), ___579, ___580))), ','(','('='(_ModCall, ___587), ','('g_read'('data.term', '<module>:data.term'(___588)), '<module>:data.term:make$direct'(_LocalId, '.'(_F, '.'(_Env, '.'(_Pos, '.'(_CutLevel, '[]')))), ___587, ___588))), ','('asserta'(':-'('emop_dyn_call_to'(_ModTerm, _F, _Pos, _CutLevel), ','('!', _ModCall))), 'fail')))), 'true')).
':-'('<module>:emop.compile:assert_call_redirect$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:assert_call_redirect'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:atom_fresh_[1998]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(compile_file, 5, predicate, '[]', __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2000]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(prolog_to_wam, 4, predicate, '[]', __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2002]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(prolog_to_patched_wam, 4, predicate, suspended([var('Fid'),var('FilenamePl'),var('Mode'),var('FilenameWam')],[call(scope,filename_unpatched_wam,[var('Fid'),var('FilenameUnpatchedWam')]),call(scope,gplc,[var('FilenamePl'),var('Mode'),var('FilenameUnpatchedWam')]),call(scope,filename_wam,[var('Fid'),var('FilenameWam')]),call(scope,patch_wam,[var('FilenameUnpatchedWam'),var('FilenameWam')])]), __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2004]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(prolog_to_object, 4, predicate, '[]', __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2006]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(initial_scope, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2008]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(symbol, 6, constructor, none, __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2010]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(generate_object_file, 4, predicate, suspended([var('Clauses'),var('BaseFilename'),var('Fid'),var('ObjectFilename')],[call(scope,clauses_to_prolog,[var('Clauses'),var('Fid'),var('FilenamePl')]),call(scope,prolog_to_object,[var('BaseFilename'),var('Fid'),var('FilenamePl'),var('ObjectFilename')])]), __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2012]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(clauses_to_prolog, 3, predicate, '[]', __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2014]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(import, 10, predicate, '[]', __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2016]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(load_ast, 7, predicate, '[]', __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2018]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(check_user_defined, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2020]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(reconsult, 7, predicate, '[]', __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2022]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(find_fid, 3, predicate, '[]', __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2024]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(consult_dyn, 7, predicate, '[]', __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2026]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(consult, 7, predicate, '[]', __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2028]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(require, 7, predicate, '[]', __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2030]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(solve_deps, 6, predicate, '[]', __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2032]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(generate_call_redirect, 2, predicate, suspended([var('ModuleList'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2034]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(generate_static, 2, predicate, suspended([var('ModuleList'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2036]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(assert_call_redirect, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2038]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(generate_init_goal, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2040]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(split_fid, 5, predicate, '[]', __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2042]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(read_interface_expand, 10, predicate, '[]', __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2044]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(paths, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2046]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(lib_dir, 1, predicate, suspended([none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2048]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(module_filename, 3, predicate, '[]', __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2050]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(lookup, 5, predicate, '[]', __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2052]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(lookup_file, 3, predicate, '[]', __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2054]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(try_open, 2, predicate, suspended([var('Filename'),var('S')],[call(scope,catch,[none,none,none])]), __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2056]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(filename_o, 3, predicate, suspended([var('BaseFilename'),var('Fid'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2058]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(filename_wam, 2, predicate, suspended([var('Fid'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2060]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(filename_unpatched_wam, 2, predicate, suspended([var('Fid'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2062]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(filename_mpi, 3, predicate, suspended([var('BaseFilename'),var('Fid'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2064]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(filename_link_wam, 2, predicate, suspended([var('Fid'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2066]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(filename_link_pl, 2, predicate, suspended([var('Fid'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2068]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(filename_pl, 2, predicate, suspended([var('Fid'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2070]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(build_filename, 4, predicate, suspended([var('BaseFilename'),var('Fid'),var('Suffix'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2072]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(temp_filename, 3, predicate, suspended([var('Fid'),var('Suffix'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2074]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(read_interface, 10, predicate, '[]', __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2076]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(interface, 7, constructor, none, __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2078]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(link, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2080]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(depend, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2082]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(build, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2084]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(compile, 5, predicate, '[]', __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2086]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(compile, 2, predicate, suspended([var('Modules'),var('Output')],[call(scope,compile,[var('Modules'),var('_'),var('_'),none,var('Output')])]), __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2088]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(default_init_call, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2090]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(patch_wam, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2092]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(gplc, 3, predicate, '[]', __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2094]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(log, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2096]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(prolog_options, 1, predicate, suspended([var('PrologOptionsRef')],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2098]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(size, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2100]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(set_wam_patch, 1, predicate, suspended([var('WamPatch')],[call(var('WamPatchRef'),set,[var('WamPatch')])]), __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2102]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(wam_patch, 0, predicate, suspended([],[call(var('WamPatchRef'),get,[none])]), __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2104]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(set_deps, 1, predicate, suspended([var('Deps')],[call(var('DepsRef'),set,[var('Deps')])]), __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2106]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(deps, 0, predicate, suspended([],[call(var('DepsRef'),get,[none])]), __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2108]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(set_verbose, 1, predicate, suspended([var('Verbose')],[call(var('VerboseRef'),set,[var('Verbose')])]), __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2110]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(verbose, 0, predicate, suspended([],[call(var('VerboseRef'),get,[none])]), __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2112]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(set_do_not_build_with_warning, 1, predicate, suspended([var('DoNotBuildWithWarning')],[call(var('DoNotBuildWithWarningRef'),set,[var('DoNotBuildWithWarning')])]), __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2114]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do_not_build_with_warning, 0, predicate, suspended([],[call(var('DoNotBuildWithWarningRef'),get,[none])]), __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2116]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(set_use_cache, 1, predicate, suspended([var('UseCache')],[call(var('UseCacheRef'),set,[var('UseCache')])]), __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2118]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(use_cache, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2120]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(temp_dir, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2122]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(set_build_dir, 1, predicate, suspended([var('BuildDirOption')],[call(var('BuildDirOptionRef'),set,[var('BuildDirOption')])]), __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2124]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(build_dir, 1, predicate, suspended([none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2126]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(runtime, 1, predicate, suspended([var('RuntimeRef')],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2128]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(print, 2, constructor, none, __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2130]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(flush_output, 1, constructor, none, __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2132]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(emop_call, 4, constructor, none, __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2134]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(var, 2, constructor, none, __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2136]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(g_inc, 4, constructor, none, __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2138]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(catch, 4, constructor, none, __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2140]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(initialization, 1, constructor, none, __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2142]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(callable, 3, constructor, none, __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2144]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(number, 2, constructor, none, __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2146]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(g_assign, 3, constructor, none, __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2148]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(g_read, 3, constructor, none, __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2150]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(main, 1, constructor, none, __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2152]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(name, 4, constructor, none, __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2154]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(cmdline, 1, constructor, none, __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2156]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(error, 3, constructor, none, __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2158]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(none, 1, constructor, none, __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2160]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(true, 1, constructor, none, __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2162]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(file, 1, constructor, none, __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2164]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(file, 3, constructor, none, __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2166]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(emop_call, 1, constructor, none, __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2168]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(some, 3, constructor, none, __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2170]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(mod, 1, constructor, none, __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2172]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(call, 1, constructor, none, __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2174]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(pos, 1, constructor, none, __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2176]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(clause, 5, constructor, none, __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2178]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(failure, 1, constructor, none, __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2180]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(write, 2, constructor, none, __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2182]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(lexing_error, 1, constructor, none, __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2184]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(error, 2, constructor, none, __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2186]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(parsing_error, 1, constructor, none, __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2188]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(unescaped, 1, constructor, none, __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2190]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(operator, 1, constructor, none, __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2192]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(empty, 3, constructor, none, __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2194]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(callable, 6, constructor, none, __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2196]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(file, 2, constructor, none, __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2198]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(expand_error, 1, constructor, none, __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2200]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(dep, 3, constructor, none, __36pos))).
':-'('<module>:emop.compile:atom_fresh_[2202]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(directive, 2, constructor, none, __36pos))).
':-'('<module>:emop.compile:build'(_Modules, _Output, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), ','(','(','('g_read'('emop.compile', '<module>:emop.compile'(___252)), '<module>:emop.compile:default_init_call$direct'(___251, ___252)), ','('g_read'('emop.compile', '<module>:emop.compile'(___253)), '<module>:emop.compile:compile$direct'(_Modules, _ObjectFileList, _Output, ___251, ___TempOutput, ___253))), ','(';'('->'(','('emop_call'(_HasWarningRef, 'get'('true'), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 276, from character 23 to 26'), ','('g_read'('emop.compile', '<module>:emop.compile'(___255)), '<module>:emop.compile:do_not_build_with_warning$direct'(___255))), 'throw'('error'('Building is disabled in presence of warnings.  Use option --ignore-warnings to force building.', 'cmdline'))), 'true'), ','(','(','('g_read'('emop.compile', '<module>:emop.compile'(___260)), '<module>:emop.compile:runtime$direct'(___259, ___260)), 'emop_call'(___259, 'get'(___261), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 283, from character 28 to 31')), ','('g_read'('emop.compile', '<module>:emop.compile'(___263)), '<module>:emop.compile:link$direct'(_Output, '.'(___261, _ObjectFileList), ___263)))))).
':-'('<module>:emop.compile:build$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:build'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:build_dir'(_BuildDir, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), ','(','('='(___167, ___165), 'emop_call'(_BuildDirOptionRef, 'get'(___167), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 6, from character 33 to 36')), '->'(','('='(___166, _BuildDir), '='(___165, 'some'(___166))), 'true'))).
':-'('<module>:emop.compile:build_dir$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:build_dir'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:build_filename'(_BaseFilename, _Fid, _Suffix, ___385, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), ';'('->'(','('='(_BuildDir, ___386), ','('g_read'('emop.compile', '<module>:emop.compile'(___387)), '<module>:emop.compile:build_dir$direct'(___386, ___387))), ','('='(___385, ___392), ','(','('g_read'('data.atom', '<module>:data.atom'(___391)), '<module>:data.atom:concat$direct'(_Fid, _Suffix, ___390, ___391)), ','('g_read'('data.path', '<module>:data.path'(___393)), '<module>:data.path:concat$direct'(_BuildDir, ___390, ___392, ___393))))), ','('='(___385, ___395), ','('g_read'('data.atom', '<module>:data.atom'(___396)), '<module>:data.atom:concat$direct'(_BaseFilename, _Suffix, ___395, ___396))))).
':-'('<module>:emop.compile:build_filename$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:build_filename'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:call'(___102, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), '=..'(___102, '.'('call', '[]'))).
':-'('<module>:emop.compile:call$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:call'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:callable'(___131, ___132, ___133, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), '=..'(___133, '.'('callable', '.'(___131, '.'(___132, '[]'))))).
':-'('<module>:emop.compile:callable'(___78, ___79, ___80, ___81, ___82, ___83, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), '=..'(___83, '.'('callable', '.'(___78, '.'(___79, '.'(___80, '.'(___81, '.'(___82, '[]')))))))).
':-'('<module>:emop.compile:callable$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:callable'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:callable$direct'(_____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:callable'(_____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:catch'(___135, ___136, ___137, ___138, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), '=..'(___138, '.'('catch', '.'(___135, '.'(___136, '.'(___137, '[]')))))).
':-'('<module>:emop.compile:catch$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:catch'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:check_user_defined'(_Fid, _FidPos, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), ';'('->'(','('emop_call'(_ConsultedRef, 'get'(___736), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 763, from character 55 to 58'), ','('g_read'('data.list', '<module>:data.list'(___737)), '<module>:data.list:member$direct'('c'(_Fid, _, _), ___736, ___737))), ','(','('g_read'('data.atom', '<module>:data.atom'(___743)), '<module>:data.atom:format$direct'('A module ~a has already been loaded.', '.'(_Fid, '[]'), ___742, ___743)), 'throw'('error'(___742, _FidPos)))), ';'('->'('emop_static'(_Fid), ','(','('g_read'('data.atom', '<module>:data.atom'(___751)), '<module>:data.atom:format$direct'('A module ~a has been statically compiled.', '.'(_Fid, '[]'), ___750, ___751)), 'throw'('error'(___750, _FidPos)))), 'true'))).
':-'('<module>:emop.compile:check_user_defined$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:check_user_defined'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:clause'(___96, ___97, ___98, ___99, ___100, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), '=..'(___100, '.'('clause', '.'(___96, '.'(___97, '.'(___98, '.'(___99, '[]'))))))).
':-'('<module>:emop.compile:clause$direct'(_____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:clause'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:clauses_to_prolog'(_Clauses, _Fid, _FilenamePl, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), ','(','('='(_SortedClauses, ___891), ','(','('true', ';'('->'('var'(___885), ','('g_inc'('$module_count', ___886), '='(___885, '$module'(___886, '.'('<module>:emop.compile@16'('env'(___885)), '[]'), '.'(___885, '[]'))))), ','('='(___885, '$module'(___886, ___887, _)), ','('='('.'(___888, ___889), ___887), ','('setarg'(1, ___887, '<module>:emop.compile@16'('env'(___885))), 'setarg'(2, ___887, '.'(___888, ___889))))))), ','('g_read'('data.list', '<module>:data.list'(___892)), '<module>:data.list:quick_sort$direct'(_Clauses, ___885, ___891, ___892)))), ','(','('='(_BuiltClauses, ___900), ','(','('true', ';'('->'('var'(___894), ','('g_inc'('$module_count', ___895), '='(___894, '$module'(___895, '.'('<module>:emop.compile@17'('env'(___894)), '[]'), '.'(___894, '[]'))))), ','('='(___894, '$module'(___895, ___896, _)), ','('='('.'(___897, ___898), ___896), ','('setarg'(1, ___896, '<module>:emop.compile@17'('env'(___894))), 'setarg'(2, ___896, '.'(___897, ___898))))))), ','('g_read'('data.list', '<module>:data.list'(___901)), '<module>:data.list:iter$direct'(_SortedClauses, ___894, ___900, ___901)))), ','(','('g_read'('emop.compile', '<module>:emop.compile'(___902)), '<module>:emop.compile:filename_pl$direct'(_Fid, _FilenamePl, ___902)), ','(','('g_read'('io.file', '<module>:io.file'(___904)), '<module>:io.file:open_write$direct'(_FilenamePl, _FilePl, ___904)), ','(';'('->'(','('g_read'('emop.writer', '<module>:emop.writer'(___906)), '<module>:emop.writer:write_clauses$direct'(_FilePl, _BuiltClauses, ___906)), 'true'), 'throw'('write'('failure'))), 'emop_call'(_FilePl, 'close', 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 911, from character 13 to 18'))))))).
':-'('<module>:emop.compile:clauses_to_prolog$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:clauses_to_prolog'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:cmdline'(___117, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), '=..'(___117, '.'('cmdline', '[]'))).
':-'('<module>:emop.compile:cmdline$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:cmdline'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:compile'(_Modules, _Output, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), ','(','('g_read'('emop.compile', '<module>:emop.compile'(___244)), '<module>:emop.compile:default_init_call$direct'(___243, ___244)), ','('g_read'('emop.compile', '<module>:emop.compile'(___245)), '<module>:emop.compile:compile$direct'(_Modules, _, _, ___243, _Output, ___245)))).
':-'('<module>:emop.compile:compile'(_Modules, _ObjectFileList, _BuildOutput, _MakeInitCall, _Output, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), ','(';'('->'('='(_Modules, '[]'), 'throw'('error'('No module to compile', 'cmdline'))), 'true'), ','('g_read'('emop.compile', '<module>:emop.compile'(___250)), '<module>:emop.compile:compile_file$direct'(_Modules, _Output, _BuildOutput, _MakeInitCall, _ObjectFileList, ___250)))).
':-'('<module>:emop.compile:compile$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:compile'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:compile$direct'(_____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:compile'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:compile_file'(_Modules, _Output, _BuildOutput, _MakeInitCall, _ObjectFileList, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), ','(','(','('g_read'('data.ref.non_backtrackable', '<module>:data.ref.non_backtrackable'(___988)), '<module>:data.ref.non_backtrackable:new$direct'('none', _MainModRef, ___988)), ','(','('g_read'('data.ref.non_backtrackable', '<module>:data.ref.non_backtrackable'(___990)), '<module>:data.ref.non_backtrackable:new$direct'('[]', _IncludedRef, ___990)), ','(','('g_read'('data.ref.non_backtrackable', '<module>:data.ref.non_backtrackable'(___992)), '<module>:data.ref.non_backtrackable:new$direct'('[]', _QueuedRef, ___992)), ','(','('g_read'('data.ref.non_backtrackable', '<module>:data.ref.non_backtrackable'(___994)), '<module>:data.ref.non_backtrackable:new$direct'('[]', _InitRef, ___994)), ','(','('g_read'('data.ref.non_backtrackable', '<module>:data.ref.non_backtrackable'(___996)), '<module>:data.ref.non_backtrackable:new$direct'('[]', _ModuleListRef, ___996)), ','(','('g_read'('data.ref.non_backtrackable', '<module>:data.ref.non_backtrackable'(___998)), '<module>:data.ref.non_backtrackable:new$direct'('[]', _FidListRef, ___998)), ','('g_read'('data.ref.non_backtrackable', '<module>:data.ref.non_backtrackable'(___1000)), '<module>:data.ref.non_backtrackable:new$direct'('[]', _ObjectFileListRef, ___1000)))))))), ','(','('true', ','(';'('->'('var'(_Compiler), ','('g_inc'('$module_count', ___1001), '='(_Compiler, '$module'(___1001, '.'('<module>:emop.compile@18'('env'(_Compiler, _Compiler, _MainModRef, _IncludedRef, _QueuedRef, _InitRef, _ModuleListRef, _FidListRef, _PackageNodes, _RootPackagePath, _MakeInitCall, _ObjectFileListRef, _HasWarningRef)), '[]'), '.'(_Compiler, '[]'))))), ','('='(_Compiler, '$module'(___1001, ___1002, _)), ','('='('.'(___1003, ___1004), ___1002), ','('setarg'(1, ___1002, '<module>:emop.compile@18'('env'(_Compiler, _Compiler, _MainModRef, _IncludedRef, _QueuedRef, _InitRef, _ModuleListRef, _FidListRef, _PackageNodes, _RootPackagePath, _MakeInitCall, _ObjectFileListRef, _HasWarningRef))), 'setarg'(2, ___1002, '.'(___1003, ___1004)))))), '<module>:emop.compile@18:$init1'('env'(___1005, _Compiler, _MainModRef, _IncludedRef, _QueuedRef, _InitRef, _ModuleListRef, _FidListRef, _PackageNodes, _RootPackagePath, _MakeInitCall, _ObjectFileListRef, _HasWarningRef), __36CutLevel))), ','('emop_call'(_Compiler, 'queue'('name'('emop.syntax', '[]', ''), 'none'), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1280, from character 15 to 20'), ','('emop_call'(_Compiler, 'queue'('name'('io.stream', '[]', ''), 'none'), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1281, from character 15 to 20'), ','('emop_call'(_Compiler, 'queue'('name'('sys.process', '[]', ''), 'none'), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1282, from character 15 to 20'), ','(','(','('true', ';'('->'('var'(___1022), ','('g_inc'('$module_count', ___1023), '='(___1022, '$module'(___1023, '.'('<module>:emop.compile@19'('env'(___1022, _Compiler)), '[]'), '.'(___1022, '[]'))))), ','('='(___1022, '$module'(___1023, ___1024, _)), ','('='('.'(___1025, ___1026), ___1024), ','('setarg'(1, ___1024, '<module>:emop.compile@19'('env'(___1022, _Compiler))), 'setarg'(2, ___1024, '.'(___1025, ___1026))))))), ','('g_read'('data.list', '<module>:data.list'(___1028)), '<module>:data.list:reverse_iter$direct'(_Modules, ___1022, ___1028))), ','('emop_call'(_Compiler, 'compile_all', 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1287, from character 15 to 26'), ','(','('='('some'(_MainModId, _BaseFilename), ___1030), 'emop_call'(_MainModRef, 'get'(___1030), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1288, from character 49 to 52')), ','(';'('->'(','('g_read'('data.var', '<module>:data.var'(___1032)), '<module>:data.var:check$direct'(_Output, ___1032)), ','('='(_Output, ___1033), ','('g_read'('emop.compile', '<module>:emop.compile'(___1034)), '<module>:emop.compile:filename_link_pl$direct'(_MainModId, ___1033, ___1034)))), 'true'), ','(';'('->'(','('g_read'('data.var', '<module>:data.var'(___1036)), '<module>:data.var:check$direct'(_BuildOutput, ___1036)), '='(_BuildOutput, _BaseFilename)), 'true'), ','('emop_call'(_Compiler, 'generate_link'(_MainModId, _Output), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1303, from character 15 to 28'), ','('='(_ObjectFileList, ___1037), 'emop_call'(_ObjectFileListRef, 'get'(___1037), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1304, from character 41 to 44')))))))))))))).
':-'('<module>:emop.compile:compile_file$direct'(_____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:compile_file'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:consult'(_Mod, _Checked, _Pos, _Update, _PackageNodes, _RootPackagePath, _Goals, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), ';'('->'('emop_static'(_Mod), 'throw'('error'('static_module'(_Mod), _Pos))), ','('g_read'('emop.compile', '<module>:emop.compile'(___628)), '<module>:emop.compile:consult_dyn$direct'(_Mod, _Checked, _Pos, _Update, _PackageNodes, _RootPackagePath, _Goals, ___628)))).
':-'('<module>:emop.compile:consult$direct'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:consult'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:consult_dyn'(_Mod, _Checked, _Pos, _Update, _PackageNodes, _RootPackagePath, _Goals, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), ';'('->'(','('g_read'('data.list', '<module>:data.list'(___630)), '<module>:data.list:member$direct'(_Mod, _Checked, ___630)), '='(_Goals, '[]')), ','(','('='(_Consulted, ___632), 'emop_call'(_ConsultedRef, 'get'(___632), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 646, from character 34 to 37')), ','(';'('->'(','('g_read'('data.list', '<module>:data.list'(___635)), '<module>:data.list:select$direct'('c'(_Mod, _ConsultDate, _Deps), _Consulted, _Consulted0, ___635)), '='(_HasBeenConsulted, 'yes')), ','('='(_HasBeenConsulted, 'no'), '='(_Consulted0, _Consulted))), ';'('->'(','('='(_HasBeenConsulted, 'yes'), '='(_ConsultDate, 'top')), '='(_Goals, '[]')), ','(','('='(_SMpl, ___642), ','('g_read'('emop.compile', '<module>:emop.compile'(___643)), '<module>:emop.compile:lookup$direct'('name'(_Mod, _PackageNodes, _RootPackagePath), _Pos, ___BaseFilename, _FilenameMpl, ___642, ___643))), ','(','('='(_MplChange, ___645), ','('g_read'('sys.file', '<module>:sys.file'(___646)), '<module>:sys.file:last_modification$direct'(_FilenameMpl, ___645, ___646))), ','(';'('->'(';'('->'('='(_HasBeenConsulted, 'yes'), ';'('->'(','('g_read'('data.term', '<module>:data.term'(___649)), '<module>:data.term:<$direct'(_ConsultDate, _MplChange, ___649)), ';'('->'('emop_call'(_Update, 'update'(_FilenameMpl), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 674, from character 31 to 37'), 'fail'), 'emop_call'(_ConsultedRef, 'set'('.'('c'(_Mod, _MplChange, _Deps), _Consulted0)), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 678, from character 37 to 40'))), 'fail')), 'fail'), ','('='(_Goals, _Tail), 'emop_call'(_SMpl, 'close', 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 688, from character 20 to 25'))), ','('emop_call'(_ConsultedRef, 'set'('.'('c'(_Mod, _MplChange, _Deps), _Consulted0)), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 690, from character 28 to 31'), ','(','('g_read'('emop.compile', '<module>:emop.compile'(___654)), '<module>:emop.compile:reconsult$direct'(_Mod, _FilenameMpl, _SMpl, _PackageNodes, _RootPackagePath, _Deps, _InitPred, ___654)), '='(_Goals, '.'(_InitPred, _Tail))))), ','('g_read'('emop.compile', '<module>:emop.compile'(___657)), '<module>:emop.compile:solve_deps$direct'(_Deps, '.'(_Mod, _Checked), _Update, _PackageNodes, _RootPackagePath, _Tail, ___657)))))))))).
':-'('<module>:emop.compile:consult_dyn$direct'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:consult_dyn'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:default_init_call'(___237, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), ','('true', ';'('->'('var'(___237), ','('g_inc'('$module_count', ___238), '='(___237, '$module'(___238, '.'('<module>:emop.compile@2'('env'(___237, _InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef)), '[]'), '.'(___237, '[]'))))), ','('='(___237, '$module'(___238, ___239, _)), ','('='('.'(___240, ___241), ___239), ','('setarg'(1, ___239, '<module>:emop.compile@2'('env'(___237, _InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef))), 'setarg'(2, ___239, '.'(___240, ___241)))))))).
':-'('<module>:emop.compile:default_init_call$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:default_init_call'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:dep'(___72, ___73, ___74, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), '=..'(___74, '.'('dep', '.'(___72, '.'(___73, '[]'))))).
':-'('<module>:emop.compile:dep$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:dep'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:depend'(_Modules, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), ','(','('true', ';'('->'('var'(_MakeInitCall), ','('g_inc'('$module_count', ___264), '='(_MakeInitCall, '$module'(___264, '.'('<module>:emop.compile@3'('env'(_MakeInitCall, _InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef, _MakeInitCall, _Modules, _ObjectFileList, ___Output, ___TempOutput)), '[]'), '.'(_MakeInitCall, '[]'))))), ','('='(_MakeInitCall, '$module'(___264, ___265, _)), ','('='('.'(___266, ___267), ___265), ','('setarg'(1, ___265, '<module>:emop.compile@3'('env'(_MakeInitCall, _InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef, _MakeInitCall, _Modules, _ObjectFileList, ___Output, ___TempOutput))), 'setarg'(2, ___265, '.'(___266, ___267))))))), ','(','('g_read'('emop.compile', '<module>:emop.compile'(___269)), '<module>:emop.compile:compile$direct'(_Modules, _ObjectFileList, ___Output, _MakeInitCall, ___TempOutput, ___269)), ','(','(','(','('g_read'('emop.compile', '<module>:emop.compile'(___272)), '<module>:emop.compile:runtime$direct'(___271, ___272)), 'emop_call'(___271, 'get'(___273), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 290, from character 30 to 33')), ','('true', ';'('->'('var'(___275), ','('g_inc'('$module_count', ___276), '='(___275, '$module'(___276, '.'('<module>:emop.compile@4'('env'(___275, _InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef, _MakeInitCall, _Modules, _ObjectFileList, ___Output, ___TempOutput)), '[]'), '.'(___275, '[]'))))), ','('='(___275, '$module'(___276, ___277, _)), ','('='('.'(___278, ___279), ___277), ','('setarg'(1, ___277, '<module>:emop.compile@4'('env'(___275, _InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef, _MakeInitCall, _Modules, _ObjectFileList, ___Output, ___TempOutput))), 'setarg'(2, ___277, '.'(___278, ___279)))))))), ','('g_read'('data.list', '<module>:data.list'(___281)), '<module>:data.list:iter$direct'('.'(___273, _ObjectFileList), ___275, ___281)))))).
':-'('<module>:emop.compile:depend$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:depend'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:deps'('env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), 'emop_call'(_DepsRef, 'get'('true'), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 52, from character 14 to 17')).
':-'('<module>:emop.compile:deps$direct'(__36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:deps'(__36env, __36CutLevel))).
':-'('<module>:emop.compile:directive'(___70, ___71, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), '=..'(___71, '.'('directive', '.'(___70, '[]')))).
':-'('<module>:emop.compile:directive$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:directive'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:do_not_build_with_warning'('env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), 'emop_call'(_DoNotBuildWithWarningRef, 'get'('true'), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 40, from character 31 to 34')).
':-'('<module>:emop.compile:do_not_build_with_warning$direct'(__36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:do_not_build_with_warning'(__36env, __36CutLevel))).
':-'('<module>:emop.compile:emop_call'(___107, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), '=..'(___107, '.'('emop_call', '[]'))).
':-'('<module>:emop.compile:emop_call'(___145, ___146, ___147, ___148, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), '=..'(___148, '.'('emop_call', '.'(___145, '.'(___146, '.'(___147, '[]')))))).
':-'('<module>:emop.compile:emop_call$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:emop_call'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:emop_call$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:emop_call'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:empty'(___84, ___85, ___86, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), '=..'(___86, '.'('empty', '.'(___84, '.'(___85, '[]'))))).
':-'('<module>:emop.compile:empty$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:empty'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:error'(___90, ___91, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), '=..'(___91, '.'('error', '.'(___90, '[]')))).
':-'('<module>:emop.compile:error'(___114, ___115, ___116, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), '=..'(___116, '.'('error', '.'(___114, '.'(___115, '[]'))))).
':-'('<module>:emop.compile:error$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:error'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:error$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:error'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:expand_error'(___75, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), '=..'(___75, '.'('expand_error', '[]'))).
':-'('<module>:emop.compile:expand_error$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:expand_error'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:failure'(___95, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), '=..'(___95, '.'('failure', '[]'))).
':-'('<module>:emop.compile:failure$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:failure'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:file'(___111, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), '=..'(___111, '.'('file', '[]'))).
':-'('<module>:emop.compile:file'(___76, ___77, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), '=..'(___77, '.'('file', '.'(___76, '[]')))).
':-'('<module>:emop.compile:file'(___108, ___109, ___110, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), '=..'(___110, '.'('file', '.'(___108, '.'(___109, '[]'))))).
':-'('<module>:emop.compile:file$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:file'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:file$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:file'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:file$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:file'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:filename_link_pl'(_Fid, ___401, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), ','('g_read'('emop.compile', '<module>:emop.compile'(___402)), '<module>:emop.compile:temp_filename$direct'(_Fid, '.link.pl', ___401, ___402))).
':-'('<module>:emop.compile:filename_link_pl$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:filename_link_pl'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:filename_link_wam'(_Fid, ___404, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), ','('g_read'('emop.compile', '<module>:emop.compile'(___405)), '<module>:emop.compile:temp_filename$direct'(_Fid, '.link.wam', ___404, ___405))).
':-'('<module>:emop.compile:filename_link_wam$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:filename_link_wam'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:filename_mpi'(_BaseFilename, _Fid, ___407, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), ','('g_read'('emop.compile', '<module>:emop.compile'(___408)), '<module>:emop.compile:build_filename$direct'(_BaseFilename, _Fid, '.mpi', ___407, ___408))).
':-'('<module>:emop.compile:filename_mpi$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:filename_mpi'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:filename_o'(_BaseFilename, _Fid, ___416, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), ','('g_read'('emop.compile', '<module>:emop.compile'(___417)), '<module>:emop.compile:build_filename$direct'(_BaseFilename, _Fid, '.o', ___416, ___417))).
':-'('<module>:emop.compile:filename_o$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:filename_o'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:filename_pl'(_Fid, ___398, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), ','('g_read'('emop.compile', '<module>:emop.compile'(___399)), '<module>:emop.compile:temp_filename$direct'(_Fid, '.pl', ___398, ___399))).
':-'('<module>:emop.compile:filename_pl$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:filename_pl'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:filename_unpatched_wam'(_Fid, ___410, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), ','('g_read'('emop.compile', '<module>:emop.compile'(___411)), '<module>:emop.compile:temp_filename$direct'(_Fid, '.unpatched.wam', ___410, ___411))).
':-'('<module>:emop.compile:filename_unpatched_wam$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:filename_unpatched_wam'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:filename_wam'(_Fid, ___413, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), ','('g_read'('emop.compile', '<module>:emop.compile'(___414)), '<module>:emop.compile:temp_filename$direct'(_Fid, '.wam', ___413, ___414))).
':-'('<module>:emop.compile:filename_wam$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:filename_wam'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:find_fid'('callable'(_F, 'operator', '.'(_A, '.'(_B, '[]')), _, _), _Fid, _FidPos, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), ','(';'('='(_F, ','), ';'('='(_F, ';'), '='(_F, '->'))), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ';'('->'(','('g_read'('emop.compile', '<module>:emop.compile'(___666)), '<module>:emop.compile:find_fid$direct'(_A, _Fid, _FidPos, ___666)), 'true'), ','('g_read'('emop.compile', '<module>:emop.compile'(___667)), '<module>:emop.compile:find_fid$direct'(_B, _Fid, _FidPos, ___667)))))).
':-'('<module>:emop.compile:find_fid'('()'(_Sub, _, _), _Fid, _FidPos, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), ','('g_read'('emop.compile', '<module>:emop.compile'(___669)), '<module>:emop.compile:find_fid$direct'(_Sub, _Fid, _FidPos, ___669))).
':-'('<module>:emop.compile:find_fid'('module'('atom'(_Atom, _Escaped, _Pb, _Pe), ___Env, ___Body, ___Sgn, ___Clauses, ___Pb, ___Pe), _Fid, _FidPos, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), ';'('->'(','('g_read'('emop.parser', '<module>:emop.parser'(___674)), '<module>:emop.parser:is_variable$direct'(_Atom, _Escaped, 'none', ___674)), 'fail'), ','('='(_Fid, _Atom), '='(_FidPos, 'file'(_Pb, _Pe))))).
':-'('<module>:emop.compile:find_fid$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:find_fid'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:flush_output'(___149, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), '=..'(___149, '.'('flush_output', '[]'))).
':-'('<module>:emop.compile:flush_output$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:flush_output'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:g_assign'(___126, ___127, ___128, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), '=..'(___128, '.'('g_assign', '.'(___126, '.'(___127, '[]'))))).
':-'('<module>:emop.compile:g_assign$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:g_assign'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:g_inc'(___139, ___140, ___141, ___142, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), '=..'(___142, '.'('g_inc', '.'(___139, '.'(___140, '.'(___141, '[]')))))).
':-'('<module>:emop.compile:g_inc$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:g_inc'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:g_read'(___123, ___124, ___125, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), '=..'(___125, '.'('g_read', '.'(___123, '.'(___124, '[]'))))).
':-'('<module>:emop.compile:g_read$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:g_read'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:generate_call_redirect'(_ModuleList, ___610, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), ','(','('true', ';'('->'('var'(___604), ','('g_inc'('$module_count', ___605), '='(___604, '$module'(___605, '.'('<module>:emop.compile@9'('env'(___604, _InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef, _ModuleList)), '[]'), '.'(___604, '[]'))))), ','('='(___604, '$module'(___605, ___606, _)), ','('='('.'(___607, ___608), ___606), ','('setarg'(1, ___606, '<module>:emop.compile@9'('env'(___604, _InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef, _ModuleList))), 'setarg'(2, ___606, '.'(___607, ___608))))))), ','('g_read'('data.list', '<module>:data.list'(___611)), '<module>:data.list:iter$direct'(_ModuleList, ___604, ___610, ___611)))).
':-'('<module>:emop.compile:generate_call_redirect$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:generate_call_redirect'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:generate_init_goal'(_InitList, _InitGoal, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), ','(','('='(_InitGoalRef, ___559), ','('g_read'('data.ref.backtrackable', '<module>:data.ref.backtrackable'(___560)), '<module>:data.ref.backtrackable:new$direct'('callable'('true', '[]'), ___559, ___560))), ','(','('='(_InitializedRef, ___563), ','('g_read'('data.ref.backtrackable', '<module>:data.ref.backtrackable'(___564)), '<module>:data.ref.backtrackable:new$direct'('[]', ___563, ___564))), ','(','(','('true', ';'('->'('var'(___566), ','('g_inc'('$module_count', ___567), '='(___566, '$module'(___567, '.'('<module>:emop.compile@7'('env'(___566, _InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef, _InitGoal, _InitGoalRef, _InitList, _InitializedRef)), '[]'), '.'(___566, '[]'))))), ','('='(___566, '$module'(___567, ___568, _)), ','('='('.'(___569, ___570), ___568), ','('setarg'(1, ___568, '<module>:emop.compile@7'('env'(___566, _InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef, _InitGoal, _InitGoalRef, _InitList, _InitializedRef))), 'setarg'(2, ___568, '.'(___569, ___570))))))), ','('g_read'('data.list', '<module>:data.list'(___572)), '<module>:data.list:reverse_iter$direct'(_InitList, ___566, ___572))), ','('='(_InitGoal, ___573), 'emop_call'(_InitGoalRef, 'get'(___573), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 560, from character 29 to 32')))))).
':-'('<module>:emop.compile:generate_init_goal$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:generate_init_goal'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:generate_object_file'(_Clauses, _BaseFilename, _Fid, _ObjectFilename, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), ','(','('g_read'('emop.compile', '<module>:emop.compile'(___909)), '<module>:emop.compile:clauses_to_prolog$direct'(_Clauses, _Fid, _FilenamePl, ___909)), ','('g_read'('emop.compile', '<module>:emop.compile'(___910)), '<module>:emop.compile:prolog_to_object$direct'(_BaseFilename, _Fid, _FilenamePl, _ObjectFilename, ___910)))).
':-'('<module>:emop.compile:generate_object_file$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:generate_object_file'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:generate_static'(_ModuleList, ___601, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), ','(','('true', ';'('->'('var'(___595), ','('g_inc'('$module_count', ___596), '='(___595, '$module'(___596, '.'('<module>:emop.compile@8'('env'(___595, _InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef, _ModuleList)), '[]'), '.'(___595, '[]'))))), ','('='(___595, '$module'(___596, ___597, _)), ','('='('.'(___598, ___599), ___597), ','('setarg'(1, ___597, '<module>:emop.compile@8'('env'(___595, _InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef, _ModuleList))), 'setarg'(2, ___597, '.'(___598, ___599))))))), ','('g_read'('data.list', '<module>:data.list'(___602)), '<module>:data.list:iter$direct'(_ModuleList, ___595, ___601, ___602)))).
':-'('<module>:emop.compile:generate_static$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:generate_static'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:gplc'(_FilenamePl, _Mode, _FilenameWam, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), ','(','('g_read'('emop.compile', '<module>:emop.compile'(___202)), '<module>:emop.compile:log$direct'('Compiling \'~a\'...\n', '.'(_FilenameWam, '[]'), ___202)), ';'('->'(','('g_read'('sys.process', '<module>:sys.process'(___211)), '<module>:sys.process:spawn$direct'('gplc', '.'(_Mode, '.'('-o', '.'(_FilenameWam, '.'(_FilenamePl, '[]')))), ___211)), 'true'), 'throw'('error'('Compilation failed', 'cmdline'))))).
':-'('<module>:emop.compile:gplc$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:gplc'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:import'(_Ast, _Pb, _Pe, _Update, _ExternVars, _SgnVars, _Scope, _NewScope, _NewVars, _M, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), ','('='(_Pos, 'file'(_Pb, _Pe)), ','(','('='(_Dependencies, ___825), ','('g_read'('emop.expand', '<module>:emop.expand'(___826)), '<module>:emop.expand:fresh_dependencies$direct'('[]', '.', ___825, ___826))), ','(';'('->'(','('g_read'('emop.compile', '<module>:emop.compile'(___827)), '<module>:emop.compile:find_fid$direct'(_Ast, _Fid, _FidPos, ___827)), ','('g_read'('emop.compile', '<module>:emop.compile'(___828)), '<module>:emop.compile:check_user_defined$direct'(_Fid, _FidPos, ___828))), '='(_Fid, '$toplevel')), ','(','('g_read'('emop.expand', '<module>:emop.expand'(___833)), '<module>:emop.expand:expand_file$direct'(_Fid, _Sgn, '', 'io.null', _Dependencies, _ExpandFile, ___833)), ','(';'('->'('='(_Fid, '$toplevel'), 'true'), ','(','('g_read'('emop.sgn', '<module>:emop.sgn'(___836)), '<module>:emop.sgn:add_consult_sgn$direct'(_Fid, _Sgn, ___836)), ','('emop_call'(_ConsultedRef, 'get'(___840), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 833, from character 62 to 65'), 'emop_call'(_ConsultedRef, 'set'('.'('c'(_Fid, 'top', '[]'), ___840)), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 833, from character 22 to 25')))), ','('emop_call'(_ExpandFile, 'expand_import'(_Ast, _Pos, _ExternVars, _SgnVars, _Scope, _Goals), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 835, from character 17 to 30'), ','('='(_VarTerm, 'callable'('vars', _VarVars)), ','(','('='('s'(_Clauses, _Inits, _, _NewScope, _NewVars), ___854), ','(','('true', ';'('->'('var'(___848), ','('g_inc'('$module_count', ___849), '='(___848, '$module'(___849, '.'('<module>:emop.compile@13'('env'(___848, _SgnVars, _Pos, _ExpandFile, _VarTerm)), '[]'), '.'(___848, '[]'))))), ','('='(___848, '$module'(___849, ___850, _)), ','('='('.'(___851, ___852), ___850), ','('setarg'(1, ___850, '<module>:emop.compile@13'('env'(___848, _SgnVars, _Pos, _ExpandFile, _VarTerm))), 'setarg'(2, ___850, '.'(___851, ___852))))))), ','('g_read'('data.list', '<module>:data.list'(___855)), '<module>:data.list:fold_left$direct'(_Goals, 's'(_Clauses0, '[]', 0, _Scope, _ExternVars), ___848, ___854, ___855)))), ','(','('='(_VarVars, ___863), ','(','('true', ';'('->'('var'(___857), ','('g_inc'('$module_count', ___858), '='(___857, '$module'(___858, '.'('<module>:emop.compile@14'('env'(___857, _InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef, _Ast, _Clauses, _Clauses0, _Dependencies, _ExpandFile, _ExternVars, _Fid, _FidPos, _FilenamePl, _Goals, _Inits, _M, _ModuleList, _NewScope, _NewVars, _Pb, _Pe, _Pos, _Scope, _Sgn, _SgnVars, _Update, _VarTerm, _VarVars, _Wam)), '[]'), '.'(___857, '[]'))))), ','('='(___857, '$module'(___858, ___859, _)), ','('='('.'(___860, ___861), ___859), ','('setarg'(1, ___859, '<module>:emop.compile@14'('env'(___857, _InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef, _Ast, _Clauses, _Clauses0, _Dependencies, _ExpandFile, _ExternVars, _Fid, _FidPos, _FilenamePl, _Goals, _Inits, _M, _ModuleList, _NewScope, _NewVars, _Pb, _Pe, _Pos, _Scope, _Sgn, _SgnVars, _Update, _VarTerm, _VarVars, _Wam))), 'setarg'(2, ___859, '.'(___860, ___861))))))), ','('g_read'('data.list', '<module>:data.list'(___864)), '<module>:data.list:iter$direct'(_NewVars, ___857, ___863, ___864)))), ','('emop_call'(_ExpandFile, 'close'(_ModuleList, _Clauses0), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 869, from character 17 to 22'), ','(','('g_read'('emop.compile', '<module>:emop.compile'(___866)), '<module>:emop.compile:clauses_to_prolog$direct'(_Clauses, '$toplevel', _FilenamePl, ___866)), ','(','('g_read'('emop.compile', '<module>:emop.compile'(___869)), '<module>:emop.compile:prolog_to_wam$direct'('$toplevel', _FilenamePl, '-w', _Wam, ___869)), ','('load'('.'(_Wam, '[]')), ','(','('g_read'('emop.compile', '<module>:emop.compile'(___873)), '<module>:emop.compile:assert_call_redirect$direct'(_ModuleList, ___873)), ','(','('emop_call'(_Dependencies, 'get'(___874), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 874, from character 30 to 33'), ','('g_read'('emop.compile', '<module>:emop.compile'(___878)), '<module>:emop.compile:solve_deps$direct'(___874, '[]', _Update, '[]', '.', _Goals, ___878))), ','('true', ';'('->'('var'(_M), ','('g_inc'('$module_count', ___879), '='(_M, '$module'(___879, '.'('<module>:emop.compile@15'('env'(_M, _Inits, _Goals)), '[]'), '.'(_M, '[]'))))), ','('='(_M, '$module'(___879, ___880, _)), ','('='('.'(___881, ___882), ___880), ','('setarg'(1, ___880, '<module>:emop.compile@15'('env'(_M, _Inits, _Goals))), 'setarg'(2, ___880, '.'(___881, ___882))))))))))))))))))))))).
':-'('<module>:emop.compile:import$direct'(_____10, _____9, _____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:import'(_____10, _____9, _____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:initial_scope'(_Dependencies, _Scope, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), ','(','('='(_SyntaxSgn, ___914), 'emop_call'(_Dependencies, 'find_mod_sgn'('emop.syntax', 'file'(''), ___914), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 920, from character 31 to 43')), ','(';'('->'(','('g_read'('data.var', '<module>:data.var'(___916)), '<module>:data.var:check$direct'(_SyntaxSgn, ___916)), 'throw'('error'('EMoP syntax not found', 'file'('')))), 'true'), ','(';'('->'(','('g_read'('data.list', '<module>:data.list'(___925)), '<module>:data.list:member$direct'('symbol'('syntax', 1, 'predicate', _SyntaxInfo, _), _SyntaxSgn, ___925)), 'true'), 'throw'('error'('EMoP syntax not found', 'file'('')))), ','(','('='(_SyntaxEnv, ___931), ','('g_read'('data.record', '<module>:data.record'(___932)), '<module>:data.record:{}$direct'(___931, ___932))), ','(','('g_read'('emop.expand', '<module>:emop.expand'(___944)), '<module>:emop.expand:get_args_info$direct'(_SyntaxInfo, _SyntaxSgn, _SyntaxEnv, '[]', _Dependencies, 'file'(''), '.'('emop.syntax', '[]'), '.'('var'('syntax'), '[]'), ___944)), ','(','('='(_VAS, ___946), 'emop_call'(_SyntaxEnv, '{}'('syntax', ___946), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 942, from character 22 to 23')), ','(';'('->'(','('g_read'('data.var', '<module>:data.var'(___948)), '<module>:data.var:check$direct'(_VAS, ___948)), 'throw'('error'('EMoP syntax not found', 'file'('')))), ','(','('='(_VAR, ___954), ','('g_read'('emop.unionfind', '<module>:emop.unionfind'(___955)), '<module>:emop.unionfind:get_root$direct'(_VAS, ___954, ___955))), ','('='('root'(','(_Fids, _TrueSyntaxSgn)), ___958), 'emop_call'(_VAR, 'get'(___958), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 949, from character 45 to 48')))), ','('emop_call'(_Dependencies, 'add_expand'(_Fids, 'file'('')), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 951, from character 19 to 29'), ','('='(_Scope, '.'(___966, '[]')), ','('g_read'('emop.expand', '<module>:emop.expand'(___967)), '<module>:emop.expand:make_scope$direct'('callable'('emop.syntax', '[]'), _TrueSyntaxSgn, '[]', ___966, ___967)))))))))))).
':-'('<module>:emop.compile:initial_scope$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:initial_scope'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:initialization'(___134, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), '=..'(___134, '.'('initialization', '[]'))).
':-'('<module>:emop.compile:initialization$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:initialization'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:interface'(___152, ___153, ___154, ___155, ___156, ___157, ___158, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), '=..'(___158, '.'('interface', '.'(___152, '.'(___153, '.'(___154, '.'(___155, '.'(___156, '.'(___157, '[]'))))))))).
':-'('<module>:emop.compile:interface$direct'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:interface'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:lexing_error'(___92, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), '=..'(___92, '.'('lexing_error', '[]'))).
':-'('<module>:emop.compile:lexing_error$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:lexing_error'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:lib_dir'(___510, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), ','(','('='(_ExecDir, ___503), ','(','(','('g_read'('sys.process', '<module>:sys.process'(___500)), '<module>:sys.process:exec_filename$direct'(___499, ___500)), ','('g_read'('sys.file', '<module>:sys.file'(___502)), '<module>:sys.file:real$direct'(___499, ___501, ___502))), ','('g_read'('data.path', '<module>:data.path'(___504)), '<module>:data.path:base$direct'(___501, ___503, ___504)))), ','('g_read'('data.path', '<module>:data.path'(___508)), ','('<module>:data.path:base$direct'(_ExecDir, ___507, ___508), ','('g_read'('data.path', '<module>:data.path'(___511)), '<module>:data.path:concat$direct'(___507, 'lib', ___510, ___511)))))).
':-'('<module>:emop.compile:lib_dir$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:lib_dir'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:link'(_Output, _PrologFiles, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), ','(','('g_read'('emop.compile', '<module>:emop.compile'(___285)), '<module>:emop.compile:log$direct'('Building \'~a\'...\n', '.'(_Output, '[]'), ___285)), ';'('->'(','(','(','(','(','('g_read'('emop.compile', '<module>:emop.compile'(___293)), '<module>:emop.compile:size$direct'('local', ___292, ___293)), 'emop_call'(___292, 'get'(___294), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 303, from character 46 to 49')), ','('g_read'('data.number', '<module>:data.number'(___296)), '<module>:data.number:atom$direct'(___294, ___295, ___296))), ','(','(','(','('g_read'('emop.compile', '<module>:emop.compile'(___301)), '<module>:emop.compile:size$direct'('global', ___300, ___301)), 'emop_call'(___300, 'get'(___302), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 305, from character 47 to 50')), ','('g_read'('data.number', '<module>:data.number'(___304)), '<module>:data.number:atom$direct'(___302, ___303, ___304))), ','(','(','(','('g_read'('emop.compile', '<module>:emop.compile'(___309)), '<module>:emop.compile:size$direct'('trail', ___308, ___309)), 'emop_call'(___308, 'get'(___310), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 307, from character 46 to 49')), ','('g_read'('data.number', '<module>:data.number'(___312)), '<module>:data.number:atom$direct'(___310, ___311, ___312))), ','(','(','(','('g_read'('emop.compile', '<module>:emop.compile'(___317)), '<module>:emop.compile:size$direct'('cstr', ___316, ___317)), 'emop_call'(___316, 'get'(___318), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 309, from character 45 to 48')), ','('g_read'('data.number', '<module>:data.number'(___320)), '<module>:data.number:atom$direct'(___318, ___319, ___320))), ','(','(','('g_read'('emop.compile', '<module>:emop.compile'(___324)), '<module>:emop.compile:prolog_options$direct'(___323, ___324)), 'emop_call'(___323, 'get'(___325), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 313, from character 47 to 50')), ','('g_read'('data.list', '<module>:data.list'(___327)), '<module>:data.list:append$direct'(___325, _PrologFiles, ___326, ___327))))))), ','('g_read'('sys.process', '<module>:sys.process'(___339)), '<module>:sys.process:spawn$direct'('gplc', '.'('--no-top-level', '.'('--local-size', '.'(___295, '.'('--global-size', '.'(___303, '.'('--trail-size', '.'(___311, '.'('--cstr-size', '.'(___319, '.'('-o', '.'(_Output, ___326))))))))))), ___339))), 'true'), 'throw'('error'('Linking failed', 'cmdline'))))).
':-'('<module>:emop.compile:link$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:link'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:load_ast'(_Ast, _Update, _ExternVars, _SgnVars, _Scope, _Vars, _M, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), ','(','('='(_Vars, ___760), ','(','('g_read'('emop.parse', '<module>:emop.parse'(___758)), '<module>:emop.parse:fv$direct'(_Ast, ___757, ___758)), ','('g_read'('data.list', '<module>:data.list'(___761)), '<module>:data.list:merge$direct'(_ExternVars, ___757, 'data.term', ___760, ___761)))), ','(','('='(_Dependencies, ___765), ','('g_read'('emop.expand', '<module>:emop.expand'(___766)), '<module>:emop.expand:fresh_dependencies$direct'('[]', '.', ___765, ___766))), ','(';'('->'(','('g_read'('emop.compile', '<module>:emop.compile'(___767)), '<module>:emop.compile:find_fid$direct'(_Ast, _Fid, _FidPos, ___767)), ','('g_read'('emop.compile', '<module>:emop.compile'(___768)), '<module>:emop.compile:check_user_defined$direct'(_Fid, _FidPos, ___768))), '='(_Fid, '$toplevel')), ','(','(','('g_read'('emop.expand', '<module>:emop.expand'(___774)), '<module>:emop.expand:expand_file$direct'(_Fid, _Sgn, '', 'io.null', _Dependencies, ___773, ___774)), ','('emop_call'(___773, 'expand_goal'(_Ast, _Scope, _SgnVars, _Vars, 'no_singleton_warning', _Goal), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 785, from character 9 to 20'), 'emop_call'(___773, 'close'(_ModuleList, _Clauses0), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 786, from character 9 to 14'))), ','(';'('->'('='(_Fid, '$toplevel'), 'true'), ','(','('g_read'('emop.sgn', '<module>:emop.sgn'(___778)), '<module>:emop.sgn:add_consult_sgn$direct'(_Fid, _Sgn, ___778)), ','('emop_call'(_ConsultedRef, 'get'(___782), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 794, from character 62 to 65'), 'emop_call'(_ConsultedRef, 'set'('.'('c'(_Fid, 'top', '[]'), ___782)), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 794, from character 22 to 25')))), ','(','('='(_VarVars, ___791), ','(','('true', ';'('->'('var'(___785), ','('g_inc'('$module_count', ___786), '='(___785, '$module'(___786, '.'('<module>:emop.compile@11'('env'(___785, _InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef, _Ast, _Clauses, _Clauses0, _Dependencies, _ExternVars, _Fid, _FidPos, _FilenamePl, _Goal, _Goals, _M, _ModuleList, _Scope, _Sgn, _SgnVars, _Update, _VarTerm, _VarVars, _Vars, _Wam)), '[]'), '.'(___785, '[]'))))), ','('='(___785, '$module'(___786, ___787, _)), ','('='('.'(___788, ___789), ___787), ','('setarg'(1, ___787, '<module>:emop.compile@11'('env'(___785, _InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef, _Ast, _Clauses, _Clauses0, _Dependencies, _ExternVars, _Fid, _FidPos, _FilenamePl, _Goal, _Goals, _M, _ModuleList, _Scope, _Sgn, _SgnVars, _Update, _VarTerm, _VarVars, _Vars, _Wam))), 'setarg'(2, ___787, '.'(___788, ___789))))))), ','('g_read'('data.list', '<module>:data.list'(___792)), '<module>:data.list:iter$direct'(_Vars, ___785, ___791, ___792)))), ','('='(_VarTerm, 'callable'('vars', _VarVars)), ','('='(_Clauses, '.'('clause'('emop_toplevel_goal_init', 1, '.'(_VarTerm, '[]'), _Goal), _Clauses0)), ','(','('g_read'('emop.compile', '<module>:emop.compile'(___801)), '<module>:emop.compile:clauses_to_prolog$direct'(_Clauses, '$toplevel', _FilenamePl, ___801)), ','(','('g_read'('emop.compile', '<module>:emop.compile'(___804)), '<module>:emop.compile:prolog_to_wam$direct'('$toplevel', _FilenamePl, '-w', _Wam, ___804)), ','('load'('.'(_Wam, '[]')), ','(','('g_read'('emop.compile', '<module>:emop.compile'(___808)), '<module>:emop.compile:assert_call_redirect$direct'(_ModuleList, ___808)), ','(','('emop_call'(_Dependencies, 'get'(___809), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 806, from character 30 to 33'), ','('g_read'('emop.compile', '<module>:emop.compile'(___813)), '<module>:emop.compile:solve_deps$direct'(___809, '[]', _Update, '[]', '.', _Goals, ___813))), ','('true', ';'('->'('var'(_M), ','('g_inc'('$module_count', ___814), '='(_M, '$module'(___814, '.'('<module>:emop.compile@12'('env'(_M, _Goals)), '[]'), '.'(_M, '[]'))))), ','('='(_M, '$module'(___814, ___815, _)), ','('='('.'(___816, ___817), ___815), ','('setarg'(1, ___815, '<module>:emop.compile@12'('env'(_M, _Goals))), 'setarg'(2, ___815, '.'(___816, ___817))))))))))))))))))))).
':-'('<module>:emop.compile:load_ast$direct'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:load_ast'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:log'(_Msg, _Args, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), ';'('->'(','('g_read'('emop.compile', '<module>:emop.compile'(___196)), '<module>:emop.compile:verbose$direct'(___196)), ','('g_read'('io.err', '<module>:io.err'(___198)), '<module>:io.err:format$direct'(_Msg, _Args, ___198))), 'true')).
':-'('<module>:emop.compile:log$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:log'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:lookup'(_ModSpec, _Pos, _BaseFilename, _FilenameMpl, _SMpl, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), ';'('->'(','(';'('->'('='(_ModSpec, 'file'(_ModName)), ','(','('='(_FilenameMpl, ___442), ','('g_read'('sys.file', '<module>:sys.file'(___443)), '<module>:sys.file:real$direct'(_ModName, ___442, ___443))), 'catch'(','('g_read'('io.file', '<module>:io.file'(___445)), '<module>:io.file:open_read$direct'(_FilenameMpl, _SMpl, ___445)), _, 'fail'))), '->'('='(_ModSpec, 'name'(_ModName, _PackageNodes, _RootPackagePath)), ','(','('g_read'('emop.compile', '<module>:emop.compile'(___447)), '<module>:emop.compile:module_filename$direct'(_ModName, _Pos, _RelBaseFilename, ___447)), ','(';'(','(','('g_read'('data.list', '<module>:data.list'(___449)), '<module>:data.list:longuest_prefix$direct'(_Prefix, _PackageNodes, ___449)), ','(','('g_read'('data.path', '<module>:data.path'(___451)), '<module>:data.path:join$direct'(_Prefix, _RelPath, ___451)), ','(','('g_read'('data.path', '<module>:data.path'(___452)), '<module>:data.path:concat$direct'(_RootPackagePath, _RelPath, _Path, ___452)), ','('g_read'('data.path', '<module>:data.path'(___453)), '<module>:data.path:concat$direct'(_Path, _RelBaseFilename, _BaseFilename0, ___453))))), ','(','(','('g_read'('emop.compile', '<module>:emop.compile'(___456)), '<module>:emop.compile:paths$direct'(___455, ___456)), ','('g_read'('data.list', '<module>:data.list'(___457)), '<module>:data.list:member$direct'(_Path, ___455, ___457))), ','('g_read'('data.path', '<module>:data.path'(___459)), '<module>:data.path:concat$direct'(_Path, _RelBaseFilename, _BaseFilename0, ___459)))), 'catch'(','(','('='(_FilenameMpl, ___465), ','(','('g_read'('data.atom', '<module>:data.atom'(___464)), '<module>:data.atom:concat$direct'(_BaseFilename0, '.mpl', ___463, ___464)), ','('g_read'('sys.file', '<module>:sys.file'(___466)), '<module>:sys.file:real$direct'(___463, ___465, ___466)))), ','('g_read'('io.file', '<module>:io.file'(___468)), '<module>:io.file:open_read$direct'(_FilenameMpl, _SMpl, ___468))), _, 'fail'))))), ','('g_read'('data.atom', '<module>:data.atom'(___470)), '<module>:data.atom:sub$direct'(_FilenameMpl, 0, _, 4, _BaseFilename, ___470))), 'true'), ','(';'('->'('='(_ModSpec, 'file'(_ModName)), 'true'), '='(_ModSpec, 'name'(_ModName, _PackageNodes, _RootPackagePath))), ','(','('g_read'('data.atom', '<module>:data.atom'(___477)), '<module>:data.atom:format$direct'('Unable to find \'~a\'', '.'(_ModName, '[]'), _Message, ___477)), 'throw'('error'(_Message, _Pos)))))).
':-'('<module>:emop.compile:lookup$direct'(_____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:lookup'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:lookup_file'(_RelFilename, _Filename, _S, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), ';'('->'(','(','(','('g_read'('emop.compile', '<module>:emop.compile'(___424)), '<module>:emop.compile:paths$direct'(___423, ___424)), ','('g_read'('data.list', '<module>:data.list'(___425)), '<module>:data.list:member$direct'(_Path, ___423, ___425))), 'catch'(','(','('='(_Filename, ___430), ','(','('g_read'('data.path', '<module>:data.path'(___429)), '<module>:data.path:concat$direct'(_Path, _RelFilename, ___428, ___429)), ','('g_read'('sys.file', '<module>:sys.file'(___431)), '<module>:sys.file:real$direct'(___428, ___430, ___431)))), ','('g_read'('emop.compile', '<module>:emop.compile'(___432)), '<module>:emop.compile:try_open$direct'(_Filename, _S, ___432))), ___E, 'fail')), 'true'), ','(','('g_read'('data.atom', '<module>:data.atom'(___437)), '<module>:data.atom:format$direct'('Unable to find \'~a\'', '.'(_RelFilename, '[]'), _Message, ___437)), 'throw'('error'(_Message, 'cmdline'))))).
':-'('<module>:emop.compile:lookup_file$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:lookup_file'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:main'(___122, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), '=..'(___122, '.'('main', '[]'))).
':-'('<module>:emop.compile:main$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:main'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:mod'(___103, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), '=..'(___103, '.'('mod', '[]'))).
':-'('<module>:emop.compile:mod$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:mod'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:module_filename'(_Mod, _Pos, _Filename, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), ','(','('g_read'('data.atom', '<module>:data.atom'(___480)), '<module>:data.atom:string$direct'(_Mod, _Str, ___480)), ','(','('true', ';'('->'('var'(_Change), ','('g_inc'('$module_count', ___481), '='(_Change, '$module'(___481, '.'('<module>:emop.compile@5'('env'(_Change)), '[]'), '.'(_Change, '[]'))))), ','('='(_Change, '$module'(___481, ___482, _)), ','('='('.'(___483, ___484), ___482), ','('setarg'(1, ___482, '<module>:emop.compile@5'('env'(_Change))), 'setarg'(2, ___482, '.'(___483, ___484))))))), ';'('->'(','('g_read'('data.list', '<module>:data.list'(___487)), '<module>:data.list:iter$direct'(_Str, _Change, _FilenameStr, ___487)), ','('g_read'('data.string', '<module>:data.string'(___489)), '<module>:data.string:atom$direct'(_FilenameStr, _Filename, ___489))), ','(','('g_read'('data.atom', '<module>:data.atom'(___494)), '<module>:data.atom:format$direct'('Invalid module name \'~a\'', '.'(_Mod, '[]'), _Message, ___494)), 'throw'('error'(_Message, _Pos))))))).
':-'('<module>:emop.compile:module_filename$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:module_filename'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:name'(___118, ___119, ___120, ___121, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), '=..'(___121, '.'('name', '.'(___118, '.'(___119, '.'(___120, '[]')))))).
':-'('<module>:emop.compile:name$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:name'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:none'(___113, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), '=..'(___113, '.'('none', '[]'))).
':-'('<module>:emop.compile:none$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:none'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:number'(___129, ___130, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), '=..'(___130, '.'('number', '.'(___129, '[]')))).
':-'('<module>:emop.compile:number$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:number'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:operator'(___87, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), '=..'(___87, '.'('operator', '[]'))).
':-'('<module>:emop.compile:operator$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:operator'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:parsing_error'(___89, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), '=..'(___89, '.'('parsing_error', '[]'))).
':-'('<module>:emop.compile:parsing_error$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:parsing_error'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:patch_wam'(_FilenameWam, _FilenameWamPatched, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), ','(','('g_read'('emop.compile', '<module>:emop.compile'(___218)), '<module>:emop.compile:log$direct'('Patching \'~a\'...\n', '.'(_FilenameWamPatched, '[]'), ___218)), ';'('->'(','(','('='(_OriginalFile, ___220), ','('g_read'('io.file', '<module>:io.file'(___221)), '<module>:io.file:open_read$direct'(_FilenameWam, ___220, ___221))), ','(','('='(_NewFile, ___223), ','('g_read'('io.file', '<module>:io.file'(___224)), '<module>:io.file:open_write$direct'(_FilenameWamPatched, ___223, ___224))), ','(','('='(_Patcher, ___232), ','(','('true', ';'('->'('var'(___226), ','('g_inc'('$module_count', ___227), '='(___226, '$module'(___227, '.'('<module>:emop.compile@1'('env'(___226, _InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef, _FilenameWam, _FilenameWamPatched, _NewFile, _OriginalFile, _Patcher)), '[]'), '.'(___226, '[]'))))), ','('='(___226, '$module'(___227, ___228, _)), ','('='('.'(___229, ___230), ___228), ','('setarg'(1, ___228, '<module>:emop.compile@1'('env'(___226, _InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef, _FilenameWam, _FilenameWamPatched, _NewFile, _OriginalFile, _Patcher))), 'setarg'(2, ___228, '.'(___229, ___230))))))), ','('g_read'('emop.patch_wam', '<module>:emop.patch_wam'(___233)), '<module>:emop.patch_wam:make$direct'(___226, ___232, ___233)))), ','('emop_call'(_Patcher, 'stream'(_OriginalFile, _NewFile), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 239, from character 17 to 23'), ','('emop_call'(_NewFile, 'close', 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 240, from character 17 to 22'), 'emop_call'(_OriginalFile, 'close', 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 241, from character 22 to 27')))))), 'true'), 'throw'('error'('Patching WAM file failed', 'cmdline'))))).
':-'('<module>:emop.compile:patch_wam$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:patch_wam'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:paths'(_Paths, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), ','(';'('->'(','('='(_Path, ___514), ','('g_read'('sys.env', '<module>:sys.env'(___515)), '<module>:sys.env:{}$direct'('EMOPPATH', ___514, ___515))), ','(','('g_read'('data.path', '<module>:data.path'(___519)), '<module>:data.path:separator$direct'(___518, ___519)), ','('g_read'('data.atom', '<module>:data.atom'(___520)), '<module>:data.atom:split$direct'(_Path, ___518, _EnvPaths, ___520)))), '='(_EnvPaths, '[]')), ','(','('g_read'('emop.compile', '<module>:emop.compile'(___524)), '<module>:emop.compile:lib_dir$direct'(___523, ___524)), ','('g_read'('data.list', '<module>:data.list'(___527)), '<module>:data.list:append$direct'(_EnvPaths, '.'(___523, '[]'), _Paths, ___527))))).
':-'('<module>:emop.compile:paths$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:paths'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:pos'(___101, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), '=..'(___101, '.'('pos', '[]'))).
':-'('<module>:emop.compile:pos$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:pos'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:print'(___150, ___151, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), '=..'(___151, '.'('print', '.'(___150, '[]')))).
':-'('<module>:emop.compile:print$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:print'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:prolog_options'(_PrologOptionsRef, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), 'true').
':-'('<module>:emop.compile:prolog_options$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:prolog_options'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:prolog_to_object'(_BaseFilename, _Fid, _FilenamePl, _FilenameO, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), ','(','('g_read'('emop.compile', '<module>:emop.compile'(___970)), '<module>:emop.compile:filename_o$direct'(_BaseFilename, _Fid, _FilenameO, ___970)), ';'('->'(','('g_read'('emop.compile', '<module>:emop.compile'(___971)), '<module>:emop.compile:wam_patch$direct'(___971)), ','(','('g_read'('emop.compile', '<module>:emop.compile'(___973)), '<module>:emop.compile:prolog_to_patched_wam$direct'(_Fid, _FilenamePl, '-W', _FilenameWam, ___973)), ','('g_read'('emop.compile', '<module>:emop.compile'(___975)), '<module>:emop.compile:gplc$direct'(_FilenameWam, '-c', _FilenameO, ___975)))), ','('g_read'('emop.compile', '<module>:emop.compile'(___977)), '<module>:emop.compile:gplc$direct'(_FilenamePl, '-c', _FilenameO, ___977))))).
':-'('<module>:emop.compile:prolog_to_object$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:prolog_to_object'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:prolog_to_patched_wam'(_Fid, _FilenamePl, _Mode, _FilenameWam, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), ','(','('g_read'('emop.compile', '<module>:emop.compile'(___978)), '<module>:emop.compile:filename_unpatched_wam$direct'(_Fid, _FilenameUnpatchedWam, ___978)), ','(','('g_read'('emop.compile', '<module>:emop.compile'(___979)), '<module>:emop.compile:gplc$direct'(_FilenamePl, _Mode, _FilenameUnpatchedWam, ___979)), ','(','('g_read'('emop.compile', '<module>:emop.compile'(___980)), '<module>:emop.compile:filename_wam$direct'(_Fid, _FilenameWam, ___980)), ','('g_read'('emop.compile', '<module>:emop.compile'(___981)), '<module>:emop.compile:patch_wam$direct'(_FilenameUnpatchedWam, _FilenameWam, ___981)))))).
':-'('<module>:emop.compile:prolog_to_patched_wam$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:prolog_to_patched_wam'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:prolog_to_wam'(_Fid, _FilenamePl, _Mode, _FilenameWam, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), ';'('->'(','('g_read'('emop.compile', '<module>:emop.compile'(___982)), '<module>:emop.compile:wam_patch$direct'(___982)), ','('g_read'('emop.compile', '<module>:emop.compile'(___983)), '<module>:emop.compile:prolog_to_patched_wam$direct'(_Fid, _FilenamePl, _Mode, _FilenameWam, ___983))), ','(','('g_read'('emop.compile', '<module>:emop.compile'(___984)), '<module>:emop.compile:filename_wam$direct'(_Fid, _FilenameWam, ___984)), ','('g_read'('emop.compile', '<module>:emop.compile'(___985)), '<module>:emop.compile:gplc$direct'(_FilenamePl, _Mode, _FilenameWam, ___985))))).
':-'('<module>:emop.compile:prolog_to_wam$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:prolog_to_wam'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:read_interface'(_BaseFilename, _FilenameMpl, _Fid, _Deps, _ModuleList, _Sgn, _LinkDeps, _ObjectFilename, _ExpandDeps, _MpiChange, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), ','(','('g_read'('emop.compile', '<module>:emop.compile'(___344)), '<module>:emop.compile:use_cache$direct'('dummy', ___344)), ','('emop_call'(_InterfaceCacheRef, 'get'(_InterfaceCache), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 326, from character 24 to 27'), ';'('->'(','('g_read'('data.list', '<module>:data.list'(___347)), '<module>:data.list:member$direct'('interface'(_FilenameMpl, _Fid, _Deps, _ModuleList, _Sgn, _LinkDeps, _ObjectFilename, _ExpandDeps, _MpiChange), _InterfaceCache, ___347)), 'true'), ','(','('='(_FilenameMpi, ___348), ','('g_read'('emop.compile', '<module>:emop.compile'(___349)), '<module>:emop.compile:filename_mpi$direct'(_BaseFilename, _Fid, ___348, ___349))), ','(','('='(_ObjectFilename, ___350), ','('g_read'('emop.compile', '<module>:emop.compile'(___351)), '<module>:emop.compile:filename_o$direct'(_BaseFilename, _Fid, ___350, ___351))), ','('catch'(','(','('='(_MplChange, ___353), ','('g_read'('sys.file', '<module>:sys.file'(___354)), '<module>:sys.file:last_modification$direct'(_FilenameMpl, ___353, ___354))), ','(','('='(_MpiChange, ___356), ','('g_read'('sys.file', '<module>:sys.file'(___357)), '<module>:sys.file:last_modification$direct'(_FilenameMpi, ___356, ___357))), ','(','('='(_ObjectChange, ___359), ','('g_read'('sys.file', '<module>:sys.file'(___360)), '<module>:sys.file:last_modification$direct'(_ObjectFilename, ___359, ___360))), ','(','('g_read'('data.term', '<module>:data.term'(___362)), '<module>:data.term:<$direct'(_MplChange, _MpiChange, ___362)), ','('g_read'('data.term', '<module>:data.term'(___364)), '<module>:data.term:<$direct'(_MplChange, _ObjectChange, ___364)))))), 'error'('system_error'(_), _), 'fail'), ','(','('g_read'('emop.compile', '<module>:emop.compile'(___370)), '<module>:emop.compile:log$direct'('Read interface \'~a\'...\n', '.'(_FilenameMpi, '[]'), ___370)), ','(','('='(_FileMpi, ___372), ','('g_read'('io.file', '<module>:io.file'(___373)), '<module>:io.file:open_read$direct'(_FilenameMpi, ___372, ___373))), ','('emop_call'(_FileMpi, 'read_term'('interface'(_Fid, _ExpandDeps, _Deps, _LinkDeps, _ModuleList, _Sgn)), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 347, from character 17 to 26'), ','('emop_call'(_FileMpi, 'close', 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 348, from character 17 to 22'), 'emop_call'(_InterfaceCacheRef, 'set'('.'('interface'(_FilenameMpl, _Fid, _Deps, _ModuleList, _Sgn, _LinkDeps, _ObjectFilename, _ExpandDeps, _MpiChange), _InterfaceCache)), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 349, from character 27 to 30')))))))))))).
':-'('<module>:emop.compile:read_interface$direct'(_____10, _____9, _____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:read_interface'(_____10, _____9, _____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:read_interface_expand'(_BaseFilename, _FilenameMpl, _Fid, _Deps, _ModuleList, _Sgn, _LinkDeps, _ObjectFilename, _PackageNodes, _RootPackagePath, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), ','(','('g_read'('emop.compile', '<module>:emop.compile'(___528)), '<module>:emop.compile:read_interface$direct'(_BaseFilename, _FilenameMpl, _Fid, _Deps, _ModuleList, _Sgn, _LinkDeps, _ObjectFilename, _ExpandDeps, _MpiChange, ___528)), ','(','('g_read'('emop.compile', '<module>:emop.compile'(___530)), '<module>:emop.compile:split_fid$direct'(_Fid, 'none', _BaseFilename, _PackageNodes, _RootPackagePath, ___530)), ','(','('true', ';'('->'('var'(___532), ','('g_inc'('$module_count', ___533), '='(___532, '$module'(___533, '.'('<module>:emop.compile@6'('env'(___532, _InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef, _BaseFilename, _Deps, _ExpandDeps, _Fid, _FilenameMpl, _LinkDeps, _ModuleList, _MpiChange, _ObjectFilename, _PackageNodes, _RootPackagePath, _Sgn)), '[]'), '.'(___532, '[]'))))), ','('='(___532, '$module'(___533, ___534, _)), ','('='('.'(___535, ___536), ___534), ','('setarg'(1, ___534, '<module>:emop.compile@6'('env'(___532, _InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef, _BaseFilename, _Deps, _ExpandDeps, _Fid, _FilenameMpl, _LinkDeps, _ModuleList, _MpiChange, _ObjectFilename, _PackageNodes, _RootPackagePath, _Sgn))), 'setarg'(2, ___534, '.'(___535, ___536))))))), ','('g_read'('data.list', '<module>:data.list'(___538)), '<module>:data.list:iter$direct'(_ExpandDeps, ___532, ___538)))))).
':-'('<module>:emop.compile:read_interface_expand$direct'(_____10, _____9, _____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:read_interface_expand'(_____10, _____9, _____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:reconsult'(_Mod, _FilenameMpl, _SMpl, _PackageNodes, _RootPackagePath, _Deps, _InitPred, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), ','(','('='(_Ast, ___678), ','('g_read'('emop.parser', '<module>:emop.parser'(___679)), '<module>:emop.parser:parse_file$direct'(_FilenameMpl, _SMpl, 'emop.sgn', ___678, ___679))), ','(';'('->'(','('g_read'('emop.compile', '<module>:emop.compile'(___680)), '<module>:emop.compile:find_fid$direct'(_Ast, _Fid, ___FidPos, ___680)), 'true'), 'throw'('error'('No file module', 'file'(_FilenameMpl)))), ','(';'('->'('='(_Fid, _Mod), 'true'), ','(','('g_read'('data.atom', '<module>:data.atom'(___690)), '<module>:data.atom:format$direct'('Module name mismatch ~a and ~a', '.'(_Fid, '.'(_Mod, '[]')), ___689, ___690)), 'throw'('error'(___689, 'file'(_FilenameMpl))))), ','(','('='(_FreeVars, ___694), ','('g_read'('emop.parse', '<module>:emop.parse'(___695)), '<module>:emop.parse:fv$direct'(_Ast, ___694, ___695))), ','(','('='(_SgnVars, ___697), ','('g_read'('data.record', '<module>:data.record'(___698)), '<module>:data.record:{}$direct'(___697, ___698))), ','(','('='(_Dependencies, ___700), ','('g_read'('emop.expand', '<module>:emop.expand'(___701)), '<module>:emop.expand:fresh_dependencies$direct'(_PackageNodes, _RootPackagePath, ___700, ___701))), ','(','('g_read'('emop.compile', '<module>:emop.compile'(___702)), '<module>:emop.compile:initial_scope$direct'(_Dependencies, _Scope, ___702)), ','(';'('->'(','(','('g_read'('emop.expand', '<module>:emop.expand'(___706)), '<module>:emop.expand:expand_file$direct'(_Fid, ___Sgn, _FilenameMpl, 'io.null', _Dependencies, ___705, ___706)), ','(','('='(_Goal, ___708), 'emop_call'(___705, 'expand_goal'(_Ast, _Scope, _SgnVars, _FreeVars, 'singleton_warning', ___708), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 743, from character 14 to 25')), 'emop_call'(___705, 'close'(_ModuleList, _Clauses0), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 744, from character 12 to 17'))), 'true'), 'throw'('error'('expand_error'))), ','('emop_call'(_SMpl, 'close', 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 751, from character 11 to 16'), ','(','('='(_InitPred, ___715), ','('g_read'('data.atom', '<module>:data.atom'(___716)), '<module>:data.atom:format$direct'('emop_init_~a', '.'(_Mod, '[]'), ___715, ___716))), ','('='(_Clauses, '.'('clause'(_InitPred, 0, '[]', _Goal), _Clauses0)), ','(','('='(_DynBaseName, ___724), ','('g_read'('data.atom', '<module>:data.atom'(___725)), '<module>:data.atom:format$direct'('dyn$~a', '.'(_Mod, '[]'), ___724, ___725))), ','(','('g_read'('emop.compile', '<module>:emop.compile'(___726)), '<module>:emop.compile:clauses_to_prolog$direct'(_Clauses, _DynBaseName, _FilenamePl, ___726)), ','(','('g_read'('emop.compile', '<module>:emop.compile'(___728)), '<module>:emop.compile:prolog_to_wam$direct'(_DynBaseName, _FilenamePl, '-w', _Wam, ___728)), ','('load'('.'(_Wam, '[]')), ','(','('g_read'('emop.compile', '<module>:emop.compile'(___732)), '<module>:emop.compile:assert_call_redirect$direct'(_ModuleList, ___732)), ','('='(_Deps, ___733), 'emop_call'(_Dependencies, 'get'(___733), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 759, from character 26 to 29'))))))))))))))))))).
':-'('<module>:emop.compile:reconsult$direct'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:reconsult'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:require'(_Mod, _Checked, _Pos, _Update, _PackageNodes, _RootPackagePath, _Goals, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), ';'('->'('emop_static'(_Mod), '='(_Goals, '[]')), ','('g_read'('emop.compile', '<module>:emop.compile'(___624)), '<module>:emop.compile:consult_dyn$direct'(_Mod, _Checked, _Pos, _Update, _PackageNodes, _RootPackagePath, _Goals, ___624)))).
':-'('<module>:emop.compile:require$direct'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:require'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:runtime'(_RuntimeRef, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), 'true').
':-'('<module>:emop.compile:runtime$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:runtime'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:set_build_dir'(_BuildDirOption, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), 'emop_call'(_BuildDirOptionRef, 'set'(_BuildDirOption), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 9, from character 24 to 27')).
':-'('<module>:emop.compile:set_build_dir$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:set_build_dir'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:set_deps'(_Deps, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), 'emop_call'(_DepsRef, 'set'(_Deps), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 55, from character 14 to 17')).
':-'('<module>:emop.compile:set_deps$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:set_deps'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:set_do_not_build_with_warning'(_DoNotBuildWithWarning, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), 'emop_call'(_DoNotBuildWithWarningRef, 'set'(_DoNotBuildWithWarning), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 43, from character 31 to 34')).
':-'('<module>:emop.compile:set_do_not_build_with_warning$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:set_do_not_build_with_warning'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:set_use_cache'(_UseCache, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), 'emop_call'(_UseCacheRef, 'set'(_UseCache), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 37, from character 18 to 21')).
':-'('<module>:emop.compile:set_use_cache$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:set_use_cache'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:set_verbose'(_Verbose, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), 'emop_call'(_VerboseRef, 'set'(_Verbose), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 49, from character 17 to 20')).
':-'('<module>:emop.compile:set_verbose$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:set_verbose'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:set_wam_patch'(_WamPatch, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), 'emop_call'(_WamPatchRef, 'set'(_WamPatch), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 61, from character 18 to 21')).
':-'('<module>:emop.compile:set_wam_patch$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:set_wam_patch'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:size'(_SizeId, _Size, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), ','(','('='(_Size, ___190), 'emop_call'(_SizeRec, '{}'(_SizeId, ___190), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 64, from character 21 to 22')), ';'('->'(','('g_read'('data.var', '<module>:data.var'(___192)), '<module>:data.var:check$direct'(_Size, ___192)), 'throw'('error'('unknown_size', 'set_size'))), 'true'))).
':-'('<module>:emop.compile:size$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:size'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:solve_deps'(_Deps, _Checked, _Update, _PackageNodes, _RootPackagePath, _Goals, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), ','('='(_Goals, ___620), ','(','('true', ';'('->'('var'(___614), ','('g_inc'('$module_count', ___615), '='(___614, '$module'(___615, '.'('<module>:emop.compile@10'('env'(___614, _InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef, _Checked, _Deps, _Goals, _PackageNodes, _RootPackagePath, _Update)), '[]'), '.'(___614, '[]'))))), ','('='(___614, '$module'(___615, ___616, _)), ','('='('.'(___617, ___618), ___616), ','('setarg'(1, ___616, '<module>:emop.compile@10'('env'(___614, _InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef, _Checked, _Deps, _Goals, _PackageNodes, _RootPackagePath, _Update))), 'setarg'(2, ___616, '.'(___617, ___618))))))), ','('g_read'('data.list', '<module>:data.list'(___621)), '<module>:data.list:morph$direct'(_Deps, ___614, ___620, ___621))))).
':-'('<module>:emop.compile:solve_deps$direct'(_____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:solve_deps'(_____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:some'(___104, ___105, ___106, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), '=..'(___106, '.'('some', '.'(___104, '.'(___105, '[]'))))).
':-'('<module>:emop.compile:some$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:some'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:split_fid'(_Fid, _FidPos, _BaseFilename, _PackageNodes, _RootPackagePath, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), ','(','('g_read'('data.atom', '<module>:data.atom'(___541)), '<module>:data.atom:split$direct'(_Fid, '.', _FidNodes, ___541)), ','(','('g_read'('data.list', '<module>:data.list'(___545)), '<module>:data.list:append$direct'(_PackageNodes, '.'(_, '[]'), _FidNodes, ___545)), ','(','('g_read'('data.path', '<module>:data.path'(___547)), '<module>:data.path:join$direct'(_PackageNodes, _RelRootPackagePath, ___547)), ';'('->'(','(','('g_read'('data.path', '<module>:data.path'(___551)), '<module>:data.path:base$direct'(_BaseFilename, ___550, ___551)), ','('g_read'('data.atom', '<module>:data.atom'(___552)), '<module>:data.atom:concat$direct'(_RootPackagePath, _RelRootPackagePath, ___550, ___552))), 'true'), 'throw'('error'('Invalid file module name', _FidPos))))))).
':-'('<module>:emop.compile:split_fid$direct'(_____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:split_fid'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:symbol'(___159, ___160, ___161, ___162, ___163, ___164, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), '=..'(___164, '.'('symbol', '.'(___159, '.'(___160, '.'(___161, '.'(___162, '.'(___163, '[]')))))))).
':-'('<module>:emop.compile:symbol$direct'(_____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:symbol'(_____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:temp_dir'(_TempDir, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), ';'('->'(','('g_read'('data.var', '<module>:data.var'(___170)), '<module>:data.var:check$direct'(_TempDir, ___170)), ','(','('='(_TempDir, ___172), ','('g_read'('io.dir', '<module>:io.dir'(___173)), '<module>:io.dir:mktemp$direct'(___172, ___173))), ','(','('true', ';'('->'('var'(___175), ','('g_inc'('$module_count', ___176), '='(___175, '$module'(___176, '.'('<module>:emop.compile@0'('env'(___175, _InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef)), '[]'), '.'(___175, '[]'))))), ','('='(___175, '$module'(___176, ___177, _)), ','('='('.'(___178, ___179), ___177), ','('setarg'(1, ___177, '<module>:emop.compile@0'('env'(___175, _InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef))), 'setarg'(2, ___177, '.'(___178, ___179))))))), ','('g_read'('sys.process', '<module>:sys.process'(___181)), '<module>:sys.process:at_exit$direct'(___175, ___181))))), 'true')).
':-'('<module>:emop.compile:temp_dir$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:temp_dir'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:temp_filename'(_Fid, _Suffix, ___383, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), ','(','(','('g_read'('emop.compile', '<module>:emop.compile'(___379)), '<module>:emop.compile:temp_dir$direct'(___378, ___379)), ','('g_read'('data.atom', '<module>:data.atom'(___382)), '<module>:data.atom:concat$direct'(_Fid, _Suffix, ___381, ___382))), ','('g_read'('data.path', '<module>:data.path'(___384)), '<module>:data.path:concat$direct'(___378, ___381, ___383, ___384)))).
':-'('<module>:emop.compile:temp_filename$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:temp_filename'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:true'(___112, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), '=..'(___112, '.'('true', '[]'))).
':-'('<module>:emop.compile:true$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:true'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:try_open'(_Filename, _S, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), 'catch'(','('g_read'('io.file', '<module>:io.file'(___419)), '<module>:io.file:open_read$direct'(_Filename, _S, ___419)), 'error'('existence_error'(_, _), _), 'fail')).
':-'('<module>:emop.compile:try_open$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:try_open'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:unescaped'(___88, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), '=..'(___88, '.'('unescaped', '[]'))).
':-'('<module>:emop.compile:unescaped$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:unescaped'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:use_cache'(_Pos, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), ','(','('='(_UseCache, ___182), 'emop_call'(_UseCacheRef, 'get'(___182), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 25, from character 29 to 32')), ';'('->'('='(_UseCache, 'always'), 'true'), '->'('\\='(_Pos, 'cmdline'), '='(_UseCache, 'no_cmdline'))))).
':-'('<module>:emop.compile:use_cache$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:use_cache'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:var'(___143, ___144, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), '=..'(___144, '.'('var', '.'(___143, '[]')))).
':-'('<module>:emop.compile:var$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:var'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile:verbose'('env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), 'emop_call'(_VerboseRef, 'get'('true'), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 46, from character 17 to 20')).
':-'('<module>:emop.compile:verbose$direct'(__36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:verbose'(__36env, __36CutLevel))).
':-'('<module>:emop.compile:wam_patch'('env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), 'emop_call'(_WamPatchRef, 'get'('true'), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 58, from character 18 to 21')).
':-'('<module>:emop.compile:wam_patch$direct'(__36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:wam_patch'(__36env, __36CutLevel))).
':-'('<module>:emop.compile:write'(___93, ___94, 'env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), '=..'(___94, '.'('write', '.'(___93, '[]')))).
':-'('<module>:emop.compile:write$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile:write'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@0'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@0:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@0'('do', __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@0:do'(__36env, __36CutLevel))).
':-'('<module>:emop.compile@0'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.compile@0$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.compile@0$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.compile@0$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.compile@0$has_predicate'('do'), 'true').
':-'('<module>:emop.compile@0:$sgn'(__36sgn, 'env'(___180, _InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl',908,15,887)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl',919,15,887)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.compile@0:atom_fresh_[2748]'(_atom__fresh___912749_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___912749_93, '[]'))))))).
':-'('<module>:emop.compile@0:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@0:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@0:atom_fresh_[2748]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 0, predicate, suspended([],[call(atom('io.dir'),delete_tree,[var('TempDir')])]), __36pos))).
':-'('<module>:emop.compile@0:do'('env'(___180, _InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), ','('g_read'('io.dir', '<module>:io.dir'(___1565)), '<module>:io.dir:delete_tree$direct'(_TempDir, ___1565))).
':-'('<module>:emop.compile@0:do$direct'(__36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@0:do'(__36env, __36CutLevel))).
':-'('<module>:emop.compile@1'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@1:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@1'('do'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@1:do'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@1'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.compile@1$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.compile@1$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.compile@1$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.compile@1$has_predicate'('do'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.compile@10'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@10:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@10'('do'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@10:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@10'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.compile@10$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.compile@10$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.compile@10$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.compile@10$has_predicate'('do'(_____2, _____1)), 'true').
':-'('<module>:emop.compile@10:$sgn'(__36sgn, 'env'(___619, _InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef, _Checked, _Deps, _Goals, _PackageNodes, _RootPackagePath, _Update), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl',19912,616,19888)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl',19925,616,19888)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.compile@10:atom_fresh_[2582]'(_atom__fresh___912583_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___912583_93, '[]'))))))).
':-'('<module>:emop.compile@10:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@10:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@10:atom_fresh_[2582]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 2, predicate, suspended([none,none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.compile@10:do'('dep'(_Dependency, _Pos), ___1428, 'env'(___619, _InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef, _Checked, _Deps, _Goals, _PackageNodes, _RootPackagePath, _Update), __36CutLevel), ','('g_read'('emop.compile', '<module>:emop.compile'(___1429)), '<module>:emop.compile:require$direct'(_Dependency, _Checked, _Pos, _Update, _PackageNodes, _RootPackagePath, ___1428, ___1429))).
':-'('<module>:emop.compile@10:do$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@10:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@11'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@11:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@11'('do'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@11:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@11'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.compile@11$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.compile@11$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.compile@11$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.compile@11$has_predicate'('do'(_____2, _____1)), 'true').
':-'('<module>:emop.compile@11:$sgn'(__36sgn, 'env'(___790, _InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef, _Ast, _Clauses, _Clauses0, _Dependencies, _ExternVars, _Fid, _FidPos, _FilenamePl, _Goal, _Goals, _M, _ModuleList, _Scope, _Sgn, _SgnVars, _Update, _VarTerm, _VarVars, _Vars, _Wam), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl',25466,795,25429)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl',25471,795,25429)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.compile@11:atom_fresh_[2570]'(_atom__fresh___912571_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___912571_93, '[]'))))))).
':-'('<module>:emop.compile@11:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@11:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@11:atom_fresh_[2570]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 2, predicate, suspended([var('A'),var('B')],[call(scope,f,[none,var('A'),none,var('B'),none])]), __36pos))).
':-'('<module>:emop.compile@11:do'(___753, ___754, 'env'(___790, _InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef, _Ast, _Clauses, _Clauses0, _Dependencies, _ExternVars, _Fid, _FidPos, _FilenamePl, _Goal, _Goals, _M, _ModuleList, _Scope, _Sgn, _SgnVars, _Update, _VarTerm, _VarVars, _Vars, _Wam), __36CutLevel), '='(___754, 'var'(___753))).
':-'('<module>:emop.compile@11:do$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@11:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@12'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@12:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@12'('do'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@12:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@12'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.compile@12$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.compile@12$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.compile@12$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.compile@12$has_predicate'('do'(_____1)), 'true').
':-'('<module>:emop.compile@12:$sgn'(__36sgn, 'env'(___818, _Goals), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl',25882,806,25876)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl',25900,806,25876)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.compile@12:atom_fresh_[2543]'(_atom__fresh___912544_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___912544_93, '[]'))))))).
':-'('<module>:emop.compile@12:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@12:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@12:atom_fresh_[2543]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.compile@12:do'(_Vars, 'env'(___818, _Goals), __36CutLevel), ','(','(','('true', ';'('->'('var'(___1417), ','('g_inc'('$module_count', ___1418), '='(___1417, '$module'(___1418, '.'('<module>:emop.compile@24'('env'(___1417, _Goals, _Vars, ___818)), '[]'), '.'(___1417, '[]'))))), ','('='(___1417, '$module'(___1418, ___1419, _)), ','('='('.'(___1420, ___1421), ___1419), ','('setarg'(1, ___1419, '<module>:emop.compile@24'('env'(___1417, _Goals, _Vars, ___818))), 'setarg'(2, ___1419, '.'(___1420, ___1421))))))), ','('g_read'('data.list', '<module>:data.list'(___1423)), '<module>:data.list:iter$direct'(_Goals, ___1417, ___1423))), 'call'('emop_toplevel_goal_init'(_Vars)))).
':-'('<module>:emop.compile@12:do$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@12:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@13'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@13:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@13'('do'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@13:do'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@13'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.compile@13$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.compile@13$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.compile@13$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.compile@13$has_predicate'('do'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.compile@13:$sgn'(__36sgn, 'env'(___853, _SgnVars, _Pos, _ExpandFile, _VarTerm), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl',26859,836,26799)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl',26954,836,26799)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.compile@13:atom_fresh_[2528]'(_atom__fresh___912529_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___912529_93, '[]'))))))).
':-'('<module>:emop.compile@13:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@13:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@13:atom_fresh_[2528]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 3, predicate, suspended([none,none,none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.compile@13:do'('import'(_H, _S, _Goal), 's'(_ClauseList, _Acc, _Counter, _Scope, _Vars), 's'('.'('clause'(_F, 1, '.'(_VarTerm, '[]'), _Goal), _ClauseList), '.'(_F, _Acc), ___1411, '.'(___1413, _Scope), _NewVars), 'env'(___853, _SgnVars, _Pos, _ExpandFile, _VarTerm), __36CutLevel), ','(','(','('='(_F, ___1398), ','('g_read'('data.atom', '<module>:data.atom'(___1399)), '<module>:data.atom:format$direct'('emop_toplevel_goal_init~d', '.'(_Counter, '[]'), ___1398, ___1399))), ';'('->'('='(_H, 'var'(_HV)), ','(','('='(___1401, _S), 'emop_call'(_SgnVars, '{}'(_HV, ___1401), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 844, from character 26 to 27')), ';'('->'(','('g_read'('data.list', '<module>:data.list'(___1403)), '<module>:data.list:member$direct'(_HV, _Vars, ___1403)), '='(_NewVars, _Vars)), '='(_NewVars, '.'(_HV, _Vars))))), '='(_NewVars, _Vars))), ','('g_read'('data.number', '<module>:data.number'(___1412)), ','('<module>:data.number:succ$direct'(_Counter, ___1411, ___1412), 'emop_call'(_ExpandFile, 'get_scope'(_H, _Pos, _SgnVars, _Scope, ___1413), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 864, from character 28 to 37'))))).
':-'('<module>:emop.compile@13:do$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@13:do'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@14'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@14:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@14'('do'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@14:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@14'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.compile@14$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.compile@14$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.compile@14$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.compile@14$has_predicate'('do'(_____2, _____1)), 'true').
':-'('<module>:emop.compile@14:$sgn'(__36sgn, 'env'(___862, _InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef, _Ast, _Clauses, _Clauses0, _Dependencies, _ExpandFile, _ExternVars, _Fid, _FidPos, _FilenamePl, _Goals, _Inits, _M, _ModuleList, _NewScope, _NewVars, _Pb, _Pe, _Pos, _Scope, _Sgn, _SgnVars, _Update, _VarTerm, _VarVars, _Wam), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl',27893,867,27853)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl',27898,867,27853)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.compile@14:atom_fresh_[2516]'(_atom__fresh___912517_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___912517_93, '[]'))))))).
':-'('<module>:emop.compile@14:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@14:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@14:atom_fresh_[2516]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 2, predicate, suspended([var('A'),var('B')],[call(scope,f,[none,var('A'),none,var('B'),none])]), __36pos))).
':-'('<module>:emop.compile@14:do'(___819, ___820, 'env'(___862, _InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef, _Ast, _Clauses, _Clauses0, _Dependencies, _ExpandFile, _ExternVars, _Fid, _FidPos, _FilenamePl, _Goals, _Inits, _M, _ModuleList, _NewScope, _NewVars, _Pb, _Pe, _Pos, _Scope, _Sgn, _SgnVars, _Update, _VarTerm, _VarVars, _Wam), __36CutLevel), '='(___820, 'var'(___819))).
':-'('<module>:emop.compile@14:do$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@14:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@15'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@15:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@15'('do'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@15:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@15'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.compile@15$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.compile@15$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.compile@15$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.compile@15$has_predicate'('do'(_____1)), 'true').
':-'('<module>:emop.compile@15:$sgn'(__36sgn, 'env'(___883, _Inits, _Goals), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl',28202,874,28196)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl',28227,874,28196)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.compile@15:atom_fresh_[2471]'(_atom__fresh___912472_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___912472_93, '[]'))))))).
':-'('<module>:emop.compile@15:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@15:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@15:atom_fresh_[2471]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.compile@15:do'(_Params, 'env'(___883, _Inits, _Goals), __36CutLevel), ','(','(','('true', ';'('->'('var'(___1370), ','('g_inc'('$module_count', ___1371), '='(___1370, '$module'(___1371, '.'('<module>:emop.compile@22'('env'(___1370, _Inits, _Goals, _Params, ___883)), '[]'), '.'(___1370, '[]'))))), ','('='(___1370, '$module'(___1371, ___1372, _)), ','('='('.'(___1373, ___1374), ___1372), ','('setarg'(1, ___1372, '<module>:emop.compile@22'('env'(___1370, _Inits, _Goals, _Params, ___883))), 'setarg'(2, ___1372, '.'(___1373, ___1374))))))), ','('g_read'('data.list', '<module>:data.list'(___1376)), '<module>:data.list:iter$direct'(_Goals, ___1370, ___1376))), ','(','('true', ';'('->'('var'(___1378), ','('g_inc'('$module_count', ___1379), '='(___1378, '$module'(___1379, '.'('<module>:emop.compile@23'('env'(___1378, _Inits, _Goals, _Params, ___883)), '[]'), '.'(___1378, '[]'))))), ','('='(___1378, '$module'(___1379, ___1380, _)), ','('='('.'(___1381, ___1382), ___1380), ','('setarg'(1, ___1380, '<module>:emop.compile@23'('env'(___1378, _Inits, _Goals, _Params, ___883))), 'setarg'(2, ___1380, '.'(___1381, ___1382))))))), ','('g_read'('data.list', '<module>:data.list'(___1384)), '<module>:data.list:iter$direct'(_Inits, ___1378, ___1384))))).
':-'('<module>:emop.compile@15:do$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@15:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@16'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@16:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@16'('compare'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@16:compare'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@16'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.compile@16$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.compile@16$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.compile@16$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.compile@16$has_predicate'('compare'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.compile@16:$sgn'(__36sgn, 'env'(___890), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl',28589,887,28555)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl',28613,887,28555)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.compile@16:atom_fresh_[2451]'(_atom__fresh___912452_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___912452_93, '[]'))))))).
':-'('<module>:emop.compile@16:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@16:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@16:atom_fresh_[2451]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(compare, 3, predicate, '[]', __36pos))).
':-'('<module>:emop.compile@16:compare'('directive'(_), 'clause'(_, _, _, _), '<', 'env'(___890), __36CutLevel), ','('true', ','('='(__36CutLevel, '$cut'), '!'))).
':-'('<module>:emop.compile@16:compare'('clause'(_, _, _, _), 'directive'(_), '>', 'env'(___890), __36CutLevel), ','('true', ','('='(__36CutLevel, '$cut'), '!'))).
':-'('<module>:emop.compile@16:compare'('directive'(_), 'directive'(_), '=', 'env'(___890), __36CutLevel), ','('true', ','('='(__36CutLevel, '$cut'), '!'))).
':-'('<module>:emop.compile@16:compare'('clause'(_AF, _AN, _, _), 'clause'(_BF, _BN, _, _), _R, 'env'(___890), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','('g_read'('data.term', '<module>:data.term'(___1368)), '<module>:data.term:compare$direct'(','(_AF, _AN), ','(_BF, _BN), _R, ___1368)))).
':-'('<module>:emop.compile@16:compare$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@16:compare'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@17'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@17:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@17'('do'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@17:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@17'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.compile@17$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.compile@17$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.compile@17$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.compile@17$has_predicate'('do'(_____2, _____1)), 'true').
':-'('<module>:emop.compile@17:$sgn'(__36sgn, 'env'(___899), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl',28972,895,28939)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl',28996,895,28939)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.compile@17:atom_fresh_[2437]'(_atom__fresh___912438_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___912438_93, '[]'))))))).
':-'('<module>:emop.compile@17:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@17:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@17:atom_fresh_[2437]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.compile@17:do'('clause'(_F, _, _Args, _B), _R, 'env'(___899), __36CutLevel), '='(_R, 'callable'(':-', '.'('callable'(_F, _Args), '.'(_B, '[]'))))).
':-'('<module>:emop.compile@17:do'('directive'(_X), 'callable'(':-', '.'(_X, '[]')), 'env'(___899), __36CutLevel), 'true').
':-'('<module>:emop.compile@17:do$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@17:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@18'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@18:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@18'('queue'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@18:queue'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@18'('dequeue'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@18:dequeue'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@18'('compile_all', __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@18:compile_all'(__36env, __36CutLevel))).
':-'('<module>:emop.compile@18'('runtime_error'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@18:runtime_error'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@18'('protect_goal'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@18:protect_goal'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@18'('generate_link'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@18:generate_link'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@18'('add_link_deps'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@18:add_link_deps'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@18'('compile'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@18:compile'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@18'('recompile'(_____10, _____9, _____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@18:recompile'(_____10, _____9, _____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@18'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.compile@18$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.compile@18$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.compile@18$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.compile@18$has_predicate'('queue'(_____2, _____1)), 'true').
':-'('<module>:emop.compile@18$has_predicate'('dequeue'(_____2, _____1)), 'true').
':-'('<module>:emop.compile@18$has_predicate'('compile_all'), 'true').
':-'('<module>:emop.compile@18$has_predicate'('runtime_error'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.compile@18$has_predicate'('protect_goal'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.compile@18$has_predicate'('generate_link'(_____2, _____1)), 'true').
':-'('<module>:emop.compile@18$has_predicate'('add_link_deps'(_____2, _____1)), 'true').
':-'('<module>:emop.compile@18$has_predicate'('compile'(_____2, _____1)), 'true').
':-'('<module>:emop.compile@18$has_predicate'('recompile'(_____10, _____9, _____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.compile@18:$init1'('env'(___1005, _Compiler, _MainModRef, _IncludedRef, _QueuedRef, _InitRef, _ModuleListRef, _FidListRef, _PackageNodes, _RootPackagePath, _MakeInitCall, _ObjectFileListRef, _HasWarningRef), __36CutLevel), 'true').
':-'('<module>:emop.compile@18:$sgn'(__36sgn, 'env'(___1005, _Compiler, _MainModRef, _IncludedRef, _QueuedRef, _InitRef, _ModuleListRef, _FidListRef, _PackageNodes, _RootPackagePath, _MakeInitCall, _ObjectFileListRef, _HasWarningRef), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl',31886,992,31880)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl',32182,1005,32173)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','(','(','(','(','(','(','('true', '<module>:emop.compile@18:atom_fresh_[2321]'(_atom__fresh___912322_93, __36Pb, __36Pe)), '<module>:emop.compile@18:atom_fresh_[2323]'(_atom__fresh___912324_93, __36Pb, __36Pe)), '<module>:emop.compile@18:atom_fresh_[2325]'(_atom__fresh___912326_93, __36Pb, __36Pe)), '<module>:emop.compile@18:atom_fresh_[2327]'(_atom__fresh___912328_93, __36Pb, __36Pe)), '<module>:emop.compile@18:atom_fresh_[2329]'(_atom__fresh___912330_93, __36Pb, __36Pe)), '<module>:emop.compile@18:atom_fresh_[2331]'(_atom__fresh___912332_93, __36Pb, __36Pe)), '<module>:emop.compile@18:atom_fresh_[2333]'(_atom__fresh___912334_93, __36Pb, __36Pe)), '<module>:emop.compile@18:atom_fresh_[2335]'(_atom__fresh___912336_93, __36Pb, __36Pe)), '<module>:emop.compile@18:atom_fresh_[2337]'(_atom__fresh___912338_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___912338_93, '.'(_atom__fresh___912336_93, '.'(_atom__fresh___912334_93, '.'(_atom__fresh___912332_93, '.'(_atom__fresh___912330_93, '.'(_atom__fresh___912328_93, '.'(_atom__fresh___912326_93, '.'(_atom__fresh___912324_93, '.'(_atom__fresh___912322_93, '[]'))))))))))))))).
':-'('<module>:emop.compile@18:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@18:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@18:add_link_deps'(_FilenameMpl, _LinkDeps, 'env'(___1005, _Compiler, _MainModRef, _IncludedRef, _QueuedRef, _InitRef, _ModuleListRef, _FidListRef, _PackageNodes, _RootPackagePath, _MakeInitCall, _ObjectFileListRef, _HasWarningRef), __36CutLevel), ','(','('true', ';'('->'('var'(___1222), ','('g_inc'('$module_count', ___1223), '='(___1222, '$module'(___1223, '.'('<module>:emop.compile@20'('env'(___1222, _Compiler, _MainModRef, _IncludedRef, _QueuedRef, _InitRef, _ModuleListRef, _FidListRef, _PackageNodes, _RootPackagePath, _MakeInitCall, _ObjectFileListRef, _HasWarningRef, _FilenameMpl, _LinkDeps, ___1005)), '[]'), '.'(___1222, '[]'))))), ','('='(___1222, '$module'(___1223, ___1224, _)), ','('='('.'(___1225, ___1226), ___1224), ','('setarg'(1, ___1224, '<module>:emop.compile@20'('env'(___1222, _Compiler, _MainModRef, _IncludedRef, _QueuedRef, _InitRef, _ModuleListRef, _FidListRef, _PackageNodes, _RootPackagePath, _MakeInitCall, _ObjectFileListRef, _HasWarningRef, _FilenameMpl, _LinkDeps, ___1005))), 'setarg'(2, ___1224, '.'(___1225, ___1226))))))), ','('g_read'('data.list', '<module>:data.list'(___1228)), '<module>:data.list:iter$direct'(_LinkDeps, ___1222, ___1228)))).
':-'('<module>:emop.compile@18:add_link_deps$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@18:add_link_deps'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@18:atom_fresh_[2321]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(recompile, 10, predicate, '[]', __36pos))).
':-'('<module>:emop.compile@18:atom_fresh_[2323]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(compile, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.compile@18:atom_fresh_[2325]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(add_link_deps, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.compile@18:atom_fresh_[2327]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(generate_link, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.compile@18:atom_fresh_[2329]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(protect_goal, 4, predicate, suspended([var('Msg'),var('Goal'),var('ExitGoal'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.compile@18:atom_fresh_[2331]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(runtime_error, 3, predicate, suspended([var('PrintGoal'),var('ExitGoal'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.compile@18:atom_fresh_[2333]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(compile_all, 0, predicate, [], __36pos))).
':-'('<module>:emop.compile@18:atom_fresh_[2335]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(dequeue, 2, predicate, suspended([var('ModSpec'),var('Pos')],[call(var('QueuedRef'),get,[none]),call(var('QueuedRef'),set,[var('QueuedTail')])]), __36pos))).
':-'('<module>:emop.compile@18:atom_fresh_[2337]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(queue, 2, predicate, suspended([var('ModSpec'),var('Pos')],[call(var('QueuedRef'),get,[var('Queued')]),call(var('QueuedRef'),set,[none])]), __36pos))).
':-'('<module>:emop.compile@18:compile'(_ModSpec, _Pos, 'env'(___1005, _Compiler, _MainModRef, _IncludedRef, _QueuedRef, _InitRef, _ModuleListRef, _FidListRef, _PackageNodes, _RootPackagePath, _MakeInitCall, _ObjectFileListRef, _HasWarningRef), __36CutLevel), ','(','('g_read'('emop.compile', '<module>:emop.compile'(___1229)), '<module>:emop.compile:lookup$direct'(_ModSpec, _Pos, _BaseFilename, _FilenameMpl, _SMpl, ___1229)), ','('emop_call'(_IncludedRef, 'get'(_Included), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1167, from character 24 to 27'), ';'('->'(','('g_read'('data.list', '<module>:data.list'(___1232)), '<module>:data.list:member$direct'(','(_BaseFilename, _Fid), _Included, ___1232)), 'emop_call'(_SMpl, 'close', 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1171, from character 20 to 25')), ','(';'('->'(','('g_read'('emop.compile', '<module>:emop.compile'(___1233)), '<module>:emop.compile:deps$direct'(___1233)), ','('g_read'('io.std', '<module>:io.std'(___1235)), '<module>:io.std:print_endline$direct'(_FilenameMpl, ___1235))), 'true'), ','(';'('->'(','(','('g_read'('emop.compile', '<module>:emop.compile'(___1236)), '<module>:emop.compile:use_cache$direct'(_Pos, ___1236)), ','('g_read'('emop.compile', '<module>:emop.compile'(___1237)), '<module>:emop.compile:read_interface_expand$direct'(_BaseFilename, _FilenameMpl, _Fid, _Deps, _ModuleList, _Sgn, _LinkDeps, _ObjectFilename, _PackageNodes, _RootPackagePath, ___1237))), 'emop_call'(___1005, 'add_link_deps'(_FilenameMpl, _LinkDeps), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1184, from character 18 to 31')), 'emop_call'(___1005, 'recompile'(_BaseFilename, _FilenameMpl, _SMpl, _Fid, _Deps, _ModuleList, _Sgn, _ObjectFilename, _PackageNodes, _RootPackagePath), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1186, from character 18 to 27')), ','(','('='(_ChangedDate, ___1239), ','('g_read'('sys.file', '<module>:sys.file'(___1240)), '<module>:sys.file:last_modification$direct'(_FilenameMpl, ___1239, ___1240))), ','(','('g_read'('emop.sgn', '<module>:emop.sgn'(___1242)), '<module>:emop.sgn:cache$direct'(_FilenameMpl, _ChangedDate, _Sgn, ___1242)), ','('emop_call'(_IncludedRef, 'set'('.'(','(_BaseFilename, _Fid), _Included)), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1190, from character 27 to 30'), ','(','(','('emop_call'(_ModuleListRef, 'get'(___1246), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1191, from character 76 to 79'), ','('g_read'('data.list', '<module>:data.list'(___1248)), '<module>:data.list:append$direct'(_ModuleList, ___1246, ___1247, ___1248))), 'emop_call'(_ModuleListRef, 'set'(___1247), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1191, from character 29 to 32')), ','(','('emop_call'(_FidListRef, 'get'(___1249), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1192, from character 48 to 51'), 'emop_call'(_FidListRef, 'set'('.'(_Fid, ___1249)), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1192, from character 26 to 29')), ','(','(','('true', ';'('->'('var'(___1252), ','('g_inc'('$module_count', ___1253), '='(___1252, '$module'(___1253, '.'('<module>:emop.compile@21'('env'(___1252, _Compiler, _PackageNodes, _RootPackagePath, ___1005)), '[]'), '.'(___1252, '[]'))))), ','('='(___1252, '$module'(___1253, ___1254, _)), ','('='('.'(___1255, ___1256), ___1254), ','('setarg'(1, ___1254, '<module>:emop.compile@21'('env'(___1252, _Compiler, _PackageNodes, _RootPackagePath, ___1005))), 'setarg'(2, ___1254, '.'(___1255, ___1256))))))), ','('g_read'('data.list', '<module>:data.list'(___1258)), '<module>:data.list:iter$direct'(_Deps, ___1252, ___1258))), ','('emop_call'(_SMpl, 'close', 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1204, from character 20 to 25'), ','(';'('->'('='(_Pos, 'cmdline'), 'emop_call'(_MainModRef, 'set'('some'(_Fid, _BaseFilename)), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1208, from character 29 to 32')), 'true'), ','(','('emop_call'(_InitRef, 'get'(___1262), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1212, from character 61 to 64'), 'emop_call'(_InitRef, 'set'('.'('init'(_Fid, _Pos, _Deps), ___1262)), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1212, from character 23 to 26')), ','('emop_call'(_ObjectFileListRef, 'get'(___1264), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1213, from character 73 to 76'), 'emop_call'(_ObjectFileListRef, 'set'('.'(_ObjectFilename, ___1264)), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1213, from character 33 to 36'))))))))))))))))).
':-'('<module>:emop.compile@18:compile$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@18:compile'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@18:compile_all'('env'(___1005, _Compiler, _MainModRef, _IncludedRef, _QueuedRef, _InitRef, _ModuleListRef, _FidListRef, _PackageNodes, _RootPackagePath, _MakeInitCall, _ObjectFileListRef, _HasWarningRef), __36CutLevel), '->'(','('repeat', ';'('->'('emop_call'(___1005, 'dequeue'(_ModId, _Pos), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1019, from character 18 to 25'), ';'('->'('emop_call'(___1005, 'compile'(_ModId, _Pos), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1022, from character 21 to 28'), 'fail'), 'throw'('big problem'))), 'true')), 'true')).
':-'('<module>:emop.compile@18:compile_all$direct'(__36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@18:compile_all'(__36env, __36CutLevel))).
':-'('<module>:emop.compile@18:dequeue'(_ModSpec, _Pos, 'env'(___1005, _Compiler, _MainModRef, _IncludedRef, _QueuedRef, _InitRef, _ModuleListRef, _FidListRef, _PackageNodes, _RootPackagePath, _MakeInitCall, _ObjectFileListRef, _HasWarningRef), __36CutLevel), ','('emop_call'(_QueuedRef, 'get'('.'(','(_ModSpec, _Pos), _QueuedTail)), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1012, from character 22 to 25'), 'emop_call'(_QueuedRef, 'set'(_QueuedTail), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1013, from character 22 to 25'))).
':-'('<module>:emop.compile@18:dequeue$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@18:dequeue'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@18:generate_link'(_MainModId, _LinkObjectFilename, 'env'(___1005, _Compiler, _MainModRef, _IncludedRef, _QueuedRef, _InitRef, _ModuleListRef, _FidListRef, _PackageNodes, _RootPackagePath, _MakeInitCall, _ObjectFileListRef, _HasWarningRef), __36CutLevel), ','(','('='(_ModInitGoal, ___1120), ','('emop_call'(_InitRef, 'get'(___1119), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1099, from character 53 to 56'), ','('g_read'('emop.compile', '<module>:emop.compile'(___1121)), '<module>:emop.compile:generate_init_goal$direct'(___1119, ___1120, ___1121)))), ','(','('='(_ModuleList, ___1122), 'emop_call'(_ModuleListRef, 'get'(___1122), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1100, from character 39 to 42')), ','(','('='(_Clauses1, ___1123), ','('g_read'('emop.compile', '<module>:emop.compile'(___1124)), '<module>:emop.compile:generate_call_redirect$direct'(_ModuleList, ___1123, ___1124))), ','(','('='(_Clauses0, ___1126), ','('emop_call'(_FidListRef, 'get'(___1125), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1102, from character 50 to 53'), ','('g_read'('emop.compile', '<module>:emop.compile'(___1127)), '<module>:emop.compile:generate_static$direct'(___1125, ___1126, ___1127)))), ','(','('='(_Clauses, ___1129), ','('g_read'('data.list', '<module>:data.list'(___1130)), '<module>:data.list:append$direct'(_Clauses0, _Clauses1, ___1129, ___1130))), ','('='(_EmopCallArgs, '.'('var'('mod'), '.'('var'('call'), '.'('var'('pos'), '.'('var'('$CutLevel'), '[]'))))), ','('='(_UnkErr0, 'callable'('unknown_module', '[]')), ','('='(_UnkE, 'callable'('throw', '.'('callable'('error', '.'(_UnkErr0, '.'('var'('pos'), '[]'))), '[]'))), ','('='(_Unk, 'callable'(':-', '.'('callable'('emop_dyn_call_to', _EmopCallArgs), '.'(_UnkE, '[]')))), ','('='(_Dyn, 'callable'(':-', '.'('callable'('emop_call_to', _EmopCallArgs), '.'('callable'('emop_dyn_call_to', _EmopCallArgs), '[]')))), ','('='(_DynCallToDir, 'term'(':-'('dynamic'('/'('emop_dyn_call_to', 4))))), ','(','('='(_All, ___1184), ','('g_read'('data.list', '<module>:data.list'(___1185)), '<module>:data.list:append$direct'('.'(_DynCallToDir, _Clauses), '.'(_Dyn, '.'(_Unk, '[]')), ___1184, ___1185))), ','(','('='(_InitGoal, ___1203), ','(','(','('emop_call'(_IncludedRef, 'get'(___1189), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1132, from character 66 to 69'), 'emop_call'(_MakeInitCall, 'do'(_MainModId, ___1189, ___1190), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1132, from character 40 to 42')), 'emop_call'(___1005, 'protect_goal'('Uncaught ~a', ___1190, 'term'('emop_call'('sys.process', 'exit'(0), 'init')), ___1196), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1130, from character 24 to 36')), 'emop_call'(___1005, 'protect_goal'('Uncaught ~a in initialization', 'callable'(',', '.'(_ModInitGoal, '.'(___1196, '[]'))), 'term'('halt'(1)), ___1203), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1124, from character 15 to 27'))), ','('='(_InitDir, 'callable'(':-', '.'('callable'('initialization', '.'(_InitGoal, '[]')), '[]'))), ','('='(_Mod, '.'(_InitDir, _All)), ','(','('g_read'('io.file', '<module>:io.file'(___1214)), '<module>:io.file:open_write$direct'(_LinkObjectFilename, _FilePl, ___1214)), ','(';'('->'(','('g_read'('emop.writer', '<module>:emop.writer'(___1216)), '<module>:emop.writer:write_clauses$direct'(_FilePl, _Mod, ___1216)), 'true'), 'throw'('write'('failure'))), ','('emop_call'(_FilePl, 'close', 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1149, from character 19 to 24'), ','('emop_call'(_ObjectFileListRef, 'get'(___1219), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1150, from character 74 to 77'), 'emop_call'(_ObjectFileListRef, 'set'('.'(_LinkObjectFilename, ___1219)), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1150, from character 30 to 33'))))))))))))))))))))).
':-'('<module>:emop.compile@18:generate_link$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@18:generate_link'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@18:protect_goal'(_Msg, _Goal, _ExitGoal, 'callable'('catch', '.'('callable'(';', '.'(_Goal, '.'(___1073, '[]'))), '.'('var'('$exc'), '.'(___1113, '[]')))), 'env'(___1005, _Compiler, _MainModRef, _IncludedRef, _QueuedRef, _InitRef, _ModuleListRef, _FidListRef, _PackageNodes, _RootPackagePath, _MakeInitCall, _ObjectFileListRef, _HasWarningRef), __36CutLevel), ','(','(','(','('g_read'('data.atom', '<module>:data.atom'(___1062)), '<module>:data.atom:format$direct'(_Msg, '.'('failure', '[]'), ___1061, ___1062)), ','('g_read'('data.atom', '<module>:data.atom'(___1066)), '<module>:data.atom:format$direct'('[~a]\n', '.'(___1061, '[]'), ___1065, ___1066))), 'emop_call'(___1005, 'runtime_error'('callable'('print', '.'('callable'('user_error', '[]'), '.'('callable'(___1065, '[]'), '[]'))), _ExitGoal, ___1073), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1065, from character 24 to 37')), ','(','(','('g_read'('data.atom', '<module>:data.atom'(___1091)), '<module>:data.atom:format$direct'(_Msg, '.'('exception', '[]'), ___1090, ___1091)), ','('g_read'('data.atom', '<module>:data.atom'(___1095)), '<module>:data.atom:format$direct'('[~a] ~~q\n', '.'(___1090, '[]'), ___1094, ___1095))), 'emop_call'(___1005, 'runtime_error'('callable'('format', '.'('callable'('user_error', '[]'), '.'('callable'(___1094, '[]'), '.'('callable'('.', '.'('var'('$exc'), '.'('callable'('[]', '[]'), '[]'))), '[]')))), _ExitGoal, ___1113), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1078, from character 18 to 31')))).
':-'('<module>:emop.compile@18:protect_goal$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@18:protect_goal'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@18:queue'(_ModSpec, _Pos, 'env'(___1005, _Compiler, _MainModRef, _IncludedRef, _QueuedRef, _InitRef, _ModuleListRef, _FidListRef, _PackageNodes, _RootPackagePath, _MakeInitCall, _ObjectFileListRef, _HasWarningRef), __36CutLevel), ','('emop_call'(_QueuedRef, 'get'(_Queued), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1008, from character 22 to 25'), 'emop_call'(_QueuedRef, 'set'('.'(','(_ModSpec, _Pos), _Queued)), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1009, from character 22 to 25'))).
':-'('<module>:emop.compile@18:queue$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@18:queue'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@18:recompile'(_BaseFilename, _FilenameMpl, _SMpl, _Fid, _Deps, _ModuleList, _Sgn, _ObjectFilename, _PackageNodes, _RootPackagePath, 'env'(___1005, _Compiler, _MainModRef, _IncludedRef, _QueuedRef, _InitRef, _ModuleListRef, _FidListRef, _PackageNodes, _RootPackagePath, _MakeInitCall, _ObjectFileListRef, _HasWarningRef), __36CutLevel), ','(','('g_read'('emop.message', '<module>:emop.message'(___1268)), '<module>:emop.message:reset_warning$direct'(___1268)), ','(','('g_read'('emop.compile', '<module>:emop.compile'(___1272)), '<module>:emop.compile:log$direct'('Processing \'~a\'...\n', '.'(_FilenameMpl, '[]'), ___1272)), ','(','('='(_Ast, ___1275), ','('g_read'('emop.parser', '<module>:emop.parser'(___1276)), '<module>:emop.parser:parse_file$direct'(_FilenameMpl, _SMpl, 'emop.sgn', ___1275, ___1276))), ','(';'('->'(','('g_read'('emop.compile', '<module>:emop.compile'(___1277)), '<module>:emop.compile:find_fid$direct'(_Ast, _Fid, _FidPos, ___1277)), 'true'), 'throw'('error'('No file module', 'file'(_FilenameMpl)))), ','(','('g_read'('data.atom', '<module>:data.atom'(___1283)), '<module>:data.atom:concat$direct'(_BaseFilename, '.xml', _FilenameXml, ___1283)), ','(','('g_read'('io.file', '<module>:io.file'(___1285)), '<module>:io.file:open_write$direct'(_FilenameXml, _FileXml, ___1285)), ','('emop_call'(_FileXml, 'print_endline'('<?xml version=\"1.0\"?>'), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1231, from character 20 to 33'), ','('emop_call'(_FileXml, 'print_endline'('<!DOCTYPE file PUBLIC \"-//INRIA//DTD EMoP Documentation//EN\" \"http://contraintes.inria.fr/emop/doc.dtd\">'), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1232, from character 20 to 33'), ','('emop_call'(_FileXml, 'print_endline'('<file xmlns=\"http://contraintes.inria.fr/emop/doc\">'), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1233, from character 20 to 33'), ','(','('g_read'('emop.compile', '<module>:emop.compile'(___1289)), '<module>:emop.compile:split_fid$direct'(_Fid, _FidPos, _BaseFilename, _PackageNodes, _RootPackagePath, ___1289)), ','(','('='(_FreeVars, ___1291), ','('g_read'('emop.parse', '<module>:emop.parse'(___1292)), '<module>:emop.parse:fv$direct'(_Ast, ___1291, ___1292))), ','(','('='(_SgnVars, ___1294), ','('g_read'('data.record', '<module>:data.record'(___1295)), '<module>:data.record:{}$direct'(___1294, ___1295))), ','(','('='(_Dependencies, ___1297), ','('g_read'('emop.expand', '<module>:emop.expand'(___1298)), '<module>:emop.expand:fresh_dependencies$direct'(_PackageNodes, _RootPackagePath, ___1297, ___1298))), ','(','('g_read'('emop.compile', '<module>:emop.compile'(___1299)), '<module>:emop.compile:initial_scope$direct'(_Dependencies, _Scope, ___1299)), ','(';'('->'(','(','('g_read'('emop.expand', '<module>:emop.expand'(___1302)), '<module>:emop.expand:expand_file$direct'(_Fid, _Sgn, _FilenameMpl, _FileXml, _Dependencies, ___1301, ___1302)), ','(','('='(_Goal, ___1304), 'emop_call'(___1301, 'expand_goal'(_Ast, _Scope, _SgnVars, _FreeVars, 'singleton_warning', ___1304), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1244, from character 21 to 32')), 'emop_call'(___1301, 'close'(_ModuleList, _Clauses0), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1245, from character 18 to 23'))), 'true'), 'throw'('error'('expand_error'))), ','(','('='(_Deps, ___1307), 'emop_call'(_Dependencies, 'get'(___1307), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1252, from character 32 to 35')), ','(','('='(_ExpandDeps, ___1308), 'emop_call'(_Dependencies, 'get_expand'(___1308), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1253, from character 38 to 48')), ','(','('='(_LinkDeps, ___1309), 'emop_call'(_Dependencies, 'get_link'(___1309), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1254, from character 36 to 44')), ','(','('g_read'('data.atom', '<module>:data.atom'(___1312)), '<module>:data.atom:concat$direct'(_Fid, '@init', _InitF, ___1312)), ','('='(_Clauses, '.'('clause'(_InitF, 0, '[]', _Goal), _Clauses0)), ','('emop_call'(_FileXml, 'print_endline'('</file>'), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1257, from character 20 to 33'), ','('emop_call'(_FileXml, 'close', 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1258, from character 20 to 25'), ','(','('='(_FilenameMpi, ___1317), ','('g_read'('emop.compile', '<module>:emop.compile'(___1318)), '<module>:emop.compile:filename_mpi$direct'(_BaseFilename, _Fid, ___1317, ___1318))), ','(','('g_read'('io.file', '<module>:io.file'(___1320)), '<module>:io.file:open_write$direct'(_FilenameMpi, _FileMpi, ___1320)), ','('emop_call'(_FileMpi, 'format'('~q.\n', '.'('interface'(_Fid, _ExpandDeps, _Deps, _LinkDeps, _ModuleList, _Sgn), '[]')), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1261, from character 20 to 26'), ','('emop_call'(_FileMpi, 'close', 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1262, from character 20 to 25'), ','('emop_call'(___1005, 'add_link_deps'(_FilenameMpl, _LinkDeps), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1263, from character 12 to 25'), ','(';'('->'(','('g_read'('emop.message', '<module>:emop.message'(___1326)), '<module>:emop.message:has_warning$direct'(___1326)), 'emop_call'(_HasWarningRef, 'set'('true'), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1267, from character 29 to 32')), 'true'), ';'('->'(','(','('g_read'('emop.message', '<module>:emop.message'(___1329)), '<module>:emop.message:has_warning$direct'(___1329)), ','('g_read'('emop.compile', '<module>:emop.compile'(___1330)), '<module>:emop.compile:do_not_build_with_warning$direct'(___1330))), 'true'), ','('g_read'('emop.compile', '<module>:emop.compile'(___1331)), '<module>:emop.compile:generate_object_file$direct'(_Clauses, _BaseFilename, _Fid, _ObjectFilename, ___1331)))))))))))))))))))))))))))))))).
':-'('<module>:emop.compile@18:recompile$direct'(_____10, _____9, _____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@18:recompile'(_____10, _____9, _____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@18:runtime_error'(_PrintGoal, _ExitGoal, 'callable'(',', '.'(_PrintGoal, '.'(_ExitGoal, '[]'))), 'env'(___1005, _Compiler, _MainModRef, _IncludedRef, _QueuedRef, _InitRef, _ModuleListRef, _FidListRef, _PackageNodes, _RootPackagePath, _MakeInitCall, _ObjectFileListRef, _HasWarningRef), __36CutLevel), 'true').
':-'('<module>:emop.compile@18:runtime_error$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@18:runtime_error'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@19'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@19:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@19'('do'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@19:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@19'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.compile@19$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.compile@19$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.compile@19$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.compile@19$has_predicate'('do'(_____1)), 'true').
':-'('<module>:emop.compile@19:$sgn'(__36sgn, 'env'(___1027, _Compiler), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl',42233,1282,42217)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl',42267,1282,42217)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.compile@19:atom_fresh_[2319]'(_atom__fresh___912320_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___912320_93, '[]'))))))).
':-'('<module>:emop.compile@19:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@19:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@19:atom_fresh_[2319]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 1, predicate, suspended([var('Module')],[call(var('Compiler'),queue,[var('Module'),none])]), __36pos))).
':-'('<module>:emop.compile@19:do'(_Module, 'env'(___1027, _Compiler), __36CutLevel), 'emop_call'(_Compiler, 'queue'(_Module, 'cmdline'), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1285, from character 21 to 26')).
':-'('<module>:emop.compile@19:do$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@19:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@1:$sgn'(__36sgn, 'env'(___231, _InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef, _FilenameWam, _FilenameWamPatched, _NewFile, _OriginalFile, _Patcher), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl',8001,226,7967)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl',8009,226,7967)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.compile@1:atom_fresh_[2734]'(_atom__fresh___912735_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___912735_93, '[]'))))))).
':-'('<module>:emop.compile@1:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@1:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@1:atom_fresh_[2734]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 3, predicate, '[]', __36pos))).
':-'('<module>:emop.compile@1:do'('.'('get_atom'('$cut', _R), '.'('cut'(_), _Tail)), '.'('cut'('x'(_R)), '[]'), _Tail, 'env'(___231, _InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef, _FilenameWam, _FilenameWamPatched, _NewFile, _OriginalFile, _Patcher), __36CutLevel), 'true').
':-'('<module>:emop.compile@1:do'('.'('cut'(_V), '.'('put_atom'('$cut', _R), _Tail)), '.'('put_value'(_V, _R), '[]'), _Tail, 'env'(___231, _InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef, _FilenameWam, _FilenameWamPatched, _NewFile, _OriginalFile, _Patcher), __36CutLevel), 'true').
':-'('<module>:emop.compile@1:do$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@1:do'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@2'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@2:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@2'('do'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@2:do'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@2'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.compile@2$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.compile@2$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.compile@2$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.compile@2$has_predicate'('do'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.compile@20'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@20:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@20'('do'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@20:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@20'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.compile@20$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.compile@20$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.compile@20$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.compile@20$has_predicate'('do'(_____1)), 'true').
':-'('<module>:emop.compile@20:$sgn'(__36sgn, 'env'(___1227, _Compiler, _MainModRef, _IncludedRef, _QueuedRef, _InitRef, _ModuleListRef, _FidListRef, _PackageNodes, _RootPackagePath, _MakeInitCall, _ObjectFileListRef, _HasWarningRef, _FilenameMpl, _LinkDeps, ___1005), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl',37091,1152,37069)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl',37107,1152,37069)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.compile@20:atom_fresh_[2420]'(_atom__fresh___912421_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___912421_93, '[]'))))))).
':-'('<module>:emop.compile@20:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@20:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@20:atom_fresh_[2420]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.compile@20:do'(_Filename, 'env'(___1227, _Compiler, _MainModRef, _IncludedRef, _QueuedRef, _InitRef, _ModuleListRef, _FidListRef, _PackageNodes, _RootPackagePath, _MakeInitCall, _ObjectFileListRef, _HasWarningRef, _FilenameMpl, _LinkDeps, ___1005), __36CutLevel), ','(','('='(_FullFilename, ___1338), ','(','('g_read'('data.path', '<module>:data.path'(___1337)), '<module>:data.path:base$direct'(_FilenameMpl, ___1336, ___1337)), ','('g_read'('data.path', '<module>:data.path'(___1339)), '<module>:data.path:concat$direct'(___1336, _Filename, ___1338, ___1339)))), ','('emop_call'(_ObjectFileListRef, 'get'(___1340), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1156, from character 74 to 77'), 'emop_call'(_ObjectFileListRef, 'set'('.'(_FullFilename, ___1340)), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1156, from character 36 to 39')))).
':-'('<module>:emop.compile@20:do$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@20:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@21'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@21:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@21'('do'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@21:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@21'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.compile@21$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.compile@21$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.compile@21$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.compile@21$has_predicate'('do'(_____1)), 'true').
':-'('<module>:emop.compile@21:$sgn'(__36sgn, 'env'(___1257, _Compiler, _PackageNodes, _RootPackagePath, ___1005), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl',38663,1192,38638)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl',38788,1196,38770)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.compile@21:atom_fresh_[2407]'(_atom__fresh___912408_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___912408_93, '[]'))))))).
':-'('<module>:emop.compile@21:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@21:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@21:atom_fresh_[2407]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 1, predicate, suspended([none],[call(var('Compiler'),queue,[none,var('Pos')])]), __36pos))).
':-'('<module>:emop.compile@21:do'('dep'(_Dependency, _Pos), 'env'(___1257, _Compiler, _PackageNodes, _RootPackagePath, ___1005), __36CutLevel), 'emop_call'(_Compiler, 'queue'('name'(_Dependency, _PackageNodes, _RootPackagePath), _Pos), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1199, from character 30 to 35')).
':-'('<module>:emop.compile@21:do$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@21:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@22'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@22:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@22'('do'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@22:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@22'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.compile@22$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.compile@22$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.compile@22$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.compile@22$has_predicate'('do'(_____1)), 'true').
':-'('<module>:emop.compile@22:$sgn'(__36sgn, 'env'(___1375, _Inits, _Goals, _Params, ___883), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl',28273,876,28251)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl',28286,876,28251)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.compile@22:atom_fresh_[2504]'(_atom__fresh___912505_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___912505_93, '[]'))))))).
':-'('<module>:emop.compile@22:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@22:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@22:atom_fresh_[2504]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 1, predicate, suspended([var('Goal')],[call(atom(top),call,[var('Goal')])]), __36pos))).
':-'('<module>:emop.compile@22:do'(_Goal, 'env'(___1375, _Inits, _Goals, _Params, ___883), __36CutLevel), 'call'(_Goal)).
':-'('<module>:emop.compile@22:do$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@22:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@23'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@23:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@23'('do'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@23:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@23'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.compile@23$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.compile@23$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.compile@23$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.compile@23$has_predicate'('do'(_____1)), 'true').
':-'('<module>:emop.compile@23:$sgn'(__36sgn, 'env'(___1383, _Inits, _Goals, _Params, ___883), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl',28385,880,28363)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl',28398,880,28363)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.compile@23:atom_fresh_[2489]'(_atom__fresh___912490_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___912490_93, '[]'))))))).
':-'('<module>:emop.compile@23:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@23:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@23:atom_fresh_[2489]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 1, predicate, suspended([var('F')],[call(atom(top),call,[none])]), __36pos))).
':-'('<module>:emop.compile@23:do'(_F, 'env'(___1383, _Inits, _Goals, _Params, ___883), __36CutLevel), ','(','('g_read'('data.term', '<module>:data.term'(___1390)), '<module>:data.term:make$direct'(_F, '.'(_Params, '[]'), ___1389, ___1390)), 'call'(___1389))).
':-'('<module>:emop.compile@23:do$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@23:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@24'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@24:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@24'('do'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@24:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@24'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.compile@24$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.compile@24$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.compile@24$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.compile@24$has_predicate'('do'(_____1)), 'true').
':-'('<module>:emop.compile@24:$sgn'(__36sgn, 'env'(___1422, _Goals, _Vars, ___818), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl',25944,808,25922)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl',25957,808,25922)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.compile@24:atom_fresh_[2558]'(_atom__fresh___912559_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___912559_93, '[]'))))))).
':-'('<module>:emop.compile@24:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@24:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@24:atom_fresh_[2558]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 1, predicate, suspended([var('Goal')],[call(atom(top),call,[var('Goal')])]), __36pos))).
':-'('<module>:emop.compile@24:do'(_Goal, 'env'(___1422, _Goals, _Vars, ___818), __36CutLevel), 'call'(_Goal)).
':-'('<module>:emop.compile@24:do$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@24:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@25'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@25:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@25'('do'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@25:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@25'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.compile@25$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.compile@25$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.compile@25$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.compile@25$has_predicate'('do'(_____1)), 'true').
':-'('<module>:emop.compile@25:$sgn'(__36sgn, 'env'(___1503, _InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef, _InitGoal, _InitGoalRef, _InitList, _InitializedRef, _Deps, _Fid, _Initialized, ___571), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl',17692,539,17667)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl',17704,539,17667)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.compile@25:atom_fresh_[2652]'(_atom__fresh___912653_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___912653_93, '[]'))))))).
':-'('<module>:emop.compile@25:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@25:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@25:atom_fresh_[2652]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.compile@25:do'('dep'(_Dependency, _), 'env'(___1503, _InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef, _InitGoal, _InitGoalRef, _InitList, _InitializedRef, _Deps, _Fid, _Initialized, ___571), __36CutLevel), '->'(','('g_read'('data.list', '<module>:data.list'(___1509)), '<module>:data.list:member$direct'('init'(_Dependency, _Pos, _Deps_39), _InitList, ___1509)), ';'('->'('\\='(_Pos, 'cmdline'), 'emop_call'(___571, 'add_recursive'(_Dependency, _Deps_39), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 548, from character 27 to 40')), 'true'))).
':-'('<module>:emop.compile@25:do$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@25:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@2:$sgn'(__36sgn, 'env'(___242, _InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl',8529,247,8506)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl',8537,247,8506)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.compile@2:atom_fresh_[2722]'(_atom__fresh___912723_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___912723_93, '[]'))))))).
':-'('<module>:emop.compile@2:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@2:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@2:atom_fresh_[2722]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 3, predicate, suspended([var('MainModId'),var('_'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.compile@2:do'(_MainModId, _, 'callable'('emop_call', '.'('callable'(_MainModId, '[]'), '.'('callable'('main', '[]'), '.'('callable'('initialization', '[]'), '[]')))), 'env'(___242, _InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel), 'true').
':-'('<module>:emop.compile@2:do$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@2:do'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@3'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@3:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@3'('do'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@3:do'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@3'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.compile@3$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.compile@3$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.compile@3$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.compile@3$has_predicate'('do'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.compile@3:$sgn'(__36sgn, 'env'(___268, _InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef, _MakeInitCall, _Modules, _ObjectFileList, ___Output, ___TempOutput), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl',9582,285,9576)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl',9603,285,9576)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.compile@3:atom_fresh_[2710]'(_atom__fresh___912711_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___912711_93, '[]'))))))).
':-'('<module>:emop.compile@3:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@3:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@3:atom_fresh_[2710]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 3, predicate, suspended([var('_'),var('_'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.compile@3:do'(_, _, 'callable'('true', '[]'), 'env'(___268, _InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef, _MakeInitCall, _Modules, _ObjectFileList, ___Output, ___TempOutput), __36CutLevel), 'true').
':-'('<module>:emop.compile@3:do$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@3:do'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@4'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@4:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@4'('do'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@4:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@4'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.compile@4$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.compile@4$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.compile@4$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.compile@4$has_predicate'('do'(_____1)), 'true').
':-'('<module>:emop.compile@4:$sgn'(__36sgn, 'env'(___280, _InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef, _MakeInitCall, _Modules, _ObjectFileList, ___Output, ___TempOutput), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl',9745,289,9729)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl',9783,289,9729)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.compile@4:atom_fresh_[2696]'(_atom__fresh___912697_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___912697_93, '[]'))))))).
':-'('<module>:emop.compile@4:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@4:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@4:atom_fresh_[2696]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 1, predicate, suspended([var('Object')],[call(atom('io.std'),format,[none,none])]), __36pos))).
':-'('<module>:emop.compile@4:do'(_Object, 'env'(___280, _InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef, _MakeInitCall, _Modules, _ObjectFileList, ___Output, ___TempOutput), __36CutLevel), ','('g_read'('io.std', '<module>:io.std'(___1529)), '<module>:io.std:format$direct'('~a ', '.'(_Object, '[]'), ___1529))).
':-'('<module>:emop.compile@4:do$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@4:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@5'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@5:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@5'('do'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@5:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@5'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.compile@5$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.compile@5$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.compile@5$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.compile@5$has_predicate'('do'(_____2, _____1)), 'true').
':-'('<module>:emop.compile@5:$sgn'(__36sgn, 'env'(___485), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl',14950,454,14944)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl',14968,454,14944)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.compile@5:atom_fresh_[2680]'(_atom__fresh___912681_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___912681_93, '[]'))))))).
':-'('<module>:emop.compile@5:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@5:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@5:atom_fresh_[2680]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.compile@5:do'('.', '/', 'env'(___485), __36CutLevel), ','('true', ','('='(__36CutLevel, '$cut'), '!'))).
':-'('<module>:emop.compile@5:do'('/', _, 'env'(___485), __36CutLevel), 'fail').
':-'('<module>:emop.compile@5:do'(_C, _C, 'env'(___485), __36CutLevel), 'true').
':-'('<module>:emop.compile@5:do$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@5:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@6'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@6:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@6'('do'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@6:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@6'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.compile@6$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.compile@6$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.compile@6$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.compile@6$has_predicate'('do'(_____1)), 'true').
':-'('<module>:emop.compile@6:$sgn'(__36sgn, 'env'(___537, _InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef, _BaseFilename, _Deps, _ExpandDeps, _Fid, _FilenameMpl, _LinkDeps, _ModuleList, _MpiChange, _ObjectFilename, _PackageNodes, _RootPackagePath, _Sgn), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl',16040,485,16024)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl',16058,485,16024)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.compile@6:atom_fresh_[2664]'(_atom__fresh___912665_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___912665_93, '[]'))))))).
':-'('<module>:emop.compile@6:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@6:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@6:atom_fresh_[2664]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.compile@6:do'(_Mod, 'env'(___537, _InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef, _BaseFilename, _Deps, _ExpandDeps, _Fid, _FilenameMpl, _LinkDeps, _ModuleList, _MpiChange, _ObjectFilename, _PackageNodes, _RootPackagePath, _Sgn), __36CutLevel), ','(','(','('g_read'('emop.compile', '<module>:emop.compile'(___1514)), '<module>:emop.compile:lookup$direct'('name'(_Mod, _PackageNodes, _RootPackagePath), 'none', ___BaseFilename, _Filename, ___1513, ___1514)), 'emop_call'(___1513, 'close', 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 493, from character 14 to 19')), ','('catch'(','('='(_DepChange, ___1516), ','('g_read'('sys.file', '<module>:sys.file'(___1517)), '<module>:sys.file:last_modification$direct'(_Filename, ___1516, ___1517))), 'error'('system_error'(_), _), 'fail'), ','('g_read'('data.term', '<module>:data.term'(___1521)), '<module>:data.term:<$direct'(_DepChange, _MpiChange, ___1521))))).
':-'('<module>:emop.compile@6:do$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@6:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@7'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@7:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@7'('add'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@7:add'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@7'('add_recursive'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@7:add_recursive'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@7'('do'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@7:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@7'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.compile@7$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.compile@7$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.compile@7$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.compile@7$has_predicate'('add'(_____1)), 'true').
':-'('<module>:emop.compile@7$has_predicate'('add_recursive'(_____2, _____1)), 'true').
':-'('<module>:emop.compile@7$has_predicate'('do'(_____1)), 'true').
':-'('<module>:emop.compile@7:$sgn'(__36sgn, 'env'(___571, _InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef, _InitGoal, _InitGoalRef, _InitList, _InitializedRef), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl',17133,520,17117)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl',17157,520,17117)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','('true', '<module>:emop.compile@7:atom_fresh_[2618]'(_atom__fresh___912619_93, __36Pb, __36Pe)), '<module>:emop.compile@7:atom_fresh_[2620]'(_atom__fresh___912621_93, __36Pb, __36Pe)), '<module>:emop.compile@7:atom_fresh_[2622]'(_atom__fresh___912623_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___912623_93, '.'(_atom__fresh___912621_93, '.'(_atom__fresh___912619_93, '[]'))))))))).
':-'('<module>:emop.compile@7:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@7:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@7:add'(_Fid, 'env'(___571, _InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef, _InitGoal, _InitGoalRef, _InitList, _InitializedRef), __36CutLevel), ','(','('emop_call'(_InitGoalRef, 'get'(___1482), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 526, from character 33 to 36'), ','('g_read'('data.atom', '<module>:data.atom'(___1486)), '<module>:data.atom:concat$direct'(_Fid, '@init', ___1485, ___1486))), 'emop_call'(_InitGoalRef, 'set'('callable'(',', '.'(___1482, '.'('callable'(___1485, '[]'), '[]')))), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 523, from character 24 to 27'))).
':-'('<module>:emop.compile@7:add$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@7:add'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@7:add_recursive'(_Fid, _Deps, 'env'(___571, _InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef, _InitGoal, _InitGoalRef, _InitList, _InitializedRef), __36CutLevel), ','(','('='(_Initialized, ___1493), 'emop_call'(_InitializedRef, 'get'(___1493), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 533, from character 41 to 44')), ';'('->'(','('g_read'('data.list', '<module>:data.list'(___1495)), '<module>:data.list:member$direct'(_Fid, _Initialized, ___1495)), 'true'), ','('emop_call'(_InitializedRef, 'set'('.'(_Fid, _Initialized)), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 539, from character 30 to 33'), ','(','(','('true', ';'('->'('var'(___1498), ','('g_inc'('$module_count', ___1499), '='(___1498, '$module'(___1499, '.'('<module>:emop.compile@25'('env'(___1498, _InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef, _InitGoal, _InitGoalRef, _InitList, _InitializedRef, _Deps, _Fid, _Initialized, ___571)), '[]'), '.'(___1498, '[]'))))), ','('='(___1498, '$module'(___1499, ___1500, _)), ','('='('.'(___1501, ___1502), ___1500), ','('setarg'(1, ___1500, '<module>:emop.compile@25'('env'(___1498, _InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef, _InitGoal, _InitGoalRef, _InitList, _InitializedRef, _Deps, _Fid, _Initialized, ___571))), 'setarg'(2, ___1500, '.'(___1501, ___1502))))))), ','('g_read'('data.list', '<module>:data.list'(___1504)), '<module>:data.list:iter$direct'(_Deps, ___1498, ___1504))), 'emop_call'(___571, 'add'(_Fid), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 554, from character 15 to 18')))))).
':-'('<module>:emop.compile@7:add_recursive$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@7:add_recursive'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@7:atom_fresh_[2618]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 1, predicate, suspended([none],[call(scope,add_recursive,[var('Fid'),var('Deps')])]), __36pos))).
':-'('<module>:emop.compile@7:atom_fresh_[2620]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(add_recursive, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.compile@7:atom_fresh_[2622]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(add, 1, predicate, suspended([var('Fid')],[call(var('InitGoalRef'),set,[none])]), __36pos))).
':-'('<module>:emop.compile@7:do'('init'(_Fid, _, _Deps), 'env'(___571, _InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef, _InitGoal, _InitGoalRef, _InitList, _InitializedRef), __36CutLevel), 'emop_call'(___571, 'add_recursive'(_Fid, _Deps), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 558, from character 12 to 25')).
':-'('<module>:emop.compile@7:do$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@7:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@8'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@8:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@8'('do'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@8:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@8'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.compile@8$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.compile@8$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.compile@8$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.compile@8$has_predicate'('do'(_____2, _____1)), 'true').
':-'('<module>:emop.compile@8:$sgn'(__36sgn, 'env'(___600, _InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef, _ModuleList), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl',18790,578,18774)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl',18808,578,18774)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.compile@8:atom_fresh_[2606]'(_atom__fresh___912607_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___912607_93, '[]'))))))).
':-'('<module>:emop.compile@8:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@8:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@8:atom_fresh_[2606]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 2, predicate, suspended([var('LocalId'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.compile@8:do'(_LocalId, 'callable'('emop_static', '.'('callable'(_LocalId, '[]'), '[]')), 'env'(___600, _InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef, _ModuleList), __36CutLevel), 'true').
':-'('<module>:emop.compile@8:do$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@8:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@9'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@9:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@9'('do'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.compile@9:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@9'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.compile@9$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.compile@9$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.compile@9$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.compile@9$has_predicate'('do'(_____2, _____1)), 'true').
':-'('<module>:emop.compile@9:$sgn'(__36sgn, 'env'(___609, _InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef, _ModuleList), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl',18959,584,18943)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl',18977,584,18943)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.compile@9:atom_fresh_[2594]'(_atom__fresh___912595_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___912595_93, '[]'))))))).
':-'('<module>:emop.compile@9:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@9:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.compile@9:atom_fresh_[2594]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 2, predicate, suspended([var('LocalId'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.compile@9:do'(_LocalId, 'callable'(':-', '.'('callable'('emop_call_to', '.'('callable'(_LocalId, '.'('var'('$env'), '[]')), '.'('var'('$f'), '.'('var'('$pos'), '.'('var'('$CutLevel'), '[]'))))), '.'('callable'(',', '.'('callable'('!', '[]'), '.'('callable'(_LocalId, '.'('var'('$f'), '.'('var'('$env'), '.'('var'('$pos'), '.'('var'('$CutLevel'), '[]'))))), '[]'))), '[]'))), 'env'(___609, _InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef, _ModuleList), __36CutLevel), 'true').
':-'('<module>:emop.compile@9:do$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.compile@9:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('emop.compile@init', ','(','('true', ','('g_link'('emop.compile', '<module>:emop.compile'('env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef))), '<module>:emop.compile:$init0'('env'(_InterfaceCacheRef, _ConsultedRef, _HasWarningRef, _TempDir, _BuildDirOptionRef, _UseCacheRef, _DoNotBuildWithWarningRef, _VerboseRef, _DepsRef, _WamPatchRef, _RuntimeRef, _SizeRec, _PrologOptionsRef), __36CutLevel))), ','(','('='(_HasWarningRef, ___6), ','('g_read'('data.ref.non_backtrackable', '<module>:data.ref.non_backtrackable'(___7)), '<module>:data.ref.non_backtrackable:new$direct'('false', ___6, ___7))), ','(','('='(_InterfaceCacheRef, ___10), ','('g_read'('data.ref.non_backtrackable', '<module>:data.ref.non_backtrackable'(___11)), '<module>:data.ref.non_backtrackable:new$direct'('[]', ___10, ___11))), ','(','('='(_ConsultedRef, ___14), ','('g_read'('data.ref.backtrackable', '<module>:data.ref.backtrackable'(___15)), '<module>:data.ref.backtrackable:new$direct'('[]', ___14, ___15))), ','(','('='(_BuildDirOptionRef, ___18), ','('g_read'('data.ref.backtrackable', '<module>:data.ref.backtrackable'(___19)), '<module>:data.ref.backtrackable:new$direct'('none', ___18, ___19))), ','(','('='(_UseCacheRef, ___22), ','('g_read'('data.ref.backtrackable', '<module>:data.ref.backtrackable'(___23)), '<module>:data.ref.backtrackable:new$direct'('always', ___22, ___23))), ','(','('='(_DoNotBuildWithWarningRef, ___26), ','('g_read'('data.ref.backtrackable', '<module>:data.ref.backtrackable'(___27)), '<module>:data.ref.backtrackable:new$direct'('true', ___26, ___27))), ','(','('='(_VerboseRef, ___30), ','('g_read'('data.ref.backtrackable', '<module>:data.ref.backtrackable'(___31)), '<module>:data.ref.backtrackable:new$direct'('false', ___30, ___31))), ','(','('='(_DepsRef, ___34), ','('g_read'('data.ref.backtrackable', '<module>:data.ref.backtrackable'(___35)), '<module>:data.ref.backtrackable:new$direct'('false', ___34, ___35))), ','(','('='(_WamPatchRef, ___38), ','('g_read'('data.ref.backtrackable', '<module>:data.ref.backtrackable'(___39)), '<module>:data.ref.backtrackable:new$direct'('true', ___38, ___39))), ','(','('='(_RuntimeRef, ___41), ','('g_read'('data.ref.backtrackable', '<module>:data.ref.backtrackable'(___42)), '<module>:data.ref.backtrackable:new$direct'(_, ___41, ___42))), ','(','('='(_SizeRec, ___44), ','('g_read'('data.record', '<module>:data.record'(___45)), '<module>:data.record:{}$direct'(___44, ___45))), ','(','('='(___47, ___49), ','('emop_call'(_SizeRec, '{}'('global', ___47), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1317, from character 8 to 9'), ','('g_read'('data.ref.backtrackable', '<module>:data.ref.backtrackable'(___50)), '<module>:data.ref.backtrackable:new$direct'(800000, ___49, ___50)))), ','(','('='(___52, ___54), ','('emop_call'(_SizeRec, '{}'('local', ___52), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1318, from character 8 to 9'), ','('g_read'('data.ref.backtrackable', '<module>:data.ref.backtrackable'(___55)), '<module>:data.ref.backtrackable:new$direct'(100000, ___54, ___55)))), ','(','('='(___57, ___59), ','('emop_call'(_SizeRec, '{}'('cstr', ___57), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1319, from character 8 to 9'), ','('g_read'('data.ref.backtrackable', '<module>:data.ref.backtrackable'(___60)), '<module>:data.ref.backtrackable:new$direct'(20000, ___59, ___60)))), ','(','('='(___62, ___64), ','('emop_call'(_SizeRec, '{}'('trail', ___62), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/compile.mpl\", line 1320, from character 8 to 9'), ','('g_read'('data.ref.backtrackable', '<module>:data.ref.backtrackable'(___65)), '<module>:data.ref.backtrackable:new$direct'(20000, ___64, ___65)))), ','('='(_PrologOptionsRef, ___68), ','('g_read'('data.ref.backtrackable', '<module>:data.ref.backtrackable'(___69)), '<module>:data.ref.backtrackable:new$direct'('[]', ___68, ___69)))))))))))))))))))).
':-'('initialization'('catch'(';'(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','('true', 'emop.syntax@init'), 'kernel@init'), 'data.ref.backtrackable@init'), 'data.var@init'), 'data.number@init'), 'data.term@init'), 'data.list@init'), 'data.string@init'), 'data.atom@init'), 'sys.cmdline@init'), 'io.std@init'), 'io.err@init'), 'data.ref.non_backtrackable@init'), 'emop.message@init'), 'emop.unionfind@init'), 'data.char@init'), 'emop.writer@init'), 'data.record@init'), 'control.iter@init'), 'emop.lexer@init'), 'data.stream@init'), 'io.stream@init'), 'sys.file@init'), 'emop.parser@init'), 'io.file@init'), 'emop.parse@init'), 'emop.sgn@init'), 'data.ref@init'), 'emop.expand@init'), 'io.null@init'), 'sys.env@init'), 'sys.os@init'), 'data.path@init'), 'emop.patch_wam@init'), 'sys.process@init'), 'data.random@init'), 'io.dir@init'), 'emop.compile@init'), 'emop.top@init'), 'emop.emop@init'), 'catch'(';'('emop_call'('emop.emop', 'main', 'initialization'), ','('print'('user_error', '[Uncaught failure]\n'), emop_call('sys.process',exit(0),init))), __36exc, ','('format'('user_error', '[Uncaught exception] ~q\n', '.'(__36exc, '[]')), emop_call('sys.process',exit(0),init)))), ','('print'('user_error', '[Uncaught failure in initialization]\n'), halt(1))), __36exc, ','('format'('user_error', '[Uncaught exception in initialization] ~q\n', '.'(__36exc, '[]')), halt(1))))).
:-dynamic(emop_dyn_call_to/4).
'emop_static'('emop.top').
'emop_static'('io.std').
'emop_static'('emop.writer').
'emop_static'('emop.sgn').
'emop_static'('data.ref').
'emop_static'('emop.unionfind').
'emop_static'('emop.expand').
'emop_static'('control.iter').
'emop_static'('emop.parse').
'emop_static'('emop.lexer').
'emop_static'('emop.parser').
'emop_static'('io.null').
'emop_static'('emop.patch_wam').
'emop_static'('data.path').
'emop_static'('sys.file').
'emop_static'('data.random').
'emop_static'('io.file').
'emop_static'('io.dir').
'emop_static'('data.record').
'emop_static'('emop.compile').
'emop_static'('sys.os').
'emop_static'('data.stream').
'emop_static'('data.char').
'emop_static'('io.stream').
'emop_static'('sys.cmdline').
'emop_static'('sys.env').
'emop_static'('sys.process').
'emop_static'('io.err').
'emop_static'('data.string').
'emop_static'('data.ref.backtrackable').
'emop_static'('data.term').
'emop_static'('data.list').
'emop_static'('data.atom').
'emop_static'('data.number').
'emop_static'('data.ref.non_backtrackable').
'emop_static'('emop.message').
'emop_static'('kernel').
'emop_static'('data.var').
'emop_static'('emop.syntax').
'emop_static'('emop.emop').
':-'('emop_call_to'('<module>:emop.top@7'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.top@7'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.top@6'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.top@6'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.top@5'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.top@5'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.top@4'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.top@4'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.top@3'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.top@3'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.top@2'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.top@2'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.top@1'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.top@1'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.top@0'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.top@0'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.top'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.top'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:io.std@0'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:io.std@0'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:io.std'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:io.std'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.writer@4'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.writer@4'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.writer@3'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.writer@3'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.writer@2'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.writer@2'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.writer@1'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.writer@1'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.writer@0'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.writer@0'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.writer'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.writer'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.sgn@12'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.sgn@12'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.sgn@11'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.sgn@11'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.sgn@10'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.sgn@10'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.sgn@9'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.sgn@9'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.sgn@8'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.sgn@8'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.sgn@7'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.sgn@7'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.sgn@6'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.sgn@6'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.sgn@5'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.sgn@5'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.sgn@4'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.sgn@4'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.sgn@3'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.sgn@3'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.sgn@2'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.sgn@2'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.sgn@1'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.sgn@1'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.sgn@0'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.sgn@0'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.sgn'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.sgn'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:data.ref'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:data.ref'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.unionfind'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.unionfind'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.expand@49'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.expand@49'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.expand@48'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.expand@48'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.expand@47'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.expand@47'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.expand@46'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.expand@46'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.expand@45'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.expand@45'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.expand@44'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.expand@44'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.expand@43'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.expand@43'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.expand@42'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.expand@42'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.expand@41'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.expand@41'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.expand@40'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.expand@40'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.expand@39'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.expand@39'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.expand@38'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.expand@38'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.expand@37'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.expand@37'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.expand@36'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.expand@36'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.expand@35'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.expand@35'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.expand@34'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.expand@34'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.expand@33'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.expand@33'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.expand@32'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.expand@32'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.expand@31'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.expand@31'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.expand@30'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.expand@30'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.expand@29'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.expand@29'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.expand@28'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.expand@28'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.expand@27'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.expand@27'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.expand@26'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.expand@26'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.expand@25'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.expand@25'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.expand@24'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.expand@24'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.expand@23'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.expand@23'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.expand@22'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.expand@22'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.expand@21'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.expand@21'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.expand@20'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.expand@20'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.expand@19'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.expand@19'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.expand@18'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.expand@18'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.expand@17'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.expand@17'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.expand@16'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.expand@16'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.expand@15'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.expand@15'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.expand@14'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.expand@14'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.expand@13'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.expand@13'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.expand@12'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.expand@12'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.expand@11'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.expand@11'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.expand@10'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.expand@10'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.expand@9'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.expand@9'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.expand@8'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.expand@8'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.expand@7'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.expand@7'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.expand@6'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.expand@6'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.expand@5'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.expand@5'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.expand@4'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.expand@4'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.expand@3'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.expand@3'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.expand@2'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.expand@2'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.expand@1'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.expand@1'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.expand@0'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.expand@0'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.expand'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.expand'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:control.iter@0'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:control.iter@0'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:control.iter'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:control.iter'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.parse@4'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.parse@4'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.parse@3'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.parse@3'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.parse@2'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.parse@2'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.parse@1'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.parse@1'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.parse@0'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.parse@0'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.parse'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.parse'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.lexer@15'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.lexer@15'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.lexer@14'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.lexer@14'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.lexer@13'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.lexer@13'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.lexer@12'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.lexer@12'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.lexer@11'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.lexer@11'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.lexer@10'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.lexer@10'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.lexer@9'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.lexer@9'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.lexer@8'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.lexer@8'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.lexer@7'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.lexer@7'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.lexer@6'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.lexer@6'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.lexer@5'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.lexer@5'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.lexer@4'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.lexer@4'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.lexer@3'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.lexer@3'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.lexer@2'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.lexer@2'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.lexer@1'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.lexer@1'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.lexer@0'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.lexer@0'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.lexer'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.lexer'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.parser@18'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.parser@18'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.parser@17'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.parser@17'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.parser@16'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.parser@16'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.parser@15'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.parser@15'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.parser@14'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.parser@14'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.parser@13'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.parser@13'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.parser@12'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.parser@12'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.parser@11'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.parser@11'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.parser@10'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.parser@10'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.parser@9'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.parser@9'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.parser@8'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.parser@8'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.parser@7'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.parser@7'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.parser@6'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.parser@6'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.parser@5'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.parser@5'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.parser@4'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.parser@4'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.parser@3'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.parser@3'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.parser@2'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.parser@2'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.parser@1'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.parser@1'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.parser@0'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.parser@0'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.parser'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.parser'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:io.null'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:io.null'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.patch_wam@0'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.patch_wam@0'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.patch_wam'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.patch_wam'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:data.path@0'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:data.path@0'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:data.path'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:data.path'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:sys.file'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:sys.file'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:data.random'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:data.random'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:io.file'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:io.file'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:io.dir@2'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:io.dir@2'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:io.dir@1'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:io.dir@1'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:io.dir@0'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:io.dir@0'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:io.dir'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:io.dir'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:data.record@2'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:data.record@2'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:data.record@1'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:data.record@1'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:data.record@0'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:data.record@0'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:data.record'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:data.record'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.compile@25'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.compile@25'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.compile@24'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.compile@24'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.compile@23'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.compile@23'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.compile@22'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.compile@22'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.compile@21'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.compile@21'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.compile@20'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.compile@20'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.compile@19'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.compile@19'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.compile@18'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.compile@18'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.compile@17'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.compile@17'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.compile@16'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.compile@16'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.compile@15'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.compile@15'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.compile@14'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.compile@14'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.compile@13'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.compile@13'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.compile@12'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.compile@12'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.compile@11'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.compile@11'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.compile@10'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.compile@10'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.compile@9'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.compile@9'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.compile@8'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.compile@8'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.compile@7'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.compile@7'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.compile@6'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.compile@6'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.compile@5'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.compile@5'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.compile@4'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.compile@4'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.compile@3'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.compile@3'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.compile@2'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.compile@2'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.compile@1'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.compile@1'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.compile@0'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.compile@0'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.compile'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.compile'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:sys.os'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:sys.os'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:data.stream@0'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:data.stream@0'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:data.stream'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:data.stream'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:data.char'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:data.char'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:io.stream@5'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:io.stream@5'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:io.stream@4'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:io.stream@4'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:io.stream@3'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:io.stream@3'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:io.stream@2'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:io.stream@2'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:io.stream@1'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:io.stream@1'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:io.stream@0'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:io.stream@0'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:io.stream'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:io.stream'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:sys.cmdline@5'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:sys.cmdline@5'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:sys.cmdline@4'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:sys.cmdline@4'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:sys.cmdline@3'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:sys.cmdline@3'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:sys.cmdline@2'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:sys.cmdline@2'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:sys.cmdline@1'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:sys.cmdline@1'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:sys.cmdline@0'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:sys.cmdline@0'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:sys.cmdline'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:sys.cmdline'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:sys.env'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:sys.env'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:sys.process@1'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:sys.process@1'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:sys.process@0'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:sys.process@0'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:sys.process'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:sys.process'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:io.err'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:io.err'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:data.string'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:data.string'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:data.ref.backtrackable@0'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:data.ref.backtrackable@0'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:data.ref.backtrackable'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:data.ref.backtrackable'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:data.term'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:data.term'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:data.list@5'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:data.list@5'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:data.list@4'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:data.list@4'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:data.list@3'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:data.list@3'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:data.list@2'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:data.list@2'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:data.list@1'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:data.list@1'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:data.list@0'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:data.list@0'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:data.list'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:data.list'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:data.atom@1'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:data.atom@1'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:data.atom@0'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:data.atom@0'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:data.atom'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:data.atom'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:data.number'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:data.number'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:data.ref.non_backtrackable@0'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:data.ref.non_backtrackable@0'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:data.ref.non_backtrackable'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:data.ref.non_backtrackable'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.message'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.message'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:kernel'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:kernel'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:data.var'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:data.var'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.syntax@7'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.syntax@7'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.syntax@6'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.syntax@6'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.syntax@5'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.syntax@5'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.syntax@4'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.syntax@4'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.syntax@3'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.syntax@3'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.syntax@2'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.syntax@2'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.syntax@1'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.syntax@1'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.syntax@0'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.syntax@0'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.syntax'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.syntax'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.emop@3'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.emop@3'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.emop@2'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.emop@2'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.emop@1'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.emop@1'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.emop@0'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.emop@0'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'('<module>:emop.emop'(__36env), __36f, __36pos, __36CutLevel), ','('!', '<module>:emop.emop'(__36f, __36env, __36pos, __36CutLevel))).
':-'('emop_call_to'(_mod, _call, _pos, __36CutLevel), 'emop_dyn_call_to'(_mod, _call, _pos, __36CutLevel)).
':-'('emop_dyn_call_to'(_mod, _call, _pos, __36CutLevel), 'throw'('error'('unknown_module', _pos))).
':-'('dynamic'('/'('<module>:emop.emop@0$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.emop@1$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.emop@3$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.emop@2$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.emop$dynamic', 4))).
':-'('<module>:emop.emop'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.emop:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.emop'('main', __36env, _, __36CutLevel), ','('!', '<module>:emop.emop:main'(__36env, __36CutLevel))).
':-'('<module>:emop.emop'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.emop$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.emop$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.emop$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.emop$has_predicate'('main'), 'true').
':-'('<module>:emop.emop:$sgn'(__36sgn, 'env'(_Impl), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl',0,0,0)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl',25,0,0)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.emop:atom_fresh_[642]'(_atom__fresh___91643_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___91643_93, '[]'))))))).
':-'('<module>:emop.emop:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.emop:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.emop:atom_fresh_[642]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(main, 0, predicate, [], __36pos))).
':-'('<module>:emop.emop:main'('env'(_Impl), __36CutLevel), 'emop_call'(_Impl, 'main', 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl\", line 3, from character 11 to 15')).
':-'('<module>:emop.emop:main$direct'(__36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.emop:main'(__36env, __36CutLevel))).
':-'('<module>:emop.emop@0'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.emop@0:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.emop@0'('error'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.emop@0:error'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.emop@0'('set_action'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.emop@0:set_action'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.emop@0'('set_output'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.emop@0:set_output'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.emop@0'('main', __36env, _, __36CutLevel), ','('!', '<module>:emop.emop@0:main'(__36env, __36CutLevel))).
':-'('<module>:emop.emop@0'('version', __36env, _, __36CutLevel), ','('!', '<module>:emop.emop@0:version'(__36env, __36CutLevel))).
':-'('<module>:emop.emop@0'('help', __36env, _, __36CutLevel), ','('!', '<module>:emop.emop@0:help'(__36env, __36CutLevel))).
':-'('<module>:emop.emop@0'('parse_arguments', __36env, _, __36CutLevel), ','('!', '<module>:emop.emop@0:parse_arguments'(__36env, __36CutLevel))).
':-'('<module>:emop.emop@0'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.emop@0$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.emop@0$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.emop@0$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.emop@0$has_predicate'('error'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.emop@0$has_predicate'('set_action'(_____1)), 'true').
':-'('<module>:emop.emop@0$has_predicate'('set_output'(_____1)), 'true').
':-'('<module>:emop.emop@0$has_predicate'('main'), 'true').
':-'('<module>:emop.emop@0$has_predicate'('version'), 'true').
':-'('<module>:emop.emop@0$has_predicate'('help'), 'true').
':-'('<module>:emop.emop@0$has_predicate'('parse_arguments'), 'true').
':-'('<module>:emop.emop@0:$sgn'(__36sgn, 'env'(___8, _Impl, _Action, _Output, _Modules), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl',59,5,59)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl',104,5,59)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','(','(','(','(','('true', '<module>:emop.emop@0:atom_fresh_[375]'(_atom__fresh___91376_93, __36Pb, __36Pe)), '<module>:emop.emop@0:atom_fresh_[377]'(_atom__fresh___91378_93, __36Pb, __36Pe)), '<module>:emop.emop@0:atom_fresh_[379]'(_atom__fresh___91380_93, __36Pb, __36Pe)), '<module>:emop.emop@0:atom_fresh_[381]'(_atom__fresh___91382_93, __36Pb, __36Pe)), '<module>:emop.emop@0:atom_fresh_[383]'(_atom__fresh___91384_93, __36Pb, __36Pe)), '<module>:emop.emop@0:atom_fresh_[385]'(_atom__fresh___91386_93, __36Pb, __36Pe)), '<module>:emop.emop@0:atom_fresh_[387]'(_atom__fresh___91388_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___91388_93, '.'(_atom__fresh___91386_93, '.'(_atom__fresh___91384_93, '.'(_atom__fresh___91382_93, '.'(_atom__fresh___91380_93, '.'(_atom__fresh___91378_93, '.'(_atom__fresh___91376_93, '[]'))))))))))))).
':-'('<module>:emop.emop@0:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.emop@0:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.emop@0:atom_fresh_[375]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(parse_arguments, 0, predicate, [], __36pos))).
':-'('<module>:emop.emop@0:atom_fresh_[377]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(help, 0, predicate, [], __36pos))).
':-'('<module>:emop.emop@0:atom_fresh_[379]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(version, 0, predicate, [], __36pos))).
':-'('<module>:emop.emop@0:atom_fresh_[381]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(main, 0, predicate, suspended([],[call(scope,catch,[none,var('E'),none]),call(scope,catch,[none,var('E'),none])]), __36pos))).
':-'('<module>:emop.emop@0:atom_fresh_[383]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(set_output, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.emop@0:atom_fresh_[385]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(set_action, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.emop@0:atom_fresh_[387]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(error, 3, constructor, none, __36pos))).
':-'('<module>:emop.emop@0:error'(___9, ___10, ___11, 'env'(___8, _Impl, _Action, _Output, _Modules), __36CutLevel), '=..'(___11, '.'('error', '.'(___9, '.'(___10, '[]'))))).
':-'('<module>:emop.emop@0:error$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.emop@0:error'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.emop@0:help'('env'(___8, _Impl, _Action, _Output, _Modules), __36CutLevel), ','(','('='(_ProgramName, ___74), ','('g_read'('sys.cmdline', '<module>:sys.cmdline'(___75)), '<module>:sys.cmdline:{}$direct'(0, ___74, ___75))), ','(','('g_read'('io.std', '<module>:io.std'(___78)), '<module>:io.std:print_endline$direct'('Usage:\n', ___78)), ','(','('g_read'('io.std', '<module>:io.std'(___82)), '<module>:io.std:format$direct'('~a [build] <modules>...\n\tBuild given modules.\n\n', '.'(_ProgramName, '[]'), ___82)), ','(','('g_read'('io.std', '<module>:io.std'(___86)), '<module>:io.std:format$direct'('~a compile <modules>...\n\tCompile (do not link) given modules.\n\n', '.'(_ProgramName, '[]'), ___86)), ','(','('g_read'('io.std', '<module>:io.std'(___90)), '<module>:io.std:format$direct'('~a depend <modules>...\n\tPrint module dependencies.\n\n', '.'(_ProgramName, '[]'), ___90)), ','(','('g_read'('io.std', '<module>:io.std'(___94)), '<module>:io.std:format$direct'('~a test <module>...\n\tTest given modules.\n\n', '.'(_ProgramName, '[]'), ___94)), ','(','('g_read'('io.std', '<module>:io.std'(___98)), '<module>:io.std:format$direct'('~a version\n\tPrint version informations and exit.\n\n', '.'(_ProgramName, '[]'), ___98)), ','(','('g_read'('io.std', '<module>:io.std'(___102)), '<module>:io.std:format$direct'('~a help\n\tPrint this help and exit.\n\n', '.'(_ProgramName, '[]'), ___102)), ','(','('g_read'('io.std', '<module>:io.std'(___104)), '<module>:io.std:print_endline$direct'('Other options:', ___104)), ','(','('g_read'('io.std', '<module>:io.std'(___106)), '<module>:io.std:print_endline$direct'('--output-filename=FILENAME, -o FILENAME \tSet output filename.', ___106)), ','(','('g_read'('io.std', '<module>:io.std'(___108)), '<module>:io.std:print_endline$direct'('--verbose \tVerbose compilation.', ___108)), ','(','('g_read'('io.std', '<module>:io.std'(___110)), '<module>:io.std:print_endline$direct'('--debug, -g \tPrint execution trace.', ___110)), ','(','('g_read'('io.std', '<module>:io.std'(___112)), '<module>:io.std:print_endline$direct'('--deps \tPrint dependencies.', ___112)), ','(','('g_read'('io.std', '<module>:io.std'(___114)), '<module>:io.std:print_endline$direct'('--runtime=FILENAME \tUse FILENAME as runtime.', ___114)), ','(','('g_read'('io.std', '<module>:io.std'(___116)), '<module>:io.std:print_endline$direct'('--local-size=N  \tSet default local  stack size to N kb.', ___116)), ','(','('g_read'('io.std', '<module>:io.std'(___118)), '<module>:io.std:print_endline$direct'('--global-size=N \tSet default global stack size to N kb.', ___118)), ','(','('g_read'('io.std', '<module>:io.std'(___120)), '<module>:io.std:print_endline$direct'('--trail-size=N  \tSet default trail  stack size to N kb.', ___120)), ','(','('g_read'('io.std', '<module>:io.std'(___122)), '<module>:io.std:print_endline$direct'('--cstr-size=N   \tSet default cstr   stack size to N kb.', ___122)), ','(','('g_read'('io.std', '<module>:io.std'(___124)), '<module>:io.std:print_endline$direct'('--fixed-sizes \tDo not consult environment variables at run-time.', ___124)), ','(','('g_read'('io.std', '<module>:io.std'(___126)), '<module>:io.std:print_endline$direct'('--recompile \tRecompile at least the files on the command-line.', ___126)), ','(','('g_read'('io.std', '<module>:io.std'(___128)), '<module>:io.std:print_endline$direct'('--all \tRecompile all files.', ___128)), ','(','('g_read'('io.std', '<module>:io.std'(___130)), '<module>:io.std:print_endline$direct'('--ignore-warnings \tBuild even if there are warnings.', ___130)), ','(','('g_read'('io.std', '<module>:io.std'(___132)), '<module>:io.std:print_endline$direct'('--temp-dir=PATHNAME \tKeep intermediary files in PATHNAME.', ___132)), ','(','('g_read'('io.std', '<module>:io.std'(___134)), '<module>:io.std:print_endline$direct'('--build-dir=PATHNAME \tPut inferface and object files in PATHNAME.', ___134)), ','(','('g_read'('io.std', '<module>:io.std'(___136)), '<module>:io.std:print_endline$direct'('--no-wam-patch \tDo not patch WAM files.', ___136)), ','(','('g_read'('io.std', '<module>:io.std'(___138)), '<module>:io.std:print_endline$direct'('-P OPTION \t Pass OPTION to the Prolog compiler.', ___138)), ','('g_read'('io.std', '<module>:io.std'(___139)), '<module>:io.std:endline$direct'(___139))))))))))))))))))))))))))))).
':-'('<module>:emop.emop@0:help$direct'(__36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.emop@0:help'(__36env, __36CutLevel))).
':-'('<module>:emop.emop@0:main'('env'(___8, _Impl, _Action, _Output, _Modules), __36CutLevel), ','('catch'('emop_call'(_Impl, 'parse_arguments', 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl\", line 40, from character 17 to 32'), _E, ','(','('g_read'('emop.message', '<module>:emop.message'(___23)), '<module>:emop.message:error$direct'(_E, ___23)), ','('g_read'('sys.process', '<module>:sys.process'(___25)), '<module>:sys.process:abort$direct'(___25)))), 'catch'(','(';'('->'('='(_Action, 'build'), ','('g_read'('emop.compile', '<module>:emop.compile'(___28)), '<module>:emop.compile:build$direct'(_Modules, _Output, ___28))), ';'('->'('='(_Action, 'compile'), ','('g_read'('emop.compile', '<module>:emop.compile'(___31)), '<module>:emop.compile:compile$direct'(_Modules, _Output, ___31))), ';'('->'('='(_Action, 'depend'), ','('g_read'('emop.compile', '<module>:emop.compile'(___34)), '<module>:emop.compile:depend$direct'(_Modules, ___34))), ';'('->'('='(_Action, 'top'), ','('g_read'('emop.top', '<module>:emop.top'(___37)), '<module>:emop.top:main$direct'(___37))), ';'('->'('='(_Action, 'version'), 'emop_call'(_Impl, 'version', 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl\", line 73, from character 20 to 27')), ';'('->'('='(_Action, 'help'), 'emop_call'(_Impl, 'help', 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl\", line 77, from character 20 to 24')), '->'('='(_Action, 'where'), ','(','(','('g_read'('emop.compile', '<module>:emop.compile'(___44)), '<module>:emop.compile:runtime$direct'(___43, ___44)), 'emop_call'(___43, 'get'(___45), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl\", line 81, from character 57 to 60')), ','('g_read'('io.std', '<module>:io.std'(___46)), '<module>:io.std:print_endline$direct'(___45, ___46)))))))))), ','('g_read'('sys.process', '<module>:sys.process'(___48)), '<module>:sys.process:halt$direct'(___48))), _E, ','(','('g_read'('emop.message', '<module>:emop.message'(___50)), '<module>:emop.message:error$direct'(_E, ___50)), ','('g_read'('sys.process', '<module>:sys.process'(___52)), '<module>:sys.process:abort$direct'(___52)))))).
':-'('<module>:emop.emop@0:main$direct'(__36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.emop@0:main'(__36env, __36CutLevel))).
':-'('<module>:emop.emop@0:parse_arguments'('env'(___8, _Impl, _Action, _Output, _Modules), __36CutLevel), ','(','('='(_RevModulesRef, ___147), ','('g_read'('data.ref.backtrackable', '<module>:data.ref.backtrackable'(___148)), '<module>:data.ref.backtrackable:new$direct'('[]', ___147, ___148))), ','(','('='(_PrologOptionsRef, ___151), ','('g_read'('data.ref.backtrackable', '<module>:data.ref.backtrackable'(___152)), '<module>:data.ref.backtrackable:new$direct'('[]', ___151, ___152))), ','('catch'(','(','('true', ';'('->'('var'(___154), ','('g_inc'('$module_count', ___155), '='(___154, '$module'(___155, '.'('<module>:emop.emop@1'('env'(___154, _Impl, _Action, _Output, _Modules, _Error, _Msg, _Opt, _PrologOptionsRef, _RevModulesRef, _Runtime, ___8)), '[]'), '.'(___154, '[]'))))), ','('='(___154, '$module'(___155, ___156, _)), ','('='('.'(___157, ___158), ___156), ','('setarg'(1, ___156, '<module>:emop.emop@1'('env'(___154, _Impl, _Action, _Output, _Modules, _Error, _Msg, _Opt, _PrologOptionsRef, _RevModulesRef, _Runtime, ___8))), 'setarg'(2, ___156, '.'(___157, ___158))))))), ','('g_read'('sys.cmdline', '<module>:sys.cmdline'(___160)), '<module>:sys.cmdline:parse$direct'(___154, ___160))), 'error'('cmdline'(_Error)), ','(','('='(_Msg, ___141), ','('='(_Error, ___140), ';'('->'(','('='(___142, _Opt), '='(___140, 'option_without_argument'(___142))), ','('='(___141, ___168), ','('g_read'('data.atom', '<module>:data.atom'(___169)), '<module>:data.atom:format$direct'('Option without argument ~a', '.'(_Opt, '[]'), ___168, ___169)))), ','('='(___141, ___175), ','('='(___140, ___143), ','('->'(','('='(___144, _Opt), '='(___143, 'invalid_option'(___144))), 'true'), ','('g_read'('data.atom', '<module>:data.atom'(___176)), '<module>:data.atom:format$direct'('Invalid option ~a', '.'(_Opt, '[]'), ___175, ___176)))))))), 'throw'('error'(_Msg, 'cmdline')))), ','(','('='(_Modules, ___181), ','('emop_call'(_RevModulesRef, 'get'(___180), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl\", line 328, from character 48 to 51'), ','('g_read'('data.list', '<module>:data.list'(___182)), '<module>:data.list:reverse$direct'(___180, ___181, ___182)))), ','(';'('->'(','('='(_Modules, '[]'), '='(_Action, 'top')), 'true'), 'true'), ','(','(','('g_read'('emop.compile', '<module>:emop.compile'(___187)), '<module>:emop.compile:prolog_options$direct'(___186, ___187)), ','(','('emop_call'(_PrologOptionsRef, 'get'(___189), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl\", line 337, from character 73 to 76'), ','('g_read'('data.list', '<module>:data.list'(___191)), '<module>:data.list:reverse$direct'(___189, ___190, ___191))), 'emop_call'(___186, 'set'(___190), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl\", line 337, from character 34 to 37'))), ','(';'('->'(','(','(','('g_read'('emop.compile', '<module>:emop.compile'(___195)), '<module>:emop.compile:runtime$direct'(___194, ___195)), 'emop_call'(___194, 'get'(___196), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl\", line 339, from character 45 to 48')), ','('g_read'('data.var', '<module>:data.var'(___197)), '<module>:data.var:check$direct'(___196, ___197))), ','(','(','('g_read'('emop.compile', '<module>:emop.compile'(___201)), '<module>:emop.compile:lookup_file$direct'('emop/runtime.o', _Runtime, ___200, ___201)), 'emop_call'(___200, 'close', 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl\", line 341, from character 61 to 66')), ','(','('g_read'('emop.compile', '<module>:emop.compile'(___204)), '<module>:emop.compile:runtime$direct'(___203, ___204)), 'emop_call'(___203, 'set'(_Runtime), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl\", line 342, from character 30 to 33')))), 'true'), ','('g_read'('emop.compile', '<module>:emop.compile'(___206)), '<module>:emop.compile:temp_dir$direct'(_, ___206)))))))))).
':-'('<module>:emop.emop@0:parse_arguments$direct'(__36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.emop@0:parse_arguments'(__36env, __36CutLevel))).
':-'('<module>:emop.emop@0:set_action'(_NewAction, 'env'(___8, _Impl, _Action, _Output, _Modules), __36CutLevel), ';'('->'(','('g_read'('data.var', '<module>:data.var'(___13)), '<module>:data.var:check$direct'(_Action, ___13)), '='(_Action, _NewAction)), 'throw'('error'('There cannot be more than one action', 'cmdline')))).
':-'('<module>:emop.emop@0:set_action$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.emop@0:set_action'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.emop@0:set_output'(_New, 'env'(___8, _Impl, _Action, _Output, _Modules), __36CutLevel), ';'('->'(','('g_read'('data.var', '<module>:data.var'(___18)), '<module>:data.var:check$direct'(_Output, ___18)), '='(_Output, _New)), 'throw'('error'('There cannot be more than one output filename', 'cmdline')))).
':-'('<module>:emop.emop@0:set_output$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.emop@0:set_output'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.emop@0:version'('env'(___8, _Impl, _Action, _Output, _Modules), __36CutLevel), ','(','('g_read'('io.std', '<module>:io.std'(___55)), '<module>:io.std:print_endline$direct'('EMoP version 0.02', ___55)), ','(','('g_read'('io.std', '<module>:io.std'(___57)), '<module>:io.std:print_endline$direct'('Copyright (C) 2008-2011 INRIA, Institut National de Recherche en', ___57)), ','(','('g_read'('io.std', '<module>:io.std'(___59)), '<module>:io.std:print_endline$direct'('Informatique et en Automatique, France.', ___59)), ','(','('g_read'('io.std', '<module>:io.std'(___60)), '<module>:io.std:endline$direct'(___60)), ','(','('g_read'('io.std', '<module>:io.std'(___62)), '<module>:io.std:print_endline$direct'('This is free software.  You may redistribute copies of it under', ___62)), ','(','('g_read'('io.std', '<module>:io.std'(___64)), '<module>:io.std:print_endline$direct'('the terms of the GNU General Public Licence', ___64)), ','(','('g_read'('io.std', '<module>:io.std'(___66)), '<module>:io.std:print_endline$direct'('<http://www.gnu.org/licences/gpl.html>.', ___66)), ','(','('g_read'('io.std', '<module>:io.std'(___67)), '<module>:io.std:endline$direct'(___67)), ','(','('g_read'('io.std', '<module>:io.std'(___69)), '<module>:io.std:print_endline$direct'('There is NO WARRANTY, to the extent permitted by law.', ___69)), ','(','('g_read'('io.std', '<module>:io.std'(___70)), '<module>:io.std:endline$direct'(___70)), ','('g_read'('io.std', '<module>:io.std'(___72)), '<module>:io.std:print_endline$direct'('Written by Thierry Martinez <Thierry.Martinez@inria.fr>.', ___72))))))))))))).
':-'('<module>:emop.emop@0:version$direct'(__36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.emop@0:version'(__36env, __36CutLevel))).
':-'('<module>:emop.emop@1'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.emop@1:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.emop@1'('short'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.emop@1:short'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.emop@1'('enable_debug', __36env, _, __36CutLevel), ','('!', '<module>:emop.emop@1:enable_debug'(__36env, __36CutLevel))).
':-'('<module>:emop.emop@1'('action'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.emop@1:action'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.emop@1'('non_ambiguous'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.emop@1:non_ambiguous'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.emop@1'('long'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.emop@1:long'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.emop@1'('default'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.emop@1:default'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.emop@1'('file'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.emop@1:file'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.emop@1'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.emop@1$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.emop@1$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.emop@1$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.emop@1$has_predicate'('short'(_____2, _____1)), 'true').
':-'('<module>:emop.emop@1$has_predicate'('enable_debug'), 'true').
':-'('<module>:emop.emop@1$has_predicate'('action'(_____1)), 'true').
':-'('<module>:emop.emop@1$has_predicate'('non_ambiguous'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.emop@1$has_predicate'('long'(_____2, _____1)), 'true').
':-'('<module>:emop.emop@1$has_predicate'('default'(_____1)), 'true').
':-'('<module>:emop.emop@1$has_predicate'('file'(_____1)), 'true').
':-'('<module>:emop.emop@1:$sgn'(__36sgn, 'env'(___159, _Impl, _Action, _Output, _Modules, _Error, _Msg, _Opt, _PrologOptionsRef, _RevModulesRef, _Runtime, ___8), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl',4916,153,4898)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl',4925,153,4898)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','(','(','(','(','('true', '<module>:emop.emop@1:atom_fresh_[519]'(_atom__fresh___91520_93, __36Pb, __36Pe)), '<module>:emop.emop@1:atom_fresh_[521]'(_atom__fresh___91522_93, __36Pb, __36Pe)), '<module>:emop.emop@1:atom_fresh_[523]'(_atom__fresh___91524_93, __36Pb, __36Pe)), '<module>:emop.emop@1:atom_fresh_[525]'(_atom__fresh___91526_93, __36Pb, __36Pe)), '<module>:emop.emop@1:atom_fresh_[527]'(_atom__fresh___91528_93, __36Pb, __36Pe)), '<module>:emop.emop@1:atom_fresh_[529]'(_atom__fresh___91530_93, __36Pb, __36Pe)), '<module>:emop.emop@1:atom_fresh_[531]'(_atom__fresh___91532_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___91532_93, '.'(_atom__fresh___91530_93, '.'(_atom__fresh___91528_93, '.'(_atom__fresh___91526_93, '.'(_atom__fresh___91524_93, '.'(_atom__fresh___91522_93, '.'(_atom__fresh___91520_93, '[]'))))))))))))).
':-'('<module>:emop.emop@1:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.emop@1:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.emop@1:action'('build', 'env'(___159, _Impl, _Action, _Output, _Modules, _Error, _Msg, _Opt, _PrologOptionsRef, _RevModulesRef, _Runtime, ___8), __36CutLevel), 'true').
':-'('<module>:emop.emop@1:action'('compile', 'env'(___159, _Impl, _Action, _Output, _Modules, _Error, _Msg, _Opt, _PrologOptionsRef, _RevModulesRef, _Runtime, ___8), __36CutLevel), 'true').
':-'('<module>:emop.emop@1:action'('depend', 'env'(___159, _Impl, _Action, _Output, _Modules, _Error, _Msg, _Opt, _PrologOptionsRef, _RevModulesRef, _Runtime, ___8), __36CutLevel), 'true').
':-'('<module>:emop.emop@1:action'('help', 'env'(___159, _Impl, _Action, _Output, _Modules, _Error, _Msg, _Opt, _PrologOptionsRef, _RevModulesRef, _Runtime, ___8), __36CutLevel), 'true').
':-'('<module>:emop.emop@1:action'('version', 'env'(___159, _Impl, _Action, _Output, _Modules, _Error, _Msg, _Opt, _PrologOptionsRef, _RevModulesRef, _Runtime, ___8), __36CutLevel), 'true').
':-'('<module>:emop.emop@1:action'('where', 'env'(___159, _Impl, _Action, _Output, _Modules, _Error, _Msg, _Opt, _PrologOptionsRef, _RevModulesRef, _Runtime, ___8), __36CutLevel), 'true').
':-'('<module>:emop.emop@1:action$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.emop@1:action'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.emop@1:atom_fresh_[519]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(file, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.emop@1:atom_fresh_[521]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(default, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.emop@1:atom_fresh_[523]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(long, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.emop@1:atom_fresh_[525]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(non_ambiguous, 3, predicate, '[]', __36pos))).
':-'('<module>:emop.emop@1:atom_fresh_[527]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(action, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.emop@1:atom_fresh_[529]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(enable_debug, 0, predicate, [], __36pos))).
':-'('<module>:emop.emop@1:atom_fresh_[531]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(short, 2, predicate, suspended([none,var('_')],[call(scope,set_action,[none])]), __36pos))).
':-'('<module>:emop.emop@1:default'(_NewAction, 'env'(___159, _Impl, _Action, _Output, _Modules, _Error, _Msg, _Opt, _PrologOptionsRef, _RevModulesRef, _Runtime, ___8), __36CutLevel), ','(','('g_read'('data.var', '<module>:data.var'(___361)), '<module>:data.var:check$direct'(_Action, ___361)), ','('='(_Action, ___368), ','(','('true', ';'('->'('var'(___362), ','('g_inc'('$module_count', ___363), '='(___362, '$module'(___363, '.'('<module>:emop.emop@3'('env'(___362, _Impl, _Action, _Output, _Modules, _Error, _Msg, _Opt, _PrologOptionsRef, _RevModulesRef, _Runtime, _NewAction, ___159, ___8)), '[]'), '.'(___362, '[]'))))), ','('='(___362, '$module'(___363, ___364, _)), ','('='('.'(___365, ___366), ___364), ','('setarg'(1, ___364, '<module>:emop.emop@3'('env'(___362, _Impl, _Action, _Output, _Modules, _Error, _Msg, _Opt, _PrologOptionsRef, _RevModulesRef, _Runtime, _NewAction, ___159, ___8))), 'setarg'(2, ___364, '.'(___365, ___366))))))), 'emop_call'(___159, 'non_ambiguous'(_NewAction, ___362, ___368), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl\", line 293, from character 21 to 34'))))).
':-'('<module>:emop.emop@1:default$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.emop@1:default'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.emop@1:enable_debug'('env'(___159, _Impl, _Action, _Output, _Modules, _Error, _Msg, _Opt, _PrologOptionsRef, _RevModulesRef, _Runtime, ___8), __36CutLevel), ','(','(','('g_read'('emop.compile', '<module>:emop.compile'(___223)), '<module>:emop.compile:lookup_file$direct'('emop/runtime_debug.o', _NewRuntime, ___222, ___223)), 'emop_call'(___222, 'close', 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl\", line 174, from character 73 to 78')), ','(','('g_read'('emop.compile', '<module>:emop.compile'(___226)), '<module>:emop.compile:runtime$direct'(___225, ___226)), 'emop_call'(___225, 'set'(_NewRuntime), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl\", line 175, from character 33 to 36')))).
':-'('<module>:emop.emop@1:enable_debug$direct'(__36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.emop@1:enable_debug'(__36env, __36CutLevel))).
':-'('<module>:emop.emop@1:file'(_Filename, 'env'(___159, _Impl, _Action, _Output, _Modules, _Error, _Msg, _Opt, _PrologOptionsRef, _RevModulesRef, _Runtime, ___8), __36CutLevel), ';'('->'(','('g_read'('data.atom', '<module>:data.atom'(___377)), '<module>:data.atom:sub$direct'(_Filename, _, _, 0, '.mpl', ___377)), ','('='(_Module, 'file'(_Filename)), ','('emop_call'(_RevModulesRef, 'get'(___379), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl\", line 303, from character 57 to 60'), 'emop_call'(_RevModulesRef, 'set'('.'(_Module, ___379)), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl\", line 303, from character 29 to 32')))), ';'('->'(','(','('='(_Ext, ___369), ';'('='(___369, '.pl'), ','('='(___369, ___370), ';'('='(___370, '.pro'), ','('='(___370, ___371), ';'('='(___371, '.o'), ','('='(___371, ___372), ';'('='(___372, '.c'), ','('='(___372, ___373), ';'('='(___373, '.a'), ','('='(___373, ___374), ';'('='(___374, '.wam'), '='(___374, '.fd'))))))))))))), ','('g_read'('data.atom', '<module>:data.atom'(___389)), '<module>:data.atom:sub$direct'(_Filename, _, _, 0, _Ext, ___389))), ','('emop_call'(_PrologOptionsRef, 'get'(___390), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl\", line 308, from character 65 to 68'), 'emop_call'(_PrologOptionsRef, 'set'('.'(_Filename, ___390)), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl\", line 308, from character 32 to 35'))), ','('='(_Module, 'name'(_Filename, '[]', '.')), ','('emop_call'(_RevModulesRef, 'get'(___395), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl\", line 311, from character 57 to 60'), 'emop_call'(_RevModulesRef, 'set'('.'(_Module, ___395)), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl\", line 311, from character 29 to 32')))))).
':-'('<module>:emop.emop@1:file$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.emop@1:file'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.emop@1:long'(_Long, _Next, 'env'(___159, _Impl, _Action, _Output, _Modules, _Error, _Msg, _Opt, _PrologOptionsRef, _RevModulesRef, _Runtime, ___8), __36CutLevel), ','(','('='(_Full, ___277), ','(','('true', ';'('->'('var'(___271), ','('g_inc'('$module_count', ___272), '='(___271, '$module'(___272, '.'('<module>:emop.emop@2'('env'(___271, _Impl, _Action, _Output, _Modules, _Error, _Msg, _Opt, _PrologOptionsRef, _RevModulesRef, _Runtime, _Full, _Long, _Next, ___159, ___8)), '[]'), '.'(___271, '[]'))))), ','('='(___271, '$module'(___272, ___273, _)), ','('='('.'(___274, ___275), ___273), ','('setarg'(1, ___273, '<module>:emop.emop@2'('env'(___271, _Impl, _Action, _Output, _Modules, _Error, _Msg, _Opt, _PrologOptionsRef, _RevModulesRef, _Runtime, _Full, _Long, _Next, ___159, ___8))), 'setarg'(2, ___273, '.'(___274, ___275))))))), 'emop_call'(___159, 'non_ambiguous'(_Long, ___271, ___277), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl\", line 201, from character 19 to 32'))), ','('='(_Full, ___254), ';'('->'(','('='(___254, ___278), 'emop_call'(___159, 'action'(___278), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl\", line 221, from character 17 to 22')), 'emop_call'(___8, 'set_action'(_Full), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl\", line 224, from character 15 to 25')), ','('='(___254, ___255), ';'('->'('='(___255, 'output-filename'), ','('emop_call'(_Next, 'get'(___280), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl\", line 228, from character 31 to 34'), 'emop_call'(___8, 'set_output'(___280), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl\", line 228, from character 15 to 25'))), ','('='(___255, ___256), ';'('->'('='(___256, 'local-size'), ','(','('g_read'('emop.compile', '<module>:emop.compile'(___285)), '<module>:emop.compile:size$direct'('local', ___284, ___285)), ','(','('emop_call'(_Next, 'get'(___287), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl\", line 232, from character 68 to 71'), ','('g_read'('data.atom', '<module>:data.atom'(___289)), '<module>:data.atom:number$direct'(___287, ___288, ___289))), 'emop_call'(___284, 'set'(___288), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl\", line 232, from character 42 to 45')))), ','('='(___256, ___257), ';'('->'('='(___257, 'global-size'), ','(','('g_read'('emop.compile', '<module>:emop.compile'(___294)), '<module>:emop.compile:size$direct'('global', ___293, ___294)), ','(','('emop_call'(_Next, 'get'(___296), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl\", line 236, from character 69 to 72'), ','('g_read'('data.atom', '<module>:data.atom'(___298)), '<module>:data.atom:number$direct'(___296, ___297, ___298))), 'emop_call'(___293, 'set'(___297), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl\", line 236, from character 43 to 46')))), ','('='(___257, ___258), ';'('->'('='(___258, 'trail-size'), ','(','('g_read'('emop.compile', '<module>:emop.compile'(___303)), '<module>:emop.compile:size$direct'('trail', ___302, ___303)), ','(','('emop_call'(_Next, 'get'(___305), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl\", line 240, from character 68 to 71'), ','('g_read'('data.atom', '<module>:data.atom'(___307)), '<module>:data.atom:number$direct'(___305, ___306, ___307))), 'emop_call'(___302, 'set'(___306), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl\", line 240, from character 42 to 45')))), ','('='(___258, ___259), ';'('->'('='(___259, 'cstr-size'), ','(','('g_read'('emop.compile', '<module>:emop.compile'(___312)), '<module>:emop.compile:size$direct'('cstr', ___311, ___312)), ','(','('emop_call'(_Next, 'get'(___314), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl\", line 244, from character 67 to 70'), ','('g_read'('data.atom', '<module>:data.atom'(___316)), '<module>:data.atom:number$direct'(___314, ___315, ___316))), 'emop_call'(___311, 'set'(___315), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl\", line 244, from character 41 to 44')))), ','('='(___259, ___260), ';'('->'('='(___260, 'fixed-sizes'), ','('emop_call'(_PrologOptionsRef, 'get'(___319), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl\", line 248, from character 72 to 75'), 'emop_call'(_PrologOptionsRef, 'set'('.'('--fixed-sizes', ___319)), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl\", line 248, from character 32 to 35'))), ','('='(___260, ___261), ';'('->'('='(___261, 'runtime'), ','(','('g_read'('emop.compile', '<module>:emop.compile'(___324)), '<module>:emop.compile:runtime$direct'(___323, ___324)), ','('emop_call'(_Next, 'get'(___325), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl\", line 252, from character 45 to 48'), 'emop_call'(___323, 'set'(___325), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl\", line 252, from character 36 to 39')))), ','('='(___261, ___262), ';'('->'('='(___262, 'temp-dir'), ','('emop_call'(_Next, 'get'(___328), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl\", line 256, from character 42 to 45'), ','('g_read'('emop.compile', '<module>:emop.compile'(___329)), '<module>:emop.compile:temp_dir$direct'(___328, ___329)))), ','('='(___262, ___263), ';'('->'('='(___263, 'build-dir'), ','('emop_call'(_Next, 'get'(___332), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl\", line 260, from character 54 to 57'), ','('g_read'('emop.compile', '<module>:emop.compile'(___334)), '<module>:emop.compile:set_build_dir$direct'('some'(___332), ___334)))), ','('='(___263, ___264), ';'('->'('='(___264, 'debug'), 'emop_call'(___159, 'enable_debug', 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl\", line 264, from character 15 to 27')), ','('='(___264, ___265), ';'('->'('='(___265, 'recompile'), ','('g_read'('emop.compile', '<module>:emop.compile'(___339)), '<module>:emop.compile:set_use_cache$direct'('no_cmdline', ___339))), ','('='(___265, ___266), ';'('->'('='(___266, 'all'), ','('g_read'('emop.compile', '<module>:emop.compile'(___343)), '<module>:emop.compile:set_use_cache$direct'('never', ___343))), ','('='(___266, ___267), ';'('->'('='(___267, 'ignore-warnings'), ','('g_read'('emop.compile', '<module>:emop.compile'(___347)), '<module>:emop.compile:set_do_not_build_with_warning$direct'('false', ___347))), ','('='(___267, ___268), ';'('->'('='(___268, 'verbose'), ','('g_read'('emop.compile', '<module>:emop.compile'(___351)), '<module>:emop.compile:set_verbose$direct'('true', ___351))), ','('='(___268, ___269), ';'('->'('='(___269, 'deps'), ','('g_read'('emop.compile', '<module>:emop.compile'(___355)), '<module>:emop.compile:set_deps$direct'('true', ___355))), ','('='(___269, ___270), '->'('='(___270, 'no-wam-patch'), ','('g_read'('emop.compile', '<module>:emop.compile'(___359)), '<module>:emop.compile:set_wam_patch$direct'('false', ___359)))))))))))))))))))))))))))))))))))))).
':-'('<module>:emop.emop@1:long$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.emop@1:long'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.emop@1:non_ambiguous'(_Atom, _Set, _FullAtom, 'env'(___159, _Impl, _Action, _Output, _Modules, _Error, _Msg, _Opt, _PrologOptionsRef, _RevModulesRef, _Runtime, ___8), __36CutLevel), ','(','('='(_String, ___234), ','('g_read'('data.atom', '<module>:data.atom'(___235)), '<module>:data.atom:string$direct'(_Atom, ___234, ___235))), ','('emop_call'(_Set, 'get'(_FullAtom), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl\", line 187, from character 16 to 19'), ','(','(','('g_read'('data.atom', '<module>:data.atom'(___239)), '<module>:data.atom:string$direct'(_FullAtom, ___238, ___239)), ','('g_read'('data.list', '<module>:data.list'(___240)), '<module>:data.list:append$direct'(_String, _, ___238, ___240))), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ';'('->'(','('emop_call'(_Set, 'get'(_OtherAtom), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl\", line 191, from character 19 to 22'), ','('\\='(_OtherAtom, _FullAtom), ','(','('g_read'('data.atom', '<module>:data.atom'(___244)), '<module>:data.atom:string$direct'(_OtherAtom, ___243, ___244)), ','('g_read'('data.list', '<module>:data.list'(___245)), '<module>:data.list:append$direct'(_String, _, ___243, ___245))))), ','(','('g_read'('data.atom', '<module>:data.atom'(___251)), '<module>:data.atom:format$direct'('~a is ambiguous', '.'(_Atom, '[]'), ___250, ___251)), 'throw'('error'(___250, 'cmdline')))), 'true')))))).
':-'('<module>:emop.emop@1:non_ambiguous$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.emop@1:non_ambiguous'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.emop@1:short'('h', _, 'env'(___159, _Impl, _Action, _Output, _Modules, _Error, _Msg, _Opt, _PrologOptionsRef, _RevModulesRef, _Runtime, ___8), __36CutLevel), 'emop_call'(___8, 'set_action'('help'), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl\", line 156, from character 12 to 22')).
':-'('<module>:emop.emop@1:short'('v', _, 'env'(___159, _Impl, _Action, _Output, _Modules, _Error, _Msg, _Opt, _PrologOptionsRef, _RevModulesRef, _Runtime, ___8), __36CutLevel), 'emop_call'(___8, 'set_action'('version'), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl\", line 159, from character 12 to 22')).
':-'('<module>:emop.emop@1:short'('c', _, 'env'(___159, _Impl, _Action, _Output, _Modules, _Error, _Msg, _Opt, _PrologOptionsRef, _RevModulesRef, _Runtime, ___8), __36CutLevel), 'emop_call'(___8, 'set_action'('compile'), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl\", line 162, from character 12 to 22')).
':-'('<module>:emop.emop@1:short'('o', _Next, 'env'(___159, _Impl, _Action, _Output, _Modules, _Error, _Msg, _Opt, _PrologOptionsRef, _RevModulesRef, _Runtime, ___8), __36CutLevel), ','('emop_call'(_Next, 'get'(___214), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl\", line 165, from character 28 to 31'), 'emop_call'(___8, 'set_output'(___214), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl\", line 165, from character 12 to 22'))).
':-'('<module>:emop.emop@1:short'('P', _Next, 'env'(___159, _Impl, _Action, _Output, _Modules, _Error, _Msg, _Opt, _PrologOptionsRef, _RevModulesRef, _Runtime, ___8), __36CutLevel), ','(','('emop_call'(_Next, 'get'(___216), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl\", line 168, from character 39 to 42'), 'emop_call'(_PrologOptionsRef, 'get'(___217), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl\", line 168, from character 62 to 65')), 'emop_call'(_PrologOptionsRef, 'set'('.'(___216, ___217)), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl\", line 168, from character 29 to 32'))).
':-'('<module>:emop.emop@1:short'('g', _, 'env'(___159, _Impl, _Action, _Output, _Modules, _Error, _Msg, _Opt, _PrologOptionsRef, _RevModulesRef, _Runtime, ___8), __36CutLevel), 'emop_call'(___159, 'enable_debug', 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl\", line 171, from character 12 to 24')).
':-'('<module>:emop.emop@1:short$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.emop@1:short'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.emop@2'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.emop@2:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.emop@2'('get'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.emop@2:get'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.emop@2'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.emop@2$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.emop@2$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.emop@2$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.emop@2$has_predicate'('get'(_____1)), 'true').
':-'('<module>:emop.emop@2:$sgn'(__36sgn, 'env'(___276, _Impl, _Action, _Output, _Modules, _Error, _Msg, _Opt, _PrologOptionsRef, _RevModulesRef, _Runtime, _Full, _Long, _Next, ___159, ___8), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl',6231,200,6212)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl',6252,200,6212)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.emop@2:atom_fresh_[598]'(_atom__fresh___91599_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___91599_93, '[]'))))))).
':-'('<module>:emop.emop@2:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.emop@2:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.emop@2:atom_fresh_[598]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(get, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.emop@2:get'('output-filename', 'env'(___276, _Impl, _Action, _Output, _Modules, _Error, _Msg, _Opt, _PrologOptionsRef, _RevModulesRef, _Runtime, _Full, _Long, _Next, ___159, ___8), __36CutLevel), 'true').
':-'('<module>:emop.emop@2:get'('local-size', 'env'(___276, _Impl, _Action, _Output, _Modules, _Error, _Msg, _Opt, _PrologOptionsRef, _RevModulesRef, _Runtime, _Full, _Long, _Next, ___159, ___8), __36CutLevel), 'true').
':-'('<module>:emop.emop@2:get'('global-size', 'env'(___276, _Impl, _Action, _Output, _Modules, _Error, _Msg, _Opt, _PrologOptionsRef, _RevModulesRef, _Runtime, _Full, _Long, _Next, ___159, ___8), __36CutLevel), 'true').
':-'('<module>:emop.emop@2:get'('trail-size', 'env'(___276, _Impl, _Action, _Output, _Modules, _Error, _Msg, _Opt, _PrologOptionsRef, _RevModulesRef, _Runtime, _Full, _Long, _Next, ___159, ___8), __36CutLevel), 'true').
':-'('<module>:emop.emop@2:get'('cstr-size', 'env'(___276, _Impl, _Action, _Output, _Modules, _Error, _Msg, _Opt, _PrologOptionsRef, _RevModulesRef, _Runtime, _Full, _Long, _Next, ___159, ___8), __36CutLevel), 'true').
':-'('<module>:emop.emop@2:get'('fixed-sizes', 'env'(___276, _Impl, _Action, _Output, _Modules, _Error, _Msg, _Opt, _PrologOptionsRef, _RevModulesRef, _Runtime, _Full, _Long, _Next, ___159, ___8), __36CutLevel), 'true').
':-'('<module>:emop.emop@2:get'('debug', 'env'(___276, _Impl, _Action, _Output, _Modules, _Error, _Msg, _Opt, _PrologOptionsRef, _RevModulesRef, _Runtime, _Full, _Long, _Next, ___159, ___8), __36CutLevel), 'true').
':-'('<module>:emop.emop@2:get'('runtime', 'env'(___276, _Impl, _Action, _Output, _Modules, _Error, _Msg, _Opt, _PrologOptionsRef, _RevModulesRef, _Runtime, _Full, _Long, _Next, ___159, ___8), __36CutLevel), 'true').
':-'('<module>:emop.emop@2:get'('temp-dir', 'env'(___276, _Impl, _Action, _Output, _Modules, _Error, _Msg, _Opt, _PrologOptionsRef, _RevModulesRef, _Runtime, _Full, _Long, _Next, ___159, ___8), __36CutLevel), 'true').
':-'('<module>:emop.emop@2:get'('build-dir', 'env'(___276, _Impl, _Action, _Output, _Modules, _Error, _Msg, _Opt, _PrologOptionsRef, _RevModulesRef, _Runtime, _Full, _Long, _Next, ___159, ___8), __36CutLevel), 'true').
':-'('<module>:emop.emop@2:get'('recompile', 'env'(___276, _Impl, _Action, _Output, _Modules, _Error, _Msg, _Opt, _PrologOptionsRef, _RevModulesRef, _Runtime, _Full, _Long, _Next, ___159, ___8), __36CutLevel), 'true').
':-'('<module>:emop.emop@2:get'('all', 'env'(___276, _Impl, _Action, _Output, _Modules, _Error, _Msg, _Opt, _PrologOptionsRef, _RevModulesRef, _Runtime, _Full, _Long, _Next, ___159, ___8), __36CutLevel), 'true').
':-'('<module>:emop.emop@2:get'('ignore-warnings', 'env'(___276, _Impl, _Action, _Output, _Modules, _Error, _Msg, _Opt, _PrologOptionsRef, _RevModulesRef, _Runtime, _Full, _Long, _Next, ___159, ___8), __36CutLevel), 'true').
':-'('<module>:emop.emop@2:get'('verbose', 'env'(___276, _Impl, _Action, _Output, _Modules, _Error, _Msg, _Opt, _PrologOptionsRef, _RevModulesRef, _Runtime, _Full, _Long, _Next, ___159, ___8), __36CutLevel), 'true').
':-'('<module>:emop.emop@2:get'('deps', 'env'(___276, _Impl, _Action, _Output, _Modules, _Error, _Msg, _Opt, _PrologOptionsRef, _RevModulesRef, _Runtime, _Full, _Long, _Next, ___159, ___8), __36CutLevel), 'true').
':-'('<module>:emop.emop@2:get'('no-wam-patch', 'env'(___276, _Impl, _Action, _Output, _Modules, _Error, _Msg, _Opt, _PrologOptionsRef, _RevModulesRef, _Runtime, _Full, _Long, _Next, ___159, ___8), __36CutLevel), 'true').
':-'('<module>:emop.emop@2:get'(_Item, 'env'(___276, _Impl, _Action, _Output, _Modules, _Error, _Msg, _Opt, _PrologOptionsRef, _RevModulesRef, _Runtime, _Full, _Long, _Next, ___159, ___8), __36CutLevel), 'emop_call'(___159, 'action'(_Item), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl\", line 219, from character 18 to 24')).
':-'('<module>:emop.emop@2:get$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.emop@2:get'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.emop@3'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.emop@3:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.emop@3'('get'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.emop@3:get'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.emop@3'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.emop@3$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.emop@3$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.emop@3$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.emop@3$has_predicate'('get'(_____1)), 'true').
':-'('<module>:emop.emop@3:$sgn'(__36sgn, 'env'(___367, _Impl, _Action, _Output, _Modules, _Error, _Msg, _Opt, _PrologOptionsRef, _RevModulesRef, _Runtime, _NewAction, ___159, ___8), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl',8865,292,8844)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl',8891,292,8844)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.emop@3:atom_fresh_[586]'(_atom__fresh___91587_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___91587_93, '[]'))))))).
':-'('<module>:emop.emop@3:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.emop@3:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.emop@3:atom_fresh_[586]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(get, 1, predicate, suspended([var('Item')],[call(scope,action,[var('Item')])]), __36pos))).
':-'('<module>:emop.emop@3:get'(_Item, 'env'(___367, _Impl, _Action, _Output, _Modules, _Error, _Msg, _Opt, _PrologOptionsRef, _RevModulesRef, _Runtime, _NewAction, ___159, ___8), __36CutLevel), 'emop_call'(___159, 'action'(_Item), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/emop.mpl\", line 295, from character 18 to 24')).
':-'('<module>:emop.emop@3:get$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.emop@3:get'(_____1, __36env, __36CutLevel))).
':-'('emop.emop@init', ','(','('true', 'g_link'('emop.emop', '<module>:emop.emop'('env'(_Impl)))), ','('true', ';'('->'('var'(_Impl), ','('g_inc'('$module_count', ___4), '='(_Impl, '$module'(___4, '.'('<module>:emop.emop@0'('env'(_Impl, _Impl, _Action, _Output, _Modules)), '[]'), '.'(_Impl, '[]'))))), ','('='(_Impl, '$module'(___4, ___5, _)), ','('='('.'(___6, ___7), ___5), ','('setarg'(1, ___5, '<module>:emop.emop@0'('env'(_Impl, _Impl, _Action, _Output, _Modules))), 'setarg'(2, ___5, '.'(___6, ___7))))))))).
':-'('dynamic'('/'('<module>:emop.expand@0$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.expand@4$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.expand@3$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.expand@5$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.expand@2$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.expand@1$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.expand$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.expand@11$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.expand@13$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.expand@12$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.expand@10$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.expand@22$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.expand@36$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.expand@35$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.expand@37$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.expand@34$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.expand@33$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.expand@38$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.expand@32$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.expand@31$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.expand@39$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.expand@30$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.expand@29$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.expand@28$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.expand@27$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.expand@26$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.expand@25$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.expand@24$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.expand@23$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.expand@21$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.expand@20$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.expand@19$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.expand@45$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.expand@44$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.expand@43$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.expand@42$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.expand@41$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.expand@40$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.expand@18$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.expand@47$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.expand@46$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.expand@17$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.expand@48$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.expand@16$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.expand@15$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.expand@14$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.expand@49$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.expand@9$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.expand@8$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.expand@7$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.expand@6$dynamic', 4))).
':-'('<module>:emop.expand'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand'('term'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand:term'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand'('module'(_____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand:module'(_____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand'('grammar'(_____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand:grammar'(_____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand'('doc'(_____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand:doc'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand'('empty'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand:empty'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand'('number'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand:number'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand'('operator'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand:operator'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand'('=>'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand:=>'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand'('clause'(_____7, _____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand:clause'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand'('atom'(_____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand:atom'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand'('number'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand:number'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand'('scope'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand:scope'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand'('some'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand:some'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand'('some'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand:some'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand'('directive'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand:directive'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand'('clause'(_____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand:clause'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand'('doc'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand:doc'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand'('callable'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand:callable'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand'('dep'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand:dep'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand'('dep'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand:dep'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand'('var'(_____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand:var'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand'('var'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand:var'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand'('none'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand:none'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand'('error'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand:error'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand'('file'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand:file'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand'('file'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand:file'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand'('priority'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand:priority'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand'('level'(_____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand:level'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand'('level'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand:level'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand'('syntax'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand:syntax'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand'('notation'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand:notation'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand'('operator'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand:operator'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand'('special'(_____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand:special'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand'('escaped'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand:escaped'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand'('variable'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand:variable'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand'('unescaped'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand:unescaped'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand'('ctx'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand:ctx'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand'('atom'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand:atom'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand'('callable'(_____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand:callable'(_____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand'('symbol'(_____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand:symbol'(_____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand'('empty'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand:empty'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand'('get_args_info'(_____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand:get_args_info'(_____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand'('eval_suspended'(_____9, _____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand:eval_suspended'(_____9, _____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand'('unify_module'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand:unify_module'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand'('fresh_init_goal_id'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand:fresh_init_goal_id'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand'('make_scope'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand:make_scope'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand'('fresh_dependencies'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand:fresh_dependencies'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand'('expand_file'(_____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand:expand_file'(_____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.expand$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.expand$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.expand$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.expand$has_predicate'('term'(_____2, _____1)), 'true').
':-'('<module>:emop.expand$has_predicate'('module'(_____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand$has_predicate'('grammar'(_____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand$has_predicate'('doc'(_____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand$has_predicate'('empty'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand$has_predicate'('number'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand$has_predicate'('operator'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand$has_predicate'('=>'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand$has_predicate'('clause'(_____7, _____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand$has_predicate'('atom'(_____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand$has_predicate'('number'(_____2, _____1)), 'true').
':-'('<module>:emop.expand$has_predicate'('scope'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand$has_predicate'('some'(_____2, _____1)), 'true').
':-'('<module>:emop.expand$has_predicate'('some'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand$has_predicate'('directive'(_____2, _____1)), 'true').
':-'('<module>:emop.expand$has_predicate'('clause'(_____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand$has_predicate'('doc'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand$has_predicate'('callable'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand$has_predicate'('dep'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand$has_predicate'('dep'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand$has_predicate'('var'(_____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand$has_predicate'('var'(_____2, _____1)), 'true').
':-'('<module>:emop.expand$has_predicate'('none'(_____1)), 'true').
':-'('<module>:emop.expand$has_predicate'('error'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand$has_predicate'('file'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand$has_predicate'('file'(_____2, _____1)), 'true').
':-'('<module>:emop.expand$has_predicate'('priority'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand$has_predicate'('level'(_____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand$has_predicate'('level'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand$has_predicate'('syntax'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand$has_predicate'('notation'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand$has_predicate'('operator'(_____1)), 'true').
':-'('<module>:emop.expand$has_predicate'('special'(_____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand$has_predicate'('escaped'(_____1)), 'true').
':-'('<module>:emop.expand$has_predicate'('variable'(_____1)), 'true').
':-'('<module>:emop.expand$has_predicate'('unescaped'(_____1)), 'true').
':-'('<module>:emop.expand$has_predicate'('ctx'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand$has_predicate'('atom'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand$has_predicate'('callable'(_____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand$has_predicate'('symbol'(_____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand$has_predicate'('empty'(_____1)), 'true').
':-'('<module>:emop.expand$has_predicate'('get_args_info'(_____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand$has_predicate'('eval_suspended'(_____9, _____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand$has_predicate'('unify_module'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand$has_predicate'('fresh_init_goal_id'(_____1)), 'true').
':-'('<module>:emop.expand$has_predicate'('make_scope'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand$has_predicate'('fresh_dependencies'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand$has_predicate'('expand_file'(_____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand:$sgn'(__36sgn, 'env'(_Impl, _InitGoalIdRef), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',0,0,0)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',42,0,0)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','('true', '<module>:emop.expand:atom_fresh_[3445]'(_atom__fresh___913446_93, __36Pb, __36Pe)), '<module>:emop.expand:atom_fresh_[3447]'(_atom__fresh___913448_93, __36Pb, __36Pe)), '<module>:emop.expand:atom_fresh_[3449]'(_atom__fresh___913450_93, __36Pb, __36Pe)), '<module>:emop.expand:atom_fresh_[3451]'(_atom__fresh___913452_93, __36Pb, __36Pe)), '<module>:emop.expand:atom_fresh_[3453]'(_atom__fresh___913454_93, __36Pb, __36Pe)), '<module>:emop.expand:atom_fresh_[3455]'(_atom__fresh___913456_93, __36Pb, __36Pe)), '<module>:emop.expand:atom_fresh_[3457]'(_atom__fresh___913458_93, __36Pb, __36Pe)), '<module>:emop.expand:atom_fresh_[3459]'(_atom__fresh___913460_93, __36Pb, __36Pe)), '<module>:emop.expand:atom_fresh_[3461]'(_atom__fresh___913462_93, __36Pb, __36Pe)), '<module>:emop.expand:atom_fresh_[3463]'(_atom__fresh___913464_93, __36Pb, __36Pe)), '<module>:emop.expand:atom_fresh_[3465]'(_atom__fresh___913466_93, __36Pb, __36Pe)), '<module>:emop.expand:atom_fresh_[3467]'(_atom__fresh___913468_93, __36Pb, __36Pe)), '<module>:emop.expand:atom_fresh_[3469]'(_atom__fresh___913470_93, __36Pb, __36Pe)), '<module>:emop.expand:atom_fresh_[3471]'(_atom__fresh___913472_93, __36Pb, __36Pe)), '<module>:emop.expand:atom_fresh_[3473]'(_atom__fresh___913474_93, __36Pb, __36Pe)), '<module>:emop.expand:atom_fresh_[3475]'(_atom__fresh___913476_93, __36Pb, __36Pe)), '<module>:emop.expand:atom_fresh_[3477]'(_atom__fresh___913478_93, __36Pb, __36Pe)), '<module>:emop.expand:atom_fresh_[3479]'(_atom__fresh___913480_93, __36Pb, __36Pe)), '<module>:emop.expand:atom_fresh_[3481]'(_atom__fresh___913482_93, __36Pb, __36Pe)), '<module>:emop.expand:atom_fresh_[3483]'(_atom__fresh___913484_93, __36Pb, __36Pe)), '<module>:emop.expand:atom_fresh_[3485]'(_atom__fresh___913486_93, __36Pb, __36Pe)), '<module>:emop.expand:atom_fresh_[3487]'(_atom__fresh___913488_93, __36Pb, __36Pe)), '<module>:emop.expand:atom_fresh_[3489]'(_atom__fresh___913490_93, __36Pb, __36Pe)), '<module>:emop.expand:atom_fresh_[3491]'(_atom__fresh___913492_93, __36Pb, __36Pe)), '<module>:emop.expand:atom_fresh_[3493]'(_atom__fresh___913494_93, __36Pb, __36Pe)), '<module>:emop.expand:atom_fresh_[3495]'(_atom__fresh___913496_93, __36Pb, __36Pe)), '<module>:emop.expand:atom_fresh_[3497]'(_atom__fresh___913498_93, __36Pb, __36Pe)), '<module>:emop.expand:atom_fresh_[3499]'(_atom__fresh___913500_93, __36Pb, __36Pe)), '<module>:emop.expand:atom_fresh_[3501]'(_atom__fresh___913502_93, __36Pb, __36Pe)), '<module>:emop.expand:atom_fresh_[3503]'(_atom__fresh___913504_93, __36Pb, __36Pe)), '<module>:emop.expand:atom_fresh_[3505]'(_atom__fresh___913506_93, __36Pb, __36Pe)), '<module>:emop.expand:atom_fresh_[3507]'(_atom__fresh___913508_93, __36Pb, __36Pe)), '<module>:emop.expand:atom_fresh_[3509]'(_atom__fresh___913510_93, __36Pb, __36Pe)), '<module>:emop.expand:atom_fresh_[3511]'(_atom__fresh___913512_93, __36Pb, __36Pe)), '<module>:emop.expand:atom_fresh_[3513]'(_atom__fresh___913514_93, __36Pb, __36Pe)), '<module>:emop.expand:atom_fresh_[3515]'(_atom__fresh___913516_93, __36Pb, __36Pe)), '<module>:emop.expand:atom_fresh_[3517]'(_atom__fresh___913518_93, __36Pb, __36Pe)), '<module>:emop.expand:atom_fresh_[3519]'(_atom__fresh___913520_93, __36Pb, __36Pe)), '<module>:emop.expand:atom_fresh_[3521]'(_atom__fresh___913522_93, __36Pb, __36Pe)), '<module>:emop.expand:atom_fresh_[3523]'(_atom__fresh___913524_93, __36Pb, __36Pe)), '<module>:emop.expand:atom_fresh_[3525]'(_atom__fresh___913526_93, __36Pb, __36Pe)), '<module>:emop.expand:atom_fresh_[3527]'(_atom__fresh___913528_93, __36Pb, __36Pe)), '<module>:emop.expand:atom_fresh_[3529]'(_atom__fresh___913530_93, __36Pb, __36Pe)), '<module>:emop.expand:atom_fresh_[3531]'(_atom__fresh___913532_93, __36Pb, __36Pe)), '<module>:emop.expand:atom_fresh_[3533]'(_atom__fresh___913534_93, __36Pb, __36Pe)), '<module>:emop.expand:atom_fresh_[3535]'(_atom__fresh___913536_93, __36Pb, __36Pe)), '<module>:emop.expand:atom_fresh_[3537]'(_atom__fresh___913538_93, __36Pb, __36Pe)), '<module>:emop.expand:atom_fresh_[3539]'(_atom__fresh___913540_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913540_93, '.'(_atom__fresh___913538_93, '.'(_atom__fresh___913536_93, '.'(_atom__fresh___913534_93, '.'(_atom__fresh___913532_93, '.'(_atom__fresh___913530_93, '.'(_atom__fresh___913528_93, '.'(_atom__fresh___913526_93, '.'(_atom__fresh___913524_93, '.'(_atom__fresh___913522_93, '.'(_atom__fresh___913520_93, '.'(_atom__fresh___913518_93, '.'(_atom__fresh___913516_93, '.'(_atom__fresh___913514_93, '.'(_atom__fresh___913512_93, '.'(_atom__fresh___913510_93, '.'(_atom__fresh___913508_93, '.'(_atom__fresh___913506_93, '.'(_atom__fresh___913504_93, '.'(_atom__fresh___913502_93, '.'(_atom__fresh___913500_93, '.'(_atom__fresh___913498_93, '.'(_atom__fresh___913496_93, '.'(_atom__fresh___913494_93, '.'(_atom__fresh___913492_93, '.'(_atom__fresh___913490_93, '.'(_atom__fresh___913488_93, '.'(_atom__fresh___913486_93, '.'(_atom__fresh___913484_93, '.'(_atom__fresh___913482_93, '.'(_atom__fresh___913480_93, '.'(_atom__fresh___913478_93, '.'(_atom__fresh___913476_93, '.'(_atom__fresh___913474_93, '.'(_atom__fresh___913472_93, '.'(_atom__fresh___913470_93, '.'(_atom__fresh___913468_93, '.'(_atom__fresh___913466_93, '.'(_atom__fresh___913464_93, '.'(_atom__fresh___913462_93, '.'(_atom__fresh___913460_93, '.'(_atom__fresh___913458_93, '.'(_atom__fresh___913456_93, '.'(_atom__fresh___913454_93, '.'(_atom__fresh___913452_93, '.'(_atom__fresh___913450_93, '.'(_atom__fresh___913448_93, '.'(_atom__fresh___913446_93, '[]')))))))))))))))))))))))))))))))))))))))))))))))))))))).
':-'('<module>:emop.expand:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand:=>'(___345, ___346, ___347, 'env'(_Impl, _InitGoalIdRef), __36CutLevel), '=..'(___347, '.'('=>', '.'(___345, '.'(___346, '[]'))))).
':-'('<module>:emop.expand:=>$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand:=>'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand:atom'(___440, ___441, ___442, ___443, 'env'(_Impl, _InitGoalIdRef), __36CutLevel), '=..'(___443, '.'('atom', '.'(___440, '.'(___441, '.'(___442, '[]')))))).
':-'('<module>:emop.expand:atom'(___355, ___356, ___357, ___358, ___359, 'env'(_Impl, _InitGoalIdRef), __36CutLevel), '=..'(___359, '.'('atom', '.'(___355, '.'(___356, '.'(___357, '.'(___358, '[]'))))))).
':-'('<module>:emop.expand:atom$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand:atom'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand:atom$direct'(_____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand:atom'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand:atom_fresh_[3445]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(expand_file, 6, predicate, '[]', __36pos))).
':-'('<module>:emop.expand:atom_fresh_[3447]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fresh_dependencies, 3, predicate, suspended([var('PackageNodes'),var('RootPackagePath'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.expand:atom_fresh_[3449]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(make_scope, 4, predicate, '[]', __36pos))).
':-'('<module>:emop.expand:atom_fresh_[3451]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fresh_init_goal_id, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.expand:atom_fresh_[3453]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(unify_module, 4, predicate, '[]', __36pos))).
':-'('<module>:emop.expand:atom_fresh_[3455]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(eval_suspended, 9, predicate, '[]', __36pos))).
':-'('<module>:emop.expand:atom_fresh_[3457]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(get_args_info, 8, predicate, '[]', __36pos))).
':-'('<module>:emop.expand:atom_fresh_[3459]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(empty, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.expand:atom_fresh_[3461]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(symbol, 6, constructor, none, __36pos))).
':-'('<module>:emop.expand:atom_fresh_[3463]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(callable, 6, constructor, none, __36pos))).
':-'('<module>:emop.expand:atom_fresh_[3465]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(atom, 4, constructor, none, __36pos))).
':-'('<module>:emop.expand:atom_fresh_[3467]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(ctx, 3, constructor, none, __36pos))).
':-'('<module>:emop.expand:atom_fresh_[3469]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(unescaped, 1, constructor, none, __36pos))).
':-'('<module>:emop.expand:atom_fresh_[3471]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(variable, 1, constructor, none, __36pos))).
':-'('<module>:emop.expand:atom_fresh_[3473]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(escaped, 1, constructor, none, __36pos))).
':-'('<module>:emop.expand:atom_fresh_[3475]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(special, 5, constructor, none, __36pos))).
':-'('<module>:emop.expand:atom_fresh_[3477]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(operator, 1, constructor, none, __36pos))).
':-'('<module>:emop.expand:atom_fresh_[3479]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(notation, 4, constructor, none, __36pos))).
':-'('<module>:emop.expand:atom_fresh_[3481]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(syntax, 4, constructor, none, __36pos))).
':-'('<module>:emop.expand:atom_fresh_[3483]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(level, 4, constructor, none, __36pos))).
':-'('<module>:emop.expand:atom_fresh_[3485]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(level, 5, constructor, none, __36pos))).
':-'('<module>:emop.expand:atom_fresh_[3487]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(priority, 3, constructor, none, __36pos))).
':-'('<module>:emop.expand:atom_fresh_[3489]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(file, 2, constructor, none, __36pos))).
':-'('<module>:emop.expand:atom_fresh_[3491]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(file, 3, constructor, none, __36pos))).
':-'('<module>:emop.expand:atom_fresh_[3493]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(error, 3, constructor, none, __36pos))).
':-'('<module>:emop.expand:atom_fresh_[3495]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(none, 1, constructor, none, __36pos))).
':-'('<module>:emop.expand:atom_fresh_[3497]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(var, 2, constructor, none, __36pos))).
':-'('<module>:emop.expand:atom_fresh_[3499]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(var, 5, constructor, none, __36pos))).
':-'('<module>:emop.expand:atom_fresh_[3501]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(dep, 3, constructor, none, __36pos))).
':-'('<module>:emop.expand:atom_fresh_[3503]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(dep, 4, constructor, none, __36pos))).
':-'('<module>:emop.expand:atom_fresh_[3505]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(callable, 3, constructor, none, __36pos))).
':-'('<module>:emop.expand:atom_fresh_[3507]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(doc, 4, constructor, none, __36pos))).
':-'('<module>:emop.expand:atom_fresh_[3509]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(clause, 5, constructor, none, __36pos))).
':-'('<module>:emop.expand:atom_fresh_[3511]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(directive, 2, constructor, none, __36pos))).
':-'('<module>:emop.expand:atom_fresh_[3513]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(some, 3, constructor, none, __36pos))).
':-'('<module>:emop.expand:atom_fresh_[3515]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(some, 2, constructor, none, __36pos))).
':-'('<module>:emop.expand:atom_fresh_[3517]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(scope, 4, constructor, none, __36pos))).
':-'('<module>:emop.expand:atom_fresh_[3519]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(number, 2, constructor, none, __36pos))).
':-'('<module>:emop.expand:atom_fresh_[3521]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(atom, 5, constructor, none, __36pos))).
':-'('<module>:emop.expand:atom_fresh_[3523]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(clause, 7, constructor, none, __36pos))).
':-'('<module>:emop.expand:atom_fresh_[3525]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(=>, 3, constructor, none, __36pos))).
':-'('<module>:emop.expand:atom_fresh_[3527]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(operator, 3, constructor, none, __36pos))).
':-'('<module>:emop.expand:atom_fresh_[3529]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(number, 4, constructor, none, __36pos))).
':-'('<module>:emop.expand:atom_fresh_[3531]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(empty, 3, constructor, none, __36pos))).
':-'('<module>:emop.expand:atom_fresh_[3533]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(doc, 5, constructor, none, __36pos))).
':-'('<module>:emop.expand:atom_fresh_[3535]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(grammar, 6, constructor, none, __36pos))).
':-'('<module>:emop.expand:atom_fresh_[3537]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(module, 8, constructor, none, __36pos))).
':-'('<module>:emop.expand:atom_fresh_[3539]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(term, 2, constructor, none, __36pos))).
':-'('<module>:emop.expand:callable'(___382, ___383, ___384, 'env'(_Impl, _InitGoalIdRef), __36CutLevel), '=..'(___384, '.'('callable', '.'(___382, '.'(___383, '[]'))))).
':-'('<module>:emop.expand:callable'(___444, ___445, ___446, ___447, ___448, ___449, 'env'(_Impl, _InitGoalIdRef), __36CutLevel), '=..'(___449, '.'('callable', '.'(___444, '.'(___445, '.'(___446, '.'(___447, '.'(___448, '[]')))))))).
':-'('<module>:emop.expand:callable$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand:callable'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand:callable$direct'(_____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand:callable'(_____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand:clause'(___373, ___374, ___375, ___376, ___377, 'env'(_Impl, _InitGoalIdRef), __36CutLevel), '=..'(___377, '.'('clause', '.'(___373, '.'(___374, '.'(___375, '.'(___376, '[]'))))))).
':-'('<module>:emop.expand:clause'(___348, ___349, ___350, ___351, ___352, ___353, ___354, 'env'(_Impl, _InitGoalIdRef), __36CutLevel), '=..'(___354, '.'('clause', '.'(___348, '.'(___349, '.'(___350, '.'(___351, '.'(___352, '.'(___353, '[]'))))))))).
':-'('<module>:emop.expand:clause$direct'(_____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand:clause'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand:clause$direct'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand:clause'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand:ctx'(___437, ___438, ___439, 'env'(_Impl, _InitGoalIdRef), __36CutLevel), '=..'(___439, '.'('ctx', '.'(___437, '.'(___438, '[]'))))).
':-'('<module>:emop.expand:ctx$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand:ctx'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand:dep'(___389, ___390, ___391, 'env'(_Impl, _InitGoalIdRef), __36CutLevel), '=..'(___391, '.'('dep', '.'(___389, '.'(___390, '[]'))))).
':-'('<module>:emop.expand:dep'(___385, ___386, ___387, ___388, 'env'(_Impl, _InitGoalIdRef), __36CutLevel), '=..'(___388, '.'('dep', '.'(___385, '.'(___386, '.'(___387, '[]')))))).
':-'('<module>:emop.expand:dep$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand:dep'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand:dep$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand:dep'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand:directive'(___371, ___372, 'env'(_Impl, _InitGoalIdRef), __36CutLevel), '=..'(___372, '.'('directive', '.'(___371, '[]')))).
':-'('<module>:emop.expand:directive$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand:directive'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand:doc'(___378, ___379, ___380, ___381, 'env'(_Impl, _InitGoalIdRef), __36CutLevel), '=..'(___381, '.'('doc', '.'(___378, '.'(___379, '.'(___380, '[]')))))).
':-'('<module>:emop.expand:doc'(___330, ___331, ___332, ___333, ___334, 'env'(_Impl, _InitGoalIdRef), __36CutLevel), '=..'(___334, '.'('doc', '.'(___330, '.'(___331, '.'(___332, '.'(___333, '[]'))))))).
':-'('<module>:emop.expand:doc$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand:doc'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand:doc$direct'(_____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand:doc'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand:empty'('[]', 'env'(_Impl, _InitGoalIdRef), __36CutLevel), 'true').
':-'('<module>:emop.expand:empty'('none', 'env'(_Impl, _InitGoalIdRef), __36CutLevel), 'true').
':-'('<module>:emop.expand:empty'(___335, ___336, ___337, 'env'(_Impl, _InitGoalIdRef), __36CutLevel), '=..'(___337, '.'('empty', '.'(___335, '.'(___336, '[]'))))).
':-'('<module>:emop.expand:empty$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand:empty'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand:empty$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand:empty'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand:error'(___400, ___401, ___402, 'env'(_Impl, _InitGoalIdRef), __36CutLevel), '=..'(___402, '.'('error', '.'(___400, '.'(___401, '[]'))))).
':-'('<module>:emop.expand:error$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand:error'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand:escaped'(___434, 'env'(_Impl, _InitGoalIdRef), __36CutLevel), '=..'(___434, '.'('escaped', '[]'))).
':-'('<module>:emop.expand:escaped$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand:escaped'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand:eval_suspended'(_ArgsTarget, _CArgs, _CList, _SupEnv, _Cache, _Dependencies, _Pos, _Fids, _MSgn, 'env'(_Impl, _InitGoalIdRef), __36CutLevel), ';'('->'(';'('='(_ArgsTarget, 'none'), '='(_CArgs, 'none')), 'true'), ','(','('='(_EvalEnv, ___471), ','('g_read'('data.record', '<module>:data.record'(___472)), '<module>:data.record:{}$direct'(___471, ___472))), ','(','(','('true', ';'('->'('var'(___473), ','('g_inc'('$module_count', ___474), '='(___473, '$module'(___474, '.'('<module>:emop.expand@7'('env'(___473, _Impl, _InitGoalIdRef, _ArgsTarget, _CArgs, _CList, _Cache, _Dependencies, _EvalEnv, _Fids, _MSgn, _Pos, _SupEnv)), '[]'), '.'(___473, '[]'))))), ','('='(___473, '$module'(___474, ___475, _)), ','('='('.'(___476, ___477), ___475), ','('setarg'(1, ___475, '<module>:emop.expand@7'('env'(___473, _Impl, _InitGoalIdRef, _ArgsTarget, _CArgs, _CList, _Cache, _Dependencies, _EvalEnv, _Fids, _MSgn, _Pos, _SupEnv))), 'setarg'(2, ___475, '.'(___476, ___477))))))), 'emop_call'(___473, 'do'(_CArgs, _ArgsTarget), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 66, from character 11 to 13')), ','(','('true', ';'('->'('var'(___480), ','('g_inc'('$module_count', ___481), '='(___480, '$module'(___481, '.'('<module>:emop.expand@8'('env'(___480, _Impl, _InitGoalIdRef, _ArgsTarget, _CArgs, _CList, _Cache, _Dependencies, _EvalEnv, _Fids, _MSgn, _Pos, _SupEnv)), '[]'), '.'(___480, '[]'))))), ','('='(___480, '$module'(___481, ___482, _)), ','('='('.'(___483, ___484), ___482), ','('setarg'(1, ___482, '<module>:emop.expand@8'('env'(___480, _Impl, _InitGoalIdRef, _ArgsTarget, _CArgs, _CList, _Cache, _Dependencies, _EvalEnv, _Fids, _MSgn, _Pos, _SupEnv))), 'setarg'(2, ___482, '.'(___483, ___484))))))), ','('g_read'('data.list', '<module>:data.list'(___486)), '<module>:data.list:iter$direct'(_CList, ___480, ___486))))))).
':-'('<module>:emop.expand:eval_suspended$direct'(_____9, _____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand:eval_suspended'(_____9, _____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand:expand_file'(_Fid, _MainSgn, _Filename, _FileXml, _Dependencies, _Expander, 'env'(_Impl, _InitGoalIdRef), __36CutLevel), ','(','(','('g_read'('data.ref.backtrackable', '<module>:data.ref.backtrackable'(___540)), '<module>:data.ref.backtrackable:new$direct'('[]', _ClausesRef, ___540)), ','(','('g_read'('data.ref.backtrackable', '<module>:data.ref.backtrackable'(___542)), '<module>:data.ref.backtrackable:new$direct'('[]', _ModuleListRef, ___542)), ','(','('g_read'('data.ref.backtrackable', '<module>:data.ref.backtrackable'(___544)), '<module>:data.ref.backtrackable:new$direct'('[]', _ModuleQueue, ___544)), ','(','('g_read'('data.ref.backtrackable', '<module>:data.ref.backtrackable'(___546)), '<module>:data.ref.backtrackable:new$direct'('[]', _CheckQueue, ___546)), ','(','('g_read'('data.ref.backtrackable', '<module>:data.ref.backtrackable'(___547)), '<module>:data.ref.backtrackable:new$direct'(0, _PredicateIdCounterRef, ___547)), ','('g_read'('data.ref.backtrackable', '<module>:data.ref.backtrackable'(___548)), '<module>:data.ref.backtrackable:new$direct'(0, _FreshModuleCounterRef, ___548))))))), ','(','('true', ';'('->'('var'(_ExpandFile), ','('g_inc'('$module_count', ___549), '='(_ExpandFile, '$module'(___549, '.'('<module>:emop.expand@10'('env'(_ExpandFile, _ExpandFile, _Impl, _Fid, _MainSgn, _HasMainModule, _FileXml, _Dependencies, _ModuleListRef, _ClausesRef, _PredicateIdCounterRef, _FreshModuleCounterRef, _ModuleQueue, _CheckQueue)), '[]'), '.'(_ExpandFile, '[]'))))), ','('='(_ExpandFile, '$module'(___549, ___550, _)), ','('='('.'(___551, ___552), ___550), ','('setarg'(1, ___550, '<module>:emop.expand@10'('env'(_ExpandFile, _ExpandFile, _Impl, _Fid, _MainSgn, _HasMainModule, _FileXml, _Dependencies, _ModuleListRef, _ClausesRef, _PredicateIdCounterRef, _FreshModuleCounterRef, _ModuleQueue, _CheckQueue))), 'setarg'(2, ___550, '.'(___551, ___552))))))), ','(','('='(_ImplicitConstructorsRef, ___556), ','('g_read'('data.ref.backtrackable', '<module>:data.ref.backtrackable'(___557)), '<module>:data.ref.backtrackable:new$direct'('[]', ___556, ___557))), ','('true', ';'('->'('var'(_Expander), ','('g_inc'('$module_count', ___558), '='(_Expander, '$module'(___558, '.'('<module>:emop.expand@11'('env'(_Expander, _Impl, _InitGoalIdRef, _CheckQueue, _ClausesRef, _Dependencies, _ExpandFile, _Expander, _Fid, _FileXml, _Filename, _FreshModuleCounterRef, _HasMainModule, _ImplicitConstructorsRef, _MainSgn, _ModuleListRef, _ModuleQueue, _PredicateIdCounterRef)), '[]'), '.'(_Expander, '[]'))))), ','('='(_Expander, '$module'(___558, ___559, _)), ','('='('.'(___560, ___561), ___559), ','('setarg'(1, ___559, '<module>:emop.expand@11'('env'(_Expander, _Impl, _InitGoalIdRef, _CheckQueue, _ClausesRef, _Dependencies, _ExpandFile, _Expander, _Fid, _FileXml, _Filename, _FreshModuleCounterRef, _HasMainModule, _ImplicitConstructorsRef, _MainSgn, _ModuleListRef, _ModuleQueue, _PredicateIdCounterRef))), 'setarg'(2, ___559, '.'(___560, ___561))))))))))).
':-'('<module>:emop.expand:expand_file$direct'(_____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand:expand_file'(_____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand:file'(___406, ___407, 'env'(_Impl, _InitGoalIdRef), __36CutLevel), '=..'(___407, '.'('file', '.'(___406, '[]')))).
':-'('<module>:emop.expand:file'(___403, ___404, ___405, 'env'(_Impl, _InitGoalIdRef), __36CutLevel), '=..'(___405, '.'('file', '.'(___403, '.'(___404, '[]'))))).
':-'('<module>:emop.expand:file$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand:file'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand:file$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand:file'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand:fresh_dependencies'(_PackageNodes, _RootPackagePath, ___532, 'env'(_Impl, _InitGoalIdRef), __36CutLevel), ','(','(','('='(_DependenciesRef, ___524), ','('g_read'('data.ref.backtrackable', '<module>:data.ref.backtrackable'(___525)), '<module>:data.ref.backtrackable:new$direct'('[]', ___524, ___525))), ','(','('='(_ExpandDependenciesRef, ___527), ','('g_read'('data.ref.backtrackable', '<module>:data.ref.backtrackable'(___528)), '<module>:data.ref.backtrackable:new$direct'('[]', ___527, ___528))), ','('='(_LinkRef, ___530), ','('g_read'('data.ref.backtrackable', '<module>:data.ref.backtrackable'(___531)), '<module>:data.ref.backtrackable:new$direct'('[]', ___530, ___531))))), ','('true', ';'('->'('var'(___532), ','('g_inc'('$module_count', ___533), '='(___532, '$module'(___533, '.'('<module>:emop.expand@9'('env'(___532, _Impl, _InitGoalIdRef, _DependenciesRef, _ExpandDependenciesRef, _LinkRef, _PackageNodes, _RootPackagePath)), '[]'), '.'(___532, '[]'))))), ','('='(___532, '$module'(___533, ___534, _)), ','('='('.'(___535, ___536), ___534), ','('setarg'(1, ___534, '<module>:emop.expand@9'('env'(___532, _Impl, _InitGoalIdRef, _DependenciesRef, _ExpandDependenciesRef, _LinkRef, _PackageNodes, _RootPackagePath))), 'setarg'(2, ___534, '.'(___535, ___536))))))))).
':-'('<module>:emop.expand:fresh_dependencies$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand:fresh_dependencies'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand:fresh_init_goal_id'(_V, 'env'(_Impl, _InitGoalIdRef), __36CutLevel), ','(';'('->'(','('g_read'('data.var', '<module>:data.var'(___510)), '<module>:data.var:check$direct'(_InitGoalIdRef, ___510)), ','('='(_InitGoalIdRef, ___512), ','('g_read'('data.ref.non_backtrackable', '<module>:data.ref.non_backtrackable'(___513)), '<module>:data.ref.non_backtrackable:new$direct'(0, ___512, ___513)))), 'true'), ','('='(_V, ___515), ','('g_read'('data.number', '<module>:data.number'(___516)), '<module>:data.number:|++$direct'(_InitGoalIdRef, ___515, ___516))))).
':-'('<module>:emop.expand:fresh_init_goal_id$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand:fresh_init_goal_id'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand:get_args_info'(_ArgsInfo, _MSgn, _EvalEnv, _Cache, _Dependencies, _Pos, _Fids, _ArgsTarget, 'env'(_Impl, _InitGoalIdRef), __36CutLevel), ';'('->'(';'('='(_ArgsInfo, 'none'), '='(_ArgsTarget, 'none')), 'true'), ';'('->'('='(_ArgsInfo, 'suspended'(_CArgs, _CList)), ','('g_read'('emop.expand', '<module>:emop.expand'(___461)), '<module>:emop.expand:eval_suspended$direct'(_ArgsTarget, _CArgs, _CList, _EvalEnv, _Cache, _Dependencies, _Pos, _Fids, _MSgn, ___461))), ','(','('true', ';'('->'('var'(___462), ','('g_inc'('$module_count', ___463), '='(___462, '$module'(___463, '.'('<module>:emop.expand@6'('env'(___462, _Impl, _InitGoalIdRef, _ArgsInfo, _ArgsTarget, _CArgs, _CList, _Cache, _Dependencies, _EvalEnv, _Fids, _MSgn, _Pos)), '[]'), '.'(___462, '[]'))))), ','('='(___462, '$module'(___463, ___464, _)), ','('='('.'(___465, ___466), ___464), ','('setarg'(1, ___464, '<module>:emop.expand@6'('env'(___462, _Impl, _InitGoalIdRef, _ArgsInfo, _ArgsTarget, _CArgs, _CList, _Cache, _Dependencies, _EvalEnv, _Fids, _MSgn, _Pos))), 'setarg'(2, ___464, '.'(___465, ___466))))))), 'emop_call'(___462, 'do'(_ArgsInfo, _ArgsTarget), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 40, from character 11 to 13'))))).
':-'('<module>:emop.expand:get_args_info$direct'(_____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand:get_args_info'(_____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand:grammar'(___324, ___325, ___326, ___327, ___328, ___329, 'env'(_Impl, _InitGoalIdRef), __36CutLevel), '=..'(___329, '.'('grammar', '.'(___324, '.'(___325, '.'(___326, '.'(___327, '.'(___328, '[]')))))))).
':-'('<module>:emop.expand:grammar$direct'(_____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand:grammar'(_____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand:level'(___416, ___417, ___418, ___419, 'env'(_Impl, _InitGoalIdRef), __36CutLevel), '=..'(___419, '.'('level', '.'(___416, '.'(___417, '.'(___418, '[]')))))).
':-'('<module>:emop.expand:level'(___411, ___412, ___413, ___414, ___415, 'env'(_Impl, _InitGoalIdRef), __36CutLevel), '=..'(___415, '.'('level', '.'(___411, '.'(___412, '.'(___413, '.'(___414, '[]'))))))).
':-'('<module>:emop.expand:level$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand:level'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand:level$direct'(_____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand:level'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand:make_scope'(_Value, _Sgn, _SupScope, _Scope, 'env'(_Impl, _InitGoalIdRef), __36CutLevel), ','('='(_Scope, 'scope'(_Value, _Sgn, ___519)), ','('emop_call'(_Impl, 'grammars'(_SupScope, ___518), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 130, from character 67 to 75'), ','('g_read'('emop.parser', '<module>:emop.parser'(___520)), '<module>:emop.parser:make_grammar$direct'(_Sgn, ___518, ___519, ___520))))).
':-'('<module>:emop.expand:make_scope$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand:make_scope'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand:module'(___316, ___317, ___318, ___319, ___320, ___321, ___322, ___323, 'env'(_Impl, _InitGoalIdRef), __36CutLevel), '=..'(___323, '.'('module', '.'(___316, '.'(___317, '.'(___318, '.'(___319, '.'(___320, '.'(___321, '.'(___322, '[]')))))))))).
':-'('<module>:emop.expand:module$direct'(_____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand:module'(_____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand:none'(___399, 'env'(_Impl, _InitGoalIdRef), __36CutLevel), '=..'(___399, '.'('none', '[]'))).
':-'('<module>:emop.expand:none$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand:none'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand:notation'(___424, ___425, ___426, ___427, 'env'(_Impl, _InitGoalIdRef), __36CutLevel), '=..'(___427, '.'('notation', '.'(___424, '.'(___425, '.'(___426, '[]')))))).
':-'('<module>:emop.expand:notation$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand:notation'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand:number'(___360, ___361, 'env'(_Impl, _InitGoalIdRef), __36CutLevel), '=..'(___361, '.'('number', '.'(___360, '[]')))).
':-'('<module>:emop.expand:number'(___338, ___339, ___340, ___341, 'env'(_Impl, _InitGoalIdRef), __36CutLevel), '=..'(___341, '.'('number', '.'(___338, '.'(___339, '.'(___340, '[]')))))).
':-'('<module>:emop.expand:number$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand:number'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand:number$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand:number'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand:operator'(___428, 'env'(_Impl, _InitGoalIdRef), __36CutLevel), '=..'(___428, '.'('operator', '[]'))).
':-'('<module>:emop.expand:operator'(___342, ___343, ___344, 'env'(_Impl, _InitGoalIdRef), __36CutLevel), '=..'(___344, '.'('operator', '.'(___342, '.'(___343, '[]'))))).
':-'('<module>:emop.expand:operator$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand:operator'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand:operator$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand:operator'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand:priority'(___408, ___409, ___410, 'env'(_Impl, _InitGoalIdRef), __36CutLevel), '=..'(___410, '.'('priority', '.'(___408, '.'(___409, '[]'))))).
':-'('<module>:emop.expand:priority$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand:priority'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand:scope'(___362, ___363, ___364, ___365, 'env'(_Impl, _InitGoalIdRef), __36CutLevel), '=..'(___365, '.'('scope', '.'(___362, '.'(___363, '.'(___364, '[]')))))).
':-'('<module>:emop.expand:scope$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand:scope'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand:some'(___366, ___367, 'env'(_Impl, _InitGoalIdRef), __36CutLevel), '=..'(___367, '.'('some', '.'(___366, '[]')))).
':-'('<module>:emop.expand:some'(___368, ___369, ___370, 'env'(_Impl, _InitGoalIdRef), __36CutLevel), '=..'(___370, '.'('some', '.'(___368, '.'(___369, '[]'))))).
':-'('<module>:emop.expand:some$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand:some'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand:some$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand:some'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand:special'(___429, ___430, ___431, ___432, ___433, 'env'(_Impl, _InitGoalIdRef), __36CutLevel), '=..'(___433, '.'('special', '.'(___429, '.'(___430, '.'(___431, '.'(___432, '[]'))))))).
':-'('<module>:emop.expand:special$direct'(_____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand:special'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand:symbol'(___450, ___451, ___452, ___453, ___454, ___455, 'env'(_Impl, _InitGoalIdRef), __36CutLevel), '=..'(___455, '.'('symbol', '.'(___450, '.'(___451, '.'(___452, '.'(___453, '.'(___454, '[]')))))))).
':-'('<module>:emop.expand:symbol$direct'(_____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand:symbol'(_____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand:syntax'(___420, ___421, ___422, ___423, 'env'(_Impl, _InitGoalIdRef), __36CutLevel), '=..'(___423, '.'('syntax', '.'(___420, '.'(___421, '.'(___422, '[]')))))).
':-'('<module>:emop.expand:syntax$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand:syntax'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand:term'(___314, ___315, 'env'(_Impl, _InitGoalIdRef), __36CutLevel), '=..'(___315, '.'('term', '.'(___314, '[]')))).
':-'('<module>:emop.expand:term$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand:term'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand:unescaped'(___436, 'env'(_Impl, _InitGoalIdRef), __36CutLevel), '=..'(___436, '.'('unescaped', '[]'))).
':-'('<module>:emop.expand:unescaped$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand:unescaped'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand:unify_module'(_EvalEnv, _Var, _NewSgn, _NewFids, 'env'(_Impl, _InitGoalIdRef), __36CutLevel), ','(','('='(_VAS, ___487), 'emop_call'(_EvalEnv, '{}'(_Var, ___487), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 108, from character 20 to 21')), ';'('->'(','('g_read'('data.var', '<module>:data.var'(___489)), '<module>:data.var:check$direct'(_VAS, ___489)), ','('='(_VAS, ___493), ','('g_read'('data.ref.backtrackable', '<module>:data.ref.backtrackable'(___494)), '<module>:data.ref.backtrackable:new$direct'('root'(','(_NewFids, _NewSgn)), ___493, ___494)))), ','(','('='(_VAR, ___496), ','('g_read'('emop.unionfind', '<module>:emop.unionfind'(___497)), '<module>:emop.unionfind:get_root$direct'(_VAS, ___496, ___497))), ','(','('='('root'(','(_OldFids, _VARS)), ___500), 'emop_call'(_VAR, 'get'(___500), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 115, from character 39 to 42')), ','(','(','('g_read'('data.list', '<module>:data.list'(___503)), '<module>:data.list:append$direct'(_NewFids, _OldFids, ___502, ___503)), ','('g_read'('data.list', '<module>:data.list'(___506)), '<module>:data.list:append$direct'(_VARS, _NewSgn, ___505, ___506))), 'emop_call'(_VAR, 'set'('root'(','(___502, ___505))), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 116, from character 13 to 16'))))))).
':-'('<module>:emop.expand:unify_module$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand:unify_module'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand:var'(___397, ___398, 'env'(_Impl, _InitGoalIdRef), __36CutLevel), '=..'(___398, '.'('var', '.'(___397, '[]')))).
':-'('<module>:emop.expand:var'(___392, ___393, ___394, ___395, ___396, 'env'(_Impl, _InitGoalIdRef), __36CutLevel), '=..'(___396, '.'('var', '.'(___392, '.'(___393, '.'(___394, '.'(___395, '[]'))))))).
':-'('<module>:emop.expand:var$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand:var'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand:var$direct'(_____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand:var'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand:variable'(___435, 'env'(_Impl, _InitGoalIdRef), __36CutLevel), '=..'(___435, '.'('variable', '[]'))).
':-'('<module>:emop.expand:variable$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand:variable'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@0'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@0:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@0'('scope'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@0:scope'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@0'('module'(_____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@0:module'(_____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@0'('operator'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@0:operator'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@0'('unescaped'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@0:unescaped'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@0'('/'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@0:/'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@0'('var'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@0:var'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@0'('doc'(_____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@0:doc'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@0'('var'(_____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@0:var'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@0'('dep'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@0:dep'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@0'('error'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@0:error'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@0'('callable'(_____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@0:callable'(_____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@0'('file'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@0:file'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@0'('grammars'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@0:grammars'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@0'('warning_implicit_constructors'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@0:warning_implicit_constructors'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@0'('warning_implicit_constructors_aux'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@0:warning_implicit_constructors_aux'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@0'('var_lookup'(_____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@0:var_lookup'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@0'('extract_env'(_____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@0:extract_env'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@0'('callable'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@0:callable'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@0'('seq'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@0:seq'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@0'('has_cut'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@0:has_cut'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@0'('seq_eq'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@0:seq_eq'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@0'('check_prefix_used'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@0:check_prefix_used'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@0'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.expand@0$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.expand@0$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.expand@0$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.expand@0$has_predicate'('scope'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand@0$has_predicate'('module'(_____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand@0$has_predicate'('operator'(_____1)), 'true').
':-'('<module>:emop.expand@0$has_predicate'('unescaped'(_____1)), 'true').
':-'('<module>:emop.expand@0$has_predicate'('/'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand@0$has_predicate'('var'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand@0$has_predicate'('doc'(_____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand@0$has_predicate'('var'(_____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand@0$has_predicate'('dep'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand@0$has_predicate'('error'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand@0$has_predicate'('callable'(_____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand@0$has_predicate'('file'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand@0$has_predicate'('grammars'(_____2, _____1)), 'true').
':-'('<module>:emop.expand@0$has_predicate'('warning_implicit_constructors'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand@0$has_predicate'('warning_implicit_constructors_aux'(_____2, _____1)), 'true').
':-'('<module>:emop.expand@0$has_predicate'('var_lookup'(_____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand@0$has_predicate'('extract_env'(_____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand@0$has_predicate'('callable'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand@0$has_predicate'('seq'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand@0$has_predicate'('has_cut'(_____1)), 'true').
':-'('<module>:emop.expand@0$has_predicate'('seq_eq'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand@0$has_predicate'('check_prefix_used'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand@0:$sgn'(__36sgn, 'env'(___8), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',81002,1991,81002)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',81018,1991,81002)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','('true', '<module>:emop.expand@0:atom_fresh_[3391]'(_atom__fresh___913392_93, __36Pb, __36Pe)), '<module>:emop.expand@0:atom_fresh_[3393]'(_atom__fresh___913394_93, __36Pb, __36Pe)), '<module>:emop.expand@0:atom_fresh_[3395]'(_atom__fresh___913396_93, __36Pb, __36Pe)), '<module>:emop.expand@0:atom_fresh_[3397]'(_atom__fresh___913398_93, __36Pb, __36Pe)), '<module>:emop.expand@0:atom_fresh_[3399]'(_atom__fresh___913400_93, __36Pb, __36Pe)), '<module>:emop.expand@0:atom_fresh_[3401]'(_atom__fresh___913402_93, __36Pb, __36Pe)), '<module>:emop.expand@0:atom_fresh_[3403]'(_atom__fresh___913404_93, __36Pb, __36Pe)), '<module>:emop.expand@0:atom_fresh_[3405]'(_atom__fresh___913406_93, __36Pb, __36Pe)), '<module>:emop.expand@0:atom_fresh_[3407]'(_atom__fresh___913408_93, __36Pb, __36Pe)), '<module>:emop.expand@0:atom_fresh_[3409]'(_atom__fresh___913410_93, __36Pb, __36Pe)), '<module>:emop.expand@0:atom_fresh_[3411]'(_atom__fresh___913412_93, __36Pb, __36Pe)), '<module>:emop.expand@0:atom_fresh_[3413]'(_atom__fresh___913414_93, __36Pb, __36Pe)), '<module>:emop.expand@0:atom_fresh_[3415]'(_atom__fresh___913416_93, __36Pb, __36Pe)), '<module>:emop.expand@0:atom_fresh_[3417]'(_atom__fresh___913418_93, __36Pb, __36Pe)), '<module>:emop.expand@0:atom_fresh_[3419]'(_atom__fresh___913420_93, __36Pb, __36Pe)), '<module>:emop.expand@0:atom_fresh_[3421]'(_atom__fresh___913422_93, __36Pb, __36Pe)), '<module>:emop.expand@0:atom_fresh_[3423]'(_atom__fresh___913424_93, __36Pb, __36Pe)), '<module>:emop.expand@0:atom_fresh_[3425]'(_atom__fresh___913426_93, __36Pb, __36Pe)), '<module>:emop.expand@0:atom_fresh_[3427]'(_atom__fresh___913428_93, __36Pb, __36Pe)), '<module>:emop.expand@0:atom_fresh_[3429]'(_atom__fresh___913430_93, __36Pb, __36Pe)), '<module>:emop.expand@0:atom_fresh_[3431]'(_atom__fresh___913432_93, __36Pb, __36Pe)), '<module>:emop.expand@0:atom_fresh_[3433]'(_atom__fresh___913434_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913434_93, '.'(_atom__fresh___913432_93, '.'(_atom__fresh___913430_93, '.'(_atom__fresh___913428_93, '.'(_atom__fresh___913426_93, '.'(_atom__fresh___913424_93, '.'(_atom__fresh___913422_93, '.'(_atom__fresh___913420_93, '.'(_atom__fresh___913418_93, '.'(_atom__fresh___913416_93, '.'(_atom__fresh___913414_93, '.'(_atom__fresh___913412_93, '.'(_atom__fresh___913410_93, '.'(_atom__fresh___913408_93, '.'(_atom__fresh___913406_93, '.'(_atom__fresh___913404_93, '.'(_atom__fresh___913402_93, '.'(_atom__fresh___913400_93, '.'(_atom__fresh___913398_93, '.'(_atom__fresh___913396_93, '.'(_atom__fresh___913394_93, '.'(_atom__fresh___913392_93, '[]')))))))))))))))))))))))))))).
':-'('<module>:emop.expand@0:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@0:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@0:/'(___23, ___24, ___25, 'env'(___8), __36CutLevel), '=..'(___25, '.'('/', '.'(___23, '.'(___24, '[]'))))).
':-'('<module>:emop.expand@0:/$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@0:/'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@0:atom_fresh_[3391]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(check_prefix_used, 3, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@0:atom_fresh_[3393]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(seq_eq, 3, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@0:atom_fresh_[3395]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(has_cut, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@0:atom_fresh_[3397]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(seq, 3, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@0:atom_fresh_[3399]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(callable, 3, constructor, none, __36pos))).
':-'('<module>:emop.expand@0:atom_fresh_[3401]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(extract_env, 5, predicate, suspended([var('StructEnv'),var('EnvRec'),var('Env'),var('SupSgnVars'),var('SgnVars')],[module('Extract',[symbol(do,2,predicate,[none,none],file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',82857,2040,82798),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',84079,2080,84065)))]),call(atom('data.list'),morph,[var('StructEnv'),var('Extract'),var('Env')])]), __36pos))).
':-'('<module>:emop.expand@0:atom_fresh_[3403]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(var_lookup, 5, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@0:atom_fresh_[3405]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(warning_implicit_constructors_aux, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@0:atom_fresh_[3407]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(warning_implicit_constructors, 3, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@0:atom_fresh_[3409]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(grammars, 2, predicate, suspended([none,none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.expand@0:atom_fresh_[3411]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(file, 3, constructor, none, __36pos))).
':-'('<module>:emop.expand@0:atom_fresh_[3413]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(callable, 6, constructor, none, __36pos))).
':-'('<module>:emop.expand@0:atom_fresh_[3415]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(error, 3, constructor, none, __36pos))).
':-'('<module>:emop.expand@0:atom_fresh_[3417]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(dep, 3, constructor, none, __36pos))).
':-'('<module>:emop.expand@0:atom_fresh_[3419]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(var, 5, constructor, none, __36pos))).
':-'('<module>:emop.expand@0:atom_fresh_[3421]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(doc, 5, constructor, none, __36pos))).
':-'('<module>:emop.expand@0:atom_fresh_[3423]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(var, 4, constructor, none, __36pos))).
':-'('<module>:emop.expand@0:atom_fresh_[3425]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(/, 3, constructor, none, __36pos))).
':-'('<module>:emop.expand@0:atom_fresh_[3427]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(unescaped, 1, constructor, none, __36pos))).
':-'('<module>:emop.expand@0:atom_fresh_[3429]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(operator, 1, constructor, none, __36pos))).
':-'('<module>:emop.expand@0:atom_fresh_[3431]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(module, 8, constructor, none, __36pos))).
':-'('<module>:emop.expand@0:atom_fresh_[3433]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(scope, 4, constructor, none, __36pos))).
':-'('<module>:emop.expand@0:callable'(___55, ___56, ___57, 'env'(___8), __36CutLevel), '=..'(___57, '.'('callable', '.'(___55, '.'(___56, '[]'))))).
':-'('<module>:emop.expand@0:callable'(___46, ___47, ___48, ___49, ___50, ___51, 'env'(___8), __36CutLevel), '=..'(___51, '.'('callable', '.'(___46, '.'(___47, '.'(___48, '.'(___49, '.'(___50, '[]')))))))).
':-'('<module>:emop.expand@0:callable$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@0:callable'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@0:callable$direct'(_____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@0:callable'(_____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@0:check_prefix_used'(_Used, _Pb, _Pe, 'env'(___8), __36CutLevel), ';'('->'(','('g_read'('data.var', '<module>:data.var'(___216)), '<module>:data.var:check$direct'(_Used, ___216)), ','('g_read'('emop.message', '<module>:emop.message'(___220)), '<module>:emop.message:warning$direct'('Unused prefix', 'file'(_Pb, _Pe), ___220))), 'true')).
':-'('<module>:emop.expand@0:check_prefix_used$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@0:check_prefix_used'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@0:dep'(___40, ___41, ___42, 'env'(___8), __36CutLevel), '=..'(___42, '.'('dep', '.'(___40, '.'(___41, '[]'))))).
':-'('<module>:emop.expand@0:dep$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@0:dep'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@0:doc'(___30, ___31, ___32, ___33, ___34, 'env'(___8), __36CutLevel), '=..'(___34, '.'('doc', '.'(___30, '.'(___31, '.'(___32, '.'(___33, '[]'))))))).
':-'('<module>:emop.expand@0:doc$direct'(_____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@0:doc'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@0:error'(___43, ___44, ___45, 'env'(___8), __36CutLevel), '=..'(___45, '.'('error', '.'(___43, '.'(___44, '[]'))))).
':-'('<module>:emop.expand@0:error$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@0:error'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@0:extract_env'(_StructEnv, _EnvRec, _Env, _SupSgnVars, _SgnVars, 'env'(___8), __36CutLevel), ','(','('true', ';'('->'('var'(_Extract), ','('g_inc'('$module_count', ___109), '='(_Extract, '$module'(___109, '.'('<module>:emop.expand@4'('env'(_Extract, _Extract, _EnvRec, _SupSgnVars, _SgnVars, ___8)), '[]'), '.'(_Extract, '[]'))))), ','('='(_Extract, '$module'(___109, ___110, _)), ','('='('.'(___111, ___112), ___110), ','('setarg'(1, ___110, '<module>:emop.expand@4'('env'(_Extract, _Extract, _EnvRec, _SupSgnVars, _SgnVars, ___8))), 'setarg'(2, ___110, '.'(___111, ___112))))))), ','('g_read'('data.list', '<module>:data.list'(___115)), '<module>:data.list:morph$direct'(_StructEnv, _Extract, _Env, ___115)))).
':-'('<module>:emop.expand@0:extract_env$direct'(_____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@0:extract_env'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@0:file'(___52, ___53, ___54, 'env'(___8), __36CutLevel), '=..'(___54, '.'('file', '.'(___52, '.'(___53, '[]'))))).
':-'('<module>:emop.expand@0:file$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@0:file'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@0:grammars'('[]', '[]', 'env'(___8), __36CutLevel), 'true').
':-'('<module>:emop.expand@0:grammars'('.'('scope'(_, _, _Grammar), _Scopes), '.'(_Grammar, ___62), 'env'(___8), __36CutLevel), 'emop_call'(___8, 'grammars'(_Scopes, ___62), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1996, from character 58 to 66')).
':-'('<module>:emop.expand@0:grammars$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@0:grammars'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@0:has_cut'('callable'(___127, '.'(_G, '.'(_G_39, '[]'))), 'env'(___8), __36CutLevel), ','(';'('='(___127, ','), ','('='(___127, ___128), ';'('='(___128, ';'), '='(___128, '->')))), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ';'('->'('emop_call'(___8, 'has_cut'(_G), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 2114, from character 9 to 16'), 'true'), 'emop_call'(___8, 'has_cut'(_G_39), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 2118, from character 9 to 16'))))).
':-'('<module>:emop.expand@0:has_cut'('callable'('!', ___136), 'env'(___8), __36CutLevel), ';'('='(___136, '[]'), '='(___136, '.'(_, '[]')))).
':-'('<module>:emop.expand@0:has_cut$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@0:has_cut'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@0:module'(___13, ___14, ___15, ___16, ___17, ___18, ___19, ___20, 'env'(___8), __36CutLevel), '=..'(___20, '.'('module', '.'(___13, '.'(___14, '.'(___15, '.'(___16, '.'(___17, '.'(___18, '.'(___19, '[]')))))))))).
':-'('<module>:emop.expand@0:module$direct'(_____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@0:module'(_____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@0:operator'(___21, 'env'(___8), __36CutLevel), '=..'(___21, '.'('operator', '[]'))).
':-'('<module>:emop.expand@0:operator$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@0:operator'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@0:scope'(___9, ___10, ___11, ___12, 'env'(___8), __36CutLevel), '=..'(___12, '.'('scope', '.'(___9, '.'(___10, '.'(___11, '[]')))))).
':-'('<module>:emop.expand@0:scope$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@0:scope'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@0:seq'('callable'('true', '[]'), _G, _G, 'env'(___8), __36CutLevel), ','('true', ','('='(__36CutLevel, '$cut'), '!'))).
':-'('<module>:emop.expand@0:seq'(_G, 'callable'('true', '[]'), _G, 'env'(___8), __36CutLevel), ','('true', ','('='(__36CutLevel, '$cut'), '!'))).
':-'('<module>:emop.expand@0:seq'(_G0, _G1, 'callable'(',', '.'(_G0, '.'(_G1, '[]'))), 'env'(___8), __36CutLevel), 'true').
':-'('<module>:emop.expand@0:seq$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@0:seq'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@0:seq_eq'('callable'('true', '[]'), _G, _G, 'env'(___8), __36CutLevel), ','('true', ','('='(__36CutLevel, '$cut'), '!'))).
':-'('<module>:emop.expand@0:seq_eq'(_G, 'callable'('true', '[]'), _G, 'env'(___8), __36CutLevel), ','('true', ','('='(__36CutLevel, '$cut'), '!'))).
':-'('<module>:emop.expand@0:seq_eq'(_G0, _G1, 'callable'(',', '.'(_G0, '.'(_G1, '[]'))), 'env'(___8), __36CutLevel), ','('emop_call'(___8, 'has_cut'(_G0), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 2127, from character 7 to 14'), ','('true', ','('='(__36CutLevel, '$cut'), '!')))).
':-'('<module>:emop.expand@0:seq_eq'(_G, 'callable'('=', '.'(_X, '.'(_Y, '[]'))), 'callable'(',', '.'('callable'('=', '.'(_X, '.'(_Y, '[]'))), '.'(_G, '[]'))), 'env'(___8), __36CutLevel), ','('true', ','('='(__36CutLevel, '$cut'), '!'))).
':-'('<module>:emop.expand@0:seq_eq'(_G0, 'callable'(',', '.'('callable'(',', '.'(_G1, '.'(_G2, '[]'))), '.'(_G3, '[]'))), ___188, 'env'(___8), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), 'emop_call'(___8, 'seq_eq'(_G0, 'callable'(',', '.'(_G1, '.'('callable'(',', '.'(_G2, '.'(_G3, '[]'))), '[]'))), ___188), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 2131, from character 11 to 17'))).
':-'('<module>:emop.expand@0:seq_eq'(_G0, 'callable'(',', '.'('callable'('=', '.'(_X, '.'(_Y, '[]'))), '.'(_G1, '[]'))), 'callable'(',', '.'('callable'('=', '.'(_X, '.'(_Y, '[]'))), '.'(___205, '[]'))), 'env'(___8), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), 'emop_call'(___8, 'seq_eq'(_G0, _G1, ___205), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 2133, from character 49 to 55'))).
':-'('<module>:emop.expand@0:seq_eq'(_G0, _G1, 'callable'(',', '.'(_G0, '.'(_G1, '[]'))), 'env'(___8), __36CutLevel), 'true').
':-'('<module>:emop.expand@0:seq_eq$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@0:seq_eq'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@0:unescaped'(___22, 'env'(___8), __36CutLevel), '=..'(___22, '.'('unescaped', '[]'))).
':-'('<module>:emop.expand@0:unescaped$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@0:unescaped'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@0:var'(___26, ___27, ___28, ___29, 'env'(___8), __36CutLevel), '=..'(___29, '.'('var', '.'(___26, '.'(___27, '.'(___28, '[]')))))).
':-'('<module>:emop.expand@0:var'(___35, ___36, ___37, ___38, ___39, 'env'(___8), __36CutLevel), '=..'(___39, '.'('var', '.'(___35, '.'(___36, '.'(___37, '.'(___38, '[]'))))))).
':-'('<module>:emop.expand@0:var$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@0:var'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@0:var$direct'(_____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@0:var'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@0:var_lookup'(_Name, _PB, _PE, _Vars, _Var, 'env'(___8), __36CutLevel), ','(','('='(_Var, ___102), 'emop_call'(_Vars, '{}'(_Name, ___102), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 2029, from character 18 to 19')), ';'('->'(','('g_read'('data.var', '<module>:data.var'(___104)), '<module>:data.var:check$direct'(_Var, ___104)), '='(_Var, 'var'(_PB, _PE, 'local', _))), '='(_Var, 'var'(_, _, _, 'non_singleton'))))).
':-'('<module>:emop.expand@0:var_lookup$direct'(_____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@0:var_lookup'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@0:warning_implicit_constructors'(_Constructors, _Dependencies, _Pos, 'env'(___8), __36CutLevel), ','(','('='(_Constructors0, ___72), ','(','('true', ';'('->'('var'(___66), ','('g_inc'('$module_count', ___67), '='(___66, '$module'(___67, '.'('<module>:emop.expand@1'('env'(___66, _Dependencies, ___8)), '[]'), '.'(___66, '[]'))))), ','('='(___66, '$module'(___67, ___68, _)), ','('='('.'(___69, ___70), ___68), ','('setarg'(1, ___68, '<module>:emop.expand@1'('env'(___66, _Dependencies, ___8))), 'setarg'(2, ___68, '.'(___69, ___70))))))), ','('g_read'('data.list', '<module>:data.list'(___73)), '<module>:data.list:fold_left$direct'(_Constructors, '[]', ___66, ___72, ___73)))), 'emop_call'(___8, 'warning_implicit_constructors_aux'(_Constructors0, _Pos), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 2004, from character 6 to 39'))).
':-'('<module>:emop.expand@0:warning_implicit_constructors$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@0:warning_implicit_constructors'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@0:warning_implicit_constructors_aux'('[]', _, 'env'(___8), __36CutLevel), ','('true', ','('='(__36CutLevel, '$cut'), '!'))).
':-'('<module>:emop.expand@0:warning_implicit_constructors_aux'(_Constructors, _Pos, 'env'(___8), __36CutLevel), ','(','('='(_Sgn, ___82), ','(','('true', ';'('->'('var'(___76), ','('g_inc'('$module_count', ___77), '='(___76, '$module'(___77, '.'('<module>:emop.expand@2'('env'(___76, _Constructors, _Pos, _Sgn, ___8)), '[]'), '.'(___76, '[]'))))), ','('='(___76, '$module'(___77, ___78, _)), ','('='('.'(___79, ___80), ___78), ','('setarg'(1, ___78, '<module>:emop.expand@2'('env'(___76, _Constructors, _Pos, _Sgn, ___8))), 'setarg'(2, ___78, '.'(___79, ___80))))))), ','('g_read'('data.list', '<module>:data.list'(___83)), '<module>:data.list:iter$direct'(_Constructors, ___76, ___82, ___83)))), ','(','(','('g_read'('data.atom', '<module>:data.atom'(___90)), '<module>:data.atom:format$direct'('Implicit constructors: ~q', '.'(_Sgn, '[]'), ___89, ___90)), ','('g_read'('emop.message', '<module>:emop.message'(___91)), '<module>:emop.message:warning$direct'(___89, _Pos, ___91))), ','(','(','('true', ';'('->'('var'(___93), ','('g_inc'('$module_count', ___94), '='(___93, '$module'(___94, '.'('<module>:emop.expand@3'('env'(___93, _Constructors, _Pos, _Sgn, ___8)), '[]'), '.'(___93, '[]'))))), ','('='(___93, '$module'(___94, ___95, _)), ','('='('.'(___96, ___97), ___95), ','('setarg'(1, ___95, '<module>:emop.expand@3'('env'(___93, _Constructors, _Pos, _Sgn, ___8))), 'setarg'(2, ___95, '.'(___96, ___97))))))), ','('g_read'('data.list', '<module>:data.list'(___99)), '<module>:data.list:iter$direct'(_Constructors, ___93, ___99))), ','('g_read'('io.err', '<module>:io.err'(___101)), '<module>:io.err:endline$direct'(___101)))))).
':-'('<module>:emop.expand@0:warning_implicit_constructors_aux$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@0:warning_implicit_constructors_aux'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@1'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@1:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@1'('do'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@1:do'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@1'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.expand@1$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.expand@1$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.expand@1$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.expand@1$has_predicate'('do'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand@10'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@10:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@10'('queue_check'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@10:queue_check'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@10'('predicate_id'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@10:predicate_id'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@10'('add_clause'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@10:add_clause'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@10'('add_directive'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@10:add_directive'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@10'('get_scope'(_____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@10:get_scope'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@10'('fresh_module_index'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@10:fresh_module_index'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@10'('env'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@10:env'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@10'('prolog_module_name'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@10:prolog_module_name'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@10'('prolog_predicate_name'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@10:prolog_predicate_name'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@10'('predicate_name_direct'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@10:predicate_name_direct'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@10'('expand_import'(_____10, _____9, _____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@10:expand_import'(_____10, _____9, _____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@10'('expand_module'(_____11, _____10, _____9, _____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@10:expand_module'(_____11, _____10, _____9, _____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@10'('compile_module'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@10:compile_module'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@10'('expander'(_____7, _____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@10:expander'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@10'('dequeue_modules', __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@10:dequeue_modules'(__36env, __36CutLevel))).
':-'('<module>:emop.expand@10'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.expand@10$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.expand@10$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.expand@10$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.expand@10$has_predicate'('queue_check'(_____1)), 'true').
':-'('<module>:emop.expand@10$has_predicate'('predicate_id'(_____1)), 'true').
':-'('<module>:emop.expand@10$has_predicate'('add_clause'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand@10$has_predicate'('add_directive'(_____1)), 'true').
':-'('<module>:emop.expand@10$has_predicate'('get_scope'(_____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand@10$has_predicate'('fresh_module_index'(_____1)), 'true').
':-'('<module>:emop.expand@10$has_predicate'('env'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand@10$has_predicate'('prolog_module_name'(_____2, _____1)), 'true').
':-'('<module>:emop.expand@10$has_predicate'('prolog_predicate_name'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand@10$has_predicate'('predicate_name_direct'(_____2, _____1)), 'true').
':-'('<module>:emop.expand@10$has_predicate'('expand_import'(_____10, _____9, _____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand@10$has_predicate'('expand_module'(_____11, _____10, _____9, _____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand@10$has_predicate'('compile_module'(_____1)), 'true').
':-'('<module>:emop.expand@10$has_predicate'('expander'(_____7, _____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand@10$has_predicate'('dequeue_modules'), 'true').
':-'('<module>:emop.expand@10:$sgn'(__36sgn, 'env'(___553, _ExpandFile, _Impl, _Fid, _MainSgn, _HasMainModule, _FileXml, _Dependencies, _ModuleListRef, _ClausesRef, _PredicateIdCounterRef, _FreshModuleCounterRef, _ModuleQueue, _CheckQueue), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',5746,190,5740)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',6060,204,6051)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','('true', '<module>:emop.expand@10:atom_fresh_[3553]'(_atom__fresh___913554_93, __36Pb, __36Pe)), '<module>:emop.expand@10:atom_fresh_[3555]'(_atom__fresh___913556_93, __36Pb, __36Pe)), '<module>:emop.expand@10:atom_fresh_[3557]'(_atom__fresh___913558_93, __36Pb, __36Pe)), '<module>:emop.expand@10:atom_fresh_[3559]'(_atom__fresh___913560_93, __36Pb, __36Pe)), '<module>:emop.expand@10:atom_fresh_[3561]'(_atom__fresh___913562_93, __36Pb, __36Pe)), '<module>:emop.expand@10:atom_fresh_[3563]'(_atom__fresh___913564_93, __36Pb, __36Pe)), '<module>:emop.expand@10:atom_fresh_[3565]'(_atom__fresh___913566_93, __36Pb, __36Pe)), '<module>:emop.expand@10:atom_fresh_[3567]'(_atom__fresh___913568_93, __36Pb, __36Pe)), '<module>:emop.expand@10:atom_fresh_[3569]'(_atom__fresh___913570_93, __36Pb, __36Pe)), '<module>:emop.expand@10:atom_fresh_[3571]'(_atom__fresh___913572_93, __36Pb, __36Pe)), '<module>:emop.expand@10:atom_fresh_[3573]'(_atom__fresh___913574_93, __36Pb, __36Pe)), '<module>:emop.expand@10:atom_fresh_[3575]'(_atom__fresh___913576_93, __36Pb, __36Pe)), '<module>:emop.expand@10:atom_fresh_[3577]'(_atom__fresh___913578_93, __36Pb, __36Pe)), '<module>:emop.expand@10:atom_fresh_[3579]'(_atom__fresh___913580_93, __36Pb, __36Pe)), '<module>:emop.expand@10:atom_fresh_[3581]'(_atom__fresh___913582_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913582_93, '.'(_atom__fresh___913580_93, '.'(_atom__fresh___913578_93, '.'(_atom__fresh___913576_93, '.'(_atom__fresh___913574_93, '.'(_atom__fresh___913572_93, '.'(_atom__fresh___913570_93, '.'(_atom__fresh___913568_93, '.'(_atom__fresh___913566_93, '.'(_atom__fresh___913564_93, '.'(_atom__fresh___913562_93, '.'(_atom__fresh___913560_93, '.'(_atom__fresh___913558_93, '.'(_atom__fresh___913556_93, '.'(_atom__fresh___913554_93, '[]'))))))))))))))))))))).
':-'('<module>:emop.expand@10:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@10:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@10:add_clause'(_F, _Args, _B, 'env'(___553, _ExpandFile, _Impl, _Fid, _MainSgn, _HasMainModule, _FileXml, _Dependencies, _ModuleListRef, _ClausesRef, _PredicateIdCounterRef, _FreshModuleCounterRef, _ModuleQueue, _CheckQueue), __36CutLevel), ','('emop_call'(_ClausesRef, 'get'(_Clauses), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 215, from character 23 to 26'), ','(','('g_read'('data.list', '<module>:data.list'(___620)), '<module>:data.list:length$direct'(_Args, ___619, ___620)), 'emop_call'(_ClausesRef, 'set'('.'('clause'(_F, ___619, _Args, _B), _Clauses)), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 216, from character 23 to 26')))).
':-'('<module>:emop.expand@10:add_clause$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@10:add_clause'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@10:add_directive'(_X, 'env'(___553, _ExpandFile, _Impl, _Fid, _MainSgn, _HasMainModule, _FileXml, _Dependencies, _ModuleListRef, _ClausesRef, _PredicateIdCounterRef, _FreshModuleCounterRef, _ModuleQueue, _CheckQueue), __36CutLevel), ','('emop_call'(_ClausesRef, 'get'(_Clauses), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 219, from character 23 to 26'), 'emop_call'(_ClausesRef, 'set'('.'('directive'(_X), _Clauses)), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 220, from character 23 to 26'))).
':-'('<module>:emop.expand@10:add_directive$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@10:add_directive'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@10:atom_fresh_[3553]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(dequeue_modules, 0, predicate, [], __36pos))).
':-'('<module>:emop.expand@10:atom_fresh_[3555]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(expander, 7, predicate, suspended([var('Vars'),var('SgnVars'),var('ThisOption'),var('InheritedEnvVars'),var('FreeVars'),var('ImplicitConstructorsRef'),var('Expander')],[module('Expander',[symbol(singleton_warning,0,predicate,suspended([],[module('Warning',[symbol(do,2,predicate,[none,none],file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',36315,937,36262),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',36874,952,36851)))]),call(var('Vars'),iter,[var('Warning')])]),file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',36224,935,36194),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',36927,954,36893))),symbol(ast_match,2,predicate,[none,none],file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',36969,956,36929),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',37021,958,36990))),symbol(transform_goal,3,predicate,[none,none,none],file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',39651,1032,39602),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',40151,1044,40102))),symbol(transform_term,4,predicate,[none,none,none,none],file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',40214,1046,40158),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',40721,1058,40665))),symbol(transform_term_list,4,predicate,[none,none,none,none],file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',40743,1060,40728),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',40762,1060,40728))),symbol(expand_notation,4,predicate,[none,none,none,none],file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',41082,1066,41025),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',41330,1073,41310))),symbol(init_sequence,4,predicate,[none,none,none,none],file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',41387,1075,41337),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',41702,1083,41682))),symbol(build_sequence,4,predicate,suspended([var('S'),var('Pb'),var('Pe'),none],[call(scope,true,[])]),file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',41750,1085,41709),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',42133,1096,42113))),symbol(split_list,3,predicate,[none,none,none],file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',42150,1098,42135),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',42160,1098,42135))),symbol(template_sequence,6,predicate,suspended([var('AccuLists'),var('AccuVars'),var('M'),var('Pb'),var('Pe'),var('S')],[call(scope,template_sequence_,[none,var('AccuVars'),var('M'),var('Pb'),var('Pe'),var('S')])]),file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',42358,1102,42290),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',42639,1110,42619))),symbol(template_sequence_,6,predicate,[none,none,none,none,none,none],file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',42718,1112,42649),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',43094,1121,43074))),symbol(rebuild_,3,predicate,[none,none,none],file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',43119,1123,43104),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',43127,1123,43104))),symbol(rebuild,3,predicate,[none,none,none],file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',46126,1191,46092),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',46325,1198,46305))),symbol(eval_number,2,predicate,suspended([none,var('X')],[call(scope,true,[])]),file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',46367,1200,46327),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',46389,1201,46369))),symbol(check_guard,3,predicate,suspended([none,var('Position'),var('Scope')],[call(scope,check_guard,[var('A'),var('Position'),var('Scope')]),call(scope,check_guard,[var('B'),var('Position'),var('Scope')])]),file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',46955,1214,46900),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',47059,1216,47009))),symbol(expand_notation_step,4,predicate,[none,none,none,none],file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',50473,1303,50411),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',51642,1329,51593))),symbol(expand_goal,3,predicate,suspended([none,var('Ctx'),var('Goal')],[call(scope,expand_goal_callable,[var('F'),var('Escaped'),var('Args'),var('Pb'),var('Pe'),var('Ctx'),var('Goal')])]),file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',54726,1398,54652),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',54805,1399,54729))),symbol(expand_goal_callable,7,predicate,[none,none,none,none,none,none,none],file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',56230,1431,56159),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',56446,1437,56397))),symbol(make_cut,2,predicate,suspended([var('AT'),none],[call(scope,true,[])]),file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',63787,1592,63759),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',64431,1611,64411))),symbol(change_current_mod,3,predicate,[none,none,none],file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',64448,1613,64433),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',64466,1613,64433))),symbol(open_scope,7,predicate,[none,none,none,none,none,none,none],file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',64668,1619,64607),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',65009,1624,64953))),symbol(expand_call,7,predicate,[none,none,none,none,none,none,none],file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',65081,1626,65017),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',71753,1768,71709))),symbol(sub_module_env,2,predicate,suspended([none,none],[call(scope,true,[])]),file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',71793,1770,71755),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',71919,1772,71902))),symbol(expand_term_list,4,predicate,[none,none,none,none],file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',71978,1775,71963),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',71994,1775,71963))),symbol(expand_term_call,8,predicate,[none,none,none,none,none,none,none,none],file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',72433,1784,72358),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',73140,1802,73120))),symbol(expand_subterm,8,predicate,suspended([var('F'),var('Escaped'),var('Args0'),var('Pb'),var('Pe'),var('Ctx'),var('Goal'),var('Term')],[call(scope,expand_term_list,[var('Args0'),none,var('G0'),var('Args1')]),call(scope,expand_term_call,[var('F'),var('Escaped'),var('Args1'),var('Pb'),var('Pe'),var('Ctx'),var('G1'),var('Term')]),call(var('Impl'),seq,[var('G0'),var('G1'),var('Goal')])]),file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',73222,1804,73148),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',73429,1807,73388))),symbol(expand_term,4,predicate,suspended([none,var('Ctx'),var('Goal'),var('Term')],[call(scope,expand_term_callable,[var('F'),var('Escaped'),var('Args'),var('Pb'),var('Pe'),var('Ctx'),var('Goal'),var('Term')])]),file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',73511,1809,73431),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',73596,1810,73514))),symbol(expand_term_callable,8,predicate,[none,none,none,none,none,none,none,none],file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',76086,1868,75988),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',76304,1874,76259)))])]), __36pos))).
':-'('<module>:emop.expand@10:atom_fresh_[3557]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(compile_module, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@10:atom_fresh_[3559]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(expand_module, 11, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@10:atom_fresh_[3561]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(expand_import, 10, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@10:atom_fresh_[3563]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(predicate_name_direct, 2, predicate, suspended([var('F'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.expand@10:atom_fresh_[3565]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(prolog_predicate_name, 3, predicate, suspended([var('Id'),var('F'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.expand@10:atom_fresh_[3567]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(prolog_module_name, 2, predicate, suspended([var('F'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.expand@10:atom_fresh_[3569]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(env, 4, constructor, none, __36pos))).
':-'('<module>:emop.expand@10:atom_fresh_[3571]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fresh_module_index, 1, predicate, suspended([none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.expand@10:atom_fresh_[3573]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(get_scope, 5, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@10:atom_fresh_[3575]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(add_directive, 1, predicate, suspended([var('X')],[call(var('ClausesRef'),get,[var('Clauses')]),call(var('ClausesRef'),set,[none])]), __36pos))).
':-'('<module>:emop.expand@10:atom_fresh_[3577]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(add_clause, 3, predicate, suspended([var('F'),var('Args'),var('B')],[call(var('ClausesRef'),get,[var('Clauses')]),call(var('ClausesRef'),set,[none])]), __36pos))).
':-'('<module>:emop.expand@10:atom_fresh_[3579]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(predicate_id, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@10:atom_fresh_[3581]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(queue_check, 1, predicate, suspended([var('Check')],[call(var('CheckQueue'),set,[none])]), __36pos))).
':-'('<module>:emop.expand@10:compile_module'('module'(_Sgn, _Clauses, _LocalId, _IntEnvTerm, _SupScope, _This, _EnvRec, _EnvVars, _EnvList0, _SgnVars, _Pb, _Pe, _ModuleGoal0, _ModuleGoal, _InheritedEnvVars, _AdditionalEnvList, _Vars), 'env'(___553, _ExpandFile, _Impl, _Fid, _MainSgn, _HasMainModule, _FileXml, _Dependencies, _ModuleListRef, _ClausesRef, _PredicateIdCounterRef, _FreshModuleCounterRef, _ModuleQueue, _CheckQueue), __36CutLevel), ','(','('g_read'('data.atom', '<module>:data.atom'(___742)), '<module>:data.atom:format$direct'('~a$has_predicate', '.'(_LocalId, '[]'), _HasPredicate, ___742)), ','(','('true', ';'('->'('var'(_AddClause), ','('g_inc'('$module_count', ___743), '='(_AddClause, '$module'(___743, '.'('<module>:emop.expand@16'('env'(_AddClause, _LocalId, _IntEnvTerm, _ExpandFile, _HasPredicate, ___553)), '[]'), '.'(_AddClause, '[]'))))), ','('='(_AddClause, '$module'(___743, ___744, _)), ','('='('.'(___745, ___746), ___744), ','('setarg'(1, ___744, '<module>:emop.expand@16'('env'(_AddClause, _LocalId, _IntEnvTerm, _ExpandFile, _HasPredicate, ___553))), 'setarg'(2, ___744, '.'(___745, ___746))))))), ','('emop_call'(_AddClause, 'add_predicate'('$sgn', 1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 583, from character 19 to 32'), ','(','('='(_AccuGoal, ___753), ','('g_read'('data.ref.backtrackable', '<module>:data.ref.backtrackable'(___754)), '<module>:data.ref.backtrackable:new$direct'('callable'('true', '[]'), ___753, ___754))), ','(','('true', ';'('->'('var'(_SimplifySgn), ','('g_inc'('$module_count', ___755), '='(_SimplifySgn, '$module'(___755, '.'('<module>:emop.expand@17'('env'(_SimplifySgn, _AccuGoal, _ExpandFile, _LocalId, ___553)), '[]'), '.'(_SimplifySgn, '[]'))))), ','('='(_SimplifySgn, '$module'(___755, ___756, _)), ','('='('.'(___757, ___758), ___756), ','('setarg'(1, ___756, '<module>:emop.expand@17'('env'(_SimplifySgn, _AccuGoal, _ExpandFile, _LocalId, ___553))), 'setarg'(2, ___756, '.'(___757, ___758))))))), ','(','('='(_ShortSgn, ___760), 'emop_call'(_SimplifySgn, 'simpl'(_Sgn, ___760), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 626, from character 32 to 37')), ','(','(','('g_read'('data.ref', '<module>:data.ref'(___804)), '<module>:data.ref:?$direct'(_AccuGoal, ___803, ___804)), 'emop_call'(_AddClause, 'add_clause'('$sgn', '.'('var'('$sgn'), '[]'), 'callable'(',', '.'('callable'('=', '.'('var'('$Pb'), '.'('term'(_Pb), '[]'))), '.'('callable'(',', '.'('callable'('=', '.'('var'('$Pe'), '.'('term'(_Pe), '[]'))), '.'('callable'(',', '.'('callable'('=', '.'('var'('$pos'), '.'('callable'('file', '.'('var'('$Pb'), '.'('var'('$Pe'), '[]'))), '[]'))), '.'('callable'(',', '.'(___803, '.'('callable'('=', '.'('var'('$sgn'), '.'(_ShortSgn, '[]'))), '[]'))), '[]'))), '[]'))), '[]')))), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 627, from character 19 to 29')), ','(','(','('true', ';'('->'('var'(___829), ','('g_inc'('$module_count', ___830), '='(___829, '$module'(___830, '.'('<module>:emop.expand@18'('env'(___829, _AddClause, ___553)), '[]'), '.'(___829, '[]'))))), ','('='(___829, '$module'(___830, ___831, _)), ','('='('.'(___832, ___833), ___831), ','('setarg'(1, ___831, '<module>:emop.expand@18'('env'(___829, _AddClause, ___553))), 'setarg'(2, ___831, '.'(___832, ___833))))))), ','('g_read'('data.list', '<module>:data.list'(___835)), '<module>:data.list:iter$direct'(_Sgn, ___829, ___835))), ','(','('='(_ImplicitConstructorsRef, ___838), ','('g_read'('data.ref.backtrackable', '<module>:data.ref.backtrackable'(___839)), '<module>:data.ref.backtrackable:new$direct'('[]', ___838, ___839))), ','(','('='(_GrammarRef, ___844), ','(','('g_read'('emop.parser', '<module>:emop.parser'(___843)), '<module>:emop.parser:grammar_empty$direct'(___842, ___843)), ','('g_read'('data.ref.backtrackable', '<module>:data.ref.backtrackable'(___845)), '<module>:data.ref.backtrackable:new$direct'(___842, ___844, ___845)))), ','(','('='(_ScopeStack, '.'('scope'(_This, _Sgn, ___846), _SupScope)), 'emop_call'(_GrammarRef, 'get'(___846), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 698, from character 51 to 54')), ','(','('='(_CurrentScopeRef, ___850), ','('g_read'('data.ref.backtrackable', '<module>:data.ref.backtrackable'(___851)), '<module>:data.ref.backtrackable:new$direct'(_ScopeStack, ___850, ___851))), ','(','('='(_EnvListRef, ___853), ','('g_read'('data.ref.backtrackable', '<module>:data.ref.backtrackable'(___854)), '<module>:data.ref.backtrackable:new$direct'(_InheritedEnvVars, ___853, ___854))), ','(','('='(_ModuleGoalRef, ___859), ','('g_read'('data.ref.backtrackable', '<module>:data.ref.backtrackable'(___860)), '<module>:data.ref.backtrackable:new$direct'('callable'('true', '[]'), ___859, ___860))), ','(';'('->'(','(','('true', ';'('->'('var'(___862), ','('g_inc'('$module_count', ___863), '='(___862, '$module'(___863, '.'('<module>:emop.expand@19'('env'(___862, _AddClause, _EnvRec, _This, _EnvVars, _CurrentScopeRef, _ImplicitConstructorsRef, _Impl, _EnvList0, _FileXml, _SgnVars, _EnvListRef, _ModuleGoalRef, _Dependencies, ___553)), '[]'), '.'(___862, '[]'))))), ','('='(___862, '$module'(___863, ___864, _)), ','('='('.'(___865, ___866), ___864), ','('setarg'(1, ___864, '<module>:emop.expand@19'('env'(___862, _AddClause, _EnvRec, _This, _EnvVars, _CurrentScopeRef, _ImplicitConstructorsRef, _Impl, _EnvList0, _FileXml, _SgnVars, _EnvListRef, _ModuleGoalRef, _Dependencies, ___553))), 'setarg'(2, ___864, '.'(___865, ___866))))))), ','('g_read'('data.list', '<module>:data.list'(___868)), '<module>:data.list:iter$direct'(_Clauses, ___862, ___868))), 'true'), 'throw'('iter NewClauses')), ','(','('='(_AdditionalEnvList, ___870), 'emop_call'(_EnvListRef, 'get'(___870), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 863, from character 40 to 43')), ','(','('='(_ModuleGoal, ___872), ','('emop_call'(_ModuleGoalRef, 'get'(___871), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 864, from character 58 to 61'), 'emop_call'(_Impl, 'seq'(_ModuleGoal0, ___871, ___872), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 864, from character 27 to 30'))), ','(','(','('emop_call'(_ImplicitConstructorsRef, 'get'(___873), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 866, from character 36 to 39'), 'emop_call'(_Dependencies, 'get'(___874), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 866, from character 54 to 57')), 'emop_call'(_Impl, 'warning_implicit_constructors'(___873, ___874, 'file'(_Pb, _Pe)), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 865, from character 14 to 43')), ','('emop_call'(_FileXml, 'print_endline'('</module>'), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 868, from character 17 to 30'), ','('emop_call'(_ExpandFile, 'add_clause'(_LocalId, '.'('var'('$t'), '.'('var'('$env'), '.'('var'('$pos'), '.'('var'('$CutLevel'), '[]')))), 'callable'(_DynamicId, '.'('var'('$t'), '.'('var'('$env'), '.'('var'('$pos'), '.'('var'('$CutLevel'), '[]')))))), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 869, from character 20 to 30'), ','(','('='(_DynamicId, ___906), ','('g_read'('data.atom', '<module>:data.atom'(___907)), '<module>:data.atom:concat$direct'(_LocalId, '$dynamic', ___906, ___907))), ','('emop_call'(___553, 'add_directive'('callable'('dynamic', '.'('callable'('/', '.'('callable'(_DynamicId, '[]'), '.'('number'(4), '[]'))), '[]'))), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 875, from character 9 to 22'), ','('emop_call'(___553, 'add_clause'(_DynamicId, '.'('var'('$t'), '.'('var'('_'), '.'('var'('$pos'), '.'('var'('$CutLevel'), '[]')))), 'callable'(',', '.'('callable'('functor', '.'('var'('$t'), '.'('var'('$f'), '.'('var'('$n'), '[]')))), '.'('callable'('throw', '.'('callable'('error', '.'('callable'('unknown_predicate', '.'('callable'('/', '.'('var'('$f'), '.'('var'('$n'), '[]'))), '[]')), '.'('var'('$pos'), '[]'))), '[]')), '[]')))), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 876, from character 9 to 19'), ','(','('true', ';'('->'('var'(_Warning), ','('g_inc'('$module_count', ___974), '='(_Warning, '$module'(___974, '.'('<module>:emop.expand@20'('env'(_Warning, _Impl, _Vars, ___553)), '[]'), '.'(_Warning, '[]'))))), ','('='(_Warning, '$module'(___974, ___975, _)), ','('='('.'(___976, ___977), ___975), ','('setarg'(1, ___975, '<module>:emop.expand@20'('env'(_Warning, _Impl, _Vars, ___553))), 'setarg'(2, ___975, '.'(___976, ___977))))))), ','(','('true', ';'('->'('var'(___979), ','('g_inc'('$module_count', ___980), '='(___979, '$module'(___980, '.'('<module>:emop.expand@21'('env'(___979, _EnvRec, _Warning, ___553)), '[]'), '.'(___979, '[]'))))), ','('='(___979, '$module'(___980, ___981, _)), ','('='('.'(___982, ___983), ___981), ','('setarg'(1, ___981, '<module>:emop.expand@21'('env'(___979, _EnvRec, _Warning, ___553))), 'setarg'(2, ___981, '.'(___982, ___983))))))), 'emop_call'(___553, 'queue_check'(___979), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 929, from character 9 to 20'))))))))))))))))))))))))))).
':-'('<module>:emop.expand@10:compile_module$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@10:compile_module'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@10:dequeue_modules'('env'(___553, _ExpandFile, _Impl, _Fid, _MainSgn, _HasMainModule, _FileXml, _Dependencies, _ModuleListRef, _ClausesRef, _PredicateIdCounterRef, _FreshModuleCounterRef, _ModuleQueue, _CheckQueue), __36CutLevel), ';'('->'('emop_call'(_ModuleQueue, 'get'('.'(_H, _T)), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1941, from character 27 to 30'), ','('emop_call'(_ModuleQueue, 'set'(_T), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1943, from character 27 to 30'), ','('emop_call'(___553, 'compile_module'(_H), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1944, from character 15 to 29'), 'emop_call'(___553, 'dequeue_modules', 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1945, from character 15 to 30')))), 'true')).
':-'('<module>:emop.expand@10:dequeue_modules$direct'(__36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@10:dequeue_modules'(__36env, __36CutLevel))).
':-'('<module>:emop.expand@10:env'(___603, ___604, ___605, ___606, 'env'(___553, _ExpandFile, _Impl, _Fid, _MainSgn, _HasMainModule, _FileXml, _Dependencies, _ModuleListRef, _ClausesRef, _PredicateIdCounterRef, _FreshModuleCounterRef, _ModuleQueue, _CheckQueue), __36CutLevel), '=..'(___606, '.'('env', '.'(___603, '.'(___604, '.'(___605, '[]')))))).
':-'('<module>:emop.expand@10:env$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@10:env'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@10:expand_import'(_Ast, _Pos, _FreeVars, _SgnVars, _EnvRec, _EnvVars, _ImplicitConstructorsRef, _ThisOption, _Scope, _Goals, 'env'(___553, _ExpandFile, _Impl, _Fid, _MainSgn, _HasMainModule, _FileXml, _Dependencies, _ModuleListRef, _ClausesRef, _PredicateIdCounterRef, _FreshModuleCounterRef, _ModuleQueue, _CheckQueue), __36CutLevel), ','(','('true', ';'('->'('var'(___672), ','('g_inc'('$module_count', ___673), '='(___672, '$module'(___673, '.'('<module>:emop.expand@14'('env'(___672, _ExpandFile, _Impl, _Fid, _MainSgn, _HasMainModule, _FileXml, _Dependencies, _ModuleListRef, _ClausesRef, _PredicateIdCounterRef, _FreshModuleCounterRef, _ModuleQueue, _CheckQueue, _Ast, _EnvRec, _EnvVars, _FreeVars, _Goals, _ImplicitConstructorsRef, _Pos, _Scope, _SgnVars, _ThisOption, ___553)), '[]'), '.'(___672, '[]'))))), ','('='(___672, '$module'(___673, ___674, _)), ','('='('.'(___675, ___676), ___674), ','('setarg'(1, ___674, '<module>:emop.expand@14'('env'(___672, _ExpandFile, _Impl, _Fid, _MainSgn, _HasMainModule, _FileXml, _Dependencies, _ModuleListRef, _ClausesRef, _PredicateIdCounterRef, _FreshModuleCounterRef, _ModuleQueue, _CheckQueue, _Ast, _EnvRec, _EnvVars, _FreeVars, _Goals, _ImplicitConstructorsRef, _Pos, _Scope, _SgnVars, _ThisOption, ___553))), 'setarg'(2, ___674, '.'(___675, ___676))))))), 'emop_call'(___672, 'do'(_Ast, _Goals), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 297, from character 14 to 16'))).
':-'('<module>:emop.expand@10:expand_import$direct'(_____10, _____9, _____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@10:expand_import'(_____10, _____9, _____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@10:expand_module'(_Name, _Pb, _Pe, _Env, _Sgn, _Clauses, _InheritedEnvVars, _SupScope, _SupSgnVars, _Vars, _Goal, 'env'(___553, _ExpandFile, _Impl, _Fid, _MainSgn, _HasMainModule, _FileXml, _Dependencies, _ModuleListRef, _ClausesRef, _PredicateIdCounterRef, _FreshModuleCounterRef, _ModuleQueue, _CheckQueue), __36CutLevel), ','(';'('->'(','('g_read'('data.var', '<module>:data.var'(___679)), '<module>:data.var:check$direct'(_Vars, ___679)), 'throw'('uninstanciated vars')), 'true'), ','(','('='(_EnvRec, ___682), ','('g_read'('data.record', '<module>:data.record'(___683)), '<module>:data.record:{}$direct'(___682, ___683))), ','(','('='(_SgnVars, ___685), ','('g_read'('data.record', '<module>:data.record'(___686)), '<module>:data.record:{}$direct'(___685, ___686))), ','('emop_call'(_Impl, 'extract_env'(_Env, _EnvRec, _EnvList0, _SupSgnVars, _SgnVars), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 309, from character 14 to 25'), ','(','('='(_IntEnvList0, ___688), ','('g_read'('data.list', '<module>:data.list'(___689)), '<module>:data.list:append$direct'(_EnvList0, _AdditionalEnvList, ___688, ___689))), ','(','('='(_ExtEnvList0, ___691), ','('g_read'('data.list', '<module>:data.list'(___692)), '<module>:data.list:append$direct'(_EnvList0, _AdditionalEnvList, ___691, ___692))), ','(';'('->'(','(','('true', ';'('->'('var'(___693), ','('g_inc'('$module_count', ___694), '='(___693, '$module'(___694, '.'('<module>:emop.expand@15'('env'(___693, _Title, _Sgn, _VarSgn, _ModuleGoal0, _Fid, _MainSgn, _ExpandFile, _IntEnvList0, _ExtEnvList0, _IntEnvList, _ExtEnvList, _IntEnvTerm, _This, _InheritedEnvVars, _EnvVars, _LocalId, _ModuleListRef, _SupSgnVars, _Vars, _Impl, _HasMainModule, ___553)), '[]'), '.'(___693, '[]'))))), ','('='(___693, '$module'(___694, ___695, _)), ','('='('.'(___696, ___697), ___695), ','('setarg'(1, ___695, '<module>:emop.expand@15'('env'(___693, _Title, _Sgn, _VarSgn, _ModuleGoal0, _Fid, _MainSgn, _ExpandFile, _IntEnvList0, _ExtEnvList0, _IntEnvList, _ExtEnvList, _IntEnvTerm, _This, _InheritedEnvVars, _EnvVars, _LocalId, _ModuleListRef, _SupSgnVars, _Vars, _Impl, _HasMainModule, ___553))), 'setarg'(2, ___695, '.'(___696, ___697))))))), 'emop_call'(___693, 'expand_module_name'(_Name), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 487, from character 14 to 32')), 'true'), 'throw'('expand_module_name fail')), ','('='(_Goal, 'callable'(',', '.'('callable'('true', '[]'), '.'(_ModuleGoal, '[]')))), ','('emop_call'(_FileXml, 'format'('<module title=\"~a\">\n', '.'(_Title, '[]')), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 494, from character 17 to 23'), ','(';'('->'(','('g_read'('data.var', '<module>:data.var'(___712)), '<module>:data.var:check$direct'(_VarSgn, ___712)), ','(','('='(_VarSgn, ___718), ','('g_read'('data.ref.backtrackable', '<module>:data.ref.backtrackable'(___719)), '<module>:data.ref.backtrackable:new$direct'('root'(','('.'(_Fid, '[]'), _Sgn)), ___718, ___719))), '='(_SupScope0, _SupScope))), ','(','('='(_VarSgnRoot, ___721), ','('g_read'('emop.unionfind', '<module>:emop.unionfind'(___722)), '<module>:emop.unionfind:get_root$direct'(_VarSgn, ___721, ___722))), ','('emop_call'(_VarSgnRoot, 'get'('root'(','(_OtherFids, _OtherSgn))), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 502, from character 23 to 26'), ','(','(','('g_read'('data.list', '<module>:data.list'(___728)), '<module>:data.list:append$direct'(_OtherSgn, _Sgn, ___727, ___728)), 'emop_call'(_VarSgnRoot, 'set'('root'(','('.'(_Fid, _OtherFids), ___727))), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 503, from character 23 to 26')), ','('='(_SupScope0, '.'(___731, _SupScope)), ','('g_read'('emop.expand', '<module>:emop.expand'(___732)), '<module>:emop.expand:make_scope$direct'(_This, _OtherSgn, _SupScope, ___731, ___732))))))), ','('emop_call'(_ModuleQueue, 'get'(___735), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 506, from character 213 to 216'), 'emop_call'(_ModuleQueue, 'set'('.'('module'(_Sgn, _Clauses, _LocalId, _IntEnvTerm, _SupScope0, _This, _EnvRec, _EnvVars, _EnvList0, _SgnVars, _Pb, _Pe, _ModuleGoal0, _ModuleGoal, _InheritedEnvVars, _AdditionalEnvList, _Vars), ___735)), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 506, from character 21 to 24'))))))))))))).
':-'('<module>:emop.expand@10:expand_module$direct'(_____11, _____10, _____9, _____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@10:expand_module'(_____11, _____10, _____9, _____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@10:expander'(_Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _ImplicitConstructorsRef, _Expander, 'env'(___553, _ExpandFile, _Impl, _Fid, _MainSgn, _HasMainModule, _FileXml, _Dependencies, _ModuleListRef, _ClausesRef, _PredicateIdCounterRef, _FreshModuleCounterRef, _ModuleQueue, _CheckQueue), __36CutLevel), ','('true', ';'('->'('var'(_Expander), ','('g_inc'('$module_count', ___985), '='(_Expander, '$module'(___985, '.'('<module>:emop.expand@22'('env'(_Expander, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553)), '[]'), '.'(_Expander, '[]'))))), ','('='(_Expander, '$module'(___985, ___986, _)), ','('='('.'(___987, ___988), ___986), ','('setarg'(1, ___986, '<module>:emop.expand@22'('env'(_Expander, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553))), 'setarg'(2, ___986, '.'(___987, ___988)))))))).
':-'('<module>:emop.expand@10:expander$direct'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@10:expander'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@10:fresh_module_index'(___651, 'env'(___553, _ExpandFile, _Impl, _Fid, _MainSgn, _HasMainModule, _FileXml, _Dependencies, _ModuleListRef, _ClausesRef, _PredicateIdCounterRef, _FreshModuleCounterRef, _ModuleQueue, _CheckQueue), __36CutLevel), ','('g_read'('data.number', '<module>:data.number'(___652)), '<module>:data.number:|++$direct'(_FreshModuleCounterRef, ___651, ___652))).
':-'('<module>:emop.expand@10:fresh_module_index$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@10:fresh_module_index'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@10:get_scope'(_Mod, _Pos, _SgnVars, _CurrentScope, _Scope, 'env'(___553, _ExpandFile, _Impl, _Fid, _MainSgn, _HasMainModule, _FileXml, _Dependencies, _ModuleListRef, _ClausesRef, _PredicateIdCounterRef, _FreshModuleCounterRef, _ModuleQueue, _CheckQueue), __36CutLevel), ','(';'('->'('='(_Mod, 'var'(_ModVar)), ','(','('='(_Sgn0, ___626), 'emop_call'(_SgnVars, '{}'(_ModVar, ___626), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 226, from character 30 to 31')), ';'('->'(','('g_read'('data.var', '<module>:data.var'(___628)), '<module>:data.var:check$direct'(_Sgn0, ___628)), 'throw'('error'('This variable has no associated signature', _Pos))), ','('='('root'(','(_Fids, _Sgn)), ___636), ','(','('g_read'('emop.unionfind', '<module>:emop.unionfind'(___635)), '<module>:emop.unionfind:get_root$direct'(_Sgn0, ___634, ___635)), 'emop_call'(___634, 'get'(___636), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 232, from character 70 to 73')))))), ';'('->'('='(_Mod, 'callable'(_ModAtom, '[]')), ','('='(_Fids, '.'(_ModAtom, '[]')), ','(','('='(_Sgn, ___641), 'emop_call'(_Dependencies, 'find_mod_sgn'(_ModAtom, _Pos, ___641), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 238, from character 34 to 46')), ';'('->'(','('g_read'('data.var', '<module>:data.var'(___643)), '<module>:data.var:check$direct'(_Sgn, ___643)), 'throw'('error'('No module signature', _Pos))), 'true')))), 'throw'('error'('Invalid module', _Pos)))), ','('emop_call'(_Dependencies, 'add_expand'(_Fids, _Pos), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 249, from character 25 to 35'), ','('='(_Scope, ___648), ','('g_read'('emop.expand', '<module>:emop.expand'(___649)), '<module>:emop.expand:make_scope$direct'(_Mod, _Sgn, _CurrentScope, ___648, ___649)))))).
':-'('<module>:emop.expand@10:get_scope$direct'(_____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@10:get_scope'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@10:predicate_id'(_PredicateId, 'env'(___553, _ExpandFile, _Impl, _Fid, _MainSgn, _HasMainModule, _FileXml, _Dependencies, _ModuleListRef, _ClausesRef, _PredicateIdCounterRef, _FreshModuleCounterRef, _ModuleQueue, _CheckQueue), __36CutLevel), ','('='(_PredicateId, ___616), ','(','('g_read'('data.number', '<module>:data.number'(___613)), '<module>:data.number:|++$direct'(_PredicateIdCounterRef, ___612, ___613)), ','('g_read'('data.atom', '<module>:data.atom'(___617)), '<module>:data.atom:format$direct'('p~d', '.'(___612, '[]'), ___616, ___617))))).
':-'('<module>:emop.expand@10:predicate_id$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@10:predicate_id'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@10:predicate_name_direct'(_F, ___670, 'env'(___553, _ExpandFile, _Impl, _Fid, _MainSgn, _HasMainModule, _FileXml, _Dependencies, _ModuleListRef, _ClausesRef, _PredicateIdCounterRef, _FreshModuleCounterRef, _ModuleQueue, _CheckQueue), __36CutLevel), ','('g_read'('data.atom', '<module>:data.atom'(___671)), '<module>:data.atom:format$direct'('~a$direct', '.'(_F, '[]'), ___670, ___671))).
':-'('<module>:emop.expand@10:predicate_name_direct$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@10:predicate_name_direct'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@10:prolog_module_name'(_F, ___657, 'env'(___553, _ExpandFile, _Impl, _Fid, _MainSgn, _HasMainModule, _FileXml, _Dependencies, _ModuleListRef, _ClausesRef, _PredicateIdCounterRef, _FreshModuleCounterRef, _ModuleQueue, _CheckQueue), __36CutLevel), ','('g_read'('data.atom', '<module>:data.atom'(___658)), '<module>:data.atom:format$direct'('<module>:~a', '.'(_F, '[]'), ___657, ___658))).
':-'('<module>:emop.expand@10:prolog_module_name$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@10:prolog_module_name'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@10:prolog_predicate_name'(_Id, _F, ___664, 'env'(___553, _ExpandFile, _Impl, _Fid, _MainSgn, _HasMainModule, _FileXml, _Dependencies, _ModuleListRef, _ClausesRef, _PredicateIdCounterRef, _FreshModuleCounterRef, _ModuleQueue, _CheckQueue), __36CutLevel), ','('g_read'('data.atom', '<module>:data.atom'(___665)), '<module>:data.atom:format$direct'('~a:~a', '.'(_Id, '.'(_F, '[]')), ___664, ___665))).
':-'('<module>:emop.expand@10:prolog_predicate_name$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@10:prolog_predicate_name'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@10:queue_check'(_Check, 'env'(___553, _ExpandFile, _Impl, _Fid, _MainSgn, _HasMainModule, _FileXml, _Dependencies, _ModuleListRef, _ClausesRef, _PredicateIdCounterRef, _FreshModuleCounterRef, _ModuleQueue, _CheckQueue), __36CutLevel), ','('emop_call'(_CheckQueue, 'get'(___607), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 207, from character 47 to 50'), 'emop_call'(_CheckQueue, 'set'('.'(_Check, ___607)), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 207, from character 23 to 26'))).
':-'('<module>:emop.expand@10:queue_check$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@10:queue_check'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@11'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@11:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@11'('expand_goal'(_____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@11:expand_goal'(_____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@11'('expand_import'(_____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@11:expand_import'(_____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@11'('close'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@11:close'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@11'('get_scope'(_____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@11:get_scope'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@11'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.expand@11$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.expand@11$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.expand@11$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.expand@11$has_predicate'('expand_goal'(_____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand@11$has_predicate'('expand_import'(_____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand@11$has_predicate'('close'(_____2, _____1)), 'true').
':-'('<module>:emop.expand@11$has_predicate'('get_scope'(_____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand@11:$sgn'(__36sgn, 'env'(___562, _Impl, _InitGoalIdRef, _CheckQueue, _ClausesRef, _Dependencies, _ExpandFile, _Expander, _Fid, _FileXml, _Filename, _FreshModuleCounterRef, _HasMainModule, _ImplicitConstructorsRef, _MainSgn, _ModuleListRef, _ModuleQueue, _PredicateIdCounterRef), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',79446,1950,79440)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',79463,1950,79440)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','(','('true', '<module>:emop.expand@11:atom_fresh_[3541]'(_atom__fresh___913542_93, __36Pb, __36Pe)), '<module>:emop.expand@11:atom_fresh_[3543]'(_atom__fresh___913544_93, __36Pb, __36Pe)), '<module>:emop.expand@11:atom_fresh_[3545]'(_atom__fresh___913546_93, __36Pb, __36Pe)), '<module>:emop.expand@11:atom_fresh_[3547]'(_atom__fresh___913548_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913548_93, '.'(_atom__fresh___913546_93, '.'(_atom__fresh___913544_93, '.'(_atom__fresh___913542_93, '[]')))))))))).
':-'('<module>:emop.expand@11:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@11:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@11:atom_fresh_[3541]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(get_scope, 5, predicate, suspended([var('Mod'),var('Pos'),var('SgnVars'),var('CurrentScope'),var('Scope')],[call(var('ExpandFile'),get_scope,[var('Mod'),var('Pos'),var('SgnVars'),var('CurrentScope'),var('Scope')])]), __36pos))).
':-'('<module>:emop.expand@11:atom_fresh_[3543]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(close, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@11:atom_fresh_[3545]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(expand_import, 6, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@11:atom_fresh_[3547]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(expand_goal, 6, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@11:close'(_ModuleList, _Clauses, 'env'(___562, _Impl, _InitGoalIdRef, _CheckQueue, _ClausesRef, _Dependencies, _ExpandFile, _Expander, _Fid, _FileXml, _Filename, _FreshModuleCounterRef, _HasMainModule, _ImplicitConstructorsRef, _MainSgn, _ModuleListRef, _ModuleQueue, _PredicateIdCounterRef), __36CutLevel), ','(','(','('emop_call'(_ImplicitConstructorsRef, 'get'(___586), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1978, from character 71 to 74'), 'emop_call'(_Dependencies, 'get'(___587), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1978, from character 89 to 92')), 'emop_call'(_Impl, 'warning_implicit_constructors'(___586, ___587, 'file'(_Filename)), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1978, from character 17 to 46')), ','('emop_call'(_ExpandFile, 'dequeue_modules', 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1979, from character 23 to 38'), ','(','(','('emop_call'(_CheckQueue, 'get'(___590), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1980, from character 38 to 41'), ','('true', ';'('->'('var'(___591), ','('g_inc'('$module_count', ___592), '='(___591, '$module'(___592, '.'('<module>:emop.expand@13'('env'(___591, ___562)), '[]'), '.'(___591, '[]'))))), ','('='(___591, '$module'(___592, ___593, _)), ','('='('.'(___594, ___595), ___593), ','('setarg'(1, ___593, '<module>:emop.expand@13'('env'(___591, ___562))), 'setarg'(2, ___593, '.'(___594, ___595)))))))), ','('g_read'('data.list', '<module>:data.list'(___597)), '<module>:data.list:iter$direct'(___590, ___591, ___597))), ','(','('='(_ModuleList, ___598), 'emop_call'(_ModuleListRef, 'get'(___598), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1984, from character 39 to 42')), ','('='(_Clauses, ___601), ','('emop_call'(_ClausesRef, 'get'(___600), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1985, from character 51 to 54'), ','('g_read'('data.list', '<module>:data.list'(___602)), '<module>:data.list:reverse$direct'(___600, ___601, ___602))))))))).
':-'('<module>:emop.expand@11:close$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@11:close'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@11:expand_goal'(_Ast, _Scope, _SgnVars, _FreeVars, _SingletonWarning, _Goal, 'env'(___562, _Impl, _InitGoalIdRef, _CheckQueue, _ClausesRef, _Dependencies, _ExpandFile, _Expander, _Fid, _FileXml, _Filename, _FreshModuleCounterRef, _HasMainModule, _ImplicitConstructorsRef, _MainSgn, _ModuleListRef, _ModuleQueue, _PredicateIdCounterRef), __36CutLevel), ','(','('='(_Vars, ___564), ','('g_read'('data.record', '<module>:data.record'(___565)), '<module>:data.record:{}$direct'(___564, ___565))), ','('emop_call'(_ExpandFile, 'expander'(_Vars, _SgnVars, 'none', '[]', _FreeVars, _ImplicitConstructorsRef, _ExpandGoal), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1954, from character 23 to 31'), ','(','('='(_Ast0, ___570), ','('emop_call'(_Impl, 'grammars'(_Scope, ___569), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1958, from character 58 to 66'), ','('g_read'('emop.parser', '<module>:emop.parser'(___571)), '<module>:emop.parser:internal_reparse$direct'(_Ast, ___569, ___570, ___571)))), ','('emop_call'(_ExpandGoal, 'transform_goal'(_Ast0, 'ctx'('none', _Scope), _Goal), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1959, from character 23 to 37'), ';'('->'('='(_SingletonWarning, 'singleton_warning'), ','(','('true', ';'('->'('var'(___575), ','('g_inc'('$module_count', ___576), '='(___575, '$module'(___576, '.'('<module>:emop.expand@12'('env'(___575, _Impl, _InitGoalIdRef, _CheckQueue, _ClausesRef, _Dependencies, _ExpandFile, _Expander, _Fid, _FileXml, _Filename, _FreshModuleCounterRef, _HasMainModule, _ImplicitConstructorsRef, _MainSgn, _ModuleListRef, _ModuleQueue, _PredicateIdCounterRef, _Ast, _Ast0, _ExpandGoal, _FreeVars, _Goal, _Scope, _SgnVars, _SingletonWarning, _Vars, ___562)), '[]'), '.'(___575, '[]'))))), ','('='(___575, '$module'(___576, ___577, _)), ','('='('.'(___578, ___579), ___577), ','('setarg'(1, ___577, '<module>:emop.expand@12'('env'(___575, _Impl, _InitGoalIdRef, _CheckQueue, _ClausesRef, _Dependencies, _ExpandFile, _Expander, _Fid, _FileXml, _Filename, _FreshModuleCounterRef, _HasMainModule, _ImplicitConstructorsRef, _MainSgn, _ModuleListRef, _ModuleQueue, _PredicateIdCounterRef, _Ast, _Ast0, _ExpandGoal, _FreeVars, _Goal, _Scope, _SgnVars, _SingletonWarning, _Vars, ___562))), 'setarg'(2, ___577, '.'(___578, ___579))))))), 'emop_call'(_ExpandFile, 'queue_check'(___575), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1963, from character 26 to 37'))), 'true')))))).
':-'('<module>:emop.expand@11:expand_goal$direct'(_____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@11:expand_goal'(_____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@11:expand_import'(_Ast, _Pos, _FreeVars, _SgnVars, _Scope, _Goals, 'env'(___562, _Impl, _InitGoalIdRef, _CheckQueue, _ClausesRef, _Dependencies, _ExpandFile, _Expander, _Fid, _FileXml, _Filename, _FreshModuleCounterRef, _HasMainModule, _ImplicitConstructorsRef, _MainSgn, _ModuleListRef, _ModuleQueue, _PredicateIdCounterRef), __36CutLevel), ','(','('='(_EnvRec, ___582), ','('g_read'('data.record', '<module>:data.record'(___583)), '<module>:data.record:{}$direct'(___582, ___583))), ','('='(_EnvVars, '[]'), ','('='(_ThisOption, 'none'), 'emop_call'(_ExpandFile, 'expand_import'(_Ast, _Pos, _FreeVars, _SgnVars, _EnvRec, _EnvVars, _ImplicitConstructorsRef, _ThisOption, _Scope, _Goals), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1975, from character 23 to 36'))))).
':-'('<module>:emop.expand@11:expand_import$direct'(_____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@11:expand_import'(_____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@11:get_scope'(_Mod, _Pos, _SgnVars, _CurrentScope, _Scope, 'env'(___562, _Impl, _InitGoalIdRef, _CheckQueue, _ClausesRef, _Dependencies, _ExpandFile, _Expander, _Fid, _FileXml, _Filename, _FreshModuleCounterRef, _HasMainModule, _ImplicitConstructorsRef, _MainSgn, _ModuleListRef, _ModuleQueue, _PredicateIdCounterRef), __36CutLevel), 'emop_call'(_ExpandFile, 'get_scope'(_Mod, _Pos, _SgnVars, _CurrentScope, _Scope), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1988, from character 23 to 32')).
':-'('<module>:emop.expand@11:get_scope$direct'(_____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@11:get_scope'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@12'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@12:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@12'('do', __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@12:do'(__36env, __36CutLevel))).
':-'('<module>:emop.expand@12'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.expand@12$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.expand@12$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.expand@12$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.expand@12$has_predicate'('do'), 'true').
':-'('<module>:emop.expand@12:$sgn'(__36sgn, 'env'(___580, _Impl, _InitGoalIdRef, _CheckQueue, _ClausesRef, _Dependencies, _ExpandFile, _Expander, _Fid, _FileXml, _Filename, _FreshModuleCounterRef, _HasMainModule, _ImplicitConstructorsRef, _MainSgn, _ModuleListRef, _ModuleQueue, _PredicateIdCounterRef, _Ast, _Ast0, _ExpandGoal, _FreeVars, _Goal, _Scope, _SgnVars, _SingletonWarning, _Vars, ___562), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',79985,1962,79959)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',80000,1962,79959)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.expand@12:atom_fresh_[3551]'(_atom__fresh___913552_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913552_93, '[]'))))))).
':-'('<module>:emop.expand@12:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@12:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@12:atom_fresh_[3551]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 0, predicate, [], __36pos))).
':-'('<module>:emop.expand@12:do'('env'(___580, _Impl, _InitGoalIdRef, _CheckQueue, _ClausesRef, _Dependencies, _ExpandFile, _Expander, _Fid, _FileXml, _Filename, _FreshModuleCounterRef, _HasMainModule, _ImplicitConstructorsRef, _MainSgn, _ModuleListRef, _ModuleQueue, _PredicateIdCounterRef, _Ast, _Ast0, _ExpandGoal, _FreeVars, _Goal, _Scope, _SgnVars, _SingletonWarning, _Vars, ___562), __36CutLevel), 'emop_call'(_ExpandGoal, 'singleton_warning', 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1965, from character 32 to 49')).
':-'('<module>:emop.expand@12:do$direct'(__36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@12:do'(__36env, __36CutLevel))).
':-'('<module>:emop.expand@13'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@13:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@13'('do'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@13:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@13'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.expand@13$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.expand@13$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.expand@13$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.expand@13$has_predicate'('do'(_____1)), 'true').
':-'('<module>:emop.expand@13:$sgn'(__36sgn, 'env'(___596, ___562), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',80654,1979,80632)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',80679,1979,80632)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.expand@13:atom_fresh_[3549]'(_atom__fresh___913550_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913550_93, '[]'))))))).
':-'('<module>:emop.expand@13:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@13:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@13:atom_fresh_[3549]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@13:do'(_Check, 'env'(___596, ___562), __36CutLevel), 'emop_call'(_Check, 'do', 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1982, from character 24 to 26')).
':-'('<module>:emop.expand@13:do$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@13:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@14'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@14:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@14'('import'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@14:import'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@14'('do'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@14:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@14'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.expand@14$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.expand@14$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.expand@14$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.expand@14$has_predicate'('import'(_____2, _____1)), 'true').
':-'('<module>:emop.expand@14$has_predicate'('do'(_____2, _____1)), 'true').
':-'('<module>:emop.expand@14:$sgn'(__36sgn, 'env'(___677, _ExpandFile, _Impl, _Fid, _MainSgn, _HasMainModule, _FileXml, _Dependencies, _ModuleListRef, _ClausesRef, _PredicateIdCounterRef, _FreshModuleCounterRef, _ModuleQueue, _CheckQueue, _Ast, _EnvRec, _EnvVars, _FreeVars, _Goals, _ImplicitConstructorsRef, _Pos, _Scope, _SgnVars, _ThisOption, ___553), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',8052,265,8040)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',8060,265,8040)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','('true', '<module>:emop.expand@14:atom_fresh_[4186]'(_atom__fresh___914187_93, __36Pb, __36Pe)), '<module>:emop.expand@14:atom_fresh_[4188]'(_atom__fresh___914189_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___914189_93, '.'(_atom__fresh___914187_93, '[]')))))))).
':-'('<module>:emop.expand@14:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@14:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@14:atom_fresh_[4186]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@14:atom_fresh_[4188]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(import, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@14:do'(_A, _List, 'env'(___677, _ExpandFile, _Impl, _Fid, _MainSgn, _HasMainModule, _FileXml, _Dependencies, _ModuleListRef, _ClausesRef, _PredicateIdCounterRef, _FreshModuleCounterRef, _ModuleQueue, _CheckQueue, _Ast, _EnvRec, _EnvVars, _FreeVars, _Goals, _ImplicitConstructorsRef, _Pos, _Scope, _SgnVars, _ThisOption, ___553), __36CutLevel), ';'('->'(','('g_read'('data.list', '<module>:data.list'(___2792)), '<module>:data.list:append$direct'(_H, '.'('callable'(',', 'unescaped', 'none', _, _), _T), _A, ___2792)), ','(','('='(_List, '.'(___2793, _Tail)), 'emop_call'(___677, 'import'(_H, ___2793), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 292, from character 29 to 35')), 'emop_call'(___677, 'do'(_T, _Tail), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 293, from character 21 to 23'))), ','('='(_List, '.'(___2795, '[]')), 'emop_call'(___677, 'import'(_A, ___2795), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 295, from character 29 to 35')))).
':-'('<module>:emop.expand@14:do$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@14:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@14:import'(_Expr, _Goal, 'env'(___677, _ExpandFile, _Impl, _Fid, _MainSgn, _HasMainModule, _FileXml, _Dependencies, _ModuleListRef, _ClausesRef, _PredicateIdCounterRef, _FreshModuleCounterRef, _ModuleQueue, _CheckQueue, _Ast, _EnvRec, _EnvVars, _FreeVars, _Goals, _ImplicitConstructorsRef, _Pos, _Scope, _SgnVars, _ThisOption, ___553), __36CutLevel), ','(','('='(_Expr0, ___2764), ','(','(','('g_read'('emop.parse', '<module>:emop.parse'(___2762)), '<module>:emop.parse:reconcat_list$direct'(_Expr, _Pos, ___2761, ___2762)), 'emop_call'(_Impl, 'grammars'(_Scope, ___2763), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 268, from character 97 to 105')), ','('g_read'('emop.parser', '<module>:emop.parser'(___2765)), '<module>:emop.parser:internal_reparse$direct'(___2761, ___2763, ___2764, ___2765)))), ','(','('='(_FreeVars1, ___2767), ','('g_read'('emop.parse', '<module>:emop.parse'(___2768)), '<module>:emop.parse:fv$direct'(_Expr0, ___2767, ___2768))), ','(','('g_read'('data.list', '<module>:data.list'(___2770)), '<module>:data.list:append$direct'(_FreeVars, _FreeVars1, _FreeVars2, ___2770)), ','(','('='(_SubSgnVars, ___2771), 'emop_call'(_SgnVars, 'copy'(___2771), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 271, from character 39 to 43')), ','(','('='(_LocalExpander, ___2773), ','('emop_call'(_EnvRec, 'copy'(___2772), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 272, from character 50 to 54'), 'emop_call'(___553, 'expander'(___2772, _SubSgnVars, _ThisOption, _EnvVars, _FreeVars2, _ImplicitConstructorsRef, ___2773), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 272, from character 34 to 42'))), ','('='(_Ctx, 'ctx'('none', _Scope)), ','(','('='(_H1, ___2776), 'emop_call'(_LocalExpander, 'transform_term'(_Expr0, _Ctx, _Goal0, ___2776), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 274, from character 37 to 51')), ','(';'('->'('='(_H1, 'var'(_HVarMod)), ','('='(_SubSgn, ___2778), 'emop_call'(_SubSgnVars, '{}'(_HVarMod, ___2778), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 278, from character 41 to 42'))), 'true'), ','(','(','('true', ';'('->'('var'(___2779), ','('g_inc'('$module_count', ___2780), '='(___2779, '$module'(___2780, '.'('<module>:emop.expand@49'('env'(___2779, _ExpandFile, _Impl, _Fid, _MainSgn, _HasMainModule, _FileXml, _Dependencies, _ModuleListRef, _ClausesRef, _PredicateIdCounterRef, _FreshModuleCounterRef, _ModuleQueue, _CheckQueue, _Ast, _EnvRec, _EnvVars, _FreeVars, _Goals, _ImplicitConstructorsRef, _Pos, _Scope, _SgnVars, _ThisOption, _Ctx, _Expr, _Expr0, _FreeVars1, _FreeVars2, _Goal, _Goal0, _H1, _HVarMod, _LocalExpander, _SubSgn, _SubSgnVars, ___677, ___553)), '[]'), '.'(___2779, '[]'))))), ','('='(___2779, '$module'(___2780, ___2781, _)), ','('='('.'(___2782, ___2783), ___2781), ','('setarg'(1, ___2781, '<module>:emop.expand@49'('env'(___2779, _ExpandFile, _Impl, _Fid, _MainSgn, _HasMainModule, _FileXml, _Dependencies, _ModuleListRef, _ClausesRef, _PredicateIdCounterRef, _FreshModuleCounterRef, _ModuleQueue, _CheckQueue, _Ast, _EnvRec, _EnvVars, _FreeVars, _Goals, _ImplicitConstructorsRef, _Pos, _Scope, _SgnVars, _ThisOption, _Ctx, _Expr, _Expr0, _FreeVars1, _FreeVars2, _Goal, _Goal0, _H1, _HVarMod, _LocalExpander, _SubSgn, _SubSgnVars, ___677, ___553))), 'setarg'(2, ___2781, '.'(___2782, ___2783))))))), 'emop_call'(___553, 'queue_check'(___2779), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 282, from character 18 to 29')), '='(_Goal, 'import'(_H1, _SubSgn, _Goal0)))))))))))).
':-'('<module>:emop.expand@14:import$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@14:import'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@15'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@15:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@15'('expand_module_name'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@15:expand_module_name'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@15'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.expand@15$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.expand@15$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.expand@15$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.expand@15$has_predicate'('expand_module_name'(_____1)), 'true').
':-'('<module>:emop.expand@15:$sgn'(__36sgn, 'env'(___698, _Title, _Sgn, _VarSgn, _ModuleGoal0, _Fid, _MainSgn, _ExpandFile, _IntEnvList0, _ExtEnvList0, _IntEnvList, _ExtEnvList, _IntEnvTerm, _This, _InheritedEnvVars, _EnvVars, _LocalId, _ModuleListRef, _SupSgnVars, _Vars, _Impl, _HasMainModule, ___553), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',9910,312,9898)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',10465,334,10450)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.expand@15:atom_fresh_[4157]'(_atom__fresh___914158_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___914158_93, '[]'))))))).
':-'('<module>:emop.expand@15:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@15:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@15:atom_fresh_[4157]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(expand_module_name, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@15:expand_module_name'('atom'(_Title, _Escaped, _Pb, _Pe), 'env'(___698, _Title, _Sgn, _VarSgn, _ModuleGoal0, _Fid, _MainSgn, _ExpandFile, _IntEnvList0, _ExtEnvList0, _IntEnvList, _ExtEnvList, _IntEnvTerm, _This, _InheritedEnvVars, _EnvVars, _LocalId, _ModuleListRef, _SupSgnVars, _Vars, _Impl, _HasMainModule, ___553), __36CutLevel), ','(','('g_read'('emop.parser', '<module>:emop.parser'(___2579)), '<module>:emop.parser:fresh_var$direct'(_ModuleCount, ___2579)), ','(','('g_read'('emop.parser', '<module>:emop.parser'(___2581)), '<module>:emop.parser:fresh_var$direct'(_ClosureList, ___2581)), ','('='(_IncrModuleCounter, 'callable'('g_inc', '.'('callable'('$module_count', '[]'), '.'(_ModuleCount, '[]')))), ','(','('g_read'('emop.parser', '<module>:emop.parser'(___2591)), '<module>:emop.parser:fresh_var$direct'(_Head, ___2591)), ','(','('g_read'('emop.parser', '<module>:emop.parser'(___2593)), '<module>:emop.parser:fresh_var$direct'(_Tail, ___2593)), ','('='(_AppendClosure, 'callable'(',', '.'('callable'('=', '.'('callable'('.', '.'(_Head, '.'(_Tail, '[]'))), '.'(_ClosureList, '[]'))), '.'('callable'(',', '.'('callable'('setarg', '.'('number'(1), '.'(_ClosureList, '.'(_ExtModTerm, '[]')))), '.'('callable'('setarg', '.'('number'(2), '.'(_ClosureList, '.'('callable'('.', '.'(_Head, '.'(_Tail, '[]'))), '[]')))), '[]'))), '[]')))), ';'('->'(','('g_read'('emop.parser', '<module>:emop.parser'(___2635)), '<module>:emop.parser:is_variable$direct'(_Title, _Escaped, 'none', ___2635)), ','('emop_call'(_Impl, 'var_lookup'(_Title, _Pb, _Pe, _Vars, _), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 382, from character 26 to 36'), ','(','('='(___2636, _VarSgn), 'emop_call'(_SupSgnVars, '{}'(_Title, ___2636), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 383, from character 32 to 33')), ','(','('g_read'('emop.parser', '<module>:emop.parser'(___2638)), '<module>:emop.parser:fresh_var$direct'(_This, ___2638)), ','('='(_EnvVars, '.'(_This, _InheritedEnvVars)), ','('='(_IntEnvList, '.'(_This, _IntEnvList0)), ','('='(_ExtEnvList, '.'('var'(_Title), _ExtEnvList0)), ','('emop_call'(_ExpandFile, 'fresh_module_index'(_Index), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 388, from character 32 to 50'), ','(','('='(_LocalId, ___2650), ','(','('g_read'('data.atom', '<module>:data.atom'(___2649)), '<module>:data.atom:format$direct'('~a@~d', '.'(_Fid, '.'(_Index, '[]')), ___2648, ___2649)), 'emop_call'(___553, 'prolog_module_name'(___2648, ___2650), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 389, from character 31 to 49'))), ','(','('emop_call'(_ModuleListRef, 'get'(___2651), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 390, from character 64 to 67'), 'emop_call'(_ModuleListRef, 'set'('.'(_LocalId, ___2651)), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 390, from character 35 to 38')), ','('='(_IntEnvTerm, 'callable'('env', _IntEnvList)), ','('='(_ExtEnvTerm, 'callable'('env', _ExtEnvList)), ','('='(_ExtModTerm, 'callable'(_LocalId, '.'(_ExtEnvTerm, '[]'))), '='(_ModuleGoal0, 'callable'(';', '.'('callable'('->', '.'('callable'('var', '.'('var'(_Title), '[]')), '.'('callable'(',', '.'(_IncrModuleCounter, '.'('callable'('=', '.'('var'(_Title), '.'('callable'('$module', '.'(_ModuleCount, '.'('callable'('.', '.'(_ExtModTerm, '.'('callable'('[]', '[]'), '[]'))), '.'('callable'('.', '.'('var'(_Title), '.'('callable'('[]', '[]'), '[]'))), '[]')))), '[]'))), '[]'))), '[]'))), '.'('callable'(',', '.'('callable'('=', '.'('var'(_Title), '.'('callable'('$module', '.'(_ModuleCount, '.'(_ClosureList, '.'('var'('_'), '[]')))), '[]'))), '.'(_AppendClosure, '[]'))), '[]'))))))))))))))))), ','(';'('->'(','('g_read'('data.var', '<module>:data.var'(___2729)), '<module>:data.var:check$direct'(_HasMainModule, ___2729)), '='(_HasMainModule, 'true')), 'throw'('error'('There can only be one main module per file.', 'file'(_Pb, _Pe)))), ','('='(_MainSgn, _Sgn), ','(';'('->'('='(_Fid, _Title), 'true'), ','(','('g_read'('data.atom', '<module>:data.atom'(___2739)), '<module>:data.atom:format$direct'('The named module should be ~a.', '.'(_Fid, '[]'), ___2738, ___2739)), 'throw'('error'(___2738, 'file'(_Pb, _Pe))))), ','('='(_This, 'callable'(_Title, '[]')), ','('='(_EnvVars, _InheritedEnvVars), ','('='(_IntEnvList, _IntEnvList0), ','('='(_ExtEnvList, _ExtEnvList0), ','(','('='(_LocalId, ___2744), 'emop_call'(___553, 'prolog_module_name'(_Fid, ___2744), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 478, from character 31 to 49')), ','(','('emop_call'(_ModuleListRef, 'get'(___2745), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 479, from character 64 to 67'), 'emop_call'(_ModuleListRef, 'set'('.'(_LocalId, ___2745)), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 479, from character 35 to 38')), ','('='(_IntEnvTerm, 'callable'('env', _IntEnvList)), ','('='(_ExtEnvTerm, 'callable'('env', _ExtEnvList)), ','('='(_ExtModTerm, 'callable'(_LocalId, '.'(_ExtEnvTerm, '[]'))), '='(_ModuleGoal0, 'callable'('g_link', '.'(_This, '.'(_ExtModTerm, '[]')))))))))))))))))))))))).
':-'('<module>:emop.expand@15:expand_module_name$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@15:expand_module_name'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@16'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@16:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@16'('args'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@16:args'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@16'('prefixed'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@16:prefixed'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@16'('add_clause'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@16:add_clause'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@16'('proto_args'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@16:proto_args'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@16'('add_predicate'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@16:add_predicate'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@16'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.expand@16$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.expand@16$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.expand@16$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.expand@16$has_predicate'('args'(_____2, _____1)), 'true').
':-'('<module>:emop.expand@16$has_predicate'('prefixed'(_____2, _____1)), 'true').
':-'('<module>:emop.expand@16$has_predicate'('add_clause'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand@16$has_predicate'('proto_args'(_____2, _____1)), 'true').
':-'('<module>:emop.expand@16$has_predicate'('add_predicate'(_____2, _____1)), 'true').
':-'('<module>:emop.expand@16:$sgn'(__36sgn, 'env'(___747, _LocalId, _IntEnvTerm, _ExpandFile, _HasPredicate, ___553), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',18833,509,18824)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',18899,509,18824)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','(','(','('true', '<module>:emop.expand@16:atom_fresh_[4115]'(_atom__fresh___914116_93, __36Pb, __36Pe)), '<module>:emop.expand@16:atom_fresh_[4117]'(_atom__fresh___914118_93, __36Pb, __36Pe)), '<module>:emop.expand@16:atom_fresh_[4119]'(_atom__fresh___914120_93, __36Pb, __36Pe)), '<module>:emop.expand@16:atom_fresh_[4121]'(_atom__fresh___914122_93, __36Pb, __36Pe)), '<module>:emop.expand@16:atom_fresh_[4123]'(_atom__fresh___914124_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___914124_93, '.'(_atom__fresh___914122_93, '.'(_atom__fresh___914120_93, '.'(_atom__fresh___914118_93, '.'(_atom__fresh___914116_93, '[]'))))))))))).
':-'('<module>:emop.expand@16:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@16:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@16:add_clause'(_F, _Args, _Body, 'env'(___747, _LocalId, _IntEnvTerm, _ExpandFile, _HasPredicate, ___553), __36CutLevel), ','(','('emop_call'(___747, 'prefixed'(_F, ___2494), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 518, from character 37 to 45'), 'emop_call'(___747, 'args'(_Args, ___2495), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 518, from character 50 to 54')), 'emop_call'(_ExpandFile, 'add_clause'(___2494, ___2495, _Body), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 518, from character 26 to 36'))).
':-'('<module>:emop.expand@16:add_clause$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@16:add_clause'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@16:add_predicate'(_F, _N, 'env'(___747, _LocalId, _IntEnvTerm, _ExpandFile, _HasPredicate, ___553), __36CutLevel), ','('emop_call'(___747, 'proto_args'(_N, _ProtoArgs), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 533, from character 15 to 25'), ','(','('g_read'('data.list', '<module>:data.list'(___2516)), '<module>:data.list:append$direct'(_ProtoArgs, '.'('var'('$env'), '.'('var'('$CutLevel'), '[]')), _ProtoEnv, ___2516)), ','('emop_call'(_ExpandFile, 'add_clause'(_HasPredicate, '.'('callable'(_F, _ProtoArgs), '[]'), 'callable'('true', '[]')), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 539, from character 26 to 36'), ','(','('='(_PrefixedF, ___2523), 'emop_call'(___553, 'prolog_predicate_name'(_LocalId, _F, ___2523), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 544, from character 27 to 48')), ','(','(','('emop_call'(___553, 'predicate_name_direct'(_PrefixedF, ___2524), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 546, from character 18 to 39'), ','('g_read'('data.list', '<module>:data.list'(___2531)), '<module>:data.list:append$direct'(_ProtoArgs, '.'('var'('$env'), '[]'), ___2530, ___2531))), 'emop_call'(_ExpandFile, 'add_clause'(___2524, ___2530, 'callable'(',', '.'('callable'(',', '.'('callable'('!', '[]'), '.'('callable'('=', '.'('var'('$CutLevel'), '.'('callable'('$cut', '[]'), '[]'))), '[]'))), '.'('callable'(_PrefixedF, _ProtoEnv), '[]')))), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 545, from character 26 to 36')), 'emop_call'(_ExpandFile, 'add_clause'(_LocalId, '.'('callable'(_F, _ProtoArgs), '.'('var'('$env'), '.'('var'('_'), '.'('var'('$CutLevel'), '[]')))), 'callable'(',', '.'('callable'('!', '[]'), '.'('callable'(_PrefixedF, _ProtoEnv), '[]')))), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 571, from character 26 to 36'))))))).
':-'('<module>:emop.expand@16:add_predicate$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@16:add_predicate'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@16:args'(_Args, ___2485, 'env'(___747, _LocalId, _IntEnvTerm, _ExpandFile, _HasPredicate, ___553), __36CutLevel), ','('g_read'('data.list', '<module>:data.list'(___2486)), '<module>:data.list:append$direct'(_Args, '.'(_IntEnvTerm, '.'('var'('$CutLevel'), '[]')), ___2485, ___2486))).
':-'('<module>:emop.expand@16:args$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@16:args'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@16:atom_fresh_[4115]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(add_predicate, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@16:atom_fresh_[4117]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(proto_args, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@16:atom_fresh_[4119]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(add_clause, 3, predicate, suspended([var('F'),var('Args'),var('Body')],[call(var('ExpandFile'),add_clause,[none,none,var('Body')])]), __36pos))).
':-'('<module>:emop.expand@16:atom_fresh_[4121]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(prefixed, 2, predicate, suspended([var('F'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.expand@16:atom_fresh_[4123]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(args, 2, predicate, suspended([var('Args'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.expand@16:prefixed'(_F, ___2492, 'env'(___747, _LocalId, _IntEnvTerm, _ExpandFile, _HasPredicate, ___553), __36CutLevel), ','('g_read'('data.atom', '<module>:data.atom'(___2493)), '<module>:data.atom:format$direct'('~a:~a', '.'(_LocalId, '.'(_F, '[]')), ___2492, ___2493))).
':-'('<module>:emop.expand@16:prefixed$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@16:prefixed'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@16:proto_args'(_N, _Args, 'env'(___747, _LocalId, _IntEnvTerm, _ExpandFile, _HasPredicate, ___553), __36CutLevel), ';'('->'(','('g_read'('data.number', '<module>:data.number'(___2497)), '<module>:data.number:>$direct'(_N, 0, ___2497)), ','(','('g_read'('data.atom', '<module>:data.atom'(___2502)), '<module>:data.atom:format$direct'('__~d', '.'(_N, '[]'), _Atom, ___2502)), ','('='(_Args, '.'('var'(_Atom), _Tail)), ','(','('g_read'('data.number', '<module>:data.number'(___2506)), '<module>:data.number:pred$direct'(_N, _M, ___2506)), 'emop_call'(___747, 'proto_args'(_M, _Tail), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 527, from character 18 to 28'))))), '='(_Args, '[]'))).
':-'('<module>:emop.expand@16:proto_args$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@16:proto_args'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@17'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@17:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@17'('simpl'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@17:simpl'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@17'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.expand@17$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.expand@17$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.expand@17$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.expand@17$has_predicate'('simpl'(_____2, _____1)), 'true').
':-'('<module>:emop.expand@17:$sgn'(__36sgn, 'env'(___759, _AccuGoal, _ExpandFile, _LocalId, ___553), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',21454,584,21445)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',21506,584,21445)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.expand@17:atom_fresh_[4027]'(_atom__fresh___914028_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___914028_93, '[]'))))))).
':-'('<module>:emop.expand@17:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@17:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@17:atom_fresh_[4027]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(simpl, 2, predicate, suspended([var('Sgn'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.expand@17:simpl'(_Sgn, ___2293, 'env'(___759, _AccuGoal, _ExpandFile, _LocalId, ___553), __36CutLevel), ','(','('true', ';'('->'('var'(___2287), ','('g_inc'('$module_count', ___2288), '='(___2287, '$module'(___2288, '.'('<module>:emop.expand@48'('env'(___2287, _AccuGoal, _ExpandFile, _LocalId, _Sgn, ___759, ___553)), '[]'), '.'(___2287, '[]'))))), ','('='(___2287, '$module'(___2288, ___2289, _)), ','('='('.'(___2290, ___2291), ___2289), ','('setarg'(1, ___2289, '<module>:emop.expand@48'('env'(___2287, _AccuGoal, _ExpandFile, _LocalId, _Sgn, ___759, ___553))), 'setarg'(2, ___2289, '.'(___2290, ___2291))))))), ','('g_read'('data.list', '<module>:data.list'(___2294)), '<module>:data.list:fold_right$direct'(_Sgn, 'callable'('[]', '[]'), ___2287, ___2293, ___2294)))).
':-'('<module>:emop.expand@17:simpl$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@17:simpl'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@18'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@18:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@18'('do'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@18:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@18'('do'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@18:do'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@18'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.expand@18$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.expand@18$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.expand@18$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.expand@18$has_predicate'('do'(_____1)), 'true').
':-'('<module>:emop.expand@18$has_predicate'('do'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand@18:$sgn'(__36sgn, 'env'(___834, _AddClause, ___553), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',25284,671,25265)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',25307,671,25265)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','('true', '<module>:emop.expand@18:atom_fresh_[3970]'(_atom__fresh___913971_93, __36Pb, __36Pe)), '<module>:emop.expand@18:atom_fresh_[3972]'(_atom__fresh___913973_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913973_93, '.'(_atom__fresh___913971_93, '[]')))))))).
':-'('<module>:emop.expand@18:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@18:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@18:atom_fresh_[3970]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 3, predicate, suspended([none,var('F'),var('N')],[call(var('AddClause'),add_predicate,[var('F'),var('N')])]), __36pos))).
':-'('<module>:emop.expand@18:atom_fresh_[3972]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@18:do'('symbol'(_F, _N, _Kind, _, _), 'env'(___834, _AddClause, ___553), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), 'emop_call'(___834, 'do'(_Kind, _F, _N), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 675, from character 15 to 17'))).
':-'('<module>:emop.expand@18:do'(_, 'env'(___834, _AddClause, ___553), __36CutLevel), 'true').
':-'('<module>:emop.expand@18:do'('predicate', _F, _N, 'env'(___834, _AddClause, ___553), __36CutLevel), 'emop_call'(_AddClause, 'add_predicate'(_F, _N), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 679, from character 25 to 38')).
':-'('<module>:emop.expand@18:do'('constructor', _F, _N, 'env'(___834, _AddClause, ___553), __36CutLevel), ','('emop_call'(_AddClause, 'add_predicate'(_F, _N), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 681, from character 25 to 38'), ','(','('g_read'('data.list', '<module>:data.list'(___2237)), '<module>:data.list:length$direct'(_Args, _N, ___2237)), ','(','(','('true', ';'('->'('var'(___2239), ','('g_inc'('$module_count', ___2240), '='(___2239, '$module'(___2240, '.'('<module>:emop.expand@46'('env'(___2239, _AddClause, _Args, _Args0, _Body, _F, _List, _List0, _N, _Result, ___834, ___553)), '[]'), '.'(___2239, '[]'))))), ','('='(___2239, '$module'(___2240, ___2241, _)), ','('='('.'(___2242, ___2243), ___2241), ','('setarg'(1, ___2241, '<module>:emop.expand@46'('env'(___2239, _AddClause, _Args, _Args0, _Body, _F, _List, _List0, _N, _Result, ___834, ___553))), 'setarg'(2, ___2241, '.'(___2242, ___2243))))))), ','('g_read'('data.list', '<module>:data.list'(___2245)), '<module>:data.list:iter$direct'(_Args, ___2239, ___2245))), ','(','('g_read'('data.list', '<module>:data.list'(___2249)), '<module>:data.list:append$direct'(_Args0, '.'(_Result, '[]'), _Args, ___2249)), ','(','('='(_List0, ___2260), ','(','('true', ';'('->'('var'(___2254), ','('g_inc'('$module_count', ___2255), '='(___2254, '$module'(___2255, '.'('<module>:emop.expand@47'('env'(___2254, _AddClause, _Args, _Args0, _Body, _F, _List, _List0, _N, _Result, ___834, ___553)), '[]'), '.'(___2254, '[]'))))), ','('='(___2254, '$module'(___2255, ___2256, _)), ','('='('.'(___2257, ___2258), ___2256), ','('setarg'(1, ___2256, '<module>:emop.expand@47'('env'(___2254, _AddClause, _Args, _Args0, _Body, _F, _List, _List0, _N, _Result, ___834, ___553))), 'setarg'(2, ___2256, '.'(___2257, ___2258))))))), ','('g_read'('data.list', '<module>:data.list'(___2261)), '<module>:data.list:fold_right$direct'(_Args0, 'callable'('[]', '[]'), ___2254, ___2260, ___2261)))), ','('='(_List, 'callable'('.', '.'('callable'(_F, '[]'), '.'(_List0, '[]')))), ','('='(_Body, 'callable'('=..', '.'(_Result, '.'(_List, '[]')))), 'emop_call'(_AddClause, 'add_clause'(_F, _Args, _Body), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 693, from character 25 to 35'))))))))).
':-'('<module>:emop.expand@18:do'('abstract', _, _, 'env'(___834, _AddClause, ___553), __36CutLevel), 'true').
':-'('<module>:emop.expand@18:do$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@18:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@18:do$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@18:do'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@19'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@19:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@19'('do'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@19:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@19'('do_special'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@19:do_special'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@19'('generate_doc'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@19:generate_doc'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@19'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.expand@19$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.expand@19$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.expand@19$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.expand@19$has_predicate'('do'(_____1)), 'true').
':-'('<module>:emop.expand@19$has_predicate'('do_special'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand@19$has_predicate'('generate_doc'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand@19:$sgn'(__36sgn, 'env'(___867, _AddClause, _EnvRec, _This, _EnvVars, _CurrentScopeRef, _ImplicitConstructorsRef, _Impl, _EnvList0, _FileXml, _SgnVars, _EnvListRef, _ModuleGoalRef, _Dependencies, ___553), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',26621,702,26599)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',26997,716,26982)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','('true', '<module>:emop.expand@19:atom_fresh_[3795]'(_atom__fresh___913796_93, __36Pb, __36Pe)), '<module>:emop.expand@19:atom_fresh_[3797]'(_atom__fresh___913798_93, __36Pb, __36Pe)), '<module>:emop.expand@19:atom_fresh_[3799]'(_atom__fresh___913800_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913800_93, '.'(_atom__fresh___913798_93, '.'(_atom__fresh___913796_93, '[]'))))))))).
':-'('<module>:emop.expand@19:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@19:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@19:atom_fresh_[3795]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(generate_doc, 3, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@19:atom_fresh_[3797]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do_special, 4, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@19:atom_fresh_[3799]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 1, predicate, suspended([none],[call(scope,do_special,[var('S'),var('Desc'),var('Pb'),var('Pe')])]), __36pos))).
':-'('<module>:emop.expand@19:do'('special'(_S, _Desc, _Pb, _Pe), 'env'(___867, _AddClause, _EnvRec, _This, _EnvVars, _CurrentScopeRef, _ImplicitConstructorsRef, _Impl, _EnvList0, _FileXml, _SgnVars, _EnvListRef, _ModuleGoalRef, _Dependencies, ___553), __36CutLevel), 'emop_call'(___867, 'do_special'(_S, _Desc, _Pb, _Pe), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 719, from character 18 to 28')).
':-'('<module>:emop.expand@19:do'('clause'(_F, _Args0, _B0, _Doc, _, _), 'env'(___867, _AddClause, _EnvRec, _This, _EnvVars, _CurrentScopeRef, _ImplicitConstructorsRef, _Impl, _EnvList0, _FileXml, _SgnVars, _EnvListRef, _ModuleGoalRef, _Dependencies, ___553), __36CutLevel), ','('emop_call'(___867, 'generate_doc'(_Doc, _F, _Args0), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 818, from character 18 to 30'), ','(','('='(_Args, ___2126), ','(','('true', ';'('->'('var'(___2120), ','('g_inc'('$module_count', ___2121), '='(___2120, '$module'(___2121, '.'('<module>:emop.expand@43'('env'(___2120, _AddClause, _EnvRec, _This, _EnvVars, _CurrentScopeRef, _ImplicitConstructorsRef, _Impl, _EnvList0, _FileXml, _SgnVars, _EnvListRef, _ModuleGoalRef, _Dependencies, _Args, _Args0, _Args1, _B, _B0, _Body, _Body0, _Body1, _Ctx, _Doc, _F, _FreeVars, _FreeVars0, _FreeVars1, _FreeVars2, _LocalExpander, ___867, ___553)), '[]'), '.'(___2120, '[]'))))), ','('='(___2120, '$module'(___2121, ___2122, _)), ','('='('.'(___2123, ___2124), ___2122), ','('setarg'(1, ___2122, '<module>:emop.expand@43'('env'(___2120, _AddClause, _EnvRec, _This, _EnvVars, _CurrentScopeRef, _ImplicitConstructorsRef, _Impl, _EnvList0, _FileXml, _SgnVars, _EnvListRef, _ModuleGoalRef, _Dependencies, _Args, _Args0, _Args1, _B, _B0, _Body, _Body0, _Body1, _Ctx, _Doc, _F, _FreeVars, _FreeVars0, _FreeVars1, _FreeVars2, _LocalExpander, ___867, ___553))), 'setarg'(2, ___2122, '.'(___2123, ___2124))))))), ','('g_read'('data.list', '<module>:data.list'(___2127)), '<module>:data.list:iter$direct'(_Args0, ___2120, ___2126, ___2127)))), ','(','('='(_B, ___2131), ','(','('emop_call'(_CurrentScopeRef, 'get'(___2129), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 822, from character 85 to 88'), 'emop_call'(_Impl, 'grammars'(___2129, ___2130), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 822, from character 60 to 68')), ','('g_read'('emop.parser', '<module>:emop.parser'(___2132)), '<module>:emop.parser:internal_reparse$direct'(_B0, ___2130, ___2131, ___2132)))), ','(','('='(_FreeVars0, ___2134), ','('g_read'('emop.parse', '<module>:emop.parse'(___2135)), '<module>:emop.parse:fv_list$direct'(_Args, ___2134, ___2135))), ','(','('='(_FreeVars1, ___2137), ','('g_read'('emop.parse', '<module>:emop.parse'(___2138)), '<module>:emop.parse:fv$direct'(_B, ___2137, ___2138))), ','(','('g_read'('data.list', '<module>:data.list'(___2141)), '<module>:data.list:merge$direct'(_FreeVars0, _FreeVars1, 'data.term', _FreeVars2, ___2141)), ','(','(','(','('true', ';'('->'('var'(___2144), ','('g_inc'('$module_count', ___2145), '='(___2144, '$module'(___2145, '.'('<module>:emop.expand@44'('env'(___2144, _AddClause, _EnvRec, _This, _EnvVars, _CurrentScopeRef, _ImplicitConstructorsRef, _Impl, _EnvList0, _FileXml, _SgnVars, _EnvListRef, _ModuleGoalRef, _Dependencies, _Args, _Args0, _Args1, _B, _B0, _Body, _Body0, _Body1, _Ctx, _Doc, _F, _FreeVars, _FreeVars0, _FreeVars1, _FreeVars2, _LocalExpander, ___867, ___553)), '[]'), '.'(___2144, '[]'))))), ','('='(___2144, '$module'(___2145, ___2146, _)), ','('='('.'(___2147, ___2148), ___2146), ','('setarg'(1, ___2146, '<module>:emop.expand@44'('env'(___2144, _AddClause, _EnvRec, _This, _EnvVars, _CurrentScopeRef, _ImplicitConstructorsRef, _Impl, _EnvList0, _FileXml, _SgnVars, _EnvListRef, _ModuleGoalRef, _Dependencies, _Args, _Args0, _Args1, _B, _B0, _Body, _Body0, _Body1, _Ctx, _Doc, _F, _FreeVars, _FreeVars0, _FreeVars1, _FreeVars2, _LocalExpander, ___867, ___553))), 'setarg'(2, ___2146, '.'(___2147, ___2148))))))), ','('g_read'('data.list', '<module>:data.list'(___2151)), '<module>:data.list:iter$direct'(_EnvList0, ___2144, ___2150, ___2151))), ','('g_read'('data.list', '<module>:data.list'(___2152)), '<module>:data.list:append$direct'(___2150, _FreeVars2, _FreeVars, ___2152))), ','(','('='(_LocalExpander, ___2156), ','(','('emop_call'(_EnvRec, 'copy'(___2153), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 833, from character 50 to 54'), 'emop_call'(_SgnVars, 'copy'(___2154), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 833, from character 64 to 68')), 'emop_call'(___553, 'expander'(___2153, ___2154, 'some'(_This), _EnvVars, _FreeVars, _ImplicitConstructorsRef, ___2156), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 833, from character 34 to 42'))), ','(','('='(_Ctx, 'ctx'('none', ___2158)), 'emop_call'(_CurrentScopeRef, 'get'(___2158), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 834, from character 50 to 53')), ','(';'('->'(','('='(_Args1, ___2160), 'emop_call'(_LocalExpander, 'transform_term_list'(_Args, _Ctx, _Body0, ___2160), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 836, from character 43 to 62')), 'true'), 'throw'('error'('expand_args'))), ','(';'('->'('emop_call'(_LocalExpander, 'transform_goal'(_B, _Ctx, _Body1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 843, from character 35 to 49'), 'true'), ','(','('g_read'('io.err', '<module>:io.err'(___2164)), '<module>:io.err:print_endline$direct'(_B, ___2164)), ','(','('g_read'('io.err', '<module>:io.err'(___2166)), '<module>:io.err:flush$direct'(___2166)), 'throw'('error'('expand_goal'))))), ','('emop_call'(_Impl, 'seq'(_Body0, _Body1, _Body), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 851, from character 23 to 26'), ','(','(','('true', ';'('->'('var'(___2169), ','('g_inc'('$module_count', ___2170), '='(___2169, '$module'(___2170, '.'('<module>:emop.expand@45'('env'(___2169, _AddClause, _EnvRec, _This, _EnvVars, _CurrentScopeRef, _ImplicitConstructorsRef, _Impl, _EnvList0, _FileXml, _SgnVars, _EnvListRef, _ModuleGoalRef, _Dependencies, _Args, _Args0, _Args1, _B, _B0, _Body, _Body0, _Body1, _Ctx, _Doc, _F, _FreeVars, _FreeVars0, _FreeVars1, _FreeVars2, _LocalExpander, ___867, ___553)), '[]'), '.'(___2169, '[]'))))), ','('='(___2169, '$module'(___2170, ___2171, _)), ','('='('.'(___2172, ___2173), ___2171), ','('setarg'(1, ___2171, '<module>:emop.expand@45'('env'(___2169, _AddClause, _EnvRec, _This, _EnvVars, _CurrentScopeRef, _ImplicitConstructorsRef, _Impl, _EnvList0, _FileXml, _SgnVars, _EnvListRef, _ModuleGoalRef, _Dependencies, _Args, _Args0, _Args1, _B, _B0, _Body, _Body0, _Body1, _Ctx, _Doc, _F, _FreeVars, _FreeVars0, _FreeVars1, _FreeVars2, _LocalExpander, ___867, ___553))), 'setarg'(2, ___2171, '.'(___2172, ___2173))))))), 'emop_call'(___553, 'queue_check'(___2169), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 852, from character 18 to 29')), 'emop_call'(_AddClause, 'add_clause'(_F, _Args1, _Body), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 856, from character 28 to 38'))))))))))))))).
':-'('<module>:emop.expand@19:do$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@19:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@19:do_special'(___2026, _Desc, _Pb, _Pe, 'env'(___867, _AddClause, _EnvRec, _This, _EnvVars, _CurrentScopeRef, _ImplicitConstructorsRef, _Impl, _EnvList0, _FileXml, _SgnVars, _EnvListRef, _ModuleGoalRef, _Dependencies, ___553), __36CutLevel), ','(','('='(_S, ___2025), ';'(','('='(___2026, 'syntax'), '='(___2025, 'syntax')), ','('='(___2026, ___2028), ','('='(___2025, ___2027), ';'(','('='(___2028, 'level'), '='(___2027, 'level')), ','('='(___2028, 'notation'), '='(___2027, 'notation'))))))), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','('emop_call'(_CurrentScopeRef, 'get'('.'('scope'(_This, _Sgn, _Grammar), _SupScope)), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 723, from character 34 to 37'), ','(','('='(_SupGrammars, ___2040), 'emop_call'(_Impl, 'grammars'(_SupScope, ___2040), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 724, from character 37 to 45')), ','(','('='(_GrammarRef, ___2042), ','('g_read'('data.ref.backtrackable', '<module>:data.ref.backtrackable'(___2043)), '<module>:data.ref.backtrackable:new$direct'(_Grammar, ___2042, ___2043))), ','(','('='(_S, ___2035), ';'('->'('='(___2035, 'syntax'), ','('g_read'('emop.parser', '<module>:emop.parser'(___2046)), '<module>:emop.parser:expand_syntax$direct'(_GrammarRef, _SupGrammars, _Desc, _Pb, _Pe, ___2046))), ','('='(___2035, ___2036), ';'('->'('='(___2036, 'level'), ','('g_read'('emop.parser', '<module>:emop.parser'(___2049)), '<module>:emop.parser:expand_level$direct'(_GrammarRef, _SupGrammars, _Desc, _Pb, _Pe, ___2049))), ','('='(___2036, ___2037), '->'('='(___2037, 'notation'), ','('g_read'('emop.parser', '<module>:emop.parser'(___2052)), '<module>:emop.parser:add_notation$direct'(_GrammarRef, _SupGrammars, _Desc, _Pb, _Pe, ___2052)))))))), ','('emop_call'(_GrammarRef, 'get'(___2053), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 739, from character 67 to 70'), 'emop_call'(_CurrentScopeRef, 'set'('.'('scope'(_This, _Sgn, ___2053), _SupScope)), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 739, from character 34 to 37'))))))))).
':-'('<module>:emop.expand@19:do_special'('link', _Desc, ___Pb, ___Pe, 'env'(___867, _AddClause, _EnvRec, _This, _EnvVars, _CurrentScopeRef, _ImplicitConstructorsRef, _Impl, _EnvList0, _FileXml, _SgnVars, _EnvListRef, _ModuleGoalRef, _Dependencies, ___553), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','(','('true', ';'('->'('var'(___2058), ','('g_inc'('$module_count', ___2059), '='(___2058, '$module'(___2059, '.'('<module>:emop.expand@40'('env'(___2058, _AddClause, _EnvRec, _This, _EnvVars, _CurrentScopeRef, _ImplicitConstructorsRef, _Impl, _EnvList0, _FileXml, _SgnVars, _EnvListRef, _ModuleGoalRef, _Dependencies, _Desc, ___Pb, ___Pe, ___867, ___553)), '[]'), '.'(___2058, '[]'))))), ','('='(___2058, '$module'(___2059, ___2060, _)), ','('='('.'(___2061, ___2062), ___2060), ','('setarg'(1, ___2060, '<module>:emop.expand@40'('env'(___2058, _AddClause, _EnvRec, _This, _EnvVars, _CurrentScopeRef, _ImplicitConstructorsRef, _Impl, _EnvList0, _FileXml, _SgnVars, _EnvListRef, _ModuleGoalRef, _Dependencies, _Desc, ___Pb, ___Pe, ___867, ___553))), 'setarg'(2, ___2060, '.'(___2061, ___2062))))))), ','('g_read'('data.list', '<module>:data.list'(___2064)), '<module>:data.list:iter$direct'(_Desc, ___2058, ___2064))))).
':-'('<module>:emop.expand@19:do_special'('import', _S, _Pb, _Pe, 'env'(___867, _AddClause, _EnvRec, _This, _EnvVars, _CurrentScopeRef, _ImplicitConstructorsRef, _Impl, _EnvList0, _FileXml, _SgnVars, _EnvListRef, _ModuleGoalRef, _Dependencies, ___553), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','(','('='(_FreeVars, ___2073), ','(','('true', ';'('->'('var'(___2067), ','('g_inc'('$module_count', ___2068), '='(___2067, '$module'(___2068, '.'('<module>:emop.expand@41'('env'(___2067, _AddClause, _EnvRec, _This, _EnvVars, _CurrentScopeRef, _ImplicitConstructorsRef, _Impl, _EnvList0, _FileXml, _SgnVars, _EnvListRef, _ModuleGoalRef, _Dependencies, _FreeVars, _Pb, _Pe, _S, ___867, ___553)), '[]'), '.'(___2067, '[]'))))), ','('='(___2067, '$module'(___2068, ___2069, _)), ','('='('.'(___2070, ___2071), ___2069), ','('setarg'(1, ___2069, '<module>:emop.expand@41'('env'(___2067, _AddClause, _EnvRec, _This, _EnvVars, _CurrentScopeRef, _ImplicitConstructorsRef, _Impl, _EnvList0, _FileXml, _SgnVars, _EnvListRef, _ModuleGoalRef, _Dependencies, _FreeVars, _Pb, _Pe, _S, ___867, ___553))), 'setarg'(2, ___2069, '.'(___2070, ___2071))))))), ','('g_read'('data.list', '<module>:data.list'(___2074)), '<module>:data.list:iter$direct'(_EnvList0, ___2067, ___2073, ___2074)))), ','(','(','('emop_call'(_CurrentScopeRef, 'get'(___2078), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 759, from character 153 to 156'), 'emop_call'(___553, 'expand_import'(_S, 'file'(_Pb, _Pe), _FreeVars, _SgnVars, _EnvRec, _EnvVars, _ImplicitConstructorsRef, 'some'(_This), ___2078, ___2079), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 759, from character 33 to 46')), ','('true', ';'('->'('var'(___2080), ','('g_inc'('$module_count', ___2081), '='(___2080, '$module'(___2081, '.'('<module>:emop.expand@42'('env'(___2080, _AddClause, _EnvRec, _This, _EnvVars, _CurrentScopeRef, _ImplicitConstructorsRef, _Impl, _EnvList0, _FileXml, _SgnVars, _EnvListRef, _ModuleGoalRef, _Dependencies, _FreeVars, _Pb, _Pe, _S, ___867, ___553)), '[]'), '.'(___2080, '[]'))))), ','('='(___2080, '$module'(___2081, ___2082, _)), ','('='('.'(___2083, ___2084), ___2082), ','('setarg'(1, ___2082, '<module>:emop.expand@42'('env'(___2080, _AddClause, _EnvRec, _This, _EnvVars, _CurrentScopeRef, _ImplicitConstructorsRef, _Impl, _EnvList0, _FileXml, _SgnVars, _EnvListRef, _ModuleGoalRef, _Dependencies, _FreeVars, _Pb, _Pe, _S, ___867, ___553))), 'setarg'(2, ___2082, '.'(___2083, ___2084)))))))), ','('g_read'('data.list', '<module>:data.list'(___2086)), '<module>:data.list:iter$direct'(___2079, ___2080, ___2086)))))).
':-'('<module>:emop.expand@19:do_special'(_, _, _, _, 'env'(___867, _AddClause, _EnvRec, _This, _EnvVars, _CurrentScopeRef, _ImplicitConstructorsRef, _Impl, _EnvList0, _FileXml, _SgnVars, _EnvListRef, _ModuleGoalRef, _Dependencies, ___553), __36CutLevel), 'true').
':-'('<module>:emop.expand@19:do_special$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@19:do_special'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@19:generate_doc'('nodoc', _, _, 'env'(___867, _AddClause, _EnvRec, _This, _EnvVars, _CurrentScopeRef, _ImplicitConstructorsRef, _Impl, _EnvList0, _FileXml, _SgnVars, _EnvListRef, _ModuleGoalRef, _Dependencies, ___553), __36CutLevel), 'true').
':-'('<module>:emop.expand@19:generate_doc'('doc'(_Text, _, _), _F, _Args, 'env'(___867, _AddClause, _EnvRec, _This, _EnvVars, _CurrentScopeRef, _ImplicitConstructorsRef, _Impl, _EnvList0, _FileXml, _SgnVars, _EnvListRef, _ModuleGoalRef, _Dependencies, ___553), __36CutLevel), ','(','(','('g_read'('data.list', '<module>:data.list'(___2093)), '<module>:data.list:length$direct'(_Args, ___2092, ___2093)), 'emop_call'(_FileXml, 'format'('   <predicate functor=\"~a\" arity=\"~d\">\n', '.'(_F, '.'(___2092, '[]'))), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 797, from character 26 to 32')), ','(';'('->'(','('g_read'('data.atom', '<module>:data.atom'(___2099)), '<module>:data.atom:split_at_delim_left$direct'(_Text, '.', _Proto, _Desc, ___2099)), 'true'), ','('='(_Desc, _Text), ','(','('='(_N, ___2089), ';'('->'('='(_Args, 'none'), '='(___2089, 0)), ','('='(___2089, ___2102), ','('g_read'('data.list', '<module>:data.list'(___2103)), '<module>:data.list:length$direct'(_Args, ___2102, ___2103))))), ','('='(_Proto, ___2109), ','('g_read'('data.atom', '<module>:data.atom'(___2110)), '<module>:data.atom:format$direct'('~a/~n', '.'(_F, '.'(_N, '[]')), ___2109, ___2110)))))), ','('emop_call'(_FileXml, 'format'('       <prototype>~a</prototype>\n', '.'(_Proto, '[]')), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 813, from character 26 to 32'), ','('emop_call'(_FileXml, 'format'('       <description>~a</description>\n', '.'(_Desc, '[]')), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 814, from character 26 to 32'), 'emop_call'(_FileXml, 'print_endline'('   </predicate>'), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 815, from character 26 to 39')))))).
':-'('<module>:emop.expand@19:generate_doc$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@19:generate_doc'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@1:$sgn'(__36sgn, 'env'(___71, _Dependencies, ___8), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',81347,1998,81315)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',81391,1998,81315)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.expand@1:atom_fresh_[3443]'(_atom__fresh___913444_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913444_93, '[]'))))))).
':-'('<module>:emop.expand@1:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@1:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@1:atom_fresh_[3443]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 3, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@1:do'('c'(_F, 0, _), _Constructors, _Constructors, 'env'(___71, _Dependencies, ___8), __36CutLevel), ','(','('g_read'('data.list', '<module>:data.list'(___310)), '<module>:data.list:member$direct'('dep'(_F, _), _Dependencies, ___310)), ','('true', ','('='(__36CutLevel, '$cut'), '!')))).
':-'('<module>:emop.expand@1:do'('c'(_F, _N, _U), _Constructors, '.'('c'(_F, _N, _U), _Constructors), 'env'(___71, _Dependencies, ___8), __36CutLevel), 'true').
':-'('<module>:emop.expand@1:do$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@1:do'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@2'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@2:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@2'('do'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@2:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@2'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.expand@2$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.expand@2$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.expand@2$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.expand@2$has_predicate'('do'(_____2, _____1)), 'true').
':-'('<module>:emop.expand@20'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@20:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@20'('do'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@20:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@20'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.expand@20$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.expand@20$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.expand@20$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.expand@20$has_predicate'('do'(_____2, _____1)), 'true').
':-'('<module>:emop.expand@20:$sgn'(__36sgn, 'env'(___978, _Impl, _Vars, ___553), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',35007,902,34998)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',35036,902,34998)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.expand@20:atom_fresh_[3777]'(_atom__fresh___913778_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913778_93, '[]'))))))).
':-'('<module>:emop.expand@20:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@20:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@20:atom_fresh_[3777]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@20:do'(_Var, 'var'(_PB, _PE, _, _Status), 'env'(___978, _Impl, _Vars, ___553), __36CutLevel), ';'('->'(','('='(_Status, 'singleton'), '='(_PB, 'dummy')), 'true'), ','('emop_call'(_Impl, 'var_lookup'(_Var, _PB, _PE, _Vars, _), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 911, from character 23 to 33'), ','('emop_call'(_Impl, 'var_lookup'(_Var, _, _, _Vars, _), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 913, from character 23 to 33'), ';'('->'('='(_Status, 'singleton'), ','(','('g_read'('data.atom', '<module>:data.atom'(___2021)), '<module>:data.atom:format$direct'('Environment variable never used \'~a\'', '.'(_Var, '[]'), ___2020, ___2021)), ','('g_read'('emop.message', '<module>:emop.message'(___2023)), '<module>:emop.message:warning$direct'(___2020, 'file'(_PB, _PE), ___2023)))), 'true'))))).
':-'('<module>:emop.expand@20:do$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@20:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@21'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@21:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@21'('do', __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@21:do'(__36env, __36CutLevel))).
':-'('<module>:emop.expand@21'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.expand@21$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.expand@21$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.expand@21$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.expand@21$has_predicate'('do'), 'true').
':-'('<module>:emop.expand@21:$sgn'(__36sgn, 'env'(___984, _EnvRec, _Warning, ___553), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',35846,928,35837)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',35879,928,35837)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.expand@21:atom_fresh_[3765]'(_atom__fresh___913766_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913766_93, '[]'))))))).
':-'('<module>:emop.expand@21:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@21:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@21:atom_fresh_[3765]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 0, predicate, suspended([],[call(var('EnvRec'),iter,[var('Warning')])]), __36pos))).
':-'('<module>:emop.expand@21:do'('env'(___984, _EnvRec, _Warning, ___553), __36CutLevel), 'emop_call'(_EnvRec, 'iter'(_Warning), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 931, from character 22 to 26')).
':-'('<module>:emop.expand@21:do$direct'(__36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@21:do'(__36env, __36CutLevel))).
':-'('<module>:emop.expand@22'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@22:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@22'('singleton_warning', __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@22:singleton_warning'(__36env, __36CutLevel))).
':-'('<module>:emop.expand@22'('ast_match'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@22:ast_match'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@22'('transform_goal'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@22:transform_goal'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@22'('transform_term'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@22:transform_term'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@22'('transform_term_list'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@22:transform_term_list'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@22'('expand_notation'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@22:expand_notation'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@22'('init_sequence'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@22:init_sequence'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@22'('build_sequence'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@22:build_sequence'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@22'('split_list'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@22:split_list'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@22'('template_sequence'(_____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@22:template_sequence'(_____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@22'('template_sequence_'(_____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@22:template_sequence_'(_____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@22'('rebuild_'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@22:rebuild_'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@22'('rebuild'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@22:rebuild'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@22'('eval_number'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@22:eval_number'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@22'('check_guard'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@22:check_guard'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@22'('expand_notation_step'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@22:expand_notation_step'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@22'('expand_goal'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@22:expand_goal'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@22'('expand_goal_callable'(_____7, _____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@22:expand_goal_callable'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@22'('make_cut'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@22:make_cut'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@22'('change_current_mod'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@22:change_current_mod'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@22'('open_scope'(_____7, _____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@22:open_scope'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@22'('expand_call'(_____7, _____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@22:expand_call'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@22'('sub_module_env'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@22:sub_module_env'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@22'('expand_term_list'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@22:expand_term_list'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@22'('expand_term_call'(_____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@22:expand_term_call'(_____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@22'('expand_subterm'(_____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@22:expand_subterm'(_____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@22'('expand_term'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@22:expand_term'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@22'('expand_term_callable'(_____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@22:expand_term_callable'(_____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@22'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.expand@22$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.expand@22$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.expand@22$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.expand@22$has_predicate'('singleton_warning'), 'true').
':-'('<module>:emop.expand@22$has_predicate'('ast_match'(_____2, _____1)), 'true').
':-'('<module>:emop.expand@22$has_predicate'('transform_goal'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand@22$has_predicate'('transform_term'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand@22$has_predicate'('transform_term_list'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand@22$has_predicate'('expand_notation'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand@22$has_predicate'('init_sequence'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand@22$has_predicate'('build_sequence'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand@22$has_predicate'('split_list'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand@22$has_predicate'('template_sequence'(_____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand@22$has_predicate'('template_sequence_'(_____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand@22$has_predicate'('rebuild_'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand@22$has_predicate'('rebuild'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand@22$has_predicate'('eval_number'(_____2, _____1)), 'true').
':-'('<module>:emop.expand@22$has_predicate'('check_guard'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand@22$has_predicate'('expand_notation_step'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand@22$has_predicate'('expand_goal'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand@22$has_predicate'('expand_goal_callable'(_____7, _____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand@22$has_predicate'('make_cut'(_____2, _____1)), 'true').
':-'('<module>:emop.expand@22$has_predicate'('change_current_mod'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand@22$has_predicate'('open_scope'(_____7, _____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand@22$has_predicate'('expand_call'(_____7, _____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand@22$has_predicate'('sub_module_env'(_____2, _____1)), 'true').
':-'('<module>:emop.expand@22$has_predicate'('expand_term_list'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand@22$has_predicate'('expand_term_call'(_____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand@22$has_predicate'('expand_subterm'(_____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand@22$has_predicate'('expand_term'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand@22$has_predicate'('expand_term_callable'(_____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand@22:$sgn'(__36sgn, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',36065,934,36056)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',36193,934,36056)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','('true', '<module>:emop.expand@22:atom_fresh_[3583]'(_atom__fresh___913584_93, __36Pb, __36Pe)), '<module>:emop.expand@22:atom_fresh_[3585]'(_atom__fresh___913586_93, __36Pb, __36Pe)), '<module>:emop.expand@22:atom_fresh_[3587]'(_atom__fresh___913588_93, __36Pb, __36Pe)), '<module>:emop.expand@22:atom_fresh_[3589]'(_atom__fresh___913590_93, __36Pb, __36Pe)), '<module>:emop.expand@22:atom_fresh_[3591]'(_atom__fresh___913592_93, __36Pb, __36Pe)), '<module>:emop.expand@22:atom_fresh_[3593]'(_atom__fresh___913594_93, __36Pb, __36Pe)), '<module>:emop.expand@22:atom_fresh_[3595]'(_atom__fresh___913596_93, __36Pb, __36Pe)), '<module>:emop.expand@22:atom_fresh_[3597]'(_atom__fresh___913598_93, __36Pb, __36Pe)), '<module>:emop.expand@22:atom_fresh_[3599]'(_atom__fresh___913600_93, __36Pb, __36Pe)), '<module>:emop.expand@22:atom_fresh_[3601]'(_atom__fresh___913602_93, __36Pb, __36Pe)), '<module>:emop.expand@22:atom_fresh_[3603]'(_atom__fresh___913604_93, __36Pb, __36Pe)), '<module>:emop.expand@22:atom_fresh_[3605]'(_atom__fresh___913606_93, __36Pb, __36Pe)), '<module>:emop.expand@22:atom_fresh_[3607]'(_atom__fresh___913608_93, __36Pb, __36Pe)), '<module>:emop.expand@22:atom_fresh_[3609]'(_atom__fresh___913610_93, __36Pb, __36Pe)), '<module>:emop.expand@22:atom_fresh_[3611]'(_atom__fresh___913612_93, __36Pb, __36Pe)), '<module>:emop.expand@22:atom_fresh_[3613]'(_atom__fresh___913614_93, __36Pb, __36Pe)), '<module>:emop.expand@22:atom_fresh_[3615]'(_atom__fresh___913616_93, __36Pb, __36Pe)), '<module>:emop.expand@22:atom_fresh_[3617]'(_atom__fresh___913618_93, __36Pb, __36Pe)), '<module>:emop.expand@22:atom_fresh_[3619]'(_atom__fresh___913620_93, __36Pb, __36Pe)), '<module>:emop.expand@22:atom_fresh_[3621]'(_atom__fresh___913622_93, __36Pb, __36Pe)), '<module>:emop.expand@22:atom_fresh_[3623]'(_atom__fresh___913624_93, __36Pb, __36Pe)), '<module>:emop.expand@22:atom_fresh_[3625]'(_atom__fresh___913626_93, __36Pb, __36Pe)), '<module>:emop.expand@22:atom_fresh_[3627]'(_atom__fresh___913628_93, __36Pb, __36Pe)), '<module>:emop.expand@22:atom_fresh_[3629]'(_atom__fresh___913630_93, __36Pb, __36Pe)), '<module>:emop.expand@22:atom_fresh_[3631]'(_atom__fresh___913632_93, __36Pb, __36Pe)), '<module>:emop.expand@22:atom_fresh_[3633]'(_atom__fresh___913634_93, __36Pb, __36Pe)), '<module>:emop.expand@22:atom_fresh_[3635]'(_atom__fresh___913636_93, __36Pb, __36Pe)), '<module>:emop.expand@22:atom_fresh_[3637]'(_atom__fresh___913638_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913638_93, '.'(_atom__fresh___913636_93, '.'(_atom__fresh___913634_93, '.'(_atom__fresh___913632_93, '.'(_atom__fresh___913630_93, '.'(_atom__fresh___913628_93, '.'(_atom__fresh___913626_93, '.'(_atom__fresh___913624_93, '.'(_atom__fresh___913622_93, '.'(_atom__fresh___913620_93, '.'(_atom__fresh___913618_93, '.'(_atom__fresh___913616_93, '.'(_atom__fresh___913614_93, '.'(_atom__fresh___913612_93, '.'(_atom__fresh___913610_93, '.'(_atom__fresh___913608_93, '.'(_atom__fresh___913606_93, '.'(_atom__fresh___913604_93, '.'(_atom__fresh___913602_93, '.'(_atom__fresh___913600_93, '.'(_atom__fresh___913598_93, '.'(_atom__fresh___913596_93, '.'(_atom__fresh___913594_93, '.'(_atom__fresh___913592_93, '.'(_atom__fresh___913590_93, '.'(_atom__fresh___913588_93, '.'(_atom__fresh___913586_93, '.'(_atom__fresh___913584_93, '[]')))))))))))))))))))))))))))))))))).
':-'('<module>:emop.expand@22:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@22:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@22:ast_match'(_A, '()'(_B, _, _), 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), 'emop_call'(___989, 'ast_match'(_A, _B), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 959, from character 15 to 24'))).
':-'('<module>:emop.expand@22:ast_match'('()'(_A, _, _), _B, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), 'emop_call'(___989, 'ast_match'(_A, _B), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 961, from character 15 to 24')).
':-'('<module>:emop.expand@22:ast_match'('var'(_X), _Y, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','('='(_Y, 'callable'(_F, _Escaped, _Args, _, _)), ','(','('g_read'('emop.parser', '<module>:emop.parser'(___1001)), '<module>:emop.parser:is_variable$direct'(_F, _Escaped, _Args, ___1001)), '='(_X, 'variable'(_Y)))))).
':-'('<module>:emop.expand@22:ast_match'('number'(_X), _Y, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','('='(_Y, 'number'(_, _, _)), '='(_X, 'variable'(_Y))))).
':-'('<module>:emop.expand@22:ast_match'('variable'(_X), _Y, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), '='(_X, 'variable'(_Y)))).
':-'('<module>:emop.expand@22:ast_match'('callable'(_F, ___Escaped, _Args0, _, _), 'callable'(_F0, _Escaped0, _Args1, _, _), 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','('\\+'(','('g_read'('emop.parser', '<module>:emop.parser'(___1011)), '<module>:emop.parser:is_variable$direct'(_F0, _Escaped0, _Args1, ___1011))), ','(';'('->'('='(_F, 'variable'(_X, _Escaped1, _Arity)), ','('='(_X, _F0), ','('='(_Escaped1, _Escaped0), ','('='(_Arity, ___1014), ','('g_read'('data.list', '<module>:data.list'(___1015)), '<module>:data.list:length$direct'(_Args0, ___1014, ___1015)))))), ','('='(_F, _F0), '\\='(_Escaped0, 'escaped'))), ';'('->'('='(_Args0, 'none'), '='(_Args1, 'none')), ';'('->'('='(_Args1, 'none'), ';'('->'('='(_Args0, 'none'), 'true'), '='(_Args0, '.'('seq'('seq'('[]')), '[]')))), '->'(','(','('true', ';'('->'('var'(___1026), ','('g_inc'('$module_count', ___1027), '='(___1026, '$module'(___1027, '.'('<module>:emop.expand@24'('env'(___1026, ___989, ___553)), '[]'), '.'(___1026, '[]'))))), ','('='(___1026, '$module'(___1027, ___1028, _)), ','('='('.'(___1029, ___1030), ___1028), ','('setarg'(1, ___1028, '<module>:emop.expand@24'('env'(___1026, ___989, ___553))), 'setarg'(2, ___1028, '.'(___1029, ___1030))))))), 'emop_call'(___1026, 'match_args'(_Args0, _Args1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1014, from character 17 to 27')), 'true'))))))).
':-'('<module>:emop.expand@22:ast_match'('module'(_Name0, _Env0, _Body0, _, _), 'module'(_Name1, _Env1, _Body1, _Sgn1, _Clauses1, _, _), 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ','('='(_Name0, 'variable'(_Name1)), ','(','(','('true', ';'('->'('var'(___1035), ','('g_inc'('$module_count', ___1036), '='(___1035, '$module'(___1036, '.'('<module>:emop.expand@25'('env'(___1035, ___989, ___553)), '[]'), '.'(___1035, '[]'))))), ','('='(___1035, '$module'(___1036, ___1037, _)), ','('='('.'(___1038, ___1039), ___1037), ','('setarg'(1, ___1037, '<module>:emop.expand@25'('env'(___1035, ___989, ___553))), 'setarg'(2, ___1037, '.'(___1038, ___1039))))))), 'emop_call'(___1035, 'match_args'(_Env0, _Env1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1029, from character 14 to 24')), '='(_Body0, 'module'(_Body1, _Sgn1, _Clauses1))))).
':-'('<module>:emop.expand@22:ast_match'('number'(_X, _, _), 'number'(_X, _, _), 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), 'true').
':-'('<module>:emop.expand@22:ast_match$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@22:ast_match'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@22:atom_fresh_[3583]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(expand_term_callable, 8, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@22:atom_fresh_[3585]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(expand_term, 4, predicate, suspended([none,var('Ctx'),var('Goal'),var('Term')],[call(scope,expand_term_callable,[var('F'),var('Escaped'),var('Args'),var('Pb'),var('Pe'),var('Ctx'),var('Goal'),var('Term')])]), __36pos))).
':-'('<module>:emop.expand@22:atom_fresh_[3587]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(expand_subterm, 8, predicate, suspended([var('F'),var('Escaped'),var('Args0'),var('Pb'),var('Pe'),var('Ctx'),var('Goal'),var('Term')],[call(scope,expand_term_list,[var('Args0'),none,var('G0'),var('Args1')]),call(scope,expand_term_call,[var('F'),var('Escaped'),var('Args1'),var('Pb'),var('Pe'),var('Ctx'),var('G1'),var('Term')]),call(var('Impl'),seq,[var('G0'),var('G1'),var('Goal')])]), __36pos))).
':-'('<module>:emop.expand@22:atom_fresh_[3589]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(expand_term_call, 8, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@22:atom_fresh_[3591]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(expand_term_list, 4, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@22:atom_fresh_[3593]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(sub_module_env, 2, predicate, suspended([none,none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.expand@22:atom_fresh_[3595]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(expand_call, 7, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@22:atom_fresh_[3597]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(open_scope, 7, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@22:atom_fresh_[3599]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(change_current_mod, 3, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@22:atom_fresh_[3601]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(make_cut, 2, predicate, suspended([var('AT'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.expand@22:atom_fresh_[3603]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(expand_goal_callable, 7, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@22:atom_fresh_[3605]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(expand_goal, 3, predicate, suspended([none,var('Ctx'),var('Goal')],[call(scope,expand_goal_callable,[var('F'),var('Escaped'),var('Args'),var('Pb'),var('Pe'),var('Ctx'),var('Goal')])]), __36pos))).
':-'('<module>:emop.expand@22:atom_fresh_[3607]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(expand_notation_step, 4, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@22:atom_fresh_[3609]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(check_guard, 3, predicate, suspended([none,var('Position'),var('Scope')],[call(scope,check_guard,[var('A'),var('Position'),var('Scope')]),call(scope,check_guard,[var('B'),var('Position'),var('Scope')])]), __36pos))).
':-'('<module>:emop.expand@22:atom_fresh_[3611]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(eval_number, 2, predicate, suspended([none,var('X')],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.expand@22:atom_fresh_[3613]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(rebuild, 3, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@22:atom_fresh_[3615]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(rebuild_, 3, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@22:atom_fresh_[3617]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(template_sequence_, 6, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@22:atom_fresh_[3619]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(template_sequence, 6, predicate, suspended([var('AccuLists'),var('AccuVars'),var('M'),var('Pb'),var('Pe'),var('S')],[call(scope,template_sequence_,[none,var('AccuVars'),var('M'),var('Pb'),var('Pe'),var('S')])]), __36pos))).
':-'('<module>:emop.expand@22:atom_fresh_[3621]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(split_list, 3, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@22:atom_fresh_[3623]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(build_sequence, 4, predicate, suspended([var('S'),var('Pb'),var('Pe'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.expand@22:atom_fresh_[3625]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(init_sequence, 4, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@22:atom_fresh_[3627]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(expand_notation, 4, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@22:atom_fresh_[3629]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(transform_term_list, 4, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@22:atom_fresh_[3631]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(transform_term, 4, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@22:atom_fresh_[3633]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(transform_goal, 3, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@22:atom_fresh_[3635]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(ast_match, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@22:atom_fresh_[3637]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(singleton_warning, 0, predicate, suspended([],[module('Warning',[symbol(do,2,predicate,[none,none],file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',36315,937,36262),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',36874,952,36851)))]),call(var('Vars'),iter,[var('Warning')])]), __36pos))).
':-'('<module>:emop.expand@22:build_sequence'(_S, _Pb, _Pe, ___1083, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ','('='(_S, ___1082), ';'('->'('='(___1082, '[]'), '='(___1083, 'callable'('true', 'unescaped', 'none', _Pb, _Pe))), ','('='(___1083, ___1100), ','('='(___1082, ___1084), ','('->'(','('='(___1085, _SH), ','('='(___1086, _ST), '='(___1084, '.'(___1085, ___1086)))), 'true'), ','('true', ','(';'('->'('var'(___1094), ','('g_inc'('$module_count', ___1095), '='(___1094, '$module'(___1095, '.'('<module>:emop.expand@27'('env'(___1094, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, _Pb, _Pe, _S, _SH, _ST, ___989, ___553)), '[]'), '.'(___1094, '[]'))))), ','('='(___1094, '$module'(___1095, ___1096, _)), ','('='('.'(___1097, ___1098), ___1096), ','('setarg'(1, ___1096, '<module>:emop.expand@27'('env'(___1094, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, _Pb, _Pe, _S, _SH, _ST, ___989, ___553))), 'setarg'(2, ___1096, '.'(___1097, ___1098)))))), ','('g_read'('data.list', '<module>:data.list'(___1101)), '<module>:data.list:fold_left$direct'(_ST, _SH, ___1094, ___1100, ___1101)))))))))).
':-'('<module>:emop.expand@22:build_sequence$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@22:build_sequence'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@22:change_current_mod'('ctx'(___CurrentMod, _CurrentScope), _NewMod, 'ctx'(_NewMod, _CurrentScope), 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), 'true').
':-'('<module>:emop.expand@22:change_current_mod$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@22:change_current_mod'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@22:check_guard'(','(_A, _B), _Position, _Scope, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ','('emop_call'(___989, 'check_guard'(_A, _Position, _Scope), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1216, from character 18 to 29'), 'emop_call'(___989, 'check_guard'(_B, _Position, _Scope), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1217, from character 18 to 29'))).
':-'('<module>:emop.expand@22:check_guard'(';'(_A, _B), _Position, _Scope, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ';'('emop_call'(___989, 'check_guard'(_A, _Position, _Scope), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1220, from character 21 to 32'), 'emop_call'(___989, 'check_guard'(_B, _Position, _Scope), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1222, from character 21 to 32'))).
':-'('<module>:emop.expand@22:check_guard'('true', _, _, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), 'true').
':-'('<module>:emop.expand@22:check_guard'('type_term'(_Kind, 'variable'(_X)), _, _, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ','('='(_Kind, ___1227), ';'('->'('='(___1227, 'var'), ','('='(_X, 'callable'(_F, _Escaped, _Args, _, _)), ','('g_read'('emop.parser', '<module>:emop.parser'(___1232)), '<module>:emop.parser:is_variable$direct'(_F, _Escaped, _Args, ___1232)))), ','('='(___1227, ___1228), '->'('='(___1228, 'number'), '='(_X, 'number'(_, _, _))))))).
':-'('<module>:emop.expand@22:check_guard'('sgn_check'(_Kind, 'functor'(_Mod, _Symbol, _Escaped, _Arity0)), _Position, _Scope, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ','(','('='(_Arity, ___1237), 'emop_call'(___989, 'eval_number'(_Arity0, ___1237), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1237, from character 26 to 37')), ','(';'('->'('='(_Mod, 'scope'), ';'('->'('='(_Escaped, 'escaped'), '='(_Kind0, 'constructor')), ','(','('true', ';'('->'('var'(___1241), ','('g_inc'('$module_count', ___1242), '='(___1241, '$module'(___1242, '.'('<module>:emop.expand@32'('env'(___1241, _Kind0, _Symbol, _Arity, ___989, ___553)), '[]'), '.'(___1241, '[]'))))), ','('='(___1241, '$module'(___1242, ___1243, _)), ','('='('.'(___1244, ___1245), ___1243), ','('setarg'(1, ___1243, '<module>:emop.expand@32'('env'(___1241, _Kind0, _Symbol, _Arity, ___989, ___553))), 'setarg'(2, ___1243, '.'(___1244, ___1245))))))), 'emop_call'(___1241, 'find'(_Scope), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1267, from character 26 to 30')))), ','(';'('->'('='(_Mod, 'variable'(_Mod0)), 'true'), '='(_Mod0, _Mod)), ','(';'('->'(','('='(_Mod0, 'callable'(_MVar, _MVEscaped, _MVArgs, _, _)), ','('g_read'('emop.parser', '<module>:emop.parser'(___1250)), '<module>:emop.parser:is_variable$direct'(_MVar, _MVEscaped, _MVArgs, ___1250))), ','(','('='(_MVarEnv, ___1251), 'emop_call'(_SgnVars, '{}'(_MVar, ___1251), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1281, from character 42 to 43')), ';'('->'(','('g_read'('data.var', '<module>:data.var'(___1253)), '<module>:data.var:check$direct'(_MVarEnv, ___1253)), 'fail'), ','('='('root'(','(_, _MSgn)), ___1259), ','(','('g_read'('emop.unionfind', '<module>:emop.unionfind'(___1258)), '<module>:emop.unionfind:get_root$direct'(_MVarEnv, ___1257, ___1258)), 'emop_call'(___1257, 'get'(___1259), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1287, from character 80 to 83')))))), '->'('='(_Mod0, 'callable'(_Atom, _, 'none', _, _)), ','('='(_MSgn, ___1262), 'emop_call'(_Dependencies, 'find_mod_sgn'(_Atom, _Position, ___1262), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1292, from character 44 to 56')))), ','('g_read'('data.list', '<module>:data.list'(___1265)), '<module>:data.list:member$direct'('symbol'(_Symbol, _Arity, _Kind0, ___ArgsInfo, _), _MSgn, ___1265))))), ';'('->'('='(_Kind, 'symbol'), 'true'), '='(_Kind, _Kind0))))).
':-'('<module>:emop.expand@22:check_guard$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@22:check_guard'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@22:eval_number'('number'(_X), _X, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), 'true').
':-'('<module>:emop.expand@22:eval_number'('length'('seq'(_X)), ___1196, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ','('g_read'('data.list', '<module>:data.list'(___1197)), '<module>:data.list:length$direct'(_X, ___1196, ___1197))).
':-'('<module>:emop.expand@22:eval_number'('+'(_A, _B), ___1202, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ','(','('emop_call'(___989, 'eval_number'(_A, ___1200), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1206, from character 31 to 42'), 'emop_call'(___989, 'eval_number'(_B, ___1201), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1206, from character 48 to 59')), ','('g_read'('data.number', '<module>:data.number'(___1203)), '<module>:data.number:+$direct'(___1200, ___1201, ___1202, ___1203)))).
':-'('<module>:emop.expand@22:eval_number'('-'(_A, _B), ___1208, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ','(','('emop_call'(___989, 'eval_number'(_A, ___1206), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1208, from character 31 to 42'), 'emop_call'(___989, 'eval_number'(_B, ___1207), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1208, from character 48 to 59')), ','('g_read'('data.number', '<module>:data.number'(___1209)), '<module>:data.number:-$direct'(___1206, ___1207, ___1208, ___1209)))).
':-'('<module>:emop.expand@22:eval_number'('*'(_A, _B), ___1214, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ','(','('emop_call'(___989, 'eval_number'(_A, ___1212), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1210, from character 31 to 42'), 'emop_call'(___989, 'eval_number'(_B, ___1213), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1210, from character 48 to 59')), ','('g_read'('data.number', '<module>:data.number'(___1215)), '<module>:data.number:*$direct'(___1212, ___1213, ___1214, ___1215)))).
':-'('<module>:emop.expand@22:eval_number'('/'(_A, _B), ___1220, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ','(','('emop_call'(___989, 'eval_number'(_A, ___1218), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1212, from character 31 to 42'), 'emop_call'(___989, 'eval_number'(_B, ___1219), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1212, from character 48 to 59')), ','('g_read'('data.number', '<module>:data.number'(___1221)), '<module>:data.number:/$direct'(___1218, ___1219, ___1220, ___1221)))).
':-'('<module>:emop.expand@22:eval_number$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@22:eval_number'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@22:expand_call'(_F, _Escaped, _Args, _Pb, _Pe, _Ctx, _Goal, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ','('='(_Ctx, 'ctx'(_CurrentMod, _CurrentScope)), ','(','('g_read'('data.list', '<module>:data.list'(___1623)), '<module>:data.list:length$direct'(_Args, _N, ___1623)), ','(','('true', ';'('->'('var'(___1624), ','('g_inc'('$module_count', ___1625), '='(___1624, '$module'(___1625, '.'('<module>:emop.expand@35'('env'(___1624, _F, _N, _Escaped, _Args, _Pb, _Pe, _Goal, _CurrentScope, _ImplicitConstructorsRef, _SgnVars, _Dependencies, _Fid, ___989, ___553)), '[]'), '.'(___1624, '[]'))))), ','('='(___1624, '$module'(___1625, ___1626, _)), ','('='('.'(___1627, ___1628), ___1626), ','('setarg'(1, ___1626, '<module>:emop.expand@35'('env'(___1624, _F, _N, _Escaped, _Args, _Pb, _Pe, _Goal, _CurrentScope, _ImplicitConstructorsRef, _SgnVars, _Dependencies, _Fid, ___989, ___553))), 'setarg'(2, ___1626, '.'(___1627, ___1628))))))), 'emop_call'(___1624, 'expand_call'(_CurrentMod), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1769, from character 20 to 31'))))).
':-'('<module>:emop.expand@22:expand_call$direct'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@22:expand_call'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@22:expand_goal'('callable'(_F, _Escaped, _Args, _Pb, _Pe), _Ctx, _Goal, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), 'emop_call'(___989, 'expand_goal_callable'(_F, _Escaped, _Args, _Pb, _Pe, _Ctx, _Goal), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1400, from character 18 to 38')).
':-'('<module>:emop.expand@22:expand_goal'('()'(_Term, _, _), _Ctx, _Goal, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), 'emop_call'(___989, 'expand_goal'(_Term, _Ctx, _Goal), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1402, from character 18 to 29')).
':-'('<module>:emop.expand@22:expand_goal'('.()'(_Mod, _Sub, _Pb, _Pe), _Ctx, _Goal, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ','('emop_call'(___989, 'expand_term'(_Mod, _Ctx, _Goal0, _Mod0), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1404, from character 18 to 29'), ','('emop_call'(___989, 'open_scope'(_Mod0, _Sub, _Pb, _Pe, _Ctx, _Sub0, _Ctx0), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1405, from character 18 to 28'), ','('emop_call'(___989, 'transform_goal'(_Sub0, _Ctx0, _Goal1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1406, from character 18 to 32'), ','('='(_Goal, ___1353), 'emop_call'(_Impl, 'seq'(_Goal0, _Goal1, ___1353), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1407, from character 30 to 33')))))).
':-'('<module>:emop.expand@22:expand_goal'('module'(_Name, _Env, _, _Sgn, _Clauses, _Pb, _Pe), _Ctx, _Goal, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ','('='(_Ctx, 'ctx'(_, _CurrentScope)), ','('emop_call'(___989, 'sub_module_env'(_Env, ___1356), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1414, from character 21 to 35'), 'emop_call'(___553, 'expand_module'(_Name, _Pb, _Pe, ___1356, _Sgn, _Clauses, _InheritedEnvVars, _CurrentScope, _SgnVars, _Vars, _Goal), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1410, from character 18 to 31')))).
':-'('<module>:emop.expand@22:expand_goal'('number'(_, _Pb, _Pe), _, _, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), 'throw'('error'('A number is not a valid goal', 'file'(_Pb, _Pe)))).
':-'('<module>:emop.expand@22:expand_goal'('empty'(_Pb, _Pe), _, _, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), 'throw'('error'('Empty goal not allowed', 'file'(_Pb, _Pe)))).
':-'('<module>:emop.expand@22:expand_goal'('doc'(_, _Pb, _Pe, _), _, _, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), 'throw'('error'('Documentation not allowed here', 'file'(_Pb, _Pe)))).
':-'('<module>:emop.expand@22:expand_goal$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@22:expand_goal'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@22:expand_goal_callable'(',', _, '.'(_A0, '.'(_B0, '[]')), _, _, _Ctx, _Goal, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','(','('emop_call'(_Expander, 'expand_goal'(_A0, _Ctx, _A1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1435, from character 21 to 32'), 'emop_call'(_Expander, 'expand_goal'(_B0, _Ctx, _B1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1436, from character 21 to 32')), '='(_Goal, 'callable'(',', '.'(_A1, '.'(_B1, '[]'))))))).
':-'('<module>:emop.expand@22:expand_goal_callable'('>>', _, '.'(_A0, '.'(_B0, '[]')), _, _, _Ctx, _Goal, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','(','('emop_call'(_Expander, 'expand_goal'(_A0, _Ctx, _A1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1442, from character 21 to 32'), 'emop_call'(_Expander, 'expand_goal'(_B0, _Ctx, _B1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1443, from character 21 to 32')), ','('='(_Goal, ___1382), 'emop_call'(_Impl, 'seq_eq'(_A1, _B1, ___1382), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1445, from character 30 to 36'))))).
':-'('<module>:emop.expand@22:expand_goal_callable'('->', _, '.'(_A0, '.'(_B0, '[]')), _, _, _Ctx, _Goal, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','(','('emop_call'(_Expander, 'expand_goal'(_A0, _Ctx, _A1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1449, from character 21 to 32'), 'emop_call'(_Expander, 'expand_goal'(_B0, _Ctx, _B1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1450, from character 21 to 32')), '='(_Goal, 'callable'('->', '.'(_A1, '.'(_B1, '[]'))))))).
':-'('<module>:emop.expand@22:expand_goal_callable'(';', _, '.'(_A0, '.'(_B0, '[]')), _, _, _Ctx, _Goal, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','(','('emop_call'(_Expander, 'expand_goal'(_A0, _Ctx, _A1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1456, from character 21 to 32'), 'emop_call'(_Expander, 'expand_goal'(_B0, _Ctx, _B1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1457, from character 21 to 32')), '='(_Goal, 'callable'(';', '.'(_A1, '.'(_B1, '[]'))))))).
':-'('<module>:emop.expand@22:expand_goal_callable'(':', _, '.'(_A0, '.'(_B0, '[]')), _Pb, _Pe, _Ctx, _Goal, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','(','('emop_call'(___989, 'change_current_mod'(_Ctx, 'none', ___1406), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1472, from character 34 to 52'), 'emop_call'(___989, 'expand_term'(_A0, ___1406, _AG, _A1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1472, from character 18 to 29')), ','(','('emop_call'(___989, 'change_current_mod'(_Ctx, 'some'(_Used, _A1), ___1408), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1473, from character 34 to 52'), 'emop_call'(___989, 'expand_goal'(_B0, ___1408, _B1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1473, from character 18 to 29')), ','('emop_call'(_Impl, 'check_prefix_used'(_Used, _Pb, _Pe), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1474, from character 23 to 40'), 'emop_call'(_Impl, 'seq'(_AG, _B1, _Goal), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1475, from character 23 to 26')))))).
':-'('<module>:emop.expand@22:expand_goal_callable'('\\+', _, '.'(_A0, '[]'), _, _, _Ctx, _Goal, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','('emop_call'(___989, 'expand_goal'(_A0, _Ctx, _A1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1478, from character 18 to 29'), '='(_Goal, 'callable'('\\+', '.'(_A1, '[]')))))).
':-'('<module>:emop.expand@22:expand_goal_callable'('catch', 'unescaped', '.'(_A0, '.'(_B0, '.'(_C0, '[]'))), _, _, _Ctx, _Goal, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','(','('emop_call'(_Expander, 'expand_goal'(_A0, _Ctx, _A1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1483, from character 21 to 32'), ','(','('emop_call'(___989, 'change_current_mod'(_Ctx, 'none', ___1423), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1484, from character 37 to 55'), 'emop_call'(_Expander, 'expand_term'(_B0, ___1423, _BG, _B1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1484, from character 21 to 32')), 'emop_call'(_Expander, 'expand_goal'(_C0, _Ctx, _C1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1485, from character 21 to 32'))), 'emop_call'(_Impl, 'seq'(_BG, 'callable'('catch', '.'(_A1, '.'(_B1, '.'(_C1, '[]')))), _Goal), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1487, from character 23 to 26')))).
':-'('<module>:emop.expand@22:expand_goal_callable'('call_det', 'unescaped', '.'(_A0, '.'(_B0, '[]')), _, _, _Ctx, _Goal, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','(','('emop_call'(_Expander, 'expand_goal'(_A0, _Ctx, _A1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1491, from character 21 to 32'), ','('emop_call'(___989, 'change_current_mod'(_Ctx, 'none', ___1436), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1492, from character 37 to 55'), 'emop_call'(_Expander, 'expand_term'(_B0, ___1436, _BG, _B1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1492, from character 21 to 32'))), 'emop_call'(_Impl, 'seq'('callable'('call_det', '.'(_A1, '.'(_B1, '[]'))), _BG, _Goal), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1494, from character 23 to 26')))).
':-'('<module>:emop.expand@22:expand_goal_callable'('!', 'unescaped', ___1444, _, _, _, _Goal, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ','(','('g_read'('emop.expand', '<module>:emop.expand'(___1445)), '<module>:emop.expand:empty$direct'(___1444, ___1445)), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','('='(_Goal, ___1448), 'emop_call'(___989, 'make_cut'('var'('$CutLevel'), ___1448), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1497, from character 25 to 33'))))).
':-'('<module>:emop.expand@22:expand_goal_callable'('!', 'unescaped', '.'(_A, '[]'), _, _, _Ctx, _Goal, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','('emop_call'(___989, 'expand_term'(_A, _Ctx, _AG, _AT), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1500, from character 18 to 29'), ','('='(_Goal, ___1454), ','('emop_call'(___989, 'make_cut'(_AT, ___1453), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1501, from character 38 to 46'), 'emop_call'(_Impl, 'seq'(_AG, ___1453, ___1454), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1501, from character 30 to 33')))))).
':-'('<module>:emop.expand@22:expand_goal_callable'('true', 'unescaped', ___1457, _, _, _, _Goal, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ','(','('g_read'('emop.expand', '<module>:emop.expand'(___1458)), '<module>:emop.expand:empty$direct'(___1457, ___1458)), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), '='(_Goal, 'callable'('true', '[]'))))).
':-'('<module>:emop.expand@22:expand_goal_callable'('fail', 'unescaped', ___1464, _, _, _, _Goal, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ','(','('g_read'('emop.expand', '<module>:emop.expand'(___1465)), '<module>:emop.expand:empty$direct'(___1464, ___1465)), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), '='(_Goal, 'callable'('fail', '[]'))))).
':-'('<module>:emop.expand@22:expand_goal_callable'('repeat', 'unescaped', ___1471, _, _, _, _Goal, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ','(','('g_read'('emop.expand', '<module>:emop.expand'(___1472)), '<module>:emop.expand:empty$direct'(___1471, ___1472)), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), '='(_Goal, 'callable'('repeat', '[]'))))).
':-'('<module>:emop.expand@22:expand_goal_callable'('for', 'unescaped', '.'(_I0, '.'(_A0, '.'(_B0, '[]'))), _, _, _Ctx, _Goal, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','(','(','('emop_call'(___989, 'change_current_mod'(_Ctx, 'none', ___1483), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1514, from character 37 to 55'), 'emop_call'(_Expander, 'expand_term'(_I0, ___1483, _IG, _I1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1514, from character 21 to 32')), ','(','('emop_call'(___989, 'change_current_mod'(_Ctx, 'none', ___1485), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1515, from character 37 to 55'), 'emop_call'(_Expander, 'expand_term'(_A0, ___1485, _AG, _A1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1515, from character 21 to 32')), ','('emop_call'(___989, 'change_current_mod'(_Ctx, 'none', ___1487), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1516, from character 37 to 55'), 'emop_call'(_Expander, 'expand_term'(_B0, ___1487, _BG, _B1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1516, from character 21 to 32')))), ','('emop_call'(_Impl, 'seq'(_IG, _AG, _Term0), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1519, from character 21 to 24'), ','('emop_call'(_Impl, 'seq'(_Term0, _BG, _Term1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1520, from character 21 to 24'), 'emop_call'(_Impl, 'seq'(_Term1, 'callable'('for', '.'(_I1, '.'(_A1, '.'(_B1, '[]')))), _Goal), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1521, from character 21 to 24')))))).
':-'('<module>:emop.expand@22:expand_goal_callable'('throw', 'unescaped', '.'(_A0, '[]'), _, _, _Ctx, _Goal, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','(','('emop_call'(___989, 'change_current_mod'(_Ctx, 'none', ___1499), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1525, from character 43 to 61'), 'emop_call'(_Expander, 'expand_term'(_A0, ___1499, _AG, _A1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1525, from character 27 to 38')), 'emop_call'(_Impl, 'seq'(_AG, 'callable'('throw', '.'(_A1, '[]')), _Goal), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1526, from character 23 to 26')))).
':-'('<module>:emop.expand@22:expand_goal_callable'('=', _, '.'(_A0, '.'(_B0, '[]')), _, _, _Ctx, _Goal, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','(','('emop_call'(___989, 'change_current_mod'(_Ctx, 'none', ___1509), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1529, from character 34 to 52'), 'emop_call'(___989, 'expand_term'(_A0, ___1509, _AG, _A1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1529, from character 18 to 29')), ','(','('emop_call'(___989, 'change_current_mod'(_Ctx, 'none', ___1511), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1530, from character 34 to 52'), 'emop_call'(___989, 'expand_term'(_B0, ___1511, _BG, _B1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1530, from character 18 to 29')), ','(';'('->'(','('='(_A1, 'var'(_V1)), '='(_B1, 'var'(_V2))), ','(','('='(_AS, ___1514), 'emop_call'(_SgnVars, '{}'(_V1, ___1514), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1534, from character 34 to 35')), ','(','('='(_BS, ___1515), 'emop_call'(_SgnVars, '{}'(_V2, ___1515), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1534, from character 53 to 54')), ';'('->'(','('g_read'('data.var', '<module>:data.var'(___1517)), '<module>:data.var:check$direct'(_AS, ___1517)), '='(_BS, _AS)), ';'('->'(','('g_read'('data.var', '<module>:data.var'(___1519)), '<module>:data.var:check$direct'(_BS, ___1519)), '='(_AS, _BS)), ','(','('='(_AR, ___1521), ','('g_read'('emop.unionfind', '<module>:emop.unionfind'(___1522)), '<module>:emop.unionfind:get_root$direct'(_AS, ___1521, ___1522))), ','(','('='(_BR, ___1524), ','('g_read'('emop.unionfind', '<module>:emop.unionfind'(___1525)), '<module>:emop.unionfind:get_root$direct'(_BS, ___1524, ___1525))), ','('emop_call'(_AR, 'get'('root'(','(_AFids, _ASgn))), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1546, from character 27 to 30'), ','('emop_call'(_BR, 'get'('root'(','(_BFids, _BSgn))), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1547, from character 27 to 30'), ','(','(','(','('g_read'('data.list', '<module>:data.list'(___1532)), '<module>:data.list:append$direct'(_AFids, _BFids, ___1531, ___1532)), ','('g_read'('data.list', '<module>:data.list'(___1535)), '<module>:data.list:append$direct'(_ASgn, _BSgn, ___1534, ___1535))), 'emop_call'(_AR, 'set'('root'(','(___1531, ___1534))), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1548, from character 27 to 30')), 'emop_call'(_BR, 'set'('link'(_AR)), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1549, from character 27 to 30'))))))))))), 'true'), ','('emop_call'(_Impl, 'seq'(_AG, _BG, _Term), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1554, from character 23 to 26'), ';'('->'(';'('='(_A1, 'var'('_')), '='(_B1, 'var'('_'))), '='(_Goal, _Term)), 'emop_call'(_Impl, 'seq'('callable'('=', '.'(_A1, '.'(_B1, '[]'))), _Term, _Goal), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1564, from character 26 to 29')))))))).
':-'('<module>:emop.expand@22:expand_goal_callable'('\\=', _, '.'(_A0, '.'(_B0, '[]')), _, _, _Ctx, _Goal, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','(','('emop_call'(___989, 'change_current_mod'(_Ctx, 'none', ___1553), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1568, from character 34 to 52'), 'emop_call'(___989, 'expand_term'(_A0, ___1553, _AG, _A1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1568, from character 18 to 29')), ','(','('emop_call'(___989, 'change_current_mod'(_Ctx, 'none', ___1555), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1569, from character 34 to 52'), 'emop_call'(___989, 'expand_term'(_B0, ___1555, _BG, _B1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1569, from character 18 to 29')), ','('emop_call'(_Impl, 'seq'(_AG, _BG, _SubG), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1571, from character 21 to 24'), 'emop_call'(_Impl, 'seq'(_SubG, 'callable'('\\=', '.'(_A1, '.'(_B1, '[]'))), _Goal), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1572, from character 21 to 24')))))).
':-'('<module>:emop.expand@22:expand_goal_callable'('==', _, '.'(_A0, '.'(_B0, '[]')), _, _, _Ctx, _Goal, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','(','('emop_call'(___989, 'change_current_mod'(_Ctx, 'none', ___1566), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1576, from character 34 to 52'), 'emop_call'(___989, 'expand_term'(_A0, ___1566, _AG, _A1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1576, from character 18 to 29')), ','(','('emop_call'(___989, 'change_current_mod'(_Ctx, 'none', ___1568), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1577, from character 34 to 52'), 'emop_call'(___989, 'expand_term'(_B0, ___1568, _BG, _B1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1577, from character 18 to 29')), ','('emop_call'(_Impl, 'seq'(_AG, _BG, _SubG), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1579, from character 21 to 24'), 'emop_call'(_Impl, 'seq'(_SubG, 'callable'('==', '.'(_A1, '.'(_B1, '[]'))), _Goal), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1580, from character 21 to 24')))))).
':-'('<module>:emop.expand@22:expand_goal_callable'(_F, _Escaped, _Args, _Pb, _Pe, _Ctx, _Goal, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ';'('->'(','('g_read'('emop.parser', '<module>:emop.parser'(___1575)), '<module>:emop.parser:is_variable$direct'(_F, _Escaped, _Args, ___1575)), ','(','('g_read'('data.atom', '<module>:data.atom'(___1581)), '<module>:data.atom:format$direct'('Variable ~a is not a valid goal', '.'(_F, '[]'), ___1580, ___1581)), 'throw'('error'(___1580, 'file'(_Pb, _Pe))))), ','(','('emop_call'(___989, 'change_current_mod'(_Ctx, 'none', ___1585), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1588, from character 44 to 62'), 'emop_call'(___989, 'expand_term_list'(_Args, ___1585, _G0, _Args1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1588, from character 21 to 37')), ','('emop_call'(___989, 'expand_call'(_F, _Escaped, _Args1, _Pb, _Pe, _Ctx, _G1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1589, from character 21 to 32'), 'emop_call'(_Impl, 'seq'(_G0, _G1, _Goal), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1590, from character 26 to 29'))))).
':-'('<module>:emop.expand@22:expand_goal_callable$direct'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@22:expand_goal_callable'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@22:expand_notation'(_Ast0, _Scope, _Level, _Ast1, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ';'('->'('emop_call'(___989, 'expand_notation_step'(_Ast0, _Scope, _Level, _Ast2), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1069, from character 21 to 41'), 'emop_call'(___989, 'expand_notation'(_Ast2, _Scope, _Level, _Ast1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1071, from character 21 to 36')), '='(_Ast0, _Ast1))).
':-'('<module>:emop.expand@22:expand_notation$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@22:expand_notation'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@22:expand_notation_step'(_Ast0, _Scope, _Level, _Ast1, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ','(';'('->'('='(_Ast0, 'callable'(_F, _, _Args, _, _)), ','('='(_Index, ___1278), ','(';'('->'('='(_Args, 'none'), '='(___1267, 0)), ','('='(___1267, ___1273), ','('g_read'('data.list', '<module>:data.list'(___1274)), '<module>:data.list:length$direct'(_Args, ___1273, ___1274)))), ','('g_read'('data.atom', '<module>:data.atom'(___1279)), '<module>:data.atom:format$direct'('~a/~n', '.'(_F, '.'(___1267, '[]')), ___1278, ___1279))))), '='(_Index, 0)), ','(','('g_read'('data.list', '<module>:data.list'(___1282)), '<module>:data.list:member$direct'('scope'(_, _, _Grammar), _Scope, ___1282)), ','('='(_Grammar, 'grammar'(_, _, _, _, _Notations)), ','(','('='(_LevelNotations, ___1284), 'emop_call'(_Notations, '{}'(_Level, ___1284), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1314, from character 45 to 46')), ','('\\+'(','('g_read'('data.var', '<module>:data.var'(___1286)), '<module>:data.var:check$direct'(_LevelNotations, ___1286))), ','('='(_LevelNotations, ','(_Indexed, _Unindexed)), ','(';'(','('\\='(_Index, 0), ','(','('='(_List, ___1288), 'emop_call'(_Indexed, '{}'(_Index, ___1288), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1319, from character 36 to 37')), '\\+'(','('g_read'('data.var', '<module>:data.var'(___1290)), '<module>:data.var:check$direct'(_List, ___1290))))), '='(_List, _Unindexed)), ','(','('emop_call'(_List, 'get'(___1293), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1324, from character 74 to 77'), ','('g_read'('data.list', '<module>:data.list'(___1294)), '<module>:data.list:member_last$direct'('notation'(_Head, _Guard, _Tail), ___1293, ___1294))), ','(','('g_read'('data.term', '<module>:data.term'(___1300)), '<module>:data.term:copy$direct'(','(_Head, ','(_Guard, _Tail)), ','(_Head0, ','(_Guard0, _Tail0)), ___1300)), ','('emop_call'(___989, 'ast_match'(_Head0, _Ast0), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1326, from character 18 to 27'), ','(','('='(_Position, ___1302), ','('g_read'('emop.parse', '<module>:emop.parse'(___1303)), '<module>:emop.parse:position$direct'(_Ast0, ___1302, ___1303))), ','('emop_call'(___989, 'check_guard'(_Guard0, _Position, _Scope), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1328, from character 18 to 29'), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), 'emop_call'(___989, 'rebuild'(_Tail0, _Position, _Ast1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1330, from character 18 to 25'))))))))))))))).
':-'('<module>:emop.expand@22:expand_notation_step'('()'(_Ast0, _Pb, _Pe), _Scope, _Level, '()'(_Ast1, _Pb, _Pe), 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), 'emop_call'(___989, 'expand_notation_step'(_Ast0, _Scope, _Level, _Ast1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1332, from character 18 to 38')).
':-'('<module>:emop.expand@22:expand_notation_step'('.()'(_A0, _B0, _Pb, _Pe), _Scope, _, '.()'(_A1, _B0, _Pb, _Pe), 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ','(','('g_read'('data.list', '<module>:data.list'(___1310)), '<module>:data.list:member$direct'('scope'(_, _, _Grammar), _Scope, ___1310)), ','('='(_Grammar, 'grammar'(_, _, _LevelIds, _, _)), ','(','('='(_TermId, ___1313), 'emop_call'(_LevelIds, '{}'('term', ___1313), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1336, from character 36 to 37')), ','('\\+'(','('g_read'('data.var', '<module>:data.var'(___1315)), '<module>:data.var:check$direct'(_TermId, ___1315))), 'emop_call'(___989, 'expand_notation_step'(_A0, _Scope, _TermId, _A1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1338, from character 18 to 38')))))).
':-'('<module>:emop.expand@22:expand_notation_step'('callable'(_F, _Escaped, _Args0, _Pb, _Pe), _Scope, _Level, 'callable'(_F, _Escaped, _Args1, _Pb, _Pe), 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ','(','('g_read'('data.list', '<module>:data.list'(___1323)), '<module>:data.list:member$direct'('scope'(_, _, _Grammar), _Scope, ___1323)), ','('='(_Grammar, 'grammar'(_, _, _, _Levels, _)), ','(','('g_read'('data.list', '<module>:data.list'(___1327)), '<module>:data.list:member_last$direct'('level'(_LevelList, _LF, _LEscaped, _LArgs), _Levels, ___1327)), ','('->'(','('g_read'('data.list', '<module>:data.list'(___1329)), '<module>:data.list:member$direct'(_Level, _LevelList, ___1329)), 'true'), ','(','('='(_LEscaped, ___1318), ';'('->'('='(___1318, 'operator'), ','('\\='(_Escaped, 'escaped'), '='(_F, _LF))), ','('='(___1318, ___1319), ';'('->'('='(___1319, 'unescaped'), 'true'), ','('='(___1319, ___1320), '->'('='(___1320, 'escaped'), '='(_F, _LF))))))), ','(','(','('true', ';'('->'('var'(___1334), ','('g_inc'('$module_count', ___1335), '='(___1334, '$module'(___1335, '.'('<module>:emop.expand@33'('env'(___1334, ___989, ___553)), '[]'), '.'(___1334, '[]'))))), ','('='(___1334, '$module'(___1335, ___1336, _)), ','('='('.'(___1337, ___1338), ___1336), ','('setarg'(1, ___1336, '<module>:emop.expand@33'('env'(___1334, ___989, ___553))), 'setarg'(2, ___1336, '.'(___1337, ___1338))))))), 'emop_call'(___1334, 'compute_level_args'(_LArgs, _Args0, _LevelArgs), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1385, from character 20 to 38')), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','(','('='(_Args1, ___1347), ','(','('true', ';'('->'('var'(___1341), ','('g_inc'('$module_count', ___1342), '='(___1341, '$module'(___1342, '.'('<module>:emop.expand@34'('env'(___1341, _Changed, _Scope, ___989, ___553)), '[]'), '.'(___1341, '[]'))))), ','('='(___1341, '$module'(___1342, ___1343, _)), ','('='('.'(___1344, ___1345), ___1343), ','('setarg'(1, ___1343, '<module>:emop.expand@34'('env'(___1341, _Changed, _Scope, ___989, ___553))), 'setarg'(2, ___1343, '.'(___1344, ___1345))))))), ','('g_read'('data.list', '<module>:data.list'(___1348)), '<module>:data.list:iter$direct'(_LevelArgs, ___1341, ___1347, ___1348)))), '\\+'('='(_Changed, 'false'))))))))))).
':-'('<module>:emop.expand@22:expand_notation_step$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@22:expand_notation_step'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@22:expand_subterm'(_F, _Escaped, _Args0, _Pb, _Pe, _Ctx, _Goal, _Term, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ','(','('emop_call'(___989, 'change_current_mod'(_Ctx, 'none', ___1672), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1806, from character 42 to 60'), 'emop_call'(___989, 'expand_term_list'(_Args0, ___1672, _G0, _Args1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1806, from character 18 to 34')), ','('emop_call'(___989, 'expand_term_call'(_F, _Escaped, _Args1, _Pb, _Pe, _Ctx, _G1, _Term), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1807, from character 18 to 34'), 'emop_call'(_Impl, 'seq'(_G0, _G1, _Goal), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1808, from character 23 to 26')))).
':-'('<module>:emop.expand@22:expand_subterm$direct'(_____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@22:expand_subterm'(_____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@22:expand_term'('callable'(_F, _Escaped, _Args, _Pb, _Pe), _Ctx, _Goal, _Term, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), 'emop_call'(___989, 'expand_term_callable'(_F, _Escaped, _Args, _Pb, _Pe, _Ctx, _Goal, _Term), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1811, from character 18 to 38')).
':-'('<module>:emop.expand@22:expand_term'('()'(_SubTerm, _, _), _Ctx, _Goal, _Term, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), 'emop_call'(___989, 'expand_term'(_SubTerm, _Ctx, _Goal, _Term), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1813, from character 18 to 29')).
':-'('<module>:emop.expand@22:expand_term'('.()'(_Mod, _Sub, _Pb, _Pe), _Ctx, _Goal, _Term, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ','('emop_call'(___989, 'expand_term'(_Mod, _Ctx, _Goal0, _Mod0), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1815, from character 18 to 29'), ','('emop_call'(___989, 'open_scope'(_Mod0, _Sub, _Pb, _Pe, _Ctx, _Sub0, _Ctx0), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1816, from character 18 to 28'), ','('emop_call'(___989, 'transform_term'(_Sub0, _Ctx0, _Goal1, _Term), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1817, from character 18 to 32'), ','('='(_Goal, ___1676), 'emop_call'(_Impl, 'seq'(_Goal0, _Goal1, ___1676), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1818, from character 30 to 33')))))).
':-'('<module>:emop.expand@22:expand_term'('module'(_Name, _Env, ___Body, _Sgn, _Clauses, _PB, _PE), _Ctx, _Goal, _Term, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ','('='(_Name, 'atom'(_Atom, _Escaped, _, _)), ','(';'('->'(','('g_read'('emop.parser', '<module>:emop.parser'(___1681)), '<module>:emop.parser:is_variable$direct'(_Atom, _Escaped, 'none', ___1681)), ';'('->'('='(_Atom, '_'), ','(','('g_read'('emop.parser', '<module>:emop.parser'(___1684)), '<module>:emop.parser:fresh_var$direct'(_Term, ___1684)), ','('='(_Term, 'var'(_FreshVarName)), '='(_Name0, 'atom'(_FreshVarName, 'variable', _PB, _PE))))), ','('='(_Name0, _Name), '='(_Term, 'var'(_Atom))))), ','('='(_Name0, _Name), '='(_Term, 'callable'(_Atom, '[]')))), ','('='(_Ctx, 'ctx'(_, _CurrentScope)), ','('emop_call'(___989, 'sub_module_env'(_Env, ___1692), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1843, from character 21 to 35'), 'emop_call'(___553, 'expand_module'(_Name0, _PB, _PE, ___1692, _Sgn, _Clauses, _InheritedEnvVars, _CurrentScope, _SgnVars, _Vars, _Goal), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1839, from character 18 to 31')))))).
':-'('<module>:emop.expand@22:expand_term'('number'(_Number, _, _), _, _Goal, _Term, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ','('='(_Goal, 'callable'('true', '[]')), '='(_Term, 'number'(_Number)))).
':-'('<module>:emop.expand@22:expand_term'('empty'(_Pb, _Pe), _, _, _, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), 'throw'('error'('Empty term not allowed', 'file'(_Pb, _Pe)))).
':-'('<module>:emop.expand@22:expand_term'('doc'(_, _Pb, _Pe, _), _, _, _, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), 'throw'('error'('Documentation not allowed here', 'file'(_Pb, _Pe)))).
':-'('<module>:emop.expand@22:expand_term$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@22:expand_term'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@22:expand_term_call'(_F, _Escaped, _Args, _Pb, _Pe, _Ctx, _Goal, _Term, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ';'('->'(','(','('g_read'('emop.parser', '<module>:emop.parser'(___1653)), '<module>:emop.parser:fresh_var$direct'(_Term0, ___1653)), ','(','('g_read'('data.list', '<module>:data.list'(___1657)), '<module>:data.list:append$direct'(_Args, '.'(_Term0, '[]'), _Args0, ___1657)), ','('emop_call'(___989, 'expand_call'(_F, _Escaped, _Args0, _Pb, _Pe, _Ctx, _G1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1789, from character 21 to 32'), ';'('->'('='(_G1, 'callable'('=', '.'(_Term0, '.'('callable'(_F, _Args1), '[]')))), ','('='(_Goal, 'callable'('true', '[]')), '='(_Term, 'callable'(_F, _Args1)))), ','('='(_Goal, _G1), '='(_Term, _Term0)))))), 'true'), 'throw'('error'('expand_term_call failed', 'file'(_Pb, _Pe))))).
':-'('<module>:emop.expand@22:expand_term_call$direct'(_____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@22:expand_term_call'(_____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@22:expand_term_callable'('>>', ___1707, '.'(_A0, '.'(_B0, '[]')), _, _, _Ctx, _Goal, _Term, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ','(';'('='(___1707, 'unescaped'), '='(___1707, 'operator')), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','(','('emop_call'(_Expander, 'expand_goal'(_A0, _Ctx, _A1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1872, from character 21 to 32'), 'emop_call'(_Expander, 'expand_term'(_B0, _Ctx, _B1, _Term), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1873, from character 21 to 32')), ','('='(_Goal, ___1713), 'emop_call'(_Impl, 'seq_eq'(_A1, _B1, ___1713), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1875, from character 30 to 36')))))).
':-'('<module>:emop.expand@22:expand_term_callable'(':', ___1715, '.'(_A0, '.'(_B0, '[]')), _Pb, _Pe, _Ctx, _Goal, _Term, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ','(';'('='(___1715, 'unescaped'), '='(___1715, 'operator')), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','('emop_call'(___989, 'expand_term'(_A0, _Ctx, _AG, _A1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1904, from character 18 to 29'), ','(','('emop_call'(___989, 'change_current_mod'(_Ctx, 'some'(_Used, _A1), ___1722), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1905, from character 34 to 52'), 'emop_call'(___989, 'expand_term'(_B0, ___1722, _BG, _B1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1905, from character 18 to 29')), ','('emop_call'(_Impl, 'check_prefix_used'(_Used, _Pb, _Pe), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1906, from character 23 to 40'), ','('emop_call'(_Impl, 'seq'(_AG, _BG, _Goal), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1907, from character 23 to 26'), '='(_Term, _B1)))))))).
':-'('<module>:emop.expand@22:expand_term_callable'(':', ___1724, '.'(_A0, '[]'), ___Pb, ___Pe, _Ctx, _Goal, _Term, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ','(';'('='(___1724, 'unescaped'), '='(___1724, 'operator')), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','('emop_call'(___989, 'change_current_mod'(_Ctx, 'none', ___1730), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1911, from character 43 to 61'), 'emop_call'(_Expander, 'expand_term'(_A0, ___1730, _Goal, _Term), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1911, from character 27 to 38'))))).
':-'('<module>:emop.expand@22:expand_term_callable'('this', 'unescaped', 'none', _Pb, _Pe, ___Ctx, _Goal, _Term, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','('='(_Goal, 'callable'('true', '[]')), ';'('->'('='(_ThisOption, 'none'), 'throw'('error'('\'this\' cannot be used outside a module', 'file'(_Pb, _Pe)))), '='(_ThisOption, 'some'(_Term)))))).
':-'('<module>:emop.expand@22:expand_term_callable'(_F, _Escaped, _Args, _Pb, _Pe, _Ctx, _Goal, _Term, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ';'('->'(','('g_read'('emop.parser', '<module>:emop.parser'(___1743)), '<module>:emop.parser:is_variable$direct'(_F, _Escaped, _Args, ___1743)), ','('='(_Goal, 'callable'('true', '[]')), ','('emop_call'(_Impl, 'var_lookup'(_F, _Pb, _Pe, _Vars, _), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1932, from character 26 to 36'), '='(_Term, 'var'(_F))))), 'emop_call'(___989, 'expand_subterm'(_F, _Escaped, _Args, _Pb, _Pe, _Ctx, _Goal, _Term), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1935, from character 21 to 35'))).
':-'('<module>:emop.expand@22:expand_term_callable$direct'(_____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@22:expand_term_callable'(_____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@22:expand_term_list'('none', _, 'callable'('true', '[]'), '[]', 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), 'true').
':-'('<module>:emop.expand@22:expand_term_list'('[]', _, 'callable'('true', '[]'), '[]', 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), 'true').
':-'('<module>:emop.expand@22:expand_term_list'('.'(_H0, _T0), _Ctx, _G, '.'(_H1, _T1), 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ','(','('emop_call'(_Expander, 'expand_term'(_H0, _Ctx, _G0, _H1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1780, from character 21 to 32'), 'emop_call'(_Expander, 'expand_term_list'(_T0, _Ctx, _G1, _T1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1781, from character 21 to 37')), 'emop_call'(_Impl, 'seq'(_G0, _G1, _G), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1783, from character 23 to 26'))).
':-'('<module>:emop.expand@22:expand_term_list$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@22:expand_term_list'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@22:init_sequence'('seq'(_M), _S, _Pb, _Pe, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ','(','('g_read'('data.list', '<module>:data.list'(___1071)), '<module>:data.list:length$direct'(_M, _N, ___1071)), ','(','('g_read'('data.list', '<module>:data.list'(___1073)), '<module>:data.list:length$direct'(_S, _N, ___1073)), ','(','('true', ';'('->'('var'(___1075), ','('g_inc'('$module_count', ___1076), '='(___1075, '$module'(___1076, '.'('<module>:emop.expand@26'('env'(___1075, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, _M, _N, _Pb, _Pe, _S, ___989, ___553)), '[]'), '.'(___1075, '[]'))))), ','('='(___1075, '$module'(___1076, ___1077, _)), ','('='('.'(___1078, ___1079), ___1077), ','('setarg'(1, ___1077, '<module>:emop.expand@26'('env'(___1075, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, _M, _N, _Pb, _Pe, _S, ___989, ___553))), 'setarg'(2, ___1077, '.'(___1078, ___1079))))))), ','('g_read'('data.list', '<module>:data.list'(___1081)), '<module>:data.list:iter$direct'(_S, ___1075, ___1081)))))).
':-'('<module>:emop.expand@22:init_sequence$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@22:init_sequence'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@22:make_cut'(_AT, 'callable'(',', '.'('callable'('true', '[]'), '.'('callable'(',', '.'('callable'('=', '.'(_AT, '.'('callable'('$cut', '[]'), '[]'))), '.'('callable'('!', '[]'), '[]'))), '[]'))), 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), 'true').
':-'('<module>:emop.expand@22:make_cut$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@22:make_cut'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@22:open_scope'(_Mod, _Sub, _Pb, _Pe, _Ctx, _Sub0, _Ctx0, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ','('='(_Ctx, 'ctx'(_CurrentMod, _CurrentScope)), ','(','('='(_Scope, ___1614), 'emop_call'(___553, 'get_scope'(_Mod, 'file'(_Pb, _Pe), _SgnVars, _CurrentScope, ___1614), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1622, from character 26 to 35')), ','('='(_CurrentScope0, '.'(_Scope, _CurrentScope)), ','(','('='(_Sub0, ___1618), ','('emop_call'(_Impl, 'grammars'(_CurrentScope0, ___1617), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1624, from character 64 to 72'), ','('g_read'('emop.parser', '<module>:emop.parser'(___1619)), '<module>:emop.parser:internal_reparse$direct'(_Sub, ___1617, ___1618, ___1619)))), '='(_Ctx0, 'ctx'(_CurrentMod, _CurrentScope0))))))).
':-'('<module>:emop.expand@22:open_scope$direct'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@22:open_scope'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@22:rebuild'(_A, _Pos, _B, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ';'('->'('emop_call'(___989, 'rebuild_'(_A, _Pos, _B), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1194, from character 21 to 29'), 'true'), 'throw'('rebuild failed'(_A)))).
':-'('<module>:emop.expand@22:rebuild$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@22:rebuild'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@22:rebuild_'('variable'(_X), _, _X, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), 'true').
':-'('<module>:emop.expand@22:rebuild_'('fresh'(_X), 'file'(_Pb, _Pe), _X, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ';'('->'(','('g_read'('data.var', '<module>:data.var'(___1130)), '<module>:data.var:check$direct'(_X, ___1130)), ','(','('g_read'('emop.parser', '<module>:emop.parser'(___1133)), '<module>:emop.parser:fresh_var$direct'('var'(_Name), ___1133)), '='(_X, 'callable'(_Name, 'variable', 'none', _Pb, _Pe)))), 'true')).
':-'('<module>:emop.expand@22:rebuild_'('seq'(_S, _M), 'file'(_Pb, _Pe), _X, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ','('emop_call'(___989, 'init_sequence'(_M, _S, _Pb, _Pe), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1135, from character 18 to 31'), ','('='(_X, ___1139), 'emop_call'(___989, 'build_sequence'(_S, _Pb, _Pe, ___1139), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1136, from character 22 to 36')))).
':-'('<module>:emop.expand@22:rebuild_'('seq'(_AccuLists, _AccuVars, _M), 'file'(_Pb, _Pe), _X, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ','('emop_call'(___989, 'template_sequence'(_AccuLists, _AccuVars, _M, _Pb, _Pe, _S), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1138, from character 18 to 35'), ','('='(_X, ___1142), 'emop_call'(___989, 'build_sequence'(_S, _Pb, _Pe, ___1142), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1139, from character 22 to 36')))).
':-'('<module>:emop.expand@22:rebuild_'('callable'(_F, _Escaped, _Args0, _, _), 'file'(_Pb, _Pe), 'callable'(_F, _Escaped, _Args1, _Pb, _Pe), 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ';'('->'('='(_Args0, 'none'), '='(_Args1, 'none')), ','('='(_Args1, ___1155), ','(','('true', ';'('->'('var'(___1149), ','('g_inc'('$module_count', ___1150), '='(___1149, '$module'(___1150, '.'('<module>:emop.expand@29'('env'(___1149, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, _Args0, _Args1, _Escaped, _F, _Pb, _Pe, ___989, ___553)), '[]'), '.'(___1149, '[]'))))), ','('='(___1149, '$module'(___1150, ___1151, _)), ','('='('.'(___1152, ___1153), ___1151), ','('setarg'(1, ___1151, '<module>:emop.expand@29'('env'(___1149, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, _Args0, _Args1, _Escaped, _F, _Pb, _Pe, ___989, ___553))), 'setarg'(2, ___1151, '.'(___1152, ___1153))))))), ','('g_read'('data.list', '<module>:data.list'(___1156)), '<module>:data.list:morph$direct'(_Args0, ___1149, ___1155, ___1156)))))).
':-'('<module>:emop.expand@22:rebuild_'('module'(_Name0, _Env0, _Body0, _, _), 'file'(_Pb, _Pe), 'module'(_Name1, _Env1, _Body1, _Sgn1, _Clauses1, _Pb, _Pe), 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ','('='(_Name1, _Name0), ','(';'('->'(';'('->'('='(_Env0, 'none'), '='(_Env1, 'none')), ','('='(_Env1, ___1169), ','(','('true', ';'('->'('var'(___1163), ','('g_inc'('$module_count', ___1164), '='(___1163, '$module'(___1164, '.'('<module>:emop.expand@30'('env'(___1163, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, _Body0, _Body1, _Clauses1, _Clauses2, _Env0, _Env1, _Name0, _Name1, _Pb, _Pe, _Sgn1, ___989, ___553)), '[]'), '.'(___1163, '[]'))))), ','('='(___1163, '$module'(___1164, ___1165, _)), ','('='('.'(___1166, ___1167), ___1165), ','('setarg'(1, ___1165, '<module>:emop.expand@30'('env'(___1163, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, _Body0, _Body1, _Clauses1, _Clauses2, _Env0, _Env1, _Name0, _Name1, _Pb, _Pe, _Sgn1, ___989, ___553))), 'setarg'(2, ___1165, '.'(___1166, ___1167))))))), ','('g_read'('data.list', '<module>:data.list'(___1170)), '<module>:data.list:morph$direct'(_Env0, ___1163, ___1169, ___1170))))), 'true'), 'throw'('rebuild env fail')), ';'('->'('='(_Body0, 'module'(_Body1, _Sgn1, _Clauses1)), 'true'), ';'('->'('='(_Body0, 'custom'(_Sgn1, _Clauses2)), ','('='(_Clauses1, ___1181), ','(','('true', ';'('->'('var'(___1175), ','('g_inc'('$module_count', ___1176), '='(___1175, '$module'(___1176, '.'('<module>:emop.expand@31'('env'(___1175, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, _Body0, _Body1, _Clauses1, _Clauses2, _Env0, _Env1, _Name0, _Name1, _Pb, _Pe, _Sgn1, ___989, ___553)), '[]'), '.'(___1175, '[]'))))), ','('='(___1175, '$module'(___1176, ___1177, _)), ','('='('.'(___1178, ___1179), ___1177), ','('setarg'(1, ___1177, '<module>:emop.expand@31'('env'(___1175, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, _Body0, _Body1, _Clauses1, _Clauses2, _Env0, _Env1, _Name0, _Name1, _Pb, _Pe, _Sgn1, ___989, ___553))), 'setarg'(2, ___1177, '.'(___1178, ___1179))))))), ','('g_read'('data.list', '<module>:data.list'(___1182)), '<module>:data.list:iter$direct'(_Clauses2, ___1175, ___1181, ___1182))))), 'throw'('rebuild body fail')))))).
':-'('<module>:emop.expand@22:rebuild_'('()'(_T0, _, _), 'file'(_Pb, _Pe), '()'(_T1, _Pb, _Pe), 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), 'emop_call'(___989, 'rebuild'(_T0, 'file'(_Pb, _Pe), _T1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1189, from character 18 to 25')).
':-'('<module>:emop.expand@22:rebuild_'('number'(_X, _, _), 'file'(_Pb, _Pe), 'number'(_X, _Pb, _Pe), 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), 'true').
':-'('<module>:emop.expand@22:rebuild_$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@22:rebuild_'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@22:singleton_warning'('env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ','(','('true', ';'('->'('var'(_Warning), ','('g_inc'('$module_count', ___991), '='(_Warning, '$module'(___991, '.'('<module>:emop.expand@23'('env'(_Warning, ___989, ___553)), '[]'), '.'(_Warning, '[]'))))), ','('='(_Warning, '$module'(___991, ___992, _)), ','('='('.'(___993, ___994), ___992), ','('setarg'(1, ___992, '<module>:emop.expand@23'('env'(_Warning, ___989, ___553))), 'setarg'(2, ___992, '.'(___993, ___994))))))), 'emop_call'(_Vars, 'iter'(_Warning), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 955, from character 20 to 24'))).
':-'('<module>:emop.expand@22:singleton_warning$direct'(__36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@22:singleton_warning'(__36env, __36CutLevel))).
':-'('<module>:emop.expand@22:split_list'('[]', '[]', '[]', 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), 'true').
':-'('<module>:emop.expand@22:split_list'('.'('.'(_H, _T), _Ls), '.'(_H, _Hs), '.'(_T, _Ts), 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), 'emop_call'(___989, 'split_list'(_Ls, _Hs, _Ts), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1101, from character 18 to 28')).
':-'('<module>:emop.expand@22:split_list$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@22:split_list'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@22:sub_module_env'('none', ___1638, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','(','('true', ';'('->'('var'(___1632), ','('g_inc'('$module_count', ___1633), '='(___1632, '$module'(___1633, '.'('<module>:emop.expand@36'('env'(___1632, ___989, ___553)), '[]'), '.'(___1632, '[]'))))), ','('='(___1632, '$module'(___1633, ___1634, _)), ','('='('.'(___1635, ___1636), ___1634), ','('setarg'(1, ___1634, '<module>:emop.expand@36'('env'(___1632, ___989, ___553))), 'setarg'(2, ___1634, '.'(___1635, ___1636))))))), ','('g_read'('data.list', '<module>:data.list'(___1639)), '<module>:data.list:iter$direct'(_FreeVars, ___1632, ___1638, ___1639))))).
':-'('<module>:emop.expand@22:sub_module_env'(_Env, _Env, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), 'true').
':-'('<module>:emop.expand@22:sub_module_env$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@22:sub_module_env'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@22:template_sequence'(_AccuLists, _AccuVars, _M, _Pb, _Pe, _S, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ','(','(','('true', ';'('->'('var'(___1110), ','('g_inc'('$module_count', ___1111), '='(___1110, '$module'(___1111, '.'('<module>:emop.expand@28'('env'(___1110, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, _AccuLists, _AccuVars, _M, _Pb, _Pe, _S, ___989, ___553)), '[]'), '.'(___1110, '[]'))))), ','('='(___1110, '$module'(___1111, ___1112, _)), ','('='('.'(___1113, ___1114), ___1112), ','('setarg'(1, ___1112, '<module>:emop.expand@28'('env'(___1110, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, _AccuLists, _AccuVars, _M, _Pb, _Pe, _S, ___989, ___553))), 'setarg'(2, ___1112, '.'(___1113, ___1114))))))), ','('g_read'('data.list', '<module>:data.list'(___1117)), '<module>:data.list:iter$direct'(_AccuLists, ___1110, ___1116, ___1117))), 'emop_call'(___989, 'template_sequence_'(___1116, _AccuVars, _M, _Pb, _Pe, _S), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1104, from character 18 to 36'))).
':-'('<module>:emop.expand@22:template_sequence$direct'(_____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@22:template_sequence'(_____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@22:template_sequence_'(_AccuLists, _AccuVars, _M, _Pb, _Pe, _S, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ';'('->'('emop_call'(___989, 'split_list'(_AccuLists, _AccuHeads, _AccuTails), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1115, from character 21 to 31'), ','(','('g_read'('data.term', '<module>:data.term'(___1121)), '<module>:data.term:copy$direct'(','(_AccuVars, _M), ','(_AccuHeads, _H), ___1121)), ','(','('='(_S, '.'(___1123, _T)), 'emop_call'(___989, 'rebuild'(_H, 'file'(_Pb, _Pe), ___1123), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1118, from character 26 to 33')), 'emop_call'(___989, 'template_sequence'(_AccuTails, _AccuVars, _M, _Pb, _Pe, _T), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1119, from character 21 to 38')))), '='(_S, '[]'))).
':-'('<module>:emop.expand@22:template_sequence_$direct'(_____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@22:template_sequence_'(_____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@22:transform_goal'(_Goal0, _Ctx, _Goal1, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ','('='(_Ctx, 'ctx'(_, _Scope)), ','(';'('->'(','(','('g_read'('data.list', '<module>:data.list'(___1047)), '<module>:data.list:member$direct'('scope'(_, _, _Grammar), _Scope, ___1047)), ','('='(_Grammar, 'grammar'(_, _, _LevelIds, _, _)), ','(','('='(_GoalId, ___1050), 'emop_call'(_LevelIds, '{}'('goal', ___1050), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1038, from character 39 to 40')), '\\+'(','('g_read'('data.var', '<module>:data.var'(___1052)), '<module>:data.var:check$direct'(_GoalId, ___1052)))))), 'emop_call'(___989, 'expand_notation'(_Goal0, _Scope, _GoalId, _Goal2), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1041, from character 21 to 36')), '='(_Goal2, _Goal0)), 'emop_call'(___989, 'expand_goal'(_Goal2, _Ctx, _Goal1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1045, from character 18 to 29')))).
':-'('<module>:emop.expand@22:transform_goal$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@22:transform_goal'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@22:transform_term'(_Term0, _Ctx, _Goal1, _Term1, 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ','('='(_Ctx, 'ctx'(_, _Scope)), ','(';'('->'(','(','('g_read'('data.list', '<module>:data.list'(___1056)), '<module>:data.list:member$direct'('scope'(_, _, _Grammar), _Scope, ___1056)), ','('='(_Grammar, 'grammar'(_, _, _LevelIds, _, _)), ','(','('='(_TermId, ___1059), 'emop_call'(_LevelIds, '{}'('term', ___1059), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1052, from character 39 to 40')), '\\+'(','('g_read'('data.var', '<module>:data.var'(___1061)), '<module>:data.var:check$direct'(_TermId, ___1061)))))), 'emop_call'(___989, 'expand_notation'(_Term0, _Scope, _TermId, _Term2), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1055, from character 21 to 36')), '='(_Term2, _Term0)), 'emop_call'(___989, 'expand_term'(_Term2, _Ctx, _Goal1, _Term1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1059, from character 18 to 29')))).
':-'('<module>:emop.expand@22:transform_term$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@22:transform_term'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@22:transform_term_list'('[]', _, 'callable'('true', '[]'), '[]', 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), 'true').
':-'('<module>:emop.expand@22:transform_term_list'('.'(_H0, _T0), _Ctx, _Goal1, '.'(_H1, _T1), 'env'(___989, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, ___553), __36CutLevel), ','('emop_call'(___989, 'transform_term'(_H0, _Ctx, _G0, _H1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1063, from character 18 to 32'), ','('emop_call'(___989, 'transform_term_list'(_T0, _Ctx, _G1, _T1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1064, from character 18 to 37'), 'emop_call'(_Impl, 'seq'(_G0, _G1, _Goal1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1065, from character 23 to 26')))).
':-'('<module>:emop.expand@22:transform_term_list$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@22:transform_term_list'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@23'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@23:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@23'('do'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@23:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@23'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.expand@23$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.expand@23$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.expand@23$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.expand@23$has_predicate'('do'(_____2, _____1)), 'true').
':-'('<module>:emop.expand@23:$sgn'(__36sgn, 'env'(___995, ___989, ___553), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',36242,936,36227)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',36261,936,36227)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.expand@23:atom_fresh_[3745]'(_atom__fresh___913746_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913746_93, '[]'))))))).
':-'('<module>:emop.expand@23:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@23:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@23:atom_fresh_[3745]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@23:do'(_Var, 'var'(_PB, _PE, _Kind, _Status), 'env'(___995, ___989, ___553), __36CutLevel), ';'('->'(','('='(_Kind, 'local'), ','('='(_Status, 'singleton'), '\\+'(','('g_read'('data.atom', '<module>:data.atom'(___2001)), '<module>:data.atom:sub$direct'(_Var, 0, 1, _, '_', ___2001))))), ','(','('g_read'('data.atom', '<module>:data.atom'(___2008)), '<module>:data.atom:format$direct'('Singleton variable \'~a\'', '.'(_Var, '[]'), ___2007, ___2008)), ','('g_read'('emop.message', '<module>:emop.message'(___2010)), '<module>:emop.message:warning$direct'(___2007, 'file'(_PB, _PE), ___2010)))), 'true')).
':-'('<module>:emop.expand@23:do$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@23:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@24'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@24:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@24'('match_args'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@24:match_args'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@24'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.expand@24$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.expand@24$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.expand@24$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.expand@24$has_predicate'('match_args'(_____2, _____1)), 'true').
':-'('<module>:emop.expand@24:$sgn'(__36sgn, 'env'(___1031, ___989, ___553), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',38437,1004,38419)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',38448,1004,38419)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.expand@24:atom_fresh_[3729]'(_atom__fresh___913730_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913730_93, '[]'))))))).
':-'('<module>:emop.expand@24:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@24:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@24:atom_fresh_[3729]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(match_args, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@24:match_args'('[]', '[]', 'env'(___1031, ___989, ___553), __36CutLevel), 'true').
':-'('<module>:emop.expand@24:match_args'('.'('seq'(_X), _Tail0), _List, 'env'(___1031, ___989, ___553), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','('='(_X, 'seq'(_Sublist0)), ','(','('g_read'('data.list', '<module>:data.list'(___1993)), '<module>:data.list:append$direct'(_Sublist0, _Tail1, _List, ___1993)), 'emop_call'(___1031, 'match_args'(_Tail0, _Tail1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1010, from character 21 to 31'))))).
':-'('<module>:emop.expand@24:match_args'('.'(_U, _T0), '.'(_V, _T1), 'env'(___1031, ___989, ___553), __36CutLevel), ','('emop_call'(___989, 'ast_match'(_U, _V), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1012, from character 21 to 30'), 'emop_call'(___1031, 'match_args'(_T0, _T1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1013, from character 21 to 31'))).
':-'('<module>:emop.expand@24:match_args$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@24:match_args'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@25'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@25:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@25'('match_args'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@25:match_args'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@25'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.expand@25$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.expand@25$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.expand@25$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.expand@25$has_predicate'('match_args'(_____2, _____1)), 'true').
':-'('<module>:emop.expand@25:$sgn'(__36sgn, 'env'(___1040, ___989, ___553), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',39087,1019,39075)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',39098,1019,39075)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.expand@25:atom_fresh_[3713]'(_atom__fresh___913714_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913714_93, '[]'))))))).
':-'('<module>:emop.expand@25:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@25:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@25:atom_fresh_[3713]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(match_args, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@25:match_args'('[]', '[]', 'env'(___1040, ___989, ___553), __36CutLevel), 'true').
':-'('<module>:emop.expand@25:match_args'('.'('seq'(_X), _Tail0), _List, 'env'(___1040, ___989, ___553), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','('='(_X, 'seq'(_Sublist0)), ','(','('g_read'('data.list', '<module>:data.list'(___1983)), '<module>:data.list:append$direct'(_Sublist0, _Tail1, _List, ___1983)), 'emop_call'(___1040, 'match_args'(_Tail0, _Tail1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1026, from character 18 to 28'))))).
':-'('<module>:emop.expand@25:match_args'('.'('variable'(_U), _T0), '.'(_U, _T1), 'env'(___1040, ___989, ___553), __36CutLevel), 'emop_call'(___1040, 'match_args'(_T0, _T1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1028, from character 18 to 28')).
':-'('<module>:emop.expand@25:match_args$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@25:match_args'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@26'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@26:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@26'('do'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@26:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@26'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.expand@26$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.expand@26$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.expand@26$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.expand@26$has_predicate'('do'(_____1)), 'true').
':-'('<module>:emop.expand@26:$sgn'(__36sgn, 'env'(___1080, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, _M, _N, _Pb, _Pe, _S, ___989, ___553), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',41502,1078,41474)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',41511,1078,41474)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.expand@26:atom_fresh_[3701]'(_atom__fresh___913702_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913702_93, '[]'))))))).
':-'('<module>:emop.expand@26:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@26:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@26:atom_fresh_[3701]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 1, predicate, suspended([none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.expand@26:do'('callable'(_X, 'variable', 'none', _Pb, _Pe), 'env'(___1080, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, _M, _N, _Pb, _Pe, _S, ___989, ___553), __36CutLevel), ','(','('='(___1971, ___1968), ','('g_read'('emop.parser', '<module>:emop.parser'(___1972)), '<module>:emop.parser:fresh_var$direct'(___1971, ___1972))), '->'(','('='(___1969, _X), '='(___1968, 'var'(___1969))), 'true'))).
':-'('<module>:emop.expand@26:do$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@26:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@27'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@27:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@27'('do'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@27:do'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@27'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.expand@27$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.expand@27$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.expand@27$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.expand@27$has_predicate'('do'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand@27:$sgn'(__36sgn, 'env'(___1099, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, _Pb, _Pe, _S, _SH, _ST, ___989, ___553), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',41991,1093,41960)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',42010,1093,41960)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.expand@27:atom_fresh_[3689]'(_atom__fresh___913690_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913690_93, '[]'))))))).
':-'('<module>:emop.expand@27:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@27:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@27:atom_fresh_[3689]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 3, predicate, suspended([var('H'),var('Seq'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.expand@27:do'(_H, _Seq, 'callable'(',', 'operator', '.'(_Seq, '.'(_H, '[]')), _Pb, _Pe), 'env'(___1099, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, _Pb, _Pe, _S, _SH, _ST, ___989, ___553), __36CutLevel), 'true').
':-'('<module>:emop.expand@27:do$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@27:do'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@28'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@28:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@28'('do'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@28:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@28'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.expand@28$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.expand@28$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.expand@28$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.expand@28$has_predicate'('do'(_____2, _____1)), 'true').
':-'('<module>:emop.expand@28:$sgn'(__36sgn, 'env'(___1115, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, _AccuLists, _AccuVars, _M, _Pb, _Pe, _S, ___989, ___553), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',42430,1104,42399)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',42447,1104,42399)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.expand@28:atom_fresh_[3675]'(_atom__fresh___913676_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913676_93, '[]'))))))).
':-'('<module>:emop.expand@28:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@28:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@28:atom_fresh_[3675]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 2, predicate, suspended([none,none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.expand@28:do'('seq'(_X), _X, 'env'(___1115, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, _AccuLists, _AccuVars, _M, _Pb, _Pe, _S, ___989, ___553), __36CutLevel), ','('true', ','('='(__36CutLevel, '$cut'), '!'))).
':-'('<module>:emop.expand@28:do'(_X, _X, 'env'(___1115, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, _AccuLists, _AccuVars, _M, _Pb, _Pe, _S, ___989, ___553), __36CutLevel), 'true').
':-'('<module>:emop.expand@28:do$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@28:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@29'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@29:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@29'('do'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@29:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@29'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.expand@29$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.expand@29$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.expand@29$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.expand@29$has_predicate'('do'(_____2, _____1)), 'true').
':-'('<module>:emop.expand@29:$sgn'(__36sgn, 'env'(___1154, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, _Args0, _Args1, _Escaped, _F, _Pb, _Pe, ___989, ___553), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',44103,1145,44064)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',44117,1145,44064)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.expand@29:atom_fresh_[3665]'(_atom__fresh___913666_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913666_93, '[]'))))))).
':-'('<module>:emop.expand@29:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@29:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@29:atom_fresh_[3665]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 2, predicate, suspended([none,none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.expand@29:do'('seq'(_A), _A, 'env'(___1154, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, _Args0, _Args1, _Escaped, _F, _Pb, _Pe, ___989, ___553), __36CutLevel), ','('true', ','('='(__36CutLevel, '$cut'), '!'))).
':-'('<module>:emop.expand@29:do'('seq'(_S, _M), _S, 'env'(___1154, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, _Args0, _Args1, _Escaped, _F, _Pb, _Pe, ___989, ___553), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), 'emop_call'(___989, 'init_sequence'(_M, _S, _Pb, _Pe), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1148, from character 46 to 59'))).
':-'('<module>:emop.expand@29:do'('seq'(_AccuLists, _AccuVars, _M), ___1956, 'env'(___1154, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, _Args0, _Args1, _Escaped, _F, _Pb, _Pe, ___989, ___553), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), 'emop_call'(___989, 'template_sequence'(_AccuLists, _AccuVars, _M, _Pb, _Pe, ___1956), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1150, from character 27 to 44'))).
':-'('<module>:emop.expand@29:do'(_A, '.'(___1958, '[]'), 'env'(___1154, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, _Args0, _Args1, _Escaped, _F, _Pb, _Pe, ___989, ___553), __36CutLevel), 'emop_call'(___989, 'rebuild'(_A, 'file'(_Pb, _Pe), ___1958), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1151, from character 33 to 40')).
':-'('<module>:emop.expand@29:do$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@29:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@2:$sgn'(__36sgn, 'env'(___81, _Constructors, _Pos, _Sgn, ___8), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',81781,2007,81759)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',81801,2007,81759)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.expand@2:atom_fresh_[3441]'(_atom__fresh___913442_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913442_93, '[]'))))))).
':-'('<module>:emop.expand@2:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@2:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@2:atom_fresh_[3441]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 2, predicate, suspended([none,none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.expand@2:do'('c'(_F, _N, _), '/'(_F, _N), 'env'(___81, _Constructors, _Pos, _Sgn, ___8), __36CutLevel), 'true').
':-'('<module>:emop.expand@2:do$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@2:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@3'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@3:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@3'('do'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@3:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@3'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.expand@3$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.expand@3$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.expand@3$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.expand@3$has_predicate'('do'(_____1)), 'true').
':-'('<module>:emop.expand@30'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@30:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@30'('do'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@30:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@30'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.expand@30$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.expand@30$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.expand@30$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.expand@30$has_predicate'('do'(_____2, _____1)), 'true').
':-'('<module>:emop.expand@30:$sgn'(__36sgn, 'env'(___1168, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, _Body0, _Body1, _Clauses1, _Clauses2, _Env0, _Env1, _Name0, _Name1, _Pb, _Pe, _Sgn1, ___989, ___553), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',44857,1161,44816)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',44870,1161,44816)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.expand@30:atom_fresh_[3663]'(_atom__fresh___913664_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913664_93, '[]'))))))).
':-'('<module>:emop.expand@30:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@30:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@30:atom_fresh_[3663]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 2, predicate, suspended([none,none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.expand@30:do'('seq'(_A), _A, 'env'(___1168, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, _Body0, _Body1, _Clauses1, _Clauses2, _Env0, _Env1, _Name0, _Name1, _Pb, _Pe, _Sgn1, ___989, ___553), __36CutLevel), ','('true', ','('='(__36CutLevel, '$cut'), '!'))).
':-'('<module>:emop.expand@30:do'('seq'(_S, _M), _S, 'env'(___1168, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, _Body0, _Body1, _Clauses1, _Clauses2, _Env0, _Env1, _Name0, _Name1, _Pb, _Pe, _Sgn1, ___989, ___553), __36CutLevel), 'emop_call'(___989, 'init_sequence'(_M, _S, _Pb, _Pe), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1164, from character 45 to 58')).
':-'('<module>:emop.expand@30:do'(_V, '.'(___1950, '[]'), 'env'(___1168, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, _Body0, _Body1, _Clauses1, _Clauses2, _Env0, _Env1, _Name0, _Name1, _Pb, _Pe, _Sgn1, ___989, ___553), __36CutLevel), 'emop_call'(___989, 'rebuild'(_V, 'file'(_Pb, _Pe), ___1950), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1165, from character 36 to 43')).
':-'('<module>:emop.expand@30:do$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@30:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@31'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@31:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@31'('do'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@31:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@31'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.expand@31$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.expand@31$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.expand@31$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.expand@31$has_predicate'('do'(_____2, _____1)), 'true').
':-'('<module>:emop.expand@31:$sgn'(__36sgn, 'env'(___1180, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, _Body0, _Body1, _Clauses1, _Clauses2, _Env0, _Env1, _Name0, _Name1, _Pb, _Pe, _Sgn1, ___989, ___553), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',45512,1179,45470)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',45528,1179,45470)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.expand@31:atom_fresh_[3659]'(_atom__fresh___913660_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913660_93, '[]'))))))).
':-'('<module>:emop.expand@31:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@31:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@31:atom_fresh_[3659]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 2, predicate, suspended([none,none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.expand@31:do'('clause'(_F, _Args, _B, _Doc, _, _), 'clause'(_F, ___1940, ___1943, _Doc, _Pb, _Pe), 'env'(___1180, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, _Body0, _Body1, _Clauses1, _Clauses2, _Env0, _Env1, _Name0, _Name1, _Pb, _Pe, _Sgn1, ___989, ___553), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','(','(','('true', ';'('->'('var'(___1934), ','('g_inc'('$module_count', ___1935), '='(___1934, '$module'(___1935, '.'('<module>:emop.expand@39'('env'(___1934, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, _Body0, _Body1, _Clauses1, _Clauses2, _Env0, _Env1, _Name0, _Name1, _Pb, _Pe, _Sgn1, _Args, _B, _Doc, _F, ___1180, ___989, ___553)), '[]'), '.'(___1934, '[]'))))), ','('='(___1934, '$module'(___1935, ___1936, _)), ','('='('.'(___1937, ___1938), ___1936), ','('setarg'(1, ___1936, '<module>:emop.expand@39'('env'(___1934, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, _Body0, _Body1, _Clauses1, _Clauses2, _Env0, _Env1, _Name0, _Name1, _Pb, _Pe, _Sgn1, _Args, _B, _Doc, _F, ___1180, ___989, ___553))), 'setarg'(2, ___1936, '.'(___1937, ___1938))))))), ','('g_read'('data.list', '<module>:data.list'(___1941)), '<module>:data.list:iter$direct'(_Args, ___1934, ___1940, ___1941))), 'emop_call'(___989, 'rebuild'(_B, 'file'(_Pb, _Pe), ___1943), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1182, from character 105 to 112')))).
':-'('<module>:emop.expand@31:do'(_A, _A, 'env'(___1180, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, _Body0, _Body1, _Clauses1, _Clauses2, _Env0, _Env1, _Name0, _Name1, _Pb, _Pe, _Sgn1, ___989, ___553), __36CutLevel), 'true').
':-'('<module>:emop.expand@31:do$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@31:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@32'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@32:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@32'('find'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@32:find'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@32'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.expand@32$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.expand@32$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.expand@32$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.expand@32$has_predicate'('find'(_____1)), 'true').
':-'('<module>:emop.expand@32:$sgn'(__36sgn, 'env'(___1246, _Kind0, _Symbol, _Arity, ___989, ___553), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',48145,1245,48121)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',48176,1245,48121)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.expand@32:atom_fresh_[3657]'(_atom__fresh___913658_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913658_93, '[]'))))))).
':-'('<module>:emop.expand@32:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@32:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@32:atom_fresh_[3657]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(find, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@32:find'('.'('scope'(___M, _Sgn, ___Grammar), _ScopeStack), 'env'(___1246, _Kind0, _Symbol, _Arity, ___989, ___553), __36CutLevel), ';'('->'(','('g_read'('data.list', '<module>:data.list'(___1926)), '<module>:data.list:member$direct'('symbol'(_Symbol, _Arity, _Kind, ___ArgsInfo, _), _Sgn, ___1926)), ';'('->'(';'('='(_Kind, 'predicate'), '='(_Kind, 'abstract')), '='(_Kind0, 'predicate')), '->'('='(_Kind, 'constructor'), '='(_Kind0, 'constructor')))), 'emop_call'(___1246, 'find'(_ScopeStack), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1265, from character 33 to 37'))).
':-'('<module>:emop.expand@32:find$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@32:find'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@33'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@33:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@33'('compute_level_args'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@33:compute_level_args'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@33'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.expand@33$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.expand@33$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.expand@33$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.expand@33$has_predicate'('compute_level_args'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand@33:$sgn'(__36sgn, 'env'(___1339, ___989, ___553), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',53048,1361,53030)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',53059,1361,53030)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.expand@33:atom_fresh_[3653]'(_atom__fresh___913654_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913654_93, '[]'))))))).
':-'('<module>:emop.expand@33:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@33:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@33:atom_fresh_[3653]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(compute_level_args, 3, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@33:compute_level_args'('[]', '[]', '[]', 'env'(___1339, ___989, ___553), __36CutLevel), 'true').
':-'('<module>:emop.expand@33:compute_level_args'('.'(_H, _T), _Args0, _LevelArgs, 'env'(___1339, ___989, ___553), __36CutLevel), ','('='(_H, ___1900), ';'('->'(','('='(___1901, _Level), '='(___1900, 'seq'(___1901))), ','(','(','('g_read'('data.list', '<module>:data.list'(___1905)), '<module>:data.list:append$direct'(_Prefix, _Tail, _Args0, ___1905)), ','(','('='(_LevelPrefix, ___1913), ','(','('true', ';'('->'('var'(___1907), ','('g_inc'('$module_count', ___1908), '='(___1907, '$module'(___1908, '.'('<module>:emop.expand@38'('env'(___1907, _Level, ___1339, ___989, ___553)), '[]'), '.'(___1907, '[]'))))), ','('='(___1907, '$module'(___1908, ___1909, _)), ','('='('.'(___1910, ___1911), ___1909), ','('setarg'(1, ___1909, '<module>:emop.expand@38'('env'(___1907, _Level, ___1339, ___989, ___553))), 'setarg'(2, ___1909, '.'(___1910, ___1911))))))), ','('g_read'('data.list', '<module>:data.list'(___1914)), '<module>:data.list:iter$direct'(_Prefix, ___1907, ___1913, ___1914)))), ','(','('g_read'('data.list', '<module>:data.list'(___1915)), '<module>:data.list:length$direct'(_Prefix, _N, ___1915)), ','(','('g_read'('data.list', '<module>:data.list'(___1916)), '<module>:data.list:length$direct'(_LevelPrefix, _N, ___1916)), ','('g_read'('data.list', '<module>:data.list'(___1917)), '<module>:data.list:append$direct'(_LevelPrefix, _LevelTail, _LevelArgs, ___1917)))))), 'emop_call'(___1339, 'compute_level_args'(_T, _Tail, _LevelTail), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1377, from character 27 to 45'))), ','('='(___1900, ___1902), '->'('='(___1902, _Level), ','('='(_Args0, '.'(_Arg, _Tail)), ','('='(_LevelArgs, '.'(','(_Level, _Arg), _LevelTail)), 'emop_call'(___1339, 'compute_level_args'(_T, _Tail, _LevelTail), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1383, from character 27 to 45')))))))).
':-'('<module>:emop.expand@33:compute_level_args$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@33:compute_level_args'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@34'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@34:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@34'('do'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@34:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@34'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.expand@34$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.expand@34$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.expand@34$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.expand@34$has_predicate'('do'(_____2, _____1)), 'true').
':-'('<module>:emop.expand@34:$sgn'(__36sgn, 'env'(___1346, _Changed, _Scope, ___989, ___553), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',54236,1386,54200)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',54270,1386,54200)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.expand@34:atom_fresh_[3651]'(_atom__fresh___913652_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913652_93, '[]'))))))).
':-'('<module>:emop.expand@34:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@34:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@34:atom_fresh_[3651]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@34:do'(','(_Level, _Arg0), _Arg1, 'env'(___1346, _Changed, _Scope, ___989, ___553), __36CutLevel), ';'('->'('emop_call'(___989, 'expand_notation_step'(_Arg0, _Scope, _Level, _Arg1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1390, from character 27 to 47'), '='(_Changed, 'true')), '='(_Arg1, _Arg0))).
':-'('<module>:emop.expand@34:do$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@34:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@35'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@35:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@35'('constr'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@35:constr'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@35'('expand_call'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@35:expand_call'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@35'('make_call'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@35:make_call'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@35'('check_defined'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@35:check_defined'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@35'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.expand@35$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.expand@35$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.expand@35$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.expand@35$has_predicate'('constr'(_____1)), 'true').
':-'('<module>:emop.expand@35$has_predicate'('expand_call'(_____1)), 'true').
':-'('<module>:emop.expand@35$has_predicate'('make_call'(_____2, _____1)), 'true').
':-'('<module>:emop.expand@35$has_predicate'('check_defined'(_____2, _____1)), 'true').
':-'('<module>:emop.expand@35:$sgn'(__36sgn, 'env'(___1629, _F, _N, _Escaped, _Args, _Pb, _Pe, _Goal, _CurrentScope, _ImplicitConstructorsRef, _SgnVars, _Dependencies, _Fid, ___989, ___553), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',65202,1629,65184)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',65313,1629,65184)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','(','('true', '<module>:emop.expand@35:atom_fresh_[3641]'(_atom__fresh___913642_93, __36Pb, __36Pe)), '<module>:emop.expand@35:atom_fresh_[3643]'(_atom__fresh___913644_93, __36Pb, __36Pe)), '<module>:emop.expand@35:atom_fresh_[3645]'(_atom__fresh___913646_93, __36Pb, __36Pe)), '<module>:emop.expand@35:atom_fresh_[3647]'(_atom__fresh___913648_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913648_93, '.'(_atom__fresh___913646_93, '.'(_atom__fresh___913644_93, '.'(_atom__fresh___913642_93, '[]')))))))))).
':-'('<module>:emop.expand@35:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@35:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@35:atom_fresh_[3641]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(check_defined, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@35:atom_fresh_[3643]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(make_call, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@35:atom_fresh_[3645]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(expand_call, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@35:atom_fresh_[3647]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(constr, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@35:check_defined'(_MSgn, _Kind, 'env'(___1629, _F, _N, _Escaped, _Args, _Pb, _Pe, _Goal, _CurrentScope, _ImplicitConstructorsRef, _SgnVars, _Dependencies, _Fid, ___989, ___553), __36CutLevel), ','(','('='(_N, ___1839), ','('g_read'('data.list', '<module>:data.list'(___1840)), '<module>:data.list:length$direct'(_Args, ___1839, ___1840))), ';'('->'(','('g_read'('data.list', '<module>:data.list'(___1843)), '<module>:data.list:member$direct'('symbol'(_F, _N, _Kind, _ArgsInfo, _), _MSgn, ___1843)), ';'('->'('='(_Kind, 'predicate'), ','('g_read'('emop.expand', '<module>:emop.expand'(___1849)), '<module>:emop.expand:get_args_info$direct'(_ArgsInfo, _MSgn, _SgnVars, '[]', _Dependencies, 'file'(_Pb, _Pe), '.'(_Fid, '[]'), _Args, ___1849))), 'true')), ','(','('g_read'('data.atom', '<module>:data.atom'(___1857)), '<module>:data.atom:format$direct'('Predicate ~a/~d may be undefined.', '.'(_F, '.'(_N, '[]')), ___1856, ___1857)), ','('g_read'('emop.message', '<module>:emop.message'(___1859)), '<module>:emop.message:warning$direct'(___1856, 'file'(_Pb, _Pe), ___1859)))))).
':-'('<module>:emop.expand@35:check_defined$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@35:check_defined'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@35:constr'(_N0, 'env'(___1629, _F, _N, _Escaped, _Args, _Pb, _Pe, _Goal, _CurrentScope, _ImplicitConstructorsRef, _SgnVars, _Dependencies, _Fid, ___989, ___553), __36CutLevel), ','(','(','('g_read'('data.list', '<module>:data.list'(___1756)), '<module>:data.list:append$direct'(_Args0, '.'(_Result, '[]'), _Args, ___1756)), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','('g_read'('data.list', '<module>:data.list'(___1757)), '<module>:data.list:length$direct'(_Args0, _N0, ___1757)))), '='(_Goal, 'callable'('=', '.'(_Result, '.'('callable'(_F, _Args0), '[]')))))).
':-'('<module>:emop.expand@35:constr$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@35:constr'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@35:expand_call'('none', 'env'(___1629, _F, _N, _Escaped, _Args, _Pb, _Pe, _Goal, _CurrentScope, _ImplicitConstructorsRef, _SgnVars, _Dependencies, _Fid, ___989, ___553), __36CutLevel), ','(','('true', ';'('->'('var'(_SolveScope), ','('g_inc'('$module_count', ___1765), '='(_SolveScope, '$module'(___1765, '.'('<module>:emop.expand@37'('env'(_SolveScope, _F, _N, _Args, _Pb, _Pe, _ImplicitConstructorsRef, _Escaped, _SgnVars, _Dependencies, _Fid, ___1629, ___989, ___553)), '[]'), '.'(_SolveScope, '[]'))))), ','('='(_SolveScope, '$module'(___1765, ___1766, _)), ','('='('.'(___1767, ___1768), ___1766), ','('setarg'(1, ___1766, '<module>:emop.expand@37'('env'(_SolveScope, _F, _N, _Args, _Pb, _Pe, _ImplicitConstructorsRef, _Escaped, _SgnVars, _Dependencies, _Fid, ___1629, ___989, ___553))), 'setarg'(2, ___1766, '.'(___1767, ___1768))))))), ';'('->'('='(_Escaped, 'escaped'), 'emop_call'(___1629, 'constr'(_), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1681, from character 27 to 33')), ';'('->'('emop_call'(_SolveScope, 'find'(_CurrentScope), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1683, from character 38 to 42'), 'true'), 'throw'('error'('scope resolution failed')))))).
':-'('<module>:emop.expand@35:expand_call'('some'('used', 'callable'('top', '[]')), 'env'(___1629, _F, _N, _Escaped, _Args, _Pb, _Pe, _Goal, _CurrentScope, _ImplicitConstructorsRef, _SgnVars, _Dependencies, _Fid, ___989, ___553), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), '='(_Goal, 'callable'(_F, _Args)))).
':-'('<module>:emop.expand@35:expand_call'('some'('used', _M), 'env'(___1629, _F, _N, _Escaped, _Args, _Pb, _Pe, _Goal, _CurrentScope, _ImplicitConstructorsRef, _SgnVars, _Dependencies, _Fid, ___989, ___553), __36CutLevel), ';'('->'('='(_M, 'callable'(_Atom, '[]')), ','(','('='(_MSgn, ___1784), 'emop_call'(_Dependencies, 'find_mod_sgn'(_Atom, 'file'(_Pb, _Pe), ___1784), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1696, from character 47 to 59')), ','('emop_call'(___1629, 'check_defined'(_MSgn, _Kind), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1697, from character 27 to 40'), 'emop_call'(___1629, 'make_call'(_M, _Kind), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1698, from character 27 to 36')))), '->'('='(_M, 'var'(_MVar)), ','(','('='(_MVarEnv, ___1786), 'emop_call'(_SgnVars, '{}'(_MVar, ___1786), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1702, from character 45 to 46')), ','(';'('->'(','('g_read'('data.var', '<module>:data.var'(___1788)), '<module>:data.var:check$direct'(_MVarEnv, ___1788)), 'true'), ','(','('='('root'(','(_, _MSgn)), ___1794), ','(','('g_read'('emop.unionfind', '<module>:emop.unionfind'(___1793)), '<module>:emop.unionfind:get_root$direct'(_MVarEnv, ___1792, ___1793)), 'emop_call'(___1792, 'get'(___1794), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1708, from character 83 to 86'))), 'emop_call'(___1629, 'check_defined'(_MSgn, _Kind), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1709, from character 30 to 43'))), 'emop_call'(___1629, 'make_call'(_M, _Kind), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1711, from character 27 to 36')))))).
':-'('<module>:emop.expand@35:expand_call$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@35:expand_call'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@35:make_call'(_M, _Kind, 'env'(___1629, _F, _N, _Escaped, _Args, _Pb, _Pe, _Goal, _CurrentScope, _ImplicitConstructorsRef, _SgnVars, _Dependencies, _Fid, ___989, ___553), __36CutLevel), ';'('->'(';'('='(_Kind, 'predicate'), '='(_Kind, 'abstract')), ';'('->'('='(_M, 'callable'(_Atom, '[]')), ','(','('g_read'('emop.parser', '<module>:emop.parser'(___1800)), '<module>:emop.parser:fresh_var$direct'(_CallEnv, ___1800)), ','(','('='(_ModName, ___1801), 'emop_call'(___553, 'prolog_module_name'(_Atom, ___1801), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1726, from character 40 to 58')), ','('='(_Goal, 'callable'(',', '.'('callable'('g_read', '.'('callable'(_Atom, '[]'), '.'('callable'(_ModName, '.'(_CallEnv, '[]')), '[]'))), '.'('callable'(___1814, ___1818), '[]')))), ','(','('emop_call'(___553, 'predicate_name_direct'(_F, ___1813), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1739, from character 73 to 94'), 'emop_call'(___553, 'prolog_predicate_name'(_ModName, ___1813, ___1814), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1739, from character 42 to 63')), ','('g_read'('data.list', '<module>:data.list'(___1819)), '<module>:data.list:append$direct'(_Args, '.'(_CallEnv, '[]'), ___1818, ___1819))))))), ','(','('g_read'('emop.message', '<module>:emop.message'(___1827)), '<module>:emop.message:position_text$direct'('file'(_Pb, _Pe), _Text, ___1827)), '='(_Goal, 'callable'('emop_call', '.'(_M, '.'('callable'(_F, _Args), '.'('callable'(_Text, '[]'), '[]')))))))), '->'('='(_Kind, 'constructor'), 'emop_call'(___1629, 'constr'(___N0), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1751, from character 27 to 33')))).
':-'('<module>:emop.expand@35:make_call$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@35:make_call'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@36'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@36:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@36'('do'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@36:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@36'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.expand@36$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.expand@36$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.expand@36$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.expand@36$has_predicate'('do'(_____2, _____1)), 'true').
':-'('<module>:emop.expand@36:$sgn'(__36sgn, 'env'(___1637, ___989, ___553), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',71810,1770,71755)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',71829,1770,71755)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.expand@36:atom_fresh_[3639]'(_atom__fresh___913640_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913640_93, '[]'))))))).
':-'('<module>:emop.expand@36:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@36:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@36:atom_fresh_[3639]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 2, predicate, suspended([var('X'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.expand@36:do'(_X, 'callable'(_X, 'variable', 'none', 'dummy', 'dummy'), 'env'(___1637, ___989, ___553), __36CutLevel), 'true').
':-'('<module>:emop.expand@36:do$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@36:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@37'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@37:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@37'('find'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@37:find'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@37'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.expand@37$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.expand@37$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.expand@37$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.expand@37$has_predicate'('find'(_____1)), 'true').
':-'('<module>:emop.expand@37:$sgn'(__36sgn, 'env'(___1769, _F, _N, _Args, _Pb, _Pe, _ImplicitConstructorsRef, _Escaped, _SgnVars, _Dependencies, _Fid, ___1629, ___989, ___553), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',65661,1638,65637)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',65763,1638,65637)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.expand@37:atom_fresh_[3649]'(_atom__fresh___913650_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913650_93, '[]'))))))).
':-'('<module>:emop.expand@37:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@37:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@37:atom_fresh_[3649]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(find, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@37:find'('[]', 'env'(___1769, _F, _N, _Args, _Pb, _Pe, _ImplicitConstructorsRef, _Escaped, _SgnVars, _Dependencies, _Fid, ___1629, ___989, ___553), __36CutLevel), ';'('->'(','('='(_Args, ___1861), ','('g_read'('emop.expand', '<module>:emop.expand'(___1862)), '<module>:emop.expand:empty$direct'(___1861, ___1862))), ','(','('g_read'('data.atom', '<module>:data.atom'(___1868)), '<module>:data.atom:format$direct'('Unknown predicate ~a/0', '.'(_F, '[]'), ___1867, ___1868)), 'throw'('error'(___1867, 'file'(_Pb, _Pe))))), ','('emop_call'(___1629, 'constr'(_N0), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1646, from character 33 to 39'), ';'('->'('='(_Escaped, 'escaped'), 'true'), ','(','('='(_ImplicitConstructors, ___1872), 'emop_call'(_ImplicitConstructorsRef, 'get'(___1872), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1652, from character 83 to 86')), ';'('->'(','('g_read'('data.list', '<module>:data.list'(___1875)), '<module>:data.list:member$direct'('c'(_F, _N0, _Usages), _ImplicitConstructors, ___1875)), ','('g_read'('data.list', '<module>:data.list'(___1878)), '<module>:data.list:add_to_left$direct'('file'(_Pb, _Pe), _Usages, ___1878))), 'emop_call'(_ImplicitConstructorsRef, 'set'('.'('c'(_F, _N0, '.'('file'(_Pb, _Pe), '[]')), _ImplicitConstructors)), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1658, from character 63 to 66'))))))).
':-'('<module>:emop.expand@37:find'('.'('scope'(_M, _Sgn, ___Grammar), _ScopeStack), 'env'(___1769, _F, _N, _Args, _Pb, _Pe, _ImplicitConstructorsRef, _Escaped, _SgnVars, _Dependencies, _Fid, ___1629, ___989, ___553), __36CutLevel), ';'('->'(','('g_read'('data.list', '<module>:data.list'(___1888)), '<module>:data.list:member$direct'('symbol'(_F, _N, _Kind, _ArgsInfo, _), _Sgn, ___1888)), ','('emop_call'(___1629, 'make_call'(_M, _Kind), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1672, from character 33 to 42'), ','('g_read'('emop.expand', '<module>:emop.expand'(___1893)), '<module>:emop.expand:get_args_info$direct'(_ArgsInfo, _Sgn, _SgnVars, '[]', _Dependencies, 'file'(_Pb, _Pe), '.'(_Fid, '[]'), _Args, ___1893)))), 'emop_call'(___1769, 'find'(_ScopeStack), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1675, from character 33 to 37'))).
':-'('<module>:emop.expand@37:find$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@37:find'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@38'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@38:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@38'('do'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@38:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@38'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.expand@38$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.expand@38$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.expand@38$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.expand@38$has_predicate'('do'(_____2, _____1)), 'true').
':-'('<module>:emop.expand@38:$sgn'(__36sgn, 'env'(___1912, _Level, ___1339, ___989, ___553), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',53436,1369,53382)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',53458,1369,53382)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.expand@38:atom_fresh_[3655]'(_atom__fresh___913656_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913656_93, '[]'))))))).
':-'('<module>:emop.expand@38:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@38:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@38:atom_fresh_[3655]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 2, predicate, suspended([var('Arg'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.expand@38:do'(_Arg, ','(_Level, _Arg), 'env'(___1912, _Level, ___1339, ___989, ___553), __36CutLevel), 'true').
':-'('<module>:emop.expand@38:do$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@38:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@39'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@39:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@39'('do'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@39:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@39'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.expand@39$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.expand@39$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.expand@39$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.expand@39$has_predicate'('do'(_____2, _____1)), 'true').
':-'('<module>:emop.expand@39:$sgn'(__36sgn, 'env'(___1939, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, _Body0, _Body1, _Clauses1, _Clauses2, _Env0, _Env1, _Name0, _Name1, _Pb, _Pe, _Sgn1, _Args, _B, _Doc, _F, ___1180, ___989, ___553), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',45641,1181,45589)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',45653,1181,45589)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.expand@39:atom_fresh_[3661]'(_atom__fresh___913662_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913662_93, '[]'))))))).
':-'('<module>:emop.expand@39:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@39:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@39:atom_fresh_[3661]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 2, predicate, suspended([var('Arg'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.expand@39:do'(_Arg, ___1946, 'env'(___1939, _Vars, _SgnVars, _ThisOption, _InheritedEnvVars, _FreeVars, _Expander, _Impl, _ImplicitConstructorsRef, _Dependencies, _Body0, _Body1, _Clauses1, _Clauses2, _Env0, _Env1, _Name0, _Name1, _Pb, _Pe, _Sgn1, _Args, _B, _Doc, _F, ___1180, ___989, ___553), __36CutLevel), 'emop_call'(___989, 'rebuild'(_Arg, 'file'(_Pb, _Pe), ___1946), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 1182, from character 75 to 82')).
':-'('<module>:emop.expand@39:do$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@39:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@3:$sgn'(__36sgn, 'env'(___98, _Constructors, _Pos, _Sgn, ___8), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',81974,2014,81958)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',81994,2014,81958)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.expand@3:atom_fresh_[3437]'(_atom__fresh___913438_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913438_93, '[]'))))))).
':-'('<module>:emop.expand@3:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@3:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@3:atom_fresh_[3437]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@3:do'('c'(_F, _N, _Usages), 'env'(___98, _Constructors, _Pos, _Sgn, ___8), __36CutLevel), ','(','('='('.'(_First, _Others), ___272), ','('g_read'('data.list', '<module>:data.list'(___273)), '<module>:data.list:reverse$direct'(_Usages, ___272, ___273))), ','(','(','('g_read'('emop.message', '<module>:emop.message'(___280)), '<module>:emop.message:line_text$direct'(_First, 'lowercase', ___279, ___280)), ','('g_read'('io.err', '<module>:io.err'(___284)), '<module>:io.err:format$direct'('~q appears at ~a', '.'('/'(_F, _N), '.'(___279, '[]')), ___284))), ','(','(','('true', ';'('->'('var'(___286), ','('g_inc'('$module_count', ___287), '='(___286, '$module'(___287, '.'('<module>:emop.expand@5'('env'(___286, _Constructors, _Pos, _Sgn, _F, _First, _N, _Others, _Usages, ___98, ___8)), '[]'), '.'(___286, '[]'))))), ','('='(___286, '$module'(___287, ___288, _)), ','('='('.'(___289, ___290), ___288), ','('setarg'(1, ___288, '<module>:emop.expand@5'('env'(___286, _Constructors, _Pos, _Sgn, _F, _First, _N, _Others, _Usages, ___98, ___8))), 'setarg'(2, ___288, '.'(___289, ___290))))))), ','('g_read'('data.list', '<module>:data.list'(___292)), '<module>:data.list:iter$direct'(_Others, ___286, ___292))), ','('g_read'('io.err', '<module>:io.err'(___295)), '<module>:io.err:print_endline$direct'('.', ___295)))))).
':-'('<module>:emop.expand@3:do$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@3:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@4'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@4:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@4'('do'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@4:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@4'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.expand@4$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.expand@4$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.expand@4$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.expand@4$has_predicate'('do'(_____2, _____1)), 'true').
':-'('<module>:emop.expand@40'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@40:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@40'('do'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@40:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@40'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.expand@40$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.expand@40$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.expand@40$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.expand@40$has_predicate'('do'(_____1)), 'true').
':-'('<module>:emop.expand@40:$sgn'(__36sgn, 'env'(___2063, _AddClause, _EnvRec, _This, _EnvVars, _CurrentScopeRef, _ImplicitConstructorsRef, _Impl, _EnvList0, _FileXml, _SgnVars, _EnvListRef, _ModuleGoalRef, _Dependencies, _Desc, ___Pb, ___Pe, ___867, ___553), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',28089,741,28061)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',28101,741,28061)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.expand@40:atom_fresh_[3956]'(_atom__fresh___913957_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913957_93, '[]'))))))).
':-'('<module>:emop.expand@40:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@40:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@40:atom_fresh_[3956]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@40:do'('callable'(',', 'unescaped', 'none', _, _), 'env'(___2063, _AddClause, _EnvRec, _This, _EnvVars, _CurrentScopeRef, _ImplicitConstructorsRef, _Impl, _EnvList0, _FileXml, _SgnVars, _EnvListRef, _ModuleGoalRef, _Dependencies, _Desc, ___Pb, ___Pe, ___867, ___553), __36CutLevel), ','('true', ','('='(__36CutLevel, '$cut'), '!'))).
':-'('<module>:emop.expand@40:do'(_File, 'env'(___2063, _AddClause, _EnvRec, _This, _EnvVars, _CurrentScopeRef, _ImplicitConstructorsRef, _Impl, _EnvList0, _FileXml, _SgnVars, _EnvListRef, _ModuleGoalRef, _Dependencies, _Desc, ___Pb, ___Pe, ___867, ___553), __36CutLevel), ';'('->'('='(_File, 'callable'(_FileName, _, 'none', _, _)), 'emop_call'(_Dependencies, 'add_link'(_FileName), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 749, from character 40 to 48')), ','(','('g_read'('emop.parse', '<module>:emop.parse'(___2231)), '<module>:emop.parse:position$direct'(_File, ___2230, ___2231)), 'throw'('error'('Not a valid filename', ___2230))))).
':-'('<module>:emop.expand@40:do$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@40:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@41'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@41:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@41'('do'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@41:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@41'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.expand@41$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.expand@41$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.expand@41$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.expand@41$has_predicate'('do'(_____2, _____1)), 'true').
':-'('<module>:emop.expand@41:$sgn'(__36sgn, 'env'(___2072, _AddClause, _EnvRec, _This, _EnvVars, _CurrentScopeRef, _ImplicitConstructorsRef, _Impl, _EnvList0, _FileXml, _SgnVars, _EnvListRef, _ModuleGoalRef, _Dependencies, _FreeVars, _Pb, _Pe, _S, ___867, ___553), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',28682,755,28643)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',28698,755,28643)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.expand@41:atom_fresh_[3944]'(_atom__fresh___913945_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913945_93, '[]'))))))).
':-'('<module>:emop.expand@41:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@41:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@41:atom_fresh_[3944]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 2, predicate, suspended([none,var('X')],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.expand@41:do'('var'(_X), _X, 'env'(___2072, _AddClause, _EnvRec, _This, _EnvVars, _CurrentScopeRef, _ImplicitConstructorsRef, _Impl, _EnvList0, _FileXml, _SgnVars, _EnvListRef, _ModuleGoalRef, _Dependencies, _FreeVars, _Pb, _Pe, _S, ___867, ___553), __36CutLevel), 'true').
':-'('<module>:emop.expand@41:do$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@41:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@42'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@42:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@42'('do'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@42:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@42'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.expand@42$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.expand@42$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.expand@42$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.expand@42$has_predicate'('do'(_____1)), 'true').
':-'('<module>:emop.expand@42:$sgn'(__36sgn, 'env'(___2085, _AddClause, _EnvRec, _This, _EnvVars, _CurrentScopeRef, _ImplicitConstructorsRef, _Impl, _EnvList0, _FileXml, _SgnVars, _EnvListRef, _ModuleGoalRef, _Dependencies, _FreeVars, _Pb, _Pe, _S, ___867, ___553), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',28784,758,28756)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',28916,758,28756)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.expand@42:atom_fresh_[3915]'(_atom__fresh___913916_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913916_93, '[]'))))))).
':-'('<module>:emop.expand@42:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@42:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@42:atom_fresh_[3915]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@42:do'('import'(_H1, _SubSgn, _Goal0), 'env'(___2085, _AddClause, _EnvRec, _This, _EnvVars, _CurrentScopeRef, _ImplicitConstructorsRef, _Impl, _EnvList0, _FileXml, _SgnVars, _EnvListRef, _ModuleGoalRef, _Dependencies, _FreeVars, _Pb, _Pe, _S, ___867, ___553), __36CutLevel), ','(','('='(_FreshPred, ___2188), ','(','('g_read'('emop.expand', '<module>:emop.expand'(___2185)), '<module>:emop.expand:fresh_init_goal_id$direct'(___2184, ___2185)), ','('g_read'('data.atom', '<module>:data.atom'(___2189)), '<module>:data.atom:format$direct'('$init~d', '.'(___2184, '[]'), ___2188, ___2189)))), ','(';'('->'('='(_H1, 'var'(_HVarMod)), ','(';'('->'(','('emop_call'(_EnvListRef, 'get'(_CurrentEnvList), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 766, from character 41 to 44'), '\\+'(','('g_read'('data.list', '<module>:data.list'(___2192)), '<module>:data.list:member$direct'(_H1, _CurrentEnvList, ___2192)))), ','(','('g_read'('emop.parser', '<module>:emop.parser'(___2194)), '<module>:emop.parser:fresh_var$direct'(_HF, ___2194)), ','('='(_HF, 'var'(_HFVarMod)), ','('='(_Goal1, 'callable'(',', '.'(_Goal0, '.'('callable'('=', '.'(_HF, '.'(_H1, '[]'))), '[]')))), 'emop_call'(_EnvListRef, 'set'('.'(_HF, _CurrentEnvList)), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 772, from character 41 to 44'))))), ','('='(_HF, _H1), ','('='(_HFVarMod, _HVarMod), ','('='(_FreshArgs, '[]'), '='(_Goal1, _Goal0))))), ','('='(___2208, _SubSgn), 'emop_call'(_SgnVars, '{}'(_HFVarMod, ___2208), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 779, from character 35 to 36')))), ','('='(_HF, _H1), ','('='(_HFVarMod, _HVarMod), ','('='(_FreshArgs, '[]'), '='(_Goal1, _Goal0))))), ','('emop_call'(_AddClause, 'add_clause'(_FreshPred, _FreshArgs, _Goal1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 786, from character 34 to 44'), ','(','(','(','('emop_call'(_ModuleGoalRef, 'get'(___2210), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 787, from character 65 to 68'), ','('emop_call'(_AddClause, 'prefixed'(_FreshPred, ___2211), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 787, from character 89 to 97'), 'emop_call'(_AddClause, 'args'(_FreshArgs, ___2212), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 787, from character 120 to 124'))), 'emop_call'(_Impl, 'seq'(___2210, 'callable'(___2211, ___2212), ___2214), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 787, from character 47 to 50')), 'emop_call'(_ModuleGoalRef, 'set'(___2214), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 787, from character 38 to 41')), ','(','('='(_CurrentScope, ___2215), 'emop_call'(_CurrentScopeRef, 'get'(___2215), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 788, from character 55 to 58')), ','(','('='(_Scope, ___2217), 'emop_call'(___553, 'get_scope'(_HF, 'file'(_Pb, _Pe), _SgnVars, _CurrentScope, ___2217), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 789, from character 32 to 41')), ','('='(_CurrentScope, '.'(_Head, _Tail)), 'emop_call'(_CurrentScopeRef, 'set'('.'(_Head, '.'(_Scope, _Tail))), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 791, from character 40 to 43'))))))))).
':-'('<module>:emop.expand@42:do$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@42:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@43'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@43:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@43'('do'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@43:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@43'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.expand@43$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.expand@43$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.expand@43$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.expand@43$has_predicate'('do'(_____2, _____1)), 'true').
':-'('<module>:emop.expand@43:$sgn'(__36sgn, 'env'(___2125, _AddClause, _EnvRec, _This, _EnvVars, _CurrentScopeRef, _ImplicitConstructorsRef, _Impl, _EnvList0, _FileXml, _SgnVars, _EnvListRef, _ModuleGoalRef, _Dependencies, _Args, _Args0, _Args1, _B, _B0, _Body, _Body0, _Body1, _Ctx, _Doc, _F, _FreeVars, _FreeVars0, _FreeVars1, _FreeVars2, _LocalExpander, ___867, ___553), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',31742,818,31707)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',31755,818,31707)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.expand@43:atom_fresh_[3899]'(_atom__fresh___913900_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913900_93, '[]'))))))).
':-'('<module>:emop.expand@43:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@43:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@43:atom_fresh_[3899]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 2, predicate, suspended([var('X'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.expand@43:do'(_X, ___2179, 'env'(___2125, _AddClause, _EnvRec, _This, _EnvVars, _CurrentScopeRef, _ImplicitConstructorsRef, _Impl, _EnvList0, _FileXml, _SgnVars, _EnvListRef, _ModuleGoalRef, _Dependencies, _Args, _Args0, _Args1, _B, _B0, _Body, _Body0, _Body1, _Ctx, _Doc, _F, _FreeVars, _FreeVars0, _FreeVars1, _FreeVars2, _LocalExpander, ___867, ___553), __36CutLevel), ','(','('emop_call'(_CurrentScopeRef, 'get'(___2177), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 820, from character 91 to 94'), 'emop_call'(_Impl, 'grammars'(___2177, ___2178), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 820, from character 66 to 74')), ','('g_read'('emop.parser', '<module>:emop.parser'(___2180)), '<module>:emop.parser:internal_reparse$direct'(_X, ___2178, ___2179, ___2180)))).
':-'('<module>:emop.expand@43:do$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@43:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@44'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@44:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@44'('do'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@44:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@44'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.expand@44$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.expand@44$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.expand@44$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.expand@44$has_predicate'('do'(_____2, _____1)), 'true').
':-'('<module>:emop.expand@44:$sgn'(__36sgn, 'env'(___2149, _AddClause, _EnvRec, _This, _EnvVars, _CurrentScopeRef, _ImplicitConstructorsRef, _Impl, _EnvList0, _FileXml, _SgnVars, _EnvListRef, _ModuleGoalRef, _Dependencies, _Args, _Args0, _Args1, _B, _B0, _Body, _Body0, _Body1, _Ctx, _Doc, _F, _FreeVars, _FreeVars0, _FreeVars1, _FreeVars2, _LocalExpander, ___867, ___553), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',32218,826,32187)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',32234,826,32187)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.expand@44:atom_fresh_[3887]'(_atom__fresh___913888_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913888_93, '[]'))))))).
':-'('<module>:emop.expand@44:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@44:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@44:atom_fresh_[3887]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 2, predicate, suspended([none,var('X')],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.expand@44:do'('var'(_X), _X, 'env'(___2149, _AddClause, _EnvRec, _This, _EnvVars, _CurrentScopeRef, _ImplicitConstructorsRef, _Impl, _EnvList0, _FileXml, _SgnVars, _EnvListRef, _ModuleGoalRef, _Dependencies, _Args, _Args0, _Args1, _B, _B0, _Body, _Body0, _Body1, _Ctx, _Doc, _F, _FreeVars, _FreeVars0, _FreeVars1, _FreeVars2, _LocalExpander, ___867, ___553), __36CutLevel), 'true').
':-'('<module>:emop.expand@44:do$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@44:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@45'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@45:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@45'('do', __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@45:do'(__36env, __36CutLevel))).
':-'('<module>:emop.expand@45'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.expand@45$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.expand@45$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.expand@45$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.expand@45$has_predicate'('do'), 'true').
':-'('<module>:emop.expand@45:$sgn'(__36sgn, 'env'(___2174, _AddClause, _EnvRec, _This, _EnvVars, _CurrentScopeRef, _ImplicitConstructorsRef, _Impl, _EnvList0, _FileXml, _SgnVars, _EnvListRef, _ModuleGoalRef, _Dependencies, _Args, _Args0, _Args1, _B, _B0, _Body, _Body0, _Body1, _Ctx, _Doc, _F, _FreeVars, _FreeVars0, _FreeVars1, _FreeVars2, _LocalExpander, ___867, ___553), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',33175,851,33157)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',33190,851,33157)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.expand@45:atom_fresh_[3873]'(_atom__fresh___913874_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913874_93, '[]'))))))).
':-'('<module>:emop.expand@45:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@45:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@45:atom_fresh_[3873]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 0, predicate, [], __36pos))).
':-'('<module>:emop.expand@45:do'('env'(___2174, _AddClause, _EnvRec, _This, _EnvVars, _CurrentScopeRef, _ImplicitConstructorsRef, _Impl, _EnvList0, _FileXml, _SgnVars, _EnvListRef, _ModuleGoalRef, _Dependencies, _Args, _Args0, _Args1, _B, _B0, _Body, _Body0, _Body1, _Ctx, _Doc, _F, _FreeVars, _FreeVars0, _FreeVars1, _FreeVars2, _LocalExpander, ___867, ___553), __36CutLevel), 'emop_call'(_LocalExpander, 'singleton_warning', 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 854, from character 38 to 55')).
':-'('<module>:emop.expand@45:do$direct'(__36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@45:do'(__36env, __36CutLevel))).
':-'('<module>:emop.expand@46'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@46:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@46'('do'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@46:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@46'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.expand@46$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.expand@46$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.expand@46$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.expand@46$has_predicate'('do'(_____1)), 'true').
':-'('<module>:emop.expand@46:$sgn'(__36sgn, 'env'(___2244, _AddClause, _Args, _Args0, _Body, _F, _List, _List0, _N, _Result, ___834, ___553), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',25656,682,25631)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',25668,682,25631)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.expand@46:atom_fresh_[4015]'(_atom__fresh___914016_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___914016_93, '[]'))))))).
':-'('<module>:emop.expand@46:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@46:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@46:atom_fresh_[4015]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 1, predicate, suspended([none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.expand@46:do'(___2281, 'env'(___2244, _AddClause, _Args, _Args0, _Body, _F, _List, _List0, _N, _Result, ___834, ___553), __36CutLevel), ','('g_read'('emop.parser', '<module>:emop.parser'(___2282)), '<module>:emop.parser:fresh_var$direct'(___2281, ___2282))).
':-'('<module>:emop.expand@46:do$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@46:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@47'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@47:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@47'('do'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@47:do'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@47'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.expand@47$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.expand@47$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.expand@47$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.expand@47$has_predicate'('do'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand@47:$sgn'(__36sgn, 'env'(___2259, _AddClause, _Args, _Args0, _Body, _F, _List, _List0, _N, _Result, ___834, ___553), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',25836,687,25811)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',25875,687,25811)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.expand@47:atom_fresh_[4003]'(_atom__fresh___914004_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___914004_93, '[]'))))))).
':-'('<module>:emop.expand@47:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@47:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@47:atom_fresh_[4003]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 3, predicate, suspended([var('Hd'),var('Tl'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.expand@47:do'(_Hd, _Tl, 'callable'('.', '.'(_Hd, '.'(_Tl, '[]'))), 'env'(___2259, _AddClause, _Args, _Args0, _Body, _F, _List, _List0, _N, _Result, ___834, ___553), __36CutLevel), 'true').
':-'('<module>:emop.expand@47:do$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@47:do'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@48'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@48:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@48'('as_sub_clause'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@48:as_sub_clause'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@48'('do'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@48:do'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@48'('simplify_args_info'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@48:simplify_args_info'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@48'('simplify'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@48:simplify'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@48'('simplify_args'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@48:simplify_args'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@48'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.expand@48$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.expand@48$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.expand@48$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.expand@48$has_predicate'('as_sub_clause'(_____2, _____1)), 'true').
':-'('<module>:emop.expand@48$has_predicate'('do'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand@48$has_predicate'('simplify_args_info'(_____2, _____1)), 'true').
':-'('<module>:emop.expand@48$has_predicate'('simplify'(_____2, _____1)), 'true').
':-'('<module>:emop.expand@48$has_predicate'('simplify_args'(_____2, _____1)), 'true').
':-'('<module>:emop.expand@48:$sgn'(__36sgn, 'env'(___2292, _AccuGoal, _ExpandFile, _LocalId, _Sgn, ___759, ___553), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',21542,585,21507)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',21579,585,21507)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','(','(','('true', '<module>:emop.expand@48:atom_fresh_[4043]'(_atom__fresh___914044_93, __36Pb, __36Pe)), '<module>:emop.expand@48:atom_fresh_[4045]'(_atom__fresh___914046_93, __36Pb, __36Pe)), '<module>:emop.expand@48:atom_fresh_[4047]'(_atom__fresh___914048_93, __36Pb, __36Pe)), '<module>:emop.expand@48:atom_fresh_[4049]'(_atom__fresh___914050_93, __36Pb, __36Pe)), '<module>:emop.expand@48:atom_fresh_[4051]'(_atom__fresh___914052_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___914052_93, '.'(_atom__fresh___914050_93, '.'(_atom__fresh___914048_93, '.'(_atom__fresh___914046_93, '.'(_atom__fresh___914044_93, '[]'))))))))))).
':-'('<module>:emop.expand@48:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@48:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@48:as_sub_clause'(_Term, 'var'(_V), 'env'(___2292, _AccuGoal, _ExpandFile, _LocalId, _Sgn, ___759, ___553), __36CutLevel), ','(','('='(_ClauseName, ___2298), ','(','('g_read'('data.atom', '<module>:data.atom'(___2297)), '<module>:data.atom:new$direct'(___2296, ___2297)), 'emop_call'(___553, 'prolog_predicate_name'(_LocalId, ___2296, ___2298), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 588, from character 34 to 55'))), ','(','('='(_V, ___2300), ','('g_read'('data.atom', '<module>:data.atom'(___2301)), '<module>:data.atom:new$direct'(___2300, ___2301))), ','('emop_call'(_ExpandFile, 'add_clause'(_ClauseName, '.'('var'('$s'), '.'('var'('$Pb'), '.'('var'('$Pe'), '[]'))), 'callable'('=', '.'('var'('$s'), '.'(_Term, '[]')))), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 590, from character 32 to 42'), ','(','('g_read'('data.ref', '<module>:data.ref'(___2322)), '<module>:data.ref:?$direct'(_AccuGoal, ___2321, ___2322)), ','('g_read'('data.ref', '<module>:data.ref'(___2337)), '<module>:data.ref:<-$direct'(_AccuGoal, 'callable'(',', '.'(___2321, '.'('callable'(_ClauseName, '.'('var'(_V), '.'('var'('$Pb'), '.'('var'('$Pe'), '[]')))), '[]'))), ___2337))))))).
':-'('<module>:emop.expand@48:as_sub_clause$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@48:as_sub_clause'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@48:atom_fresh_[4043]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(simplify_args, 2, predicate, suspended([none,none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.expand@48:atom_fresh_[4045]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(simplify, 2, predicate, suspended([none,none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.expand@48:atom_fresh_[4047]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(simplify_args_info, 2, predicate, suspended([none,none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.expand@48:atom_fresh_[4049]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 3, predicate, suspended([none,var('T'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.expand@48:atom_fresh_[4051]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(as_sub_clause, 2, predicate, suspended([var('Term'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.expand@48:do'('syntax'(_S, _, _), _T, 'callable'('.', '.'(___2352, '.'(_T, '[]'))), 'env'(___2292, _AccuGoal, _ExpandFile, _LocalId, _Sgn, ___759, ___553), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','('emop_call'(___2292, 'simplify_args'(_S, ___2342), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 597, from character 67 to 80'), 'emop_call'(___2292, 'as_sub_clause'('callable'('syntax', '.'(___2342, '.'('var'('$Pb'), '.'('var'('$Pe'), '[]')))), ___2352), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 597, from character 33 to 46')))).
':-'('<module>:emop.expand@48:do'('level'(_S, _, _), _T, 'callable'('.', '.'(___2370, '.'(_T, '[]'))), 'env'(___2292, _AccuGoal, _ExpandFile, _LocalId, _Sgn, ___759, ___553), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','('emop_call'(___2292, 'simplify_args'(_S, ___2360), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 600, from character 66 to 79'), 'emop_call'(___2292, 'as_sub_clause'('callable'('level', '.'(___2360, '.'('var'('$Pb'), '.'('var'('$Pe'), '[]')))), ___2370), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 600, from character 33 to 46')))).
':-'('<module>:emop.expand@48:do'('notation'(_S, _, _), _T, 'callable'('.', '.'(___2388, '.'(_T, '[]'))), 'env'(___2292, _AccuGoal, _ExpandFile, _LocalId, _Sgn, ___759, ___553), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','('emop_call'(___2292, 'simplify_args'(_S, ___2378), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 603, from character 69 to 82'), 'emop_call'(___2292, 'as_sub_clause'('callable'('notation', '.'(___2378, '.'('var'('$Pb'), '.'('var'('$Pe'), '[]')))), ___2388), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 603, from character 33 to 46')))).
':-'('<module>:emop.expand@48:do'('symbol'(_F, _N, _Kind, _ArgsInfo, ___Pos), _T, 'callable'('.', '.'(___2409, '.'(_T, '[]'))), 'env'(___2292, _AccuGoal, _ExpandFile, _LocalId, _Sgn, ___759, ___553), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','('emop_call'(___2292, 'simplify_args_info'(_ArgsInfo, ___2399), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 606, from character 105 to 123'), 'emop_call'(___2292, 'as_sub_clause'('callable'('symbol', '.'('term'(_F), '.'('number'(_N), '.'('term'(_Kind), '.'(___2399, '.'('var'('$pos'), '[]')))))), ___2409), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 606, from character 33 to 46')))).
':-'('<module>:emop.expand@48:do'(_, _T, _T, 'env'(___2292, _AccuGoal, _ExpandFile, _LocalId, _Sgn, ___759, ___553), __36CutLevel), 'true').
':-'('<module>:emop.expand@48:do$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@48:do'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@48:simplify'('callable'(_F, _Escaped, _Args, _, _), 'callable'('callable', '.'('callable'(_F, '[]'), '.'('callable'(_Escaped, '[]'), '.'(___2424, '.'('var'('$Pb'), '.'('var'('$Pe'), '[]')))))), 'env'(___2292, _AccuGoal, _ExpandFile, _LocalId, _Sgn, ___759, ___553), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), 'emop_call'(___2292, 'simplify_args'(_Args, ___2424), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 614, from character 80 to 93'))).
':-'('<module>:emop.expand@48:simplify'('()'(_X, _, _), 'callable'('()', '.'(___2438, '.'('var'('$Pb'), '.'('var'('$Pe'), '[]')))), 'env'(___2292, _AccuGoal, _ExpandFile, _LocalId, _Sgn, ___759, ___553), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), 'emop_call'(___2292, 'simplify'(_X, ___2438), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 615, from character 62 to 70'))).
':-'('<module>:emop.expand@48:simplify'('.()'(_M, _Term, _, _), 'callable'('.()', '.'(___2450, '.'(___2451, '.'('var'('$Pb'), '.'('var'('$Pe'), '[]'))))), 'env'(___2292, _AccuGoal, _ExpandFile, _LocalId, _Sgn, ___759, ___553), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','('emop_call'(___2292, 'simplify'(_M, ___2450), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 618, from character 35 to 43'), 'emop_call'(___2292, 'simplify'(_Term, ___2451), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 618, from character 48 to 56')))).
':-'('<module>:emop.expand@48:simplify'(_X, 'term'(_X), 'env'(___2292, _AccuGoal, _ExpandFile, _LocalId, _Sgn, ___759, ___553), __36CutLevel), 'true').
':-'('<module>:emop.expand@48:simplify$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@48:simplify'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@48:simplify_args'('none', 'callable'('none', '[]'), 'env'(___2292, _AccuGoal, _ExpandFile, _LocalId, _Sgn, ___759, ___553), __36CutLevel), 'true').
':-'('<module>:emop.expand@48:simplify_args'('[]', 'callable'('[]', '[]'), 'env'(___2292, _AccuGoal, _ExpandFile, _LocalId, _Sgn, ___759, ___553), __36CutLevel), 'true').
':-'('<module>:emop.expand@48:simplify_args'('.'(_H, _T), 'callable'('.', '.'(___2473, '.'(___2474, '[]'))), 'env'(___2292, _AccuGoal, _ExpandFile, _LocalId, _Sgn, ___759, ___553), __36CutLevel), ','('emop_call'(___2292, 'simplify'(_H, ___2473), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 623, from character 55 to 63'), 'emop_call'(___2292, 'simplify_args'(_T, ___2474), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 623, from character 68 to 81'))).
':-'('<module>:emop.expand@48:simplify_args$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@48:simplify_args'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@48:simplify_args_info'('.'(_H, _T), ___2416, 'env'(___2292, _AccuGoal, _ExpandFile, _LocalId, _Sgn, ___759, ___553), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), 'emop_call'(___759, 'simpl'('.'(_H, _T), ___2416), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 609, from character 50 to 55'))).
':-'('<module>:emop.expand@48:simplify_args_info'(_T, 'term'(_T), 'env'(___2292, _AccuGoal, _ExpandFile, _LocalId, _Sgn, ___759, ___553), __36CutLevel), 'true').
':-'('<module>:emop.expand@48:simplify_args_info$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@48:simplify_args_info'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@49'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@49:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@49'('do', __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@49:do'(__36env, __36CutLevel))).
':-'('<module>:emop.expand@49'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.expand@49$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.expand@49$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.expand@49$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.expand@49$has_predicate'('do'), 'true').
':-'('<module>:emop.expand@49:$sgn'(__36sgn, 'env'(___2784, _ExpandFile, _Impl, _Fid, _MainSgn, _HasMainModule, _FileXml, _Dependencies, _ModuleListRef, _ClausesRef, _PredicateIdCounterRef, _FreshModuleCounterRef, _ModuleQueue, _CheckQueue, _Ast, _EnvRec, _EnvVars, _FreeVars, _Goals, _ImplicitConstructorsRef, _Pos, _Scope, _SgnVars, _ThisOption, _Ctx, _Expr, _Expr0, _FreeVars1, _FreeVars2, _Goal, _Goal0, _H1, _HVarMod, _LocalExpander, _SubSgn, _SubSgnVars, ___677, ___553), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',8834,281,8816)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',8849,281,8816)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.expand@49:atom_fresh_[4211]'(_atom__fresh___914212_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___914212_93, '[]'))))))).
':-'('<module>:emop.expand@49:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@49:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@49:atom_fresh_[4211]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 0, predicate, [], __36pos))).
':-'('<module>:emop.expand@49:do'('env'(___2784, _ExpandFile, _Impl, _Fid, _MainSgn, _HasMainModule, _FileXml, _Dependencies, _ModuleListRef, _ClausesRef, _PredicateIdCounterRef, _FreshModuleCounterRef, _ModuleQueue, _CheckQueue, _Ast, _EnvRec, _EnvVars, _FreeVars, _Goals, _ImplicitConstructorsRef, _Pos, _Scope, _SgnVars, _ThisOption, _Ctx, _Expr, _Expr0, _FreeVars1, _FreeVars2, _Goal, _Goal0, _H1, _HVarMod, _LocalExpander, _SubSgn, _SubSgnVars, ___677, ___553), __36CutLevel), 'emop_call'(_LocalExpander, 'singleton_warning', 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 284, from character 38 to 55')).
':-'('<module>:emop.expand@49:do$direct'(__36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@49:do'(__36env, __36CutLevel))).
':-'('<module>:emop.expand@4:$sgn'(__36sgn, 'env'(___113, _Extract, _EnvRec, _SupSgnVars, _SgnVars, ___8), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',82742,2039,82736)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',82797,2039,82736)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.expand@4:atom_fresh_[3435]'(_atom__fresh___913436_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913436_93, '[]'))))))).
':-'('<module>:emop.expand@4:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@4:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@4:atom_fresh_[3435]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@4:do'('callable'(_Atom, _Escaped, _Args, _Pb, _Pe), _Result, 'env'(___113, _Extract, _EnvRec, _SupSgnVars, _SgnVars, ___8), __36CutLevel), ';'('->'(','('g_read'('emop.parser', '<module>:emop.parser'(___223)), '<module>:emop.parser:is_variable$direct'(_Atom, _Escaped, _Args, ___223)), ','(';'('->'('='(_Atom, '_'), 'throw'('error'('Anonymous environment variable', 'file'(_Pb, _Pe)))), 'true'), ','(','('='(___228, ___229), ','('emop_call'(_SgnVars, '{}'(_Atom, ___228), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 2054, from character 23 to 24'), 'emop_call'(_SupSgnVars, '{}'(_Atom, ___229), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 2054, from character 43 to 44'))), ','(','('='(_Var, ___230), 'emop_call'(_EnvRec, '{}'(_Atom, ___230), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 2055, from character 29 to 30')), ';'('->'(','('g_read'('data.var', '<module>:data.var'(___232)), '<module>:data.var:check$direct'(_Var, ___232)), ','('='(_Result, '.'('var'(_Atom), '[]')), '='(_Var, 'var'(_Pb, _Pe, 'env', _)))), ','('='(_Result, '[]'), ';'('->'('\\='(_Pb, 'dummy'), ','(','('g_read'('data.atom', '<module>:data.atom'(___246)), '<module>:data.atom:format$direct'('Duplicated variable in environment \'~a\'', '.'(_Atom, '[]'), ___245, ___246)), ','('g_read'('emop.message', '<module>:emop.message'(___248)), '<module>:emop.message:warning$direct'(___245, 'file'(_Pb, _Pe), ___248)))), 'true'))))))), 'throw'('error'('A term cannot appear in an environment', 'file'(_Pb, _Pe))))).
':-'('<module>:emop.expand@4:do'('()'(_SubEnv, _, _), _Env, 'env'(___113, _Extract, _EnvRec, _SupSgnVars, _SgnVars, ___8), __36CutLevel), 'emop_call'(_Extract, 'do'(_SubEnv, _Env), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 2083, from character 20 to 22')).
':-'('<module>:emop.expand@4:do'('module'(_, _, _, _, _, _Pb, _Pe), _, 'env'(___113, _Extract, _EnvRec, _SupSgnVars, _SgnVars, ___8), __36CutLevel), 'throw'('error'('A module cannot appear in an environment', 'file'(_Pb, _Pe)))).
':-'('<module>:emop.expand@4:do'('number'(_, _Pb, _Pe), _, 'env'(___113, _Extract, _EnvRec, _SupSgnVars, _SgnVars, ___8), __36CutLevel), 'throw'('error'('A number cannot appear in an environment', 'file'(_Pb, _Pe)))).
':-'('<module>:emop.expand@4:do'('empty'(_Pb, _Pe), _, 'env'(___113, _Extract, _EnvRec, _SupSgnVars, _SgnVars, ___8), __36CutLevel), 'throw'('error'('Empty item not allowed in an environment', 'file'(_Pb, _Pe)))).
':-'('<module>:emop.expand@4:do'('doc'(_, _Pb, _Pe, _), _, 'env'(___113, _Extract, _EnvRec, _SupSgnVars, _SgnVars, ___8), __36CutLevel), 'throw'('error'('Documentation not allowed here', 'file'(_Pb, _Pe)))).
':-'('<module>:emop.expand@4:do$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@4:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@5'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@5:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@5'('do'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@5:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@5'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.expand@5$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.expand@5$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.expand@5$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.expand@5$has_predicate'('do'(_____1)), 'true').
':-'('<module>:emop.expand@5:$sgn'(__36sgn, 'env'(___291, _Constructors, _Pos, _Sgn, _F, _First, _N, _Others, _Usages, ___98, ___8), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',82209,2018,82187)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',82223,2018,82187)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.expand@5:atom_fresh_[3439]'(_atom__fresh___913440_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913440_93, '[]'))))))).
':-'('<module>:emop.expand@5:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@5:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@5:atom_fresh_[3439]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 1, predicate, suspended([var('OtherPos')],[call(atom('io.err'),format,[none,none])]), __36pos))).
':-'('<module>:emop.expand@5:do'(_OtherPos, 'env'(___291, _Constructors, _Pos, _Sgn, _F, _First, _N, _Others, _Usages, ___98, ___8), __36CutLevel), ','(','('g_read'('emop.message', '<module>:emop.message'(___301)), '<module>:emop.message:line_text$direct'(_OtherPos, 'lowercase', ___300, ___301)), ','('g_read'('io.err', '<module>:io.err'(___304)), '<module>:io.err:format$direct'(' and ~a', '.'(___300, '[]'), ___304)))).
':-'('<module>:emop.expand@5:do$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@5:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@6'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@6:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@6'('do'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@6:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@6'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.expand@6$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.expand@6$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.expand@6$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.expand@6$has_predicate'('do'(_____2, _____1)), 'true').
':-'('<module>:emop.expand@6:$sgn'(__36sgn, 'env'(___467, _Impl, _InitGoalIdRef, _ArgsInfo, _ArgsTarget, _CArgs, _CList, _Cache, _Dependencies, _EvalEnv, _Fids, _MSgn, _Pos), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',902,27,893)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',910,27,893)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.expand@6:atom_fresh_[4316]'(_atom__fresh___914317_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___914317_93, '[]'))))))).
':-'('<module>:emop.expand@6:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@6:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@6:atom_fresh_[4316]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@6:do'('[]', '[]', 'env'(___467, _Impl, _InitGoalIdRef, _ArgsInfo, _ArgsTarget, _CArgs, _CList, _Cache, _Dependencies, _EvalEnv, _Fids, _MSgn, _Pos), __36CutLevel), 'true').
':-'('<module>:emop.expand@6:do'('.'(_HI, _TI), '.'(_HA, _TA), 'env'(___467, _Impl, _InitGoalIdRef, _ArgsInfo, _ArgsTarget, _CArgs, _CList, _Cache, _Dependencies, _EvalEnv, _Fids, _MSgn, _Pos), __36CutLevel), ','(';'('->'(','('\\='(_HI, 'none'), '='(_HA, 'var'(_VA))), ','('g_read'('emop.expand', '<module>:emop.expand'(___2866)), '<module>:emop.expand:unify_module$direct'(_EvalEnv, _VA, _HI, _Fids, ___2866))), 'true'), 'emop_call'(___467, 'do'(_TI, _TA), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 39, from character 15 to 17'))).
':-'('<module>:emop.expand@6:do$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@6:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@7'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@7:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@7'('do'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@7:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@7'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.expand@7$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.expand@7$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.expand@7$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.expand@7$has_predicate'('do'(_____2, _____1)), 'true').
':-'('<module>:emop.expand@7:$sgn'(__36sgn, 'env'(___478, _Impl, _InitGoalIdRef, _ArgsTarget, _CArgs, _CList, _Cache, _Dependencies, _EvalEnv, _Fids, _MSgn, _Pos, _SupEnv), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',1520,53,1511)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',1528,53,1511)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.expand@7:atom_fresh_[4302]'(_atom__fresh___914303_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___914303_93, '[]'))))))).
':-'('<module>:emop.expand@7:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@7:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@7:atom_fresh_[4302]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@7:do'('[]', '[]', 'env'(___478, _Impl, _InitGoalIdRef, _ArgsTarget, _CArgs, _CList, _Cache, _Dependencies, _EvalEnv, _Fids, _MSgn, _Pos, _SupEnv), __36CutLevel), 'true').
':-'('<module>:emop.expand@7:do'('.'(_HI, _TI), '.'(_HA, _TA), 'env'(___478, _Impl, _InitGoalIdRef, _ArgsTarget, _CArgs, _CList, _Cache, _Dependencies, _EvalEnv, _Fids, _MSgn, _Pos, _SupEnv), __36CutLevel), ','(';'('->'(','('='(_HI, 'var'(_VI)), '='(_HA, 'var'(_VA))), ','('='(___2858, ___2859), ','('emop_call'(_EvalEnv, '{}'(_VI, ___2858), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 61, from character 26 to 27'), 'emop_call'(_SupEnv, '{}'(_VA, ___2859), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 61, from character 40 to 41')))), 'true'), 'emop_call'(___478, 'do'(_TI, _TA), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 65, from character 15 to 17'))).
':-'('<module>:emop.expand@7:do$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@7:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@8'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@8:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@8'('do'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@8:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@8'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.expand@8$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.expand@8$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.expand@8$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.expand@8$has_predicate'('do'(_____1)), 'true').
':-'('<module>:emop.expand@8:$sgn'(__36sgn, 'env'(___485, _Impl, _InitGoalIdRef, _ArgsTarget, _CArgs, _CList, _Cache, _Dependencies, _EvalEnv, _Fids, _MSgn, _Pos, _SupEnv), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',1903,66,1884)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',1916,66,1884)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.expand@8:atom_fresh_[4283]'(_atom__fresh___914284_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___914284_93, '[]'))))))).
':-'('<module>:emop.expand@8:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@8:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@8:atom_fresh_[4283]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@8:do'('call'(_Mod, _CallF, _CallArgs), 'env'(___485, _Impl, _InitGoalIdRef, _ArgsTarget, _CArgs, _CList, _Cache, _Dependencies, _EvalEnv, _Fids, _MSgn, _Pos, _SupEnv), __36CutLevel), ';'('->'(','(','('='(_CallN, ___2819), ','('g_read'('data.list', '<module>:data.list'(___2820)), '<module>:data.list:length$direct'(_CallArgs, ___2819, ___2820))), ','(';'('->'('='(_Mod, 'scope'), ','('='(_NewFids, '[]'), '='(_MSgn0, _MSgn))), ';'('->'('='(_Mod, 'var'(_X)), ','('='(_NewFids, '[]'), ','(','('='(___2825, _MVarEnv), 'emop_call'(_EvalEnv, '{}'(_X, ___2825), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 80, from character 29 to 30')), ','('\\+'(','('g_read'('data.var', '<module>:data.var'(___2827)), '<module>:data.var:check$direct'(_MVarEnv, ___2827))), ','('='('root'(','(_NewFids, _MSgn0)), ___2833), ','(','('g_read'('emop.unionfind', '<module>:emop.unionfind'(___2832)), '<module>:emop.unionfind:get_root$direct'(_MVarEnv, ___2831, ___2832)), 'emop_call'(___2831, 'get'(___2833), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 82, from character 81 to 84'))))))), '->'(','('='(_Mod, 'atom'(_Atom)), '\\='(_Atom, 'top')), ','('='(_NewFids, '.'(_Atom, '[]')), ','('='(_MSgn0, ___2838), 'emop_call'(_Dependencies, 'find_mod_sgn'(_Atom, _Pos, ___2838), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 88, from character 42 to 54')))))), ','('g_read'('data.list', '<module>:data.list'(___2842)), '<module>:data.list:member$direct'('symbol'(_CallF, _CallN, 'predicate', _ArgsInfo, _Position), _MSgn0, ___2842)))), ';'('->'(','('g_read'('data.list', '<module>:data.list'(___2844)), '<module>:data.list:member$direct'(_Position, _Cache, ___2844)), 'true'), ','(','('g_read'('data.list', '<module>:data.list'(___2848)), '<module>:data.list:append$direct'(_NewFids, _Fids, ___2847, ___2848)), ','('g_read'('emop.expand', '<module>:emop.expand'(___2849)), '<module>:emop.expand:get_args_info$direct'(_ArgsInfo, _MSgn, _EvalEnv, '.'(_Position, _Cache), _Dependencies, _Pos, ___2847, _CallArgs, ___2849))))), 'true')).
':-'('<module>:emop.expand@8:do'('module'(_X, _MSgn0), 'env'(___485, _Impl, _InitGoalIdRef, _ArgsTarget, _CArgs, _CList, _Cache, _Dependencies, _EvalEnv, _Fids, _MSgn, _Pos, _SupEnv), __36CutLevel), ','('g_read'('emop.expand', '<module>:emop.expand'(___2851)), '<module>:emop.expand:unify_module$direct'(_EvalEnv, _X, _MSgn0, _Fids, ___2851))).
':-'('<module>:emop.expand@8:do$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@8:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@9'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@9:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@9'('add'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@9:add'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@9'('add_expand'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@9:add_expand'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@9'('add_link'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@9:add_link'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@9'('get'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@9:get'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@9'('get_expand'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@9:get_expand'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@9'('get_link'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@9:get_link'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@9'('find_mod_sgn'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.expand@9:find_mod_sgn'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@9'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.expand@9$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.expand@9$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.expand@9$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.expand@9$has_predicate'('add'(_____2, _____1)), 'true').
':-'('<module>:emop.expand@9$has_predicate'('add_expand'(_____2, _____1)), 'true').
':-'('<module>:emop.expand@9$has_predicate'('add_link'(_____1)), 'true').
':-'('<module>:emop.expand@9$has_predicate'('get'(_____1)), 'true').
':-'('<module>:emop.expand@9$has_predicate'('get_expand'(_____1)), 'true').
':-'('<module>:emop.expand@9$has_predicate'('get_link'(_____1)), 'true').
':-'('<module>:emop.expand@9$has_predicate'('find_mod_sgn'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.expand@9:$sgn'(__36sgn, 'env'(___537, _Impl, _InitGoalIdRef, _DependenciesRef, _ExpandDependenciesRef, _LinkRef, _PackageNodes, _RootPackagePath), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',4272,137,4266)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl',4280,137,4266)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','(','(','(','(','('true', '<module>:emop.expand@9:atom_fresh_[4225]'(_atom__fresh___914226_93, __36Pb, __36Pe)), '<module>:emop.expand@9:atom_fresh_[4227]'(_atom__fresh___914228_93, __36Pb, __36Pe)), '<module>:emop.expand@9:atom_fresh_[4229]'(_atom__fresh___914230_93, __36Pb, __36Pe)), '<module>:emop.expand@9:atom_fresh_[4231]'(_atom__fresh___914232_93, __36Pb, __36Pe)), '<module>:emop.expand@9:atom_fresh_[4233]'(_atom__fresh___914234_93, __36Pb, __36Pe)), '<module>:emop.expand@9:atom_fresh_[4235]'(_atom__fresh___914236_93, __36Pb, __36Pe)), '<module>:emop.expand@9:atom_fresh_[4237]'(_atom__fresh___914238_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___914238_93, '.'(_atom__fresh___914236_93, '.'(_atom__fresh___914234_93, '.'(_atom__fresh___914232_93, '.'(_atom__fresh___914230_93, '.'(_atom__fresh___914228_93, '.'(_atom__fresh___914226_93, '[]'))))))))))))).
':-'('<module>:emop.expand@9:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@9:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@9:add'(_Mod, _Pos, 'env'(___537, _Impl, _InitGoalIdRef, _DependenciesRef, _ExpandDependenciesRef, _LinkRef, _PackageNodes, _RootPackagePath), __36CutLevel), ','('emop_call'(_DependenciesRef, 'get'(_Dependencies), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 140, from character 28 to 31'), ';'('->'(','('g_read'('data.list', '<module>:data.list'(___2800)), '<module>:data.list:member$direct'('dep'(_Mod, _), _Dependencies, ___2800)), 'true'), 'emop_call'(_DependenciesRef, 'set'('.'('dep'(_Mod, _Pos), _Dependencies)), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 146, from character 31 to 34')))).
':-'('<module>:emop.expand@9:add$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@9:add'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@9:add_expand'('[]', ___Pos, 'env'(___537, _Impl, _InitGoalIdRef, _DependenciesRef, _ExpandDependenciesRef, _LinkRef, _PackageNodes, _RootPackagePath), __36CutLevel), ','('true', ','('='(__36CutLevel, '$cut'), '!'))).
':-'('<module>:emop.expand@9:add_expand'('.'(_H, _T), _Pos, 'env'(___537, _Impl, _InitGoalIdRef, _DependenciesRef, _ExpandDependenciesRef, _LinkRef, _PackageNodes, _RootPackagePath), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','('emop_call'(___537, 'add_expand'(_H, _Pos), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 153, from character 12 to 22'), 'emop_call'(___537, 'add_expand'(_T, _Pos), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 154, from character 12 to 22')))).
':-'('<module>:emop.expand@9:add_expand'(_Mod, _Pos, 'env'(___537, _Impl, _InitGoalIdRef, _DependenciesRef, _ExpandDependenciesRef, _LinkRef, _PackageNodes, _RootPackagePath), __36CutLevel), ','('emop_call'(___537, 'add'(_Mod, _Pos), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 156, from character 12 to 15'), ','('emop_call'(_ExpandDependenciesRef, 'get'(_Dependencies), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 157, from character 34 to 37'), ';'('->'(','('g_read'('data.list', '<module>:data.list'(___2806)), '<module>:data.list:member$direct'(_Mod, _Dependencies, ___2806)), 'true'), 'emop_call'(_ExpandDependenciesRef, 'set'('.'(_Mod, _Dependencies)), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 163, from character 37 to 40'))))).
':-'('<module>:emop.expand@9:add_expand$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@9:add_expand'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@9:add_link'(_Filename, 'env'(___537, _Impl, _InitGoalIdRef, _DependenciesRef, _ExpandDependenciesRef, _LinkRef, _PackageNodes, _RootPackagePath), __36CutLevel), ','('emop_call'(_LinkRef, 'get'(___2808), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 167, from character 44 to 47'), 'emop_call'(_LinkRef, 'set'('.'(_Filename, ___2808)), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 167, from character 20 to 23'))).
':-'('<module>:emop.expand@9:add_link$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@9:add_link'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@9:atom_fresh_[4225]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(find_mod_sgn, 3, predicate, suspended([var('Mod'),var('Pos'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.expand@9:atom_fresh_[4227]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(get_link, 1, predicate, suspended([none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.expand@9:atom_fresh_[4229]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(get_expand, 1, predicate, suspended([none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.expand@9:atom_fresh_[4231]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(get, 1, predicate, suspended([none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.expand@9:atom_fresh_[4233]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(add_link, 1, predicate, suspended([var('Filename')],[call(var('LinkRef'),set,[none])]), __36pos))).
':-'('<module>:emop.expand@9:atom_fresh_[4235]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(add_expand, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@9:atom_fresh_[4237]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(add, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.expand@9:find_mod_sgn'(_Mod, _Pos, ___2815, 'env'(___537, _Impl, _InitGoalIdRef, _DependenciesRef, _ExpandDependenciesRef, _LinkRef, _PackageNodes, _RootPackagePath), __36CutLevel), ','('emop_call'(___537, 'add'(_Mod, _Pos), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 176, from character 12 to 15'), ','('g_read'('emop.sgn', '<module>:emop.sgn'(___2816)), '<module>:emop.sgn:from_mod_spec$direct'('name'(_Mod, _PackageNodes, _RootPackagePath), _Pos, ___2815, ___2816)))).
':-'('<module>:emop.expand@9:find_mod_sgn$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@9:find_mod_sgn'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@9:get'(___2810, 'env'(___537, _Impl, _InitGoalIdRef, _DependenciesRef, _ExpandDependenciesRef, _LinkRef, _PackageNodes, _RootPackagePath), __36CutLevel), 'emop_call'(_DependenciesRef, 'get'(___2810), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 169, from character 31 to 34')).
':-'('<module>:emop.expand@9:get$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@9:get'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@9:get_expand'(___2811, 'env'(___537, _Impl, _InitGoalIdRef, _DependenciesRef, _ExpandDependenciesRef, _LinkRef, _PackageNodes, _RootPackagePath), __36CutLevel), 'emop_call'(_ExpandDependenciesRef, 'get'(___2811), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 171, from character 44 to 47')).
':-'('<module>:emop.expand@9:get_expand$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@9:get_expand'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.expand@9:get_link'(___2812, 'env'(___537, _Impl, _InitGoalIdRef, _DependenciesRef, _ExpandDependenciesRef, _LinkRef, _PackageNodes, _RootPackagePath), __36CutLevel), 'emop_call'(_LinkRef, 'get'(___2812), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/expand.mpl\", line 173, from character 28 to 31')).
':-'('<module>:emop.expand@9:get_link$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.expand@9:get_link'(_____1, __36env, __36CutLevel))).
':-'('emop.expand@init', ','(','('true', 'g_link'('emop.expand', '<module>:emop.expand'('env'(_Impl, _InitGoalIdRef)))), ','('true', ';'('->'('var'(_Impl), ','('g_inc'('$module_count', ___4), '='(_Impl, '$module'(___4, '.'('<module>:emop.expand@0'('env'(_Impl)), '[]'), '.'(_Impl, '[]'))))), ','('='(_Impl, '$module'(___4, ___5, _)), ','('='('.'(___6, ___7), ___5), ','('setarg'(1, ___5, '<module>:emop.expand@0'('env'(_Impl))), 'setarg'(2, ___5, '.'(___6, ___7))))))))).
':-'('dynamic'('/'('<module>:emop.lexer@0$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.lexer@1$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.lexer@15$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.lexer@14$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.lexer@13$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.lexer@12$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.lexer@11$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.lexer@10$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.lexer@9$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.lexer@8$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.lexer@7$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.lexer@6$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.lexer@5$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.lexer@4$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.lexer@3$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.lexer@2$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.lexer$dynamic', 4))).
':-'('<module>:emop.lexer'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer'('lex'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer:lex'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.lexer$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.lexer$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.lexer$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.lexer$has_predicate'('lex'(_____2, _____1)), 'true').
':-'('<module>:emop.lexer:$sgn'(__36sgn, 'env'(_Impl), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',0,0,0)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',26,0,0)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.lexer:atom_fresh_[3323]'(_atom__fresh___913324_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913324_93, '[]'))))))).
':-'('<module>:emop.lexer:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer:atom_fresh_[3323]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(lex, 2, predicate, suspended([var('Stream'),var('Lexems')],[call(var('Impl'),lex,[var('Stream'),var('Lexems')])]), __36pos))).
':-'('<module>:emop.lexer:lex'(_Stream, _Lexems, 'env'(_Impl), __36CutLevel), 'emop_call'(_Impl, 'lex'(_Stream, _Lexems), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 3, from character 11 to 14')).
':-'('<module>:emop.lexer:lex$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer:lex'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@0'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@0:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@0'('*'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@0:*'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@0'('functor'(_____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@0:functor'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@0'('close'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@0:close'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@0'('string'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@0:string'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@0'('escaped'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@0:escaped'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@0'('number'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@0:number'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@0'('variable'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@0:variable'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@0'('atom'(_____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@0:atom'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@0'('error'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@0:error'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@0'('file'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@0:file'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@0'('colon'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@0:colon'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@0'('unescaped'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@0:unescaped'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@0'('long'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@0:long'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@0'('doc'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@0:doc'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@0'('comment'(_____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@0:comment'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@0'('line'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@0:line'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@0'('end_of_line'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@0:end_of_line'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@0'('yes'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@0:yes'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@0'('end_of_file'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@0:end_of_file'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@0'('end_of_file'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@0:end_of_file'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@0'('no'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@0:no'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@0'('lex'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@0:lex'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@0'('blank'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@0:blank'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@0'('symbol_char'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@0:symbol_char'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@0'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.lexer@0$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.lexer@0$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.lexer@0$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.lexer@0$has_predicate'('*'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.lexer@0$has_predicate'('functor'(_____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.lexer@0$has_predicate'('close'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.lexer@0$has_predicate'('string'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.lexer@0$has_predicate'('escaped'(_____1)), 'true').
':-'('<module>:emop.lexer@0$has_predicate'('number'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.lexer@0$has_predicate'('variable'(_____1)), 'true').
':-'('<module>:emop.lexer@0$has_predicate'('atom'(_____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.lexer@0$has_predicate'('error'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.lexer@0$has_predicate'('file'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.lexer@0$has_predicate'('colon'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.lexer@0$has_predicate'('unescaped'(_____1)), 'true').
':-'('<module>:emop.lexer@0$has_predicate'('long'(_____1)), 'true').
':-'('<module>:emop.lexer@0$has_predicate'('doc'(_____1)), 'true').
':-'('<module>:emop.lexer@0$has_predicate'('comment'(_____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.lexer@0$has_predicate'('line'(_____1)), 'true').
':-'('<module>:emop.lexer@0$has_predicate'('end_of_line'(_____2, _____1)), 'true').
':-'('<module>:emop.lexer@0$has_predicate'('yes'(_____1)), 'true').
':-'('<module>:emop.lexer@0$has_predicate'('end_of_file'(_____2, _____1)), 'true').
':-'('<module>:emop.lexer@0$has_predicate'('end_of_file'(_____1)), 'true').
':-'('<module>:emop.lexer@0$has_predicate'('no'(_____1)), 'true').
':-'('<module>:emop.lexer@0$has_predicate'('lex'(_____2, _____1)), 'true').
':-'('<module>:emop.lexer@0$has_predicate'('blank'(_____1)), 'true').
':-'('<module>:emop.lexer@0$has_predicate'('symbol_char'(_____1)), 'true').
':-'('<module>:emop.lexer@0:$sgn'(__36sgn, 'env'(___8, _Impl), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',89,5,89)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',109,5,89)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','('true', '<module>:emop.lexer@0:atom_fresh_[3211]'(_atom__fresh___913212_93, __36Pb, __36Pe)), '<module>:emop.lexer@0:atom_fresh_[3213]'(_atom__fresh___913214_93, __36Pb, __36Pe)), '<module>:emop.lexer@0:atom_fresh_[3215]'(_atom__fresh___913216_93, __36Pb, __36Pe)), '<module>:emop.lexer@0:atom_fresh_[3217]'(_atom__fresh___913218_93, __36Pb, __36Pe)), '<module>:emop.lexer@0:atom_fresh_[3219]'(_atom__fresh___913220_93, __36Pb, __36Pe)), '<module>:emop.lexer@0:atom_fresh_[3221]'(_atom__fresh___913222_93, __36Pb, __36Pe)), '<module>:emop.lexer@0:atom_fresh_[3223]'(_atom__fresh___913224_93, __36Pb, __36Pe)), '<module>:emop.lexer@0:atom_fresh_[3225]'(_atom__fresh___913226_93, __36Pb, __36Pe)), '<module>:emop.lexer@0:atom_fresh_[3227]'(_atom__fresh___913228_93, __36Pb, __36Pe)), '<module>:emop.lexer@0:atom_fresh_[3229]'(_atom__fresh___913230_93, __36Pb, __36Pe)), '<module>:emop.lexer@0:atom_fresh_[3231]'(_atom__fresh___913232_93, __36Pb, __36Pe)), '<module>:emop.lexer@0:atom_fresh_[3233]'(_atom__fresh___913234_93, __36Pb, __36Pe)), '<module>:emop.lexer@0:atom_fresh_[3235]'(_atom__fresh___913236_93, __36Pb, __36Pe)), '<module>:emop.lexer@0:atom_fresh_[3237]'(_atom__fresh___913238_93, __36Pb, __36Pe)), '<module>:emop.lexer@0:atom_fresh_[3239]'(_atom__fresh___913240_93, __36Pb, __36Pe)), '<module>:emop.lexer@0:atom_fresh_[3241]'(_atom__fresh___913242_93, __36Pb, __36Pe)), '<module>:emop.lexer@0:atom_fresh_[3243]'(_atom__fresh___913244_93, __36Pb, __36Pe)), '<module>:emop.lexer@0:atom_fresh_[3245]'(_atom__fresh___913246_93, __36Pb, __36Pe)), '<module>:emop.lexer@0:atom_fresh_[3247]'(_atom__fresh___913248_93, __36Pb, __36Pe)), '<module>:emop.lexer@0:atom_fresh_[3249]'(_atom__fresh___913250_93, __36Pb, __36Pe)), '<module>:emop.lexer@0:atom_fresh_[3251]'(_atom__fresh___913252_93, __36Pb, __36Pe)), '<module>:emop.lexer@0:atom_fresh_[3253]'(_atom__fresh___913254_93, __36Pb, __36Pe)), '<module>:emop.lexer@0:atom_fresh_[3255]'(_atom__fresh___913256_93, __36Pb, __36Pe)), '<module>:emop.lexer@0:atom_fresh_[3257]'(_atom__fresh___913258_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913258_93, '.'(_atom__fresh___913256_93, '.'(_atom__fresh___913254_93, '.'(_atom__fresh___913252_93, '.'(_atom__fresh___913250_93, '.'(_atom__fresh___913248_93, '.'(_atom__fresh___913246_93, '.'(_atom__fresh___913244_93, '.'(_atom__fresh___913242_93, '.'(_atom__fresh___913240_93, '.'(_atom__fresh___913238_93, '.'(_atom__fresh___913236_93, '.'(_atom__fresh___913234_93, '.'(_atom__fresh___913232_93, '.'(_atom__fresh___913230_93, '.'(_atom__fresh___913228_93, '.'(_atom__fresh___913226_93, '.'(_atom__fresh___913224_93, '.'(_atom__fresh___913222_93, '.'(_atom__fresh___913220_93, '.'(_atom__fresh___913218_93, '.'(_atom__fresh___913216_93, '.'(_atom__fresh___913214_93, '.'(_atom__fresh___913212_93, '[]')))))))))))))))))))))))))))))).
':-'('<module>:emop.lexer@0:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@0:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@0:*'(___9, ___10, ___11, 'env'(___8, _Impl), __36CutLevel), '=..'(___11, '.'('*', '.'(___9, '.'(___10, '[]'))))).
':-'('<module>:emop.lexer@0:*$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@0:*'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@0:atom'(___31, ___32, ___33, ___34, ___35, 'env'(___8, _Impl), __36CutLevel), '=..'(___35, '.'('atom', '.'(___31, '.'(___32, '.'(___33, '.'(___34, '[]'))))))).
':-'('<module>:emop.lexer@0:atom$direct'(_____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@0:atom'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@0:atom_fresh_[3211]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(symbol_char, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.lexer@0:atom_fresh_[3213]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(blank, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.lexer@0:atom_fresh_[3215]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(lex, 2, predicate, suspended([var('Stream'),var('Lexems')],[module('Lexems',[symbol(read,1,predicate,[none],file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',400,10,379),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',6687,233,6673))),symbol(read_line_comment,1,predicate,suspended([var('Comment')],[module('Accu',[symbol(get,1,predicate,[none],file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',6785,237,6763),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',6916,242,6896)))]),call(atom('data.list'),accumulate,[var('Accu'),var('String')]),call(atom('data.string'),atom,[var('String'),var('Comment')])]),file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',6725,235,6689),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',7026,245,6980))),symbol(read_long_comment,1,predicate,[none],file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',7064,247,7028),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',8568,296,8522))),symbol(read_atom_close,4,predicate,[none,none,none,none],file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',8621,298,8570),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',8851,306,8837))),symbol(sequence_of_dots,1,predicate,suspended([none],[call(scope,true,[])]),file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',8879,308,8853),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',8964,309,8881))),symbol(dotted_symbol,3,predicate,suspended([var('C'),var('M'),var('Atom')],[module('Accu_ident',[symbol(get,1,predicate,[none],file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',9070,313,9048),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',9813,338,9793)))]),call(atom('data.list'),accumulate_sublists,[var('Accu_ident'),var('T')]),call(atom('data.string'),atom,[none,var('Atom')])]),file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',9001,311,8966),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',9946,341,9887))),symbol(read_ident_tail,2,predicate,suspended([var('C'),none],[call(scope,true,[])]),file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',9976,343,9948),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',10560,364,10549))),symbol(read_symbol_tail,2,predicate,[none,none],file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',10597,366,10562),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',10951,381,10937))),symbol(read_hexa,1,predicate,suspended([var('Value')],[module('Aux',[symbol(read,2,predicate,[none,none],file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',11042,385,11016),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',11284,392,11264)))]),call(var('Aux'),read,[none,var('Value')])]),file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',10979,383,10953),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',11331,394,11300))),symbol(read_binary,1,predicate,suspended([var('Value')],[module('Aux',[symbol(read,2,predicate,[none,none],file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',11424,398,11398),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',11652,405,11632)))]),call(var('Aux'),read,[none,var('Value')])]),file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',11361,396,11333),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',11699,407,11668))),symbol(read_octal,2,predicate,[none,none],file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',11731,409,11701),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',12207,426,12193))),symbol(read_decimal,3,predicate,[none,none,none],file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',12245,428,12209),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',12571,439,12509))),symbol(read_decimal_end,4,predicate,[none,none,none,none],file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',12633,441,12573),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',13930,486,13916))),symbol(read_numeric,1,predicate,[none],file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',13962,488,13932),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',14108,492,14072))),symbol(read_tail_numeric,1,predicate,suspended([var('String')],[module('Accu_digit',[symbol(get,1,predicate,[none],file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',14211,496,14189),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',14389,502,14369)))]),call(atom('data.list'),accumulate,[var('Accu_digit'),var('String')])]),file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',14145,494,14110),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',14458,504,14405))),symbol(read_quoted_string,4,predicate,[none,none,none,none],file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',14531,506,14472),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',16686,573,16672)))])]), __36pos))).
':-'('<module>:emop.lexer@0:atom_fresh_[3217]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(no, 1, constructor, none, __36pos))).
':-'('<module>:emop.lexer@0:atom_fresh_[3219]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(end_of_file, 1, constructor, none, __36pos))).
':-'('<module>:emop.lexer@0:atom_fresh_[3221]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(end_of_file, 2, constructor, none, __36pos))).
':-'('<module>:emop.lexer@0:atom_fresh_[3223]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(yes, 1, constructor, none, __36pos))).
':-'('<module>:emop.lexer@0:atom_fresh_[3225]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(end_of_line, 2, constructor, none, __36pos))).
':-'('<module>:emop.lexer@0:atom_fresh_[3227]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(line, 1, constructor, none, __36pos))).
':-'('<module>:emop.lexer@0:atom_fresh_[3229]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(comment, 5, constructor, none, __36pos))).
':-'('<module>:emop.lexer@0:atom_fresh_[3231]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(doc, 1, constructor, none, __36pos))).
':-'('<module>:emop.lexer@0:atom_fresh_[3233]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(long, 1, constructor, none, __36pos))).
':-'('<module>:emop.lexer@0:atom_fresh_[3235]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(unescaped, 1, constructor, none, __36pos))).
':-'('<module>:emop.lexer@0:atom_fresh_[3237]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(colon, 4, constructor, none, __36pos))).
':-'('<module>:emop.lexer@0:atom_fresh_[3239]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(file, 3, constructor, none, __36pos))).
':-'('<module>:emop.lexer@0:atom_fresh_[3241]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(error, 3, constructor, none, __36pos))).
':-'('<module>:emop.lexer@0:atom_fresh_[3243]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(atom, 5, constructor, none, __36pos))).
':-'('<module>:emop.lexer@0:atom_fresh_[3245]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(variable, 1, constructor, none, __36pos))).
':-'('<module>:emop.lexer@0:atom_fresh_[3247]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(number, 4, constructor, none, __36pos))).
':-'('<module>:emop.lexer@0:atom_fresh_[3249]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(escaped, 1, constructor, none, __36pos))).
':-'('<module>:emop.lexer@0:atom_fresh_[3251]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(string, 4, constructor, none, __36pos))).
':-'('<module>:emop.lexer@0:atom_fresh_[3253]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(close, 4, constructor, none, __36pos))).
':-'('<module>:emop.lexer@0:atom_fresh_[3255]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(functor, 5, constructor, none, __36pos))).
':-'('<module>:emop.lexer@0:atom_fresh_[3257]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(*, 3, constructor, none, __36pos))).
':-'('<module>:emop.lexer@0:blank'(_C, 'env'(___8, _Impl), __36CutLevel), ','(';'('='(_C, ' '), ';'('='(_C, '\t'), '='(_C, '\r'))), ','('true', ','('='(__36CutLevel, '$cut'), '!')))).
':-'('<module>:emop.lexer@0:blank$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@0:blank'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@0:close'(___17, ___18, ___19, ___20, 'env'(___8, _Impl), __36CutLevel), '=..'(___20, '.'('close', '.'(___17, '.'(___18, '.'(___19, '[]')))))).
':-'('<module>:emop.lexer@0:close$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@0:close'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@0:colon'(___42, ___43, ___44, ___45, 'env'(___8, _Impl), __36CutLevel), '=..'(___45, '.'('colon', '.'(___42, '.'(___43, '.'(___44, '[]')))))).
':-'('<module>:emop.lexer@0:colon$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@0:colon'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@0:comment'(___49, ___50, ___51, ___52, ___53, 'env'(___8, _Impl), __36CutLevel), '=..'(___53, '.'('comment', '.'(___49, '.'(___50, '.'(___51, '.'(___52, '[]'))))))).
':-'('<module>:emop.lexer@0:comment$direct'(_____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@0:comment'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@0:doc'(___48, 'env'(___8, _Impl), __36CutLevel), '=..'(___48, '.'('doc', '[]'))).
':-'('<module>:emop.lexer@0:doc$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@0:doc'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@0:end_of_file'(___60, 'env'(___8, _Impl), __36CutLevel), '=..'(___60, '.'('end_of_file', '[]'))).
':-'('<module>:emop.lexer@0:end_of_file'(___58, ___59, 'env'(___8, _Impl), __36CutLevel), '=..'(___59, '.'('end_of_file', '.'(___58, '[]')))).
':-'('<module>:emop.lexer@0:end_of_file$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@0:end_of_file'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@0:end_of_file$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@0:end_of_file'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@0:end_of_line'(___55, ___56, 'env'(___8, _Impl), __36CutLevel), '=..'(___56, '.'('end_of_line', '.'(___55, '[]')))).
':-'('<module>:emop.lexer@0:end_of_line$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@0:end_of_line'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@0:error'(___36, ___37, ___38, 'env'(___8, _Impl), __36CutLevel), '=..'(___38, '.'('error', '.'(___36, '.'(___37, '[]'))))).
':-'('<module>:emop.lexer@0:error$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@0:error'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@0:escaped'(___25, 'env'(___8, _Impl), __36CutLevel), '=..'(___25, '.'('escaped', '[]'))).
':-'('<module>:emop.lexer@0:escaped$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@0:escaped'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@0:file'(___39, ___40, ___41, 'env'(___8, _Impl), __36CutLevel), '=..'(___41, '.'('file', '.'(___39, '.'(___40, '[]'))))).
':-'('<module>:emop.lexer@0:file$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@0:file'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@0:functor'(___12, ___13, ___14, ___15, ___16, 'env'(___8, _Impl), __36CutLevel), '=..'(___16, '.'('functor', '.'(___12, '.'(___13, '.'(___14, '.'(___15, '[]'))))))).
':-'('<module>:emop.lexer@0:functor$direct'(_____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@0:functor'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@0:lex'(_Stream, _Lexems, 'env'(___8, _Impl), __36CutLevel), ','('true', ';'('->'('var'(_Lexems), ','('g_inc'('$module_count', ___62), '='(_Lexems, '$module'(___62, '.'('<module>:emop.lexer@1'('env'(_Lexems, _Stream, _Impl, ___8)), '[]'), '.'(_Lexems, '[]'))))), ','('='(_Lexems, '$module'(___62, ___63, _)), ','('='('.'(___64, ___65), ___63), ','('setarg'(1, ___63, '<module>:emop.lexer@1'('env'(_Lexems, _Stream, _Impl, ___8))), 'setarg'(2, ___63, '.'(___64, ___65)))))))).
':-'('<module>:emop.lexer@0:lex$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@0:lex'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@0:line'(___54, 'env'(___8, _Impl), __36CutLevel), '=..'(___54, '.'('line', '[]'))).
':-'('<module>:emop.lexer@0:line$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@0:line'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@0:long'(___47, 'env'(___8, _Impl), __36CutLevel), '=..'(___47, '.'('long', '[]'))).
':-'('<module>:emop.lexer@0:long$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@0:long'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@0:no'(___61, 'env'(___8, _Impl), __36CutLevel), '=..'(___61, '.'('no', '[]'))).
':-'('<module>:emop.lexer@0:no$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@0:no'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@0:number'(___26, ___27, ___28, ___29, 'env'(___8, _Impl), __36CutLevel), '=..'(___29, '.'('number', '.'(___26, '.'(___27, '.'(___28, '[]')))))).
':-'('<module>:emop.lexer@0:number$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@0:number'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@0:string'(___21, ___22, ___23, ___24, 'env'(___8, _Impl), __36CutLevel), '=..'(___24, '.'('string', '.'(___21, '.'(___22, '.'(___23, '[]')))))).
':-'('<module>:emop.lexer@0:string$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@0:string'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@0:symbol_char'(_C, 'env'(___8, _Impl), __36CutLevel), ';'('->'(';'('='(_C, ':'), ';'('='(_C, '+'), ';'('='(_C, '-'), ';'('='(_C, '*'), ';'('='(_C, '/'), ';'('='(_C, '\\'), ';'('='(_C, '='), ';'('='(_C, '<'), ';'('='(_C, '>'), ';'('='(_C, '|'), ';'('='(_C, '@'), ';'('='(_C, '#'), ';'('='(_C, '?'), ';'('='(_C, '!'), ';'('='(_C, '&'), ';'('='(_C, '~'), ';'('='(_C, '$'), '='(_C, '^')))))))))))))))))), 'true'), 'fail')).
':-'('<module>:emop.lexer@0:symbol_char$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@0:symbol_char'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@0:unescaped'(___46, 'env'(___8, _Impl), __36CutLevel), '=..'(___46, '.'('unescaped', '[]'))).
':-'('<module>:emop.lexer@0:unescaped$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@0:unescaped'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@0:variable'(___30, 'env'(___8, _Impl), __36CutLevel), '=..'(___30, '.'('variable', '[]'))).
':-'('<module>:emop.lexer@0:variable$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@0:variable'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@0:yes'(___57, 'env'(___8, _Impl), __36CutLevel), '=..'(___57, '.'('yes', '[]'))).
':-'('<module>:emop.lexer@0:yes$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@0:yes'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@1'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@1:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@1'('read'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@1:read'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@1'('read_line_comment'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@1:read_line_comment'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@1'('read_long_comment'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@1:read_long_comment'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@1'('read_atom_close'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@1:read_atom_close'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@1'('sequence_of_dots'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@1:sequence_of_dots'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@1'('dotted_symbol'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@1:dotted_symbol'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@1'('read_ident_tail'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@1:read_ident_tail'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@1'('read_symbol_tail'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@1:read_symbol_tail'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@1'('read_hexa'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@1:read_hexa'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@1'('read_binary'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@1:read_binary'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@1'('read_octal'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@1:read_octal'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@1'('read_decimal'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@1:read_decimal'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@1'('read_decimal_end'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@1:read_decimal_end'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@1'('read_numeric'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@1:read_numeric'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@1'('read_tail_numeric'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@1:read_tail_numeric'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@1'('read_quoted_string'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@1:read_quoted_string'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@1'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.lexer@1$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.lexer@1$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.lexer@1$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.lexer@1$has_predicate'('read'(_____1)), 'true').
':-'('<module>:emop.lexer@1$has_predicate'('read_line_comment'(_____1)), 'true').
':-'('<module>:emop.lexer@1$has_predicate'('read_long_comment'(_____1)), 'true').
':-'('<module>:emop.lexer@1$has_predicate'('read_atom_close'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.lexer@1$has_predicate'('sequence_of_dots'(_____1)), 'true').
':-'('<module>:emop.lexer@1$has_predicate'('dotted_symbol'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.lexer@1$has_predicate'('read_ident_tail'(_____2, _____1)), 'true').
':-'('<module>:emop.lexer@1$has_predicate'('read_symbol_tail'(_____2, _____1)), 'true').
':-'('<module>:emop.lexer@1$has_predicate'('read_hexa'(_____1)), 'true').
':-'('<module>:emop.lexer@1$has_predicate'('read_binary'(_____1)), 'true').
':-'('<module>:emop.lexer@1$has_predicate'('read_octal'(_____2, _____1)), 'true').
':-'('<module>:emop.lexer@1$has_predicate'('read_decimal'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.lexer@1$has_predicate'('read_decimal_end'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.lexer@1$has_predicate'('read_numeric'(_____1)), 'true').
':-'('<module>:emop.lexer@1$has_predicate'('read_tail_numeric'(_____1)), 'true').
':-'('<module>:emop.lexer@1$has_predicate'('read_quoted_string'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.lexer@10'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@10:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@10'('do'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@10:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@10'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.lexer@10$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.lexer@10$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.lexer@10$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.lexer@10$has_predicate'('do'(_____1)), 'true').
':-'('<module>:emop.lexer@10:$sgn'(__36sgn, 'env'(___280, _Impl, ___66, ___8), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',10843,378,10824)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',10873,378,10824)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.lexer@10:atom_fresh_[3303]'(_atom__fresh___913304_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913304_93, '[]'))))))).
':-'('<module>:emop.lexer@10:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@10:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@10:atom_fresh_[3303]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 1, predicate, suspended([var('C')],[call(var('Impl'),symbol_char,[var('C')])]), __36pos))).
':-'('<module>:emop.lexer@10:do'(_C, 'env'(___280, _Impl, ___66, ___8), __36CutLevel), 'emop_call'(_Impl, 'symbol_char'(_C), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 381, from character 23 to 34')).
':-'('<module>:emop.lexer@10:do$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@10:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@11'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@11:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@11'('read'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@11:read'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@11'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.lexer@11$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.lexer@11$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.lexer@11$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.lexer@11$has_predicate'('read'(_____2, _____1)), 'true').
':-'('<module>:emop.lexer@11:$sgn'(__36sgn, 'env'(___286, _Stream, ___66, ___8), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',10994,384,10982)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',11015,384,10982)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.lexer@11:atom_fresh_[3301]'(_atom__fresh___913302_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913302_93, '[]'))))))).
':-'('<module>:emop.lexer@11:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@11:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@11:atom_fresh_[3301]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(read, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.lexer@11:read'(_V, _R, 'env'(___286, _Stream, ___66, ___8), __36CutLevel), ';'('->'(','('emop_call'(_Stream, 'read'(___381), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 388, from character 56 to 60'), ','('g_read'('data.char', '<module>:data.char'(___382)), '<module>:data.char:hexadecimal_digit$direct'(___381, _V0, ___382))), ','(','('g_read'('data.number', '<module>:data.number'(___386)), '<module>:data.number:+$direct'('*'(_V, 16), _V0, ___385, ___386)), 'emop_call'(___286, 'read'(___385, _R), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 390, from character 26 to 30'))), '='(_V, _R))).
':-'('<module>:emop.lexer@11:read$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@11:read'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@12'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@12:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@12'('read'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@12:read'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@12'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.lexer@12$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.lexer@12$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.lexer@12$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.lexer@12$has_predicate'('read'(_____2, _____1)), 'true').
':-'('<module>:emop.lexer@12:$sgn'(__36sgn, 'env'(___291, _Stream, ___66, ___8), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',11376,397,11364)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',11397,397,11364)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.lexer@12:atom_fresh_[3299]'(_atom__fresh___913300_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913300_93, '[]'))))))).
':-'('<module>:emop.lexer@12:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@12:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@12:atom_fresh_[3299]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(read, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.lexer@12:read'(_V, _R, 'env'(___291, _Stream, ___66, ___8), __36CutLevel), ';'('->'(','('emop_call'(_Stream, 'read'(___374), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 401, from character 42 to 46'), ','('g_read'('data.char', '<module>:data.char'(___375)), '<module>:data.char:bit$direct'(___374, _V0, ___375))), ','(','('g_read'('data.number', '<module>:data.number'(___379)), '<module>:data.number:+$direct'('*'(_V, 2), _V0, ___378, ___379)), 'emop_call'(___291, 'read'(___378, _R), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 403, from character 26 to 30'))), '='(_V, _R))).
':-'('<module>:emop.lexer@12:read$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@12:read'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@13'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@13:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@13'('read'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@13:read'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@13'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.lexer@13$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.lexer@13$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.lexer@13$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.lexer@13$has_predicate'('read'(_____2, _____1)), 'true').
':-'('<module>:emop.lexer@13:$sgn'(__36sgn, 'env'(___296, _Stream, ___66, ___8), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',11746,410,11734)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',11767,410,11734)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.lexer@13:atom_fresh_[3297]'(_atom__fresh___913298_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913298_93, '[]'))))))).
':-'('<module>:emop.lexer@13:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@13:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@13:atom_fresh_[3297]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(read, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.lexer@13:read'(_V, _R, 'env'(___296, _Stream, ___66, ___8), __36CutLevel), ';'('->'(','('emop_call'(_Stream, 'read'(___367), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 414, from character 50 to 54'), ','('g_read'('data.char', '<module>:data.char'(___368)), '<module>:data.char:octal_digit$direct'(___367, _V0, ___368))), ','(','('g_read'('data.number', '<module>:data.number'(___372)), '<module>:data.number:+$direct'('*'(_V, 8), _V0, ___371, ___372)), 'emop_call'(___296, 'read'(___371, _R), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 416, from character 26 to 30'))), '='(_V, _R))).
':-'('<module>:emop.lexer@13:read$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@13:read'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@14'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@14:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@14'('get'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@14:get'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@14'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.lexer@14$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.lexer@14$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.lexer@14$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.lexer@14$has_predicate'('get'(_____1)), 'true').
':-'('<module>:emop.lexer@14:$sgn'(__36sgn, 'env'(___337, _Stream, ___66, ___8), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',14160,495,14148)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',14188,495,14148)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.lexer@14:atom_fresh_[3295]'(_atom__fresh___913296_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913296_93, '[]'))))))).
':-'('<module>:emop.lexer@14:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@14:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@14:atom_fresh_[3295]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(get, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.lexer@14:get'(_C, 'env'(___337, _Stream, ___66, ___8), __36CutLevel), '->'(','('emop_call'(_Stream, 'read'(_C), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 499, from character 28 to 32'), ','('g_read'('data.char', '<module>:data.char'(___365)), '<module>:data.char:decimal_digit$direct'(_C, _, ___365))), 'true')).
':-'('<module>:emop.lexer@14:get$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@14:get'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@15'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@15:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@15'('get'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@15:get'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@15'('skip_space'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@15:skip_space'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@15'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.lexer@15$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.lexer@15$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.lexer@15$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.lexer@15$has_predicate'('get'(_____1)), 'true').
':-'('<module>:emop.lexer@15$has_predicate'('skip_space'(_____1)), 'true').
':-'('<module>:emop.lexer@15:$sgn'(__36sgn, 'env'(___344, _Stream, _Delimiter, _Accu__string, _Pb0, ___66, ___8), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',14546,507,14534)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',14604,507,14534)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','('true', '<module>:emop.lexer@15:atom_fresh_[3291]'(_atom__fresh___913292_93, __36Pb, __36Pe)), '<module>:emop.lexer@15:atom_fresh_[3293]'(_atom__fresh___913294_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913294_93, '.'(_atom__fresh___913292_93, '[]')))))))).
':-'('<module>:emop.lexer@15:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@15:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@15:atom_fresh_[3291]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(skip_space, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.lexer@15:atom_fresh_[3293]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(get, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.lexer@15:get'(_C, 'env'(___344, _Stream, _Delimiter, _Accu__string, _Pb0, ___66, ___8), __36CutLevel), '->'(','('emop_call'(_Stream, 'position'(_Pb), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 511, from character 28 to 36'), ','('emop_call'(_Stream, 'read'(_C0), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 512, from character 28 to 32'), ';'('->'('='(_C0, 'end_of_file'), 'throw'('error'('Unterminated string', 'file'(_Pb0, _Pb)))), ';'('->'('emop_call'(_Delimiter, 'do'(_C0), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 518, from character 34 to 36'), ','('emop_call'(_Stream, 'read'(_C0), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 520, from character 31 to 35'), '='(_C, _C0))), ';'('->'('='(_C0, '\\'), ';'('->'(','(';'('true', 'emop_call'(_Stream, 'read'('\r'), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 529, from character 37 to 41')), 'emop_call'(_Stream, 'read'('\n'), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 531, from character 34 to 38')), 'emop_call'(_Accu__string, 'skip_space'(_C), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 533, from character 39 to 49')), ';'('->'(','('g_read'('data.char', '<module>:data.char'(___358)), '<module>:data.char:read_escape$direct'(_Stream, _C, ___358)), 'true'), ','('emop_call'(_Stream, 'position'(_Pe), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 539, from character 34 to 42'), 'throw'('error'('Ill-formed escape character', 'file'(_Pb, _Pe))))))), '='(_C, _C0)))))), 'true')).
':-'('<module>:emop.lexer@15:get$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@15:get'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@15:skip_space'(_C, 'env'(___344, _Stream, _Delimiter, _Accu__string, _Pb0, ___66, ___8), __36CutLevel), ';'('->'(','('emop_call'(_Stream, 'read'(_C0), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 553, from character 28 to 32'), ';'('='(_C0, ' '), '='(_C0, '\t'))), 'emop_call'(_Accu__string, 'skip_space'(_C), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 560, from character 33 to 43')), 'emop_call'(_Accu__string, 'get'(_C), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 562, from character 33 to 36'))).
':-'('<module>:emop.lexer@15:skip_space$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@15:skip_space'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@1:$sgn'(__36sgn, 'env'(___66, _Stream, _Impl, ___8), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',348,9,342)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',378,9,342)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','('true', '<module>:emop.lexer@1:atom_fresh_[3259]'(_atom__fresh___913260_93, __36Pb, __36Pe)), '<module>:emop.lexer@1:atom_fresh_[3261]'(_atom__fresh___913262_93, __36Pb, __36Pe)), '<module>:emop.lexer@1:atom_fresh_[3263]'(_atom__fresh___913264_93, __36Pb, __36Pe)), '<module>:emop.lexer@1:atom_fresh_[3265]'(_atom__fresh___913266_93, __36Pb, __36Pe)), '<module>:emop.lexer@1:atom_fresh_[3267]'(_atom__fresh___913268_93, __36Pb, __36Pe)), '<module>:emop.lexer@1:atom_fresh_[3269]'(_atom__fresh___913270_93, __36Pb, __36Pe)), '<module>:emop.lexer@1:atom_fresh_[3271]'(_atom__fresh___913272_93, __36Pb, __36Pe)), '<module>:emop.lexer@1:atom_fresh_[3273]'(_atom__fresh___913274_93, __36Pb, __36Pe)), '<module>:emop.lexer@1:atom_fresh_[3275]'(_atom__fresh___913276_93, __36Pb, __36Pe)), '<module>:emop.lexer@1:atom_fresh_[3277]'(_atom__fresh___913278_93, __36Pb, __36Pe)), '<module>:emop.lexer@1:atom_fresh_[3279]'(_atom__fresh___913280_93, __36Pb, __36Pe)), '<module>:emop.lexer@1:atom_fresh_[3281]'(_atom__fresh___913282_93, __36Pb, __36Pe)), '<module>:emop.lexer@1:atom_fresh_[3283]'(_atom__fresh___913284_93, __36Pb, __36Pe)), '<module>:emop.lexer@1:atom_fresh_[3285]'(_atom__fresh___913286_93, __36Pb, __36Pe)), '<module>:emop.lexer@1:atom_fresh_[3287]'(_atom__fresh___913288_93, __36Pb, __36Pe)), '<module>:emop.lexer@1:atom_fresh_[3289]'(_atom__fresh___913290_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913290_93, '.'(_atom__fresh___913288_93, '.'(_atom__fresh___913286_93, '.'(_atom__fresh___913284_93, '.'(_atom__fresh___913282_93, '.'(_atom__fresh___913280_93, '.'(_atom__fresh___913278_93, '.'(_atom__fresh___913276_93, '.'(_atom__fresh___913274_93, '.'(_atom__fresh___913272_93, '.'(_atom__fresh___913270_93, '.'(_atom__fresh___913268_93, '.'(_atom__fresh___913266_93, '.'(_atom__fresh___913264_93, '.'(_atom__fresh___913262_93, '.'(_atom__fresh___913260_93, '[]')))))))))))))))))))))).
':-'('<module>:emop.lexer@1:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@1:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@1:atom_fresh_[3259]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(read_quoted_string, 4, predicate, '[]', __36pos))).
':-'('<module>:emop.lexer@1:atom_fresh_[3261]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(read_tail_numeric, 1, predicate, suspended([var('String')],[module('Accu_digit',[symbol(get,1,predicate,[none],file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',14211,496,14189),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',14389,502,14369)))]),call(atom('data.list'),accumulate,[var('Accu_digit'),var('String')])]), __36pos))).
':-'('<module>:emop.lexer@1:atom_fresh_[3263]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(read_numeric, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.lexer@1:atom_fresh_[3265]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(read_decimal_end, 4, predicate, '[]', __36pos))).
':-'('<module>:emop.lexer@1:atom_fresh_[3267]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(read_decimal, 3, predicate, '[]', __36pos))).
':-'('<module>:emop.lexer@1:atom_fresh_[3269]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(read_octal, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.lexer@1:atom_fresh_[3271]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(read_binary, 1, predicate, suspended([var('Value')],[module('Aux',[symbol(read,2,predicate,[none,none],file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',11424,398,11398),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',11652,405,11632)))]),call(var('Aux'),read,[none,var('Value')])]), __36pos))).
':-'('<module>:emop.lexer@1:atom_fresh_[3273]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(read_hexa, 1, predicate, suspended([var('Value')],[module('Aux',[symbol(read,2,predicate,[none,none],file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',11042,385,11016),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',11284,392,11264)))]),call(var('Aux'),read,[none,var('Value')])]), __36pos))).
':-'('<module>:emop.lexer@1:atom_fresh_[3275]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(read_symbol_tail, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.lexer@1:atom_fresh_[3277]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(read_ident_tail, 2, predicate, suspended([var('C'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.lexer@1:atom_fresh_[3279]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(dotted_symbol, 3, predicate, suspended([var('C'),var('M'),var('Atom')],[module('Accu_ident',[symbol(get,1,predicate,[none],file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',9070,313,9048),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',9813,338,9793)))]),call(atom('data.list'),accumulate_sublists,[var('Accu_ident'),var('T')]),call(atom('data.string'),atom,[none,var('Atom')])]), __36pos))).
':-'('<module>:emop.lexer@1:atom_fresh_[3281]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(sequence_of_dots, 1, predicate, suspended([none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.lexer@1:atom_fresh_[3283]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(read_atom_close, 4, predicate, '[]', __36pos))).
':-'('<module>:emop.lexer@1:atom_fresh_[3285]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(read_long_comment, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.lexer@1:atom_fresh_[3287]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(read_line_comment, 1, predicate, suspended([var('Comment')],[module('Accu',[symbol(get,1,predicate,[none],file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',6785,237,6763),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',6916,242,6896)))]),call(atom('data.list'),accumulate,[var('Accu'),var('String')]),call(atom('data.string'),atom,[var('String'),var('Comment')])]), __36pos))).
':-'('<module>:emop.lexer@1:atom_fresh_[3289]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(read, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.lexer@1:dotted_symbol'(_C, _M, _Atom, 'env'(___66, _Stream, _Impl, ___8), __36CutLevel), ','(','('true', ';'('->'('var'(_Accu__ident), ','('g_inc'('$module_count', ___249), '='(_Accu__ident, '$module'(___249, '.'('<module>:emop.lexer@8'('env'(_Accu__ident, _Stream, _M, ___66, ___8)), '[]'), '.'(_Accu__ident, '[]'))))), ','('='(_Accu__ident, '$module'(___249, ___250, _)), ','('='('.'(___251, ___252), ___250), ','('setarg'(1, ___250, '<module>:emop.lexer@8'('env'(_Accu__ident, _Stream, _M, ___66, ___8))), 'setarg'(2, ___250, '.'(___251, ___252))))))), ','(','('g_read'('data.list', '<module>:data.list'(___255)), '<module>:data.list:accumulate_sublists$direct'(_Accu__ident, _T, ___255)), ','(','('g_read'('data.list', '<module>:data.list'(___259)), '<module>:data.list:append$direct'(_C, _T, ___258, ___259)), ','('g_read'('data.string', '<module>:data.string'(___260)), '<module>:data.string:atom$direct'(___258, _Atom, ___260)))))).
':-'('<module>:emop.lexer@1:dotted_symbol$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@1:dotted_symbol'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@1:read'(_Lexem, 'env'(___66, _Stream, _Impl, ___8), __36CutLevel), ','('emop_call'(_Stream, 'position'(_Pb), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 12, from character 19 to 27'), ','('->'('emop_call'(_Stream, 'read'(_C), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 14, from character 22 to 26'), 'true'), ';'('->'('='(_C, 'end_of_file'), '='(_Lexem, 'end_of_file'(_Pb))), ';'('->'('emop_call'(_Impl, 'blank'(_C), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 23, from character 20 to 25'), 'emop_call'(___66, 'read'(_Lexem), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 25, from character 15 to 19')), ';'('->'('='(_C, '\n'), '='(_Lexem, 'end_of_line'(_Pb))), ';'('->'('='(_C, '%'), ','('emop_call'(___66, 'read_line_comment'(_Comment), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 33, from character 15 to 32'), ','('emop_call'(_Stream, 'position'(_Pe), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 34, from character 22 to 30'), '='(_Lexem, 'comment'('line', _Comment, _Pb, _Pe))))), ';'('->'(','('='(_C, '/'), 'emop_call'(_Stream, 'read'('*'), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 38, from character 22 to 26')), ';'('->'('emop_call'(_Stream, 'read'('*'), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 41, from character 25 to 29'), ','('emop_call'(___66, 'read_long_comment'(_Comment), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 43, from character 18 to 35'), ','('emop_call'(_Stream, 'position'(_Pe), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 44, from character 25 to 33'), '='(_Lexem, 'comment'('doc', _Comment, _Pb, _Pe))))), ','('emop_call'(___66, 'read_long_comment'(_Comment), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 47, from character 18 to 35'), ','('emop_call'(_Stream, 'position'(_Pe), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 48, from character 25 to 33'), '='(_Lexem, 'comment'('long', _Comment, _Pb, _Pe)))))), ';'('->'(';'(','(','('g_read'('data.term', '<module>:data.term'(___107)), '<module>:data.term:>=$direct'(_C, 'A', ___107)), ','('g_read'('data.term', '<module>:data.term'(___109)), '<module>:data.term:=<$direct'(_C, 'Z', ___109))), ';'(','(','('g_read'('data.term', '<module>:data.term'(___112)), '<module>:data.term:>=$direct'(_C, 'a', ___112)), ','('g_read'('data.term', '<module>:data.term'(___114)), '<module>:data.term:=<$direct'(_C, 'z', ___114))), ';'('='(_C, '_'), ','(','('g_read'('data.char', '<module>:data.char'(___119)), '<module>:data.char:code$direct'(_C, ___118, ___119)), ','('g_read'('data.number', '<module>:data.number'(___120)), '<module>:data.number:>=$direct'(___118, 128, ___120)))))), ','('emop_call'(___66, 'read_ident_tail'(_C, _Atom), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 68, from character 15 to 30'), 'emop_call'(___66, 'read_atom_close'(_Atom, 'unescaped', _Pb, _Lexem), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 69, from character 15 to 30'))), ';'('->'(','('='(_C, '.'), 'emop_call'(_Stream, 'read'('('), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 72, from character 22 to 26')), ','('emop_call'(_Stream, 'position'(_Pe), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 74, from character 22 to 30'), '='(_Lexem, '.('(_Pb, _Pe)))), ';'('->'(','('='(_C, '.'), ','('emop_call'(_Stream, 'read'(_C0), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 78, from character 22 to 26'), ','('g_read'('data.char', '<module>:data.char'(___127)), '<module>:data.char:decimal_digit$direct'(_C0, _, ___127)))), ','('emop_call'(___66, 'read_tail_numeric'(_Tail), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 81, from character 15 to 32'), ','('emop_call'(___66, 'read_decimal_end'('.'('0', '[]'), '.'(_C0, _Tail), _Pb, _Value), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 82, from character 15 to 31'), ','('emop_call'(_Stream, 'position'(_Pe), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 83, from character 22 to 30'), '='(_Lexem, 'number'(_Value, _Pb, _Pe)))))), ';'('->'(';'('='(_C, ','), '='(_C, ';')), ','('emop_call'(_Stream, 'position'(_Pe), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 92, from character 22 to 30'), '='(_Lexem, 'atom'(_C, 'unescaped', _Pb, _Pe)))), ';'('->'(';'('emop_call'(_Impl, 'symbol_char'(_C), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 96, from character 23 to 34'), '='(_C, '.')), ','('emop_call'(___66, 'read_symbol_tail'(_C, _Atom), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 101, from character 15 to 31'), ','('emop_call'(_Stream, 'position'(_Pe), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 102, from character 22 to 30'), '='(_Lexem, 'atom'(_Atom, 'unescaped', _Pb, _Pe))))), ';'('->'(','('='(_C, '0'), ','('emop_call'(_Stream, 'read'('.'), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 106, from character 22 to 26'), ','('emop_call'(_Stream, 'read'(_C0), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 107, from character 22 to 26'), ','('g_read'('data.char', '<module>:data.char'(___143)), '<module>:data.char:decimal_digit$direct'(_C0, _, ___143))))), ','('emop_call'(___66, 'read_tail_numeric'(_Tail), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 110, from character 15 to 32'), ','('emop_call'(___66, 'read_decimal_end'('.'('0', '[]'), '.'(_C0, _Tail), _Pb, _Value), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 111, from character 15 to 31'), ','('emop_call'(_Stream, 'position'(_Pe), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 112, from character 22 to 30'), '='(_Lexem, 'number'(_Value, _Pb, _Pe)))))), ';'('->'('='(_C, '0'), ','(';'('->'(','('emop_call'(_Stream, 'read'(_C0), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 118, from character 25 to 29'), ';'('->'(';'('='(_C0, 'x'), '='(_C0, 'X')), 'emop_call'(___66, 'read_hexa'(_Value), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 126, from character 21 to 30')), ';'('->'(';'('='(_C0, 'b'), '='(_C0, 'B')), 'emop_call'(___66, 'read_binary'(_Value), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 134, from character 21 to 32')), ';'('->'('='(_C0, '\''), ','('emop_call'(_Stream, 'read'(_C1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 138, from character 28 to 32'), ','(';'('->'('='(_C1, '\\'), ','('g_read'('data.char', '<module>:data.char'(___157)), '<module>:data.char:read_escape$direct'(_Stream, _ValueC, ___157))), '='(_ValueC, _C1)), ','('='(_Value, ___159), ','('g_read'('data.char', '<module>:data.char'(___160)), '<module>:data.char:code$direct'(_ValueC, ___159, ___160)))))), '->'(';'('->'(';'('='(_C0, 'o'), '='(_C0, 'O')), 'emop_call'(_Stream, 'read'(_C1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 155, from character 31 to 35')), ','(','('g_read'('data.char', '<module>:data.char'(___164)), '<module>:data.char:decimal_digit$direct'(_C0, _, ___164)), '='(_C1, _C0))), 'emop_call'(___66, 'read_octal'(_C1, _Value), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 161, from character 21 to 31')))))), 'true'), '='(_Value, 0)), ','('emop_call'(_Stream, 'position'(_Pe), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 168, from character 22 to 30'), '='(_Lexem, 'number'(_Value, _Pb, _Pe))))), ';'('->'(','('g_read'('data.char', '<module>:data.char'(___167)), '<module>:data.char:decimal_digit$direct'(_C, _, ___167)), ','('emop_call'(___66, 'read_decimal'(_C, _Pb, _Value), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 173, from character 15 to 27'), ','('emop_call'(_Stream, 'position'(_Pe), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 174, from character 22 to 30'), '='(_Lexem, 'number'(_Value, _Pb, _Pe))))), ';'('->'('='(_C, '\''), ','(','('='(_String, ___176), ','(','('true', ';'('->'('var'(___170), ','('g_inc'('$module_count', ___171), '='(___170, '$module'(___171, '.'('<module>:emop.lexer@2'('env'(___170, _Stream, _Impl, _Atom, _C, _C0, _C1, _Comment, _Delim, _Lexem, _Pb, _Pe, _String, _Tail, _Value, _ValueC, ___66, ___8)), '[]'), '.'(___170, '[]'))))), ','('='(___170, '$module'(___171, ___172, _)), ','('='('.'(___173, ___174), ___172), ','('setarg'(1, ___172, '<module>:emop.lexer@2'('env'(___170, _Stream, _Impl, _Atom, _C, _C0, _C1, _Comment, _Delim, _Lexem, _Pb, _Pe, _String, _Tail, _Value, _ValueC, ___66, ___8))), 'setarg'(2, ___172, '.'(___173, ___174))))))), 'emop_call'(___66, 'read_quoted_string'(_Pb, _, ___170, ___176), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 179, from character 24 to 42'))), ','(','('g_read'('data.string', '<module>:data.string'(___178)), '<module>:data.string:atom$direct'(_String, _Atom, ___178)), 'emop_call'(___66, 'read_atom_close'(_Atom, 'escaped', _Pb, _Lexem), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 183, from character 15 to 30')))), ';'('->'('='(_C, '\"'), ','(','('='(_String, ___187), ','(','('true', ';'('->'('var'(___181), ','('g_inc'('$module_count', ___182), '='(___181, '$module'(___182, '.'('<module>:emop.lexer@3'('env'(___181, _Stream, _Impl, _Atom, _C, _C0, _C1, _Comment, _Delim, _Lexem, _Pb, _Pe, _String, _Tail, _Value, _ValueC, ___66, ___8)), '[]'), '.'(___181, '[]'))))), ','('='(___181, '$module'(___182, ___183, _)), ','('='('.'(___184, ___185), ___183), ','('setarg'(1, ___183, '<module>:emop.lexer@3'('env'(___181, _Stream, _Impl, _Atom, _C, _C0, _C1, _Comment, _Delim, _Lexem, _Pb, _Pe, _String, _Tail, _Value, _ValueC, ___66, ___8))), 'setarg'(2, ___183, '.'(___184, ___185))))))), 'emop_call'(___66, 'read_quoted_string'(_Pb, _, ___181, ___187), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 187, from character 24 to 42'))), ','('emop_call'(_Stream, 'position'(_Pe), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 190, from character 22 to 30'), '='(_Lexem, 'string'(_String, _Pb, _Pe))))), ';'('->'('='(_C, '`'), ','(','('='(_String, ___196), ','(','('true', ';'('->'('var'(___190), ','('g_inc'('$module_count', ___191), '='(___190, '$module'(___191, '.'('<module>:emop.lexer@4'('env'(___190, _Stream, _Impl, _Atom, _C, _C0, _C1, _Comment, _Delim, _Lexem, _Pb, _Pe, _String, _Tail, _Value, _ValueC, ___66, ___8)), '[]'), '.'(___190, '[]'))))), ','('='(___190, '$module'(___191, ___192, _)), ','('='('.'(___193, ___194), ___192), ','('setarg'(1, ___192, '<module>:emop.lexer@4'('env'(___190, _Stream, _Impl, _Atom, _C, _C0, _C1, _Comment, _Delim, _Lexem, _Pb, _Pe, _String, _Tail, _Value, _ValueC, ___66, ___8))), 'setarg'(2, ___192, '.'(___193, ___194))))))), 'emop_call'(___66, 'read_quoted_string'(_Pb, _Delim, ___190, ___196), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 195, from character 24 to 42'))), ','(','('g_read'('data.string', '<module>:data.string'(___198)), '<module>:data.string:atom$direct'(_String, _Atom, ___198)), ','('='(_Lexem, ___89), ','('='(_Delim, ___88), ';'('->'('='(___88, '`'), '='(___89, 'atom'(_Atom, 'variable', _Pb, _Pe))), ','('='(___89, ___203), ','('='(___88, ___90), ','('->'('true', 'true'), 'emop_call'(___66, 'read_atom_close'(_Atom, 'unescaped', _Pb, ___203), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 207, from character 18 to 33')))))))))), ';'('->'(';'('='(_C, '('), ';'('='(_C, '['), '='(_C, '{'))), ','('emop_call'(_Stream, 'position'(_Pe), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 218, from character 22 to 30'), ','('g_read'('data.term', '<module>:data.term'(___212)), '<module>:data.term:decomposition$direct'(_Lexem, '.'(_C, '.'(_Pb, '.'(_Pe, '[]'))), ___212)))), ';'('->'(';'('='(_C, ')'), ';'('='(_C, ']'), '='(_C, '}'))), ','('emop_call'(_Stream, 'position'(_Pe), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 229, from character 22 to 30'), '='(_Lexem, 'close'(_C, _Pb, _Pe)))), ','('emop_call'(_Stream, 'position'(_Pe), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 232, from character 22 to 30'), 'throw'('error'('Unknown char', 'file'(_Pb, _Pe))))))))))))))))))))))))).
':-'('<module>:emop.lexer@1:read$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@1:read'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@1:read_atom_close'(_Atom, _Escaped, _Pb, _Lexem, 'env'(___66, _Stream, _Impl, ___8), __36CutLevel), ','('emop_call'(_Stream, 'position'(_Pe), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 300, from character 19 to 27'), ';'('->'('emop_call'(_Stream, 'read'('('), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 302, from character 22 to 26'), '='(_Lexem, 'functor'(_Atom, _Escaped, _Pb, _Pe))), '='(_Lexem, 'atom'(_Atom, _Escaped, _Pb, _Pe))))).
':-'('<module>:emop.lexer@1:read_atom_close$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@1:read_atom_close'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@1:read_binary'(_Value, 'env'(___66, _Stream, _Impl, ___8), __36CutLevel), ','(','('true', ';'('->'('var'(_Aux), ','('g_inc'('$module_count', ___287), '='(_Aux, '$module'(___287, '.'('<module>:emop.lexer@12'('env'(_Aux, _Stream, ___66, ___8)), '[]'), '.'(_Aux, '[]'))))), ','('='(_Aux, '$module'(___287, ___288, _)), ','('='('.'(___289, ___290), ___288), ','('setarg'(1, ___288, '<module>:emop.lexer@12'('env'(_Aux, _Stream, ___66, ___8))), 'setarg'(2, ___288, '.'(___289, ___290))))))), 'emop_call'(_Aux, 'read'(0, _Value), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 408, from character 16 to 20'))).
':-'('<module>:emop.lexer@1:read_binary$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@1:read_binary'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@1:read_decimal'(_C, _Pb, _Value, 'env'(___66, _Stream, _Impl, ___8), __36CutLevel), ','('emop_call'(___66, 'read_tail_numeric'(_Tail__int__part), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 430, from character 12 to 29'), ','('='(_Int__part, '.'(_C, _Tail__int__part)), ','(';'('->'(','('emop_call'(_Stream, 'read'('.'), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 433, from character 22 to 26'), 'emop_call'(___66, 'read_numeric'(_Float__part), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 434, from character 15 to 27')), 'true'), 'true'), 'emop_call'(___66, 'read_decimal_end'(_Int__part, _Float__part, _Pb, _Value), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 440, from character 12 to 28'))))).
':-'('<module>:emop.lexer@1:read_decimal$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@1:read_decimal'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@1:read_decimal_end'(_Int__part, _Float__part, _Pb, _Value, 'env'(___66, _Stream, _Impl, ___8), __36CutLevel), ','(';'('->'('emop_call'(_Stream, 'read'('e'), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 444, from character 22 to 26'), ','(';'('->'('='(_Float__part, '.'('0', '[]')), 'true'), 'true'), ';'('->'('emop_call'(_Stream, 'read'('-'), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 454, from character 25 to 29'), ';'('->'('emop_call'(___66, 'read_numeric'(_Tail__exp__part), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 457, from character 21 to 33'), '='(_Exp__part, '.'('-', _Tail__exp__part))), ','('emop_call'(_Stream, 'position'(_Pe), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 461, from character 28 to 36'), 'throw'('error'('Ill-formed number', 'file'(_Pb, _Pe)))))), ';'('->'('emop_call'(___66, 'read_numeric'(_Exp__part), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 467, from character 18 to 30'), 'true'), ','('emop_call'(_Stream, 'position'(_Pe), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 471, from character 25 to 33'), 'throw'('error'('Ill-formed number', 'file'(_Pb, _Pe)))))))), '='(_Exp__part, '.'('0', '[]'))), ';'('->'('='(_Float__part, '[]'), ','('g_read'('data.string', '<module>:data.string'(___319)), '<module>:data.string:number$direct'(_Int__part, _Value, ___319))), ','(','('g_read'('data.list', '<module>:data.list'(___323)), '<module>:data.list:append$direct'(_Int__part, '.'('.', _Float__part), _Partial, ___323)), ','(','('g_read'('data.list', '<module>:data.list'(___327)), '<module>:data.list:append$direct'(_Partial, '.'('e', _Exp__part), _String, ___327)), ','('g_read'('data.string', '<module>:data.string'(___329)), '<module>:data.string:number$direct'(_String, _Value, ___329))))))).
':-'('<module>:emop.lexer@1:read_decimal_end$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@1:read_decimal_end'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@1:read_hexa'(_Value, 'env'(___66, _Stream, _Impl, ___8), __36CutLevel), ','(','('true', ';'('->'('var'(_Aux), ','('g_inc'('$module_count', ___282), '='(_Aux, '$module'(___282, '.'('<module>:emop.lexer@11'('env'(_Aux, _Stream, ___66, ___8)), '[]'), '.'(_Aux, '[]'))))), ','('='(_Aux, '$module'(___282, ___283, _)), ','('='('.'(___284, ___285), ___283), ','('setarg'(1, ___283, '<module>:emop.lexer@11'('env'(_Aux, _Stream, ___66, ___8))), 'setarg'(2, ___283, '.'(___284, ___285))))))), 'emop_call'(_Aux, 'read'(0, _Value), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 395, from character 16 to 20'))).
':-'('<module>:emop.lexer@1:read_hexa$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@1:read_hexa'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@1:read_ident_tail'(_C, ___269, 'env'(___66, _Stream, _Impl, ___8), __36CutLevel), ','(','('true', ';'('->'('var'(___263), ','('g_inc'('$module_count', ___264), '='(___263, '$module'(___264, '.'('<module>:emop.lexer@9'('env'(___263, ___66, ___8)), '[]'), '.'(___263, '[]'))))), ','('='(___263, '$module'(___264, ___265, _)), ','('='('.'(___266, ___267), ___265), ','('setarg'(1, ___265, '<module>:emop.lexer@9'('env'(___263, ___66, ___8))), 'setarg'(2, ___265, '.'(___266, ___267))))))), 'emop_call'(___66, 'dotted_symbol'('.'(_C, '[]'), ___263, ___269), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 344, from character 30 to 43'))).
':-'('<module>:emop.lexer@1:read_ident_tail$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@1:read_ident_tail'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@1:read_line_comment'(_Comment, 'env'(___66, _Stream, _Impl, ___8), __36CutLevel), ','(','('true', ';'('->'('var'(_Accu), ','('g_inc'('$module_count', ___220), '='(_Accu, '$module'(___220, '.'('<module>:emop.lexer@5'('env'(_Accu, _Stream, ___66, ___8)), '[]'), '.'(_Accu, '[]'))))), ','('='(_Accu, '$module'(___220, ___221, _)), ','('='('.'(___222, ___223), ___221), ','('setarg'(1, ___221, '<module>:emop.lexer@5'('env'(_Accu, _Stream, ___66, ___8))), 'setarg'(2, ___221, '.'(___222, ___223))))))), ','(','('g_read'('data.list', '<module>:data.list'(___226)), '<module>:data.list:accumulate$direct'(_Accu, _String, ___226)), ','('g_read'('data.string', '<module>:data.string'(___228)), '<module>:data.string:atom$direct'(_String, _Comment, ___228))))).
':-'('<module>:emop.lexer@1:read_line_comment$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@1:read_line_comment'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@1:read_long_comment'(_Comment, 'env'(___66, _Stream, _Impl, ___8), __36CutLevel), ','(','(','('true', ';'('->'('var'(___229), ','('g_inc'('$module_count', ___230), '='(___229, '$module'(___230, '.'('<module>:emop.lexer@6'('env'(___229, _Stream, _Pb, ___66, ___8)), '[]'), '.'(___229, '[]'))))), ','('='(___229, '$module'(___230, ___231, _)), ','('='('.'(___232, ___233), ___231), ','('setarg'(1, ___231, '<module>:emop.lexer@6'('env'(___229, _Stream, _Pb, ___66, ___8))), 'setarg'(2, ___231, '.'(___232, ___233))))))), 'emop_call'(___229, 'do'(_String), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 296, from character 14 to 16')), ','('g_read'('data.string', '<module>:data.string'(___236)), '<module>:data.string:atom$direct'(_String, _Comment, ___236)))).
':-'('<module>:emop.lexer@1:read_long_comment$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@1:read_long_comment'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@1:read_numeric'(_String, 'env'(___66, _Stream, _Impl, ___8), __36CutLevel), ','('emop_call'(_Stream, 'read'(_C0), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 490, from character 19 to 23'), ','(','('g_read'('data.char', '<module>:data.char'(___331)), '<module>:data.char:decimal_digit$direct'(_C0, _, ___331)), ','('='(_String, '.'(_C0, _Tail)), 'emop_call'(___66, 'read_tail_numeric'(_Tail), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 493, from character 12 to 29'))))).
':-'('<module>:emop.lexer@1:read_numeric$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@1:read_numeric'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@1:read_octal'(_C, _Value, 'env'(___66, _Stream, _Impl, ___8), __36CutLevel), ','(','('true', ';'('->'('var'(_Aux), ','('g_inc'('$module_count', ___292), '='(_Aux, '$module'(___292, '.'('<module>:emop.lexer@13'('env'(_Aux, _Stream, ___66, ___8)), '[]'), '.'(_Aux, '[]'))))), ','('='(_Aux, '$module'(___292, ___293, _)), ','('='('.'(___294, ___295), ___293), ','('setarg'(1, ___293, '<module>:emop.lexer@13'('env'(_Aux, _Stream, ___66, ___8))), 'setarg'(2, ___293, '.'(___294, ___295))))))), ';'('->'(','('g_read'('data.char', '<module>:data.char'(___298)), '<module>:data.char:octal_digit$direct'(_C, _V0, ___298)), 'emop_call'(_Aux, 'read'(_V0, _Value), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 424, from character 19 to 23')), '='(_Value, 0)))).
':-'('<module>:emop.lexer@1:read_octal$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@1:read_octal'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@1:read_quoted_string'(_Pb0, _Delim, _Delimiter, _String, 'env'(___66, _Stream, _Impl, ___8), __36CutLevel), ','(','('true', ';'('->'('var'(_Accu__string), ','('g_inc'('$module_count', ___340), '='(_Accu__string, '$module'(___340, '.'('<module>:emop.lexer@15'('env'(_Accu__string, _Stream, _Delimiter, _Accu__string, _Pb0, ___66, ___8)), '[]'), '.'(_Accu__string, '[]'))))), ','('='(_Accu__string, '$module'(___340, ___341, _)), ','('='('.'(___342, ___343), ___341), ','('setarg'(1, ___341, '<module>:emop.lexer@15'('env'(_Accu__string, _Stream, _Delimiter, _Accu__string, _Pb0, ___66, ___8))), 'setarg'(2, ___341, '.'(___342, ___343))))))), ','(','('g_read'('data.list', '<module>:data.list'(___346)), '<module>:data.list:accumulate$direct'(_Accu__string, _String, ___346)), ';'('->'(','('emop_call'(_Stream, 'read'(_Delim), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 567, from character 22 to 26'), 'emop_call'(_Delimiter, 'do'(_Delim), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 568, from character 25 to 27')), 'true'), ','('emop_call'(_Stream, 'position'(_Pe), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 572, from character 22 to 30'), 'throw'('error'('Unterminated string', 'file'(_Pb0, _Pe)))))))).
':-'('<module>:emop.lexer@1:read_quoted_string$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@1:read_quoted_string'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@1:read_symbol_tail'(_C, _Atom, 'env'(___66, _Stream, _Impl, ___8), __36CutLevel), ','(';'('->'('='(_C, '.'), ','('='(_Firsts, '.'(_C, ___271)), 'emop_call'(___66, 'sequence_of_dots'(___271), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 374, from character 18 to 34'))), '='(_Firsts, '.'(_C, '[]'))), ','('='(_Atom, ___281), ','(','('true', ';'('->'('var'(___275), ','('g_inc'('$module_count', ___276), '='(___275, '$module'(___276, '.'('<module>:emop.lexer@10'('env'(___275, _Impl, ___66, ___8)), '[]'), '.'(___275, '[]'))))), ','('='(___275, '$module'(___276, ___277, _)), ','('='('.'(___278, ___279), ___277), ','('setarg'(1, ___277, '<module>:emop.lexer@10'('env'(___275, _Impl, ___66, ___8))), 'setarg'(2, ___277, '.'(___278, ___279))))))), 'emop_call'(___66, 'dotted_symbol'(_Firsts, ___275, ___281), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 379, from character 19 to 32'))))).
':-'('<module>:emop.lexer@1:read_symbol_tail$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@1:read_symbol_tail'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@1:read_tail_numeric'(_String, 'env'(___66, _Stream, _Impl, ___8), __36CutLevel), ','(','('true', ';'('->'('var'(_Accu__digit), ','('g_inc'('$module_count', ___333), '='(_Accu__digit, '$module'(___333, '.'('<module>:emop.lexer@14'('env'(_Accu__digit, _Stream, ___66, ___8)), '[]'), '.'(_Accu__digit, '[]'))))), ','('='(_Accu__digit, '$module'(___333, ___334, _)), ','('='('.'(___335, ___336), ___334), ','('setarg'(1, ___334, '<module>:emop.lexer@14'('env'(_Accu__digit, _Stream, ___66, ___8))), 'setarg'(2, ___334, '.'(___335, ___336))))))), ','('g_read'('data.list', '<module>:data.list'(___339)), '<module>:data.list:accumulate$direct'(_Accu__digit, _String, ___339)))).
':-'('<module>:emop.lexer@1:read_tail_numeric$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@1:read_tail_numeric'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@1:sequence_of_dots'(___247, 'env'(___66, _Stream, _Impl, ___8), __36CutLevel), ','(','('true', ';'('->'('var'(___241), ','('g_inc'('$module_count', ___242), '='(___241, '$module'(___242, '.'('<module>:emop.lexer@7'('env'(___241, _Stream, ___66, ___8)), '[]'), '.'(___241, '[]'))))), ','('='(___241, '$module'(___242, ___243, _)), ','('='('.'(___244, ___245), ___243), ','('setarg'(1, ___243, '<module>:emop.lexer@7'('env'(___241, _Stream, ___66, ___8))), 'setarg'(2, ___243, '.'(___244, ___245))))))), ','('g_read'('data.list', '<module>:data.list'(___248)), '<module>:data.list:accumulate$direct'(___241, ___247, ___248)))).
':-'('<module>:emop.lexer@1:sequence_of_dots$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@1:sequence_of_dots'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@2'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@2:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@2'('do'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@2:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@2'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.lexer@2$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.lexer@2$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.lexer@2$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.lexer@2$has_predicate'('do'(_____1)), 'true').
':-'('<module>:emop.lexer@2:$sgn'(__36sgn, 'env'(___175, _Stream, _Impl, _Atom, _C, _C0, _C1, _Comment, _Delim, _Lexem, _Pb, _Pe, _String, _Tail, _Value, _ValueC, ___66, ___8), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',5155,178,5131)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',5182,178,5131)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.lexer@2:atom_fresh_[3321]'(_atom__fresh___913322_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913322_93, '[]'))))))).
':-'('<module>:emop.lexer@2:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@2:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@2:atom_fresh_[3321]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.lexer@2:do'('\'', 'env'(___175, _Stream, _Impl, _Atom, _C, _C0, _C1, _Comment, _Delim, _Lexem, _Pb, _Pe, _String, _Tail, _Value, _ValueC, ___66, ___8), __36CutLevel), 'true').
':-'('<module>:emop.lexer@2:do$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@2:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@3'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@3:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@3'('do'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@3:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@3'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.lexer@3$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.lexer@3$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.lexer@3$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.lexer@3$has_predicate'('do'(_____1)), 'true').
':-'('<module>:emop.lexer@3:$sgn'(__36sgn, 'env'(___186, _Stream, _Impl, _Atom, _C, _C0, _C1, _Comment, _Delim, _Lexem, _Pb, _Pe, _String, _Tail, _Value, _ValueC, ___66, ___8), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',5410,186,5386)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',5437,186,5386)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.lexer@3:atom_fresh_[3319]'(_atom__fresh___913320_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913320_93, '[]'))))))).
':-'('<module>:emop.lexer@3:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@3:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@3:atom_fresh_[3319]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.lexer@3:do'('\"', 'env'(___186, _Stream, _Impl, _Atom, _C, _C0, _C1, _Comment, _Delim, _Lexem, _Pb, _Pe, _String, _Tail, _Value, _ValueC, ___66, ___8), __36CutLevel), 'true').
':-'('<module>:emop.lexer@3:do$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@3:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@4'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@4:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@4'('do'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@4:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@4'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.lexer@4$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.lexer@4$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.lexer@4$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.lexer@4$has_predicate'('do'(_____1)), 'true').
':-'('<module>:emop.lexer@4:$sgn'(__36sgn, 'env'(___195, _Stream, _Impl, _Atom, _C, _C0, _C1, _Comment, _Delim, _Lexem, _Pb, _Pe, _String, _Tail, _Value, _ValueC, ___66, ___8), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',5641,194,5617)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',5672,194,5617)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.lexer@4:atom_fresh_[3317]'(_atom__fresh___913318_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913318_93, '[]'))))))).
':-'('<module>:emop.lexer@4:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@4:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@4:atom_fresh_[3317]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.lexer@4:do'('`', 'env'(___195, _Stream, _Impl, _Atom, _C, _C0, _C1, _Comment, _Delim, _Lexem, _Pb, _Pe, _String, _Tail, _Value, _ValueC, ___66, ___8), __36CutLevel), 'true').
':-'('<module>:emop.lexer@4:do'('\'', 'env'(___195, _Stream, _Impl, _Atom, _C, _C0, _C1, _Comment, _Delim, _Lexem, _Pb, _Pe, _String, _Tail, _Value, _ValueC, ___66, ___8), __36CutLevel), 'true').
':-'('<module>:emop.lexer@4:do$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@4:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@5'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@5:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@5'('get'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@5:get'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@5'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.lexer@5$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.lexer@5$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.lexer@5$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.lexer@5$has_predicate'('get'(_____1)), 'true').
':-'('<module>:emop.lexer@5:$sgn'(__36sgn, 'env'(___224, _Stream, ___66, ___8), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',6740,236,6728)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',6762,236,6728)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.lexer@5:atom_fresh_[3315]'(_atom__fresh___913316_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913316_93, '[]'))))))).
':-'('<module>:emop.lexer@5:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@5:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@5:atom_fresh_[3315]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(get, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.lexer@5:get'(_C, 'env'(___224, _Stream, ___66, ___8), __36CutLevel), '->'('emop_call'(_Stream, 'read'(_C), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 240, from character 28 to 32'), '\\='(_C, '\n'))).
':-'('<module>:emop.lexer@5:get$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@5:get'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@6'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@6:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@6'('skip_beginning_of_line', __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@6:skip_beginning_of_line'(__36env, __36CutLevel))).
':-'('<module>:emop.lexer@6'('do'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@6:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@6'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.lexer@6$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.lexer@6$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.lexer@6$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.lexer@6$has_predicate'('skip_beginning_of_line'), 'true').
':-'('<module>:emop.lexer@6$has_predicate'('do'(_____1)), 'true').
':-'('<module>:emop.lexer@6:$sgn'(__36sgn, 'env'(___234, _Stream, _Pb, ___66, ___8), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',7079,248,7067)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',7100,248,7067)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','('true', '<module>:emop.lexer@6:atom_fresh_[3311]'(_atom__fresh___913312_93, __36Pb, __36Pe)), '<module>:emop.lexer@6:atom_fresh_[3313]'(_atom__fresh___913314_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913314_93, '.'(_atom__fresh___913312_93, '[]')))))))).
':-'('<module>:emop.lexer@6:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@6:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@6:atom_fresh_[3311]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.lexer@6:atom_fresh_[3313]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(skip_beginning_of_line, 0, predicate, [], __36pos))).
':-'('<module>:emop.lexer@6:do'(_List, 'env'(___234, _Stream, _Pb, ___66, ___8), __36CutLevel), '->'('emop_call'(_Stream, 'read'(_C0), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 272, from character 28 to 32'), ';'('->'('='(_C0, 'end_of_file'), ','('emop_call'(_Stream, 'position'(_Pe), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 277, from character 31 to 39'), 'throw'('error'('Unterminated comment', 'file'(_Pb, _Pe))))), ';'('->'('='(_C0, '\n'), ','('emop_call'(___234, 'skip_beginning_of_line', 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 284, from character 24 to 46'), 'emop_call'(___234, 'do'(_List), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 285, from character 24 to 26'))), ';'('->'(','('='(_C0, '*'), 'emop_call'(_Stream, 'read'('/'), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 288, from character 31 to 35')), '='(_List, '[]')), ','('='(_List, '.'(_C0, _T)), 'emop_call'(___234, 'do'(_T), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 293, from character 24 to 26'))))))).
':-'('<module>:emop.lexer@6:do$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@6:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@6:skip_beginning_of_line'('env'(___234, _Stream, _Pb, ___66, ___8), __36CutLevel), ';'(','(','('='(___423, ___419), 'emop_call'(_Stream, 'read'(___423), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 252, from character 28 to 32')), ';'('->'(','('='(___419, ___420), ';'('='(___420, ' '), '='(___420, '\t'))), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), 'emop_call'(___234, 'skip_beginning_of_line', 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 256, from character 24 to 46'))), ','('='(___419, ___421), ';'('->'('='(___421, '*'), ','('\\+'('emop_call'(_Stream, 'read'('/'), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 260, from character 34 to 38')), ','('true', ','('='(__36CutLevel, '$cut'), '!')))), ','('='(___421, ___422), '->'('true', ','('true', ','('='(__36CutLevel, '$cut'), '!')))))))), 'true')).
':-'('<module>:emop.lexer@6:skip_beginning_of_line$direct'(__36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@6:skip_beginning_of_line'(__36env, __36CutLevel))).
':-'('<module>:emop.lexer@7'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@7:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@7'('get'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@7:get'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@7'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.lexer@7$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.lexer@7$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.lexer@7$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.lexer@7$has_predicate'('get'(_____1)), 'true').
':-'('<module>:emop.lexer@7:$sgn'(__36sgn, 'env'(___246, _Stream, ___66, ___8), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',8914,309,8881)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',8931,309,8881)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.lexer@7:atom_fresh_[3309]'(_atom__fresh___913310_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913310_93, '[]'))))))).
':-'('<module>:emop.lexer@7:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@7:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@7:atom_fresh_[3309]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(get, 1, predicate, suspended([none],[call(var('Stream'),read,[none])]), __36pos))).
':-'('<module>:emop.lexer@7:get'('.', 'env'(___246, _Stream, ___66, ___8), __36CutLevel), 'emop_call'(_Stream, 'read'('.'), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 310, from character 70 to 74')).
':-'('<module>:emop.lexer@7:get$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@7:get'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@8'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@8:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@8'('get'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@8:get'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@8'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.lexer@8$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.lexer@8$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.lexer@8$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.lexer@8$has_predicate'('get'(_____1)), 'true').
':-'('<module>:emop.lexer@8:$sgn'(__36sgn, 'env'(___253, _Stream, _M, ___66, ___8), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',9016,312,9004)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',9047,312,9004)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.lexer@8:atom_fresh_[3307]'(_atom__fresh___913308_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913308_93, '[]'))))))).
':-'('<module>:emop.lexer@8:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@8:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@8:atom_fresh_[3307]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(get, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.lexer@8:get'(_L, 'env'(___253, _Stream, _M, ___66, ___8), __36CutLevel), ';'('->'(','('emop_call'(_Stream, 'read'(_C), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 316, from character 28 to 32'), ','('\\='(_C, 'end_of_file'), ';'('->'('emop_call'(_M, 'do'(_C), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 319, from character 26 to 28'), '='(_L, '.'(_C, '[]'))), '->'(','('='(_C, '.'), ';'(','(','('='(_T, ___412), 'emop_call'(___66, 'sequence_of_dots'(___412), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 325, from character 31 to 47')), '\\='(_T, '[]')), ','('emop_call'(_Stream, 'read'(_C0), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 328, from character 34 to 38'), ','('emop_call'(_M, 'do'(_C0), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl\", line 329, from character 29 to 31'), '='(_T, '.'(_C0, '[]')))))), '='(_L, '.'(_C, _T)))))), 'true'), 'fail')).
':-'('<module>:emop.lexer@8:get$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@8:get'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@9'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@9:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@9'('do'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.lexer@9:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@9'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.lexer@9$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.lexer@9$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.lexer@9$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.lexer@9$has_predicate'('do'(_____1)), 'true').
':-'('<module>:emop.lexer@9:$sgn'(__36sgn, 'env'(___268, ___66, ___8), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',9978,343,9948)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/lexer.mpl',10001,343,9948)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.lexer@9:atom_fresh_[3305]'(_atom__fresh___913306_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913306_93, '[]'))))))).
':-'('<module>:emop.lexer@9:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@9:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.lexer@9:atom_fresh_[3305]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.lexer@9:do'(_C, 'env'(___268, ___66, ___8), __36CutLevel), ','('\\='(_C, 'end_of_file'), ';'(','(','('g_read'('data.term', '<module>:data.term'(___390)), '<module>:data.term:>=$direct'(_C, 'a', ___390)), ','('g_read'('data.term', '<module>:data.term'(___392)), '<module>:data.term:=<$direct'(_C, 'z', ___392))), ';'(','(','('g_read'('data.term', '<module>:data.term'(___394)), '<module>:data.term:>=$direct'(_C, 'A', ___394)), ','('g_read'('data.term', '<module>:data.term'(___396)), '<module>:data.term:=<$direct'(_C, 'Z', ___396))), ';'(','(','('g_read'('data.term', '<module>:data.term'(___398)), '<module>:data.term:>=$direct'(_C, '0', ___398)), ','('g_read'('data.term', '<module>:data.term'(___400)), '<module>:data.term:=<$direct'(_C, '9', ___400))), ';'('='(_C, '_'), ';'('='(_C, '\''), ','(','('g_read'('data.char', '<module>:data.char'(___406)), '<module>:data.char:code$direct'(_C, ___405, ___406)), ','('g_read'('data.number', '<module>:data.number'(___407)), '<module>:data.number:>=$direct'(___405, 128, ___407)))))))))).
':-'('<module>:emop.lexer@9:do$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.lexer@9:do'(_____1, __36env, __36CutLevel))).
':-'('emop.lexer@init', ','(','('true', 'g_link'('emop.lexer', '<module>:emop.lexer'('env'(_Impl)))), ','('true', ';'('->'('var'(_Impl), ','('g_inc'('$module_count', ___4), '='(_Impl, '$module'(___4, '.'('<module>:emop.lexer@0'('env'(_Impl, _Impl)), '[]'), '.'(_Impl, '[]'))))), ','('='(_Impl, '$module'(___4, ___5, _)), ','('='('.'(___6, ___7), ___5), ','('setarg'(1, ___5, '<module>:emop.lexer@0'('env'(_Impl, _Impl))), 'setarg'(2, ___5, '.'(___6, ___7))))))))).
':-'('dynamic'('/'('<module>:emop.message$dynamic', 4))).
':-'('<module>:emop.message'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.message:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.message'('file'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.message:file'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.message'('file'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.message:file'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.message'('cmdline'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.message:cmdline'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.message'('system_error'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.message:system_error'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.message'('error'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.message:error'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.message'('pos'(_____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.message:pos'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.message'('has_warning', __36env, _, __36CutLevel), ','('!', '<module>:emop.message:has_warning'(__36env, __36CutLevel))).
':-'('<module>:emop.message'('reset_warning', __36env, _, __36CutLevel), ','('!', '<module>:emop.message:reset_warning'(__36env, __36CutLevel))).
':-'('<module>:emop.message'('line_text'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.message:line_text'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.message'('position_text'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.message:position_text'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.message'('format'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.message:format'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.message'('error'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.message:error'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.message'('warning'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.message:warning'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.message'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.message$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.message$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.message$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.message$has_predicate'('file'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.message$has_predicate'('file'(_____2, _____1)), 'true').
':-'('<module>:emop.message$has_predicate'('cmdline'(_____1)), 'true').
':-'('<module>:emop.message$has_predicate'('system_error'(_____2, _____1)), 'true').
':-'('<module>:emop.message$has_predicate'('error'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.message$has_predicate'('pos'(_____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.message$has_predicate'('has_warning'), 'true').
':-'('<module>:emop.message$has_predicate'('reset_warning'), 'true').
':-'('<module>:emop.message$has_predicate'('line_text'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.message$has_predicate'('position_text'(_____2, _____1)), 'true').
':-'('<module>:emop.message$has_predicate'('format'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.message$has_predicate'('error'(_____1)), 'true').
':-'('<module>:emop.message$has_predicate'('warning'(_____2, _____1)), 'true').
':-'('<module>:emop.message:$sgn'(__36sgn, 'env'(_HasWarningRef), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/message.mpl',0,0,0)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/message.mpl',39,0,0)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','(','(','(','(','(','(','(','(','(','(','('true', '<module>:emop.message:atom_fresh_[1480]'(_atom__fresh___911481_93, __36Pb, __36Pe)), '<module>:emop.message:atom_fresh_[1482]'(_atom__fresh___911483_93, __36Pb, __36Pe)), '<module>:emop.message:atom_fresh_[1484]'(_atom__fresh___911485_93, __36Pb, __36Pe)), '<module>:emop.message:atom_fresh_[1486]'(_atom__fresh___911487_93, __36Pb, __36Pe)), '<module>:emop.message:atom_fresh_[1488]'(_atom__fresh___911489_93, __36Pb, __36Pe)), '<module>:emop.message:atom_fresh_[1490]'(_atom__fresh___911491_93, __36Pb, __36Pe)), '<module>:emop.message:atom_fresh_[1492]'(_atom__fresh___911493_93, __36Pb, __36Pe)), '<module>:emop.message:atom_fresh_[1494]'(_atom__fresh___911495_93, __36Pb, __36Pe)), '<module>:emop.message:atom_fresh_[1496]'(_atom__fresh___911497_93, __36Pb, __36Pe)), '<module>:emop.message:atom_fresh_[1498]'(_atom__fresh___911499_93, __36Pb, __36Pe)), '<module>:emop.message:atom_fresh_[1500]'(_atom__fresh___911501_93, __36Pb, __36Pe)), '<module>:emop.message:atom_fresh_[1502]'(_atom__fresh___911503_93, __36Pb, __36Pe)), '<module>:emop.message:atom_fresh_[1504]'(_atom__fresh___911505_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___911505_93, '.'(_atom__fresh___911503_93, '.'(_atom__fresh___911501_93, '.'(_atom__fresh___911499_93, '.'(_atom__fresh___911497_93, '.'(_atom__fresh___911495_93, '.'(_atom__fresh___911493_93, '.'(_atom__fresh___911491_93, '.'(_atom__fresh___911489_93, '.'(_atom__fresh___911487_93, '.'(_atom__fresh___911485_93, '.'(_atom__fresh___911483_93, '.'(_atom__fresh___911481_93, '[]'))))))))))))))))))).
':-'('<module>:emop.message:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.message:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.message:atom_fresh_[1480]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(warning, 2, predicate, suspended([var('Message'),var('Pos')],[call(scope,format,[var('Pos'),var('Message'),none]),call(var('HasWarningRef'),set,[none])]), __36pos))).
':-'('<module>:emop.message:atom_fresh_[1482]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(error, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.message:atom_fresh_[1484]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(format, 3, predicate, suspended([none,var('Message'),var('Kind')],[call(atom('io.err'),format,[none,none])]), __36pos))).
':-'('<module>:emop.message:atom_fresh_[1486]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(position_text, 2, predicate, suspended([none,var('Text')],[call(scope,catch,[none,var('_'),none])]), __36pos))).
':-'('<module>:emop.message:atom_fresh_[1488]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(line_text, 3, predicate, '[]', __36pos))).
':-'('<module>:emop.message:atom_fresh_[1490]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(reset_warning, 0, predicate, suspended([],[call(var('HasWarningRef'),set,[none])]), __36pos))).
':-'('<module>:emop.message:atom_fresh_[1492]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(has_warning, 0, predicate, suspended([],[call(var('HasWarningRef'),get,[none])]), __36pos))).
':-'('<module>:emop.message:atom_fresh_[1494]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(pos, 5, constructor, none, __36pos))).
':-'('<module>:emop.message:atom_fresh_[1496]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(error, 3, constructor, none, __36pos))).
':-'('<module>:emop.message:atom_fresh_[1498]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(system_error, 2, constructor, none, __36pos))).
':-'('<module>:emop.message:atom_fresh_[1500]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(cmdline, 1, constructor, none, __36pos))).
':-'('<module>:emop.message:atom_fresh_[1502]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(file, 2, constructor, none, __36pos))).
':-'('<module>:emop.message:atom_fresh_[1504]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(file, 3, constructor, none, __36pos))).
':-'('<module>:emop.message:cmdline'(___13, 'env'(_HasWarningRef), __36CutLevel), '=..'(___13, '.'('cmdline', '[]'))).
':-'('<module>:emop.message:cmdline$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.message:cmdline'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.message:error'(_Error, 'env'(_HasWarningRef), __36CutLevel), ';'('->'(','('='(_Error, 'error'(_Message, _Pos)), ','('g_read'('emop.message', '<module>:emop.message'(___125)), '<module>:emop.message:format$direct'(_Pos, _Message, 'Error', ___125))), 'true'), ';'('->'(','('='(_Error, 'error'('system_error'(_Message), _)), ','('g_read'('io.err', '<module>:io.err'(___132)), '<module>:io.err:format$direct'('System error: ~a.\n', '.'(_Message, '[]'), ___132))), 'true'), ','('g_read'('io.err', '<module>:io.err'(___137)), '<module>:io.err:format$direct'('\n[exception] ~p\n\n', '.'(_Error, '[]'), ___137))))).
':-'('<module>:emop.message:error'(___16, ___17, ___18, 'env'(_HasWarningRef), __36CutLevel), '=..'(___18, '.'('error', '.'(___16, '.'(___17, '[]'))))).
':-'('<module>:emop.message:error$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.message:error'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.message:error$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.message:error'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.message:file'(___11, ___12, 'env'(_HasWarningRef), __36CutLevel), '=..'(___12, '.'('file', '.'(___11, '[]')))).
':-'('<module>:emop.message:file'(___8, ___9, ___10, 'env'(_HasWarningRef), __36CutLevel), '=..'(___10, '.'('file', '.'(___8, '.'(___9, '[]'))))).
':-'('<module>:emop.message:file$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.message:file'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.message:file$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.message:file'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.message:format'('cmdline', _Message, _Kind, 'env'(_HasWarningRef), __36CutLevel), ','('g_read'('io.err', '<module>:io.err'(___97)), '<module>:io.err:format$direct'('[~a] ~a\n', '.'(_Kind, '.'(_Message, '[]')), ___97))).
':-'('<module>:emop.message:format'('file'(_File), _Message, _Kind, 'env'(_HasWarningRef), __36CutLevel), ','(';'('->'('='(_File, ''), 'true'), ','('g_read'('io.err', '<module>:io.err'(___104)), '<module>:io.err:format$direct'('File ~a:\n', '.'(_File, '[]'), ___104))), ','('g_read'('io.err', '<module>:io.err'(___110)), '<module>:io.err:format$direct'('[~a] ~a\n\n', '.'(_Kind, '.'(_Message, '[]')), ___110)))).
':-'('<module>:emop.message:format'('file'(_Pb, _Pe), _Message, _Kind, 'env'(_HasWarningRef), __36CutLevel), ','(','('g_read'('emop.message', '<module>:emop.message'(___117)), '<module>:emop.message:position_text$direct'('file'(_Pb, _Pe), ___116, ___117)), ','('g_read'('io.err', '<module>:io.err'(___122)), '<module>:io.err:format$direct'('~a:\n[~a] ~a\n\n', '.'(___116, '.'(_Kind, '.'(_Message, '[]'))), ___122)))).
':-'('<module>:emop.message:format$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.message:format'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.message:has_warning'('env'(_HasWarningRef), __36CutLevel), 'emop_call'(_HasWarningRef, 'get'('true'), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/message.mpl\", line 5, from character 20 to 23')).
':-'('<module>:emop.message:has_warning$direct'(__36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.message:has_warning'(__36env, __36CutLevel))).
':-'('<module>:emop.message:line_text'('file'(_Pb, _Pe), _Initial, _Text, 'env'(_HasWarningRef), __36CutLevel), ','('='(_Pb, 'pos'(___Filename0, _Off0, _Line0, _BOL0)), ','('='(_Pe, 'pos'(___Filename1, _Off1, _Line1, _BOL1)), ','(','('g_read'('data.number', '<module>:data.number'(___30)), '<module>:data.number:succ$direct'(_Line0, _SLine0, ___30)), ','(','('g_read'('data.number', '<module>:data.number'(___32)), '<module>:data.number:-$direct'(_Off0, _BOL0, _C0, ___32)), ','(','('g_read'('data.number', '<module>:data.number'(___34)), '<module>:data.number:-$direct'(_Off1, _BOL1, _C1, ___34)), ';'('->'('='(_Line0, _Line1), ';'('->'('='(_Initial, 'uppercase'), ','('g_read'('data.atom', '<module>:data.atom'(___42)), '<module>:data.atom:format$direct'('Line ~d, from character ~d to ~d', '.'(_SLine0, '.'(_C0, '.'(_C1, '[]'))), _Text, ___42))), '->'('='(_Initial, 'lowercase'), ','('g_read'('data.atom', '<module>:data.atom'(___50)), '<module>:data.atom:format$direct'('line ~d, from character ~d to ~d', '.'(_SLine0, '.'(_C0, '.'(_C1, '[]'))), _Text, ___50))))), ','(','('g_read'('data.number', '<module>:data.number'(___52)), '<module>:data.number:succ$direct'(_Line1, _SLine1, ___52)), ';'('->'('='(_Initial, 'uppercase'), ','('g_read'('data.atom', '<module>:data.atom'(___61)), '<module>:data.atom:format$direct'('From line ~d character ~d to line ~d character ~d', '.'(_SLine0, '.'(_C0, '.'(_SLine1, '.'(_C1, '[]')))), _Text, ___61))), '->'('='(_Initial, 'lowercase'), ','('g_read'('data.atom', '<module>:data.atom'(___70)), '<module>:data.atom:format$direct'('from line ~d character ~d to line ~d character ~d', '.'(_SLine0, '.'(_C0, '.'(_SLine1, '.'(_C1, '[]')))), _Text, ___70)))))))))))).
':-'('<module>:emop.message:line_text$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.message:line_text'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.message:pos'(___19, ___20, ___21, ___22, ___23, 'env'(_HasWarningRef), __36CutLevel), '=..'(___23, '.'('pos', '.'(___19, '.'(___20, '.'(___21, '.'(___22, '[]'))))))).
':-'('<module>:emop.message:pos$direct'(_____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.message:pos'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.message:position_text'('file'(_Pb, _Pe), _Text, 'env'(_HasWarningRef), __36CutLevel), 'catch'(','('='(_Pb, 'pos'(_Filename0, ___Off0, ___Line0, ___BOL0)), ','('='(_Pe, 'pos'(_Filename1, ___Off1, ___Line1, ___BOL1)), ','(';'('->'('='(_Filename0, _Filename1), 'true'), 'throw'('error_across_two_files')), ';'('->'('='(_Filename0, ''), ','('='(_Text, ___78), ','('g_read'('emop.message', '<module>:emop.message'(___79)), '<module>:emop.message:line_text$direct'('file'(_Pb, _Pe), 'uppercase', ___78, ___79)))), ','(','('g_read'('emop.message', '<module>:emop.message'(___85)), '<module>:emop.message:line_text$direct'('file'(_Pb, _Pe), 'lowercase', ___84, ___85)), ','('g_read'('data.atom', '<module>:data.atom'(___89)), '<module>:data.atom:format$direct'('File \"~a\", ~a', '.'(_Filename0, '.'(___84, '[]')), _Text, ___89))))))), _, '='(_Text, 'At unknown position'))).
':-'('<module>:emop.message:position_text$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.message:position_text'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.message:reset_warning'('env'(_HasWarningRef), __36CutLevel), 'emop_call'(_HasWarningRef, 'set'('false'), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/message.mpl\", line 8, from character 20 to 23')).
':-'('<module>:emop.message:reset_warning$direct'(__36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.message:reset_warning'(__36env, __36CutLevel))).
':-'('<module>:emop.message:system_error'(___14, ___15, 'env'(_HasWarningRef), __36CutLevel), '=..'(___15, '.'('system_error', '.'(___14, '[]')))).
':-'('<module>:emop.message:system_error$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.message:system_error'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.message:warning'(_Message, _Pos, 'env'(_HasWarningRef), __36CutLevel), ','(','('g_read'('emop.message', '<module>:emop.message'(___139)), '<module>:emop.message:format$direct'(_Pos, _Message, 'Warning', ___139)), 'emop_call'(_HasWarningRef, 'set'('true'), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/message.mpl\", line 121, from character 20 to 23'))).
':-'('<module>:emop.message:warning$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.message:warning'(_____2, _____1, __36env, __36CutLevel))).
':-'('emop.message@init', ','(','('true', 'g_link'('emop.message', '<module>:emop.message'('env'(_HasWarningRef)))), ','('='(_HasWarningRef, ___6), ','('g_read'('data.ref.non_backtrackable', '<module>:data.ref.non_backtrackable'(___7)), '<module>:data.ref.non_backtrackable:new$direct'('false', ___6, ___7))))).
':-'('dynamic'('/'('<module>:emop.parse$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.parse@4$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.parse@3$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.parse@2$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.parse@1$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.parse@0$dynamic', 4))).
':-'('<module>:emop.parse'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parse:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse'('atom'(_____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parse:atom'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse'('unescaped'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parse:unescaped'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse'('operator'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parse:operator'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse'('error'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parse:error'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse'('none'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parse:none'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse'('doc'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parse:doc'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse'('empty'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parse:empty'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse'('number'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parse:number'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse'('module'(_____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parse:module'(_____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse'('callable'(_____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parse:callable'(_____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse'('position'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parse:position'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse'('file'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parse:file'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse'('stream'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parse:stream'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse'('term'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parse:term'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse'('reparse'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parse:reparse'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse'('reparse_flat'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parse:reparse_flat'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse'('reflat_append'(_____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parse:reflat_append'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse'('reflat'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parse:reflat'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse'('reflat_list'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parse:reflat_list'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse'('enum_concat_list'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parse:enum_concat_list'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse'('decompose_pos'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parse:decompose_pos'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse'('reconcat_list'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parse:reconcat_list'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse'('fv'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parse:fv'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse'('fv_list'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parse:fv_list'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.parse$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.parse$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.parse$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.parse$has_predicate'('atom'(_____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parse$has_predicate'('unescaped'(_____1)), 'true').
':-'('<module>:emop.parse$has_predicate'('operator'(_____1)), 'true').
':-'('<module>:emop.parse$has_predicate'('error'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.parse$has_predicate'('none'(_____1)), 'true').
':-'('<module>:emop.parse$has_predicate'('doc'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parse$has_predicate'('empty'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.parse$has_predicate'('number'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parse$has_predicate'('module'(_____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parse$has_predicate'('callable'(_____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parse$has_predicate'('position'(_____2, _____1)), 'true').
':-'('<module>:emop.parse$has_predicate'('file'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.parse$has_predicate'('stream'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parse$has_predicate'('term'(_____2, _____1)), 'true').
':-'('<module>:emop.parse$has_predicate'('reparse'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.parse$has_predicate'('reparse_flat'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.parse$has_predicate'('reflat_append'(_____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parse$has_predicate'('reflat'(_____2, _____1)), 'true').
':-'('<module>:emop.parse$has_predicate'('reflat_list'(_____2, _____1)), 'true').
':-'('<module>:emop.parse$has_predicate'('enum_concat_list'(_____2, _____1)), 'true').
':-'('<module>:emop.parse$has_predicate'('decompose_pos'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.parse$has_predicate'('reconcat_list'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.parse$has_predicate'('fv'(_____2, _____1)), 'true').
':-'('<module>:emop.parse$has_predicate'('fv_list'(_____2, _____1)), 'true').
':-'('<module>:emop.parse:$sgn'(__36sgn, 'env', __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parse.mpl',0,0,0)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parse.mpl',19,0,0)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','('true', '<module>:emop.parse:atom_fresh_[3325]'(_atom__fresh___913326_93, __36Pb, __36Pe)), '<module>:emop.parse:atom_fresh_[3327]'(_atom__fresh___913328_93, __36Pb, __36Pe)), '<module>:emop.parse:atom_fresh_[3329]'(_atom__fresh___913330_93, __36Pb, __36Pe)), '<module>:emop.parse:atom_fresh_[3331]'(_atom__fresh___913332_93, __36Pb, __36Pe)), '<module>:emop.parse:atom_fresh_[3333]'(_atom__fresh___913334_93, __36Pb, __36Pe)), '<module>:emop.parse:atom_fresh_[3335]'(_atom__fresh___913336_93, __36Pb, __36Pe)), '<module>:emop.parse:atom_fresh_[3337]'(_atom__fresh___913338_93, __36Pb, __36Pe)), '<module>:emop.parse:atom_fresh_[3339]'(_atom__fresh___913340_93, __36Pb, __36Pe)), '<module>:emop.parse:atom_fresh_[3341]'(_atom__fresh___913342_93, __36Pb, __36Pe)), '<module>:emop.parse:atom_fresh_[3343]'(_atom__fresh___913344_93, __36Pb, __36Pe)), '<module>:emop.parse:atom_fresh_[3345]'(_atom__fresh___913346_93, __36Pb, __36Pe)), '<module>:emop.parse:atom_fresh_[3347]'(_atom__fresh___913348_93, __36Pb, __36Pe)), '<module>:emop.parse:atom_fresh_[3349]'(_atom__fresh___913350_93, __36Pb, __36Pe)), '<module>:emop.parse:atom_fresh_[3351]'(_atom__fresh___913352_93, __36Pb, __36Pe)), '<module>:emop.parse:atom_fresh_[3353]'(_atom__fresh___913354_93, __36Pb, __36Pe)), '<module>:emop.parse:atom_fresh_[3355]'(_atom__fresh___913356_93, __36Pb, __36Pe)), '<module>:emop.parse:atom_fresh_[3357]'(_atom__fresh___913358_93, __36Pb, __36Pe)), '<module>:emop.parse:atom_fresh_[3359]'(_atom__fresh___913360_93, __36Pb, __36Pe)), '<module>:emop.parse:atom_fresh_[3361]'(_atom__fresh___913362_93, __36Pb, __36Pe)), '<module>:emop.parse:atom_fresh_[3363]'(_atom__fresh___913364_93, __36Pb, __36Pe)), '<module>:emop.parse:atom_fresh_[3365]'(_atom__fresh___913366_93, __36Pb, __36Pe)), '<module>:emop.parse:atom_fresh_[3367]'(_atom__fresh___913368_93, __36Pb, __36Pe)), '<module>:emop.parse:atom_fresh_[3369]'(_atom__fresh___913370_93, __36Pb, __36Pe)), '<module>:emop.parse:atom_fresh_[3371]'(_atom__fresh___913372_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913372_93, '.'(_atom__fresh___913370_93, '.'(_atom__fresh___913368_93, '.'(_atom__fresh___913366_93, '.'(_atom__fresh___913364_93, '.'(_atom__fresh___913362_93, '.'(_atom__fresh___913360_93, '.'(_atom__fresh___913358_93, '.'(_atom__fresh___913356_93, '.'(_atom__fresh___913354_93, '.'(_atom__fresh___913352_93, '.'(_atom__fresh___913350_93, '.'(_atom__fresh___913348_93, '.'(_atom__fresh___913346_93, '.'(_atom__fresh___913344_93, '.'(_atom__fresh___913342_93, '.'(_atom__fresh___913340_93, '.'(_atom__fresh___913338_93, '.'(_atom__fresh___913336_93, '.'(_atom__fresh___913334_93, '.'(_atom__fresh___913332_93, '.'(_atom__fresh___913330_93, '.'(_atom__fresh___913328_93, '.'(_atom__fresh___913326_93, '[]')))))))))))))))))))))))))))))).
':-'('<module>:emop.parse:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parse:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse:atom'(___4, ___5, ___6, ___7, ___8, 'env', __36CutLevel), '=..'(___8, '.'('atom', '.'(___4, '.'(___5, '.'(___6, '.'(___7, '[]'))))))).
':-'('<module>:emop.parse:atom$direct'(_____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parse:atom'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse:atom_fresh_[3325]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fv_list, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.parse:atom_fresh_[3327]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fv, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.parse:atom_fresh_[3329]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(reconcat_list, 3, predicate, suspended([none,var('_Pos'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.parse:atom_fresh_[3331]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(decompose_pos, 3, predicate, '[]', __36pos))).
':-'('<module>:emop.parse:atom_fresh_[3333]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(enum_concat_list, 2, predicate, suspended([none,none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.parse:atom_fresh_[3335]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(reflat_list, 2, predicate, suspended([none,none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.parse:atom_fresh_[3337]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(reflat, 2, predicate, suspended([none,none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.parse:atom_fresh_[3339]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(reflat_append, 5, predicate, suspended([none,var('C'),var('Pb'),var('Pe'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.parse:atom_fresh_[3341]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(reparse_flat, 3, predicate, '[]', __36pos))).
':-'('<module>:emop.parse:atom_fresh_[3343]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(reparse, 3, predicate, suspended([var('Ast0'),var('Grammar'),var('Ast1')],[call(scope,reparse_flat,[none,var('Grammar'),var('Ast1')])]), __36pos))).
':-'('<module>:emop.parse:atom_fresh_[3345]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(term, 2, predicate, suspended([none,none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.parse:atom_fresh_[3347]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(stream, 4, predicate, '[]', __36pos))).
':-'('<module>:emop.parse:atom_fresh_[3349]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(file, 3, predicate, '[]', __36pos))).
':-'('<module>:emop.parse:atom_fresh_[3351]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(position, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.parse:atom_fresh_[3353]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(callable, 6, constructor, none, __36pos))).
':-'('<module>:emop.parse:atom_fresh_[3355]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(module, 8, constructor, none, __36pos))).
':-'('<module>:emop.parse:atom_fresh_[3357]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(number, 4, constructor, none, __36pos))).
':-'('<module>:emop.parse:atom_fresh_[3359]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(empty, 3, constructor, none, __36pos))).
':-'('<module>:emop.parse:atom_fresh_[3361]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(doc, 4, constructor, none, __36pos))).
':-'('<module>:emop.parse:atom_fresh_[3363]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(none, 1, constructor, none, __36pos))).
':-'('<module>:emop.parse:atom_fresh_[3365]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(error, 3, constructor, none, __36pos))).
':-'('<module>:emop.parse:atom_fresh_[3367]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(operator, 1, constructor, none, __36pos))).
':-'('<module>:emop.parse:atom_fresh_[3369]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(unescaped, 1, constructor, none, __36pos))).
':-'('<module>:emop.parse:atom_fresh_[3371]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(atom, 5, constructor, none, __36pos))).
':-'('<module>:emop.parse:callable'(___34, ___35, ___36, ___37, ___38, ___39, 'env', __36CutLevel), '=..'(___39, '.'('callable', '.'(___34, '.'(___35, '.'(___36, '.'(___37, '.'(___38, '[]')))))))).
':-'('<module>:emop.parse:callable$direct'(_____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parse:callable'(_____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse:decompose_pos'('file'(_Pb, _Pe), _Pb, _Pe, 'env', __36CutLevel), ','('true', ','('='(__36CutLevel, '$cut'), '!'))).
':-'('<module>:emop.parse:decompose_pos'(_, 'dummy', 'dummy', 'env', __36CutLevel), 'true').
':-'('<module>:emop.parse:decompose_pos$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parse:decompose_pos'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse:doc'(___15, ___16, ___17, ___18, 'env', __36CutLevel), '=..'(___18, '.'('doc', '.'(___15, '.'(___16, '.'(___17, '[]')))))).
':-'('<module>:emop.parse:doc$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parse:doc'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse:empty'(___19, ___20, ___21, 'env', __36CutLevel), '=..'(___21, '.'('empty', '.'(___19, '.'(___20, '[]'))))).
':-'('<module>:emop.parse:empty$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parse:empty'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse:enum_concat_list'('callable'('$~$', 'operator', '.'(_A, '.'(_B, '[]')), _, _), '.'(_A, ___205), 'env', __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','('g_read'('emop.parse', '<module>:emop.parse'(___206)), '<module>:emop.parse:enum_concat_list$direct'(_B, ___205, ___206)))).
':-'('<module>:emop.parse:enum_concat_list'(_A, '.'(_A, '[]'), 'env', __36CutLevel), 'true').
':-'('<module>:emop.parse:enum_concat_list$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parse:enum_concat_list'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse:error'(___11, ___12, ___13, 'env', __36CutLevel), '=..'(___13, '.'('error', '.'(___11, '.'(___12, '[]'))))).
':-'('<module>:emop.parse:error$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parse:error'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse:file'(_Filename, _Grammar, _Ast, 'env', __36CutLevel), ','(','('g_read'('io.file', '<module>:io.file'(___55)), '<module>:io.file:open_read$direct'(_Filename, _Stream, ___55)), ','(','('g_read'('emop.parse', '<module>:emop.parse'(___56)), '<module>:emop.parse:stream$direct'(_Filename, _Stream, _Grammar, _Ast, ___56)), 'emop_call'(_Stream, 'close', 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parse.mpl\", line 16, from character 13 to 18')))).
':-'('<module>:emop.parse:file$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parse:file'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse:fv'('callable'(_Atom, _Escaped, _Args, _, _), _V, 'env', __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ';'('->'(','('g_read'('emop.parser', '<module>:emop.parser'(___227)), '<module>:emop.parser:is_variable$direct'(_Atom, _Escaped, _Args, ___227)), ';'('->'('='(_Atom, '_'), '='(_V, '[]')), '='(_V, '.'(_Atom, '[]')))), ','('g_read'('emop.parse', '<module>:emop.parse'(___232)), '<module>:emop.parse:fv_list$direct'(_Args, _V, ___232))))).
':-'('<module>:emop.parse:fv'('()'(_X, _, _), _V, 'env', __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','('g_read'('emop.parse', '<module>:emop.parse'(___234)), '<module>:emop.parse:fv$direct'(_X, _V, ___234)))).
':-'('<module>:emop.parse:fv'('.()'(_X, _Y, _, _), _V, 'env', __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','(','('g_read'('emop.parse', '<module>:emop.parse'(___236)), '<module>:emop.parse:fv$direct'(_X, _VX, ___236)), ','(','('g_read'('emop.parse', '<module>:emop.parse'(___237)), '<module>:emop.parse:fv$direct'(_Y, _VY, ___237)), ','('g_read'('data.list', '<module>:data.list'(___240)), '<module>:data.list:merge$direct'(_VX, _VY, 'data.term', _V, ___240)))))).
':-'('<module>:emop.parse:fv'('module'(_Name, _Env, _, _, _, _, _), _V, 'env', __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','(';'('->'(','('='(_Name, 'atom'(_Title, _Escaped, _, _)), ','(','('g_read'('emop.parser', '<module>:emop.parser'(___245)), '<module>:emop.parser:is_variable$direct'(_Title, _Escaped, 'none', ___245)), '\\='(_Title, '_'))), '='(_V0, '.'(_Title, '[]'))), '='(_V0, '[]')), ';'('->'('='(_Env, 'none'), '='(_V, _V0)), ','(','('='(_V1, ___258), ','(','('true', ';'('->'('var'(___252), ','('g_inc'('$module_count', ___253), '='(___252, '$module'(___253, '.'('<module>:emop.parse@4'('env'(___252, _Env, _Escaped, _Name, _Title, _V, _V0, _V1)), '[]'), '.'(___252, '[]'))))), ','('='(___252, '$module'(___253, ___254, _)), ','('='('.'(___255, ___256), ___254), ','('setarg'(1, ___254, '<module>:emop.parse@4'('env'(___252, _Env, _Escaped, _Name, _Title, _V, _V0, _V1))), 'setarg'(2, ___254, '.'(___255, ___256))))))), ','('g_read'('data.list', '<module>:data.list'(___259)), '<module>:data.list:morph$direct'(_Env, ___252, ___258, ___259)))), ','('='(_V, ___264), ','(','('g_read'('data.list', '<module>:data.list'(___262)), '<module>:data.list:++$direct'(_V0, _V1, ___261, ___262)), ','('g_read'('data.list', '<module>:data.list'(___265)), '<module>:data.list:merge_sort$direct'(___261, 'data.term', ___264, ___265))))))))).
':-'('<module>:emop.parse:fv'(_, '[]', 'env', __36CutLevel), 'true').
':-'('<module>:emop.parse:fv$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parse:fv'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse:fv_list'('none', '[]', 'env', __36CutLevel), 'true').
':-'('<module>:emop.parse:fv_list'('[]', '[]', 'env', __36CutLevel), 'true').
':-'('<module>:emop.parse:fv_list'('.'(_H, _T), _V, 'env', __36CutLevel), ','(','('g_read'('emop.parse', '<module>:emop.parse'(___272)), '<module>:emop.parse:fv$direct'(_H, _V0, ___272)), ','(','('g_read'('emop.parse', '<module>:emop.parse'(___273)), '<module>:emop.parse:fv_list$direct'(_T, _V1, ___273)), ','('g_read'('data.list', '<module>:data.list'(___276)), '<module>:data.list:merge$direct'(_V0, _V1, 'data.term', _V, ___276))))).
':-'('<module>:emop.parse:fv_list$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parse:fv_list'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse:module'(___26, ___27, ___28, ___29, ___30, ___31, ___32, ___33, 'env', __36CutLevel), '=..'(___33, '.'('module', '.'(___26, '.'(___27, '.'(___28, '.'(___29, '.'(___30, '.'(___31, '.'(___32, '[]')))))))))).
':-'('<module>:emop.parse:module$direct'(_____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parse:module'(_____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse:none'(___14, 'env', __36CutLevel), '=..'(___14, '.'('none', '[]'))).
':-'('<module>:emop.parse:none$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parse:none'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse:number'(___22, ___23, ___24, ___25, 'env', __36CutLevel), '=..'(___25, '.'('number', '.'(___22, '.'(___23, '.'(___24, '[]')))))).
':-'('<module>:emop.parse:number$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parse:number'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse:operator'(___10, 'env', __36CutLevel), '=..'(___10, '.'('operator', '[]'))).
':-'('<module>:emop.parse:operator$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parse:operator'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse:position'('callable'(___F, ___Escaped, ___Args, _Pb, _Pe), 'file'(_Pb, _Pe), 'env', __36CutLevel), 'true').
':-'('<module>:emop.parse:position'('()'(___Term, _Pb, _Pe), 'file'(_Pb, _Pe), 'env', __36CutLevel), 'true').
':-'('<module>:emop.parse:position'('.()'(___M, ___Term, _Pb, _Pe), 'file'(_Pb, _Pe), 'env', __36CutLevel), 'true').
':-'('<module>:emop.parse:position'('module'(___Name, ___Env, ___Body, ___Sgn, ___Clauses, _Pb, _Pe), 'file'(_Pb, _Pe), 'env', __36CutLevel), 'true').
':-'('<module>:emop.parse:position'('number'(_, _Pb, _Pe), 'file'(_Pb, _Pe), 'env', __36CutLevel), 'true').
':-'('<module>:emop.parse:position'('empty'(_Pb, _Pe), 'file'(_Pb, _Pe), 'env', __36CutLevel), 'true').
':-'('<module>:emop.parse:position'('doc'(_, _Pb, _Pe), 'file'(_Pb, _Pe), 'env', __36CutLevel), 'true').
':-'('<module>:emop.parse:position$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parse:position'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse:reconcat_list'('.'(_A, '[]'), ___Pos, _A, 'env', __36CutLevel), ','('true', ','('='(__36CutLevel, '$cut'), '!'))).
':-'('<module>:emop.parse:reconcat_list'('.'(_A, _B), _Pos, 'callable'('$~$', 'operator', '.'(_A, '.'(___219, '[]')), _Pb, _Pe), 'env', __36CutLevel), ','(','('g_read'('emop.parse', '<module>:emop.parse'(___216)), '<module>:emop.parse:decompose_pos$direct'(_Pos, _Pb, _Pe, ___216)), ','('g_read'('emop.parse', '<module>:emop.parse'(___220)), '<module>:emop.parse:reconcat_list$direct'(_B, _Pos, ___219, ___220)))).
':-'('<module>:emop.parse:reconcat_list$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parse:reconcat_list'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse:reflat'('callable'('$~$', 'operator', '.'(_A, '.'(_B, '[]')), _Pb, _Pe), ___148, 'env', __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','(','(','('g_read'('emop.parse', '<module>:emop.parse'(___145)), '<module>:emop.parse:reflat$direct'(_A, ___144, ___145)), ','('g_read'('emop.parse', '<module>:emop.parse'(___147)), '<module>:emop.parse:reflat$direct'(_B, ___146, ___147))), ','('g_read'('emop.parse', '<module>:emop.parse'(___149)), '<module>:emop.parse:reflat_append$direct'(___144, ___146, _Pb, _Pe, ___148, ___149))))).
':-'('<module>:emop.parse:reflat'('callable'(_F, 'operator', '.'(_A, '.'(_B, '[]')), _Pb, _Pe), ___168, 'env', __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','(','(','('g_read'('emop.parse', '<module>:emop.parse'(___156)), '<module>:emop.parse:reflat$direct'(_A, ___155, ___156)), ','('g_read'('emop.parse', '<module>:emop.parse'(___163)), '<module>:emop.parse:reflat$direct'(_B, ___162, ___163))), ','('g_read'('emop.parse', '<module>:emop.parse'(___169)), '<module>:emop.parse:reflat_append$direct'(___155, 'callable'('$~$', 'operator', '.'('callable'(_F, 'unescaped', 'none', _Pb, _Pe), '.'(___162, '[]')), _Pb, _Pe), _Pb, _Pe, ___168, ___169))))).
':-'('<module>:emop.parse:reflat'('callable'(_F, _Escaped, _Args, _Pb, _Pe), 'callable'(_F, _Escaped, ___171, _Pb, _Pe), 'env', __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','('g_read'('emop.parse', '<module>:emop.parse'(___172)), '<module>:emop.parse:reflat_list$direct'(_Args, ___171, ___172)))).
':-'('<module>:emop.parse:reflat'('()'(_Sub, _Pb, _Pe), '()'(___175, _Pb, _Pe), 'env', __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','('g_read'('emop.parse', '<module>:emop.parse'(___176)), '<module>:emop.parse:reflat$direct'(_Sub, ___175, ___176)))).
':-'('<module>:emop.parse:reflat'('.()'(_A, _B, _Pb, _Pe), ___182, 'env', __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','(','('g_read'('emop.parse', '<module>:emop.parse'(___180)), '<module>:emop.parse:reflat$direct'(_A, ___179, ___180)), ','('g_read'('emop.parse', '<module>:emop.parse'(___183)), '<module>:emop.parse:reflat_append$direct'(___179, '.()'(_B, _Pb, _Pe), _Pb, _Pe, ___182, ___183))))).
':-'('<module>:emop.parse:reflat'('module'(_Name, _Env, _Body, _Sgn, _Clauses, _Pb, _Pe), 'module'(_Name, ___185, _Body, _Sgn, _Clauses, _Pb, _Pe), 'env', __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','('g_read'('emop.parse', '<module>:emop.parse'(___186)), '<module>:emop.parse:reflat_list$direct'(_Env, ___185, ___186)))).
':-'('<module>:emop.parse:reflat'(_A, _A, 'env', __36CutLevel), 'true').
':-'('<module>:emop.parse:reflat$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parse:reflat'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse:reflat_append'('callable'('$~$', 'operator', '.'(_A, '.'(_B, '[]')), _Pb0, _Pe0), _C, _Pb, _Pe, ___130, 'env', __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','(','('g_read'('emop.parse', '<module>:emop.parse'(___129)), '<module>:emop.parse:reflat_append$direct'(_B, _C, _Pb0, _Pe0, ___128, ___129)), ','('g_read'('emop.parse', '<module>:emop.parse'(___131)), '<module>:emop.parse:reflat_append$direct'(_A, ___128, _Pb, _Pe, ___130, ___131))))).
':-'('<module>:emop.parse:reflat_append'(_A, _B, _Pb, _Pe, 'callable'('$~$', 'operator', '.'(_A, '.'(_B, '[]')), _Pb, _Pe), 'env', __36CutLevel), 'true').
':-'('<module>:emop.parse:reflat_append$direct'(_____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parse:reflat_append'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse:reflat_list'('none', 'none', 'env', __36CutLevel), ','('true', ','('='(__36CutLevel, '$cut'), '!'))).
':-'('<module>:emop.parse:reflat_list'(_L, ___197, 'env', __36CutLevel), ','(','('true', ';'('->'('var'(___191), ','('g_inc'('$module_count', ___192), '='(___191, '$module'(___192, '.'('<module>:emop.parse@3'('env'(___191, _L)), '[]'), '.'(___191, '[]'))))), ','('='(___191, '$module'(___192, ___193, _)), ','('='('.'(___194, ___195), ___193), ','('setarg'(1, ___193, '<module>:emop.parse@3'('env'(___191, _L))), 'setarg'(2, ___193, '.'(___194, ___195))))))), ','('g_read'('data.list', '<module>:data.list'(___198)), '<module>:data.list:iter$direct'(_L, ___191, ___197, ___198)))).
':-'('<module>:emop.parse:reflat_list$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parse:reflat_list'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse:reparse'(_Ast0, _Grammar, _Ast1, 'env', __36CutLevel), ','(','('g_read'('emop.parse', '<module>:emop.parse'(___99)), '<module>:emop.parse:reflat$direct'(_Ast0, ___98, ___99)), ','('g_read'('emop.parse', '<module>:emop.parse'(___100)), '<module>:emop.parse:reparse_flat$direct'(___98, _Grammar, _Ast1, ___100)))).
':-'('<module>:emop.parse:reparse$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parse:reparse'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse:reparse_flat'(_Ast0, _Grammar, _Ast1, 'env', __36CutLevel), ','(','('='(_Grammars, ___108), ','(','('true', ';'('->'('var'(___102), ','('g_inc'('$module_count', ___103), '='(___102, '$module'(___103, '.'('<module>:emop.parse@1'('env'(___102, _Ast0, _Ast1, _Grammar, _Grammars, _Grammars_39)), '[]'), '.'(___102, '[]'))))), ','('='(___102, '$module'(___103, ___104, _)), ','('='('.'(___105, ___106), ___104), ','('setarg'(1, ___104, '<module>:emop.parse@1'('env'(___102, _Ast0, _Ast1, _Grammar, _Grammars, _Grammars_39))), 'setarg'(2, ___104, '.'(___105, ___106))))))), ','('g_read'('control.iter', '<module>:control.iter'(___109)), '<module>:control.iter:findall$direct'(___102, ___108, ___109)))), ','(','('='(_Grammars_39, ___118), ','(','('true', ';'('->'('var'(___112), ','('g_inc'('$module_count', ___113), '='(___112, '$module'(___113, '.'('<module>:emop.parse@2'('env'(___112, _Ast0, _Ast1, _Grammar, _Grammars, _Grammars_39)), '[]'), '.'(___112, '[]'))))), ','('='(___112, '$module'(___113, ___114, _)), ','('='('.'(___115, ___116), ___114), ','('setarg'(1, ___114, '<module>:emop.parse@2'('env'(___112, _Ast0, _Ast1, _Grammar, _Grammars, _Grammars_39))), 'setarg'(2, ___114, '.'(___115, ___116))))))), ','('g_read'('data.list', '<module>:data.list'(___119)), '<module>:data.list:fold_left$direct'(_Grammars, '[]', ___112, ___118, ___119)))), ','('g_read'('emop.parser', '<module>:emop.parser'(___121)), '<module>:emop.parser:reparse_flat$direct'(_Ast0, _Grammars_39, _Ast1, ___121))))).
':-'('<module>:emop.parse:reparse_flat$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parse:reparse_flat'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse:stream'(_Filename, _Stream, _Grammar, _Ast, 'env', __36CutLevel), ','(','('g_read'('emop.parser', '<module>:emop.parser'(___59)), '<module>:emop.parser:parse_stream$direct'(_Filename, 'file', _Stream, _, _Ast0, ___59)), ','('='(_Ast, ___60), ','('g_read'('emop.parse', '<module>:emop.parse'(___61)), '<module>:emop.parse:reparse$direct'(_Ast0, _Grammar, ___60, ___61))))).
':-'('<module>:emop.parse:stream$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parse:stream'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse:term'('callable'(_F, _, _Args, _, _), ___76, 'env', __36CutLevel), ','(';'('->'('='(_Args, 'none'), '='(___63, '[]')), ','('='(___63, ___74), ','(','('true', ';'('->'('var'(___68), ','('g_inc'('$module_count', ___69), '='(___68, '$module'(___69, '.'('<module>:emop.parse@0'('env'(___68, _Args, _F)), '[]'), '.'(___68, '[]'))))), ','('='(___68, '$module'(___69, ___70, _)), ','('='('.'(___71, ___72), ___70), ','('setarg'(1, ___70, '<module>:emop.parse@0'('env'(___68, _Args, _F))), 'setarg'(2, ___70, '.'(___71, ___72))))))), ','('g_read'('data.list', '<module>:data.list'(___75)), '<module>:data.list:iter$direct'(_Args, ___68, ___74, ___75))))), ','('g_read'('data.term', '<module>:data.term'(___77)), '<module>:data.term:make$direct'(_F, ___63, ___76, ___77)))).
':-'('<module>:emop.parse:term'('()'(_Sub, _, _), ___79, 'env', __36CutLevel), ','('g_read'('emop.parse', '<module>:emop.parse'(___80)), '<module>:emop.parse:term$direct'(_Sub, ___79, ___80))).
':-'('<module>:emop.parse:term'('.()'(_, _, _, _), _, 'env', __36CutLevel), 'throw'('error'('.()', 'term'))).
':-'('<module>:emop.parse:term'('module'(_, _, _, _, _, _, _), _, 'env', __36CutLevel), 'throw'('error'('module', 'term'))).
':-'('<module>:emop.parse:term'('number'(_N, _, _), _N, 'env', __36CutLevel), 'true').
':-'('<module>:emop.parse:term'('empty'(_, _), _, 'env', __36CutLevel), 'throw'('error'('empty', 'term'))).
':-'('<module>:emop.parse:term'('doc'(_, _, _), _, 'env', __36CutLevel), 'throw'('error'('doc', 'term'))).
':-'('<module>:emop.parse:term$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parse:term'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse:unescaped'(___9, 'env', __36CutLevel), '=..'(___9, '.'('unescaped', '[]'))).
':-'('<module>:emop.parse:unescaped$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parse:unescaped'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse@0'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parse@0:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse@0'('do'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parse@0:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse@0'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.parse@0$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.parse@0$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.parse@0$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.parse@0$has_predicate'('do'(_____2, _____1)), 'true').
':-'('<module>:emop.parse@0:$sgn'(__36sgn, 'env'(___73, _Args, _F), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parse.mpl',940,24,901)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parse.mpl',952,24,901)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.parse@0:atom_fresh_[3381]'(_atom__fresh___913382_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913382_93, '[]'))))))).
':-'('<module>:emop.parse@0:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parse@0:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse@0:atom_fresh_[3381]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 2, predicate, suspended([var('X'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.parse@0:do'(_X, ___294, 'env'(___73, _Args, _F), __36CutLevel), ','('g_read'('emop.parse', '<module>:emop.parse'(___295)), '<module>:emop.parse:term$direct'(_X, ___294, ___295))).
':-'('<module>:emop.parse@0:do$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parse@0:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse@1'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parse@1:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse@1'('do'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parse@1:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse@1'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.parse@1$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.parse@1$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.parse@1$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.parse@1$has_predicate'('do'(_____1)), 'true').
':-'('<module>:emop.parse@1:$sgn'(__36sgn, 'env'(___107, _Ast0, _Ast1, _Grammar, _Grammars, _Grammars_39), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parse.mpl',1482,41,1452)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parse.mpl',1493,41,1452)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.parse@1:atom_fresh_[3379]'(_atom__fresh___913380_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913380_93, '[]'))))))).
':-'('<module>:emop.parse@1:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parse@1:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse@1:atom_fresh_[3379]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 1, predicate, suspended([none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.parse@1:do'(___293, 'env'(___107, _Ast0, _Ast1, _Grammar, _Grammars, _Grammars_39), __36CutLevel), 'emop_call'(_Grammar, '$sgn'(___293), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parse.mpl\", line 43, from character 22 to 28')).
':-'('<module>:emop.parse@1:do$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parse@1:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse@2'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parse@2:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse@2'('do'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parse@2:do'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse@2'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.parse@2$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.parse@2$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.parse@2$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.parse@2$has_predicate'('do'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.parse@2:$sgn'(__36sgn, 'env'(___117, _Ast0, _Ast1, _Grammar, _Grammars, _Grammars_39), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parse.mpl',1561,44,1533)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parse.mpl',1586,44,1533)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.parse@2:atom_fresh_[3377]'(_atom__fresh___913378_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913378_93, '[]'))))))).
':-'('<module>:emop.parse@2:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parse@2:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse@2:atom_fresh_[3377]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 3, predicate, suspended([var('Sgn'),var('Acc'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.parse@2:do'(_Sgn, _Acc, '.'(___290, _Acc), 'env'(___117, _Ast0, _Ast1, _Grammar, _Grammars, _Grammars_39), __36CutLevel), ','('g_read'('emop.parser', '<module>:emop.parser'(___291)), '<module>:emop.parser:make_grammar$direct'(_Sgn, _Acc, ___290, ___291))).
':-'('<module>:emop.parse@2:do$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parse@2:do'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse@3'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parse@3:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse@3'('do'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parse@3:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse@3'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.parse@3$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.parse@3$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.parse@3$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.parse@3$has_predicate'('do'(_____2, _____1)), 'true').
':-'('<module>:emop.parse@3:$sgn'(__36sgn, 'env'(___196, _L), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parse.mpl',2910,86,2880)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parse.mpl',2919,86,2880)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.parse@3:atom_fresh_[3375]'(_atom__fresh___913376_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913376_93, '[]'))))))).
':-'('<module>:emop.parse@3:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parse@3:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse@3:atom_fresh_[3375]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 2, predicate, suspended([var('X'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.parse@3:do'(_X, ___287, 'env'(___196, _L), __36CutLevel), ','('g_read'('emop.parse', '<module>:emop.parse'(___288)), '<module>:emop.parse:reflat$direct'(_X, ___287, ___288))).
':-'('<module>:emop.parse@3:do$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parse@3:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse@4'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parse@4:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse@4'('do'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parse@4:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse@4'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.parse@4$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.parse@4$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.parse@4$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.parse@4$has_predicate'('do'(_____2, _____1)), 'true').
':-'('<module>:emop.parse@4:$sgn'(__36sgn, 'env'(___257, _Env, _Escaped, _Name, _Title, _V, _V0, _V1), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parse.mpl',4129,140,4105)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parse.mpl',4141,140,4105)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.parse@4:atom_fresh_[3373]'(_atom__fresh___913374_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913374_93, '[]'))))))).
':-'('<module>:emop.parse@4:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parse@4:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parse@4:atom_fresh_[3373]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 2, predicate, suspended([none,none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.parse@4:do'('callable'('_', _, _, _, _), '[]', 'env'(___257, _Env, _Escaped, _Name, _Title, _V, _V0, _V1), __36CutLevel), ','('true', ','('='(__36CutLevel, '$cut'), '!'))).
':-'('<module>:emop.parse@4:do'('callable'(_Atom, _, _, _, _), '.'(_Atom, '[]'), 'env'(___257, _Env, _Escaped, _Name, _Title, _V, _V0, _V1), __36CutLevel), ','('true', ','('='(__36CutLevel, '$cut'), '!'))).
':-'('<module>:emop.parse@4:do'('()'(_Sub, _, _), '.'(_Sub, '[]'), 'env'(___257, _Env, _Escaped, _Name, _Title, _V, _V0, _V1), __36CutLevel), ','('true', ','('='(__36CutLevel, '$cut'), '!'))).
':-'('<module>:emop.parse@4:do'(_, '[]', 'env'(___257, _Env, _Escaped, _Name, _Title, _V, _V0, _V1), __36CutLevel), 'true').
':-'('<module>:emop.parse@4:do$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parse@4:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('emop.parse@init', ','('true', 'g_link'('emop.parse', '<module>:emop.parse'('env')))).
':-'('dynamic'('/'('<module>:emop.parser$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.parser@13$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.parser@12$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.parser@11$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.parser@10$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.parser@14$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.parser@9$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.parser@15$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.parser@17$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.parser@16$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.parser@18$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.parser@8$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.parser@7$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.parser@6$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.parser@5$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.parser@4$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.parser@3$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.parser@2$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.parser@1$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.parser@0$dynamic', 4))).
':-'('<module>:emop.parser'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('clause'(_____7, _____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:clause'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('notation'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:notation'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('module'(_____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:module'(_____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('operator'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:operator'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('string'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:string'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('succede'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:succede'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('xf'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:xf'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('fx'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:fx'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('yf'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:yf'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('fy'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:fy'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('xfx'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:xfx'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('this'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:this'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('repeat'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:repeat'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('!'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:!'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('fail'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:fail'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('true'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:true'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('throw'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:throw'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('setof'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:setof'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('bagof'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:bagof'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('findall'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:findall'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('for'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:for'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('catch'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:catch'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('end_of_file'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:end_of_file'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('close'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:close'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('functor'(_____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:functor'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('comment'(_____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:comment'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('colon'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:colon'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('none'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:none'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('precede'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:precede'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('error'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:error'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('doc'(_____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:doc'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('yfx'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:yfx'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('unespaced'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:unespaced'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('right'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:right'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('binary'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:binary'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('yes'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:yes'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('eol'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:eol'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('eos'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:eos'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('toplevel'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:toplevel'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('error'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:error'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('file'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:file'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('atom'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:atom'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('escaped'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:escaped'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('end_of_line'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:end_of_line'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('empty'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:empty'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('callable'(_____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:callable'(_____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('some'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:some'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('number'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:number'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('op'(_____7, _____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:op'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('doc'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:doc'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('left'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:left'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('xfy'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:xfy'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('doc'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:doc'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('variable'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:variable'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('atom'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:atom'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('atom'(_____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:atom'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('unescaped'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:unescaped'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('fresh_var'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:fresh_var'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('eliminate_parenthesis'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:eliminate_parenthesis'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('is_variable'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:is_variable'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('fresh_operator_id'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:fresh_operator_id'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('fresh_level_id'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:fresh_level_id'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('parse_file'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:parse_file'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('parse_stream'(_____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:parse_stream'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('parse'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:parse'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('internal_reparse'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:internal_reparse'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('reparse_flat'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:reparse_flat'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('remove_concat'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:remove_concat'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('grammar'(_____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:grammar'(_____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('grammar_empty'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:grammar_empty'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('reparse_list'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:reparse_list'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('symbol_list'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:symbol_list'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('find_operator'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:find_operator'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('level'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:level'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('syntax'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:syntax'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('level'(_____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:level'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('priority'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:priority'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('expand_priorities'(_____7, _____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:expand_priorities'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('expand_syntax'(_____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:expand_syntax'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('read_symbol_definition'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:read_symbol_definition'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('extract_level_scope'(_____7, _____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:extract_level_scope'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('find_level'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:find_level'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('extract_level'(_____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:extract_level'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('grammar_star'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:grammar_star'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('expand_level'(_____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:expand_level'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('operator'(_____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:operator'(_____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('add_notation'(_____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:add_notation'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('add_to_grammar'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:add_to_grammar'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'('make_grammar'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser:make_grammar'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.parser$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.parser$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.parser$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('clause'(_____7, _____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('notation'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('module'(_____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('operator'(_____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('string'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('succede'(_____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('xf'(_____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('fx'(_____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('yf'(_____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('fy'(_____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('xfx'(_____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('this'(_____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('repeat'(_____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('!'(_____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('fail'(_____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('true'(_____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('throw'(_____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('setof'(_____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('bagof'(_____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('findall'(_____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('for'(_____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('catch'(_____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('end_of_file'(_____2, _____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('close'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('functor'(_____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('comment'(_____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('colon'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('none'(_____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('precede'(_____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('error'(_____2, _____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('doc'(_____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('yfx'(_____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('unespaced'(_____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('right'(_____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('binary'(_____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('yes'(_____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('eol'(_____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('eos'(_____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('toplevel'(_____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('error'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('file'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('atom'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('escaped'(_____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('end_of_line'(_____2, _____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('empty'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('callable'(_____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('some'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('number'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('op'(_____7, _____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('doc'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('left'(_____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('xfy'(_____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('doc'(_____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('variable'(_____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('atom'(_____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('atom'(_____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('unescaped'(_____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('fresh_var'(_____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('eliminate_parenthesis'(_____2, _____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('is_variable'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('fresh_operator_id'(_____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('fresh_level_id'(_____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('parse_file'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('parse_stream'(_____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('parse'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('internal_reparse'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('reparse_flat'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('remove_concat'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('grammar'(_____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('grammar_empty'(_____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('reparse_list'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('symbol_list'(_____2, _____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('find_operator'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('level'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('syntax'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('level'(_____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('priority'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('expand_priorities'(_____7, _____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('expand_syntax'(_____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('read_symbol_definition'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('extract_level_scope'(_____7, _____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('find_level'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('extract_level'(_____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('grammar_star'(_____2, _____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('expand_level'(_____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('operator'(_____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('add_notation'(_____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('add_to_grammar'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser$has_predicate'('make_grammar'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser:!'(___40, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___40, '.'('!', '[]'))).
':-'('<module>:emop.parser:!$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:!'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:$sgn'(__36sgn, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',0,0,0)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',108,0,0)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','('true', '<module>:emop.parser:atom_fresh_[2891]'(_atom__fresh___912892_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[2893]'(_atom__fresh___912894_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[2895]'(_atom__fresh___912896_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[2897]'(_atom__fresh___912898_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[2899]'(_atom__fresh___912900_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[2901]'(_atom__fresh___912902_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[2903]'(_atom__fresh___912904_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[2905]'(_atom__fresh___912906_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[2907]'(_atom__fresh___912908_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[2909]'(_atom__fresh___912910_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[2911]'(_atom__fresh___912912_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[2913]'(_atom__fresh___912914_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[2915]'(_atom__fresh___912916_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[2917]'(_atom__fresh___912918_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[2919]'(_atom__fresh___912920_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[2921]'(_atom__fresh___912922_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[2923]'(_atom__fresh___912924_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[2925]'(_atom__fresh___912926_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[2927]'(_atom__fresh___912928_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[2929]'(_atom__fresh___912930_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[2931]'(_atom__fresh___912932_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[2933]'(_atom__fresh___912934_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[2935]'(_atom__fresh___912936_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[2937]'(_atom__fresh___912938_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[2939]'(_atom__fresh___912940_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[2941]'(_atom__fresh___912942_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[2943]'(_atom__fresh___912944_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[2945]'(_atom__fresh___912946_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[2947]'(_atom__fresh___912948_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[2949]'(_atom__fresh___912950_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[2951]'(_atom__fresh___912952_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[2953]'(_atom__fresh___912954_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[2955]'(_atom__fresh___912956_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[2957]'(_atom__fresh___912958_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[2959]'(_atom__fresh___912960_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[2961]'(_atom__fresh___912962_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[2963]'(_atom__fresh___912964_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[2965]'(_atom__fresh___912966_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[2967]'(_atom__fresh___912968_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[2969]'(_atom__fresh___912970_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[2971]'(_atom__fresh___912972_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[2973]'(_atom__fresh___912974_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[2975]'(_atom__fresh___912976_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[2977]'(_atom__fresh___912978_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[2979]'(_atom__fresh___912980_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[2981]'(_atom__fresh___912982_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[2983]'(_atom__fresh___912984_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[2985]'(_atom__fresh___912986_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[2987]'(_atom__fresh___912988_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[2989]'(_atom__fresh___912990_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[2991]'(_atom__fresh___912992_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[2993]'(_atom__fresh___912994_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[2995]'(_atom__fresh___912996_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[2997]'(_atom__fresh___912998_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[2999]'(_atom__fresh___913000_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[3001]'(_atom__fresh___913002_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[3003]'(_atom__fresh___913004_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[3005]'(_atom__fresh___913006_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[3007]'(_atom__fresh___913008_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[3009]'(_atom__fresh___913010_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[3011]'(_atom__fresh___913012_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[3013]'(_atom__fresh___913014_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[3015]'(_atom__fresh___913016_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[3017]'(_atom__fresh___913018_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[3019]'(_atom__fresh___913020_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[3021]'(_atom__fresh___913022_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[3023]'(_atom__fresh___913024_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[3025]'(_atom__fresh___913026_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[3027]'(_atom__fresh___913028_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[3029]'(_atom__fresh___913030_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[3031]'(_atom__fresh___913032_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[3033]'(_atom__fresh___913034_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[3035]'(_atom__fresh___913036_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[3037]'(_atom__fresh___913038_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[3039]'(_atom__fresh___913040_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[3041]'(_atom__fresh___913042_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[3043]'(_atom__fresh___913044_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[3045]'(_atom__fresh___913046_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[3047]'(_atom__fresh___913048_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[3049]'(_atom__fresh___913050_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[3051]'(_atom__fresh___913052_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[3053]'(_atom__fresh___913054_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[3055]'(_atom__fresh___913056_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[3057]'(_atom__fresh___913058_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[3059]'(_atom__fresh___913060_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[3061]'(_atom__fresh___913062_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[3063]'(_atom__fresh___913064_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[3065]'(_atom__fresh___913066_93, __36Pb, __36Pe)), '<module>:emop.parser:atom_fresh_[3067]'(_atom__fresh___913068_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913068_93, '.'(_atom__fresh___913066_93, '.'(_atom__fresh___913064_93, '.'(_atom__fresh___913062_93, '.'(_atom__fresh___913060_93, '.'(_atom__fresh___913058_93, '.'(_atom__fresh___913056_93, '.'(_atom__fresh___913054_93, '.'(_atom__fresh___913052_93, '.'(_atom__fresh___913050_93, '.'(_atom__fresh___913048_93, '.'(_atom__fresh___913046_93, '.'(_atom__fresh___913044_93, '.'(_atom__fresh___913042_93, '.'(_atom__fresh___913040_93, '.'(_atom__fresh___913038_93, '.'(_atom__fresh___913036_93, '.'(_atom__fresh___913034_93, '.'(_atom__fresh___913032_93, '.'(_atom__fresh___913030_93, '.'(_atom__fresh___913028_93, '.'(_atom__fresh___913026_93, '.'(_atom__fresh___913024_93, '.'(_atom__fresh___913022_93, '.'(_atom__fresh___913020_93, '.'(_atom__fresh___913018_93, '.'(_atom__fresh___913016_93, '.'(_atom__fresh___913014_93, '.'(_atom__fresh___913012_93, '.'(_atom__fresh___913010_93, '.'(_atom__fresh___913008_93, '.'(_atom__fresh___913006_93, '.'(_atom__fresh___913004_93, '.'(_atom__fresh___913002_93, '.'(_atom__fresh___913000_93, '.'(_atom__fresh___912998_93, '.'(_atom__fresh___912996_93, '.'(_atom__fresh___912994_93, '.'(_atom__fresh___912992_93, '.'(_atom__fresh___912990_93, '.'(_atom__fresh___912988_93, '.'(_atom__fresh___912986_93, '.'(_atom__fresh___912984_93, '.'(_atom__fresh___912982_93, '.'(_atom__fresh___912980_93, '.'(_atom__fresh___912978_93, '.'(_atom__fresh___912976_93, '.'(_atom__fresh___912974_93, '.'(_atom__fresh___912972_93, '.'(_atom__fresh___912970_93, '.'(_atom__fresh___912968_93, '.'(_atom__fresh___912966_93, '.'(_atom__fresh___912964_93, '.'(_atom__fresh___912962_93, '.'(_atom__fresh___912960_93, '.'(_atom__fresh___912958_93, '.'(_atom__fresh___912956_93, '.'(_atom__fresh___912954_93, '.'(_atom__fresh___912952_93, '.'(_atom__fresh___912950_93, '.'(_atom__fresh___912948_93, '.'(_atom__fresh___912946_93, '.'(_atom__fresh___912944_93, '.'(_atom__fresh___912942_93, '.'(_atom__fresh___912940_93, '.'(_atom__fresh___912938_93, '.'(_atom__fresh___912936_93, '.'(_atom__fresh___912934_93, '.'(_atom__fresh___912932_93, '.'(_atom__fresh___912930_93, '.'(_atom__fresh___912928_93, '.'(_atom__fresh___912926_93, '.'(_atom__fresh___912924_93, '.'(_atom__fresh___912922_93, '.'(_atom__fresh___912920_93, '.'(_atom__fresh___912918_93, '.'(_atom__fresh___912916_93, '.'(_atom__fresh___912914_93, '.'(_atom__fresh___912912_93, '.'(_atom__fresh___912910_93, '.'(_atom__fresh___912908_93, '.'(_atom__fresh___912906_93, '.'(_atom__fresh___912904_93, '.'(_atom__fresh___912902_93, '.'(_atom__fresh___912900_93, '.'(_atom__fresh___912898_93, '.'(_atom__fresh___912896_93, '.'(_atom__fresh___912894_93, '.'(_atom__fresh___912892_93, '[]'))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))).
':-'('<module>:emop.parser:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:add_notation'(_GrammarRef, _Grammars, _Desc, _Pb, _Pe, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), ','(','('g_read'('emop.parser', '<module>:emop.parser'(___680)), '<module>:emop.parser:extract_level_scope$direct'(_Desc, _Pb, _Pe, _LevelList, _GrammarRef, _Grammars, _Desc0, ___680)), ','(';'('->'(','(','('true', ';'('->'('var'(___681), ','('g_inc'('$module_count', ___682), '='(___681, '$module'(___682, '.'('<module>:emop.parser@7'('env'(___681, _Tail, _Pb, _Pe)), '[]'), '.'(___681, '[]'))))), ','('='(___681, '$module'(___682, ___683, _)), ','('='('.'(___684, ___685), ___683), ','('setarg'(1, ___683, '<module>:emop.parser@7'('env'(___681, _Tail, _Pb, _Pe))), 'setarg'(2, ___683, '.'(___684, ___685))))))), 'emop_call'(___681, 'cut'(_Desc0, _Head, _Guard), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1313, from character 17 to 20')), 'true'), 'throw'('error'('Notation without ->.', 'file'(_Pb, _Pe)))), ','(','('='(_Grammars1, ___692), ','('emop_call'(_GrammarRef, 'get'(___690), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1319, from character 49 to 52'), ','('g_read'('emop.parser', '<module>:emop.parser'(___693)), '<module>:emop.parser:grammar_star$direct'('.'(___690, _Grammars), ___692, ___693)))), ','(','('='(_Head0, ___698), ','(','('g_read'('emop.parse', '<module>:emop.parse'(___697)), '<module>:emop.parse:reconcat_list$direct'(_Head, 'file'(_Pb, _Pe), ___696, ___697)), ','('g_read'('emop.parser', '<module>:emop.parser'(___699)), '<module>:emop.parser:reparse_flat$direct'(___696, _Grammars1, ___698, ___699)))), ','(','('='(_Guard0, ___711), ','(','(','('g_read'('emop.parse', '<module>:emop.parse'(___704)), '<module>:emop.parse:reconcat_list$direct'(_Guard, 'file'(_Pb, _Pe), ___703, ___704)), ','('true', ';'('->'('var'(___705), ','('g_inc'('$module_count', ___706), '='(___705, '$module'(___706, '.'('<module>:emop.parser@8'('env'(___705, _ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef, _Desc, _Desc0, _Env, _GrammarRef, _Grammars, _Grammars1, _Guard, _Guard0, _Guard1, _Head, _Head0, _Head1, _InferLengthRef, _LevelList, _Notations, _Pb, _Pe, _Tail, _Tail0, _Tail1)), '[]'), '.'(___705, '[]'))))), ','('='(___705, '$module'(___706, ___707, _)), ','('='('.'(___708, ___709), ___707), ','('setarg'(1, ___707, '<module>:emop.parser@8'('env'(___705, _ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef, _Desc, _Desc0, _Env, _GrammarRef, _Grammars, _Grammars1, _Guard, _Guard0, _Guard1, _Head, _Head0, _Head1, _InferLengthRef, _LevelList, _Notations, _Pb, _Pe, _Tail, _Tail0, _Tail1))), 'setarg'(2, ___707, '.'(___708, ___709)))))))), ','('g_read'('emop.parse', '<module>:emop.parse'(___712)), '<module>:emop.parse:reparse_flat$direct'(___703, ___705, ___711, ___712)))), ','(','('='(_Tail0, ___717), ','(','('g_read'('emop.parse', '<module>:emop.parse'(___716)), '<module>:emop.parse:reconcat_list$direct'(_Tail, 'file'(_Pb, _Pe), ___715, ___716)), ','('g_read'('emop.parser', '<module>:emop.parser'(___718)), '<module>:emop.parser:reparse_flat$direct'(___715, _Grammars1, ___717, ___718)))), ','(','('='(_Env, ___720), ','('g_read'('data.record', '<module>:data.record'(___721)), '<module>:data.record:{}$direct'(___720, ___721))), ','(','('='(_InferLengthRef, ___723), ','('g_read'('data.ref.backtrackable', '<module>:data.ref.backtrackable'(___724)), '<module>:data.ref.backtrackable:new$direct'(___723, ___724))), ','(','(','('true', ';'('->'('var'(___725), ','('g_inc'('$module_count', ___726), '='(___725, '$module'(___726, '.'('<module>:emop.parser@9'('env'(___725, _Env, _InferLengthRef, _Grammars1)), '[]'), '.'(___725, '[]'))))), ','('='(___725, '$module'(___726, ___727, _)), ','('='('.'(___728, ___729), ___727), ','('setarg'(1, ___727, '<module>:emop.parser@9'('env'(___725, _Env, _InferLengthRef, _Grammars1))), 'setarg'(2, ___727, '.'(___728, ___729))))))), ','('emop_call'(___725, 'rename'('head', _Head0, _Head1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1801, from character 13 to 19'), 'emop_call'(___725, 'rename'('tail', _Tail0, _Tail1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1802, from character 13 to 19'))), ','(','(','('true', ';'('->'('var'(___733), ','('g_inc'('$module_count', ___734), '='(___733, '$module'(___734, '.'('<module>:emop.parser@10'('env'(___733, _Env)), '[]'), '.'(___733, '[]'))))), ','('='(___733, '$module'(___734, ___735, _)), ','('='('.'(___736, ___737), ___735), ','('setarg'(1, ___735, '<module>:emop.parser@10'('env'(___733, _Env))), 'setarg'(2, ___735, '.'(___736, ___737))))))), 'emop_call'(___733, 'make'(_Guard0, _Guard1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1987, from character 12 to 16')), ','(','(','('emop_call'(_InferLengthRef, 'get'(___740), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1988, from character 40 to 43'), ','('true', ';'('->'('var'(___741), ','('g_inc'('$module_count', ___742), '='(___741, '$module'(___742, '.'('<module>:emop.parser@11'('env'(___741, _Env)), '[]'), '.'(___741, '[]'))))), ','('='(___741, '$module'(___742, ___743, _)), ','('='('.'(___744, ___745), ___743), ','('setarg'(1, ___743, '<module>:emop.parser@11'('env'(___741, _Env))), 'setarg'(2, ___743, '.'(___744, ___745)))))))), ','('g_read'('data.list', '<module>:data.list'(___747)), '<module>:data.list:iter$direct'(___740, ___741, ___747))), ','('emop_call'(_GrammarRef, 'get'('grammar'(_, _, _, _, _Notations)), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1998, from character 21 to 24'), ','(','('true', ';'('->'('var'(___750), ','('g_inc'('$module_count', ___751), '='(___750, '$module'(___751, '.'('<module>:emop.parser@12'('env'(___750, _ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef, _Desc, _Desc0, _Env, _GrammarRef, _Grammars, _Grammars1, _Guard, _Guard0, _Guard1, _Head, _Head0, _Head1, _InferLengthRef, _LevelList, _Notations, _Pb, _Pe, _Tail, _Tail0, _Tail1)), '[]'), '.'(___750, '[]'))))), ','('='(___750, '$module'(___751, ___752, _)), ','('='('.'(___753, ___754), ___752), ','('setarg'(1, ___752, '<module>:emop.parser@12'('env'(___750, _ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef, _Desc, _Desc0, _Env, _GrammarRef, _Grammars, _Grammars1, _Guard, _Guard0, _Guard1, _Head, _Head0, _Head1, _InferLengthRef, _LevelList, _Notations, _Pb, _Pe, _Tail, _Tail0, _Tail1))), 'setarg'(2, ___752, '.'(___753, ___754))))))), ','('g_read'('data.list', '<module>:data.list'(___756)), '<module>:data.list:iter$direct'(_LevelList, ___750, ___756)))))))))))))))).
':-'('<module>:emop.parser:add_notation$direct'(_____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:add_notation'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:add_to_grammar'('syntax'(_Desc, _Pb, _Pe), _GrammarRef, _SupGrammars, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), ','('g_read'('emop.parser', '<module>:emop.parser'(___758)), '<module>:emop.parser:expand_syntax$direct'(_GrammarRef, _SupGrammars, _Desc, _Pb, _Pe, ___758))).
':-'('<module>:emop.parser:add_to_grammar'('level'(_Desc, _Pb, _Pe), _GrammarRef, _SupGrammars, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), ','('g_read'('emop.parser', '<module>:emop.parser'(___760)), '<module>:emop.parser:expand_level$direct'(_GrammarRef, _SupGrammars, _Desc, _Pb, _Pe, ___760))).
':-'('<module>:emop.parser:add_to_grammar'('notation'(_Desc, _Pb, _Pe), _GrammarRef, _SupGrammars, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), ','('g_read'('emop.parser', '<module>:emop.parser'(___762)), '<module>:emop.parser:add_notation$direct'(_GrammarRef, _SupGrammars, _Desc, _Pb, _Pe, ___762))).
':-'('<module>:emop.parser:add_to_grammar'('symbol'(_, _, _, _, _), ___GrammarRef, ___SupGrammars, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), 'true').
':-'('<module>:emop.parser:add_to_grammar$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:add_to_grammar'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:atom'(___131, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___131, '.'('atom', '[]'))).
':-'('<module>:emop.parser:atom'(___92, ___93, ___94, ___95, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___95, '.'('atom', '.'(___92, '.'(___93, '.'(___94, '[]')))))).
':-'('<module>:emop.parser:atom'(___132, ___133, ___134, ___135, ___136, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___136, '.'('atom', '.'(___132, '.'(___133, '.'(___134, '.'(___135, '[]'))))))).
':-'('<module>:emop.parser:atom$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:atom'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:atom$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:atom'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:atom$direct'(_____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:atom'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:atom_fresh_[2891]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(make_grammar, 3, predicate, '[]', __36pos))).
':-'('<module>:emop.parser:atom_fresh_[2893]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(add_to_grammar, 3, predicate, suspended([none,var('GrammarRef'),var('SupGrammars')],[call(scope,expand_syntax,[var('GrammarRef'),var('SupGrammars'),var('Desc'),var('Pb'),var('Pe')])]), __36pos))).
':-'('<module>:emop.parser:atom_fresh_[2895]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(add_notation, 5, predicate, '[]', __36pos))).
':-'('<module>:emop.parser:atom_fresh_[2897]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(operator, 6, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[2899]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(expand_level, 5, predicate, '[]', __36pos))).
':-'('<module>:emop.parser:atom_fresh_[2901]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(grammar_star, 2, predicate, suspended([var('Grammars'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.parser:atom_fresh_[2903]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(extract_level, 5, predicate, suspended([none,var('LevelList'),var('GrammarRef'),var('Grammars'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.parser:atom_fresh_[2905]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(find_level, 4, predicate, '[]', __36pos))).
':-'('<module>:emop.parser:atom_fresh_[2907]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(extract_level_scope, 7, predicate, '[]', __36pos))).
':-'('<module>:emop.parser:atom_fresh_[2909]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(read_symbol_definition, 3, predicate, '[]', __36pos))).
':-'('<module>:emop.parser:atom_fresh_[2911]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(expand_syntax, 5, predicate, '[]', __36pos))).
':-'('<module>:emop.parser:atom_fresh_[2913]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(expand_priorities, 7, predicate, '[]', __36pos))).
':-'('<module>:emop.parser:atom_fresh_[2915]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(priority, 3, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[2917]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(level, 5, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[2919]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(syntax, 4, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[2921]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(level, 4, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[2923]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(find_operator, 4, predicate, '[]', __36pos))).
':-'('<module>:emop.parser:atom_fresh_[2925]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(symbol_list, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.parser:atom_fresh_[2927]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(reparse_list, 3, predicate, '[]', __36pos))).
':-'('<module>:emop.parser:atom_fresh_[2929]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(grammar_empty, 1, predicate, suspended([none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.parser:atom_fresh_[2931]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(grammar, 6, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[2933]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(remove_concat, 3, predicate, '[]', __36pos))).
':-'('<module>:emop.parser:atom_fresh_[2935]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(reparse_flat, 3, predicate, suspended([var('Flat'),var('Grammars'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.parser:atom_fresh_[2937]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(internal_reparse, 3, predicate, suspended([var('Ast'),var('Grammars'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.parser:atom_fresh_[2939]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(parse, 4, predicate, suspended([var('Lexems'),var('Mode'),var('EmopSgn'),var('Ast')],[module('Parser',[symbol(parse_left,4,predicate,suspended([var('Delim'),var('Ops'),var('Values'),var('Ast')],[call(var('Lexems'),read,[var('Lexem')]),call(var('Parser'),parse_left,[var('Lexem'),var('Delim'),var('Ops'),var('Values'),var('Ast')])]),file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',3751,131,3706),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',3848,133,3786))),symbol(parse_right,4,predicate,suspended([var('Delim'),var('Ops'),var('Values'),var('Ast')],[call(var('Lexems'),read,[var('Lexem')]),call(var('Parser'),parse_right,[var('Lexem'),var('Delim'),var('Ops'),var('Values'),var('Ast')])]),file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',3896,135,3850),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',3994,137,3931))),symbol(parse_left,5,predicate,suspended([none,var('_Delim'),var('_Ops'),var('_Values'),var('_Ast')],[call(scope,throw,[none])]),file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',4130,145,4119),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',4222,146,4133))),symbol(parse_string,7,predicate,[none,none,none,none,none,none,none],file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',7658,250,7595),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',8316,271,8302))),symbol(parse_module,6,predicate,[none,none,none,none,none,none],file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',8373,273,8318),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',9053,293,9003))),symbol(parse_module_env,4,predicate,[none,none,none,none],file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',9117,295,9055),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',9683,315,9669))),symbol(parse_module_body,7,predicate,[none,none,none,none,none,none,none],file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',9758,317,9685),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',10255,331,10186))),symbol(parse_right,5,predicate,[none,none,none,none,none],file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',11366,369,11355),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',11622,378,11566))),symbol(parse_end_of_file,4,predicate,suspended([var('Delim'),var('Ops'),var('Values'),var('Ast')],[call(scope,catch,[none,var('E'),none])]),file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',12071,395,12019),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',12467,411,12453))),symbol(sequence_list,2,predicate,[none,none],file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',16185,541,16145),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',16202,542,16188))),symbol(append,5,predicate,[none,none,none,none,none],file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',16402,548,16393),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',16408,548,16393))),symbol(read_string,4,predicate,[none,none,none,none],file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',16592,553,16583),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',16603,553,16583))),symbol(op,4,predicate,[none,none,none,none],file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',16942,564,16933),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',16944,564,16933))),symbol(op_left,1,predicate,[none],file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',17112,570,17103),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',17119,570,17103))),symbol(op_binary,1,predicate,[none],file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',17157,573,17148),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',17166,573,17148))),symbol(op_right,1,predicate,[none],file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',17233,577,17224),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',17241,577,17224))),symbol(relative,3,predicate,[none,none,none],file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',17280,580,17271),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',17288,580,17271))),symbol(check_no_delim,1,predicate,[none],file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',17357,583,17348),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',17371,583,17348))),symbol(check_delim,4,predicate,suspended([none,var('_'),var('PB'),var('PE')],[call(scope,throw,[none])]),file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',17525,587,17487),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',17590,588,17528))),symbol(apply_op,6,predicate,[none,none,none,none,none,none],file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',17869,596,17807),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',18300,611,18286))),symbol(flush,3,predicate,[none,none,none],file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',18677,623,18645),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',18824,630,18810))),symbol(flush_upto,7,predicate,[none,none,none,none,none,none,none],file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',19318,648,19309),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',19328,648,19309)))]),call(var('Parser'),parse_left,[none,none,none,var('Ast')])]), __36pos))).
':-'('<module>:emop.parser:atom_fresh_[2941]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(parse_stream, 5, predicate, '[]', __36pos))).
':-'('<module>:emop.parser:atom_fresh_[2943]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(parse_file, 4, predicate, '[]', __36pos))).
':-'('<module>:emop.parser:atom_fresh_[2945]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fresh_level_id, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.parser:atom_fresh_[2947]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fresh_operator_id, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.parser:atom_fresh_[2949]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(is_variable, 3, predicate, '[]', __36pos))).
':-'('<module>:emop.parser:atom_fresh_[2951]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(eliminate_parenthesis, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.parser:atom_fresh_[2953]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fresh_var, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.parser:atom_fresh_[2955]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(unescaped, 1, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[2957]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(atom, 5, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[2959]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(atom, 1, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[2961]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(variable, 1, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[2963]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(doc, 1, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[2965]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(xfy, 1, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[2967]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(left, 1, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[2969]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(doc, 4, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[2971]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(op, 7, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[2973]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(number, 4, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[2975]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(some, 4, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[2977]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(callable, 6, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[2979]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(empty, 3, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[2981]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(end_of_line, 2, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[2983]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(escaped, 1, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[2985]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(atom, 4, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[2987]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(file, 3, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[2989]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(error, 3, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[2991]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(toplevel, 1, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[2993]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(eos, 1, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[2995]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(eol, 1, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[2997]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(yes, 1, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[2999]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(binary, 1, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[3001]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(right, 1, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[3003]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(unespaced, 1, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[3005]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(yfx, 1, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[3007]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(doc, 5, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[3009]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(error, 2, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[3011]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(precede, 1, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[3013]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(none, 1, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[3015]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(colon, 4, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[3017]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(comment, 5, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[3019]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(functor, 5, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[3021]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(close, 4, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[3023]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(end_of_file, 2, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[3025]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(catch, 1, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[3027]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(for, 1, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[3029]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(findall, 1, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[3031]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(bagof, 1, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[3033]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(setof, 1, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[3035]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(throw, 1, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[3037]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(true, 1, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[3039]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fail, 1, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[3041]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(!, 1, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[3043]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(repeat, 1, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[3045]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(this, 1, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[3047]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(xfx, 1, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[3049]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fy, 1, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[3051]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(yf, 1, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[3053]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fx, 1, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[3055]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(xf, 1, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[3057]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(succede, 1, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[3059]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(string, 4, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[3061]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(operator, 1, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[3063]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(module, 8, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[3065]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(notation, 4, constructor, none, __36pos))).
':-'('<module>:emop.parser:atom_fresh_[3067]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(clause, 7, constructor, none, __36pos))).
':-'('<module>:emop.parser:bagof'(___45, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___45, '.'('bagof', '[]'))).
':-'('<module>:emop.parser:bagof$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:bagof'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:binary'(___81, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___81, '.'('binary', '[]'))).
':-'('<module>:emop.parser:binary$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:binary'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:callable'(___102, ___103, ___104, ___105, ___106, ___107, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___107, '.'('callable', '.'(___102, '.'(___103, '.'(___104, '.'(___105, '.'(___106, '[]')))))))).
':-'('<module>:emop.parser:callable$direct'(_____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:callable'(_____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:catch'(___48, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___48, '.'('catch', '[]'))).
':-'('<module>:emop.parser:catch$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:catch'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:clause'(___8, ___9, ___10, ___11, ___12, ___13, ___14, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___14, '.'('clause', '.'(___8, '.'(___9, '.'(___10, '.'(___11, '.'(___12, '.'(___13, '[]'))))))))).
':-'('<module>:emop.parser:clause$direct'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:clause'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:close'(___51, ___52, ___53, ___54, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___54, '.'('close', '.'(___51, '.'(___52, '.'(___53, '[]')))))).
':-'('<module>:emop.parser:close$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:close'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:colon'(___65, ___66, ___67, ___68, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___68, '.'('colon', '.'(___65, '.'(___66, '.'(___67, '[]')))))).
':-'('<module>:emop.parser:colon$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:colon'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:comment'(___60, ___61, ___62, ___63, ___64, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___64, '.'('comment', '.'(___60, '.'(___61, '.'(___62, '.'(___63, '[]'))))))).
':-'('<module>:emop.parser:comment$direct'(_____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:comment'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:doc'(___129, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___129, '.'('doc', '[]'))).
':-'('<module>:emop.parser:doc'(___123, ___124, ___125, ___126, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___126, '.'('doc', '.'(___123, '.'(___124, '.'(___125, '[]')))))).
':-'('<module>:emop.parser:doc'(___73, ___74, ___75, ___76, ___77, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___77, '.'('doc', '.'(___73, '.'(___74, '.'(___75, '.'(___76, '[]'))))))).
':-'('<module>:emop.parser:doc$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:doc'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:doc$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:doc'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:doc$direct'(_____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:doc'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:eliminate_parenthesis'('()'(_V0, _, _), _V1, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','('g_read'('emop.parser', '<module>:emop.parser'(___182)), '<module>:emop.parser:eliminate_parenthesis$direct'(_V0, _V1, ___182)))).
':-'('<module>:emop.parser:eliminate_parenthesis'(_V, _V, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), 'true').
':-'('<module>:emop.parser:eliminate_parenthesis$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:eliminate_parenthesis'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:empty'(___99, ___100, ___101, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___101, '.'('empty', '.'(___99, '.'(___100, '[]'))))).
':-'('<module>:emop.parser:empty$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:empty'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:end_of_file'(___49, ___50, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___50, '.'('end_of_file', '.'(___49, '[]')))).
':-'('<module>:emop.parser:end_of_file$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:end_of_file'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:end_of_line'(___97, ___98, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___98, '.'('end_of_line', '.'(___97, '[]')))).
':-'('<module>:emop.parser:end_of_line$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:end_of_line'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:eol'(___83, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___83, '.'('eol', '[]'))).
':-'('<module>:emop.parser:eol$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:eol'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:eos'(___84, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___84, '.'('eos', '[]'))).
':-'('<module>:emop.parser:eos$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:eos'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:error'(___71, ___72, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___72, '.'('error', '.'(___71, '[]')))).
':-'('<module>:emop.parser:error'(___86, ___87, ___88, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___88, '.'('error', '.'(___86, '.'(___87, '[]'))))).
':-'('<module>:emop.parser:error$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:error'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:error$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:error'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:escaped'(___96, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___96, '.'('escaped', '[]'))).
':-'('<module>:emop.parser:escaped$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:escaped'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:expand_level'(_GrammarRef, _Grammars, _Desc, _Pb, _Pe, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), ','(','('g_read'('emop.parser', '<module>:emop.parser'(___660)), '<module>:emop.parser:extract_level_scope$direct'(_Desc, _Pb, _Pe, _LevelList, _GrammarRef, _Grammars, _Desc0, ___660)), ','(','('='(_Grammars0, ___663), ','('emop_call'(_GrammarRef, 'get'(___661), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1279, from character 49 to 52'), ','('g_read'('emop.parser', '<module>:emop.parser'(___664)), '<module>:emop.parser:grammar_star$direct'('.'(___661, _Grammars), ___663, ___664)))), ','(','('='(_Desc1, ___669), ','(','('g_read'('emop.parse', '<module>:emop.parse'(___668)), '<module>:emop.parse:reconcat_list$direct'(_Desc0, 'file'(_Pb, _Pe), ___667, ___668)), ','('g_read'('emop.parser', '<module>:emop.parser'(___670)), '<module>:emop.parser:reparse_flat$direct'(___667, _Grammars0, ___669, ___670)))), ';'('->'(','('='(_Level, ___671), ','('g_read'('emop.parser', '<module>:emop.parser'(___672)), '<module>:emop.parser:extract_level$direct'(_Desc1, _LevelList, _GrammarRef, _Grammars, ___671, ___672))), ','(','('='(___650, ___655), ','(','('='(___673, 'grammar'(___650, ___651, ___652, ___653, ___654)), 'emop_call'(_GrammarRef, 'get'(___673), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1285, from character 29 to 32')), ','('true', ','(','('='(___651, ___656), 'true'), ','(','('='(___652, ___657), 'true'), ','(','('='(___653, ___658), '->'('='(___658, _Levels), 'true')), ','('='(___654, ___659), 'true'))))))), 'emop_call'(_GrammarRef, 'set'('grammar'(___655, ___656, ___657, '.'(_Level, _Levels), ___659)), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1284, from character 26 to 29'))), 'throw'('error'('Invalid level specification', 'file'(_Pb, _Pe)))))))).
':-'('<module>:emop.parser:expand_level$direct'(_____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:expand_level'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:expand_priorities'(_Id, _F, _List, _Pb, _Pe, _GrammarRef, _Grammars, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), ','(';'('->'(','('g_read'('emop.parser', '<module>:emop.parser'(___383)), '<module>:emop.parser:read_symbol_definition$direct'(_List, _Other, _Tail, ___383)), 'true'), 'throw'('error'('Operator name expected', 'file'(_Pb, _Pe)))), ','(','('='(_Id0, ___387), ','('g_read'('emop.parser', '<module>:emop.parser'(___388)), '<module>:emop.parser:find_operator$direct'(_Other, _GrammarRef, _Grammars, ___387, ___388))), ','(','(','('='(___363, ___373), ','(','('='(___389, 'grammar'(___363, ___364, ___365, ___366, ___367)), 'emop_call'(_GrammarRef, 'get'(___389), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1066, from character 26 to 29')), ','('true', ','(','('='(___364, ___374), '->'('='(___374, _Priorities), 'true')), ','(','('='(___365, ___375), 'true'), ','(','('='(___366, ___376), 'true'), ','('='(___367, ___377), 'true'))))))), 'emop_call'(_GrammarRef, 'set'('grammar'(___373, '.'('priority'(_Id, _Id0), _Priorities), ___375, ___376, ___377)), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1065, from character 23 to 26')), ','(';'('->'('='(_F, '='), ','(','('='(___368, ___378), ','(','('='(___395, 'grammar'(___368, ___369, ___370, ___371, ___372)), 'emop_call'(_GrammarRef, 'get'(___395), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1076, from character 29 to 32')), ','('true', ','(','('='(___369, ___379), '->'('='(___379, _Priorities_39), 'true')), ','(','('='(___370, ___380), 'true'), ','(','('='(___371, ___381), 'true'), ','('='(___372, ___382), 'true'))))))), 'emop_call'(_GrammarRef, 'set'('grammar'(___378, '.'('priority'(_Id0, _Id), _Priorities_39), ___380, ___381, ___382)), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1075, from character 26 to 29'))), 'true'), ';'('->'('='(_Tail, '[]'), 'true'), '->'('='(_Tail, '.'(_H, _T)), ';'('->'(','('='(_H, 'callable'(_F0, 'unescaped', 'none', _, _)), ';'('='(_F0, '='), '='(_F0, '<'))), ','('g_read'('emop.parser', '<module>:emop.parser'(___407)), '<module>:emop.parser:expand_priorities$direct'(_Id0, _F0, _T, _Pb, _Pe, _GrammarRef, _Grammars, ___407))), ','(','('g_read'('emop.parse', '<module>:emop.parse'(___411)), '<module>:emop.parse:position$direct'(_H, ___410, ___411)), 'throw'('error'('Priority comparison < or = expected', ___410))))))))))).
':-'('<module>:emop.parser:expand_priorities$direct'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:expand_priorities'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:expand_syntax'(_GrammarRef, _Grammars, _List, _Pb, _Pe, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), ','(','('g_read'('emop.parser', '<module>:emop.parser'(___417)), '<module>:emop.parser:read_symbol_definition$direct'(_List, _First, '.'('callable'(_F, 'unescaped', 'none', _, _), _Tail), ___417)), ','(';'('='(_F, '='), '='(_F, '<')), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','(','('g_read'('emop.parser', '<module>:emop.parser'(___421)), '<module>:emop.parser:find_operator$direct'(_First, _GrammarRef, _Grammars, ___420, ___421)), ','('g_read'('emop.parser', '<module>:emop.parser'(___422)), '<module>:emop.parser:expand_priorities$direct'(___420, _F, _Tail, _Pb, _Pe, _GrammarRef, _Grammars, ___422))))))).
':-'('<module>:emop.parser:expand_syntax'(_GrammarRef, ___Grammars, _List, _Pb, _Pe, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), ','(','('='(_Assoc, ___424), ','('='(_List, ___423), ';'('->'(','('='(___428, 'infix'), ','('='(___429, 'unescaped'), ','('='(___430, 'none'), ','('='(___425, 'callable'(___428, ___429, ___430, ___431, ___432)), ','('='(___423, '.'(___425, ___426)), ','('true', ','('true', ','('='(___436, 'left'), ','('='(___437, 'unescaped'), ','('='(___438, 'none'), ','('='(___433, 'callable'(___436, ___437, ___438, ___439, ___440)), ','('='(___426, '.'(___433, ___434)), ','('true', ','('true', ','('='(___446, 'associative'), ','('='(___447, 'unescaped'), ','('='(___448, 'none'), ','('='(___441, 'callable'(___446, ___447, ___448, ___449, ___450)), ','('='(___434, '.'(___441, ___442)), ','('true', ','('true', ','('='(___451, _Symbols), ','('='(___442, ___515), ','('g_read'('emop.parser', '<module>:emop.parser'(___516)), '<module>:emop.parser:symbol_list$direct'(___451, ___515, ___516))))))))))))))))))))))))), '='(___424, 'yfx')), ','('='(___424, ___435), ','('='(___423, ___427), ';'('->'(','('='(___452, 'infix'), ','('='(___453, 'unescaped'), ','('='(___454, 'none'), ','('='(___443, 'callable'(___452, ___453, ___454, ___455, ___456)), ','('='(___427, '.'(___443, ___444)), ','('true', ','('true', ','('='(___460, 'right'), ','('='(___461, 'unescaped'), ','('='(___462, 'none'), ','('='(___457, 'callable'(___460, ___461, ___462, ___463, ___464)), ','('='(___444, '.'(___457, ___458)), ','('true', ','('true', ','('='(___470, 'associative'), ','('='(___471, 'unescaped'), ','('='(___472, 'none'), ','('='(___465, 'callable'(___470, ___471, ___472, ___473, ___474)), ','('='(___458, '.'(___465, ___466)), ','('true', ','('true', ','('='(___475, _Symbols), ','('='(___466, ___533), ','('g_read'('emop.parser', '<module>:emop.parser'(___534)), '<module>:emop.parser:symbol_list$direct'(___475, ___533, ___534))))))))))))))))))))))))), '='(___435, 'xfy')), ','('='(___435, ___459), ','('='(___427, ___445), ';'('->'(','('='(___476, 'infix'), ','('='(___477, 'unescaped'), ','('='(___478, 'none'), ','('='(___467, 'callable'(___476, ___477, ___478, ___479, ___480)), ','('='(___445, '.'(___467, ___468)), ','('true', ','('true', ','('='(___481, _Symbols), ','('='(___468, ___541), ','('g_read'('emop.parser', '<module>:emop.parser'(___542)), '<module>:emop.parser:symbol_list$direct'(___481, ___541, ___542))))))))))), '='(___459, 'xfx')), ','('='(___459, ___482), ','('='(___445, ___469), ';'('->'(','('='(___486, 'prefix'), ','('='(___487, 'unescaped'), ','('='(___488, 'none'), ','('='(___483, 'callable'(___486, ___487, ___488, ___489, ___490)), ','('='(___469, '.'(___483, ___484)), ','('true', ','('true', ','('='(___491, _Symbols), ','('='(___484, ___549), ','('g_read'('emop.parser', '<module>:emop.parser'(___550)), '<module>:emop.parser:symbol_list$direct'(___491, ___549, ___550))))))))))), '='(___482, 'fy')), ','('='(___482, 'yf'), ','('='(___469, ___485), '->'(','('='(___494, 'postfix'), ','('='(___495, 'unescaped'), ','('='(___496, 'none'), ','('='(___492, 'callable'(___494, ___495, ___496, ___497, ___498)), ','('='(___485, '.'(___492, ___493)), ','('true', ','('true', ','('='(___499, _Symbols), ','('='(___493, ___557), ','('g_read'('emop.parser', '<module>:emop.parser'(___558)), '<module>:emop.parser:symbol_list$direct'(___499, ___557, ___558))))))))))), 'true'))))))))))))))), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','('='(_List, '.'('callable'(_Kind, _, _, _, _), _)), ','(','('true', ';'('->'('var'(___563), ','('g_inc'('$module_count', ___564), '='(___563, '$module'(___564, '.'('<module>:emop.parser@4'('env'(___563, _Pb, _Pe, _Kind, _Assoc, _GrammarRef)), '[]'), '.'(___563, '[]'))))), ','('='(___563, '$module'(___564, ___565, _)), ','('='('.'(___566, ___567), ___565), ','('setarg'(1, ___565, '<module>:emop.parser@4'('env'(___563, _Pb, _Pe, _Kind, _Assoc, _GrammarRef))), 'setarg'(2, ___565, '.'(___566, ___567))))))), ','('g_read'('data.list', '<module>:data.list'(___569)), '<module>:data.list:iter$direct'(_Symbols, ___563, ___569))))))).
':-'('<module>:emop.parser:expand_syntax'(___GrammarRef, ___Grammars, ___List, _Pb, _Pe, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), 'throw'('error'('Invalid syntax definition', 'file'(_Pb, _Pe)))).
':-'('<module>:emop.parser:expand_syntax$direct'(_____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:expand_syntax'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:extract_level'('()'(_Desc, _, _), _LevelList, _GrammarRef, _Grammars, ___618, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), ','('g_read'('emop.parser', '<module>:emop.parser'(___619)), '<module>:emop.parser:extract_level$direct'(_Desc, _LevelList, _GrammarRef, _Grammars, ___618, ___619))).
':-'('<module>:emop.parser:extract_level'('callable'(_F, _Escaped, _Args, _, _), _LevelList, _GrammarRef, _Grammars, 'level'(_LevelList, _F, _Escaped, ___628), 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), ','(','('true', ';'('->'('var'(___622), ','('g_inc'('$module_count', ___623), '='(___622, '$module'(___623, '.'('<module>:emop.parser@6'('env'(___622, _GrammarRef, _Grammars)), '[]'), '.'(___622, '[]'))))), ','('='(___622, '$module'(___623, ___624, _)), ','('='('.'(___625, ___626), ___624), ','('setarg'(1, ___624, '<module>:emop.parser@6'('env'(___622, _GrammarRef, _Grammars))), 'setarg'(2, ___624, '.'(___625, ___626))))))), ','('g_read'('data.list', '<module>:data.list'(___629)), '<module>:data.list:iter$direct'(_Args, ___622, ___628, ___629)))).
':-'('<module>:emop.parser:extract_level$direct'(_____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:extract_level'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:extract_level_scope'(_Desc, _Pb, _Pe, _LevelList, _GrammarRef, _Grammars, _Desc0, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), ';'('->'('='(_Desc, '.'('()'(_Spec, _, _), _Desc0)), ','(','('='(_SpecList, ___591), ','('g_read'('emop.parse', '<module>:emop.parse'(___592)), '<module>:emop.parse:enum_concat_list$direct'(_Spec, ___591, ___592))), ','('='(_LevelList, ___599), ','(','('true', ';'('->'('var'(___593), ','('g_inc'('$module_count', ___594), '='(___593, '$module'(___594, '.'('<module>:emop.parser@5'('env'(___593, _GrammarRef, _Grammars)), '[]'), '.'(___593, '[]'))))), ','('='(___593, '$module'(___594, ___595, _)), ','('='('.'(___596, ___597), ___595), ','('setarg'(1, ___595, '<module>:emop.parser@5'('env'(___593, _GrammarRef, _Grammars))), 'setarg'(2, ___595, '.'(___596, ___597))))))), 'emop_call'(___593, 'do'(_SpecList, ___599), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1235, from character 18 to 20'))))), 'throw'('error'('Missing level scope', 'file'(_Pb, _Pe))))).
':-'('<module>:emop.parser:extract_level_scope$direct'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:extract_level_scope'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:fail'(___41, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___41, '.'('fail', '[]'))).
':-'('<module>:emop.parser:fail$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:fail'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:file'(___89, ___90, ___91, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___91, '.'('file', '.'(___89, '.'(___90, '[]'))))).
':-'('<module>:emop.parser:file$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:file'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:find_level'(_GrammarRef, _Grammars, _Level, _Id, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), ','(','('='(___603, 'grammar'(___Operators, ___Priorities, _LevelIds, ___Levels, ___Notations)), 'emop_call'(_GrammarRef, 'get'(___603), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1241, from character 23 to 26')), ';'('->'(','(','('='(_Id, ___605), 'emop_call'(_LevelIds, '{}'(_Level, ___605), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1244, from character 29 to 30')), '\\+'(','('g_read'('data.var', '<module>:data.var'(___607)), '<module>:data.var:check$direct'(_Id, ___607)))), 'true'), ';'('->'(','(','('g_read'('data.list', '<module>:data.list'(___609)), '<module>:data.list:member$direct'(_Grammar, _Grammars, ___609)), ','('='(_Grammar, 'grammar'(_, _, _LevelIds_39, _, _)), ','(','('='(_Id, ___611), 'emop_call'(_LevelIds_39, '{}'(_Level, ___611), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1251, from character 30 to 31')), '\\+'(','('g_read'('data.var', '<module>:data.var'(___613)), '<module>:data.var:check$direct'(_Id, ___613)))))), 'true'), ','(','('='(_Id, ___614), ','('g_read'('emop.parser', '<module>:emop.parser'(___615)), '<module>:emop.parser:fresh_level_id$direct'(___614, ___615))), ','('='(___616, _Id), 'emop_call'(_LevelIds, '{}'(_Level, ___616), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1257, from character 24 to 25'))))))).
':-'('<module>:emop.parser:find_level$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:find_level'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:find_operator'('operator'(_F, _Symbol, _Pb, _Pe), _GrammarRef, _Grammars, _OperatorId, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), ';'('->'(','(';'(','('='(_Grammar, ___318), 'emop_call'(_GrammarRef, 'get'(___318), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1001, from character 39 to 42')), ','('g_read'('data.list', '<module>:data.list'(___320)), '<module>:data.list:member$direct'(_Grammar, _Grammars, ___320))), ','('='(___313, _Symbol), ','('='(___314, _OperatorId), ','('='(___312, 'operator'(___313, ___314, ___315, ___316, ___317)), ','('='(___307, ___323), ','('='(_Grammar, 'grammar'(___307, ___308, ___309, ___310, ___311)), ','('g_read'('data.list', '<module>:data.list'(___324)), ','('<module>:data.list:member$direct'(___312, ___323, ___324), ','(','('true', ','('='(___316, _F), 'true')), ','('true', ','('true', ','('true', 'true')))))))))))), 'true'), ';'('->'(','('g_read'('data.var', '<module>:data.var'(___327)), '<module>:data.var:check$direct'(_F, ___327)), ','(','('g_read'('data.atom', '<module>:data.atom'(___333)), '<module>:data.atom:format$direct'('Unknown operator ~a', '.'(_Symbol, '[]'), ___332, ___333)), 'throw'('error'(___332, 'file'(_Pb, _Pe))))), ';'('->'('='(_F, 'infix'), ','(','('g_read'('data.atom', '<module>:data.atom'(___342)), '<module>:data.atom:format$direct'('Unknown infix operator ~a', '.'(_Symbol, '[]'), ___341, ___342)), 'throw'('error'(___341, 'file'(_Pb, _Pe))))), ';'('->'('='(_F, 'prefix'), ','(','('g_read'('data.atom', '<module>:data.atom'(___351)), '<module>:data.atom:format$direct'('Unknown prefix operator ~a', '.'(_Symbol, '[]'), ___350, ___351)), 'throw'('error'(___350, 'file'(_Pb, _Pe))))), '->'('='(_F, 'postfix'), ','(','('g_read'('data.atom', '<module>:data.atom'(___360)), '<module>:data.atom:format$direct'('Unknown postfix operator ~a', '.'(_Symbol, '[]'), ___359, ___360)), 'throw'('error'(___359, 'file'(_Pb, _Pe)))))))))).
':-'('<module>:emop.parser:find_operator$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:find_operator'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:findall'(___46, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___46, '.'('findall', '[]'))).
':-'('<module>:emop.parser:findall$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:findall'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:for'(___47, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___47, '.'('for', '[]'))).
':-'('<module>:emop.parser:for$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:for'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:fresh_level_id'(_V, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), ','(';'('->'(','('g_read'('data.var', '<module>:data.var'(___203)), '<module>:data.var:check$direct'(_LevelsIdRef, ___203)), ','('='(_LevelsIdRef, ___205), ','('g_read'('data.ref.non_backtrackable', '<module>:data.ref.non_backtrackable'(___206)), '<module>:data.ref.non_backtrackable:new$direct'(0, ___205, ___206)))), 'true'), ','('='(_V, ___210), ','(','('g_read'('data.number', '<module>:data.number'(___209)), '<module>:data.number:|++$direct'(_LevelsIdRef, ___208, ___209)), ','('g_read'('data.number', '<module>:data.number'(___211)), '<module>:data.number:atom$direct'(___208, ___210, ___211)))))).
':-'('<module>:emop.parser:fresh_level_id$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:fresh_level_id'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:fresh_operator_id'(_V, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), ','(';'('->'(','('g_read'('data.var', '<module>:data.var'(___195)), '<module>:data.var:check$direct'(_OperatorsIdRef, ___195)), ','('='(_OperatorsIdRef, ___197), ','('g_read'('data.ref.non_backtrackable', '<module>:data.ref.non_backtrackable'(___198)), '<module>:data.ref.non_backtrackable:new$direct'(0, ___197, ___198)))), 'true'), ','('='(_V, ___200), ','('g_read'('data.number', '<module>:data.number'(___201)), '<module>:data.number:|++$direct'(_OperatorsIdRef, ___200, ___201))))).
':-'('<module>:emop.parser:fresh_operator_id$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:fresh_operator_id'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:fresh_var'(_V, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), ','(';'('->'(','('g_read'('data.var', '<module>:data.var'(___167)), '<module>:data.var:check$direct'(_FreshVarCounterRef, ___167)), ','('='(_FreshVarCounterRef, ___169), ','('g_read'('data.ref.non_backtrackable', '<module>:data.ref.non_backtrackable'(___170)), '<module>:data.ref.non_backtrackable:new$direct'(0, ___169, ___170)))), 'true'), ','('='(_V, 'var'(___178)), ','(','('g_read'('data.number', '<module>:data.number'(___175)), '<module>:data.number:|++$direct'(_FreshVarCounterRef, ___174, ___175)), ','('g_read'('data.atom', '<module>:data.atom'(___179)), '<module>:data.atom:format$direct'('_~d', '.'(___174, '[]'), ___178, ___179)))))).
':-'('<module>:emop.parser:fresh_var$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:fresh_var'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:functor'(___55, ___56, ___57, ___58, ___59, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___59, '.'('functor', '.'(___55, '.'(___56, '.'(___57, '.'(___58, '[]'))))))).
':-'('<module>:emop.parser:functor$direct'(_____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:functor'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:fx'(___34, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___34, '.'('fx', '[]'))).
':-'('<module>:emop.parser:fx$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:fx'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:fy'(___36, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___36, '.'('fy', '[]'))).
':-'('<module>:emop.parser:fy$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:fy'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:grammar'(___138, ___139, ___140, ___141, ___142, ___143, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___143, '.'('grammar', '.'(___138, '.'(___139, '.'(___140, '.'(___141, '.'(___142, '[]')))))))).
':-'('<module>:emop.parser:grammar$direct'(_____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:grammar'(_____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:grammar_empty'('grammar'('[]', '[]', ___285, '[]', ___289), 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), ','(','('g_read'('data.record', '<module>:data.record'(___286)), '<module>:data.record:{}$direct'(___285, ___286)), ','('g_read'('data.record', '<module>:data.record'(___290)), '<module>:data.record:{}$direct'(___289, ___290)))).
':-'('<module>:emop.parser:grammar_empty$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:grammar_empty'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:grammar_star'(_Grammars, '.'('grammar'('.'('operator'('*', ___632, '*', 'postfix', 'xf'), '[]'), '[]', ___642, '[]', ___646), _Grammars), 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), ','(','('g_read'('emop.parser', '<module>:emop.parser'(___633)), '<module>:emop.parser:fresh_operator_id$direct'(___632, ___633)), ','(','('g_read'('data.record', '<module>:data.record'(___643)), '<module>:data.record:{}$direct'(___642, ___643)), ','('g_read'('data.record', '<module>:data.record'(___647)), '<module>:data.record:{}$direct'(___646, ___647))))).
':-'('<module>:emop.parser:grammar_star$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:grammar_star'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:internal_reparse'(_Ast, _Grammars, ___272, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), ','(','('g_read'('emop.parse', '<module>:emop.parse'(___271)), '<module>:emop.parse:reflat$direct'(_Ast, ___270, ___271)), ','('g_read'('emop.parser', '<module>:emop.parser'(___273)), '<module>:emop.parser:reparse_flat$direct'(___270, _Grammars, ___272, ___273)))).
':-'('<module>:emop.parser:internal_reparse$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:internal_reparse'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:is_variable'(_Atom, _Escaped, _Args, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), ','('='(_Args, 'none'), ';'('->'('='(_Escaped, 'unescaped'), ','(','('g_read'('data.atom', '<module>:data.atom'(___186)), '<module>:data.atom:sub$direct'(_Atom, 0, 1, _, _FirstLetter, ___186)), ','(';'(','(','('g_read'('data.term', '<module>:data.term'(___189)), '<module>:data.term:>=$direct'(_FirstLetter, 'A', ___189)), ','('g_read'('data.term', '<module>:data.term'(___191)), '<module>:data.term:=<$direct'(_FirstLetter, 'Z', ___191))), '='(_FirstLetter, '_')), ','('true', ','('='(__36CutLevel, '$cut'), '!'))))), '='(_Escaped, 'variable')))).
':-'('<module>:emop.parser:is_variable$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:is_variable'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:left'(___127, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___127, '.'('left', '[]'))).
':-'('<module>:emop.parser:left$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:left'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:level'(___144, ___145, ___146, ___147, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___147, '.'('level', '.'(___144, '.'(___145, '.'(___146, '[]')))))).
':-'('<module>:emop.parser:level'(___152, ___153, ___154, ___155, ___156, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___156, '.'('level', '.'(___152, '.'(___153, '.'(___154, '.'(___155, '[]'))))))).
':-'('<module>:emop.parser:level$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:level'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:level$direct'(_____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:level'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:make_grammar'(_Sgn, _SupGrammars, _Grammar, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), ','(','('='(_GrammarRef, ___767), ','(','('g_read'('emop.parser', '<module>:emop.parser'(___766)), '<module>:emop.parser:grammar_empty$direct'(___765, ___766)), ','('g_read'('data.ref.backtrackable', '<module>:data.ref.backtrackable'(___768)), '<module>:data.ref.backtrackable:new$direct'(___765, ___767, ___768)))), ','(','(','('true', ';'('->'('var'(___770), ','('g_inc'('$module_count', ___771), '='(___770, '$module'(___771, '.'('<module>:emop.parser@13'('env'(___770, _GrammarRef, _SupGrammars)), '[]'), '.'(___770, '[]'))))), ','('='(___770, '$module'(___771, ___772, _)), ','('='('.'(___773, ___774), ___772), ','('setarg'(1, ___772, '<module>:emop.parser@13'('env'(___770, _GrammarRef, _SupGrammars))), 'setarg'(2, ___772, '.'(___773, ___774))))))), ','('g_read'('data.list', '<module>:data.list'(___776)), '<module>:data.list:iter$direct'(_Sgn, ___770, ___776))), ','('='(_Grammar, ___777), 'emop_call'(_GrammarRef, 'get'(___777), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 2050, from character 30 to 33'))))).
':-'('<module>:emop.parser:make_grammar$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:make_grammar'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:module'(___19, ___20, ___21, ___22, ___23, ___24, ___25, ___26, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___26, '.'('module', '.'(___19, '.'(___20, '.'(___21, '.'(___22, '.'(___23, '.'(___24, '.'(___25, '[]')))))))))).
':-'('<module>:emop.parser:module$direct'(_____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:module'(_____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:none'(___69, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___69, '.'('none', '[]'))).
':-'('<module>:emop.parser:none$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:none'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:notation'(___15, ___16, ___17, ___18, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___18, '.'('notation', '.'(___15, '.'(___16, '.'(___17, '[]')))))).
':-'('<module>:emop.parser:notation$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:notation'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:number'(___112, ___113, ___114, ___115, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___115, '.'('number', '.'(___112, '.'(___113, '.'(___114, '[]')))))).
':-'('<module>:emop.parser:number$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:number'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:op'(___116, ___117, ___118, ___119, ___120, ___121, ___122, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___122, '.'('op', '.'(___116, '.'(___117, '.'(___118, '.'(___119, '.'(___120, '.'(___121, '[]'))))))))).
':-'('<module>:emop.parser:op$direct'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:op'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:operator'(___27, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___27, '.'('operator', '[]'))).
':-'('<module>:emop.parser:operator'(___160, ___161, ___162, ___163, ___164, ___165, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___165, '.'('operator', '.'(___160, '.'(___161, '.'(___162, '.'(___163, '.'(___164, '[]')))))))).
':-'('<module>:emop.parser:operator$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:operator'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:operator$direct'(_____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:operator'(_____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:parse'(_Lexems, _Mode, _EmopSgn, _Ast, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), ','(','('true', ';'('->'('var'(_Parser), ','('g_inc'('$module_count', ___261), '='(_Parser, '$module'(___261, '.'('<module>:emop.parser@0'('env'(_Parser, _Lexems, _Mode, _Parser, _EmopSgn)), '[]'), '.'(_Parser, '[]'))))), ','('='(_Parser, '$module'(___261, ___262, _)), ','('='('.'(___263, ___264), ___262), ','('setarg'(1, ___262, '<module>:emop.parser@0'('env'(_Parser, _Lexems, _Mode, _Parser, _EmopSgn))), 'setarg'(2, ___262, '.'(___263, ___264))))))), 'emop_call'(_Parser, 'parse_left'('none', '[]', '[]', _Ast), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 703, from character 13 to 23'))).
':-'('<module>:emop.parser:parse$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:parse'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:parse_file'(_Filename, _Stream, _EmopSgn, _Ast, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), ','(','('='(_ParsedFileCache, ___212), 'emop_call'(_ParsedFileCacheRef, 'get'(___212), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 64, from character 43 to 46')), ','(','('='(_ChangedDate, ___214), ','('g_read'('sys.file', '<module>:sys.file'(___215)), '<module>:sys.file:last_modification$direct'(_Filename, ___214, ___215))), ';'('->'(','(','('g_read'('data.list', '<module>:data.list'(___218)), '<module>:data.list:member$direct'('cache'(_Filename, _ParsedDate, _Ast0), _ParsedFileCache, ___218)), ','('g_read'('data.term', '<module>:data.term'(___220)), '<module>:data.term:=<$direct'(_ChangedDate, _ParsedDate, ___220))), '='(_Ast, _Ast0)), ','(';'('->'(','('g_read'('data.var', '<module>:data.var'(___222)), '<module>:data.var:check$direct'(_ParseResultRef, ___222)), ','('='(_ParseResultRef, ___225), ','('g_read'('data.ref.non_backtrackable', '<module>:data.ref.non_backtrackable'(___226)), '<module>:data.ref.non_backtrackable:new$direct'('[]', ___225, ___226)))), 'true'), ';'(';'('->'(','(','('g_read'('emop.parser', '<module>:emop.parser'(___229)), '<module>:emop.parser:parse_stream$direct'(_Filename, 'file', _Stream, _EmopSgn, ___228, ___229)), 'emop_call'(_ParseResultRef, 'set'(___228), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 81, from character 30 to 33')), 'fail'), 'throw'('error'('parsing_error'))), ','(','('='(_Ast0, ___232), 'emop_call'(_ParseResultRef, 'get'(___232), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 88, from character 34 to 37')), ','('emop_call'(_ParseResultRef, 'set'('[]'), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 89, from character 27 to 30'), ','('emop_call'(_ParsedFileCacheRef, 'set'('.'('cache'(_Filename, _ChangedDate, _Ast0), _ParsedFileCache)), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 90, from character 31 to 34'), '='(_Ast, _Ast0)))))))))).
':-'('<module>:emop.parser:parse_file$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:parse_file'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:parse_stream'(_Filename, _Mode, _Stream, _EmopSgn, _Ast, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), ','(','('g_read'('io.stream', '<module>:io.stream'(___237)), '<module>:io.stream:backtrackable$direct'(_Stream, _Backtrackable, ___237)), ','(','('g_read'('io.stream', '<module>:io.stream'(___239)), '<module>:io.stream:text_position_utf8$direct'(_Backtrackable, _Filename, _Positionable, ___239)), ','(';'('->'(','('g_read'('emop.lexer', '<module>:emop.lexer'(___241)), '<module>:emop.lexer:lex$direct'(_Positionable, _Lexems, ___241)), 'true'), 'throw'('error'('lexing_error'))), ','(','('g_read'('emop.parser', '<module>:emop.parser'(___244)), '<module>:emop.parser:parse$direct'(_Lexems, _Mode, _EmopSgn, _Ast0, ___244)), ';'('->'('='(_Ast0, 'callable'('.', 'operator', '.'(_Ast, '.'('empty'(_Pb, _Pe), '[]')), _, _)), ';'('->'('='(_Mode, 'toplevel'), ','('g_read'('emop.message', '<module>:emop.message'(___256)), '<module>:emop.message:warning$direct'('Superfluous dot at the end of the goal', 'file'(_Pb, _Pe), ___256))), ','('g_read'('emop.message', '<module>:emop.message'(___260)), '<module>:emop.message:warning$direct'('Superfluous dot at the end of the file', 'file'(_Pb, _Pe), ___260)))), '='(_Ast, _Ast0))))))).
':-'('<module>:emop.parser:parse_stream$direct'(_____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:parse_stream'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:precede'(___70, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___70, '.'('precede', '[]'))).
':-'('<module>:emop.parser:precede$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:precede'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:priority'(___157, ___158, ___159, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___159, '.'('priority', '.'(___157, '.'(___158, '[]'))))).
':-'('<module>:emop.parser:priority$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:priority'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:read_symbol_definition'('.'('callable'(_F, 'unescaped', 'none', _, _), '.'('callable'(_A, _, 'none', _Pb, _Pe), _Tail)), 'operator'(_F, _A, _Pb, _Pe), _Tail, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), ','(';'('='(_F, 'prefix'), ';'('='(_F, 'postfix'), '='(_F, 'infix'))), ','('true', ','('='(__36CutLevel, '$cut'), '!')))).
':-'('<module>:emop.parser:read_symbol_definition'('.'('callable'(_A, _, 'none', _Pb, _Pe), _Tail), 'operator'(___F, _A, _Pb, _Pe), _Tail, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), 'true').
':-'('<module>:emop.parser:read_symbol_definition$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:read_symbol_definition'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:remove_concat'(_Ast0, _Grammars, _Ast1, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), ','(','('true', ';'('->'('var'(___276), ','('g_inc'('$module_count', ___277), '='(___276, '$module'(___277, '.'('<module>:emop.parser@1'('env'(___276, _Grammars)), '[]'), '.'(___276, '[]'))))), ','('='(___276, '$module'(___277, ___278, _)), ','('='('.'(___279, ___280), ___278), ','('setarg'(1, ___278, '<module>:emop.parser@1'('env'(___276, _Grammars))), 'setarg'(2, ___278, '.'(___279, ___280))))))), 'emop_call'(___276, 'do'(_Ast0, _Ast1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 733, from character 8 to 10'))).
':-'('<module>:emop.parser:remove_concat$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:remove_concat'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:reparse_flat'(_Flat, _Grammars, ___274, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), ','('g_read'('emop.parser', '<module>:emop.parser'(___275)), '<module>:emop.parser:remove_concat$direct'(_Flat, _Grammars, ___274, ___275))).
':-'('<module>:emop.parser:reparse_flat$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:reparse_flat'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:reparse_list'(_List, _Grammars, _Ast, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), ','(','('true', ';'('->'('var'(___292), ','('g_inc'('$module_count', ___293), '='(___292, '$module'(___293, '.'('<module>:emop.parser@2'('env'(___292, _Grammars)), '[]'), '.'(___292, '[]'))))), ','('='(___292, '$module'(___293, ___294, _)), ','('='('.'(___295, ___296), ___294), ','('setarg'(1, ___294, '<module>:emop.parser@2'('env'(___292, _Grammars))), 'setarg'(2, ___294, '.'(___295, ___296))))))), 'emop_call'(___292, 'reassoc_left'(_List, '[]', '[]', _Ast), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 976, from character 8 to 20'))).
':-'('<module>:emop.parser:reparse_list$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:reparse_list'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:repeat'(___39, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___39, '.'('repeat', '[]'))).
':-'('<module>:emop.parser:repeat$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:repeat'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:right'(___80, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___80, '.'('right', '[]'))).
':-'('<module>:emop.parser:right$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:right'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:setof'(___44, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___44, '.'('setof', '[]'))).
':-'('<module>:emop.parser:setof$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:setof'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:some'(___108, ___109, ___110, ___111, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___111, '.'('some', '.'(___108, '.'(___109, '.'(___110, '[]')))))).
':-'('<module>:emop.parser:some$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:some'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:string'(___28, ___29, ___30, ___31, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___31, '.'('string', '.'(___28, '.'(___29, '.'(___30, '[]')))))).
':-'('<module>:emop.parser:string$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:string'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:succede'(___32, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___32, '.'('succede', '[]'))).
':-'('<module>:emop.parser:succede$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:succede'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:symbol_list'(_List, _SymbolList, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), ','(','('true', ';'('->'('var'(___300), ','('g_inc'('$module_count', ___301), '='(___300, '$module'(___301, '.'('<module>:emop.parser@3'('env'(___300)), '[]'), '.'(___300, '[]'))))), ','('='(___300, '$module'(___301, ___302, _)), ','('='('.'(___303, ___304), ___302), ','('setarg'(1, ___302, '<module>:emop.parser@3'('env'(___300))), 'setarg'(2, ___302, '.'(___303, ___304))))))), 'emop_call'(___300, 'do'(_SymbolList, _List), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 996, from character 14 to 16'))).
':-'('<module>:emop.parser:symbol_list$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:symbol_list'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:syntax'(___148, ___149, ___150, ___151, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___151, '.'('syntax', '.'(___148, '.'(___149, '.'(___150, '[]')))))).
':-'('<module>:emop.parser:syntax$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:syntax'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:this'(___38, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___38, '.'('this', '[]'))).
':-'('<module>:emop.parser:this$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:this'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:throw'(___43, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___43, '.'('throw', '[]'))).
':-'('<module>:emop.parser:throw$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:throw'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:toplevel'(___85, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___85, '.'('toplevel', '[]'))).
':-'('<module>:emop.parser:toplevel$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:toplevel'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:true'(___42, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___42, '.'('true', '[]'))).
':-'('<module>:emop.parser:true$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:true'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:unescaped'(___137, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___137, '.'('unescaped', '[]'))).
':-'('<module>:emop.parser:unescaped$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:unescaped'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:unespaced'(___79, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___79, '.'('unespaced', '[]'))).
':-'('<module>:emop.parser:unespaced$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:unespaced'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:variable'(___130, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___130, '.'('variable', '[]'))).
':-'('<module>:emop.parser:variable$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:variable'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:xf'(___33, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___33, '.'('xf', '[]'))).
':-'('<module>:emop.parser:xf$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:xf'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:xfx'(___37, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___37, '.'('xfx', '[]'))).
':-'('<module>:emop.parser:xfx$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:xfx'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:xfy'(___128, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___128, '.'('xfy', '[]'))).
':-'('<module>:emop.parser:xfy$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:xfy'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:yes'(___82, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___82, '.'('yes', '[]'))).
':-'('<module>:emop.parser:yes$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:yes'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:yf'(___35, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___35, '.'('yf', '[]'))).
':-'('<module>:emop.parser:yf$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:yf'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser:yfx'(___78, 'env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef), __36CutLevel), '=..'(___78, '.'('yfx', '[]'))).
':-'('<module>:emop.parser:yfx$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser:yfx'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@0'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@0:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@0'('parse_left'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@0:parse_left'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@0'('parse_right'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@0:parse_right'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@0'('parse_left'(_____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@0:parse_left'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@0'('parse_string'(_____7, _____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@0:parse_string'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@0'('parse_module'(_____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@0:parse_module'(_____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@0'('parse_module_env'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@0:parse_module_env'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@0'('parse_module_body'(_____7, _____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@0:parse_module_body'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@0'('parse_right'(_____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@0:parse_right'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@0'('parse_end_of_file'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@0:parse_end_of_file'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@0'('sequence_list'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@0:sequence_list'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@0'('append'(_____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@0:append'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@0'('read_string'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@0:read_string'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@0'('op'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@0:op'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@0'('op_left'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@0:op_left'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@0'('op_binary'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@0:op_binary'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@0'('op_right'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@0:op_right'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@0'('relative'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@0:relative'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@0'('check_no_delim'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@0:check_no_delim'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@0'('check_delim'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@0:check_delim'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@0'('apply_op'(_____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@0:apply_op'(_____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@0'('flush'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@0:flush'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@0'('flush_upto'(_____7, _____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@0:flush_upto'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@0'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.parser@0$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.parser@0$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.parser@0$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.parser@0$has_predicate'('parse_left'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser@0$has_predicate'('parse_right'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser@0$has_predicate'('parse_left'(_____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser@0$has_predicate'('parse_string'(_____7, _____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser@0$has_predicate'('parse_module'(_____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser@0$has_predicate'('parse_module_env'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser@0$has_predicate'('parse_module_body'(_____7, _____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser@0$has_predicate'('parse_right'(_____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser@0$has_predicate'('parse_end_of_file'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser@0$has_predicate'('sequence_list'(_____2, _____1)), 'true').
':-'('<module>:emop.parser@0$has_predicate'('append'(_____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser@0$has_predicate'('read_string'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser@0$has_predicate'('op'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser@0$has_predicate'('op_left'(_____1)), 'true').
':-'('<module>:emop.parser@0$has_predicate'('op_binary'(_____1)), 'true').
':-'('<module>:emop.parser@0$has_predicate'('op_right'(_____1)), 'true').
':-'('<module>:emop.parser@0$has_predicate'('relative'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser@0$has_predicate'('check_no_delim'(_____1)), 'true').
':-'('<module>:emop.parser@0$has_predicate'('check_delim'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser@0$has_predicate'('apply_op'(_____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser@0$has_predicate'('flush'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser@0$has_predicate'('flush_upto'(_____7, _____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser@0:$sgn'(__36sgn, 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',3658,130,3652)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',3705,130,3652)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','('true', '<module>:emop.parser@0:atom_fresh_[3167]'(_atom__fresh___913168_93, __36Pb, __36Pe)), '<module>:emop.parser@0:atom_fresh_[3169]'(_atom__fresh___913170_93, __36Pb, __36Pe)), '<module>:emop.parser@0:atom_fresh_[3171]'(_atom__fresh___913172_93, __36Pb, __36Pe)), '<module>:emop.parser@0:atom_fresh_[3173]'(_atom__fresh___913174_93, __36Pb, __36Pe)), '<module>:emop.parser@0:atom_fresh_[3175]'(_atom__fresh___913176_93, __36Pb, __36Pe)), '<module>:emop.parser@0:atom_fresh_[3177]'(_atom__fresh___913178_93, __36Pb, __36Pe)), '<module>:emop.parser@0:atom_fresh_[3179]'(_atom__fresh___913180_93, __36Pb, __36Pe)), '<module>:emop.parser@0:atom_fresh_[3181]'(_atom__fresh___913182_93, __36Pb, __36Pe)), '<module>:emop.parser@0:atom_fresh_[3183]'(_atom__fresh___913184_93, __36Pb, __36Pe)), '<module>:emop.parser@0:atom_fresh_[3185]'(_atom__fresh___913186_93, __36Pb, __36Pe)), '<module>:emop.parser@0:atom_fresh_[3187]'(_atom__fresh___913188_93, __36Pb, __36Pe)), '<module>:emop.parser@0:atom_fresh_[3189]'(_atom__fresh___913190_93, __36Pb, __36Pe)), '<module>:emop.parser@0:atom_fresh_[3191]'(_atom__fresh___913192_93, __36Pb, __36Pe)), '<module>:emop.parser@0:atom_fresh_[3193]'(_atom__fresh___913194_93, __36Pb, __36Pe)), '<module>:emop.parser@0:atom_fresh_[3195]'(_atom__fresh___913196_93, __36Pb, __36Pe)), '<module>:emop.parser@0:atom_fresh_[3197]'(_atom__fresh___913198_93, __36Pb, __36Pe)), '<module>:emop.parser@0:atom_fresh_[3199]'(_atom__fresh___913200_93, __36Pb, __36Pe)), '<module>:emop.parser@0:atom_fresh_[3201]'(_atom__fresh___913202_93, __36Pb, __36Pe)), '<module>:emop.parser@0:atom_fresh_[3203]'(_atom__fresh___913204_93, __36Pb, __36Pe)), '<module>:emop.parser@0:atom_fresh_[3205]'(_atom__fresh___913206_93, __36Pb, __36Pe)), '<module>:emop.parser@0:atom_fresh_[3207]'(_atom__fresh___913208_93, __36Pb, __36Pe)), '<module>:emop.parser@0:atom_fresh_[3209]'(_atom__fresh___913210_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913210_93, '.'(_atom__fresh___913208_93, '.'(_atom__fresh___913206_93, '.'(_atom__fresh___913204_93, '.'(_atom__fresh___913202_93, '.'(_atom__fresh___913200_93, '.'(_atom__fresh___913198_93, '.'(_atom__fresh___913196_93, '.'(_atom__fresh___913194_93, '.'(_atom__fresh___913192_93, '.'(_atom__fresh___913190_93, '.'(_atom__fresh___913188_93, '.'(_atom__fresh___913186_93, '.'(_atom__fresh___913184_93, '.'(_atom__fresh___913182_93, '.'(_atom__fresh___913180_93, '.'(_atom__fresh___913178_93, '.'(_atom__fresh___913176_93, '.'(_atom__fresh___913174_93, '.'(_atom__fresh___913172_93, '.'(_atom__fresh___913170_93, '.'(_atom__fresh___913168_93, '[]')))))))))))))))))))))))))))).
':-'('<module>:emop.parser@0:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@0:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@0:append'('[]', _Tail, _, _, _Tail, 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), 'true').
':-'('<module>:emop.parser@0:append'('.'(_H, _T), _Tail, _PB, _PE, _L, 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), ','('='(_L, 'callable'('.', 'escaped', '.'(_H, '.'(_L0, '[]')), _PB, _PE)), 'emop_call'(_Parser, 'append'(_T, _Tail, _PB, _PE, _L0), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 552, from character 19 to 25'))).
':-'('<module>:emop.parser@0:append$direct'(_____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@0:append'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@0:apply_op'('left', _Atom, _PB, _PE, _Values0, '.'(_V, _Values1), 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), ';'('->'('='(_Values0, '.'(_Arg0, _Values1)), ';'('->'('='(_Atom, 'doc'(_Comment, _PB0, _PE0)), '='(_V, 'doc'(_Comment, _PB0, _PE0, _Arg0))), '='(_V, 'callable'(_Atom, 'operator', '.'(_Arg0, '[]'), _PB, _PE)))), 'throw'('error'('Missing operand', 'file'(_PB, _PE))))).
':-'('<module>:emop.parser@0:apply_op'('binary', _Atom, _PB, _PE, _Values0, '.'(_V, _Values1), 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), ';'('->'('='(_Values0, '.'(_Arg1, '.'(_Arg0, _Values1))), '='(_V, 'callable'(_Atom, 'operator', '.'(_Arg0, '.'(_Arg1, '[]')), _PB, _PE))), 'throw'('error'('Missing right operand', 'file'(_PB, _PE))))).
':-'('<module>:emop.parser@0:apply_op$direct'(_____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@0:apply_op'(_____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@0:atom_fresh_[3167]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(flush_upto, 7, predicate, '[]', __36pos))).
':-'('<module>:emop.parser@0:atom_fresh_[3169]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(flush, 3, predicate, '[]', __36pos))).
':-'('<module>:emop.parser@0:atom_fresh_[3171]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(apply_op, 6, predicate, '[]', __36pos))).
':-'('<module>:emop.parser@0:atom_fresh_[3173]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(check_delim, 4, predicate, suspended([none,var('_'),var('PB'),var('PE')],[call(scope,throw,[none])]), __36pos))).
':-'('<module>:emop.parser@0:atom_fresh_[3175]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(check_no_delim, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.parser@0:atom_fresh_[3177]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(relative, 3, predicate, '[]', __36pos))).
':-'('<module>:emop.parser@0:atom_fresh_[3179]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(op_right, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.parser@0:atom_fresh_[3181]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(op_binary, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.parser@0:atom_fresh_[3183]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(op_left, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.parser@0:atom_fresh_[3185]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(op, 4, predicate, '[]', __36pos))).
':-'('<module>:emop.parser@0:atom_fresh_[3187]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(read_string, 4, predicate, '[]', __36pos))).
':-'('<module>:emop.parser@0:atom_fresh_[3189]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(append, 5, predicate, '[]', __36pos))).
':-'('<module>:emop.parser@0:atom_fresh_[3191]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(sequence_list, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.parser@0:atom_fresh_[3193]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(parse_end_of_file, 4, predicate, suspended([var('Delim'),var('Ops'),var('Values'),var('Ast')],[call(scope,catch,[none,var('E'),none])]), __36pos))).
':-'('<module>:emop.parser@0:atom_fresh_[3195]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(parse_right, 5, predicate, '[]', __36pos))).
':-'('<module>:emop.parser@0:atom_fresh_[3197]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(parse_module_body, 7, predicate, '[]', __36pos))).
':-'('<module>:emop.parser@0:atom_fresh_[3199]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(parse_module_env, 4, predicate, '[]', __36pos))).
':-'('<module>:emop.parser@0:atom_fresh_[3201]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(parse_module, 6, predicate, '[]', __36pos))).
':-'('<module>:emop.parser@0:atom_fresh_[3203]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(parse_string, 7, predicate, '[]', __36pos))).
':-'('<module>:emop.parser@0:atom_fresh_[3205]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(parse_left, 5, predicate, suspended([none,var('_Delim'),var('_Ops'),var('_Values'),var('_Ast')],[call(scope,throw,[none])]), __36pos))).
':-'('<module>:emop.parser@0:atom_fresh_[3207]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(parse_right, 4, predicate, suspended([var('Delim'),var('Ops'),var('Values'),var('Ast')],[call(var('Lexems'),read,[var('Lexem')]),call(var('Parser'),parse_right,[var('Lexem'),var('Delim'),var('Ops'),var('Values'),var('Ast')])]), __36pos))).
':-'('<module>:emop.parser@0:atom_fresh_[3209]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(parse_left, 4, predicate, suspended([var('Delim'),var('Ops'),var('Values'),var('Ast')],[call(var('Lexems'),read,[var('Lexem')]),call(var('Parser'),parse_left,[var('Lexem'),var('Delim'),var('Ops'),var('Values'),var('Ast')])]), __36pos))).
':-'('<module>:emop.parser@0:check_delim'('none', _, _PB, _PE, 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), 'throw'('error'('Unmatched delimiter', 'file'(_PB, _PE)))).
':-'('<module>:emop.parser@0:check_delim'('some'(_Delim, _, _), _Delim, _, _, 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), ','('true', ','('='(__36CutLevel, '$cut'), '!'))).
':-'('<module>:emop.parser@0:check_delim'('some'(_, _PB, _), _, _, _PE, 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), 'throw'('error'('Mismatched delimiters', 'file'(_PB, _PE)))).
':-'('<module>:emop.parser@0:check_delim$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@0:check_delim'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@0:check_no_delim'('none', 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), 'true').
':-'('<module>:emop.parser@0:check_no_delim'('some'(_, _PB, _PE), 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), 'throw'('error'('Unmatched delimiter', 'file'(_PB, _PE)))).
':-'('<module>:emop.parser@0:check_no_delim$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@0:check_no_delim'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@0:flush'('[]', _Values, _Ast, 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), ';'('->'('='('.'(_Ast, '[]'), _Values), 'true'), 'throw'('error'('flush')))).
':-'('<module>:emop.parser@0:flush'('.'('doc'(_Comment, _PB, _PE), _Tail), _Values0, _Ast, 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), ','('='(_Values0, '.'(_Value, _Values1)), 'emop_call'(_Parser, 'flush'(_Tail, '.'('doc'(_Comment, _PB, _PE, _Value), _Values1), _Ast), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 638, from character 19 to 24'))).
':-'('<module>:emop.parser@0:flush'('.'('op'(_, _, _Kind, _Op, _PB, _PE), _Tail), _Values0, _Ast, 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), ','('emop_call'(_Parser, 'apply_op'(_Kind, _Op, _PB, _PE, _Values0, _Values1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 645, from character 15 to 23'), 'emop_call'(_Parser, 'flush'(_Tail, _Values1, _Ast), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 646, from character 15 to 20'))).
':-'('<module>:emop.parser@0:flush$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@0:flush'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@0:flush_upto'('[]', _Values, _, _, _, '[]', _Values, 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), 'true').
':-'('<module>:emop.parser@0:flush_upto'('.'(_Op, _Tail), _Values0, _PE, _Priority1, _Assoc1, _Ops1, _Values1, 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), ';'('->'(','('='(_Op, 'op'(_Priority0, _Assoc0, _Kind, _Atom, _PB, _)), ';'(','('g_read'('data.number', '<module>:data.number'(___2341)), '<module>:data.number:<$direct'(_Priority0, _Priority1, ___2341)), ','('='(_Priority0, _Priority1), ';'('->'('emop_call'(_Parser, 'relative'(_Assoc0, _Assoc1, _Rel), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 666, from character 28 to 36'), ';'('->'('='(_Rel, 'precede'), 'true'), 'fail')), ';'('->'('='(_Atom, ':-'), 'throw'('error'('Operator :- is not associative.  A \'.\' is probably missing.', 'file'(_PB, _PE)))), ','(','('g_read'('data.atom', '<module>:data.atom'(___2352)), '<module>:data.atom:format$direct'('Operator conflict with ~a', '.'(_Atom, '[]'), ___2351, ___2352)), 'throw'('error'(___2351, 'file'(_PB, _PE))))))))), ','('emop_call'(_Parser, 'apply_op'(_Kind, _Atom, _PB, _PE, _Values0, _Values), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 687, from character 18 to 26'), 'emop_call'(_Parser, 'flush_upto'(_Tail, _Values, _PE, _Priority1, _Assoc1, _Ops1, _Values1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 688, from character 18 to 28'))), ','('='(_Ops1, '.'(_Op, _Tail)), '='(_Values1, _Values0)))).
':-'('<module>:emop.parser@0:flush_upto$direct'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@0:flush_upto'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@0:op'('.', '.', 1300, 'xfy', 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), 'true').
':-'('<module>:emop.parser@0:op'(':-', ':-', 1200, 'xfx', 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), 'true').
':-'('<module>:emop.parser@0:op'(',', ',', 1000, 'xfy', 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), 'true').
':-'('<module>:emop.parser@0:op'('=', '=', 700, 'xfy', 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), 'true').
':-'('<module>:emop.parser@0:op'(':', ':', 50, 'yfx', 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), 'true').
':-'('<module>:emop.parser@0:op$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@0:op'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@0:op_binary'('xfx', 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), 'true').
':-'('<module>:emop.parser@0:op_binary'('xfy', 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), 'true').
':-'('<module>:emop.parser@0:op_binary'('yfx', 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), 'true').
':-'('<module>:emop.parser@0:op_binary$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@0:op_binary'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@0:op_left'('fx', 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), 'true').
':-'('<module>:emop.parser@0:op_left'('fy', 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), 'true').
':-'('<module>:emop.parser@0:op_left$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@0:op_left'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@0:op_right'('xf', 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), 'true').
':-'('<module>:emop.parser@0:op_right'('yf', 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), 'true').
':-'('<module>:emop.parser@0:op_right$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@0:op_right'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@0:parse_end_of_file'(_Delim, _Ops, _Values, _Ast, 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), 'catch'(','('emop_call'(_Parser, 'check_no_delim'(_Delim), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 399, from character 25 to 39'), 'emop_call'(_Parser, 'flush'(_Ops, _Values, _Ast), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 400, from character 25 to 30')), _E, ';'('->'('='(_Mode, 'toplevel'), 'fail'), 'throw'(_E)))).
':-'('<module>:emop.parser@0:parse_end_of_file$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@0:parse_end_of_file'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@0:parse_left'(_Delim, _Ops, _Values, _Ast, 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), ','('emop_call'(_Lexems, 'read'(_Lexem), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 133, from character 19 to 23'), 'emop_call'(_Parser, 'parse_left'(_Lexem, _Delim, _Ops, _Values, _Ast), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 134, from character 19 to 29'))).
':-'('<module>:emop.parser@0:parse_left'('.('(_Pb, _Pe), ___Delim, ___Ops, ___Values, ___Ast, 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), 'throw'('error'('Scope delimiter should be preceded by a module', 'file'(_Pb, _Pe)))).
':-'('<module>:emop.parser@0:parse_left'('comment'(_Kind, _Comment, _PB, _PE), _Delim, _Ops, _Values, _Ast, 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), ','(';'('->'('='(_Kind, 'doc'), '='(_Ops0, '.'('op'(1250, 'xfy', 'left', 'doc'(_Comment, _PB, _PE), _PB, _PE), _Ops))), '='(_Ops0, _Ops)), 'emop_call'(_Parser, 'parse_left'(_Delim, _Ops0, _Values, _Ast), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 163, from character 19 to 29'))).
':-'('<module>:emop.parser@0:parse_left'('number'(_Number, _PB, _Pos__end), _Delim, _Ops, _Values, _Ast, 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), ','('='(_Values0, '.'('number'(_Number, _PB, _Pos__end), _Values)), 'emop_call'(_Parser, 'parse_right'(_Delim, _Ops, _Values0, _Ast), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 173, from character 19 to 30'))).
':-'('<module>:emop.parser@0:parse_left'('('(_PB, _PE), _Delim, _Ops, _Values, _Ast, 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), ','('emop_call'(_Parser, 'parse_left'('some'(')', _PB, _PE), '[]', '[]', _V), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 176, from character 19 to 29'), ','('='(_Values0, '.'('()'(_V, _PB, _PE), _Values)), 'emop_call'(_Parser, 'parse_right'(_Delim, _Ops, _Values0, _Ast), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 178, from character 19 to 30')))).
':-'('<module>:emop.parser@0:parse_left'('['(_PB, _PE), _Delim, _Ops, _Values, _Ast, 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), ','('emop_call'(_Parser, 'parse_left'('some'(']', _PB, _PE), '[]', '[]', _Contents), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 181, from character 19 to 29'), ','(';'('->'('='(_Contents, 'callable'('|', 'operator', '.'(_Seq, '.'(_Tail, '[]')), _, _)), 'true'), ','('='(_Seq, _Contents), '='(_Tail, 'callable'('[]', 'unescaped', 'none', _PB, _PE)))), ','('emop_call'(_Parser, 'sequence_list'(_Seq, _List), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 190, from character 19 to 32'), ','('emop_call'(_Parser, 'append'(_List, _Tail, _PB, _PE, _V), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 191, from character 19 to 25'), ','('='(_Values0, '.'(_V, _Values)), 'emop_call'(_Parser, 'parse_right'(_Delim, _Ops, _Values0, _Ast), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 193, from character 19 to 30'))))))).
':-'('<module>:emop.parser@0:parse_left'('{'(_PB, _PE), _Delim, _Ops, _Values, _Ast, 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), ','('emop_call'(_Parser, 'parse_left'('some'('}', _PB, _PE), '[]', '[]', _V), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 196, from character 19 to 29'), ','(';'('->'('='(_V, 'empty'(_, _)), '='(_Args, '[]')), '='(_Args, '.'(_V, '[]'))), ','('='(_Values0, '.'('callable'('{}', 'unescaped', _Args, _PB, _PE), _Values)), 'emop_call'(_Parser, 'parse_right'(_Delim, _Ops, _Values0, _Ast), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 205, from character 19 to 30'))))).
':-'('<module>:emop.parser@0:parse_left'('atom'(_Atom, _Escaped, _PB, _PE), _Delim, _Ops, _Values, _Ast, 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), ';'('->'(','('='(_Escaped, 'unescaped'), ','('emop_call'(_Parser, 'op'(_Atom, _TrueAtom, _Priority, _Assoc), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 217, from character 18 to 20'), 'emop_call'(_Parser, 'op_left'(_Assoc), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 218, from character 18 to 25'))), ','('emop_call'(_Lexems, 'read'(_Lexem), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 221, from character 22 to 26'), ';'('->'(','('='(_Atom, '-'), '='(_Lexem, 'number'(_Number, _, _PE0))), ','(','('='(_Values0, '.'('number'(___2089, _PB, _PE0), _Values)), ','('g_read'('data.number', '<module>:data.number'(___2090)), '<module>:data.number:-$direct'(_Number, ___2089, ___2090))), 'emop_call'(_Parser, 'parse_right'(_Delim, _Ops, _Values0, _Ast), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 227, from character 25 to 36'))), ','('='(_Op, 'op'(_Priority, _Assoc, 'left', _TrueAtom, _PB, _PE)), ','('='(_Ops0, '.'(_Op, _Ops)), 'emop_call'(_Parser, 'parse_left'(_Lexem, _Delim, _Ops0, _Values, _Ast), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 231, from character 25 to 35')))))), ';'('->'(','('='(_Escaped, 'unescaped'), '='(_Atom, 'module')), 'emop_call'(___265, 'parse_module'(_PB, _PE, _Delim, _Ops, _Values, _Ast), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 237, from character 15 to 27')), ';'('->'('='(_Escaped, 'unescaped'), ','('='(_Value, 'callable'(_Atom, 'unescaped', 'none', _PB, _PE)), 'emop_call'(_Parser, 'parse_right'(_Delim, _Ops, '.'(_Value, _Values), _Ast), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 242, from character 22 to 33'))), ','('='(_Value, 'callable'(_Atom, _Escaped, 'none', _PB, _PE)), 'emop_call'(_Parser, 'parse_right'(_Delim, _Ops, '.'(_Value, _Values), _Ast), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 245, from character 22 to 33')))))).
':-'('<module>:emop.parser@0:parse_left'('string'(_String, _PB, _PE), _Delim, _Ops, _Values, _Ast, 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), 'emop_call'(_Parser, 'parse_string'(_String, _PB, _PE, _Delim, _Ops, _Values, _Ast), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 249, from character 19 to 31')).
':-'('<module>:emop.parser@0:parse_left'('functor'(_Atom, _Escaped, _PB, _PE), _Delim, _Ops, _Values, _Ast, 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), ','('emop_call'(_Parser, 'parse_left'('some'(')', _PB, _PE), '[]', '[]', _Seq), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 341, from character 19 to 29'), ','('emop_call'(_Parser, 'sequence_list'(_Seq, _List), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 342, from character 19 to 32'), ','('='(_Value, 'callable'(_Atom, _Escaped, _List, _PB, _PE)), ','('='(_Values0, '.'(_Value, _Values)), 'emop_call'(_Parser, 'parse_right'(_Delim, _Ops, _Values0, _Ast), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 345, from character 19 to 30')))))).
':-'('<module>:emop.parser@0:parse_left'('close'(_Symbol, _PB, _PE), _Delim, _Ops, _Values, _Ast, 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), ','('='(_Values0, '.'('empty'(_PB, _PE), _Values)), ','('emop_call'(_Parser, 'check_delim'(_Delim, _Symbol, _PB, _PE), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 355, from character 19 to 30'), 'emop_call'(_Parser, 'flush'(_Ops, _Values0, _Ast), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 356, from character 19 to 24')))).
':-'('<module>:emop.parser@0:parse_left'('end_of_file'(_P), _Delim, _Ops, _Values, _Ast, 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), 'emop_call'(___265, 'parse_end_of_file'(_Delim, _Ops, '.'('empty'(_P, _P), _Values), _Ast), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 359, from character 12 to 29')).
':-'('<module>:emop.parser@0:parse_left'('end_of_line'(_), _Delim, _Ops, _Values, _Ast, 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), 'emop_call'(_Parser, 'parse_left'(_Delim, _Ops, _Values, _Ast), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 362, from character 19 to 29')).
':-'('<module>:emop.parser@0:parse_left$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@0:parse_left'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@0:parse_left$direct'(_____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@0:parse_left'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@0:parse_module'(_PB, _PE, _Delim, _Ops, _Values, _Ast, 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), ','('emop_call'(_Lexems, 'read'(_Lexem), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 275, from character 19 to 23'), ','(';'('->'('='(_Lexem, 'atom'(___Atom, ___Escaped, ___AtomPB, ___AtomPE)), ','('='(_Name, _Lexem), 'emop_call'(_Lexems, 'read'(_Lexem0), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 280, from character 22 to 26'))), ','('='(_Name, 'atom'('_', 'unescaped', _PB, _PE)), '='(_Lexem0, _Lexem))), ','(';'('->'('emop_call'(___265, 'parse_module_env'(_Lexem0, _Curly__begin, _Curly__end, _Env), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 286, from character 15 to 31'), 'true'), 'throw'('error'('Module body is missing', 'file'(_PB, _PE)))), ','('emop_call'(___265, 'parse_module_body'(_Curly__begin, _Curly__end, _Env, _Name, _PB, _PE, _V), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 292, from character 12 to 29'), ','('='(_Values0, '.'(_V, _Values)), 'emop_call'(___265, 'parse_right'(_Delim, _Ops, _Values0, _Ast), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 294, from character 12 to 23'))))))).
':-'('<module>:emop.parser@0:parse_module$direct'(_____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@0:parse_module'(_____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@0:parse_module_body'(_Curly__begin, _Curly__end, _Env, _Name, _PB, _PE, _V, 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), ','('emop_call'(_Parser, 'parse_left'('some'('}', _Curly__begin, _Curly__end), '[]', '[]', _Body), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 319, from character 19 to 29'), ','(';'('->'(','('g_read'('data.var', '<module>:data.var'(___2134)), '<module>:data.var:check$direct'(_EmopSgn, ___2134)), 'throw'('error'('Unallowed module', 'file'(_PB, _PE)))), ';'('->'(','(','('='(_Clauses, ___2138), 'emop_call'(_EmopSgn, 'enum_clauses'(_Body, ___2138), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 325, from character 33 to 45')), ','('='(_Sgn, ___2139), 'emop_call'(_EmopSgn, 'extract_sgn'(_Clauses, ___2139), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 326, from character 29 to 40'))), 'true'), 'throw'('sgn error'))), '='(_V, 'module'(_Name, _Env, _Body, _Sgn, _Clauses, _PB, _Curly__end))))).
':-'('<module>:emop.parser@0:parse_module_body$direct'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@0:parse_module_body'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@0:parse_module_env'(_Lexem, _Curly__begin, _Curly__end, _Env, 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), ';'('->'('='(_Lexem, '{'(_Curly__begin, _Curly__end)), '='(_Env, 'none')), ';'('->'('='(_Lexem, '['(_Env__begin, _Env__end)), ','('emop_call'(_Parser, 'parse_left'('some'(']', _Env__begin, _Env__end), '[]', '[]', _Seq), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 304, from character 22 to 32'), ','('emop_call'(_Parser, 'sequence_list'(_Seq, _Env), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 305, from character 22 to 35'), ','('emop_call'(_Lexems, 'read'(_Lexem0), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 306, from character 22 to 26'), ';'('->'('='(_Lexem0, '{'(_Curly__begin, _Curly__end)), 'true'), 'fail'))))), 'fail'))).
':-'('<module>:emop.parser@0:parse_module_env$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@0:parse_module_env'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@0:parse_right'(_Delim, _Ops, _Values, _Ast, 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), ','('emop_call'(_Lexems, 'read'(_Lexem), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 137, from character 19 to 23'), 'emop_call'(_Parser, 'parse_right'(_Lexem, _Delim, _Ops, _Values, _Ast), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 138, from character 19 to 30'))).
':-'('<module>:emop.parser@0:parse_right'('comment'(_Kind, _, _Pb, _Pe), _Delim, _Ops, _Values, _Ast, 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','(';'('->'('='(_Kind, 'doc'), 'throw'('error'('Documentation not allowed here', 'file'(_Pb, _Pe)))), 'true'), 'emop_call'(_Parser, 'parse_right'(_Delim, _Ops, _Values, _Ast), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 379, from character 19 to 30')))).
':-'('<module>:emop.parser@0:parse_right'('close'(_Symbol, _PB, _PE), _Delim, _Ops, _Values, _Ast, 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','('emop_call'(_Parser, 'check_delim'(_Delim, _Symbol, _PB, _PE), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 389, from character 19 to 30'), 'emop_call'(_Parser, 'flush'(_Ops, _Values, _Ast), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 390, from character 19 to 24')))).
':-'('<module>:emop.parser@0:parse_right'('end_of_file'(_), _Delim, _Ops, _Values, _Ast, 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), 'emop_call'(___265, 'parse_end_of_file'(_Delim, _Ops, _Values, _Ast), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 394, from character 12 to 29'))).
':-'('<module>:emop.parser@0:parse_right'('end_of_line'(_), _Delim, _Ops, _Values, _Ast, 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), 'emop_call'(_Parser, 'parse_right'(_Delim, _Ops, _Values, _Ast), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 416, from character 19 to 30'))).
':-'('<module>:emop.parser@0:parse_right'('atom'('|', 'unescaped', _PB, _PE), _Delim, _Ops, _Values, _Ast, 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), ','('='(_Delim, 'some'(']', _, _)), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','('emop_call'(_Parser, 'flush_upto'(_Ops, _Values, _PE, 1050, 'xfx', _Ops0, _Values0), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 427, from character 19 to 29'), ','('='(_Op, 'op'(1050, 'xfx', 'binary', '|', _PB, _PE)), ','('='(_Ops1, '.'(_Op, _Ops0)), 'emop_call'(_Parser, 'parse_left'(_Delim, _Ops1, _Values0, _Ast), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 438, from character 19 to 29'))))))).
':-'('<module>:emop.parser@0:parse_right'('atom'(_Atom, _Escaped, _PB, _PE), _Delim, _Ops, _Values, _Ast, 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), ','('->'('='(_Escaped, 'unescaped'), 'true'), ','('->'(','('emop_call'(_Parser, 'op'(_Atom, _TrueAtom, _Priority, _Assoc), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 453, from character 22 to 24'), ';'('->'('emop_call'(_Parser, 'op_binary'(_Assoc), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 455, from character 25 to 34'), '='(_Kind, 'binary')), '->'('emop_call'(_Parser, 'op_right'(_Assoc), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 459, from character 25 to 33'), '='(_Kind, 'right')))), 'true'), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','('emop_call'(_Parser, 'flush_upto'(_Ops, _Values, _PE, _Priority, _Assoc, _Ops0, _Values0), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 467, from character 19 to 29'), ';'('->'('='(_Kind, 'binary'), ','('='(_Op, 'op'(_Priority, _Assoc, 'binary', _TrueAtom, _PB, _PE)), ','('='(_Ops1, '.'(_Op, _Ops0)), 'emop_call'(_Parser, 'parse_left'(_Delim, _Ops1, _Values0, _Ast), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 481, from character 22 to 32')))), ','('='(_Values0, '.'(_Arg, _Tail)), ','('='(_Values1, '.'('callable'(_TrueAtom, 'unespaced', '.'(_Arg, '[]'), _PB, _PE), _Tail)), 'emop_call'(_Parser, 'parse_right'(_Delim, _Ops0, _Values1, _Ast), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 485, from character 22 to 33'))))))))).
':-'('<module>:emop.parser@0:parse_right'(_Lexem, _Delim, _Ops, _Values, _Ast, 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), ','(';'('='(_Lexem, '['(___PB, ___PE)), '='(_Lexem, '{'(___PB, ___PE))), ','('='(_Values, '.'(_Value, _Values0)), ','(','('g_read'('emop.parser', '<module>:emop.parser'(___2193)), '<module>:emop.parser:eliminate_parenthesis$direct'(_Value, _Value0, ___2193)), ','('='(_Value0, 'callable'(_F, _Escaped, _Args, _PB, _PE)), ','('\\='(_Args, 'none'), ','('='(_Name, 'atom'('_', 'unescaped', _PB, _PE)), ','('emop_call'(___265, 'parse_module_env'(_Lexem, _Curly__begin, _Curly__end, _Env), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 499, from character 12 to 28'), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','('emop_call'(___265, 'parse_module_body'(_Curly__begin, _Curly__end, _Env, _Name, _PB, _PE, _V), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 501, from character 12 to 29'), ','(','('g_read'('data.list', '<module>:data.list'(___2202)), '<module>:data.list:append$direct'(_Args, '.'(_V, '[]'), _Args0, ___2202)), ','('='(_Values1, '.'('callable'(_F, _Escaped, _Args0, _PB, _PE), _Values0)), 'emop_call'(_Parser, 'parse_right'(_Delim, _Ops, _Values1, _Ast), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 504, from character 19 to 30'))))))))))))).
':-'('<module>:emop.parser@0:parse_right'('.('(_Pb, _Pe), _Delim, _Ops, _Values, _Ast, 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','('emop_call'(_Parser, 'flush_upto'(_Ops, _Values, _Pe, 80, 'xfy', _Ops0, '.'(_PrefixArg, _Values0)), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 514, from character 19 to 29'), ','('emop_call'(_Parser, 'parse_left'('some'(')', _Pb, _Pe), '[]', '[]', _V), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 523, from character 19 to 29'), ','('='(_Values1, '.'('.()'(_PrefixArg, _V, _Pb, _Pe), _Values0)), 'emop_call'(_Parser, 'parse_right'(_Delim, _Ops0, _Values1, _Ast), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 525, from character 19 to 30')))))).
':-'('<module>:emop.parser@0:parse_right'(_Term, _Delim, _Ops, _Values, _Ast, 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), ','('='(_Values, '.'(_First, _)), ','(','('g_read'('emop.parse', '<module>:emop.parse'(___2217)), '<module>:emop.parse:position$direct'(_First, 'file'(_, _Pe), ___2217)), ','('emop_call'(_Parser, 'flush_upto'(_Ops, _Values, _Pe, 100, 'xfy', _Ops0, _Values0), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 530, from character 19 to 29'), ','('='(_Ops1, '.'('op'(100, 'xfy', 'binary', '$~$', _Pe, _Pe), _Ops0)), 'emop_call'(_Parser, 'parse_left'(_Term, _Delim, _Ops1, _Values0, _Ast), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 540, from character 19 to 29')))))).
':-'('<module>:emop.parser@0:parse_right$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@0:parse_right'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@0:parse_right$direct'(_____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@0:parse_right'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@0:parse_string'(_String, _PB, _PE, _Delim, _Ops, _Values, _Ast, 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), ','('emop_call'(_Lexems, 'read'(_Lexem), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 252, from character 19 to 23'), ';'('->'('='(_Lexem, 'end_of_line'(_)), 'emop_call'(_Parser, 'parse_string'(_String, _PB, _PE, _Delim, _Ops, _Values, _Ast), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 256, from character 22 to 34')), ';'('->'('='(_Lexem, 'string'(_String0, _, _PE0)), ','(','('g_read'('data.list', '<module>:data.list'(___2111)), '<module>:data.list:append$direct'(_String, _String0, ___2110, ___2111)), 'emop_call'(_Parser, 'parse_string'(___2110, _PB, _PE0, _Delim, _Ops, _Values, _Ast), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 260, from character 22 to 34'))), ','('emop_call'(___265, 'read_string'(_String, _PB, _PE, _Value), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 270, from character 15 to 26'), 'emop_call'(_Parser, 'parse_right'(_Lexem, _Delim, _Ops, '.'(_Value, _Values), _Ast), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 271, from character 22 to 33')))))).
':-'('<module>:emop.parser@0:parse_string$direct'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@0:parse_string'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@0:read_string'('[]', _PB, _PE, 'callable'('[]', 'escaped', '[]', _PB, _PE), 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), 'true').
':-'('<module>:emop.parser@0:read_string'('.'(_H, _T), _PB, _PE, _Term, 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), ','('='(_Term, 'callable'('.', 'escaped', '.'('callable'(_H, 'escaped', '[]', _PB, _PE), '.'(_Tail, '[]')), _PB, _PE)), 'emop_call'(_Parser, 'read_string'(_T, _PB, _PE, _Tail), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 563, from character 19 to 30'))).
':-'('<module>:emop.parser@0:read_string$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@0:read_string'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@0:relative'('xfy', 'xfy', 'succede', 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), 'true').
':-'('<module>:emop.parser@0:relative'('yfx', 'yfx', 'precede', 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), 'true').
':-'('<module>:emop.parser@0:relative$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@0:relative'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@0:sequence_list'('empty'(_, _), '[]', 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), ','('true', ','('='(__36CutLevel, '$cut'), '!'))).
':-'('<module>:emop.parser@0:sequence_list'('callable'(',', 'operator', '.'(_Left, '.'(_Right, '[]')), _, _), '.'(_Left, _Tail), 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), 'emop_call'(_Parser, 'sequence_list'(_Right, _Tail), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 546, from character 19 to 32'))).
':-'('<module>:emop.parser@0:sequence_list'(_Term, '.'(_Term, '[]'), 'env'(___265, _Lexems, _Mode, _Parser, _EmopSgn), __36CutLevel), 'true').
':-'('<module>:emop.parser@0:sequence_list$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@0:sequence_list'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@1'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@1:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@1'('do'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@1:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@1'('do_list'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@1:do_list'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@1'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.parser@1$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.parser@1$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.parser@1$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.parser@1$has_predicate'('do'(_____2, _____1)), 'true').
':-'('<module>:emop.parser@1$has_predicate'('do_list'(_____2, _____1)), 'true').
':-'('<module>:emop.parser@10'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@10:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@10'('make'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@10:make'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@10'('get_number'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@10:get_number'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@10'('get_functor'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@10:get_functor'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@10'('get_variable_arg'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@10:get_variable_arg'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@10'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.parser@10$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.parser@10$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.parser@10$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.parser@10$has_predicate'('make'(_____2, _____1)), 'true').
':-'('<module>:emop.parser@10$has_predicate'('get_number'(_____2, _____1)), 'true').
':-'('<module>:emop.parser@10$has_predicate'('get_functor'(_____2, _____1)), 'true').
':-'('<module>:emop.parser@10$has_predicate'('get_variable_arg'(_____2, _____1)), 'true').
':-'('<module>:emop.parser@10:$sgn'(__36sgn, 'env'(___738, _Env), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',64370,1803,64360)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',64384,1803,64360)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','(','('true', '<module>:emop.parser@10:atom_fresh_[3075]'(_atom__fresh___913076_93, __36Pb, __36Pe)), '<module>:emop.parser@10:atom_fresh_[3077]'(_atom__fresh___913078_93, __36Pb, __36Pe)), '<module>:emop.parser@10:atom_fresh_[3079]'(_atom__fresh___913080_93, __36Pb, __36Pe)), '<module>:emop.parser@10:atom_fresh_[3081]'(_atom__fresh___913082_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913082_93, '.'(_atom__fresh___913080_93, '.'(_atom__fresh___913078_93, '.'(_atom__fresh___913076_93, '[]')))))))))).
':-'('<module>:emop.parser@10:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@10:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@10:atom_fresh_[3075]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(get_variable_arg, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.parser@10:atom_fresh_[3077]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(get_functor, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.parser@10:atom_fresh_[3079]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(get_number, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.parser@10:atom_fresh_[3081]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(make, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.parser@10:get_functor'(_X0, _Y, 'env'(___738, _Env), __36CutLevel), ','(','('='(_X, ___1005), ','('g_read'('emop.parser', '<module>:emop.parser'(___1006)), '<module>:emop.parser:eliminate_parenthesis$direct'(_X0, ___1005, ___1006))), ','(';'('->'('='(_X, 'callable'('/', 'operator', '.'(_Functor0, '.'(_Arity0, '[]')), _, _)), ','(','('='(_Functor, ___1013), ','('g_read'('emop.parser', '<module>:emop.parser'(___1014)), '<module>:emop.parser:eliminate_parenthesis$direct'(_Functor0, ___1013, ___1014))), ','('='(_Arity, ___1015), 'emop_call'(___738, 'get_number'(_Arity0, ___1015), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1928, from character 27 to 37')))), '='(_Functor, _X)), ','(';'('->'('='(_Functor, 'callable'(':', 'operator', '.'(_Mod0, '.'(_Symbol0, '[]')), _, _)), ','('emop_call'(___738, 'get_variable_arg'(_Mod0, _Mod), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1935, from character 19 to 35'), ','('='(_Symbol, ___1022), ','('g_read'('emop.parser', '<module>:emop.parser'(___1023)), '<module>:emop.parser:eliminate_parenthesis$direct'(_Symbol0, ___1022, ___1023))))), ','('='(_Mod, 'scope'), '='(_Symbol, _Functor))), ','(';'('->'('='(_Symbol, 'callable'(_F, 'unescaped', 'none', _, _)), ';'('->'(','(','('='(_Fe, ___1028), 'emop_call'(_Env, '{}'(_F, ___1028), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1945, from character 31 to 32')), ','('\\+'(','('g_read'('data.var', '<module>:data.var'(___1030)), '<module>:data.var:check$direct'(_Fe, ___1030))), '='(_Fe, 'predicate'(_Predicate, _Escaped, _FArity)))), ';'('->'(','('g_read'('data.var', '<module>:data.var'(___1033)), '<module>:data.var:check$direct'(_Arity, ___1033)), '='(_Arity, 'number'(_FArity))), 'true')), ','(','(','('g_read'('data.atom', '<module>:data.atom'(___1040)), '<module>:data.atom:format$direct'('~a should be bound to a predicate', '.'(_F, '[]'), ___1039, ___1040)), ','('g_read'('emop.parse', '<module>:emop.parse'(___1043)), '<module>:emop.parse:position$direct'(_Symbol, ___1042, ___1043))), 'throw'('error'(___1039, ___1042))))), ';'('->'('='(_Symbol, 'callable'(_Predicate, _Escaped, 'none', _, _)), ';'('->'(','('g_read'('data.var', '<module>:data.var'(___1048)), '<module>:data.var:check$direct'(_Arity, ___1048)), ','(','('g_read'('emop.parse', '<module>:emop.parse'(___1052)), '<module>:emop.parse:position$direct'(_X, ___1051, ___1052)), 'throw'('error'('Missing arity', ___1051)))), 'true')), ','(','('g_read'('emop.parse', '<module>:emop.parse'(___1057)), '<module>:emop.parse:position$direct'(_Symbol, ___1056, ___1057)), 'throw'('error'('Should be a functor', ___1056))))), '='(_Y, 'functor'(_Mod, _Predicate, _Escaped, _Arity))))))).
':-'('<module>:emop.parser@10:get_functor$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@10:get_functor'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@10:get_number'(_X, _Y, 'env'(___738, _Env), __36CutLevel), ','('='(_X, ___892), ';'('->'(','('='(___893, _Value), ','('='(___892, 'number'(___893, ___894, ___895)), ','('true', 'true'))), '='(_Y, 'number'(_Value))), ','('='(___892, ___896), ';'('->'(','('='(___897, '#'), ','('='(___898, 'operator'), ','('='(___903, _Arg), ','('='(___904, '[]'), ','('='(___899, '.'(___903, ___904)), ','('='(___896, 'callable'(___897, ___898, ___899, ___900, ___901)), ','('true', 'true'))))))), ','(','('true', ';'('->'('var'(___956), ','('g_inc'('$module_count', ___957), '='(___956, '$module'(___957, '.'('<module>:emop.parser@14'('env'(___956, _Y, _Env, ___738)), '[]'), '.'(___956, '[]'))))), ','('='(___956, '$module'(___957, ___958, _)), ','('='('.'(___959, ___960), ___958), ','('setarg'(1, ___958, '<module>:emop.parser@14'('env'(___956, _Y, _Env, ___738))), 'setarg'(2, ___958, '.'(___959, ___960))))))), 'emop_call'(___956, 'do'(_Arg), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1895, from character 21 to 23'))), ','('='(___896, ___902), ';'('->'(','('='(___905, '+'), ','('='(___906, 'operator'), ','('='(___911, _Left), ','('='(___919, _Right), ','('='(___920, '[]'), ','('='(___912, '.'(___919, ___920)), ','('='(___907, '.'(___911, ___912)), ','('='(___902, 'callable'(___905, ___906, ___907, ___908, ___909)), ','('true', 'true'))))))))), ','('='(_Y, '+'(___968, ___969)), ','('emop_call'(___738, 'get_number'(_Left, ___968), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1899, from character 27 to 37'), 'emop_call'(___738, 'get_number'(_Right, ___969), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1899, from character 45 to 55')))), ','('='(___902, ___910), ';'('->'(','('='(___913, '-'), ','('='(___914, 'operator'), ','('='(___921, _Left), ','('='(___929, _Right), ','('='(___930, '[]'), ','('='(___922, '.'(___929, ___930)), ','('='(___915, '.'(___921, ___922)), ','('='(___910, 'callable'(___913, ___914, ___915, ___916, ___917)), ','('true', 'true'))))))))), ','('='(_Y, '-'(___977, ___978)), ','('emop_call'(___738, 'get_number'(_Left, ___977), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1903, from character 27 to 37'), 'emop_call'(___738, 'get_number'(_Right, ___978), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1903, from character 45 to 55')))), ','('='(___910, ___918), ';'('->'(','('='(___923, '*'), ','('='(___924, 'operator'), ','('='(___931, _Left), ','('='(___939, _Right), ','('='(___940, '[]'), ','('='(___932, '.'(___939, ___940)), ','('='(___925, '.'(___931, ___932)), ','('='(___918, 'callable'(___923, ___924, ___925, ___926, ___927)), ','('true', 'true'))))))))), ','('='(_Y, '*'(___986, ___987)), ','('emop_call'(___738, 'get_number'(_Left, ___986), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1907, from character 27 to 37'), 'emop_call'(___738, 'get_number'(_Right, ___987), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1907, from character 45 to 55')))), ','('='(___918, ___928), ';'('->'(','('='(___933, '/'), ','('='(___934, 'operator'), ','('='(___941, _Left), ','('='(___947, _Right), ','('='(___948, '[]'), ','('='(___942, '.'(___947, ___948)), ','('='(___935, '.'(___941, ___942)), ','('='(___928, 'callable'(___933, ___934, ___935, ___936, ___937)), ','('true', 'true'))))))))), ','('='(_Y, '/'(___995, ___996)), ','('emop_call'(___738, 'get_number'(_Left, ___995), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1911, from character 27 to 37'), 'emop_call'(___738, 'get_number'(_Right, ___996), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1911, from character 45 to 55')))), ','('='(___928, ___938), ';'('->'(','('='(___943, _Sub), ','('='(___938, '()'(___943, ___944, ___945)), ','('true', 'true'))), ','('='(_Y, ___999), 'emop_call'(___738, 'get_number'(_Sub, ___999), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1915, from character 23 to 33'))), ','('='(___938, ___946), '->'('true', ','(','('g_read'('emop.parse', '<module>:emop.parse'(___1003)), '<module>:emop.parse:position$direct'(_X, ___1002, ___1003)), 'throw'('error'('Should be a number', ___1002)))))))))))))))))))).
':-'('<module>:emop.parser@10:get_number$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@10:get_number'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@10:get_variable_arg'(_X, _Y, 'env'(___738, _Env), __36CutLevel), ';'('->'(','('='(_X, 'callable'(_V, _VEscaped, _VArgs, _, _)), ','(','('g_read'('emop.parser', '<module>:emop.parser'(___1061)), '<module>:emop.parser:is_variable$direct'(_V, _VEscaped, _VArgs, ___1061)), ','(','('='(_V0, ___1062), 'emop_call'(_Env, '{}'(_V, ___1062), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1978, from character 28 to 29')), ','('\\+'(','('g_read'('data.var', '<module>:data.var'(___1064)), '<module>:data.var:check$direct'(_V0, ___1064))), '='(_V0, 'term'(_Y)))))), 'true'), ','(','('g_read'('emop.parse', '<module>:emop.parse'(___1069)), '<module>:emop.parse:position$direct'(_X, ___1068, ___1069)), 'throw'('error'('Should be a variable', ___1068))))).
':-'('<module>:emop.parser@10:get_variable_arg$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@10:get_variable_arg'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@10:make'('callable'('true', 'unescaped', 'none', _, _), 'true', 'env'(___738, _Env), __36CutLevel), ','('true', ','('='(__36CutLevel, '$cut'), '!'))).
':-'('<module>:emop.parser@10:make'('callable'(':', 'operator', '.'(_X, '.'(_Kind, '[]')), _, _), _Guard, 'env'(___738, _Env), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','(';'('->'('='(_Kind, 'callable'(_Kind0, 'unescaped', 'none', _, _)), 'true'), ','(','('g_read'('emop.parse', '<module>:emop.parse'(___856)), '<module>:emop.parse:position$direct'(_Kind, ___855, ___856)), 'throw'('error'('Invalid kind', ___855)))), ','('='(_Kind0, ___844), ';'('->'(','('='(___844, ___845), ';'('='(___845, 'var'), '='(___845, 'number'))), ','('='(_Guard, 'type_term'(_Kind0, ___860)), 'emop_call'(___738, 'get_variable_arg'(_X, ___860), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1820, from character 46 to 62'))), ','('='(___844, ___846), ';'('->'(','('='(___846, ___847), ';'('='(___847, 'constructor'), ','('='(___847, ___849), ';'('='(___849, 'predicate'), '='(___849, 'symbol'))))), ','('='(_Guard, 'sgn_check'(_Kind0, ___865)), 'emop_call'(___738, 'get_functor'(_X, ___865), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1824, from character 46 to 57'))), ','('='(___846, ___848), '->'('true', ','(','('g_read'('emop.parse', '<module>:emop.parse'(___870)), '<module>:emop.parse:position$direct'(_Kind, ___869, ___870)), 'throw'('error'('Unknown kind', ___869)))))))))))).
':-'('<module>:emop.parser@10:make'('()'(_Sub, _, _), _Guard, 'env'(___738, _Env), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), 'emop_call'(___738, 'make'(_Sub, _Guard), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1833, from character 16 to 20'))).
':-'('<module>:emop.parser@10:make'('callable'(',', 'operator', '.'(_A, '.'(_B, '[]')), _, _), _Guard, 'env'(___738, _Env), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','('emop_call'(___738, 'make'(_A, _Guard0), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1837, from character 16 to 20'), ','('emop_call'(___738, 'make'(_B, _Guard1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1838, from character 16 to 20'), '='(_Guard, ','(_Guard0, _Guard1)))))).
':-'('<module>:emop.parser@10:make'('callable'(';', 'operator', '.'(_A, '.'(_B, '[]')), _, _), _Guard, 'env'(___738, _Env), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','('emop_call'(___738, 'make'(_A, _Guard0), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1843, from character 16 to 20'), ','('emop_call'(___738, 'make'(_B, _Guard1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1844, from character 16 to 20'), '='(_Guard, ';'(_Guard0, _Guard1)))))).
':-'('<module>:emop.parser@10:make'(_X, _, 'env'(___738, _Env), __36CutLevel), ','(','('g_read'('emop.parse', '<module>:emop.parse'(___890)), '<module>:emop.parse:position$direct'(_X, ___889, ___890)), 'throw'('error'('Invalid guard', ___889)))).
':-'('<module>:emop.parser@10:make$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@10:make'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@11'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@11:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@11'('do'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@11:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@11'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.parser@11$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.parser@11$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.parser@11$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.parser@11$has_predicate'('do'(_____1)), 'true').
':-'('<module>:emop.parser@11:$sgn'(__36sgn, 'env'(___746, _Env), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',71112,1987,71092)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',71144,1987,71092)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.parser@11:atom_fresh_[3073]'(_atom__fresh___913074_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913074_93, '[]'))))))).
':-'('<module>:emop.parser@11:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@11:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@11:atom_fresh_[3073]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.parser@11:do'('infer'(_V, _W, _X, _Pb, _Pe), 'env'(___746, _Env), __36CutLevel), ';'('->'(','('g_read'('data.var', '<module>:data.var'(___822)), '<module>:data.var:check$direct'(_W, ___822)), ','(','('g_read'('data.atom', '<module>:data.atom'(___828)), '<module>:data.atom:format$direct'('Cannot infer the length of ~a', '.'(_V, '[]'), ___827, ___828)), 'throw'('error'(___827, 'file'(_Pb, _Pe))))), ','('='(___831, 'sequence'(_X)), 'emop_call'(_Env, '{}'(_W, ___831), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1995, from character 23 to 24')))).
':-'('<module>:emop.parser@11:do$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@11:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@12'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@12:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@12'('do'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@12:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@12'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.parser@12$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.parser@12$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.parser@12$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.parser@12$has_predicate'('do'(_____1)), 'true').
':-'('<module>:emop.parser@12:$sgn'(__36sgn, 'env'(___755, _ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef, _Desc, _Desc0, _Env, _GrammarRef, _Grammars, _Grammars1, _Guard, _Guard0, _Guard1, _Head, _Head0, _Head1, _InferLengthRef, _LevelList, _Notations, _Pb, _Pe, _Tail, _Tail0, _Tail1), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',71537,1998,71517)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',71554,1998,71517)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.parser@12:atom_fresh_[3071]'(_atom__fresh___913072_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913072_93, '[]'))))))).
':-'('<module>:emop.parser@12:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@12:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@12:atom_fresh_[3071]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.parser@12:do'(_Level, 'env'(___755, _ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef, _Desc, _Desc0, _Env, _GrammarRef, _Grammars, _Grammars1, _Guard, _Guard0, _Guard1, _Head, _Head0, _Head1, _InferLengthRef, _LevelList, _Notations, _Pb, _Pe, _Tail, _Tail0, _Tail1), __36CutLevel), ','(','('='(_LevelNotations, ___780), 'emop_call'(_Notations, '{}'(_Level, ___780), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 2001, from character 43 to 44')), ','(';'('->'(','('g_read'('data.var', '<module>:data.var'(___782)), '<module>:data.var:check$direct'(_LevelNotations, ___782)), ','('='(_LevelNotations, ','(___784, ___788)), ','(','('g_read'('data.record', '<module>:data.record'(___785)), '<module>:data.record:{}$direct'(___784, ___785)), ','('g_read'('data.ref.backtrackable', '<module>:data.ref.backtrackable'(___789)), '<module>:data.ref.backtrackable:new$direct'('[]', ___788, ___789))))), 'true'), ','('='(_LevelNotations, ','(_Indexed, _Unindexed)), ','(';'('->'(','('emop_call'(_Unindexed, 'get'('[]'), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 2011, from character 29 to 32'), ','('='(_Head1, 'callable'(_F, _, _Args, _, _)), ','(','('g_read'('data.atom', '<module>:data.atom'(___795)), '<module>:data.atom:check$direct'(_F, ___795)), '\\+'(','('g_read'('data.list', '<module>:data.list'(___798)), '<module>:data.list:member$direct'('seq'(_), _Args, ___798)))))), ','(','('='(_List, ___810), ','(','(';'('->'('='(_Args, 'none'), '='(___779, 0)), ','('='(___779, ___803), ','('g_read'('data.list', '<module>:data.list'(___804)), '<module>:data.list:length$direct'(_Args, ___803, ___804)))), ','('g_read'('data.atom', '<module>:data.atom'(___809)), '<module>:data.atom:format$direct'('~a/~n', '.'(_F, '.'(___779, '[]')), ___808, ___809))), 'emop_call'(_Indexed, '{}'(___808, ___810), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 2016, from character 34 to 35'))), ';'('->'(','('g_read'('data.var', '<module>:data.var'(___812)), '<module>:data.var:check$direct'(_List, ___812)), ','('='(_List, ___815), ','('g_read'('data.ref.backtrackable', '<module>:data.ref.backtrackable'(___816)), '<module>:data.ref.backtrackable:new$direct'('[]', ___815, ___816)))), 'true'))), '='(_List, _Unindexed)), ','('emop_call'(_List, 'get'(___818), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 2027, from character 64 to 67'), 'emop_call'(_List, 'set'('.'('notation'(_Head1, _Guard1, _Tail1), ___818)), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 2027, from character 21 to 24'))))))).
':-'('<module>:emop.parser@12:do$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@12:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@13'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@13:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@13'('do'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@13:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@13'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.parser@13$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.parser@13$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.parser@13$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.parser@13$has_predicate'('do'(_____1)), 'true').
':-'('<module>:emop.parser@13:$sgn'(__36sgn, 'env'(___775, _GrammarRef, _SupGrammars), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',73239,2039,73220)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',73276,2039,73220)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.parser@13:atom_fresh_[3069]'(_atom__fresh___913070_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913070_93, '[]'))))))).
':-'('<module>:emop.parser@13:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@13:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@13:atom_fresh_[3069]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.parser@13:do'(_Item, 'env'(___775, _GrammarRef, _SupGrammars), __36CutLevel), ';'('->'(','('g_read'('emop.parser', '<module>:emop.parser'(___778)), '<module>:emop.parser:add_to_grammar$direct'(_Item, _GrammarRef, _SupGrammars, ___778)), 'true'), 'true')).
':-'('<module>:emop.parser@13:do$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@13:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@14'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@14:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@14'('do'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@14:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@14'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.parser@14$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.parser@14$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.parser@14$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.parser@14$has_predicate'('do'(_____1)), 'true').
':-'('<module>:emop.parser@14:$sgn'(__36sgn, 'env'(___961, _Y, _Env, ___738), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',66127,1857,66108)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',66144,1857,66108)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.parser@14:atom_fresh_[3083]'(_atom__fresh___913084_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913084_93, '[]'))))))).
':-'('<module>:emop.parser@14:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@14:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@14:atom_fresh_[3083]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.parser@14:do'(_Arg, 'env'(___961, _Y, _Env, ___738), __36CutLevel), ';'('->'('='(_Arg, 'callable'('*', 'operator', '.'(_Sub, '[]'), _, _)), ';'('->'(','('='(_Sub, 'callable'(_V, _VEscaped, _VArgs, _, _)), ','(','('g_read'('emop.parser', '<module>:emop.parser'(___1078)), '<module>:emop.parser:is_variable$direct'(_V, _VEscaped, _VArgs, ___1078)), ','(','('='(_V0, ___1079), 'emop_call'(_Env, '{}'(_V, ___1079), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1866, from character 39 to 40')), ','('\\+'(','('g_read'('data.var', '<module>:data.var'(___1081)), '<module>:data.var:check$direct'(_V0, ___1081))), ','('='(_V0, ___1071), ';'('='(___1071, 'sequence'(_S)), '='(___1071, 'sequence'(_, _S)))))))), '='(_Y, 'length'(_S))), ','(','('g_read'('emop.parse', '<module>:emop.parse'(___1088)), '<module>:emop.parse:position$direct'(_Sub, ___1087, ___1088)), 'throw'('error'('Should be a variable bound to a sequence', ___1087))))), ';'('->'(','('='(_Arg, 'callable'(_V, _VEscaped, _VArgs, _, _)), ','(','('='(_V0, ___1091), 'emop_call'(_Env, '{}'(_V, ___1091), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1876, from character 36 to 37')), '\\+'(','('g_read'('data.var', '<module>:data.var'(___1093)), '<module>:data.var:check$direct'(_V0, ___1093))))), ';'('->'('='(_V0, ','('sequence'(_S), 'sequence'(_, _S))), '='(_Y, 'length'(_S))), '->'('='(_V0, 'predicate'(_, _, _Arity)), '='(_Y, 'number'(_Arity))))), ';'('->'('='(_Arg, '()'(_Sub, _, _)), 'emop_call'(___961, 'do'(_Sub), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1891, from character 27 to 29')), ','(','('g_read'('emop.parse', '<module>:emop.parse'(___1104)), '<module>:emop.parse:position$direct'(_Arg, ___1103, ___1104)), 'throw'('error'('Should be a bound variable', ___1103))))))).
':-'('<module>:emop.parser@14:do$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@14:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@15'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@15:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@15'('get_fresh'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@15:get_fresh'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@15'('do_term_variable'(_____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@15:do_term_variable'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@15'('do_len_seq'(_____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@15:do_len_seq'(_____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@15'('do_len_seq_ref'(_____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@15:do_len_seq_ref'(_____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@15'('do_module_body'(_____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@15:do_module_body'(_____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@15'('head_seq'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@15:head_seq'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@15'('tail_seq'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@15:tail_seq'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@15'('do'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@15:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@15'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.parser@15$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.parser@15$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.parser@15$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.parser@15$has_predicate'('get_fresh'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser@15$has_predicate'('do_term_variable'(_____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser@15$has_predicate'('do_len_seq'(_____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser@15$has_predicate'('do_len_seq_ref'(_____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser@15$has_predicate'('do_module_body'(_____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser@15$has_predicate'('head_seq'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser@15$has_predicate'('tail_seq'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser@15$has_predicate'('do'(_____2, _____1)), 'true').
':-'('<module>:emop.parser@15:$sgn'(__36sgn, 'env'(___1111, _Mode, _Env, _InferLengthRef, _Grammars1, ___730), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',42933,1332,42898)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',42980,1332,42898)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','(','(','(','(','(','('true', '<module>:emop.parser@15:atom_fresh_[3087]'(_atom__fresh___913088_93, __36Pb, __36Pe)), '<module>:emop.parser@15:atom_fresh_[3089]'(_atom__fresh___913090_93, __36Pb, __36Pe)), '<module>:emop.parser@15:atom_fresh_[3091]'(_atom__fresh___913092_93, __36Pb, __36Pe)), '<module>:emop.parser@15:atom_fresh_[3093]'(_atom__fresh___913094_93, __36Pb, __36Pe)), '<module>:emop.parser@15:atom_fresh_[3095]'(_atom__fresh___913096_93, __36Pb, __36Pe)), '<module>:emop.parser@15:atom_fresh_[3097]'(_atom__fresh___913098_93, __36Pb, __36Pe)), '<module>:emop.parser@15:atom_fresh_[3099]'(_atom__fresh___913100_93, __36Pb, __36Pe)), '<module>:emop.parser@15:atom_fresh_[3101]'(_atom__fresh___913102_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913102_93, '.'(_atom__fresh___913100_93, '.'(_atom__fresh___913098_93, '.'(_atom__fresh___913096_93, '.'(_atom__fresh___913094_93, '.'(_atom__fresh___913092_93, '.'(_atom__fresh___913090_93, '.'(_atom__fresh___913088_93, '[]')))))))))))))).
':-'('<module>:emop.parser@15:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@15:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@15:atom_fresh_[3087]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.parser@15:atom_fresh_[3089]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(tail_seq, 4, predicate, '[]', __36pos))).
':-'('<module>:emop.parser@15:atom_fresh_[3091]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(head_seq, 4, predicate, '[]', __36pos))).
':-'('<module>:emop.parser@15:atom_fresh_[3093]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do_module_body, 6, predicate, '[]', __36pos))).
':-'('<module>:emop.parser@15:atom_fresh_[3095]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do_len_seq_ref, 8, predicate, '[]', __36pos))).
':-'('<module>:emop.parser@15:atom_fresh_[3097]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do_len_seq, 8, predicate, '[]', __36pos))).
':-'('<module>:emop.parser@15:atom_fresh_[3099]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do_term_variable, 5, predicate, '[]', __36pos))).
':-'('<module>:emop.parser@15:atom_fresh_[3101]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(get_fresh, 4, predicate, '[]', __36pos))).
':-'('<module>:emop.parser@15:do'('module'(_NameAtom, _Env0, _Body0, _Sgn0, _Clauses0, _Pb, _Pe), _Result, 'env'(___1111, _Mode, _Env, _InferLengthRef, _Grammars1, ___730), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','('='(_NameAtom, 'atom'(_Name0, _Escaped, _PbName, _PeName)), ','(';'('->'(','('g_read'('emop.parser', '<module>:emop.parser'(___1429)), '<module>:emop.parser:is_variable$direct'(_Name0, _Escaped, 'none', ___1429)), ';'('->'('='(_Name0, '_'), '='(_Name1, 'atom'(_Name0, _Escaped, _PbName, _PeName))), 'emop_call'(___1111, 'do_term_variable'(_Name0, _PbName, _PeName, 'variable', _Name1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1627, from character 28 to 44'))), 'throw'('error'('Only variables are supported for module name in notation.', 'file'(_PbName, _PeName)))), ','(';'('->'('='(_Env0, 'none'), '='(_Env1, 'none')), ','('='(_Env1, ___1445), ','(','('true', ';'('->'('var'(___1439), ','('g_inc'('$module_count', ___1440), '='(___1439, '$module'(___1440, '.'('<module>:emop.parser@17'('env'(___1439, _Env, _Mode, ___1111, ___730)), '[]'), '.'(___1439, '[]'))))), ','('='(___1439, '$module'(___1440, ___1441, _)), ','('='('.'(___1442, ___1443), ___1441), ','('setarg'(1, ___1441, '<module>:emop.parser@17'('env'(___1439, _Env, _Mode, ___1111, ___730))), 'setarg'(2, ___1441, '.'(___1442, ___1443))))))), ','('g_read'('data.list', '<module>:data.list'(___1446)), '<module>:data.list:iter$direct'(_Env0, ___1439, ___1445, ___1446))))), ','('emop_call'(___1111, 'do_module_body'(_Body0, _Sgn0, _Clauses0, _Pb, _Pe, _Body1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1704, from character 22 to 36'), '='(_Result, 'module'(_Name1, _Env1, _Body1, _Pb, _Pe)))))))).
':-'('<module>:emop.parser@15:do'('callable'(_F, _Escaped, _Args, _Pb, _Pe), _Result, 'env'(___1111, _Mode, _Env, _InferLengthRef, _Grammars1, ___730), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ';'('->'(','('g_read'('emop.parser', '<module>:emop.parser'(___1449)), '<module>:emop.parser:is_variable$direct'(_F, _Escaped, _Args, ___1449)), 'emop_call'(___1111, 'do_term_variable'(_F, _Pb, _Pe, 'variable', _Result), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1711, from character 25 to 41')), ';'('->'(','('='(_Escaped, 'unescaped'), ','('='(_Mode, 'head'), '->'(';'('='(_F, 'var'), '='(_F, 'number')), ','('='(_Args, '.'('callable'(_V, _VEscaped, _VArgs, _, _), '[]')), ','('g_read'('emop.parser', '<module>:emop.parser'(___1458)), '<module>:emop.parser:is_variable$direct'(_V, _VEscaped, _VArgs, ___1458)))))), 'emop_call'(___1111, 'do_term_variable'(_V, _Pb, _Pe, _F, _Result), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1727, from character 25 to 41')), ';'('->'(','('='(_Escaped, 'operator'), ','('='(_Mode, 'head'), '='(_F, '*'))), ','('='(_Result, ___1462), 'emop_call'(___1111, 'head_seq'(_Args, _Pb, _Pe, ___1462), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1733, from character 34 to 42'))), ';'('->'(','('='(_Escaped, 'operator'), ','('='(_F, '*'), ';'('='(_Mode, 'tail'), ';'('='(_Mode, 'seq'(_, _, _)), '->'('='(_Mode, 'arg'), 'throw'('error'('Sequences are not allowed as arguments of a predicate', 'file'(_Pb, _Pe)))))))), ','('='(_Result, ___1471), 'emop_call'(___1111, 'tail_seq'(_Args, _Pb, _Pe, ___1471), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1747, from character 34 to 42'))), ','(';'('->'('='(_Escaped, 'unescaped'), ';'('->'(';'('->'('='(_Mode, 'head'), ','('emop_call'(___1111, 'get_fresh'(_F, _Pb, _Pe, _Fe), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1756, from character 34 to 43'), ','('='(_Fe, 'predicate'(_X, _FEscaped, _FArity)), ','('='(_F0, 'variable'(_X, _FEscaped, _FArity)), '='(_Escaped0, 'unescaped'))))), '->'(';'('='(_Mode, 'tail'), '='(_Mode, 'arg')), ','(','('='(___1479, _U), 'emop_call'(_Env, '{}'(_F, ___1479), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1767, from character 38 to 39')), ';'('->'(','('g_read'('data.var', '<module>:data.var'(___1481)), '<module>:data.var:check$direct'(_U, ___1481)), ','('='(_F, _F0), '='(_Escaped, _Escaped0))), ','('='(_U, 'predicate'(_X, _FEscaped, _)), ','('='(_F0, _X), '='(_Escaped0, _FEscaped))))))), 'true'), ','(','('g_read'('data.atom', '<module>:data.atom'(___1488)), '<module>:data.atom:format$direct'('The variable ~a should only bind a predicate.', '.'(_F, '[]'), ___1487, ___1488)), 'throw'('error'(___1487, 'file'(_Pb, _Pe)))))), ','('='(_Escaped, _Escaped0), '='(_F, _F0))), ','(';'('->'('='(_Args, 'none'), '='(_Args0, 'none')), ','('='(_Args0, ___1494), ','('g_read'('data.list', '<module>:data.list'(___1495)), '<module>:data.list:iter$direct'(_Args, ___1111, ___1494, ___1495)))), '='(_Result, 'callable'(_F0, _Escaped0, _Args0, _Pb, _Pe)))))))))).
':-'('<module>:emop.parser@15:do'('()'(_Sub, _Pb, _Pe), '()'(___1498, _Pb, _Pe), 'env'(___1111, _Mode, _Env, _InferLengthRef, _Grammars1, ___730), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), 'emop_call'(___1111, 'do'(_Sub, ___1498), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1797, from character 53 to 55'))).
':-'('<module>:emop.parser@15:do'(_A, _A, 'env'(___1111, _Mode, _Env, _InferLengthRef, _Grammars1, ___730), __36CutLevel), 'true').
':-'('<module>:emop.parser@15:do$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@15:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@15:do_len_seq'(_U, _F, _Pb, _Pe, _LenRef, _AccuVars, _AccuLists, _Result, 'env'(___1111, _Mode, _Env, _InferLengthRef, _Grammars1, ___730), __36CutLevel), ','('='(_U, ___1237), ';'('->'(','('='(___1238, _V), '='(___1237, 'sequence'(___1238))), ';'('->'('='(_LenRef, _F), ','('='(_Result, _X), ','(','('emop_call'(_AccuVars, 'get'(___1243), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1427, from character 54 to 57'), 'emop_call'(_AccuVars, 'set'('.'(_X, ___1243)), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1427, from character 36 to 39')), ','('emop_call'(_AccuLists, 'get'(___1245), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1428, from character 56 to 59'), 'emop_call'(_AccuLists, 'set'('.'(_V, ___1245)), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1428, from character 37 to 40'))))), ','(','('g_read'('data.atom', '<module>:data.atom'(___1253)), '<module>:data.atom:format$direct'('Sequences ~a and ~a do not necessarily have the same length.', '.'(_LenRef, '.'(_F, '[]')), ___1252, ___1253)), 'throw'('error'(___1252, 'file'(_Pb, _Pe)))))), ','('='(___1237, ___1239), '->'(','('='(___1240, _V), ','('='(___1241, _W), '='(___1239, 'sequence'(___1240, ___1241)))), 'emop_call'(___1111, 'do_len_seq_ref'(_V, _W, _Pb, _Pe, _AccuLists, _AccuVars, _LenRef, _Result), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1435, from character 24 to 38')))))).
':-'('<module>:emop.parser@15:do_len_seq$direct'(_____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@15:do_len_seq'(_____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@15:do_len_seq_ref'(_V, _W, _Pb, _Pe, _AccuLists, _AccuVars, _LenRef, _Result, 'env'(___1111, _Mode, _Env, _InferLengthRef, _Grammars1, ___730), __36CutLevel), ';'('->'('='(_LenRef, _W), ','('='(_Result, _X), ','(','('emop_call'(_AccuVars, 'get'(___1257), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1443, from character 51 to 54'), 'emop_call'(_AccuVars, 'set'('.'(_X, ___1257)), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1443, from character 33 to 36')), ','('emop_call'(_AccuLists, 'get'(___1259), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1444, from character 53 to 56'), 'emop_call'(_AccuLists, 'set'('.'(_V, ___1259)), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1444, from character 34 to 37'))))), ','(','('g_read'('data.atom', '<module>:data.atom'(___1267)), '<module>:data.atom:format$direct'('Sequences ~a and ~a do not necessarily have the same length.', '.'(_LenRef, '.'(_W, '[]')), ___1266, ___1267)), 'throw'('error'(___1266, 'file'(_Pb, _Pe)))))).
':-'('<module>:emop.parser@15:do_len_seq_ref$direct'(_____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@15:do_len_seq_ref'(_____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@15:do_module_body'(_Body0, _Sgn0, _Clauses0, _Pb, _Pe, _Body1, 'env'(___1111, _Mode, _Env, _InferLengthRef, _Grammars1, ___730), __36CutLevel), ';'('->'(','('='(_Body0, 'callable'(_BodyF, _BodyEscaped, _BodyArgs, _, _)), ','('g_read'('emop.parser', '<module>:emop.parser'(___1271)), '<module>:emop.parser:is_variable$direct'(_BodyF, _BodyEscaped, _BodyArgs, ___1271))), ';'('->'('='(_Mode, 'head'), ';'('->'(','('='(___1273, 'module body'(_V)), 'emop_call'(_Env, '{}'(_BodyF, ___1273), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1458, from character 35 to 36')), '='(_Body1, _V)), ','(','('g_read'('data.atom', '<module>:data.atom'(___1280)), '<module>:data.atom:format$direct'('The variable ~a should only bind a module body.', '.'(_BodyF, '[]'), ___1279, ___1280)), 'throw'('error'(___1279, 'file'(_Pb, _Pe)))))), ','(','('='(_U, ___1283), 'emop_call'(_Env, '{}'(_BodyF, ___1283), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1465, from character 36 to 37')), ','(';'('->'(','('g_read'('data.var', '<module>:data.var'(___1285)), '<module>:data.var:check$direct'(_U, ___1285)), ','(','('g_read'('data.atom', '<module>:data.atom'(___1291)), '<module>:data.atom:format$direct'('Fresh variables cannot appear as module body.', '.'(_BodyF, '[]'), ___1290, ___1291)), 'throw'('error'(___1290, 'file'(_Pb, _Pe))))), 'true'), ';'('->'('='(_U, 'module body'(_V)), '='(_Body1, _V)), ','(','('g_read'('data.atom', '<module>:data.atom'(___1300)), '<module>:data.atom:format$direct'('The variable ~a should be a module body.', '.'(_BodyF, '[]'), ___1299, ___1300)), 'throw'('error'(___1299, 'file'(_Pb, _Pe))))))))), ';'('->'('='(_Mode, 'tail'), ','('='(_Rewrite, ___1111), ','(','('='(_Clauses1, ___1311), ','(','('true', ';'('->'('var'(___1305), ','('g_inc'('$module_count', ___1306), '='(___1305, '$module'(___1306, '.'('<module>:emop.parser@16'('env'(___1305, _Rewrite, _Grammars1, ___1111, ___730)), '[]'), '.'(___1305, '[]'))))), ','('='(___1305, '$module'(___1306, ___1307, _)), ','('='('.'(___1308, ___1309), ___1307), ','('setarg'(1, ___1307, '<module>:emop.parser@16'('env'(___1305, _Rewrite, _Grammars1, ___1111, ___730))), 'setarg'(2, ___1307, '.'(___1308, ___1309))))))), ','('g_read'('data.list', '<module>:data.list'(___1312)), '<module>:data.list:iter$direct'(_Clauses0, ___1305, ___1311, ___1312)))), '='(_Body1, 'custom'(_Sgn0, _Clauses1))))), 'throw'('error'('Only a variable is allowed as module body in head of notations.', 'file'(_Pb, _Pe)))))).
':-'('<module>:emop.parser@15:do_module_body$direct'(_____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@15:do_module_body'(_____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@15:do_term_variable'(_F, _Pb, _Pe, _Kind, _Result, 'env'(___1111, _Mode, _Env, _InferLengthRef, _Grammars1, ___730), __36CutLevel), ';'('->'('='(_F, '_'), '='(_Result, 'callable'('_', 'variable', 'none', _Pb, _Pe))), ','('='(_Mode, ___1124), ';'('->'('='(___1124, 'head'), ','(','('='(_X, ___1167), 'emop_call'(___1111, 'get_fresh'(_F, _Pb, _Pe, ___1167), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1353, from character 28 to 37')), ','('='(_X, 'term'(_V)), ','('g_read'('data.term', '<module>:data.term'(___1172)), '<module>:data.term:make$direct'(_Kind, '.'(_V, '[]'), _Result, ___1172))))), ','('='(___1124, ___1125), ';'('->'('='(___1125, 'tail'), ','(','('='(_U, ___1174), 'emop_call'(_Env, '{}'(_F, ___1174), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1359, from character 32 to 33')), ','('='(_U, ___1126), ';'('->'(','('='(___1126, ___1176), ','('g_read'('data.var', '<module>:data.var'(___1177)), '<module>:data.var:check$direct'(___1176, ___1177))), ','('='(_Result, 'fresh'(_)), '='(_U, 'term'(_Result)))), ','('='(___1126, ___1128), ';'('->'(','('='(___1128, ___1131), ';'(','('='(___1138, _V), '='(___1131, 'term'(___1138))), ','('='(___1131, ___1139), ';'(','('='(___1147, _V), '='(___1139, 'sequence'(___1147))), ','('='(___1139, ___1148), ';'(','('='(___1155, _V), '='(___1148, 'sequence'(___1155, ___1156))), ','('='(___1157, _V), '='(___1148, 'module env var'(___1157))))))))), '='(_Result, _V)), ','('='(___1128, ___1132), ';'('->'(','('='(___1132, 'predicate'(___1140, ___1141, ___1142)), ','('true', ','('true', 'true'))), ','(','('g_read'('data.atom', '<module>:data.atom'(___1190)), '<module>:data.atom:format$direct'('The variable ~a should only appear as predicate name.', '.'(_F, '[]'), ___1189, ___1190)), 'throw'('error'(___1189, 'file'(_Pb, _Pe))))), ','('='(___1132, ___1143), ';'('->'('='(___1143, 'module body'(___1149)), ','(','('g_read'('data.atom', '<module>:data.atom'(___1199)), '<module>:data.atom:format$direct'('The variable ~a should only appear as module body.', '.'(_F, '[]'), ___1198, ___1199)), 'throw'('error'(___1198, 'file'(_Pb, _Pe))))), ','('='(___1143, ___1150), '->'('='(___1150, 'module env seq'(___1158)), ','(','('g_read'('data.atom', '<module>:data.atom'(___1208)), '<module>:data.atom:format$direct'('The variable ~a should only appear as module environment.', '.'(_F, '[]'), ___1207, ___1208)), 'throw'('error'(___1207, 'file'(_Pb, _Pe)))))))))))))))), ','('='(___1125, ___1127), ';'('->'('='(___1127, 'arg'), ','(','('='(_U, ___1212), 'emop_call'(_Env, '{}'(_F, ___1212), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1385, from character 32 to 33')), ','('='(_U, ___1129), ';'('->'(','('='(___1129, ___1214), ','('g_read'('data.var', '<module>:data.var'(___1215)), '<module>:data.var:check$direct'(___1214, ___1215))), ','('='(_Result, 'fresh'(_)), '='(_U, 'term'(_Result)))), ','('='(___1129, ___1133), ';'('->'(','('='(___1133, ___1144), ';'(','('='(___1151, _V), '='(___1144, 'term'(___1151))), ','('='(___1152, _V), '='(___1144, 'module env var'(___1152))))), '='(_Result, _V)), ','('='(___1133, ___1145), '->'('true', ','(','('g_read'('data.atom', '<module>:data.atom'(___1225)), '<module>:data.atom:format$direct'('The variable ~a is not bound to a simple term and cannot appear as argument of a predicate.', '.'(_F, '[]'), ___1224, ___1225)), 'throw'('error'(___1224, 'file'(_Pb, _Pe)))))))))))), ','('='(___1127, ___1130), '->'(','('='(___1134, _AccuLists), ','('='(___1135, _AccuVars), ','('='(___1136, _LenRef), '='(___1130, 'seq'(___1134, ___1135, ___1136))))), ','(','('='(_U, ___1229), 'emop_call'(_Env, '{}'(_F, ___1229), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1403, from character 32 to 33')), ','('='(_U, ___1137), ';'('->'(','('='(___1137, ___1231), ','('g_read'('data.var', '<module>:data.var'(___1232)), '<module>:data.var:check$direct'(___1231, ___1232))), '='(_U, 'term'('fresh'(_)))), ','('='(___1137, ___1146), ';'('->'(','('='(___1146, ___1153), ';'(','('='(___1159, _V), '='(___1153, 'term'(___1159))), ','('='(___1160, _V), '='(___1153, 'module env var'(___1160))))), '='(_Result, _V)), ','('='(___1146, ___1154), '->'('true', 'emop_call'(___1111, 'do_len_seq'(_U, _F, _Pb, _Pe, _LenRef, _AccuVars, _AccuLists, _Result), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1415, from character 27 to 37')))))))))))))))))).
':-'('<module>:emop.parser@15:do_term_variable$direct'(_____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@15:do_term_variable'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@15:get_fresh'(_F, _Pb, _Pe, _X, 'env'(___1111, _Mode, _Env, _InferLengthRef, _Grammars1, ___730), __36CutLevel), ','(','('='(_X, ___1113), 'emop_call'(_Env, '{}'(_F, ___1113), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1335, from character 29 to 30')), ';'('->'(','('g_read'('data.var', '<module>:data.var'(___1115)), '<module>:data.var:check$direct'(_X, ___1115)), 'true'), ','(','('g_read'('data.atom', '<module>:data.atom'(___1121)), '<module>:data.atom:format$direct'('The variable ~a is already bound.', '.'(_F, '[]'), ___1120, ___1121)), 'throw'('error'(___1120, 'file'(_Pb, _Pe))))))).
':-'('<module>:emop.parser@15:get_fresh$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@15:get_fresh'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@15:head_seq'(_Args, _Pb, _Pe, _Result, 'env'(___1111, _Mode, _Env, _InferLengthRef, _Grammars1, ___730), __36CutLevel), ','(';'('->'(','('='(_Args, '.'('callable'(_V, _VEscaped, _VArgs, _, _), '[]')), ','('g_read'('emop.parser', '<module>:emop.parser'(___1320)), '<module>:emop.parser:is_variable$direct'(_V, _VEscaped, _VArgs, ___1320))), 'true'), 'throw'('error'('Sequence constructor should have a variable as unique argument', 'file'(_Pb, _Pe)))), ';'('->'(','('='(___1324, 'sequence'(_X)), 'emop_call'(_Env, '{}'(_V, ___1324), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1515, from character 29 to 30')), '='(_Result, 'seq'(_X))), ','(','('g_read'('data.atom', '<module>:data.atom'(___1332)), '<module>:data.atom:format$direct'('The variable ~a should only bind a sequence.', '.'(_V, '[]'), ___1331, ___1332)), 'throw'('error'(___1331, 'file'(_Pb, _Pe))))))).
':-'('<module>:emop.parser@15:head_seq$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@15:head_seq'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@15:tail_seq'(_Args, _Pb, _Pe, _Result, 'env'(___1111, _Mode, _Env, _InferLengthRef, _Grammars1, ___730), __36CutLevel), ';'('->'(','('='(_Args, '.'('callable'(_V, _VEscaped, _VArgs, _, _), '.'('callable'(_W, _VEscaped, _VArgs, _, _), '[]'))), ','(','('g_read'('emop.parser', '<module>:emop.parser'(___1340)), '<module>:emop.parser:is_variable$direct'(_V, _VEscaped, _VArgs, ___1340)), ','('g_read'('emop.parser', '<module>:emop.parser'(___1341)), '<module>:emop.parser:is_variable$direct'(_W, _VEscaped, _VArgs, ___1341)))), ','(','('='(_V0, ___1342), 'emop_call'(___1111, 'get_fresh'(_V, _Pb, _Pe, ___1342), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1532, from character 30 to 39')), ','(','('='(___1343, _V0), 'emop_call'(_Env, '{}'(_V, ___1343), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1533, from character 29 to 30')), ','(','('='(___1344, _W0), 'emop_call'(_Env, '{}'(_W, ___1344), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1534, from character 29 to 30')), ','(';'('->'(','('g_read'('data.var', '<module>:data.var'(___1346)), '<module>:data.var:check$direct'(_W0, ___1346)), ','(','('g_read'('data.atom', '<module>:data.atom'(___1352)), '<module>:data.atom:format$direct'('The variable ~a should be bound to a sequence.', '.'(_W, '[]'), ___1351, ___1352)), 'throw'('error'(___1351, 'file'(_Pb, _Pe))))), ';'('->'(';'(','('='(_W0, 'sequence'(_X)), '='(_W, _W1)), '='(_W0, 'sequence'(_, _W1))), 'true'), ','(','('g_read'('data.atom', '<module>:data.atom'(___1362)), '<module>:data.atom:format$direct'('The variable ~a is not bound to a sequence.', '.'(_W, '[]'), ___1361, ___1362)), 'throw'('error'(___1361, 'file'(_Pb, _Pe)))))), ','('='(_V0, 'sequence'(_Y, _W1)), '='(_Result, 'seq'(_Y, _X)))))))), ';'('->'('='(_Args, '.'(_Arg, '[]')), ';'('->'(','('='(_Arg, 'callable'(_V, _VEscaped, _VArgs, _, _)), ','('g_read'('emop.parser', '<module>:emop.parser'(___1370)), '<module>:emop.parser:is_variable$direct'(_V, _VEscaped, _VArgs, ___1370))), ','(','('='(_V0, ___1371), 'emop_call'(_Env, '{}'(_V, ___1371), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1560, from character 37 to 38')), ';'('->'(','('g_read'('data.var', '<module>:data.var'(___1373)), '<module>:data.var:check$direct'(_V0, ___1373)), ','(','('emop_call'(_InferLengthRef, 'get'(___1375), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1564, from character 93 to 96'), 'emop_call'(_InferLengthRef, 'set'('.'('infer'(_V, _W, _X, _Pb, _Pe), ___1375)), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1564, from character 46 to 49')), ';'('->'('='(_Mode, 'seq'(_AccuLists, _AccuVars, _LenRef)), ','('='(_V0, 'sequence'(_V, _W)), 'emop_call'(___1111, 'do_len_seq_ref'(_V, _W, _Pb, _Pe, _AccuLists, _AccuVars, _LenRef, _Result), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1569, from character 34 to 48'))), ','('='(_V0, 'sequence'(_Y, _W)), '='(_Result, 'seq'(_Y, _X)))))), ';'('->'('='(_Mode, 'seq'(_AccuLists, _AccuVars, _LenRef)), ';'('->'('emop_call'(___1111, 'do_len_seq'(_V0, _V, _Pb, _Pe, _LenRef, _AccuVars, _AccuLists, _Result), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1579, from character 37 to 47'), 'true'), ','(','('g_read'('data.atom', '<module>:data.atom'(___1387)), '<module>:data.atom:format$direct'('The variable ~a should be bound to a sequence', '.'(_V, '[]'), ___1386, ___1387)), 'throw'('error'(___1386, 'file'(_Pb, _Pe)))))), ';'('->'(';'('='(_V0, 'sequence'(_Se)), '='(_V0, 'sequence'(_Se, _))), '='(_Result, _Se)), ','(','('g_read'('data.atom', '<module>:data.atom'(___1397)), '<module>:data.atom:format$direct'('The variable ~a should be bound to a sequence', '.'(_V, '[]'), ___1396, ___1397)), 'throw'('error'(___1396, 'file'(_Pb, _Pe))))))))), ','(','('='(_AccuLists, ___1402), ','('g_read'('data.ref.backtrackable', '<module>:data.ref.backtrackable'(___1403)), '<module>:data.ref.backtrackable:new$direct'('[]', ___1402, ___1403))), ','(','('='(_AccuVars, ___1406), ','('g_read'('data.ref.backtrackable', '<module>:data.ref.backtrackable'(___1407)), '<module>:data.ref.backtrackable:new$direct'('[]', ___1406, ___1407))), ','(','('='(_Seq, ___1409), 'emop_call'(___730, 'rename'('seq'(_AccuLists, _AccuVars, _LenRef), _Arg, ___1409), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1602, from character 34 to 40')), ','(';'('->'(','('g_read'('data.var', '<module>:data.var'(___1411)), '<module>:data.var:check$direct'(_LenRef, ___1411)), 'throw'('error'('The sequence expression should be built from at least one sequence', 'file'(_Pb, _Pe)))), 'true'), ','('='(_Result, 'seq'(___1415, ___1416, _Seq)), ','('emop_call'(_AccuLists, 'get'(___1415), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1610, from character 53 to 56'), 'emop_call'(_AccuVars, 'get'(___1416), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1610, from character 67 to 70'))))))))), ','(','('g_read'('data.atom', '<module>:data.atom'(___1423)), '<module>:data.atom:format$direct'('Sequences should either be bound to a variable according to the length of another sequence or built by a sequence expression.', '.'(_V, '[]'), ___1422, ___1423)), 'throw'('error'(___1422, 'file'(_Pb, _Pe))))))).
':-'('<module>:emop.parser@15:tail_seq$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@15:tail_seq'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@16'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@16:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@16'('do'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@16:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@16'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.parser@16$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.parser@16$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.parser@16$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.parser@16$has_predicate'('do'(_____2, _____1)), 'true').
':-'('<module>:emop.parser@16:$sgn'(__36sgn, 'env'(___1310, _Rewrite, _Grammars1, ___1111, ___730), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',49484,1484,49438)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',49521,1484,49438)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.parser@16:atom_fresh_[3105]'(_atom__fresh___913106_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913106_93, '[]'))))))).
':-'('<module>:emop.parser@16:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@16:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@16:atom_fresh_[3105]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.parser@16:do'('clause'(_F, _Args, _B, _Doc, _Pb, _Pe), _Clause1, 'env'(___1310, _Rewrite, _Grammars1, ___1111, ___730), __36CutLevel), ','(';'('->'('='(_Args, 'none'), '='(_Args1, 'none')), ','('='(_Args1, ___1570), ','(','('true', ';'('->'('var'(___1564), ','('g_inc'('$module_count', ___1565), '='(___1564, '$module'(___1565, '.'('<module>:emop.parser@18'('env'(___1564, _Rewrite, _Grammars1, _Args, _Args1, _B, _B1, _Clause1, _Doc, _F, _Pb, _Pe, ___1310, ___1111, ___730)), '[]'), '.'(___1564, '[]'))))), ','('='(___1564, '$module'(___1565, ___1566, _)), ','('='('.'(___1567, ___1568), ___1566), ','('setarg'(1, ___1566, '<module>:emop.parser@18'('env'(___1564, _Rewrite, _Grammars1, _Args, _Args1, _B, _B1, _Clause1, _Doc, _F, _Pb, _Pe, ___1310, ___1111, ___730))), 'setarg'(2, ___1566, '.'(___1567, ___1568))))))), ','('g_read'('data.list', '<module>:data.list'(___1571)), '<module>:data.list:iter$direct'(_Args, ___1564, ___1570, ___1571))))), ','(','('='(_B1, ___1574), ','(','('g_read'('emop.parser', '<module>:emop.parser'(___1573)), '<module>:emop.parser:internal_reparse$direct'(_B, _Grammars1, ___1572, ___1573)), 'emop_call'(_Rewrite, 'do'(___1572, ___1574), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1496, from character 44 to 46'))), '='(_Clause1, 'clause'(_F, _Args1, _B1, _Doc, _Pb, _Pe))))).
':-'('<module>:emop.parser@16:do$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@16:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@17'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@17:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@17'('do'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@17:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@17'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.parser@17$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.parser@17$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.parser@17$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.parser@17$has_predicate'('do'(_____2, _____1)), 'true').
':-'('<module>:emop.parser@17:$sgn'(__36sgn, 'env'(___1444, _Env, _Mode, ___1111, ___730), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',56761,1636,56719)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',56785,1636,56719)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.parser@17:atom_fresh_[3103]'(_atom__fresh___913104_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913104_93, '[]'))))))).
':-'('<module>:emop.parser@17:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@17:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@17:atom_fresh_[3103]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.parser@17:do'('callable'(_F, _Escaped, _Args, _Pb, _Pe), _R, 'env'(___1444, _Env, _Mode, ___1111, ___730), __36CutLevel), ';'('->'(','('g_read'('emop.parser', '<module>:emop.parser'(___1510)), '<module>:emop.parser:is_variable$direct'(_F, _Escaped, _Args, ___1510)), ';'('->'('='(_Mode, 'head'), ';'('->'(','('='(___1512, 'module env var'(_V)), 'emop_call'(_Env, '{}'(_F, ___1512), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1646, from character 44 to 45')), '='(_R, 'variable'(_V))), ','(','('g_read'('data.atom', '<module>:data.atom'(___1520)), '<module>:data.atom:format$direct'('The variable ~a should only bind a module environment variable.', '.'(_F, '[]'), ___1519, ___1520)), 'throw'('error'(___1519, 'file'(_Pb, _Pe)))))), ','(','('='(_U, ___1523), 'emop_call'(_Env, '{}'(_F, ___1523), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1653, from character 45 to 46')), ','(';'('->'(','('g_read'('data.var', '<module>:data.var'(___1525)), '<module>:data.var:check$direct'(_U, ___1525)), '='(_U, 'module env var'('fresh'(_)))), 'true'), ';'('->'(','('='(_U, ___1501), ';'('='(___1501, 'module env var'(_V)), ','('='(___1501, ___1503), ';'('='(___1503, 'module env seq'(_V)), '='(___1503, 'term'(_V)))))), '='(_R, _V)), ','(','('g_read'('data.atom', '<module>:data.atom'(___1536)), '<module>:data.atom:format$direct'('The variable ~a should be a module environment variable.', '.'(_F, '[]'), ___1535, ___1536)), 'throw'('error'(___1535, 'file'(_Pb, _Pe))))))))), '->'(','('='(_F, '*'), ','('='(_Escaped, 'operator'), '='(_Args, '.'(_, '[]')))), ','('='(_Mode, ___1502), ';'('->'('='(___1502, 'head'), ';'('->'(','('='(_Args, '.'('callable'(_V, _VEscaped, _VArgs, _, _), '[]')), ','('g_read'('emop.parser', '<module>:emop.parser'(___1547)), '<module>:emop.parser:is_variable$direct'(_V, _VEscaped, _VArgs, ___1547))), ','(','('='(_VE, ___1548), 'emop_call'(___1111, 'get_fresh'(_V, _Pb, _Pe, ___1548), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1682, from character 45 to 54')), ','('='(_VE, 'module env seq'(_X)), '='(_R, 'seq'(_X))))), 'throw'('error'('Sequence constructor should have a variable as unique argument', 'file'(_Pb, _Pe))))), ','('='(___1502, ___1504), ';'('->'(','('='(___1504, ___1505), ';'('='(___1505, 'tail'), ','('='(___1505, 'seq'(___1507, ___1508, ___1509)), ','('true', ','('true', 'true'))))), 'emop_call'(___1111, 'tail_seq'(_Args, _Pb, _Pe, _R), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1695, from character 37 to 45')), ','('='(___1504, ___1506), '->'('='(___1506, 'arg'), 'throw'('error'('Sequences are not allowed as arguments of a predicate', 'file'(_Pb, _Pe)))))))))))).
':-'('<module>:emop.parser@17:do$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@17:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@18'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@18:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@18'('do'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@18:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@18'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.parser@18$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.parser@18$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.parser@18$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.parser@18$has_predicate'('do'(_____2, _____1)), 'true').
':-'('<module>:emop.parser@18:$sgn'(__36sgn, 'env'(___1569, _Rewrite, _Grammars1, _Args, _Args1, _B, _B1, _Clause1, _Doc, _F, _Pb, _Pe, ___1310, ___1111, ___730), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',49843,1491,49791)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',49855,1491,49791)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.parser@18:atom_fresh_[3107]'(_atom__fresh___913108_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913108_93, '[]'))))))).
':-'('<module>:emop.parser@18:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@18:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@18:atom_fresh_[3107]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 2, predicate, suspended([var('Arg'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.parser@18:do'(_Arg, ___1579, 'env'(___1569, _Rewrite, _Grammars1, _Args, _Args1, _B, _B1, _Clause1, _Doc, _F, _Pb, _Pe, ___1310, ___1111, ___730), __36CutLevel), ','(','('g_read'('emop.parser', '<module>:emop.parser'(___1578)), '<module>:emop.parser:internal_reparse$direct'(_Arg, _Grammars1, ___1577, ___1578)), 'emop_call'(___730, 'rename'('arg', ___1577, ___1579), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1493, from character 47 to 53'))).
':-'('<module>:emop.parser@18:do$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@18:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@1:$sgn'(__36sgn, 'env'(___281, _Grammars), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',21176,711,21170)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',21195,711,21170)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','('true', '<module>:emop.parser@1:atom_fresh_[3163]'(_atom__fresh___913164_93, __36Pb, __36Pe)), '<module>:emop.parser@1:atom_fresh_[3165]'(_atom__fresh___913166_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913166_93, '.'(_atom__fresh___913164_93, '[]')))))))).
':-'('<module>:emop.parser@1:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@1:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@1:atom_fresh_[3163]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do_list, 2, predicate, suspended([none,none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.parser@1:atom_fresh_[3165]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.parser@1:do'('callable'('$~$', 'operator', '.'(_A, '.'(_B, '[]')), _, _), _Ast, 'env'(___281, _Grammars), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','(','('='(_List, '.'(_A, ___2012)), ','('g_read'('emop.parse', '<module>:emop.parse'(___2013)), '<module>:emop.parse:enum_concat_list$direct'(_B, ___2012, ___2013))), ','(','('g_read'('emop.parser', '<module>:emop.parser'(___2016)), '<module>:emop.parser:reparse_list$direct'(_List, _Grammars, ___2015, ___2016)), 'emop_call'(___281, 'do'(___2015, _Ast), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 716, from character 12 to 14'))))).
':-'('<module>:emop.parser@1:do'('callable'(_F, _Escaped, _List, _Pb, _Pe), _Ast, 'env'(___281, _Grammars), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','('='(_Ast, 'callable'(_F, _Escaped, ___2018, _Pb, _Pe)), 'emop_call'(___281, 'do_list'(_List, ___2018), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 719, from character 39 to 46')))).
':-'('<module>:emop.parser@1:do'('()'(_SubTerm, _Pb, _Pe), _Ast, 'env'(___281, _Grammars), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','('='(_Ast, '()'(___2021, _Pb, _Pe)), 'emop_call'(___281, 'do'(_SubTerm, ___2021), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 722, from character 23 to 25')))).
':-'('<module>:emop.parser@1:do'('.()'(_A, _B, _Pb, _Pe), _Ast, 'env'(___281, _Grammars), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','('='(_Ast, '.()'(___2024, _B, _Pb, _Pe)), 'emop_call'(___281, 'do'(_A, ___2024), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 725, from character 24 to 26')))).
':-'('<module>:emop.parser@1:do'('module'(_Name, _Env, _Body, _Sgn, _Clauses, _Pb, _Pe), _Ast, 'env'(___281, _Grammars), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','('='(_Ast, 'module'(_Name, ___2027, _Body, _Sgn, _Clauses, _Pb, _Pe)), 'emop_call'(___281, 'do_list'(_Env, ___2027), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 728, from character 31 to 38')))).
':-'('<module>:emop.parser@1:do'(_Ast, _Ast, 'env'(___281, _Grammars), __36CutLevel), 'true').
':-'('<module>:emop.parser@1:do$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@1:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@1:do_list'('none', 'none', 'env'(___281, _Grammars), __36CutLevel), ','('true', ','('='(__36CutLevel, '$cut'), '!'))).
':-'('<module>:emop.parser@1:do_list'(_List, ___2032, 'env'(___281, _Grammars), __36CutLevel), ','('g_read'('data.list', '<module>:data.list'(___2033)), '<module>:data.list:iter$direct'(_List, ___281, ___2032, ___2033))).
':-'('<module>:emop.parser@1:do_list$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@1:do_list'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@2'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@2:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@2'('prefix_op'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@2:prefix_op'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@2'('postfix_op'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@2:postfix_op'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@2'('binary_op'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@2:binary_op'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@2'('operator'(_____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@2:operator'(_____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@2'('priority'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@2:priority'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@2'('op'(_____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@2:op'(_____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@2'('reassoc_left'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@2:reassoc_left'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@2'('apply_op'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@2:apply_op'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@2'('flush'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@2:flush'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@2'('!', __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@2:!'(__36env, __36CutLevel))).
':-'('<module>:emop.parser@2'('less_priority'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@2:less_priority'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@2'('compare_priorities'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@2:compare_priorities'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@2'('flush_upto'(_____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@2:flush_upto'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@2'('check_postfix'(_____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@2:check_postfix'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@2'('check_infix'(_____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@2:check_infix'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@2'('check_postfix_or_infix'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@2:check_postfix_or_infix'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@2'('reassoc_right'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@2:reassoc_right'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@2'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.parser@2$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.parser@2$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.parser@2$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.parser@2$has_predicate'('prefix_op'(_____1)), 'true').
':-'('<module>:emop.parser@2$has_predicate'('postfix_op'(_____1)), 'true').
':-'('<module>:emop.parser@2$has_predicate'('binary_op'(_____1)), 'true').
':-'('<module>:emop.parser@2$has_predicate'('operator'(_____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser@2$has_predicate'('priority'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser@2$has_predicate'('op'(_____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser@2$has_predicate'('reassoc_left'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser@2$has_predicate'('apply_op'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser@2$has_predicate'('flush'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser@2$has_predicate'('!'), 'true').
':-'('<module>:emop.parser@2$has_predicate'('less_priority'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser@2$has_predicate'('compare_priorities'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser@2$has_predicate'('flush_upto'(_____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser@2$has_predicate'('check_postfix'(_____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser@2$has_predicate'('check_infix'(_____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser@2$has_predicate'('check_postfix_or_infix'(_____2, _____1)), 'true').
':-'('<module>:emop.parser@2$has_predicate'('reassoc_right'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser@2:!'('env'(___297, _Grammars), __36CutLevel), 'true').
':-'('<module>:emop.parser@2:!$direct'(__36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@2:!'(__36env, __36CutLevel))).
':-'('<module>:emop.parser@2:$sgn'(__36sgn, 'env'(___297, _Grammars), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',22157,739,22151)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',22176,739,22151)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','('true', '<module>:emop.parser@2:atom_fresh_[3129]'(_atom__fresh___913130_93, __36Pb, __36Pe)), '<module>:emop.parser@2:atom_fresh_[3131]'(_atom__fresh___913132_93, __36Pb, __36Pe)), '<module>:emop.parser@2:atom_fresh_[3133]'(_atom__fresh___913134_93, __36Pb, __36Pe)), '<module>:emop.parser@2:atom_fresh_[3135]'(_atom__fresh___913136_93, __36Pb, __36Pe)), '<module>:emop.parser@2:atom_fresh_[3137]'(_atom__fresh___913138_93, __36Pb, __36Pe)), '<module>:emop.parser@2:atom_fresh_[3139]'(_atom__fresh___913140_93, __36Pb, __36Pe)), '<module>:emop.parser@2:atom_fresh_[3141]'(_atom__fresh___913142_93, __36Pb, __36Pe)), '<module>:emop.parser@2:atom_fresh_[3143]'(_atom__fresh___913144_93, __36Pb, __36Pe)), '<module>:emop.parser@2:atom_fresh_[3145]'(_atom__fresh___913146_93, __36Pb, __36Pe)), '<module>:emop.parser@2:atom_fresh_[3147]'(_atom__fresh___913148_93, __36Pb, __36Pe)), '<module>:emop.parser@2:atom_fresh_[3149]'(_atom__fresh___913150_93, __36Pb, __36Pe)), '<module>:emop.parser@2:atom_fresh_[3151]'(_atom__fresh___913152_93, __36Pb, __36Pe)), '<module>:emop.parser@2:atom_fresh_[3153]'(_atom__fresh___913154_93, __36Pb, __36Pe)), '<module>:emop.parser@2:atom_fresh_[3155]'(_atom__fresh___913156_93, __36Pb, __36Pe)), '<module>:emop.parser@2:atom_fresh_[3157]'(_atom__fresh___913158_93, __36Pb, __36Pe)), '<module>:emop.parser@2:atom_fresh_[3159]'(_atom__fresh___913160_93, __36Pb, __36Pe)), '<module>:emop.parser@2:atom_fresh_[3161]'(_atom__fresh___913162_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913162_93, '.'(_atom__fresh___913160_93, '.'(_atom__fresh___913158_93, '.'(_atom__fresh___913156_93, '.'(_atom__fresh___913154_93, '.'(_atom__fresh___913152_93, '.'(_atom__fresh___913150_93, '.'(_atom__fresh___913148_93, '.'(_atom__fresh___913146_93, '.'(_atom__fresh___913144_93, '.'(_atom__fresh___913142_93, '.'(_atom__fresh___913140_93, '.'(_atom__fresh___913138_93, '.'(_atom__fresh___913136_93, '.'(_atom__fresh___913134_93, '.'(_atom__fresh___913132_93, '.'(_atom__fresh___913130_93, '[]'))))))))))))))))))))))).
':-'('<module>:emop.parser@2:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@2:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@2:apply_op'('binary'(___Op, ___OpId, _Alias, ___Assoc, _Pb, _Pe), '.'(_Right, '.'(_Left, _ValueStack)), '.'('callable'(_Alias, 'operator', '.'(_Left, '.'(_Right, '[]')), _Pb, _Pe), _ValueStack), 'env'(___297, _Grammars), __36CutLevel), 'true').
':-'('<module>:emop.parser@2:apply_op'('prefix'(___Op, ___OpId, _Alias, ___Assoc, _Pb, _Pe), '.'(_Left, _ValueStack), '.'('callable'(_Alias, 'operator', '.'(_Left, '[]'), _Pb, _Pe), _ValueStack), 'env'(___297, _Grammars), __36CutLevel), 'true').
':-'('<module>:emop.parser@2:apply_op$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@2:apply_op'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@2:atom_fresh_[3129]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(reassoc_right, 4, predicate, suspended([none,var('OpStack'),var('ValueStack'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.parser@2:atom_fresh_[3131]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(check_postfix_or_infix, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.parser@2:atom_fresh_[3133]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(check_infix, 5, predicate, '[]', __36pos))).
':-'('<module>:emop.parser@2:atom_fresh_[3135]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(check_postfix, 5, predicate, '[]', __36pos))).
':-'('<module>:emop.parser@2:atom_fresh_[3137]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(flush_upto, 5, predicate, '[]', __36pos))).
':-'('<module>:emop.parser@2:atom_fresh_[3139]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(compare_priorities, 3, predicate, '[]', __36pos))).
':-'('<module>:emop.parser@2:atom_fresh_[3141]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(less_priority, 4, predicate, '[]', __36pos))).
':-'('<module>:emop.parser@2:atom_fresh_[3143]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(!, 0, predicate, [], __36pos))).
':-'('<module>:emop.parser@2:atom_fresh_[3145]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(flush, 3, predicate, suspended([none,none,var('Result')],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.parser@2:atom_fresh_[3147]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(apply_op, 3, predicate, suspended([none,none,none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.parser@2:atom_fresh_[3149]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(reassoc_left, 4, predicate, '[]', __36pos))).
':-'('<module>:emop.parser@2:atom_fresh_[3151]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(op, 6, constructor, none, __36pos))).
':-'('<module>:emop.parser@2:atom_fresh_[3153]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(priority, 3, constructor, none, __36pos))).
':-'('<module>:emop.parser@2:atom_fresh_[3155]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(operator, 6, constructor, none, __36pos))).
':-'('<module>:emop.parser@2:atom_fresh_[3157]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(binary_op, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.parser@2:atom_fresh_[3159]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(postfix_op, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.parser@2:atom_fresh_[3161]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(prefix_op, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.parser@2:binary_op'('xfx', 'env'(___297, _Grammars), __36CutLevel), 'true').
':-'('<module>:emop.parser@2:binary_op'('xfy', 'env'(___297, _Grammars), __36CutLevel), 'true').
':-'('<module>:emop.parser@2:binary_op'('yfx', 'env'(___297, _Grammars), __36CutLevel), 'true').
':-'('<module>:emop.parser@2:binary_op$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@2:binary_op'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@2:check_infix'(_Op, _Grammars, _OpId, _Alias, _Assoc, 'env'(___297, _Grammars), __36CutLevel), ','(','('g_read'('data.list', '<module>:data.list'(___1924)), '<module>:data.list:member$direct'(_Grammar, _Grammars, ___1924)), ','(','('='(___1918, _Op), ','('='(___1919, _OpId), ','('='(___1920, _Alias), ','('='(___1921, 'infix'), ','('='(___1922, _Assoc), ','('='(___1917, 'operator'(___1918, ___1919, ___1920, ___1921, ___1922)), ','('='(___1912, ___1927), ','('='(_Grammar, 'grammar'(___1912, ___1913, ___1914, ___1915, ___1916)), ','('g_read'('data.list', '<module>:data.list'(___1928)), ','('<module>:data.list:member$direct'(___1917, ___1927, ___1928), ','('true', ','('true', ','('true', 'true'))))))))))))), ','('true', ','('='(__36CutLevel, '$cut'), '!'))))).
':-'('<module>:emop.parser@2:check_infix$direct'(_____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@2:check_infix'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@2:check_postfix'(_Op, _Grammars, _OpId, _Alias, _Assoc, 'env'(___297, _Grammars), __36CutLevel), ','(','('g_read'('data.list', '<module>:data.list'(___1905)), '<module>:data.list:member$direct'(_Grammar, _Grammars, ___1905)), ','(','('='(___1899, _Op), ','('='(___1900, _OpId), ','('='(___1901, _Alias), ','('='(___1902, 'postfix'), ','('='(___1903, _Assoc), ','('='(___1898, 'operator'(___1899, ___1900, ___1901, ___1902, ___1903)), ','('='(___1893, ___1908), ','('='(_Grammar, 'grammar'(___1893, ___1894, ___1895, ___1896, ___1897)), ','('g_read'('data.list', '<module>:data.list'(___1909)), ','('<module>:data.list:member$direct'(___1898, ___1908, ___1909), ','('true', ','('true', ','('true', 'true'))))))))))))), ','('true', ','('='(__36CutLevel, '$cut'), '!'))))).
':-'('<module>:emop.parser@2:check_postfix$direct'(_____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@2:check_postfix'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@2:check_postfix_or_infix'(_Op, _Grammars, 'env'(___297, _Grammars), __36CutLevel), ','(','('g_read'('data.list', '<module>:data.list'(___1944)), '<module>:data.list:member$direct'(_Grammar, _Grammars, ___1944)), ','(','('='(___1938, _Op), ','('='(___1937, 'operator'(___1938, ___1939, ___1940, ___1941, ___1942)), ','('='(___1931, ___1947), ','('='(_Grammar, 'grammar'(___1931, ___1932, ___1933, ___1934, ___1935)), ','('g_read'('data.list', '<module>:data.list'(___1948)), ','('<module>:data.list:member$direct'(___1937, ___1947, ___1948), ','(','('true', ','('true', ','('='(___1941, _Kind), 'true'))), ','('true', ','('true', ','('true', 'true')))))))))), ','(','('='(_Kind, ___1936), ';'('='(___1936, 'postfix'), '='(___1936, 'infix'))), ','('true', ','('='(__36CutLevel, '$cut'), '!')))))).
':-'('<module>:emop.parser@2:check_postfix_or_infix$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@2:check_postfix_or_infix'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@2:compare_priorities'(_Op0, _Op1, _Cmp, 'env'(___297, _Grammars), __36CutLevel), ','(','('g_read'('data.list', '<module>:data.list'(___1791)), '<module>:data.list:append$direct'(_Prefix, _, _Grammars, ___1791)), ','(';'('->'('emop_call'(___297, 'less_priority'(_Op0, '.'(_Op0, '[]'), _Prefix, _Op1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 790, from character 15 to 28'), ';'('->'('emop_call'(___297, 'less_priority'(_Op1, '.'(_Op1, '[]'), _Prefix, _Op0), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 793, from character 18 to 31'), '='(_Cmp, '=')), '='(_Cmp, '<'))), ';'('->'('emop_call'(___297, 'less_priority'(_Op1, '[]', _Prefix, _Op0), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 800, from character 15 to 28'), '='(_Cmp, '>')), 'fail')), ','('true', ','('='(__36CutLevel, '$cut'), '!'))))).
':-'('<module>:emop.parser@2:compare_priorities$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@2:compare_priorities'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@2:flush'('[]', '.'(_Result, '[]'), _Result, 'env'(___297, _Grammars), __36CutLevel), 'true').
':-'('<module>:emop.parser@2:flush'('.'(_OpRepr, _Ops), _ValueStack, ___1771, 'env'(___297, _Grammars), __36CutLevel), ','('emop_call'(___297, 'apply_op'(_OpRepr, _ValueStack, ___1770), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 773, from character 56 to 64'), 'emop_call'(___297, 'flush'(_Ops, ___1770, ___1771), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 773, from character 45 to 50'))).
':-'('<module>:emop.parser@2:flush$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@2:flush'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@2:flush_upto'('[]', _ValueStack, ___OpInfo, '[]', _ValueStack, 'env'(___297, _Grammars), __36CutLevel), 'true').
':-'('<module>:emop.parser@2:flush_upto'('.'(_OpRepr, _Ops0), _ValueStack0, _OpInfo, _Ops1, _ValueStack1, 'env'(___297, _Grammars), __36CutLevel), ','(';'('='(_OpRepr, 'binary'(_Op, _OpId, _Alias, _Assoc, _Pb, ___Pe)), '='(_OpRepr, 'prefix'(_Op, _OpId, _Alias, _Assoc, _Pb, ___Pe))), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','('='(_OpInfo, 'op'(_Op0, _OpId0, _Assoc0, ___Pb0, _Pe0)), ','(';'('->'('='(_OpId, _OpId0), ';'('->'(';'('='(_Assoc, 'yfx'), '='(_Assoc, 'yf')), '='(_Action, 'flush')), ';'('->'('='(_Assoc, 'xfy'), '='(_Action, 'stop')), ','(','('g_read'('data.atom', '<module>:data.atom'(___1822)), '<module>:data.atom:format$direct'('Operator ~a is not associative.', '.'(_Op0, '.'(_Op, '[]')), ___1821, ___1822)), 'throw'('error'(___1821, 'file'(_Pb, _Pe0))))))), ';'('->'(','(','('='(___1825, ___1803), 'emop_call'(___297, 'compare_priorities'(_OpId, _OpId0, ___1825), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 832, from character 15 to 33')), ';'('->'('='(___1803, '='), ';'('->'(','('='(_Assoc, 'yfx'), ','('='(_Assoc0, ___1804), ';'('='(___1804, 'yfx'), '='(___1804, 'yf')))), '='(_Action, 'flush')), ';'('->'(','(','('='(_Assoc, ___1805), ';'('='(___1805, 'xfy'), '='(___1805, 'fy'))), '='(_Assoc0, 'xfy')), '='(_Action, 'stop')), ';'('->'(','('='(_Assoc, 'xfx'), '='(_Assoc0, 'xfx')), ','(','('g_read'('data.atom', '<module>:data.atom'(___1843)), '<module>:data.atom:format$direct'('Operators ~a and ~a are not associative', '.'(_Op0, '.'(_Op, '[]')), ___1842, ___1843)), 'throw'('error'(___1842, 'file'(_Pb, _Pe0))))), ';'('->'('='(_Assoc, 'xfx'), ','(','('g_read'('data.atom', '<module>:data.atom'(___1852)), '<module>:data.atom:format$direct'('Operator ~a is not associative', '.'(_Op, '[]'), ___1851, ___1852)), 'throw'('error'(___1851, 'file'(_Pb, _Pe0))))), ';'('->'('='(_Assoc0, 'xfx'), ','(','('g_read'('data.atom', '<module>:data.atom'(___1861)), '<module>:data.atom:format$direct'('Operator ~a is not associative', '.'(_Op0, '[]'), ___1860, ___1861)), 'throw'('error'(___1860, 'file'(_Pb, _Pe0))))), '->'(';'(','('='(_Assoc, 'xfy'), ','('='(_RightOp, _Op), ','('='(_Assoc0, 'yfx'), '='(_LeftOp, _Op0)))), ','('='(_Assoc, 'yfx'), ','('='(_LeftOp, _Op), ','('='(_Assoc0, 'xfy'), '='(_RightOp, _Op0))))), ','(','('g_read'('data.atom', '<module>:data.atom'(___1874)), '<module>:data.atom:format$direct'('Operator ~a is left associative whereas operator ~a is right associative', '.'(_LeftOp, '.'(_RightOp, '[]')), ___1873, ___1874)), 'throw'('error'(___1873, 'file'(_Pb, _Pe0))))))))))), ','('='(___1803, ___1806), ';'('->'('='(___1806, '<'), '='(_Action, 'stop')), ','('='(___1806, ___1807), '->'('='(___1807, '>'), '='(_Action, 'flush'))))))), 'true'), ','(','('g_read'('data.atom', '<module>:data.atom'(___1887)), '<module>:data.atom:format$direct'('Operators ~a and ~a are not compatible', '.'(_Op, '.'(_Op0, '[]')), ___1886, ___1887)), 'throw'('error'(___1886, 'file'(_Pb, _Pe0)))))), ';'('->'('='(_Action, 'flush'), ','('emop_call'(___297, 'apply_op'(_OpRepr, _ValueStack0, ___1891), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 886, from character 32 to 40'), 'emop_call'(___297, 'flush_upto'(_Ops0, ___1891, _OpInfo, _Ops1, _ValueStack1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 886, from character 15 to 25'))), ','('='(_Ops1, '.'(_OpRepr, _Ops0)), '='(_ValueStack1, _ValueStack0)))))))).
':-'('<module>:emop.parser@2:flush_upto$direct'(_____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@2:flush_upto'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@2:less_priority'(_Op, _, _, _Op, 'env'(___297, _Grammars), __36CutLevel), 'true').
':-'('<module>:emop.parser@2:less_priority'(_Op0, _Cache, _Prefix, _Op1, 'env'(___297, _Grammars), __36CutLevel), ','(','('g_read'('data.list', '<module>:data.list'(___1781)), '<module>:data.list:member$direct'(_Grammar, _Prefix, ___1781)), ','(','('='(_Grammar, 'grammar'(___1772, ___1773, ___1774, ___1775, ___1776)), ','('true', ','(','('='(___1778, _Op0), ','('='(___1779, _Op2), ','('='(___1777, 'priority'(___1778, ___1779)), ','('='(___1773, ___1784), ','('g_read'('data.list', '<module>:data.list'(___1785)), '<module>:data.list:member$direct'(___1777, ___1784, ___1785)))))), ','('true', ','('true', 'true'))))), ','('\\+'(','('g_read'('data.list', '<module>:data.list'(___1788)), '<module>:data.list:member$direct'(_Op2, _Cache, ___1788))), 'emop_call'(___297, 'less_priority'(_Op2, '.'(_Op2, _Cache), _Prefix, _Op1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 785, from character 12 to 25'))))).
':-'('<module>:emop.parser@2:less_priority$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@2:less_priority'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@2:op'(___1708, ___1709, ___1710, ___1711, ___1712, ___1713, 'env'(___297, _Grammars), __36CutLevel), '=..'(___1713, '.'('op', '.'(___1708, '.'(___1709, '.'(___1710, '.'(___1711, '.'(___1712, '[]')))))))).
':-'('<module>:emop.parser@2:op$direct'(_____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@2:op'(_____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@2:operator'(___1699, ___1700, ___1701, ___1702, ___1703, ___1704, 'env'(___297, _Grammars), __36CutLevel), '=..'(___1704, '.'('operator', '.'(___1699, '.'(___1700, '.'(___1701, '.'(___1702, '.'(___1703, '[]')))))))).
':-'('<module>:emop.parser@2:operator$direct'(_____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@2:operator'(_____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@2:postfix_op'('xf', 'env'(___297, _Grammars), __36CutLevel), 'true').
':-'('<module>:emop.parser@2:postfix_op'('yf', 'env'(___297, _Grammars), __36CutLevel), 'true').
':-'('<module>:emop.parser@2:postfix_op$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@2:postfix_op'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@2:prefix_op'('fx', 'env'(___297, _Grammars), __36CutLevel), 'true').
':-'('<module>:emop.parser@2:prefix_op'('fy', 'env'(___297, _Grammars), __36CutLevel), 'true').
':-'('<module>:emop.parser@2:prefix_op$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@2:prefix_op'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@2:priority'(___1705, ___1706, ___1707, 'env'(___297, _Grammars), __36CutLevel), '=..'(___1707, '.'('priority', '.'(___1705, '.'(___1706, '[]'))))).
':-'('<module>:emop.parser@2:priority$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@2:priority'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@2:reassoc_left'('.'(_H, _T), _OpStack, _ValueStack, _Ast, 'env'(___297, _Grammars), __36CutLevel), ','('\\='(_T, '[]'), ','('='(_H, 'callable'(_Op, 'unescaped', 'none', _Pb, _Pe)), ','(','('g_read'('data.list', '<module>:data.list'(___1738)), '<module>:data.list:member$direct'(_Grammar, _Grammars, ___1738)), ','(','('='(___1728, _Op), ','('='(___1729, _OpId), ','('='(___1730, _Alias), ','('='(___1731, 'prefix'), ','('='(___1732, _Assoc), ','('='(___1727, 'operator'(___1728, ___1729, ___1730, ___1731, ___1732)), ','('='(___1722, ___1741), ','('='(_Grammar, 'grammar'(___1722, ___1723, ___1724, ___1725, ___1726)), ','('g_read'('data.list', '<module>:data.list'(___1742)), ','('<module>:data.list:member$direct'(___1727, ___1741, ___1742), ','('true', ','('true', ','('true', 'true'))))))))))))), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), 'emop_call'(___297, 'reassoc_left'(_T, '.'('prefix'(_Op, _OpId, _Alias, _Assoc, _Pb, _Pe), _OpStack), _ValueStack, _Ast), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 762, from character 12 to 24'))))))).
':-'('<module>:emop.parser@2:reassoc_left'('.'(_H, _T), _OpStack, _ValueStack, ___1749, 'env'(___297, _Grammars), __36CutLevel), 'emop_call'(___297, 'reassoc_right'(_T, _OpStack, '.'(_H, _ValueStack), ___1749), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 764, from character 12 to 25')).
':-'('<module>:emop.parser@2:reassoc_left$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@2:reassoc_left'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@2:reassoc_right'('[]', _OpStack, _ValueStack, ___1953, 'env'(___297, _Grammars), __36CutLevel), 'emop_call'(___297, 'flush'(_OpStack, _ValueStack, ___1953), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 918, from character 12 to 17')).
':-'('<module>:emop.parser@2:reassoc_right'('.'(_H, _T), _OpStack, _ValueStack, _Ast, 'env'(___297, _Grammars), __36CutLevel), ','('='(_H, '.()'(_Sub, _Pb, _Pe)), ','('emop_call'(___297, 'check_postfix'('.()', _Grammars, _OpId, ___Alias, _Assoc), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 922, from character 12 to 25'), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','('emop_call'(___297, 'flush_upto'(_OpStack, _ValueStack, 'op'('.()', _OpId, _Assoc, _Pb, _Pe), _OpStack0, _ValueStack0), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 924, from character 12 to 22'), ','('='(_ValueStack0, '.'(_Arg, _ValueStack1)), ','('='(_Value, '.()'(_Arg, _Sub, _Pb, _Pe)), 'emop_call'(___297, 'reassoc_right'(_T, _OpStack0, '.'(_Value, _ValueStack1), _Ast), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 927, from character 12 to 25')))))))).
':-'('<module>:emop.parser@2:reassoc_right'('.'(_H, _T), _OpStack, _ValueStack, _Ast, 'env'(___297, _Grammars), __36CutLevel), ','('='(_H, 'callable'(_Op, 'unescaped', 'none', _Pb, _Pe)), ','('emop_call'(___297, 'check_postfix'(_Op, _Grammars, _OpId, _Alias, _Assoc), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 930, from character 12 to 25'), ','(';'('->'('emop_call'(___297, 'check_infix'(_Op, _Grammars, _, _, _), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 932, from character 15 to 26'), ';'('->'('='(_T, '[]'), 'true'), '->'(','('='(_T, '.'(_TH, _)), '='(_TH, 'callable'(_TOp, 'unescaped', 'none', _, _))), 'emop_call'(___297, 'check_postfix_or_infix'(_TOp, _Grammars), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 942, from character 18 to 40')))), 'true'), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','('emop_call'(___297, 'flush_upto'(_OpStack, _ValueStack, 'op'(_Op, _OpId, _Assoc, _Pb, _Pe), _OpStack0, _ValueStack0), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 948, from character 12 to 22'), ','('='(_ValueStack0, '.'(_Arg, _ValueStack1)), ','('='(_Value, 'callable'(_Alias, 'operator', '.'(_Arg, '[]'), _Pb, _Pe)), 'emop_call'(___297, 'reassoc_right'(_T, _OpStack0, '.'(_Value, _ValueStack1), _Ast), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 951, from character 12 to 25'))))))))).
':-'('<module>:emop.parser@2:reassoc_right'('.'(_H, _T), _OpStack, _ValueStack, _Ast, 'env'(___297, _Grammars), __36CutLevel), ','(';'(','('='(_H, 'callable'(_Op, 'unescaped', 'none', _Pb, _Pe)), ','('\\='(_T, '[]'), '='(_Tail, _T))), ','('='(_Op, ''), ','('='(_Tail, '.'(_H, _T)), ','('='(_ValueStack, '.'(_First, _)), ','(','('='('file'(_, _Pe), ___1988), ','('g_read'('emop.parse', '<module>:emop.parse'(___1989)), '<module>:emop.parse:position$direct'(_First, ___1988, ___1989))), '='(_Pb, _Pe)))))), ','('emop_call'(___297, 'check_infix'(_Op, _Grammars, _OpId, _Alias, _Assoc), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 964, from character 12 to 23'), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','('emop_call'(___297, 'flush_upto'(_OpStack, _ValueStack, 'op'(_Op, _OpId, _Assoc, _Pb, _Pe), _OpStack0, _ValueStack0), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 966, from character 12 to 22'), 'emop_call'(___297, 'reassoc_left'(_Tail, '.'('binary'(_Op, _OpId, _Alias, _Assoc, _Pb, _Pe), _OpStack0), _ValueStack0, _Ast), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 967, from character 12 to 24')))))).
':-'('<module>:emop.parser@2:reassoc_right'('.'(_H, _T), ___ValueStack, ___OpStack, ___Ast, 'env'(___297, _Grammars), __36CutLevel), ';'('->'('='(_T, '[]'), ','(','('g_read'('emop.parse', '<module>:emop.parse'(___1998)), '<module>:emop.parse:position$direct'(_H, ___1997, ___1998)), 'throw'('error'('Postfix operator expected.', ___1997)))), ','(','('g_read'('emop.parse', '<module>:emop.parse'(___2003)), '<module>:emop.parse:position$direct'(_H, ___2002, ___2003)), 'throw'('error'('Infix or postfix operator expected.', ___2002))))).
':-'('<module>:emop.parser@2:reassoc_right$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@2:reassoc_right'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@3'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@3:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@3'('do'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@3:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@3'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.parser@3$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.parser@3$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.parser@3$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.parser@3$has_predicate'('do'(_____2, _____1)), 'true').
':-'('<module>:emop.parser@3:$sgn'(__36sgn, 'env'(___305), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',30718,979,30706)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',30729,979,30706)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.parser@3:atom_fresh_[3127]'(_atom__fresh___913128_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913128_93, '[]'))))))).
':-'('<module>:emop.parser@3:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@3:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@3:atom_fresh_[3127]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.parser@3:do'('[]', '[]', 'env'(___305), __36CutLevel), 'true').
':-'('<module>:emop.parser@3:do'('.'('callable'(_Symbol, _, 'none', _, _), '.'('callable'('as', 'unescaped', 'none', _, _), '.'('callable'(_Alias, _, 'none', _, _), _Tail))), _List, 'env'(___305), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','('='(_List, '.'(','(_Symbol, _Alias), ___1691)), 'emop_call'(___305, 'do'(_Tail, ___1691), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 993, from character 44 to 46')))).
':-'('<module>:emop.parser@3:do'('.'('callable'(_Symbol, _, 'none', _, _), _Tail), _List, 'env'(___305), __36CutLevel), ','('='(_List, '.'(','(_Symbol, _Symbol), ___1697)), 'emop_call'(___305, 'do'(_Tail, ___1697), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 995, from character 45 to 47'))).
':-'('<module>:emop.parser@3:do$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@3:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@4'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@4:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@4'('do'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@4:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@4'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.parser@4$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.parser@4$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.parser@4$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.parser@4$has_predicate'('do'(_____1)), 'true').
':-'('<module>:emop.parser@4:$sgn'(__36sgn, 'env'(___568, _Pb, _Pe, _Kind, _Assoc, _GrammarRef), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',36230,1159,36208)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',36279,1159,36208)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.parser@4:atom_fresh_[3125]'(_atom__fresh___913126_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913126_93, '[]'))))))).
':-'('<module>:emop.parser@4:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@4:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@4:atom_fresh_[3125]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.parser@4:do'(','(_Symbol, _Alias), 'env'(___568, _Pb, _Pe, _Kind, _Assoc, _GrammarRef), __36CutLevel), ','(';'('->'(','('='(_Symbol, ''), '\\='(_Kind, 'infix')), 'throw'('error'('The empty operator can only be infix.', 'file'(_Pb, _Pe)))), 'true'), ','(','('='(___1655, ___1660), ','(','('='(___1670, 'grammar'(___1655, ___1656, ___1657, ___1658, ___1659)), 'emop_call'(_GrammarRef, 'get'(___1670), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1171, from character 32 to 35')), ','('->'('='(___1660, _Operators), 'true'), ','(','('g_read'('emop.parser', '<module>:emop.parser'(___1673)), '<module>:emop.parser:fresh_operator_id$direct'(___1672, ___1673)), ','(','('='(___1656, ___1661), 'true'), ','(','('='(___1657, ___1662), 'true'), ','(','('='(___1658, ___1663), 'true'), ','('='(___1659, ___1664), 'true')))))))), 'emop_call'(_GrammarRef, 'set'('grammar'('.'('operator'(_Symbol, ___1672, _Alias, _Kind, _Assoc), _Operators), ___1661, ___1662, ___1663, ___1664)), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1170, from character 29 to 32')))).
':-'('<module>:emop.parser@4:do$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@4:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@5'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@5:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@5'('do'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@5:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@5'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.parser@5$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.parser@5$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.parser@5$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.parser@5$has_predicate'('do'(_____2, _____1)), 'true').
':-'('<module>:emop.parser@5:$sgn'(__36sgn, 'env'(___598, _GrammarRef, _Grammars), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',38102,1218,38074)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',38133,1218,38074)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.parser@5:atom_fresh_[3123]'(_atom__fresh___913124_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913124_93, '[]'))))))).
':-'('<module>:emop.parser@5:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@5:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@5:atom_fresh_[3123]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 2, predicate, suspended([none,none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.parser@5:do'('[]', '[]', 'env'(___598, _GrammarRef, _Grammars), __36CutLevel), 'true').
':-'('<module>:emop.parser@5:do'('.'('callable'(_Level, _, 'none', _, _), _T0), '.'(_Level0, _T1), 'env'(___598, _GrammarRef, _Grammars), __36CutLevel), ','(','('='(_Level0, ___1647), ','('g_read'('emop.parser', '<module>:emop.parser'(___1648)), '<module>:emop.parser:find_level$direct'(_GrammarRef, _Grammars, _Level, ___1647, ___1648))), ','('='(_T0, ___1638), ';'('->'(','('='(___1642, ','), ','('='(___1643, 'unescaped'), ','('='(___1644, 'none'), ','('='(___1639, 'callable'(___1642, ___1643, ___1644, ___1645, ___1646)), ','('='(___1638, '.'(___1639, ___1640)), ','('true', ','('true', '='(___1640, _T0s)))))))), 'emop_call'(___598, 'do'(_T0s, _T1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1229, from character 25 to 27')), ','('='(___1638, ___1641), '->'('true', 'emop_call'(___598, 'do'(_T0, _T1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1233, from character 25 to 27'))))))).
':-'('<module>:emop.parser@5:do$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@5:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@6'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@6:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@6'('do'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@6:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@6'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.parser@6$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.parser@6$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.parser@6$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.parser@6$has_predicate'('do'(_____2, _____1)), 'true').
':-'('<module>:emop.parser@6:$sgn'(__36sgn, 'env'(___627, _GrammarRef, _Grammars), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',39793,1266,39768)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',39828,1266,39768)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.parser@6:atom_fresh_[3121]'(_atom__fresh___913122_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913122_93, '[]'))))))).
':-'('<module>:emop.parser@6:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@6:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@6:atom_fresh_[3121]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 2, predicate, suspended([none,none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.parser@6:do'('callable'(_Level, _, 'none', _, _), ___1610, 'env'(___627, _GrammarRef, _Grammars), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','('g_read'('emop.parser', '<module>:emop.parser'(___1611)), '<module>:emop.parser:find_level$direct'(_GrammarRef, _Grammars, _Level, ___1610, ___1611)))).
':-'('<module>:emop.parser@6:do'('callable'('seq', 'unescaped', '.'('callable'(_Level, _, 'none', _, _), '[]'), _, _), 'seq'(___1619), 'env'(___627, _GrammarRef, _Grammars), __36CutLevel), ','('g_read'('emop.parser', '<module>:emop.parser'(___1620)), '<module>:emop.parser:find_level$direct'(_GrammarRef, _Grammars, _Level, ___1619, ___1620))).
':-'('<module>:emop.parser@6:do'('callable'('*', 'operator', '.'('callable'(_Level, _, 'none', _, _), '[]'), _, _), 'seq'(___1629), 'env'(___627, _GrammarRef, _Grammars), __36CutLevel), ','('g_read'('emop.parser', '<module>:emop.parser'(___1630)), '<module>:emop.parser:find_level$direct'(_GrammarRef, _Grammars, _Level, ___1629, ___1630))).
':-'('<module>:emop.parser@6:do$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@6:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@7'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@7:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@7'('cut_guard'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@7:cut_guard'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@7'('cut'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@7:cut'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@7'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.parser@7$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.parser@7$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.parser@7$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.parser@7$has_predicate'('cut_guard'(_____2, _____1)), 'true').
':-'('<module>:emop.parser@7$has_predicate'('cut'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser@7:$sgn'(__36sgn, 'env'(___686, _Tail, _Pb, _Pe), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',41353,1299,41338)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',41376,1299,41338)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','('true', '<module>:emop.parser@7:atom_fresh_[3117]'(_atom__fresh___913118_93, __36Pb, __36Pe)), '<module>:emop.parser@7:atom_fresh_[3119]'(_atom__fresh___913120_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913120_93, '.'(_atom__fresh___913118_93, '[]')))))))).
':-'('<module>:emop.parser@7:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@7:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@7:atom_fresh_[3117]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(cut, 3, predicate, '[]', __36pos))).
':-'('<module>:emop.parser@7:atom_fresh_[3119]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(cut_guard, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.parser@7:cut'('.'('callable'('->', 'unescaped', 'none', _, _), _Tail), '[]', '.'('callable'('true', 'unescaped', 'none', _Pb, _Pe), '[]'), 'env'(___686, _Tail, _Pb, _Pe), __36CutLevel), ','('true', ','('='(__36CutLevel, '$cut'), '!'))).
':-'('<module>:emop.parser@7:cut'('.'('callable'('|', 'unescaped', 'none', _, _), _B), '[]', _Guard, 'env'(___686, _Tail, _Pb, _Pe), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), 'emop_call'(___686, 'cut_guard'(_B, _Guard), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1310, from character 21 to 30'))).
':-'('<module>:emop.parser@7:cut'('.'(_A, _B), '.'(_A, _B0), _Guard, 'env'(___686, _Tail, _Pb, _Pe), __36CutLevel), 'emop_call'(___686, 'cut'(_B, _B0, _Guard), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1312, from character 21 to 24')).
':-'('<module>:emop.parser@7:cut$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@7:cut'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@7:cut_guard'('.'('callable'('->', 'unescaped', 'none', _, _), _Tail), '[]', 'env'(___686, _Tail, _Pb, _Pe), __36CutLevel), ','('true', ','('='(__36CutLevel, '$cut'), '!'))).
':-'('<module>:emop.parser@7:cut_guard'('.'(_A, _B), '.'(_A, _B0), 'env'(___686, _Tail, _Pb, _Pe), __36CutLevel), 'emop_call'(___686, 'cut_guard'(_B, _B0), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1304, from character 21 to 30')).
':-'('<module>:emop.parser@7:cut_guard$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@7:cut_guard'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@8'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@8:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@8'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.parser@8$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.parser@8$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.parser@8$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.parser@8:$sgn'(__36sgn, 'env'(___710, _ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef, _Desc, _Desc0, _Env, _GrammarRef, _Grammars, _Grammars1, _Guard, _Guard0, _Guard1, _Head, _Head0, _Head1, _InferLengthRef, _LevelList, _Notations, _Pb, _Pe, _Tail, _Tail0, _Tail1), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',42318,1320,42286)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',42408,1322,42393)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','(','('true', '<module>:emop.parser@8:atom_fresh_[3109]'(_atom__fresh___913110_93, __36Pb, __36Pe)), '<module>:emop.parser@8:atom_fresh_[3111]'(_atom__fresh___913112_93, __36Pb, __36Pe)), '<module>:emop.parser@8:atom_fresh_[3113]'(_atom__fresh___913114_93, __36Pb, __36Pe)), '<module>:emop.parser@8:atom_fresh_[3115]'(_atom__fresh___913116_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913116_93, '.'(_atom__fresh___913114_93, '.'(_atom__fresh___913112_93, '.'(_atom__fresh___913110_93, '[]')))))))))).
':-'('<module>:emop.parser@8:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@8:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@8:atom_fresh_[3109]'(__36s, __36Pb, __36Pe), '='(__36s, 'syntax'('.'('callable'(';', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('<', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'(',', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('<', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'(':', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('<', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('+', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('=', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('-', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('<', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('infix', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('*', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('=', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('/', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('<', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('#', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('<', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('postfix', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('*', 'escaped', 'none', __36Pb, __36Pe), '[]'))))))))))))))))))), __36Pb, __36Pe))).
':-'('<module>:emop.parser@8:atom_fresh_[3111]'(__36s, __36Pb, __36Pe), '='(__36s, 'syntax'('.'('callable'('postfix', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('*', 'escaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe))).
':-'('<module>:emop.parser@8:atom_fresh_[3113]'(__36s, __36Pb, __36Pe), '='(__36s, 'syntax'('.'('callable'('prefix', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('#', 'escaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe))).
':-'('<module>:emop.parser@8:atom_fresh_[3115]'(__36s, __36Pb, __36Pe), '='(__36s, 'syntax'('.'('callable'('infix', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('left', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('associative', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'(';', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'(',', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('+', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('-', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('*', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('/', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'(':', 'escaped', 'none', __36Pb, __36Pe), '[]')))))))))), __36Pb, __36Pe))).
':-'('<module>:emop.parser@9'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@9:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@9'('rename'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.parser@9:rename'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@9'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.parser@9$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.parser@9$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.parser@9$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.parser@9$has_predicate'('rename'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.parser@9:$sgn'(__36sgn, 'env'(___730, _Env, _InferLengthRef, _Grammars1), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',42856,1331,42844)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl',42897,1331,42844)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.parser@9:atom_fresh_[3085]'(_atom__fresh___913086_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___913086_93, '[]'))))))).
':-'('<module>:emop.parser@9:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@9:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.parser@9:atom_fresh_[3085]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(rename, 3, predicate, suspended([var('Mode'),var('Ast'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.parser@9:rename'(_Mode, _Ast, ___1112, 'env'(___730, _Env, _InferLengthRef, _Grammars1), __36CutLevel), ','(','('true', ';'('->'('var'(___1106), ','('g_inc'('$module_count', ___1107), '='(___1106, '$module'(___1107, '.'('<module>:emop.parser@15'('env'(___1106, _Mode, _Env, _InferLengthRef, _Grammars1, ___730)), '[]'), '.'(___1106, '[]'))))), ','('='(___1106, '$module'(___1107, ___1108, _)), ','('='('.'(___1109, ___1110), ___1108), ','('setarg'(1, ___1108, '<module>:emop.parser@15'('env'(___1106, _Mode, _Env, _InferLengthRef, _Grammars1, ___730))), 'setarg'(2, ___1108, '.'(___1109, ___1110))))))), 'emop_call'(___1106, 'do'(_Ast, ___1112), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/parser.mpl\", line 1799, from character 18 to 20'))).
':-'('<module>:emop.parser@9:rename$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.parser@9:rename'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('emop.parser@init', ','(','('true', 'g_link'('emop.parser', '<module>:emop.parser'('env'(_ParsedFileCacheRef, _ParseResultRef, _OperatorsIdRef, _LevelsIdRef, _FreshVarCounterRef)))), ','('='(_ParsedFileCacheRef, ___6), ','('g_read'('data.ref.non_backtrackable', '<module>:data.ref.non_backtrackable'(___7)), '<module>:data.ref.non_backtrackable:new$direct'('[]', ___6, ___7))))).
':-'('dynamic'('/'('<module>:emop.patch_wam$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.patch_wam@0$dynamic', 4))).
':-'('<module>:emop.patch_wam'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.patch_wam:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.patch_wam'('make'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.patch_wam:make'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.patch_wam'('portray_wam'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.patch_wam:portray_wam'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.patch_wam'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.patch_wam$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.patch_wam$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.patch_wam$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.patch_wam$has_predicate'('make'(_____2, _____1)), 'true').
':-'('<module>:emop.patch_wam$has_predicate'('portray_wam'(_____2, _____1)), 'true').
':-'('<module>:emop.patch_wam:$sgn'(__36sgn, 'env', __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/patch_wam.mpl',0,0,0)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/patch_wam.mpl',23,0,0)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','('true', '<module>:emop.patch_wam:atom_fresh_[2873]'(_atom__fresh___912874_93, __36Pb, __36Pe)), '<module>:emop.patch_wam:atom_fresh_[2875]'(_atom__fresh___912876_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___912876_93, '.'(_atom__fresh___912874_93, '[]')))))))).
':-'('<module>:emop.patch_wam:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.patch_wam:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.patch_wam:atom_fresh_[2873]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(portray_wam, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.patch_wam:atom_fresh_[2875]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(make, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.patch_wam:make'(_Patch, ___4, 'env', __36CutLevel), ','('true', ';'('->'('var'(___4), ','('g_inc'('$module_count', ___5), '='(___4, '$module'(___5, '.'('<module>:emop.patch_wam@0'('env'(___4, _Patch)), '[]'), '.'(___4, '[]'))))), ','('='(___4, '$module'(___5, ___6, _)), ','('='('.'(___7, ___8), ___6), ','('setarg'(1, ___6, '<module>:emop.patch_wam@0'('env'(___4, _Patch))), 'setarg'(2, ___6, '.'(___7, ___8)))))))).
':-'('<module>:emop.patch_wam:make$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.patch_wam:make'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.patch_wam:portray_wam'(_NewFile, _Clause, 'env', __36CutLevel), ';'('->'(','('='(___10, 'predicate'), ','('='(___12, _OtherArgs), ','('='(___16, _First), ','('='(___17, _Tail), ','('='(___14, '.'(___16, ___17)), ','('='(___15, '[]'), ','('='(___13, '.'(___14, ___15)), ','('='(___11, ___23), ','(','('='(_Clause, ___19), ','('g_read'('data.term', '<module>:data.term'(___20)), '<module>:data.term:make$direct'(___10, ___11, ___19, ___20))), ','('g_read'('data.list', '<module>:data.list'(___24)), '<module>:data.list:append$direct'(___12, ___13, ___23, ___24))))))))))), ','('emop_call'(_NewFile, 'print'('predicate('), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/patch_wam.mpl\", line 48, from character 17 to 22'), ','(';'(','(','('g_read'('data.list', '<module>:data.list'(___30)), '<module>:data.list:member$direct'(_Arg, _OtherArgs, ___30)), ','('emop_call'(_NewFile, 'format'('~q, ', '.'(_Arg, '[]')), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/patch_wam.mpl\", line 51, from character 20 to 26'), 'fail')), 'true'), ','('emop_call'(_NewFile, 'format'('[\n    ~q', '.'(_First, '[]')), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/patch_wam.mpl\", line 56, from character 17 to 23'), ','(';'(','(','('g_read'('data.list', '<module>:data.list'(___38)), '<module>:data.list:member$direct'(_Instr, _Tail, ___38)), ','('emop_call'(_NewFile, 'format'(',\n    ~q', '.'(_Instr, '[]')), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/patch_wam.mpl\", line 59, from character 20 to 26'), 'fail')), 'true'), 'emop_call'(_NewFile, 'print'(']).\n\n'), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/patch_wam.mpl\", line 64, from character 17 to 22')))))), 'emop_call'(_NewFile, 'format'('~q.\n\n', '.'(_Clause, '[]')), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/patch_wam.mpl\", line 66, from character 17 to 23'))).
':-'('<module>:emop.patch_wam:portray_wam$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.patch_wam:portray_wam'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.patch_wam@0'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.patch_wam@0:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.patch_wam@0'('stream'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.patch_wam@0:stream'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.patch_wam@0'('clause'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.patch_wam@0:clause'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.patch_wam@0'('instr'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.patch_wam@0:instr'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.patch_wam@0'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.patch_wam@0$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.patch_wam@0$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.patch_wam@0$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.patch_wam@0$has_predicate'('stream'(_____2, _____1)), 'true').
':-'('<module>:emop.patch_wam@0$has_predicate'('clause'(_____2, _____1)), 'true').
':-'('<module>:emop.patch_wam@0$has_predicate'('instr'(_____2, _____1)), 'true').
':-'('<module>:emop.patch_wam@0:$sgn'(__36sgn, 'env'(___9, _Patch), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/patch_wam.mpl',41,1,24)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/patch_wam.mpl',49,1,24)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','('true', '<module>:emop.patch_wam@0:atom_fresh_[2877]'(_atom__fresh___912878_93, __36Pb, __36Pe)), '<module>:emop.patch_wam@0:atom_fresh_[2879]'(_atom__fresh___912880_93, __36Pb, __36Pe)), '<module>:emop.patch_wam@0:atom_fresh_[2881]'(_atom__fresh___912882_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___912882_93, '.'(_atom__fresh___912880_93, '.'(_atom__fresh___912878_93, '[]'))))))))).
':-'('<module>:emop.patch_wam@0:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.patch_wam@0:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.patch_wam@0:atom_fresh_[2877]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(instr, 2, predicate, suspended([none,none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.patch_wam@0:atom_fresh_[2879]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(clause, 2, predicate, suspended([var('Clause'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.patch_wam@0:atom_fresh_[2881]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(stream, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.patch_wam@0:clause'(_Clause, ___50, 'env'(___9, _Patch), __36CutLevel), ','('='(_Clause, ___49), ';'(','('='(___50, ___80), ','('='(___51, ___54), ','(','('='(___49, ___65), ','('g_read'('data.term', '<module>:data.term'(___66)), '<module>:data.term:make$direct'(___51, ___52, ___65, ___66))), ','('true', ','(','('='(___55, ___57), ','(','('='(___52, ___69), ','('g_read'('data.list', '<module>:data.list'(___70)), '<module>:data.list:append$direct'(___55, ___56, ___69, ___70))), ','('true', ','(','('='(___60, ___63), ','('='(___60, '.'(___61, ___62)), ','('='(___58, ___60), ','('='(___56, '.'(___58, ___59)), ','('true', ','(','('true', ','('true', ','(','('='(__36CutLevel, '$cut'), '!'), 'emop_call'(___9, 'instr'(___63, ___74), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/patch_wam.mpl\", line 20, from character 16 to 21')))), '='(___59, '[]'))))))), ','('g_read'('data.list', '<module>:data.list'(___79)), '<module>:data.list:append$direct'(___57, '.'(___74, '[]'), ___78, ___79)))))), ','('g_read'('data.term', '<module>:data.term'(___81)), '<module>:data.term:make$direct'(___54, ___78, ___80, ___81))))))), ','('='(___50, ___53), ','('='(___49, ___53), 'true'))))).
':-'('<module>:emop.patch_wam@0:clause$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.patch_wam@0:clause'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.patch_wam@0:instr'('[]', '[]', 'env'(___9, _Patch), __36CutLevel), ','('true', ','('='(__36CutLevel, '$cut'), '!'))).
':-'('<module>:emop.patch_wam@0:instr'(_List, _Result, 'env'(___9, _Patch), __36CutLevel), ';'('->'('emop_call'(_Patch, 'do'(_List, _NewList, _Tail), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/patch_wam.mpl\", line 30, from character 18 to 20'), ','(','('='(_Result, ___85), ','('g_read'('data.list', '<module>:data.list'(___86)), '<module>:data.list:append$direct'(_NewList, _NewTail, ___85, ___86))), 'emop_call'(___9, 'instr'(_Tail, _NewTail), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/patch_wam.mpl\", line 33, from character 12 to 17'))), '->'('='(_List, '.'(_H, _T)), ','('='(_Result, '.'(_H, ___88)), 'emop_call'(___9, 'instr'(_T, ___88), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/patch_wam.mpl\", line 37, from character 26 to 31'))))).
':-'('<module>:emop.patch_wam@0:instr$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.patch_wam@0:instr'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.patch_wam@0:stream'(_OriginalFile, _NewFile, 'env'(___9, _Patch), __36CutLevel), '->'(','('repeat', ','('emop_call'(_OriginalFile, 'read_term'(_T), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/patch_wam.mpl\", line 6, from character 25 to 34'), ';'('->'('\\='(_T, 'end_of_file'), ','(','('emop_call'(___9, 'clause'(_T, ___47), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/patch_wam.mpl\", line 10, from character 36 to 42'), ','('g_read'('emop.patch_wam', '<module>:emop.patch_wam'(___48)), '<module>:emop.patch_wam:portray_wam$direct'(_NewFile, ___47, ___48))), 'fail')), 'true'))), 'true')).
':-'('<module>:emop.patch_wam@0:stream$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.patch_wam@0:stream'(_____2, _____1, __36env, __36CutLevel))).
':-'('emop.patch_wam@init', ','('true', 'g_link'('emop.patch_wam', '<module>:emop.patch_wam'('env')))).
':-'('dynamic'('/'('<module>:emop.sgn$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.sgn@3$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.sgn@7$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.sgn@6$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.sgn@5$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.sgn@8$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.sgn@4$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.sgn@2$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.sgn@1$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.sgn@10$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.sgn@9$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.sgn@0$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.sgn@12$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.sgn@11$dynamic', 4))).
':-'('<module>:emop.sgn'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn'('module'(_____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn:module'(_____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn'('variable'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn:variable'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn'('var'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn:var'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn'('unescaped'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn:unescaped'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn'('doc'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn:doc'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn'('doc'(_____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn:doc'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn'('empty'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn:empty'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn'('number'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn:number'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn'('operator'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn:operator'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn'('none'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn:none'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn'('error'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn:error'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn'('file'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn:file'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn'('symbol'(_____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn:symbol'(_____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn'('symbol'(_____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn:symbol'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn'('clause'(_____7, _____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn:clause'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn'('link'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn:link'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn'('notation'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn:notation'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn'('level'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn:level'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn'('syntax'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn:syntax'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn'('special'(_____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn:special'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn'('from_mod_spec'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn:from_mod_spec'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn'('add_consult_sgn'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn:add_consult_sgn'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn'('cache'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn:cache'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn'('from_file'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn:from_file'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn'('from_stream'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn:from_stream'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn'('atom'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn:atom'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn'('=>'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn:=>'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn'('callable'(_____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn:callable'(_____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn'('from_goal'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn:from_goal'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn'('from_goal_callable'(_____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn:from_goal_callable'(_____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn'('from_module'(_____7, _____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn:from_module'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn'('from_module'(_____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn:from_module'(_____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn'('special_head'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn:special_head'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn'('directive_syntax'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn:directive_syntax'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn'('directive_sgn'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn:directive_sgn'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn'('enum_clauses'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn:enum_clauses'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn'('read_sgn'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn:read_sgn'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn'('extract_sgn'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn:extract_sgn'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.sgn$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.sgn$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.sgn$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.sgn$has_predicate'('module'(_____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.sgn$has_predicate'('variable'(_____1)), 'true').
':-'('<module>:emop.sgn$has_predicate'('var'(_____2, _____1)), 'true').
':-'('<module>:emop.sgn$has_predicate'('unescaped'(_____1)), 'true').
':-'('<module>:emop.sgn$has_predicate'('doc'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.sgn$has_predicate'('doc'(_____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.sgn$has_predicate'('empty'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.sgn$has_predicate'('number'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.sgn$has_predicate'('operator'(_____1)), 'true').
':-'('<module>:emop.sgn$has_predicate'('none'(_____1)), 'true').
':-'('<module>:emop.sgn$has_predicate'('error'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.sgn$has_predicate'('file'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.sgn$has_predicate'('symbol'(_____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.sgn$has_predicate'('symbol'(_____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.sgn$has_predicate'('clause'(_____7, _____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.sgn$has_predicate'('link'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.sgn$has_predicate'('notation'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.sgn$has_predicate'('level'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.sgn$has_predicate'('syntax'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.sgn$has_predicate'('special'(_____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.sgn$has_predicate'('from_mod_spec'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.sgn$has_predicate'('add_consult_sgn'(_____2, _____1)), 'true').
':-'('<module>:emop.sgn$has_predicate'('cache'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.sgn$has_predicate'('from_file'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.sgn$has_predicate'('from_stream'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.sgn$has_predicate'('atom'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.sgn$has_predicate'('=>'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.sgn$has_predicate'('callable'(_____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.sgn$has_predicate'('from_goal'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.sgn$has_predicate'('from_goal_callable'(_____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.sgn$has_predicate'('from_module'(_____7, _____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.sgn$has_predicate'('from_module'(_____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.sgn$has_predicate'('special_head'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.sgn$has_predicate'('directive_syntax'(_____2, _____1)), 'true').
':-'('<module>:emop.sgn$has_predicate'('directive_sgn'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.sgn$has_predicate'('enum_clauses'(_____2, _____1)), 'true').
':-'('<module>:emop.sgn$has_predicate'('read_sgn'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.sgn$has_predicate'('extract_sgn'(_____2, _____1)), 'true').
':-'('<module>:emop.sgn:$sgn'(__36sgn, 'env'(_SignatureCacheRef, _ConsultSignatureRef, _SignatureResultRef), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl',0,0,0)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl',78,0,0)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','('true', '<module>:emop.sgn:atom_fresh_[4343]'(_atom__fresh___914344_93, __36Pb, __36Pe)), '<module>:emop.sgn:atom_fresh_[4345]'(_atom__fresh___914346_93, __36Pb, __36Pe)), '<module>:emop.sgn:atom_fresh_[4347]'(_atom__fresh___914348_93, __36Pb, __36Pe)), '<module>:emop.sgn:atom_fresh_[4349]'(_atom__fresh___914350_93, __36Pb, __36Pe)), '<module>:emop.sgn:atom_fresh_[4351]'(_atom__fresh___914352_93, __36Pb, __36Pe)), '<module>:emop.sgn:atom_fresh_[4353]'(_atom__fresh___914354_93, __36Pb, __36Pe)), '<module>:emop.sgn:atom_fresh_[4355]'(_atom__fresh___914356_93, __36Pb, __36Pe)), '<module>:emop.sgn:atom_fresh_[4357]'(_atom__fresh___914358_93, __36Pb, __36Pe)), '<module>:emop.sgn:atom_fresh_[4359]'(_atom__fresh___914360_93, __36Pb, __36Pe)), '<module>:emop.sgn:atom_fresh_[4361]'(_atom__fresh___914362_93, __36Pb, __36Pe)), '<module>:emop.sgn:atom_fresh_[4363]'(_atom__fresh___914364_93, __36Pb, __36Pe)), '<module>:emop.sgn:atom_fresh_[4365]'(_atom__fresh___914366_93, __36Pb, __36Pe)), '<module>:emop.sgn:atom_fresh_[4367]'(_atom__fresh___914368_93, __36Pb, __36Pe)), '<module>:emop.sgn:atom_fresh_[4369]'(_atom__fresh___914370_93, __36Pb, __36Pe)), '<module>:emop.sgn:atom_fresh_[4371]'(_atom__fresh___914372_93, __36Pb, __36Pe)), '<module>:emop.sgn:atom_fresh_[4373]'(_atom__fresh___914374_93, __36Pb, __36Pe)), '<module>:emop.sgn:atom_fresh_[4375]'(_atom__fresh___914376_93, __36Pb, __36Pe)), '<module>:emop.sgn:atom_fresh_[4377]'(_atom__fresh___914378_93, __36Pb, __36Pe)), '<module>:emop.sgn:atom_fresh_[4379]'(_atom__fresh___914380_93, __36Pb, __36Pe)), '<module>:emop.sgn:atom_fresh_[4381]'(_atom__fresh___914382_93, __36Pb, __36Pe)), '<module>:emop.sgn:atom_fresh_[4383]'(_atom__fresh___914384_93, __36Pb, __36Pe)), '<module>:emop.sgn:atom_fresh_[4385]'(_atom__fresh___914386_93, __36Pb, __36Pe)), '<module>:emop.sgn:atom_fresh_[4387]'(_atom__fresh___914388_93, __36Pb, __36Pe)), '<module>:emop.sgn:atom_fresh_[4389]'(_atom__fresh___914390_93, __36Pb, __36Pe)), '<module>:emop.sgn:atom_fresh_[4391]'(_atom__fresh___914392_93, __36Pb, __36Pe)), '<module>:emop.sgn:atom_fresh_[4393]'(_atom__fresh___914394_93, __36Pb, __36Pe)), '<module>:emop.sgn:atom_fresh_[4395]'(_atom__fresh___914396_93, __36Pb, __36Pe)), '<module>:emop.sgn:atom_fresh_[4397]'(_atom__fresh___914398_93, __36Pb, __36Pe)), '<module>:emop.sgn:atom_fresh_[4399]'(_atom__fresh___914400_93, __36Pb, __36Pe)), '<module>:emop.sgn:atom_fresh_[4401]'(_atom__fresh___914402_93, __36Pb, __36Pe)), '<module>:emop.sgn:atom_fresh_[4403]'(_atom__fresh___914404_93, __36Pb, __36Pe)), '<module>:emop.sgn:atom_fresh_[4405]'(_atom__fresh___914406_93, __36Pb, __36Pe)), '<module>:emop.sgn:atom_fresh_[4407]'(_atom__fresh___914408_93, __36Pb, __36Pe)), '<module>:emop.sgn:atom_fresh_[4409]'(_atom__fresh___914410_93, __36Pb, __36Pe)), '<module>:emop.sgn:atom_fresh_[4411]'(_atom__fresh___914412_93, __36Pb, __36Pe)), '<module>:emop.sgn:atom_fresh_[4413]'(_atom__fresh___914414_93, __36Pb, __36Pe)), '<module>:emop.sgn:atom_fresh_[4415]'(_atom__fresh___914416_93, __36Pb, __36Pe)), '<module>:emop.sgn:atom_fresh_[4417]'(_atom__fresh___914418_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___914418_93, '.'(_atom__fresh___914416_93, '.'(_atom__fresh___914414_93, '.'(_atom__fresh___914412_93, '.'(_atom__fresh___914410_93, '.'(_atom__fresh___914408_93, '.'(_atom__fresh___914406_93, '.'(_atom__fresh___914404_93, '.'(_atom__fresh___914402_93, '.'(_atom__fresh___914400_93, '.'(_atom__fresh___914398_93, '.'(_atom__fresh___914396_93, '.'(_atom__fresh___914394_93, '.'(_atom__fresh___914392_93, '.'(_atom__fresh___914390_93, '.'(_atom__fresh___914388_93, '.'(_atom__fresh___914386_93, '.'(_atom__fresh___914384_93, '.'(_atom__fresh___914382_93, '.'(_atom__fresh___914380_93, '.'(_atom__fresh___914378_93, '.'(_atom__fresh___914376_93, '.'(_atom__fresh___914374_93, '.'(_atom__fresh___914372_93, '.'(_atom__fresh___914370_93, '.'(_atom__fresh___914368_93, '.'(_atom__fresh___914366_93, '.'(_atom__fresh___914364_93, '.'(_atom__fresh___914362_93, '.'(_atom__fresh___914360_93, '.'(_atom__fresh___914358_93, '.'(_atom__fresh___914356_93, '.'(_atom__fresh___914354_93, '.'(_atom__fresh___914352_93, '.'(_atom__fresh___914350_93, '.'(_atom__fresh___914348_93, '.'(_atom__fresh___914346_93, '.'(_atom__fresh___914344_93, '[]')))))))))))))))))))))))))))))))))))))))))))).
':-'('<module>:emop.sgn:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn:=>'(___91, ___92, ___93, 'env'(_SignatureCacheRef, _ConsultSignatureRef, _SignatureResultRef), __36CutLevel), '=..'(___93, '.'('=>', '.'(___91, '.'(___92, '[]'))))).
':-'('<module>:emop.sgn:=>$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn:=>'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn:add_consult_sgn'(_ModName, _Sgn, 'env'(_SignatureCacheRef, _ConsultSignatureRef, _SignatureResultRef), __36CutLevel), ','('emop_call'(_ConsultSignatureRef, 'get'(___109), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 26, from character 68 to 71'), 'emop_call'(_ConsultSignatureRef, 'set'('.'(','(_ModName, _Sgn), ___109)), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 26, from character 26 to 29'))).
':-'('<module>:emop.sgn:add_consult_sgn$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn:add_consult_sgn'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn:atom'(___87, ___88, ___89, ___90, 'env'(_SignatureCacheRef, _ConsultSignatureRef, _SignatureResultRef), __36CutLevel), '=..'(___90, '.'('atom', '.'(___87, '.'(___88, '.'(___89, '[]')))))).
':-'('<module>:emop.sgn:atom$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn:atom'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn:atom_fresh_[4343]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(extract_sgn, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.sgn:atom_fresh_[4345]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(read_sgn, 4, predicate, suspended([var('Constr'),var('Pb'),var('Pe'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.sgn:atom_fresh_[4347]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(enum_clauses, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.sgn:atom_fresh_[4349]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(directive_sgn, 3, predicate, suspended([none,var('Sgn'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.sgn:atom_fresh_[4351]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(directive_syntax, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.sgn:atom_fresh_[4353]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(special_head, 3, predicate, '[]', __36pos))).
':-'('<module>:emop.sgn:atom_fresh_[4355]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(from_module, 6, predicate, '[]', __36pos))).
':-'('<module>:emop.sgn:atom_fresh_[4357]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(from_module, 7, predicate, '[]', __36pos))).
':-'('<module>:emop.sgn:atom_fresh_[4359]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(from_goal_callable, 6, predicate, '[]', __36pos))).
':-'('<module>:emop.sgn:atom_fresh_[4361]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(from_goal, 4, predicate, '[]', __36pos))).
':-'('<module>:emop.sgn:atom_fresh_[4363]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(callable, 6, constructor, none, __36pos))).
':-'('<module>:emop.sgn:atom_fresh_[4365]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(=>, 3, constructor, none, __36pos))).
':-'('<module>:emop.sgn:atom_fresh_[4367]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(atom, 4, constructor, none, __36pos))).
':-'('<module>:emop.sgn:atom_fresh_[4369]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(from_stream, 3, predicate, '[]', __36pos))).
':-'('<module>:emop.sgn:atom_fresh_[4371]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(from_file, 4, predicate, '[]', __36pos))).
':-'('<module>:emop.sgn:atom_fresh_[4373]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(cache, 3, predicate, suspended([var('Filename'),var('ChangedDate'),var('Sgn')],[call(var('SignatureCacheRef'),set,[none])]), __36pos))).
':-'('<module>:emop.sgn:atom_fresh_[4375]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(add_consult_sgn, 2, predicate, suspended([var('ModName'),var('Sgn')],[call(var('ConsultSignatureRef'),set,[none])]), __36pos))).
':-'('<module>:emop.sgn:atom_fresh_[4377]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(from_mod_spec, 3, predicate, '[]', __36pos))).
':-'('<module>:emop.sgn:atom_fresh_[4379]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(special, 5, constructor, none, __36pos))).
':-'('<module>:emop.sgn:atom_fresh_[4381]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(syntax, 4, constructor, none, __36pos))).
':-'('<module>:emop.sgn:atom_fresh_[4383]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(level, 4, constructor, none, __36pos))).
':-'('<module>:emop.sgn:atom_fresh_[4385]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(notation, 4, constructor, none, __36pos))).
':-'('<module>:emop.sgn:atom_fresh_[4387]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(link, 4, constructor, none, __36pos))).
':-'('<module>:emop.sgn:atom_fresh_[4389]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(clause, 7, constructor, none, __36pos))).
':-'('<module>:emop.sgn:atom_fresh_[4391]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(symbol, 5, constructor, none, __36pos))).
':-'('<module>:emop.sgn:atom_fresh_[4393]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(symbol, 6, constructor, none, __36pos))).
':-'('<module>:emop.sgn:atom_fresh_[4395]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(file, 3, constructor, none, __36pos))).
':-'('<module>:emop.sgn:atom_fresh_[4397]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(error, 3, constructor, none, __36pos))).
':-'('<module>:emop.sgn:atom_fresh_[4399]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(none, 1, constructor, none, __36pos))).
':-'('<module>:emop.sgn:atom_fresh_[4401]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(operator, 1, constructor, none, __36pos))).
':-'('<module>:emop.sgn:atom_fresh_[4403]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(number, 4, constructor, none, __36pos))).
':-'('<module>:emop.sgn:atom_fresh_[4405]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(empty, 3, constructor, none, __36pos))).
':-'('<module>:emop.sgn:atom_fresh_[4407]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(doc, 5, constructor, none, __36pos))).
':-'('<module>:emop.sgn:atom_fresh_[4409]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(doc, 4, constructor, none, __36pos))).
':-'('<module>:emop.sgn:atom_fresh_[4411]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(unescaped, 1, constructor, none, __36pos))).
':-'('<module>:emop.sgn:atom_fresh_[4413]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(var, 2, constructor, none, __36pos))).
':-'('<module>:emop.sgn:atom_fresh_[4415]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(variable, 1, constructor, none, __36pos))).
':-'('<module>:emop.sgn:atom_fresh_[4417]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(module, 8, constructor, none, __36pos))).
':-'('<module>:emop.sgn:cache'(_Filename, _ChangedDate, _Sgn, 'env'(_SignatureCacheRef, _ConsultSignatureRef, _SignatureResultRef), __36CutLevel), ','('emop_call'(_SignatureCacheRef, 'get'(___112), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 29, from character 85 to 88'), 'emop_call'(_SignatureCacheRef, 'set'('.'('cache'(_Filename, _ChangedDate, _Sgn), ___112)), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 29, from character 24 to 27'))).
':-'('<module>:emop.sgn:cache$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn:cache'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn:callable'(___94, ___95, ___96, ___97, ___98, ___99, 'env'(_SignatureCacheRef, _ConsultSignatureRef, _SignatureResultRef), __36CutLevel), '=..'(___99, '.'('callable', '.'(___94, '.'(___95, '.'(___96, '.'(___97, '.'(___98, '[]')))))))).
':-'('<module>:emop.sgn:callable$direct'(_____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn:callable'(_____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn:clause'(___59, ___60, ___61, ___62, ___63, ___64, ___65, 'env'(_SignatureCacheRef, _ConsultSignatureRef, _SignatureResultRef), __36CutLevel), '=..'(___65, '.'('clause', '.'(___59, '.'(___60, '.'(___61, '.'(___62, '.'(___63, '.'(___64, '[]'))))))))).
':-'('<module>:emop.sgn:clause$direct'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn:clause'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn:directive_sgn'('special'(_Symbol, _S, _Pb, _Pe), _Sgn, ___198, 'env'(_SignatureCacheRef, _ConsultSignatureRef, _SignatureResultRef), __36CutLevel), ','(','('true', ';'('->'('var'(___192), ','('g_inc'('$module_count', ___193), '='(___192, '$module'(___193, '.'('<module>:emop.sgn@0'('env'(___192, _SignatureCacheRef, _ConsultSignatureRef, _SignatureResultRef, _Pb, _Pe, _S, _Sgn, _Symbol)), '[]'), '.'(___192, '[]'))))), ','('='(___192, '$module'(___193, ___194, _)), ','('='('.'(___195, ___196), ___194), ','('setarg'(1, ___194, '<module>:emop.sgn@0'('env'(___192, _SignatureCacheRef, _ConsultSignatureRef, _SignatureResultRef, _Pb, _Pe, _S, _Sgn, _Symbol))), 'setarg'(2, ___194, '.'(___195, ___196))))))), 'emop_call'(___192, 'do'(_Symbol, ___198), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 178, from character 7 to 9'))).
':-'('<module>:emop.sgn:directive_sgn$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn:directive_sgn'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn:directive_syntax'(_Ast, _Directive, 'env'(_SignatureCacheRef, _ConsultSignatureRef, _SignatureResultRef), __36CutLevel), ','(','('='(_Concat, ___173), ','('g_read'('emop.parse', '<module>:emop.parse'(___174)), '<module>:emop.parse:reflat$direct'(_Ast, ___173, ___174))), ','(','('='(_List, ___176), ','('g_read'('emop.parse', '<module>:emop.parse'(___177)), '<module>:emop.parse:enum_concat_list$direct'(_Concat, ___176, ___177))), ','(','('g_read'('emop.sgn', '<module>:emop.sgn'(___178)), '<module>:emop.sgn:special_head$direct'(_Symbol, _List, _Tail, ___178)), ','('='(_Symbol, ___165), '->'(','('='(___165, ___166), ';'('='(___166, 'syntax'), ','('='(___166, ___167), ';'('='(___167, 'constructor'), ','('='(___167, ___168), ';'('='(___168, 'abstract'), ','('='(___168, ___169), ';'('='(___169, 'import'), ','('='(___169, ___170), ';'('='(___170, 'notation'), ','('='(___170, ___171), ';'('='(___171, 'level'), '='(___171, 'link'))))))))))))), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','(','('='('file'(_Pb, _Pe), ___188), ','('g_read'('emop.parse', '<module>:emop.parse'(___189)), '<module>:emop.parse:position$direct'(_Ast, ___188, ___189))), '='(_Directive, 'special'(_Symbol, _Tail, _Pb, _Pe)))))))))).
':-'('<module>:emop.sgn:directive_syntax$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn:directive_syntax'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn:doc'(___24, ___25, ___26, ___27, 'env'(_SignatureCacheRef, _ConsultSignatureRef, _SignatureResultRef), __36CutLevel), '=..'(___27, '.'('doc', '.'(___24, '.'(___25, '.'(___26, '[]')))))).
':-'('<module>:emop.sgn:doc'(___28, ___29, ___30, ___31, ___32, 'env'(_SignatureCacheRef, _ConsultSignatureRef, _SignatureResultRef), __36CutLevel), '=..'(___32, '.'('doc', '.'(___28, '.'(___29, '.'(___30, '.'(___31, '[]'))))))).
':-'('<module>:emop.sgn:doc$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn:doc'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn:doc$direct'(_____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn:doc'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn:empty'(___33, ___34, ___35, 'env'(_SignatureCacheRef, _ConsultSignatureRef, _SignatureResultRef), __36CutLevel), '=..'(___35, '.'('empty', '.'(___33, '.'(___34, '[]'))))).
':-'('<module>:emop.sgn:empty$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn:empty'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn:enum_clauses'(_Ast, _Clauses, 'env'(_SignatureCacheRef, _ConsultSignatureRef, _SignatureResultRef), __36CutLevel), ','(','('='(_NewClausesRef, ___201), ','('g_read'('data.ref.backtrackable', '<module>:data.ref.backtrackable'(___202)), '<module>:data.ref.backtrackable:new$direct'('[]', ___201, ___202))), ','(','(','('true', ';'('->'('var'(_EnumClauses), ','('g_inc'('$module_count', ___203), '='(_EnumClauses, '$module'(___203, '.'('<module>:emop.sgn@1'('env'(_EnumClauses, _EnumClauses, _NewClausesRef)), '[]'), '.'(_EnumClauses, '[]'))))), ','('='(_EnumClauses, '$module'(___203, ___204, _)), ','('='('.'(___205, ___206), ___204), ','('setarg'(1, ___204, '<module>:emop.sgn@1'('env'(_EnumClauses, _EnumClauses, _NewClausesRef))), 'setarg'(2, ___204, '.'(___205, ___206))))))), 'emop_call'(_EnumClauses, 'expand_clauses'(_Ast), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 442, from character 8 to 22')), ','('='(_Clauses, ___210), ','('emop_call'(_NewClausesRef, 'get'(___209), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 443, from character 50 to 53'), ','('g_read'('data.list', '<module>:data.list'(___211)), '<module>:data.list:reverse$direct'(___209, ___210, ___211))))))).
':-'('<module>:emop.sgn:enum_clauses$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn:enum_clauses'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn:error'(___42, ___43, ___44, 'env'(_SignatureCacheRef, _ConsultSignatureRef, _SignatureResultRef), __36CutLevel), '=..'(___44, '.'('error', '.'(___42, '.'(___43, '[]'))))).
':-'('<module>:emop.sgn:error$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn:error'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn:extract_sgn'(_Clauses, _Sgn, 'env'(_SignatureCacheRef, _ConsultSignatureRef, _SignatureResultRef), __36CutLevel), ';'('->'(','('='(_Sgn, ___231), ','(','(','('true', ';'('->'('var'(___223), ','('g_inc'('$module_count', ___224), '='(___223, '$module'(___224, '.'('<module>:emop.sgn@3'('env'(___223)), '[]'), '.'(___223, '[]'))))), ','('='(___223, '$module'(___224, ___225, _)), ','('='('.'(___226, ___227), ___225), ','('setarg'(1, ___225, '<module>:emop.sgn@3'('env'(___223))), 'setarg'(2, ___225, '.'(___226, ___227))))))), ','('g_read'('data.list', '<module>:data.list'(___230)), '<module>:data.list:fold_left$direct'(_Clauses, '[]', ___223, ___229, ___230))), ','('g_read'('data.list', '<module>:data.list'(___232)), '<module>:data.list:reverse$direct'(___229, ___231, ___232)))), 'true'), 'throw'('extract_sgn fail'))).
':-'('<module>:emop.sgn:extract_sgn$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn:extract_sgn'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn:file'(___45, ___46, ___47, 'env'(_SignatureCacheRef, _ConsultSignatureRef, _SignatureResultRef), __36CutLevel), '=..'(___47, '.'('file', '.'(___45, '.'(___46, '[]'))))).
':-'('<module>:emop.sgn:file$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn:file'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn:from_file'(_BaseFilename, _Filename, _Stream, _Sgn, 'env'(_SignatureCacheRef, _ConsultSignatureRef, _SignatureResultRef), __36CutLevel), ','(','('='(_ChangedDate, ___115), ','('g_read'('sys.file', '<module>:sys.file'(___116)), '<module>:sys.file:last_modification$direct'(_Filename, ___115, ___116))), ';'('->'(','(','('emop_call'(_SignatureCacheRef, 'get'(___119), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 34, from character 81 to 84'), ','('g_read'('data.list', '<module>:data.list'(___120)), '<module>:data.list:member$direct'('cache'(_Filename, _ParsedDate, _Sgn0), ___119, ___120))), ','('g_read'('data.term', '<module>:data.term'(___122)), '<module>:data.term:=<$direct'(_ChangedDate, _ParsedDate, ___122))), '='(_Sgn, _Sgn0)), ','(';'('->'(','('g_read'('data.var', '<module>:data.var'(___124)), '<module>:data.var:check$direct'(_SignatureResultRef, ___124)), ','('='(_SignatureResultRef, ___127), ','('g_read'('data.ref.non_backtrackable', '<module>:data.ref.non_backtrackable'(___128)), '<module>:data.ref.non_backtrackable:new$direct'('[]', ___127, ___128)))), 'true'), ';'(','(';'('->'(','('g_read'('emop.compile', '<module>:emop.compile'(___130)), '<module>:emop.compile:read_interface$direct'(_BaseFilename, _Filename, _, _, _, _Sgn0, _, _, _, _, ___130)), 'true'), ','('='(_Sgn0, ___131), ','('g_read'('emop.sgn', '<module>:emop.sgn'(___132)), '<module>:emop.sgn:from_stream$direct'(_Filename, _Stream, ___131, ___132)))), ','('emop_call'(_SignatureResultRef, 'set'(_Sgn0), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 54, from character 31 to 34'), 'fail')), ','(','('='(_Sgn0, ___133), 'emop_call'(_SignatureResultRef, 'get'(___133), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 57, from character 38 to 41')), ','('emop_call'(_SignatureResultRef, 'set'('[]'), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 58, from character 31 to 34'), ','(','('g_read'('emop.sgn', '<module>:emop.sgn'(___135)), '<module>:emop.sgn:cache$direct'(_Filename, _ChangedDate, _Sgn0, ___135)), '='(_Sgn, _Sgn0))))))))).
':-'('<module>:emop.sgn:from_file$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn:from_file'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn:from_goal'('callable'(_F, _Escaped, _Args, ___Pb, ___Pe), _Ctx, _ModuleSgn, _Sgn, 'env'(_SignatureCacheRef, _ConsultSignatureRef, _SignatureResultRef), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','('g_read'('emop.sgn', '<module>:emop.sgn'(___142)), '<module>:emop.sgn:from_goal_callable$direct'(_F, _Escaped, _Args, _Ctx, _ModuleSgn, _Sgn, ___142)))).
':-'('<module>:emop.sgn:from_goal'('module'(_Name, _Env, _, _Sgn0, _, _, _), _Ctx, _ModuleSgn, _Sgn, 'env'(_SignatureCacheRef, _ConsultSignatureRef, _SignatureResultRef), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','('g_read'('emop.sgn', '<module>:emop.sgn'(___144)), '<module>:emop.sgn:from_module$direct'(_Name, _Env, _Sgn0, _, _Ctx, _ModuleSgn, _Sgn, ___144)))).
':-'('<module>:emop.sgn:from_goal'(_, ___Ctx, ___ModuleSgn, ___Sgn, 'env'(_SignatureCacheRef, _ConsultSignatureRef, _SignatureResultRef), __36CutLevel), 'true').
':-'('<module>:emop.sgn:from_goal$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn:from_goal'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn:from_goal_callable'(',', 'operator', '.'(_A, '.'(_B, '[]')), _Ctx, _ModuleSgn, _Sgn, 'env'(_SignatureCacheRef, _ConsultSignatureRef, _SignatureResultRef), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','(','('g_read'('emop.sgn', '<module>:emop.sgn'(___150)), '<module>:emop.sgn:from_goal$direct'(_A, _Ctx, _ModuleSgn, _Sgn, ___150)), ','('g_read'('emop.sgn', '<module>:emop.sgn'(___151)), '<module>:emop.sgn:from_goal$direct'(_B, _Ctx, _ModuleSgn, _Sgn, ___151))))).
':-'('<module>:emop.sgn:from_goal_callable'(_, _, _, _, _, _, 'env'(_SignatureCacheRef, _ConsultSignatureRef, _SignatureResultRef), __36CutLevel), 'true').
':-'('<module>:emop.sgn:from_goal_callable$direct'(_____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn:from_goal_callable'(_____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn:from_mod_spec'(_ModSpec, _Pos, _Sgn, 'env'(_SignatureCacheRef, _ConsultSignatureRef, _SignatureResultRef), __36CutLevel), ';'('->'(','('='(_ModSpec, 'name'(_ModName, _, _)), ','('emop_call'(_ConsultSignatureRef, 'get'(___103), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 10, from character 62 to 65'), ','('g_read'('data.list', '<module>:data.list'(___104)), '<module>:data.list:member$direct'(','(_ModName, _Sgn), ___103, ___104)))), 'true'), ','(','('g_read'('emop.compile', '<module>:emop.compile'(___106)), '<module>:emop.compile:lookup$direct'(_ModSpec, _Pos, _BaseFilename, _Filename, _Stream, ___106)), ','(','('g_read'('emop.sgn', '<module>:emop.sgn'(___107)), '<module>:emop.sgn:from_file$direct'(_BaseFilename, _Filename, _Stream, _Sgn, ___107)), 'emop_call'(_Stream, 'close', 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 22, from character 16 to 21'))))).
':-'('<module>:emop.sgn:from_mod_spec$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn:from_mod_spec'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn:from_module'(_, ___Env, ___Body, ___Ctx, ___ModuleSgn, ___Sgn, 'env'(_SignatureCacheRef, _ConsultSignatureRef, _SignatureResultRef), __36CutLevel), 'true').
':-'('<module>:emop.sgn:from_module'('atom'(_Name, _Escaped, _, _), ___Env, _Sgn0, _, ___Ctx, _ModuleSgn, ___Sgn, 'env'(_SignatureCacheRef, _ConsultSignatureRef, _SignatureResultRef), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ';'('->'(','('g_read'('emop.parser', '<module>:emop.parser'(___155)), '<module>:emop.parser:is_variable$direct'(_Name, _Escaped, 'none', ___155)), 'true'), '='(_ModuleSgn, _Sgn0)))).
':-'('<module>:emop.sgn:from_module$direct'(_____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn:from_module'(_____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn:from_module$direct'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn:from_module'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn:from_stream'(_Filename, _Stream, _Sgn, 'env'(_SignatureCacheRef, _ConsultSignatureRef, _SignatureResultRef), __36CutLevel), ','(','('g_read'('emop.parser', '<module>:emop.parser'(___138)), '<module>:emop.parser:parse_file$direct'(_Filename, _Stream, 'emop.sgn', ___137, ___138)), ','('g_read'('emop.sgn', '<module>:emop.sgn'(___140)), '<module>:emop.sgn:from_goal$direct'(___137, 'none', _Sgn, _, ___140)))).
':-'('<module>:emop.sgn:from_stream$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn:from_stream'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn:level'(___74, ___75, ___76, ___77, 'env'(_SignatureCacheRef, _ConsultSignatureRef, _SignatureResultRef), __36CutLevel), '=..'(___77, '.'('level', '.'(___74, '.'(___75, '.'(___76, '[]')))))).
':-'('<module>:emop.sgn:level$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn:level'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn:link'(___66, ___67, ___68, ___69, 'env'(_SignatureCacheRef, _ConsultSignatureRef, _SignatureResultRef), __36CutLevel), '=..'(___69, '.'('link', '.'(___66, '.'(___67, '.'(___68, '[]')))))).
':-'('<module>:emop.sgn:link$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn:link'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn:module'(___12, ___13, ___14, ___15, ___16, ___17, ___18, ___19, 'env'(_SignatureCacheRef, _ConsultSignatureRef, _SignatureResultRef), __36CutLevel), '=..'(___19, '.'('module', '.'(___12, '.'(___13, '.'(___14, '.'(___15, '.'(___16, '.'(___17, '.'(___18, '[]')))))))))).
':-'('<module>:emop.sgn:module$direct'(_____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn:module'(_____8, _____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn:none'(___41, 'env'(_SignatureCacheRef, _ConsultSignatureRef, _SignatureResultRef), __36CutLevel), '=..'(___41, '.'('none', '[]'))).
':-'('<module>:emop.sgn:none$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn:none'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn:notation'(___70, ___71, ___72, ___73, 'env'(_SignatureCacheRef, _ConsultSignatureRef, _SignatureResultRef), __36CutLevel), '=..'(___73, '.'('notation', '.'(___70, '.'(___71, '.'(___72, '[]')))))).
':-'('<module>:emop.sgn:notation$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn:notation'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn:number'(___36, ___37, ___38, ___39, 'env'(_SignatureCacheRef, _ConsultSignatureRef, _SignatureResultRef), __36CutLevel), '=..'(___39, '.'('number', '.'(___36, '.'(___37, '.'(___38, '[]')))))).
':-'('<module>:emop.sgn:number$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn:number'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn:operator'(___40, 'env'(_SignatureCacheRef, _ConsultSignatureRef, _SignatureResultRef), __36CutLevel), '=..'(___40, '.'('operator', '[]'))).
':-'('<module>:emop.sgn:operator$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn:operator'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn:read_sgn'(_Constr, _Pb, _Pe, ___219, 'env'(_SignatureCacheRef, _ConsultSignatureRef, _SignatureResultRef), __36CutLevel), ','(','('true', ';'('->'('var'(___212), ','('g_inc'('$module_count', ___213), '='(___212, '$module'(___213, '.'('<module>:emop.sgn@2'('env'(___212, _Pb, _Pe)), '[]'), '.'(___212, '[]'))))), ','('='(___212, '$module'(___213, ___214, _)), ','('='('.'(___215, ___216), ___214), ','('setarg'(1, ___214, '<module>:emop.sgn@2'('env'(___212, _Pb, _Pe))), 'setarg'(2, ___214, '.'(___215, ___216))))))), 'emop_call'(___212, 'do'(_Constr, '[]', ___219), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 469, from character 7 to 9'))).
':-'('<module>:emop.sgn:read_sgn$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn:read_sgn'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn:special'(___82, ___83, ___84, ___85, ___86, 'env'(_SignatureCacheRef, _ConsultSignatureRef, _SignatureResultRef), __36CutLevel), '=..'(___86, '.'('special', '.'(___82, '.'(___83, '.'(___84, '.'(___85, '[]'))))))).
':-'('<module>:emop.sgn:special$direct'(_____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn:special'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn:special_head'(_Symbol, '.'('callable'(_Symbol, 'unescaped', 'none', _, _), '.'('callable'(':', 'unescaped', 'none', _, _), _Tail)), _Tail, 'env'(_SignatureCacheRef, _ConsultSignatureRef, _SignatureResultRef), __36CutLevel), 'true').
':-'('<module>:emop.sgn:special_head$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn:special_head'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn:symbol'(___54, ___55, ___56, ___57, ___58, 'env'(_SignatureCacheRef, _ConsultSignatureRef, _SignatureResultRef), __36CutLevel), '=..'(___58, '.'('symbol', '.'(___54, '.'(___55, '.'(___56, '.'(___57, '[]'))))))).
':-'('<module>:emop.sgn:symbol'(___48, ___49, ___50, ___51, ___52, ___53, 'env'(_SignatureCacheRef, _ConsultSignatureRef, _SignatureResultRef), __36CutLevel), '=..'(___53, '.'('symbol', '.'(___48, '.'(___49, '.'(___50, '.'(___51, '.'(___52, '[]')))))))).
':-'('<module>:emop.sgn:symbol$direct'(_____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn:symbol'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn:symbol$direct'(_____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn:symbol'(_____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn:syntax'(___78, ___79, ___80, ___81, 'env'(_SignatureCacheRef, _ConsultSignatureRef, _SignatureResultRef), __36CutLevel), '=..'(___81, '.'('syntax', '.'(___78, '.'(___79, '.'(___80, '[]')))))).
':-'('<module>:emop.sgn:syntax$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn:syntax'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn:unescaped'(___23, 'env'(_SignatureCacheRef, _ConsultSignatureRef, _SignatureResultRef), __36CutLevel), '=..'(___23, '.'('unescaped', '[]'))).
':-'('<module>:emop.sgn:unescaped$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn:unescaped'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn:var'(___21, ___22, 'env'(_SignatureCacheRef, _ConsultSignatureRef, _SignatureResultRef), __36CutLevel), '=..'(___22, '.'('var', '.'(___21, '[]')))).
':-'('<module>:emop.sgn:var$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn:var'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn:variable'(___20, 'env'(_SignatureCacheRef, _ConsultSignatureRef, _SignatureResultRef), __36CutLevel), '=..'(___20, '.'('variable', '[]'))).
':-'('<module>:emop.sgn:variable$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn:variable'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@0'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn@0:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@0'('do'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn@0:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@0'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.sgn@0$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.sgn@0$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.sgn@0$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.sgn@0$has_predicate'('do'(_____2, _____1)), 'true').
':-'('<module>:emop.sgn@0:$sgn'(__36sgn, 'env'(___197, _SignatureCacheRef, _ConsultSignatureRef, _SignatureResultRef, _Pb, _Pe, _S, _Sgn, _Symbol), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl',3725,132,3719)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl',3733,132,3719)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.sgn@0:atom_fresh_[4477]'(_atom__fresh___914478_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___914478_93, '[]'))))))).
':-'('<module>:emop.sgn@0:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn@0:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@0:atom_fresh_[4477]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 2, predicate, suspended([none,none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.sgn@0:do'('syntax', '.'('syntax'(_S, _Pb, _Pe), _Sgn), 'env'(___197, _SignatureCacheRef, _ConsultSignatureRef, _SignatureResultRef, _Pb, _Pe, _S, _Sgn, _Symbol), __36CutLevel), 'true').
':-'('<module>:emop.sgn@0:do'('level', '.'('level'(_S, _Pb, _Pe), _Sgn), 'env'(___197, _SignatureCacheRef, _ConsultSignatureRef, _SignatureResultRef, _Pb, _Pe, _S, _Sgn, _Symbol), __36CutLevel), 'true').
':-'('<module>:emop.sgn@0:do'('constructor', ___764, 'env'(___197, _SignatureCacheRef, _ConsultSignatureRef, _SignatureResultRef, _Pb, _Pe, _S, _Sgn, _Symbol), __36CutLevel), ','(','(','('g_read'('emop.sgn', '<module>:emop.sgn'(___757)), '<module>:emop.sgn:read_sgn$direct'(_S, _Pb, _Pe, ___756, ___757)), ','('true', ';'('->'('var'(___758), ','('g_inc'('$module_count', ___759), '='(___758, '$module'(___759, '.'('<module>:emop.sgn@11'('env'(___758, ___197)), '[]'), '.'(___758, '[]'))))), ','('='(___758, '$module'(___759, ___760, _)), ','('='('.'(___761, ___762), ___760), ','('setarg'(1, ___760, '<module>:emop.sgn@11'('env'(___758, ___197))), 'setarg'(2, ___760, '.'(___761, ___762)))))))), ','('g_read'('data.list', '<module>:data.list'(___765)), '<module>:data.list:fold_left$direct'(___756, _Sgn, ___758, ___764, ___765)))).
':-'('<module>:emop.sgn@0:do'('abstract', ___776, 'env'(___197, _SignatureCacheRef, _ConsultSignatureRef, _SignatureResultRef, _Pb, _Pe, _S, _Sgn, _Symbol), __36CutLevel), ','(','(','('g_read'('emop.sgn', '<module>:emop.sgn'(___769)), '<module>:emop.sgn:read_sgn$direct'(_S, _Pb, _Pe, ___768, ___769)), ','('true', ';'('->'('var'(___770), ','('g_inc'('$module_count', ___771), '='(___770, '$module'(___771, '.'('<module>:emop.sgn@12'('env'(___770, ___197)), '[]'), '.'(___770, '[]'))))), ','('='(___770, '$module'(___771, ___772, _)), ','('='('.'(___773, ___774), ___772), ','('setarg'(1, ___772, '<module>:emop.sgn@12'('env'(___770, ___197))), 'setarg'(2, ___772, '.'(___773, ___774)))))))), ','('g_read'('data.list', '<module>:data.list'(___777)), '<module>:data.list:fold_left$direct'(___768, _Sgn, ___770, ___776, ___777)))).
':-'('<module>:emop.sgn@0:do'('import', _Sgn, 'env'(___197, _SignatureCacheRef, _ConsultSignatureRef, _SignatureResultRef, _Pb, _Pe, _S, _Sgn, _Symbol), __36CutLevel), 'true').
':-'('<module>:emop.sgn@0:do'('notation', '.'('notation'(_S, _Pb, _Pe), _Sgn), 'env'(___197, _SignatureCacheRef, _ConsultSignatureRef, _SignatureResultRef, _Pb, _Pe, _S, _Sgn, _Symbol), __36CutLevel), 'true').
':-'('<module>:emop.sgn@0:do'('link', _Sgn, 'env'(___197, _SignatureCacheRef, _ConsultSignatureRef, _SignatureResultRef, _Pb, _Pe, _S, _Sgn, _Symbol), __36CutLevel), 'true').
':-'('<module>:emop.sgn@0:do$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn@0:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@1'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn@1:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@1'('expand_clauses'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn@1:expand_clauses'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@1'('expand_clause_doc'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn@1:expand_clause_doc'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@1'('expand_xml'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn@1:expand_xml'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@1'('reserved'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn@1:reserved'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@1'('add_clause'(_____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn@1:add_clause'(_____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@1'('check_predicate_quotes'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn@1:check_predicate_quotes'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@1'('expand_clauses_callable'(_____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn@1:expand_clauses_callable'(_____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@1'('expand_eq_clause'(_____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn@1:expand_eq_clause'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@1'('expand_eq_clause_deprecated'(_____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn@1:expand_eq_clause_deprecated'(_____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@1'('decompose_head'(_____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn@1:decompose_head'(_____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@1'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.sgn@1$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.sgn@1$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.sgn@1$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.sgn@1$has_predicate'('expand_clauses'(_____1)), 'true').
':-'('<module>:emop.sgn@1$has_predicate'('expand_clause_doc'(_____2, _____1)), 'true').
':-'('<module>:emop.sgn@1$has_predicate'('expand_xml'(_____2, _____1)), 'true').
':-'('<module>:emop.sgn@1$has_predicate'('reserved'(_____2, _____1)), 'true').
':-'('<module>:emop.sgn@1$has_predicate'('add_clause'(_____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.sgn@1$has_predicate'('check_predicate_quotes'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.sgn@1$has_predicate'('expand_clauses_callable'(_____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.sgn@1$has_predicate'('expand_eq_clause'(_____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.sgn@1$has_predicate'('expand_eq_clause_deprecated'(_____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.sgn@1$has_predicate'('decompose_head'(_____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.sgn@10'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn@10:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@10'('do'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn@10:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@10'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.sgn@10$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.sgn@10$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.sgn@10$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.sgn@10$has_predicate'('do'(_____1)), 'true').
':-'('<module>:emop.sgn@10:$sgn'(__36sgn, 'env'(___648, _Aux, _F, _Args, ___207), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl',12097,369,12085)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl',12124,369,12085)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.sgn@10:atom_fresh_[4473]'(_atom__fresh___914474_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___914474_93, '[]'))))))).
':-'('<module>:emop.sgn@10:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn@10:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@10:atom_fresh_[4473]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.sgn@10:do'('callable'(_F, _, _Args, _, _), 'env'(___648, _Aux, _F, _Args, ___207), __36CutLevel), 'true').
':-'('<module>:emop.sgn@10:do'('()'(_Sub__clauses, _, _), 'env'(___648, _Aux, _F, _Args, ___207), __36CutLevel), 'emop_call'(_Aux, 'do'(_Sub__clauses), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 373, from character 22 to 24')).
':-'('<module>:emop.sgn@10:do'('callable'(':', 'operator', '.'(_, '.'(_, '[]')), _Pb, _Pe), 'env'(___648, _Aux, _F, _Args, ___207), __36CutLevel), 'throw'('error'('Predicate definition cannot be prefixed', 'file'(_Pb, _Pe)))).
':-'('<module>:emop.sgn@10:do'('module'(_, _, _, _, _, _Pb, _Pe), 'env'(___648, _Aux, _F, _Args, ___207), __36CutLevel), 'throw'('error'('A module is not a valid predicate', 'file'(_Pb, _Pe)))).
':-'('<module>:emop.sgn@10:do'('number'(_, _Pb, _Pe), 'env'(___648, _Aux, _F, _Args, ___207), __36CutLevel), 'throw'('error'('A number is not a valid predicate', 'file'(_Pb, _Pe)))).
':-'('<module>:emop.sgn@10:do'('empty'(_Pb, _Pe), 'env'(___648, _Aux, _F, _Args, ___207), __36CutLevel), 'throw'('error'('An empty item is not a valid predicate', 'file'(_Pb, _Pe)))).
':-'('<module>:emop.sgn@10:do'('doc'(_, _Pb, _Pe, _), 'env'(___648, _Aux, _F, _Args, ___207), __36CutLevel), 'throw'('error'('Documentation not allowed here', 'file'(_Pb, _Pe)))).
':-'('<module>:emop.sgn@10:do$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn@10:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@11'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn@11:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@11'('do'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn@11:do'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@11'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.sgn@11$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.sgn@11$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.sgn@11$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.sgn@11$has_predicate'('do'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.sgn@11:$sgn'(__36sgn, 'env'(___763, ___197), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl',3883,138,3862)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl',3923,138,3862)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.sgn@11:atom_fresh_[4481]'(_atom__fresh___914482_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___914482_93, '[]'))))))).
':-'('<module>:emop.sgn@11:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn@11:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@11:atom_fresh_[4481]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 3, predicate, '[]', __36pos))).
':-'('<module>:emop.sgn@11:do'('symbol'(_F, _N, _Pb, _Pe), _Sgn, _NewSgn, 'env'(___763, ___197), __36CutLevel), ','(','('='(_M, ___797), ','('g_read'('data.number', '<module>:data.number'(___798)), '<module>:data.number:+$direct'(_N, 1, ___797, ___798))), ';'('->'(','('g_read'('data.list', '<module>:data.list'(___801)), '<module>:data.list:member$direct'('symbol'(_F, _M, ___Kind, _, _), _Sgn, ___801)), 'throw'('error'('This symbol is already defined', 'file'(_Pb, _Pe)))), '='(_NewSgn, '.'('symbol'(_F, _M, 'constructor', 'none', 'file'(_Pb, _Pe)), _Sgn))))).
':-'('<module>:emop.sgn@11:do$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn@11:do'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@12'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn@12:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@12'('do'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn@12:do'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@12'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.sgn@12$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.sgn@12$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.sgn@12$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.sgn@12$has_predicate'('do'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.sgn@12:$sgn'(__36sgn, 'env'(___775, ___197), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl',4519,156,4498)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl',4559,156,4498)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.sgn@12:atom_fresh_[4479]'(_atom__fresh___914480_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___914480_93, '[]'))))))).
':-'('<module>:emop.sgn@12:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn@12:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@12:atom_fresh_[4479]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 3, predicate, '[]', __36pos))).
':-'('<module>:emop.sgn@12:do'('symbol'(_F, _N, _Pb, _Pe), _Sgn, _NewSgn, 'env'(___775, ___197), __36CutLevel), ';'('->'(','('g_read'('data.list', '<module>:data.list'(___786)), '<module>:data.list:member$direct'('symbol'(_F, _N, ___Kind, _, _), _Sgn, ___786)), 'throw'('error'('This symbol is already defined', 'file'(_Pb, _Pe)))), '='(_NewSgn, '.'('symbol'(_F, _N, 'abstract', 'none', 'file'(_Pb, _Pe)), _Sgn)))).
':-'('<module>:emop.sgn@12:do$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn@12:do'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@1:$sgn'(__36sgn, 'env'(___207, _EnumClauses, _NewClausesRef), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl',5289,181,5283)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl',5365,184,5356)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','(','(','(','(','(','(','(','('true', '<module>:emop.sgn@1:atom_fresh_[4453]'(_atom__fresh___914454_93, __36Pb, __36Pe)), '<module>:emop.sgn@1:atom_fresh_[4455]'(_atom__fresh___914456_93, __36Pb, __36Pe)), '<module>:emop.sgn@1:atom_fresh_[4457]'(_atom__fresh___914458_93, __36Pb, __36Pe)), '<module>:emop.sgn@1:atom_fresh_[4459]'(_atom__fresh___914460_93, __36Pb, __36Pe)), '<module>:emop.sgn@1:atom_fresh_[4461]'(_atom__fresh___914462_93, __36Pb, __36Pe)), '<module>:emop.sgn@1:atom_fresh_[4463]'(_atom__fresh___914464_93, __36Pb, __36Pe)), '<module>:emop.sgn@1:atom_fresh_[4465]'(_atom__fresh___914466_93, __36Pb, __36Pe)), '<module>:emop.sgn@1:atom_fresh_[4467]'(_atom__fresh___914468_93, __36Pb, __36Pe)), '<module>:emop.sgn@1:atom_fresh_[4469]'(_atom__fresh___914470_93, __36Pb, __36Pe)), '<module>:emop.sgn@1:atom_fresh_[4471]'(_atom__fresh___914472_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___914472_93, '.'(_atom__fresh___914470_93, '.'(_atom__fresh___914468_93, '.'(_atom__fresh___914466_93, '.'(_atom__fresh___914464_93, '.'(_atom__fresh___914462_93, '.'(_atom__fresh___914460_93, '.'(_atom__fresh___914458_93, '.'(_atom__fresh___914456_93, '.'(_atom__fresh___914454_93, '[]')))))))))))))))).
':-'('<module>:emop.sgn@1:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn@1:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@1:add_clause'(_F, _Args, _B, _Doc, _Pb, _Pe, 'env'(___207, _EnumClauses, _NewClausesRef), __36CutLevel), ','(','('g_read'('data.list', '<module>:data.list'(___553)), '<module>:data.list:length$direct'(_Args, _N, ___553)), ';'('->'('emop_call'(___207, 'reserved'(_F, _N), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 243, from character 15 to 23'), ','(','('g_read'('data.atom', '<module>:data.atom'(___560)), '<module>:data.atom:format$direct'('This clause redefines the reserved predicate ~a/~d.', '.'(_F, '.'(_N, '[]')), ___559, ___560)), 'throw'('error'(___559, 'file'(_Pb, _Pe))))), ','('emop_call'(_NewClausesRef, 'get'(___564), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 248, from character 67 to 70'), 'emop_call'(_NewClausesRef, 'set'('.'('clause'(_F, _Args, _B, _Doc, _Pb, _Pe), ___564)), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 247, from character 29 to 32'))))).
':-'('<module>:emop.sgn@1:add_clause$direct'(_____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn@1:add_clause'(_____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@1:atom_fresh_[4453]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(decompose_head, 6, predicate, '[]', __36pos))).
':-'('<module>:emop.sgn@1:atom_fresh_[4455]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(expand_eq_clause_deprecated, 6, predicate, '[]', __36pos))).
':-'('<module>:emop.sgn@1:atom_fresh_[4457]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(expand_eq_clause, 5, predicate, '[]', __36pos))).
':-'('<module>:emop.sgn@1:atom_fresh_[4459]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(expand_clauses_callable, 6, predicate, '[]', __36pos))).
':-'('<module>:emop.sgn@1:atom_fresh_[4461]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(check_predicate_quotes, 3, predicate, '[]', __36pos))).
':-'('<module>:emop.sgn@1:atom_fresh_[4463]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(add_clause, 6, predicate, '[]', __36pos))).
':-'('<module>:emop.sgn@1:atom_fresh_[4465]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(reserved, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.sgn@1:atom_fresh_[4467]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(expand_xml, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.sgn@1:atom_fresh_[4469]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(expand_clause_doc, 2, predicate, suspended([none,var('Doc')],[call(scope,expand_clauses_callable,[var('F'),var('Escaped'),var('Args'),var('Pb'),var('Pe'),var('Doc')])]), __36pos))).
':-'('<module>:emop.sgn@1:atom_fresh_[4471]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(expand_clauses, 1, predicate, suspended([none],[call(scope,expand_clauses_callable,[var('F'),var('Escaped'),var('Args'),var('Pb'),var('Pe'),none])]), __36pos))).
':-'('<module>:emop.sgn@1:check_predicate_quotes'(_Escaped, _Pb, _Pe, 'env'(___207, _EnumClauses, _NewClausesRef), __36CutLevel), ';'('->'('='(_Escaped, 'unescaped'), 'true'), ','('g_read'('emop.message', '<module>:emop.message'(___570)), '<module>:emop.message:warning$direct'('Predicates should be quoted between `...\'', 'file'(_Pb, _Pe), ___570)))).
':-'('<module>:emop.sgn@1:check_predicate_quotes$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn@1:check_predicate_quotes'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@1:decompose_head'('callable'(_F, _Escaped, _Args, _Pb, _Pe), _Pb, _Pe, _F, _Escaped, _Args0, 'env'(___207, _EnumClauses, _NewClausesRef), __36CutLevel), ';'('->'('='(_Args, 'none'), '='(_Args0, '[]')), '='(_Args0, _Args))).
':-'('<module>:emop.sgn@1:decompose_head'('()'(_SubHead, _, _), _Pb, _Pe, _F, _Escaped, _Args, 'env'(___207, _EnumClauses, _NewClausesRef), __36CutLevel), 'emop_call'(_EnumClauses, 'decompose_head'(_SubHead, _Pb, _Pe, _F, _Escaped, _Args), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 431, from character 24 to 38')).
':-'('<module>:emop.sgn@1:decompose_head'('module'(_, _, _, _, _, _Pb, _Pe), _, _, _, _, _, 'env'(___207, _EnumClauses, _NewClausesRef), __36CutLevel), 'throw'('error'('A module is not a valid head', 'file'(_Pb, _Pe)))).
':-'('<module>:emop.sgn@1:decompose_head'('number'(_, _Pb, _Pe), _, _, _, _, _, 'env'(___207, _EnumClauses, _NewClausesRef), __36CutLevel), 'throw'('error'('A number is not a valid head', 'file'(_Pb, _Pe)))).
':-'('<module>:emop.sgn@1:decompose_head'('empty'(_Pb, _Pe), _, _, _, _, _, 'env'(___207, _EnumClauses, _NewClausesRef), __36CutLevel), 'throw'('error'('Empty head not allowed', 'file'(_Pb, _Pe)))).
':-'('<module>:emop.sgn@1:decompose_head'('doc'(_, _Pb, _Pe, _), _, _, _, _, _, 'env'(___207, _EnumClauses, _NewClausesRef), __36CutLevel), 'throw'('error'('Documentation not allowed here', 'file'(_Pb, _Pe)))).
':-'('<module>:emop.sgn@1:decompose_head$direct'(_____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn@1:decompose_head'(_____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@1:expand_clause_doc'('callable'(_F, _Escaped, _Args, _Pb, _Pe), _Doc, 'env'(___207, _EnumClauses, _NewClausesRef), __36CutLevel), 'emop_call'(___207, 'expand_clauses_callable'(_F, _Escaped, _Args, _Pb, _Pe, _Doc), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 199, from character 12 to 35')).
':-'('<module>:emop.sgn@1:expand_clause_doc'('()'(_Sub__clauses, _, _), _Doc, 'env'(___207, _EnumClauses, _NewClausesRef), __36CutLevel), 'emop_call'(___207, 'expand_clause_doc'(_Sub__clauses, _Doc), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 201, from character 12 to 29')).
':-'('<module>:emop.sgn@1:expand_clause_doc'('module'(_, _, _, _, _, _Pb, _Pe), _, 'env'(___207, _EnumClauses, _NewClausesRef), __36CutLevel), 'throw'('error'('A module is not a valid clause', 'file'(_Pb, _Pe)))).
':-'('<module>:emop.sgn@1:expand_clause_doc'('number'(_, _Pb, _Pe), _, 'env'(___207, _EnumClauses, _NewClausesRef), __36CutLevel), 'throw'('error'('A number is not a valid clause', 'file'(_Pb, _Pe)))).
':-'('<module>:emop.sgn@1:expand_clause_doc'('empty'(_Pb, _Pe), _, 'env'(___207, _EnumClauses, _NewClausesRef), __36CutLevel), 'throw'('error'('A documentation should be followed by an implementation', 'file'(_Pb, _Pe)))).
':-'('<module>:emop.sgn@1:expand_clause_doc'('doc'(_, _Pb, _Pe, _), _, 'env'(___207, _EnumClauses, _NewClausesRef), __36CutLevel), 'throw'('error'('Predicate already documented', 'file'(_Pb, _Pe)))).
':-'('<module>:emop.sgn@1:expand_clause_doc$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn@1:expand_clause_doc'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@1:expand_clauses'('callable'(_F, _Escaped, _Args, _Pb, _Pe), 'env'(___207, _EnumClauses, _NewClausesRef), __36CutLevel), 'emop_call'(___207, 'expand_clauses_callable'(_F, _Escaped, _Args, _Pb, _Pe, 'nodoc'), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 187, from character 12 to 35')).
':-'('<module>:emop.sgn@1:expand_clauses'('()'(_Sub__clauses, _, _), 'env'(___207, _EnumClauses, _NewClausesRef), __36CutLevel), 'emop_call'(___207, 'expand_clauses'(_Sub__clauses), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 189, from character 12 to 26')).
':-'('<module>:emop.sgn@1:expand_clauses'('module'(_, _, _, _, _, _Pb, _Pe), 'env'(___207, _EnumClauses, _NewClausesRef), __36CutLevel), 'throw'('error'('A module is not a valid clause', 'file'(_Pb, _Pe)))).
':-'('<module>:emop.sgn@1:expand_clauses'('number'(_, _Pb, _Pe), 'env'(___207, _EnumClauses, _NewClausesRef), __36CutLevel), 'throw'('error'('A number is not a valid clause', 'file'(_Pb, _Pe)))).
':-'('<module>:emop.sgn@1:expand_clauses'('empty'(_, _), 'env'(___207, _EnumClauses, _NewClausesRef), __36CutLevel), 'true').
':-'('<module>:emop.sgn@1:expand_clauses'('doc'(_Comment, _Pb, _Pe, _Clause), 'env'(___207, _EnumClauses, _NewClausesRef), __36CutLevel), 'emop_call'(___207, 'expand_clause_doc'(_Clause, 'doc'(_Comment, _Pb, _Pe)), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 196, from character 12 to 29')).
':-'('<module>:emop.sgn@1:expand_clauses$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn@1:expand_clauses'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@1:expand_clauses_callable'(':-', 'operator', '.'(_H, '.'(_B, '[]')), _Pb, _Pe, _Doc, 'env'(___207, _EnumClauses, _NewClausesRef), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','('emop_call'(___207, 'decompose_head'(_H, ___Pb, ___Pe, _F, _Escaped, _Args), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 263, from character 12 to 26'), ';'('->'(','('='(_F, '='), ','('='(_Escaped, 'operator'), '='(_Args, '.'(_A, '.'(_R, '[]'))))), ','(','('g_read'('emop.message', '<module>:emop.message'(___584)), '<module>:emop.message:warning$direct'('Goals in function declaration are deprecated', 'file'(_Pb, _Pe), ___584)), 'emop_call'(_EnumClauses, 'expand_eq_clause_deprecated'(_A, _R, _Pb, _Pe, _B, _Doc), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 270, from character 27 to 54'))), ','('emop_call'(___207, 'check_predicate_quotes'(_Escaped, _Pb, _Pe), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 272, from character 15 to 37'), ','(';'('->'('='(_Args, 'none'), '='(_Args0, '[]')), '='(_Args0, _Args)), 'emop_call'(___207, 'add_clause'(_F, _Args0, _B, _Doc, _Pb, _Pe), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 280, from character 15 to 25'))))))).
':-'('<module>:emop.sgn@1:expand_clauses_callable'(___587, 'operator', '.'(_A, '.'(_B, '[]')), _Pb, _Pe, ___Doc, 'env'(___207, _EnumClauses, _NewClausesRef), __36CutLevel), ','(','('='(___587, _F), ','('='(___587, ___588), ';'('='(___588, '$~$'), ','('='(___588, ___589), ';'('='(___589, '='), ','('='(___589, ___590), ';'('='(___590, ','), '='(___590, ':')))))))), ','(','('='(_Special, ___604), ','('g_read'('emop.sgn', '<module>:emop.sgn'(___605)), '<module>:emop.sgn:directive_syntax$direct'('callable'(_F, 'operator', '.'(_A, '.'(_B, '[]')), _Pb, _Pe), ___604, ___605))), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','('emop_call'(_NewClausesRef, 'get'(___606), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 289, from character 32 to 35'), 'emop_call'(_NewClausesRef, 'set'('.'(_Special, ___606)), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 285, from character 26 to 29')))))).
':-'('<module>:emop.sgn@1:expand_clauses_callable'('=', 'operator', '.'(_A, '.'(_R, '[]')), _Pb, _Pe, _Doc, 'env'(___207, _EnumClauses, _NewClausesRef), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), 'emop_call'(_EnumClauses, 'expand_eq_clause'(_A, _R, _Pb, _Pe, _Doc), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 294, from character 24 to 40'))).
':-'('<module>:emop.sgn@1:expand_clauses_callable'('.', 'operator', '.'(_A0, '.'(_A1, '[]')), _Pb, _Pe, _Doc, 'env'(___207, _EnumClauses, _NewClausesRef), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ';'('->'('='(_Doc, 'nodoc'), ','('emop_call'(___207, 'expand_clauses'(_A0), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 300, from character 15 to 29'), 'emop_call'(___207, 'expand_clauses'(_A1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 301, from character 15 to 29'))), 'throw'('error'('A documentation should be followed by an implementation', 'file'(_Pb, _Pe)))))).
':-'('<module>:emop.sgn@1:expand_clauses_callable'(_F, _Escaped, _Args, _Pb, _Pe, _Doc, 'env'(___207, _EnumClauses, _NewClausesRef), __36CutLevel), ','('emop_call'(___207, 'check_predicate_quotes'(_Escaped, _Pb, _Pe), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 311, from character 12 to 34'), ','(';'('->'('='(_Args, 'none'), '='(_Args0, '[]')), '='(_Args0, _Args)), 'emop_call'(___207, 'add_clause'(_F, _Args0, 'callable'('true', 'unescaped', 'none', _Pb, _Pe), _Doc, _Pb, _Pe), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 319, from character 12 to 22')))).
':-'('<module>:emop.sgn@1:expand_clauses_callable$direct'(_____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn@1:expand_clauses_callable'(_____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@1:expand_eq_clause'(_A, _R, _Pb, _Pe, _Doc, 'env'(___207, _EnumClauses, _NewClausesRef), __36CutLevel), ','(','('true', ';'('->'('var'(_Aux), ','('g_inc'('$module_count', ___628), '='(_Aux, '$module'(___628, '.'('<module>:emop.sgn@9'('env'(_Aux, _Aux, _F, _Args, ___207)), '[]'), '.'(_Aux, '[]'))))), ','('='(_Aux, '$module'(___628, ___629, _)), ','('='('.'(___630, ___631), ___629), ','('setarg'(1, ___629, '<module>:emop.sgn@9'('env'(_Aux, _Aux, _F, _Args, ___207))), 'setarg'(2, ___629, '.'(___630, ___631))))))), ','('emop_call'(_Aux, 'do'(_A), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 359, from character 16 to 18'), ','(';'('->'('='(_Args, 'none'), '='(_Args0, '.'(_R, '[]'))), ','('g_read'('data.list', '<module>:data.list'(___639)), '<module>:data.list:append$direct'(_Args, '.'(_R, '[]'), _Args0, ___639))), 'emop_call'(___207, 'add_clause'(_F, _Args0, 'callable'('true', 'unescaped', '[]', _Pb, _Pe), _Doc, _Pb, _Pe), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 367, from character 12 to 22'))))).
':-'('<module>:emop.sgn@1:expand_eq_clause$direct'(_____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn@1:expand_eq_clause'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@1:expand_eq_clause_deprecated'(_A, _R, _Pb, _Pe, _B, _Doc, 'env'(___207, _EnumClauses, _NewClausesRef), __36CutLevel), ','(','('true', ';'('->'('var'(_Aux), ','('g_inc'('$module_count', ___644), '='(_Aux, '$module'(___644, '.'('<module>:emop.sgn@10'('env'(_Aux, _Aux, _F, _Args, ___207)), '[]'), '.'(_Aux, '[]'))))), ','('='(_Aux, '$module'(___644, ___645, _)), ','('='('.'(___646, ___647), ___645), ','('setarg'(1, ___645, '<module>:emop.sgn@10'('env'(_Aux, _Aux, _F, _Args, ___207))), 'setarg'(2, ___645, '.'(___646, ___647))))))), ','('emop_call'(_Aux, 'do'(_A), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 406, from character 16 to 18'), ','(','('g_read'('emop.parser', '<module>:emop.parser'(___650)), '<module>:emop.parser:fresh_var$direct'(_V, ___650)), ','('='(_V, 'var'(_FreshVarName)), ','('='(_V0, 'callable'(_FreshVarName, 'variable', 'none', _Pb, _Pe)), ','('='(_B0, 'callable'(',', 'operator', '.'(_B, '.'('callable'('=', 'operator', '.'(_V0, '.'(_R, '[]')), _Pb, _Pe), '[]')), _Pb, _Pe)), ','(';'('->'('='(_Args, 'none'), '='(_Args0, '.'(_V0, '[]'))), ','('g_read'('data.list', '<module>:data.list'(___673)), '<module>:data.list:append$direct'(_Args, '.'(_V0, '[]'), _Args0, ___673))), 'emop_call'(___207, 'add_clause'(_F, _Args0, _B0, _Doc, _Pb, _Pe), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 418, from character 12 to 22'))))))))).
':-'('<module>:emop.sgn@1:expand_eq_clause_deprecated$direct'(_____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn@1:expand_eq_clause_deprecated'(_____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@1:expand_xml'(_Atom, _Xml, 'env'(___207, _EnumClauses, _NewClausesRef), __36CutLevel), ','('g_read'('data.atom', '<module>:data.atom'(___530)), '<module>:data.atom:subst$direct'(_Atom, '.'('=>'('<', '&lt;'), '.'('=>'('>', '&gt;'), '.'('=>'('\"', '&quot;'), '.'('=>'('\'', '&apos;'), '[]')))), _Xml, ___530))).
':-'('<module>:emop.sgn@1:expand_xml$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn@1:expand_xml'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@1:reserved'(',', 2, 'env'(___207, _EnumClauses, _NewClausesRef), __36CutLevel), 'true').
':-'('<module>:emop.sgn@1:reserved'('->', 2, 'env'(___207, _EnumClauses, _NewClausesRef), __36CutLevel), 'true').
':-'('<module>:emop.sgn@1:reserved'(';', 2, 'env'(___207, _EnumClauses, _NewClausesRef), __36CutLevel), 'true').
':-'('<module>:emop.sgn@1:reserved'(':', 2, 'env'(___207, _EnumClauses, _NewClausesRef), __36CutLevel), 'true').
':-'('<module>:emop.sgn@1:reserved'('.', 2, 'env'(___207, _EnumClauses, _NewClausesRef), __36CutLevel), 'true').
':-'('<module>:emop.sgn@1:reserved'('=', 2, 'env'(___207, _EnumClauses, _NewClausesRef), __36CutLevel), 'true').
':-'('<module>:emop.sgn@1:reserved'('', 2, 'env'(___207, _EnumClauses, _NewClausesRef), __36CutLevel), 'true').
':-'('<module>:emop.sgn@1:reserved'(',', 3, 'env'(___207, _EnumClauses, _NewClausesRef), __36CutLevel), 'true').
':-'('<module>:emop.sgn@1:reserved'('->', 3, 'env'(___207, _EnumClauses, _NewClausesRef), __36CutLevel), 'true').
':-'('<module>:emop.sgn@1:reserved'(';', 3, 'env'(___207, _EnumClauses, _NewClausesRef), __36CutLevel), 'true').
':-'('<module>:emop.sgn@1:reserved'(':', 3, 'env'(___207, _EnumClauses, _NewClausesRef), __36CutLevel), 'true').
':-'('<module>:emop.sgn@1:reserved'('.', 3, 'env'(___207, _EnumClauses, _NewClausesRef), __36CutLevel), 'true').
':-'('<module>:emop.sgn@1:reserved'('=', 3, 'env'(___207, _EnumClauses, _NewClausesRef), __36CutLevel), 'true').
':-'('<module>:emop.sgn@1:reserved'('.', 0, 'env'(___207, _EnumClauses, _NewClausesRef), __36CutLevel), 'true').
':-'('<module>:emop.sgn@1:reserved'('catch', 3, 'env'(___207, _EnumClauses, _NewClausesRef), __36CutLevel), 'true').
':-'('<module>:emop.sgn@1:reserved'('call_det', 2, 'env'(___207, _EnumClauses, _NewClausesRef), __36CutLevel), 'true').
':-'('<module>:emop.sgn@1:reserved'('true', 0, 'env'(___207, _EnumClauses, _NewClausesRef), __36CutLevel), 'true').
':-'('<module>:emop.sgn@1:reserved'('fail', 0, 'env'(___207, _EnumClauses, _NewClausesRef), __36CutLevel), 'true').
':-'('<module>:emop.sgn@1:reserved'('repeat', 0, 'env'(___207, _EnumClauses, _NewClausesRef), __36CutLevel), 'true').
':-'('<module>:emop.sgn@1:reserved'('for', 3, 'env'(___207, _EnumClauses, _NewClausesRef), __36CutLevel), 'true').
':-'('<module>:emop.sgn@1:reserved'('throw', 1, 'env'(___207, _EnumClauses, _NewClausesRef), __36CutLevel), 'true').
':-'('<module>:emop.sgn@1:reserved$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn@1:reserved'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@2'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn@2:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@2'('atomic'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn@2:atomic'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@2'('do'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn@2:do'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@2'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.sgn@2$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.sgn@2$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.sgn@2$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.sgn@2$has_predicate'('atomic'(_____2, _____1)), 'true').
':-'('<module>:emop.sgn@2$has_predicate'('do'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.sgn@2:$sgn'(__36sgn, 'env'(___217, _Pb, _Pe), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl',14958,445,14953)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl',14975,445,14953)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','('true', '<module>:emop.sgn@2:atom_fresh_[4449]'(_atom__fresh___914450_93, __36Pb, __36Pe)), '<module>:emop.sgn@2:atom_fresh_[4451]'(_atom__fresh___914452_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___914452_93, '.'(_atom__fresh___914450_93, '[]')))))))).
':-'('<module>:emop.sgn@2:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn@2:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@2:atom_fresh_[4449]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 3, predicate, '[]', __36pos))).
':-'('<module>:emop.sgn@2:atom_fresh_[4451]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(atomic, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.sgn@2:atomic'(_F, 'callable'(_F, _, 'none', _, _), 'env'(___217, _Pb, _Pe), __36CutLevel), ','('true', ','('='(__36CutLevel, '$cut'), '!'))).
':-'('<module>:emop.sgn@2:atomic'(_F, '()'(___456, _, _), 'env'(___217, _Pb, _Pe), __36CutLevel), 'emop_call'(___217, 'atomic'(_F, ___456), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 448, from character 23 to 29')).
':-'('<module>:emop.sgn@2:atomic$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn@2:atomic'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@2:do'('[]', _Sgn, _Sgn, 'env'(___217, _Pb, _Pe), __36CutLevel), ','('true', ','('='(__36CutLevel, '$cut'), '!'))).
':-'('<module>:emop.sgn@2:do'('.'(___459, '.'('callable'('/', 'unescaped', 'none', _Pb0, _Pe0), '.'('number'(_N, _, _), _Tail))), _Sgn, _NewSgn, 'env'(___217, _Pb, _Pe), __36CutLevel), ','('emop_call'(___217, 'atomic'(_F, ___459), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 451, from character 12 to 18'), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','(';'('->'('='(_Tail, '.'('callable'(',', 'unescaped', 'none', _, _), _Tail0)), 'true'), '='(_Tail0, _Tail)), 'emop_call'(___217, 'do'(_Tail0, '.'('symbol'(_F, _N, _Pb0, _Pe0), _Sgn), _NewSgn), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 460, from character 11 to 13'))))).
':-'('<module>:emop.sgn@2:do'(_S, _, _, 'env'(___217, _Pb, _Pe), __36CutLevel), ','(','('g_read'('io.err', '<module>:io.err'(___476)), '<module>:io.err:print_endline$direct'(_S, ___476)), 'throw'('error'('Invalid signature', 'file'(_Pb, _Pe))))).
':-'('<module>:emop.sgn@2:do$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn@2:do'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@3'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn@3:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@3'('do'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn@3:do'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@3'('infer_args_info'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn@3:infer_args_info'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@3'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.sgn@3$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.sgn@3$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.sgn@3$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.sgn@3$has_predicate'('do'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.sgn@3$has_predicate'('infer_args_info'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.sgn@3:$sgn'(__36sgn, 'env'(___228), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl',15753,472,15714)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl',15780,472,15714)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','('true', '<module>:emop.sgn@3:atom_fresh_[4419]'(_atom__fresh___914420_93, __36Pb, __36Pe)), '<module>:emop.sgn@3:atom_fresh_[4421]'(_atom__fresh___914422_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___914422_93, '.'(_atom__fresh___914420_93, '[]')))))))).
':-'('<module>:emop.sgn@3:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn@3:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@3:atom_fresh_[4419]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(infer_args_info, 3, predicate, '[]', __36pos))).
':-'('<module>:emop.sgn@3:atom_fresh_[4421]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 3, predicate, '[]', __36pos))).
':-'('<module>:emop.sgn@3:do'('special'(_S, _Desc, _Pb, _Pe), _Sgn, _NewSgn, 'env'(___228), __36CutLevel), ','('='(_NewSgn, ___236), ','('g_read'('emop.sgn', '<module>:emop.sgn'(___237)), '<module>:emop.sgn:directive_sgn$direct'('special'(_S, _Desc, _Pb, _Pe), _Sgn, ___236, ___237)))).
':-'('<module>:emop.sgn@3:do'('clause'(_F, _Args, _B, _, _Pb0, _Pe0), _Sgn, _NewSgn, 'env'(___228), __36CutLevel), ';'('->'(','(','('g_read'('data.list', '<module>:data.list'(___267)), '<module>:data.list:length$direct'(_Args, _N, ___267)), ';'('->'(','('g_read'('data.list', '<module>:data.list'(___270)), '<module>:data.list:member$direct'('symbol'(_F, _N, _Kind, _ArgsInfo, _), _Sgn, ___270)), ';'('->'('='(_Kind, 'predicate'), ','(';'('->'('='(_ArgsInfo, 'suspended'(_, _)), 'true'), ','(','('='(_ArgsInfo0, ___273), 'emop_call'(___228, 'infer_args_info'(_Args, _B, ___273), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 660, from character 32 to 47')), ';'('->'('='(_ArgsInfo0, 'suspended'(_, _)), 'true'), ','(','('true', ';'('->'('var'(___275), ','('g_inc'('$module_count', ___276), '='(___275, '$module'(___276, '.'('<module>:emop.sgn@7'('env'(___275, ___228)), '[]'), '.'(___275, '[]'))))), ','('='(___275, '$module'(___276, ___277, _)), ','('='('.'(___278, ___279), ___277), ','('setarg'(1, ___277, '<module>:emop.sgn@7'('env'(___275, ___228))), 'setarg'(2, ___277, '.'(___278, ___279))))))), 'emop_call'(___275, 'do'(_ArgsInfo0, _ArgsInfo), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 686, from character 25 to 27'))))), '='(_NewSgn, _Sgn))), 'throw'('error'('This symbol should not have any clause', 'file'(_Pb0, _Pe0))))), ','(','('='(_ArgsInfo, ___284), 'emop_call'(___228, 'infer_args_info'(_Args, _B, ___284), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 699, from character 25 to 40')), '='(_NewSgn, '.'('symbol'(_F, _N, 'predicate', _ArgsInfo, 'file'(_Pb0, _Pe0)), _Sgn))))), 'true'), 'throw'('error'('clause bug', 'file'(_Pb0, _Pe0))))).
':-'('<module>:emop.sgn@3:do$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn@3:do'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@3:infer_args_info'(_Args, _Body, _Args0, 'env'(___228), __36CutLevel), ','(','('true', ';'('->'('var'(_M), ','('g_inc'('$module_count', ___238), '='(_M, '$module'(___238, '.'('<module>:emop.sgn@4'('env'(_M, ___228)), '[]'), '.'(_M, '[]'))))), ','('='(_M, '$module'(___238, ___239, _)), ','('='('.'(___240, ___241), ___239), ','('setarg'(1, ___239, '<module>:emop.sgn@4'('env'(_M, ___228))), 'setarg'(2, ___239, '.'(___240, ___241))))))), ','('emop_call'(_M, 'simplify_args'(_Args, _Args_39, _List0), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 537, from character 13 to 26'), ','('emop_call'(_M, 'collect_goal'(_Body, _List1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 538, from character 13 to 25'), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','('='(_Args0, 'suspended'(_Args_39, ___244)), ','('g_read'('data.list', '<module>:data.list'(___245)), '<module>:data.list:++$direct'(_List0, _List1, ___244, ___245)))))))).
':-'('<module>:emop.sgn@3:infer_args_info'(_Args, _Body, _Args0, 'env'(___228), __36CutLevel), ','(','('='(_Env, ___248), ','('g_read'('data.record', '<module>:data.record'(___249)), '<module>:data.record:{}$direct'(___248, ___249))), ','(','(','('true', ';'('->'('var'(___250), ','('g_inc'('$module_count', ___251), '='(___250, '$module'(___251, '.'('<module>:emop.sgn@5'('env'(___250, _Args, _Args0, _Body, _Env, ___228)), '[]'), '.'(___250, '[]'))))), ','('='(___250, '$module'(___251, ___252, _)), ','('='('.'(___253, ___254), ___252), ','('setarg'(1, ___252, '<module>:emop.sgn@5'('env'(___250, _Args, _Args0, _Body, _Env, ___228))), 'setarg'(2, ___252, '.'(___253, ___254))))))), 'emop_call'(___250, 'collect_goal'(_Body), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 626, from character 13 to 25')), ','('='(_Args0, ___263), ','(','('true', ';'('->'('var'(___257), ','('g_inc'('$module_count', ___258), '='(___257, '$module'(___258, '.'('<module>:emop.sgn@6'('env'(___257, _Args, _Args0, _Body, _Env, ___228)), '[]'), '.'(___257, '[]'))))), ','('='(___257, '$module'(___258, ___259, _)), ','('='('.'(___260, ___261), ___259), ','('setarg'(1, ___259, '<module>:emop.sgn@6'('env'(___257, _Args, _Args0, _Body, _Env, ___228))), 'setarg'(2, ___259, '.'(___260, ___261))))))), ','('g_read'('data.list', '<module>:data.list'(___264)), '<module>:data.list:iter$direct'(_Args, ___257, ___263, ___264))))))).
':-'('<module>:emop.sgn@3:infer_args_info$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn@3:infer_args_info'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@4'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn@4:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@4'('collect_goal'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn@4:collect_goal'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@4'('collect_goal'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn@4:collect_goal'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@4'('collect_goal_callable'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn@4:collect_goal_callable'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@4'('simplify_args'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn@4:simplify_args'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@4'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.sgn@4$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.sgn@4$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.sgn@4$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.sgn@4$has_predicate'('collect_goal'(_____2, _____1)), 'true').
':-'('<module>:emop.sgn@4$has_predicate'('collect_goal'(_____1)), 'true').
':-'('<module>:emop.sgn@4$has_predicate'('collect_goal_callable'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.sgn@4$has_predicate'('simplify_args'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.sgn@4:$sgn'(__36sgn, 'env'(___242, ___228), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl',15958,477,15947)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl',15971,477,15947)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','(','('true', '<module>:emop.sgn@4:atom_fresh_[4441]'(_atom__fresh___914442_93, __36Pb, __36Pe)), '<module>:emop.sgn@4:atom_fresh_[4443]'(_atom__fresh___914444_93, __36Pb, __36Pe)), '<module>:emop.sgn@4:atom_fresh_[4445]'(_atom__fresh___914446_93, __36Pb, __36Pe)), '<module>:emop.sgn@4:atom_fresh_[4447]'(_atom__fresh___914448_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___914448_93, '.'(_atom__fresh___914446_93, '.'(_atom__fresh___914444_93, '.'(_atom__fresh___914442_93, '[]')))))))))).
':-'('<module>:emop.sgn@4:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn@4:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@4:atom_fresh_[4441]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(simplify_args, 3, predicate, '[]', __36pos))).
':-'('<module>:emop.sgn@4:atom_fresh_[4443]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(collect_goal_callable, 4, predicate, '[]', __36pos))).
':-'('<module>:emop.sgn@4:atom_fresh_[4445]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(collect_goal, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.sgn@4:atom_fresh_[4447]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(collect_goal, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.sgn@4:collect_goal'('()'(_B, _, _), 'env'(___242, ___228), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), 'emop_call'(___242, 'collect_goal'(_B), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 489, from character 17 to 29'))).
':-'('<module>:emop.sgn@4:collect_goal'(_, 'env'(___242, ___228), __36CutLevel), 'true').
':-'('<module>:emop.sgn@4:collect_goal'('callable'(_F, _E, _A, _, _), _List, 'env'(___242, ___228), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), 'emop_call'(___242, 'collect_goal_callable'(_F, _E, _A, _List), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 481, from character 17 to 38'))).
':-'('<module>:emop.sgn@4:collect_goal'('module'(_NameAtom, _, _, _Sgn, _, _, _), _List, 'env'(___242, ___228), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','('='(_NameAtom, 'atom'(_A, _E, _, _)), ','('\\='(_E, 'escaped'), '='(_List, '.'('module'(_A, _Sgn), '[]')))))).
':-'('<module>:emop.sgn@4:collect_goal$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn@4:collect_goal'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@4:collect_goal$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn@4:collect_goal'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@4:collect_goal_callable'(',', 'operator', '.'(_Left, '.'(_Right, '[]')), _List, 'env'(___242, ___228), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','('emop_call'(___242, 'collect_goal'(_Left, _List0), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 494, from character 17 to 29'), ','('emop_call'(___242, 'collect_goal'(_Right, _List1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 495, from character 17 to 29'), ','('='(_List, ___404), ','('g_read'('data.list', '<module>:data.list'(___405)), '<module>:data.list:++$direct'(_List0, _List1, ___404, ___405))))))).
':-'('<module>:emop.sgn@4:collect_goal_callable'(':', 'operator', '.'(_Left, '.'(_Right, '[]')), _List, 'env'(___242, ___228), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','('='(_Left, 'callable'(_LF, _LEscaped, _LArgs, _, _)), ','(';'('->'(','('g_read'('emop.parser', '<module>:emop.parser'(___413)), '<module>:emop.parser:is_variable$direct'(_LF, _LEscaped, _LArgs, ___413)), '='(_Mod, 'var'(_LF))), '->'('='(_LArgs, 'none'), '='(_Mod, 'atom'(_LF)))), ','('='(_Right, 'callable'(_RF, ___REscaped, _RArgs, _, _)), ','('emop_call'(___242, 'simplify_args'(_RArgs, _RArgs_39, _List0), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 510, from character 17 to 30'), ','('='(_List, ___422), ','('g_read'('data.list', '<module>:data.list'(___423)), '<module>:data.list:++$direct'(_List0, '.'('call'(_Mod, _RF, _RArgs_39), '[]'), ___422, ___423))))))))).
':-'('<module>:emop.sgn@4:collect_goal_callable'(_F, 'unescaped', _Args, _List, 'env'(___242, ___228), __36CutLevel), ','('emop_call'(___242, 'simplify_args'(_Args, _Args_39, _List0), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 513, from character 17 to 30'), ','('='(_List, ___430), ','('g_read'('data.list', '<module>:data.list'(___431)), '<module>:data.list:++$direct'(_List0, '.'('call'('scope', _F, _Args_39), '[]'), ___430, ___431))))).
':-'('<module>:emop.sgn@4:collect_goal_callable$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn@4:collect_goal_callable'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@4:simplify_args'('[]', '[]', '[]', 'env'(___242, ___228), __36CutLevel), 'true').
':-'('<module>:emop.sgn@4:simplify_args'('.'(_H, _T), '.'(_H_39, _T_39), _List, 'env'(___242, ___228), __36CutLevel), ','(';'('->'(','('='(_H, 'callable'(_F, _Escaped, _Args, _, _)), ','('g_read'('emop.parser', '<module>:emop.parser'(___439)), '<module>:emop.parser:is_variable$direct'(_F, _Escaped, _Args, ___439))), ','('='(_H_39, 'var'(_F)), '='(_List0, '[]'))), ';'('->'('='(_H, 'module'(_, _, _, _Sgn, _, _, _)), ','(','('='(_H, ___444), ','('g_read'('emop.parser', '<module>:emop.parser'(___445)), '<module>:emop.parser:fresh_var$direct'(___444, ___445))), ','('='(_H, 'var'(_X)), '='(_List0, '.'('module'(_X, _Sgn), '[]'))))), ','('='(_H_39, 'none'), '='(_List0, '[]')))), ','(','('g_read'('data.list', '<module>:data.list'(___453)), '<module>:data.list:append$direct'(_List0, _List1, _List, ___453)), 'emop_call'(___242, 'simplify_args'(_T, _T_39, _List1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 535, from character 17 to 30')))).
':-'('<module>:emop.sgn@4:simplify_args$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn@4:simplify_args'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@5'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn@5:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@5'('collect_goal'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn@5:collect_goal'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@5'('unify'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn@5:unify'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@5'('collect_module'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn@5:collect_module'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@5'('collect_goal_callable'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn@5:collect_goal_callable'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@5'('collect_term'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn@5:collect_term'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@5'('collect_term_list'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn@5:collect_term_list'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@5'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.sgn@5$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.sgn@5$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.sgn@5$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.sgn@5$has_predicate'('collect_goal'(_____1)), 'true').
':-'('<module>:emop.sgn@5$has_predicate'('unify'(_____2, _____1)), 'true').
':-'('<module>:emop.sgn@5$has_predicate'('collect_module'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.sgn@5$has_predicate'('collect_goal_callable'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.sgn@5$has_predicate'('collect_term'(_____1)), 'true').
':-'('<module>:emop.sgn@5$has_predicate'('collect_term_list'(_____1)), 'true').
':-'('<module>:emop.sgn@5:$sgn'(__36sgn, 'env'(___255, _Args, _Args0, _Body, _Env, ___228), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl',18517,542,18506)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl',18525,542,18506)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','(','(','(','('true', '<module>:emop.sgn@5:atom_fresh_[4427]'(_atom__fresh___914428_93, __36Pb, __36Pe)), '<module>:emop.sgn@5:atom_fresh_[4429]'(_atom__fresh___914430_93, __36Pb, __36Pe)), '<module>:emop.sgn@5:atom_fresh_[4431]'(_atom__fresh___914432_93, __36Pb, __36Pe)), '<module>:emop.sgn@5:atom_fresh_[4433]'(_atom__fresh___914434_93, __36Pb, __36Pe)), '<module>:emop.sgn@5:atom_fresh_[4435]'(_atom__fresh___914436_93, __36Pb, __36Pe)), '<module>:emop.sgn@5:atom_fresh_[4437]'(_atom__fresh___914438_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___914438_93, '.'(_atom__fresh___914436_93, '.'(_atom__fresh___914434_93, '.'(_atom__fresh___914432_93, '.'(_atom__fresh___914430_93, '.'(_atom__fresh___914428_93, '[]')))))))))))).
':-'('<module>:emop.sgn@5:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn@5:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@5:atom_fresh_[4427]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(collect_term_list, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.sgn@5:atom_fresh_[4429]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(collect_term, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.sgn@5:atom_fresh_[4431]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(collect_goal_callable, 3, predicate, '[]', __36pos))).
':-'('<module>:emop.sgn@5:atom_fresh_[4433]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(collect_module, 3, predicate, '[]', __36pos))).
':-'('<module>:emop.sgn@5:atom_fresh_[4435]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(unify, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.sgn@5:atom_fresh_[4437]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(collect_goal, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.sgn@5:collect_goal'('callable'(_F, _E, _A, _, _), 'env'(___255, _Args, _Args0, _Body, _Env, ___228), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), 'emop_call'(___255, 'collect_goal_callable'(_F, _E, _A), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 546, from character 17 to 38'))).
':-'('<module>:emop.sgn@5:collect_goal'('module'(_NameAtom, _, _, _Sgn, _, _, _), 'env'(___255, _Args, _Args0, _Body, _Env, ___228), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), 'emop_call'(___255, 'collect_module'(_NameAtom, _Sgn, _), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 549, from character 17 to 31'))).
':-'('<module>:emop.sgn@5:collect_goal'('()'(_B, _, _), 'env'(___255, _Args, _Args0, _Body, _Env, ___228), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), 'emop_call'(___255, 'collect_goal'(_B), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 552, from character 17 to 29'))).
':-'('<module>:emop.sgn@5:collect_goal'(_, 'env'(___255, _Args, _Args0, _Body, _Env, ___228), __36CutLevel), 'true').
':-'('<module>:emop.sgn@5:collect_goal$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn@5:collect_goal'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@5:collect_goal_callable'('=', 'operator', '.'('callable'(_A, _AE, 'none', _, _), '.'('callable'(_B, _BE, 'none', _, _), '[]')), 'env'(___255, _Args, _Args0, _Body, _Env, ___228), __36CutLevel), ','('\\='(_AE, 'escaped'), ','('\\='(_BE, 'escaped'), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','(','('emop_call'(_Env, '{}'(_A, ___358), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 587, from character 27 to 28'), 'emop_call'(_Env, '{}'(_B, ___359), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 587, from character 36 to 37')), 'emop_call'(___255, 'unify'(___358, ___359), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 587, from character 17 to 22')))))).
':-'('<module>:emop.sgn@5:collect_goal_callable'('=', 'operator', '.'(_Left, '.'(_Right, '[]')), 'env'(___255, _Args, _Args0, _Body, _Env, ___228), __36CutLevel), ','(';'(','('='(_Left, 'callable'(_A, _AE, 'none', _, _)), '='(_Right, 'module'(_NameAtom, _, _, _Sgn, _, _, _))), ','('='(_Left, 'module'(_NameAtom, _, _, _Sgn, _, _, _)), '='(_Right, 'callable'(_A, _AE, 'none', _, _)))), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','(','('emop_call'(_Env, '{}'(_A, ___371), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 597, from character 27 to 28'), 'emop_call'(___255, 'collect_module'(_NameAtom, _Sgn, ___372), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 597, from character 32 to 46')), 'emop_call'(___255, 'unify'(___371, ___372), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 597, from character 17 to 22'))))).
':-'('<module>:emop.sgn@5:collect_goal_callable'(',', 'operator', '.'(_Left, '.'(_Right, '[]')), 'env'(___255, _Args, _Args0, _Body, _Env, ___228), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','('emop_call'(___255, 'collect_goal'(_Left), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 600, from character 17 to 29'), 'emop_call'(___255, 'collect_goal'(_Right), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 601, from character 17 to 29')))).
':-'('<module>:emop.sgn@5:collect_goal_callable'(_, _, _A, 'env'(___255, _Args, _Args0, _Body, _Env, ___228), __36CutLevel), 'emop_call'(___255, 'collect_term_list'(_A), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 603, from character 17 to 34')).
':-'('<module>:emop.sgn@5:collect_goal_callable$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn@5:collect_goal_callable'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@5:collect_module'(_NameAtom, _Sgn, _V, 'env'(___255, _Args, _Args0, _Body, _Env, ___228), __36CutLevel), ','(','('='(_V, ___342), ','('g_read'('data.ref.backtrackable', '<module>:data.ref.backtrackable'(___343)), '<module>:data.ref.backtrackable:new$direct'('root'(_Sgn), ___342, ___343))), ';'('->'(','('='(_NameAtom, 'atom'(_A, _E, _, _)), '\\='(_E, 'escaped')), ','('emop_call'(_Env, '{}'(_A, ___346), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 579, from character 30 to 31'), 'emop_call'(___255, 'unify'(___346, _V), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 579, from character 20 to 25'))), 'true'))).
':-'('<module>:emop.sgn@5:collect_module$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn@5:collect_module'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@5:collect_term'('callable'(_, _, _A, _, _), 'env'(___255, _Args, _Args0, _Body, _Env, ___228), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), 'emop_call'(___255, 'collect_term_list'(_A), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 607, from character 17 to 34'))).
':-'('<module>:emop.sgn@5:collect_term'('module'(_NameAtom, _, _, _Sgn, _, _, _), 'env'(___255, _Args, _Args0, _Body, _Env, ___228), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), 'emop_call'(___255, 'collect_module'(_NameAtom, _Sgn, _), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 610, from character 17 to 31'))).
':-'('<module>:emop.sgn@5:collect_term'('()'(_B, _, _), 'env'(___255, _Args, _Args0, _Body, _Env, ___228), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), 'emop_call'(___255, 'collect_goal'(_B), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 613, from character 17 to 29'))).
':-'('<module>:emop.sgn@5:collect_term'(_, 'env'(___255, _Args, _Args0, _Body, _Env, ___228), __36CutLevel), 'true').
':-'('<module>:emop.sgn@5:collect_term$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn@5:collect_term'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@5:collect_term_list'(_A, 'env'(___255, _Args, _Args0, _Body, _Env, ___228), __36CutLevel), ';'('->'('='(_A, 'none'), 'true'), ','(','('true', ';'('->'('var'(___383), ','('g_inc'('$module_count', ___384), '='(___383, '$module'(___384, '.'('<module>:emop.sgn@8'('env'(___383, _Args, _Args0, _Body, _Env, _A, ___255, ___228)), '[]'), '.'(___383, '[]'))))), ','('='(___383, '$module'(___384, ___385, _)), ','('='('.'(___386, ___387), ___385), ','('setarg'(1, ___385, '<module>:emop.sgn@8'('env'(___383, _Args, _Args0, _Body, _Env, _A, ___255, ___228))), 'setarg'(2, ___385, '.'(___386, ___387))))))), ','('g_read'('data.list', '<module>:data.list'(___389)), '<module>:data.list:iter$direct'(_A, ___383, ___389))))).
':-'('<module>:emop.sgn@5:collect_term_list$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn@5:collect_term_list'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@5:unify'(_A, _B, 'env'(___255, _Args, _Args0, _Body, _Env, ___228), __36CutLevel), ';'('->'(';'(','('g_read'('data.var', '<module>:data.var'(___322)), '<module>:data.var:check$direct'(_A, ___322)), ','('g_read'('data.var', '<module>:data.var'(___324)), '<module>:data.var:check$direct'(_B, ___324))), '='(_A, _B)), ','(','('='(_AR, ___326), ','('g_read'('emop.unionfind', '<module>:emop.unionfind'(___327)), '<module>:emop.unionfind:get_root$direct'(_A, ___326, ___327))), ','(','('='(_BR, ___329), ','('g_read'('emop.unionfind', '<module>:emop.unionfind'(___330)), '<module>:emop.unionfind:get_root$direct'(_B, ___329, ___330))), ','(','('='('root'(_AS), ___332), 'emop_call'(_AR, 'get'(___332), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 567, from character 36 to 39')), ','(','('='('root'(_BS), ___334), 'emop_call'(_BR, 'get'(___334), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 568, from character 36 to 39')), ','(','(','('g_read'('data.list', '<module>:data.list'(___337)), '<module>:data.list:append$direct'(_AS, _BS, ___336, ___337)), 'emop_call'(_AR, 'set'('root'(___336)), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 569, from character 23 to 26')), 'emop_call'(_BR, 'set'('link'(_AR)), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 570, from character 23 to 26')))))))).
':-'('<module>:emop.sgn@5:unify$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn@5:unify'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@6'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn@6:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@6'('do'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn@6:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@6'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.sgn@6$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.sgn@6$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.sgn@6$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.sgn@6$has_predicate'('do'(_____2, _____1)), 'true').
':-'('<module>:emop.sgn@6:$sgn'(__36sgn, 'env'(___262, _Args, _Args0, _Body, _Env, ___228), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl',21504,626,21475)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl',21516,626,21475)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.sgn@6:atom_fresh_[4425]'(_atom__fresh___914426_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___914426_93, '[]'))))))).
':-'('<module>:emop.sgn@6:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn@6:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@6:atom_fresh_[4425]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 2, predicate, suspended([var('Arg'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.sgn@6:do'(_Arg, ___303, 'env'(___262, _Args, _Args0, _Body, _Env, ___228), __36CutLevel), ';'('->'(','('='(_Arg, 'callable'(_A, _AE, 'none', _, _)), ','('\\='(_AE, 'escaped'), ','(','('='(_E, ___308), 'emop_call'(_Env, '{}'(_A, ___308), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 632, from character 28 to 29')), ','('\\+'(','('g_read'('data.var', '<module>:data.var'(___310)), '<module>:data.var:check$direct'(_E, ___310))), ','('='('root'(_S), ___315), ','(','('g_read'('emop.unionfind', '<module>:emop.unionfind'(___314)), '<module>:emop.unionfind:get_root$direct'(_E, ___313, ___314)), 'emop_call'(___313, 'get'(___315), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 634, from character 59 to 62'))))))), '='(___303, _S)), ','('='(___303, ___304), ';'('->'('='(_Arg, 'module'(_, _, _, _S, _, _, _)), '='(___304, _S)), '='(___304, 'none'))))).
':-'('<module>:emop.sgn@6:do$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn@6:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@7'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn@7:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@7'('do'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn@7:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@7'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.sgn@7$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.sgn@7$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.sgn@7$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.sgn@7$has_predicate'('do'(_____2, _____1)), 'true').
':-'('<module>:emop.sgn@7:$sgn'(__36sgn, 'env'(___280, ___228), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl',22665,665,22642)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl',22676,665,22642)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.sgn@7:atom_fresh_[4423]'(_atom__fresh___914424_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___914424_93, '[]'))))))).
':-'('<module>:emop.sgn@7:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn@7:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@7:atom_fresh_[4423]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.sgn@7:do'('[]', '[]', 'env'(___280, ___228), __36CutLevel), 'true').
':-'('<module>:emop.sgn@7:do'('.'(_H0, _T0), _ArgsInfo, 'env'(___280, ___228), __36CutLevel), ','('='(_ArgsInfo, '.'(_H, _T)), ','(';'('->'('='(_H0, 'none'), 'true'), ','(';'('->'('='(_H, 'none'), '='(_NewH, _H0)), ','('='(_NewH, ___299), ','('g_read'('data.list', '<module>:data.list'(___300)), '<module>:data.list:append$direct'(_H0, _H, ___299, ___300)))), ','(','('g_read'('data.term', '<module>:data.term'(___302)), '<module>:data.term:setarg1$direct'(1, _ArgsInfo, _NewH, ___302)), 'emop_call'(___280, 'do'(_T0, _T), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 683, from character 32 to 34')))), 'emop_call'(___280, 'do'(_T0, _T), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 685, from character 29 to 31')))).
':-'('<module>:emop.sgn@7:do$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn@7:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@8'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn@8:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@8'('do'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn@8:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@8'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.sgn@8$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.sgn@8$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.sgn@8$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.sgn@8$has_predicate'('do'(_____1)), 'true').
':-'('<module>:emop.sgn@8:$sgn'(__36sgn, 'env'(___388, _Args, _Args0, _Body, _Env, _A, ___255, ___228), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl',21327,621,21297)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl',21336,621,21297)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.sgn@8:atom_fresh_[4439]'(_atom__fresh___914440_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___914440_93, '[]'))))))).
':-'('<module>:emop.sgn@8:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn@8:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@8:atom_fresh_[4439]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 1, predicate, suspended([var('X')],[call(scope,collect_term,[var('X')])]), __36pos))).
':-'('<module>:emop.sgn@8:do'(_X, 'env'(___388, _Args, _Args0, _Body, _Env, _A, ___255, ___228), __36CutLevel), 'emop_call'(___255, 'collect_term'(_X), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 623, from character 32 to 44')).
':-'('<module>:emop.sgn@8:do$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn@8:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@9'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn@9:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@9'('do'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.sgn@9:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@9'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.sgn@9$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.sgn@9$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.sgn@9$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.sgn@9$has_predicate'('do'(_____1)), 'true').
':-'('<module>:emop.sgn@9:$sgn'(__36sgn, 'env'(___632, _Aux, _F, _Args, ___207), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl',10379,321,10367)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl',10406,321,10367)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.sgn@9:atom_fresh_[4475]'(_atom__fresh___914476_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___914476_93, '[]'))))))).
':-'('<module>:emop.sgn@9:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn@9:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.sgn@9:atom_fresh_[4475]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 1, predicate, suspended([none],[call(scope,check_predicate_quotes,[var('Escaped'),var('Pb'),var('Pe')])]), __36pos))).
':-'('<module>:emop.sgn@9:do'('callable'(_F, _Escaped, _Args, _Pb, _Pe), 'env'(___632, _Aux, _F, _Args, ___207), __36CutLevel), 'emop_call'(___207, 'check_predicate_quotes'(_Escaped, _Pb, _Pe), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 324, from character 18 to 40')).
':-'('<module>:emop.sgn@9:do'('()'(_Sub__clauses, _, _), 'env'(___632, _Aux, _F, _Args, ___207), __36CutLevel), 'emop_call'(_Aux, 'do'(_Sub__clauses), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/sgn.mpl\", line 326, from character 22 to 24')).
':-'('<module>:emop.sgn@9:do'('callable'(':', 'operator', '.'(_, '.'(_, '[]')), _Pb, _Pe), 'env'(___632, _Aux, _F, _Args, ___207), __36CutLevel), 'throw'('error'('Predicate definition cannot be prefixed', 'file'(_Pb, _Pe)))).
':-'('<module>:emop.sgn@9:do'('module'(_, _, _, _, _, _Pb, _Pe), 'env'(___632, _Aux, _F, _Args, ___207), __36CutLevel), 'throw'('error'('A module is not a valid predicate', 'file'(_Pb, _Pe)))).
':-'('<module>:emop.sgn@9:do'('number'(_, _Pb, _Pe), 'env'(___632, _Aux, _F, _Args, ___207), __36CutLevel), 'throw'('error'('A number is not a valid predicate', 'file'(_Pb, _Pe)))).
':-'('<module>:emop.sgn@9:do'('empty'(_Pb, _Pe), 'env'(___632, _Aux, _F, _Args, ___207), __36CutLevel), 'throw'('error'('An empty item is not a valid predicate', 'file'(_Pb, _Pe)))).
':-'('<module>:emop.sgn@9:do'('doc'(_, _Pb, _Pe, _), 'env'(___632, _Aux, _F, _Args, ___207), __36CutLevel), 'throw'('error'('Documentation not allowed here', 'file'(_Pb, _Pe)))).
':-'('<module>:emop.sgn@9:do$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.sgn@9:do'(_____1, __36env, __36CutLevel))).
':-'('emop.sgn@init', ','(','('true', 'g_link'('emop.sgn', '<module>:emop.sgn'('env'(_SignatureCacheRef, _ConsultSignatureRef, _SignatureResultRef)))), ','(','('='(_SignatureCacheRef, ___6), ','('g_read'('data.ref.non_backtrackable', '<module>:data.ref.non_backtrackable'(___7)), '<module>:data.ref.non_backtrackable:new$direct'('[]', ___6, ___7))), ','('='(_ConsultSignatureRef, ___10), ','('g_read'('data.ref.backtrackable', '<module>:data.ref.backtrackable'(___11)), '<module>:data.ref.backtrackable:new$direct'('[]', ___10, ___11)))))).
':-'('dynamic'('/'('<module>:emop.syntax$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.syntax@7$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.syntax@6$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.syntax@5$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.syntax@4$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.syntax@3$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.syntax@2$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.syntax@1$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.syntax@0$dynamic', 4))).
':-'('<module>:emop.syntax'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.syntax:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.syntax'('syntax'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.syntax:syntax'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.syntax'('logic'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.syntax:logic'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.syntax'('comparisons'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.syntax:comparisons'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.syntax'('arithmetic'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.syntax:arithmetic'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.syntax'('level'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.syntax:level'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.syntax'('functional_logic'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.syntax:functional_logic'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.syntax'('pipe_match'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.syntax:pipe_match'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.syntax'('implicit_do'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.syntax:implicit_do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.syntax'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.syntax$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.syntax$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.syntax$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.syntax$has_predicate'('syntax'(_____1)), 'true').
':-'('<module>:emop.syntax$has_predicate'('logic'(_____1)), 'true').
':-'('<module>:emop.syntax$has_predicate'('comparisons'(_____1)), 'true').
':-'('<module>:emop.syntax$has_predicate'('arithmetic'(_____1)), 'true').
':-'('<module>:emop.syntax$has_predicate'('level'(_____1)), 'true').
':-'('<module>:emop.syntax$has_predicate'('functional_logic'(_____1)), 'true').
':-'('<module>:emop.syntax$has_predicate'('pipe_match'(_____1)), 'true').
':-'('<module>:emop.syntax$has_predicate'('implicit_do'(_____1)), 'true').
':-'('<module>:emop.syntax:$sgn'(__36sgn, 'env', __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',0,0,0)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',20,0,0)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','(','(','(','(','(','('true', '<module>:emop.syntax:atom_fresh_[654]'(_atom__fresh___91655_93, __36Pb, __36Pe)), '<module>:emop.syntax:atom_fresh_[656]'(_atom__fresh___91657_93, __36Pb, __36Pe)), '<module>:emop.syntax:atom_fresh_[658]'(_atom__fresh___91659_93, __36Pb, __36Pe)), '<module>:emop.syntax:atom_fresh_[660]'(_atom__fresh___91661_93, __36Pb, __36Pe)), '<module>:emop.syntax:atom_fresh_[662]'(_atom__fresh___91663_93, __36Pb, __36Pe)), '<module>:emop.syntax:atom_fresh_[664]'(_atom__fresh___91665_93, __36Pb, __36Pe)), '<module>:emop.syntax:atom_fresh_[666]'(_atom__fresh___91667_93, __36Pb, __36Pe)), '<module>:emop.syntax:atom_fresh_[668]'(_atom__fresh___91669_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___91669_93, '.'(_atom__fresh___91667_93, '.'(_atom__fresh___91665_93, '.'(_atom__fresh___91663_93, '.'(_atom__fresh___91661_93, '.'(_atom__fresh___91659_93, '.'(_atom__fresh___91657_93, '.'(_atom__fresh___91655_93, '[]')))))))))))))).
':-'('<module>:emop.syntax:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.syntax:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.syntax:arithmetic'(___28, 'env', __36CutLevel), ','('true', ';'('->'('var'(___28), ','('g_inc'('$module_count', ___29), '='(___28, '$module'(___29, '.'('<module>:emop.syntax@3'('env'(___28)), '[]'), '.'(___28, '[]'))))), ','('='(___28, '$module'(___29, ___30, _)), ','('='('.'(___31, ___32), ___30), ','('setarg'(1, ___30, '<module>:emop.syntax@3'('env'(___28))), 'setarg'(2, ___30, '.'(___31, ___32)))))))).
':-'('<module>:emop.syntax:arithmetic$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.syntax:arithmetic'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.syntax:atom_fresh_[654]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(implicit_do, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.syntax:atom_fresh_[656]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(pipe_match, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.syntax:atom_fresh_[658]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(functional_logic, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.syntax:atom_fresh_[660]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(level, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.syntax:atom_fresh_[662]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(arithmetic, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.syntax:atom_fresh_[664]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(comparisons, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.syntax:atom_fresh_[666]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(logic, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.syntax:atom_fresh_[668]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(syntax, 1, predicate, suspended([var('X')],[call(scope,logic,[var('X')]),call(scope,comparisons,[var('X')]),call(scope,arithmetic,[var('X')]),module('X',[syntax([callable(\+,escaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',130,6,113),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',135,6,113)),callable(<,unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',136,6,113),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',137,6,113)),callable(=,escaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',138,6,113),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',141,6,113)),callable(<,unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',142,6,113),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',143,6,113)),callable(infix,unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',144,6,113),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',149,6,113)),callable(+,escaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',150,6,113),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',153,6,113))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',135,6,113),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',154,6,113)),syntax([callable(prefix,unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',172,7,155),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',178,7,155)),callable(+,escaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',179,7,155),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',182,7,155)),callable(<,unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',183,7,155),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',184,7,155)),callable(:,escaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',185,7,155),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',188,7,155))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',178,7,155),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',189,7,155))]),call(scope,level,[var('X')]),call(scope,functional_logic,[var('X')]),call(scope,pipe_match,[var('X')]),call(scope,implicit_do,[var('X')])]), __36pos))).
':-'('<module>:emop.syntax:comparisons'(___22, 'env', __36CutLevel), ','('true', ';'('->'('var'(___22), ','('g_inc'('$module_count', ___23), '='(___22, '$module'(___23, '.'('<module>:emop.syntax@2'('env'(___22)), '[]'), '.'(___22, '[]'))))), ','('='(___22, '$module'(___23, ___24, _)), ','('='('.'(___25, ___26), ___24), ','('setarg'(1, ___24, '<module>:emop.syntax@2'('env'(___22))), 'setarg'(2, ___24, '.'(___25, ___26)))))))).
':-'('<module>:emop.syntax:comparisons$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.syntax:comparisons'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.syntax:functional_logic'(___40, 'env', __36CutLevel), ','('true', ';'('->'('var'(___40), ','('g_inc'('$module_count', ___41), '='(___40, '$module'(___41, '.'('<module>:emop.syntax@5'('env'(___40)), '[]'), '.'(___40, '[]'))))), ','('='(___40, '$module'(___41, ___42, _)), ','('='('.'(___43, ___44), ___42), ','('setarg'(1, ___42, '<module>:emop.syntax@5'('env'(___40))), 'setarg'(2, ___42, '.'(___43, ___44)))))))).
':-'('<module>:emop.syntax:functional_logic$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.syntax:functional_logic'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.syntax:implicit_do'(___52, 'env', __36CutLevel), ','('true', ';'('->'('var'(___52), ','('g_inc'('$module_count', ___53), '='(___52, '$module'(___53, '.'('<module>:emop.syntax@7'('env'(___52)), '[]'), '.'(___52, '[]'))))), ','('='(___52, '$module'(___53, ___54, _)), ','('='('.'(___55, ___56), ___54), ','('setarg'(1, ___54, '<module>:emop.syntax@7'('env'(___52))), 'setarg'(2, ___54, '.'(___55, ___56)))))))).
':-'('<module>:emop.syntax:implicit_do$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.syntax:implicit_do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.syntax:level'(___34, 'env', __36CutLevel), ','('true', ';'('->'('var'(___34), ','('g_inc'('$module_count', ___35), '='(___34, '$module'(___35, '.'('<module>:emop.syntax@4'('env'(___34)), '[]'), '.'(___34, '[]'))))), ','('='(___34, '$module'(___35, ___36, _)), ','('='('.'(___37, ___38), ___36), ','('setarg'(1, ___36, '<module>:emop.syntax@4'('env'(___34))), 'setarg'(2, ___36, '.'(___37, ___38)))))))).
':-'('<module>:emop.syntax:level$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.syntax:level'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.syntax:logic'(___16, 'env', __36CutLevel), ','('true', ';'('->'('var'(___16), ','('g_inc'('$module_count', ___17), '='(___16, '$module'(___17, '.'('<module>:emop.syntax@1'('env'(___16)), '[]'), '.'(___16, '[]'))))), ','('='(___16, '$module'(___17, ___18, _)), ','('='('.'(___19, ___20), ___18), ','('setarg'(1, ___18, '<module>:emop.syntax@1'('env'(___16))), 'setarg'(2, ___18, '.'(___19, ___20)))))))).
':-'('<module>:emop.syntax:logic$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.syntax:logic'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.syntax:pipe_match'(___46, 'env', __36CutLevel), ','('true', ';'('->'('var'(___46), ','('g_inc'('$module_count', ___47), '='(___46, '$module'(___47, '.'('<module>:emop.syntax@6'('env'(___46)), '[]'), '.'(___46, '[]'))))), ','('='(___46, '$module'(___47, ___48, _)), ','('='('.'(___49, ___50), ___48), ','('setarg'(1, ___48, '<module>:emop.syntax@6'('env'(___46))), 'setarg'(2, ___48, '.'(___49, ___50)))))))).
':-'('<module>:emop.syntax:pipe_match$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.syntax:pipe_match'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.syntax:syntax'(_X, 'env', __36CutLevel), ','(','('g_read'('emop.syntax', '<module>:emop.syntax'(___4)), '<module>:emop.syntax:logic$direct'(_X, ___4)), ','(','('g_read'('emop.syntax', '<module>:emop.syntax'(___5)), '<module>:emop.syntax:comparisons$direct'(_X, ___5)), ','(','('g_read'('emop.syntax', '<module>:emop.syntax'(___6)), '<module>:emop.syntax:arithmetic$direct'(_X, ___6)), ','(','('true', ';'('->'('var'(_X), ','('g_inc'('$module_count', ___7), '='(_X, '$module'(___7, '.'('<module>:emop.syntax@0'('env'(_X, _X)), '[]'), '.'(_X, '[]'))))), ','('='(_X, '$module'(___7, ___8, _)), ','('='('.'(___9, ___10), ___8), ','('setarg'(1, ___8, '<module>:emop.syntax@0'('env'(_X, _X))), 'setarg'(2, ___8, '.'(___9, ___10))))))), ','(','('g_read'('emop.syntax', '<module>:emop.syntax'(___12)), '<module>:emop.syntax:level$direct'(_X, ___12)), ','(','('g_read'('emop.syntax', '<module>:emop.syntax'(___13)), '<module>:emop.syntax:functional_logic$direct'(_X, ___13)), ','(','('g_read'('emop.syntax', '<module>:emop.syntax'(___14)), '<module>:emop.syntax:pipe_match$direct'(_X, ___14)), ','('g_read'('emop.syntax', '<module>:emop.syntax'(___15)), '<module>:emop.syntax:implicit_do$direct'(_X, ___15)))))))))).
':-'('<module>:emop.syntax:syntax$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.syntax:syntax'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.syntax@0'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.syntax@0:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.syntax@0'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.syntax@0$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.syntax@0$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.syntax@0$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.syntax@0:$sgn'(__36sgn, 'env'(___11, _X), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',102,5,96)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',112,5,96)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','('true', '<module>:emop.syntax@0:atom_fresh_[1067]'(_atom__fresh___911068_93, __36Pb, __36Pe)), '<module>:emop.syntax@0:atom_fresh_[1069]'(_atom__fresh___911070_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___911070_93, '.'(_atom__fresh___911068_93, '[]')))))))).
':-'('<module>:emop.syntax@0:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.syntax@0:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.syntax@0:atom_fresh_[1067]'(__36s, __36Pb, __36Pe), '='(__36s, 'syntax'('.'('callable'('prefix', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('+', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('<', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'(':', 'escaped', 'none', __36Pb, __36Pe), '[]')))), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@0:atom_fresh_[1069]'(__36s, __36Pb, __36Pe), '='(__36s, 'syntax'('.'('callable'('\\+', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('<', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('=', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('<', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('infix', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('+', 'escaped', 'none', __36Pb, __36Pe), '[]')))))), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@1'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.syntax@1:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.syntax@1'('top'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.syntax@1:top'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.syntax@1'('[]'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.syntax@1:[]'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.syntax@1'(','(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.syntax@1:,'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.syntax@1'('.'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.syntax@1:.'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.syntax@1'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.syntax@1$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.syntax@1$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.syntax@1$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.syntax@1$has_predicate'('top'(_____1)), 'true').
':-'('<module>:emop.syntax@1$has_predicate'('[]'(_____1)), 'true').
':-'('<module>:emop.syntax@1$has_predicate'(','(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.syntax@1$has_predicate'('.'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.syntax@1:$sgn'(__36sgn, 'env'(___21), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',297,14,286)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',305,14,286)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','(','(','(','(','(','(','(','('true', '<module>:emop.syntax@1:atom_fresh_[1033]'(_atom__fresh___911034_93, __36Pb, __36Pe)), '<module>:emop.syntax@1:atom_fresh_[1035]'(_atom__fresh___911036_93, __36Pb, __36Pe)), '<module>:emop.syntax@1:atom_fresh_[1037]'(_atom__fresh___911038_93, __36Pb, __36Pe)), '<module>:emop.syntax@1:atom_fresh_[1039]'(_atom__fresh___911040_93, __36Pb, __36Pe)), '<module>:emop.syntax@1:atom_fresh_[1041]'(_atom__fresh___911042_93, __36Pb, __36Pe)), '<module>:emop.syntax@1:atom_fresh_[1043]'(_atom__fresh___911044_93, __36Pb, __36Pe)), '<module>:emop.syntax@1:atom_fresh_[1045]'(_atom__fresh___911046_93, __36Pb, __36Pe)), '<module>:emop.syntax@1:atom_fresh_[1047]'(_atom__fresh___911048_93, __36Pb, __36Pe)), '<module>:emop.syntax@1:atom_fresh_[1049]'(_atom__fresh___911050_93, __36Pb, __36Pe)), '<module>:emop.syntax@1:atom_fresh_[1051]'(_atom__fresh___911052_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___911052_93, '.'(_atom__fresh___911050_93, '.'(_atom__fresh___911048_93, '.'(_atom__fresh___911046_93, '.'(_atom__fresh___911044_93, '.'(_atom__fresh___911042_93, '.'(_atom__fresh___911040_93, '.'(_atom__fresh___911038_93, '.'(_atom__fresh___911036_93, '.'(_atom__fresh___911034_93, '[]')))))))))))))))).
':-'('<module>:emop.syntax@1:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.syntax@1:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.syntax@1:,'(___60, ___61, ___62, 'env'(___21), __36CutLevel), '=..'(___62, '.'(',', '.'(___60, '.'(___61, '[]'))))).
':-'('<module>:emop.syntax@1:,$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.syntax@1:,'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.syntax@1:.'(___63, ___64, ___65, 'env'(___21), __36CutLevel), '=..'(___65, '.'('.', '.'(___63, '.'(___64, '[]'))))).
':-'('<module>:emop.syntax@1:.$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.syntax@1:.'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.syntax@1:[]'(___59, 'env'(___21), __36CutLevel), '=..'(___59, '.'('[]', '[]'))).
':-'('<module>:emop.syntax@1:[]$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.syntax@1:[]'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.syntax@1:atom_fresh_[1033]'(__36s, __36Pb, __36Pe), '='(__36s, 'syntax'('.'('callable'('.', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('<', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'(':-', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('<', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'(';', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('<', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('->', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('<', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'(',', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('<', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('\\+', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('<', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('>>', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('<', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'(':', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('=', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('.()', 'escaped', 'none', __36Pb, __36Pe), '[]'))))))))))))))))), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@1:atom_fresh_[1035]'(__36s, __36Pb, __36Pe), '='(__36s, 'syntax'('.'('callable'('postfix', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('.()', 'escaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@1:atom_fresh_[1037]'(__36s, __36Pb, __36Pe), '='(__36s, 'syntax'('.'('callable'('infix', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('left', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('associative', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'(':', 'escaped', 'none', __36Pb, __36Pe), '[]')))), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@1:atom_fresh_[1039]'(__36s, __36Pb, __36Pe), '='(__36s, 'syntax'('.'('callable'('prefix', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('\\+', 'escaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@1:atom_fresh_[1041]'(__36s, __36Pb, __36Pe), '='(__36s, 'syntax'('.'('callable'('infix', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'(':-', 'escaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@1:atom_fresh_[1043]'(__36s, __36Pb, __36Pe), '='(__36s, 'syntax'('.'('callable'('infix', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('right', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('associative', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('.', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'(';', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('->', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'(',', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('>>', 'escaped', 'none', __36Pb, __36Pe), '[]')))))))), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@1:atom_fresh_[1045]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'('.', 3, constructor, none, __36pos))).
':-'('<module>:emop.syntax@1:atom_fresh_[1047]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(',', 3, constructor, none, __36pos))).
':-'('<module>:emop.syntax@1:atom_fresh_[1049]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'([], 1, constructor, none, __36pos))).
':-'('<module>:emop.syntax@1:atom_fresh_[1051]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(top, 1, constructor, none, __36pos))).
':-'('<module>:emop.syntax@1:top'(___58, 'env'(___21), __36CutLevel), '=..'(___58, '.'('top', '[]'))).
':-'('<module>:emop.syntax@1:top$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.syntax@1:top'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.syntax@2'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.syntax@2:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.syntax@2'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.syntax@2$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.syntax@2$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.syntax@2$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.syntax@2:$sgn'(__36sgn, 'env'(___27), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',640,26,623)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',648,26,623)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','('true', '<module>:emop.syntax@2:atom_fresh_[1019]'(_atom__fresh___911020_93, __36Pb, __36Pe)), '<module>:emop.syntax@2:atom_fresh_[1021]'(_atom__fresh___911022_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___911022_93, '.'(_atom__fresh___911020_93, '[]')))))))).
':-'('<module>:emop.syntax@2:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.syntax@2:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.syntax@2:atom_fresh_[1019]'(__36s, __36Pb, __36Pe), '='(__36s, 'syntax'('.'('callable'('=', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('=', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('<', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('=', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('>', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('=', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('=<', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('=', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('>=', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('=', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('\\=', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('=', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('==', 'escaped', 'none', __36Pb, __36Pe), '[]'))))))))))))), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@2:atom_fresh_[1021]'(__36s, __36Pb, __36Pe), '='(__36s, 'syntax'('.'('callable'('infix', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('left', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('associative', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('=', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('<', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('>', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('=<', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('>=', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('\\=', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('==', 'escaped', 'none', __36Pb, __36Pe), '[]')))))))))), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@3'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.syntax@3:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.syntax@3'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.syntax@3$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.syntax@3$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.syntax@3$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.syntax@3:$sgn'(__36sgn, 'env'(___33), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',804,32,788)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',812,32,788)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','(','(','('true', '<module>:emop.syntax@3:atom_fresh_[996]'(_atom__fresh___91997_93, __36Pb, __36Pe)), '<module>:emop.syntax@3:atom_fresh_[998]'(_atom__fresh___91999_93, __36Pb, __36Pe)), '<module>:emop.syntax@3:atom_fresh_[1000]'(_atom__fresh___911001_93, __36Pb, __36Pe)), '<module>:emop.syntax@3:atom_fresh_[1002]'(_atom__fresh___911003_93, __36Pb, __36Pe)), '<module>:emop.syntax@3:atom_fresh_[1004]'(_atom__fresh___911005_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___911005_93, '.'(_atom__fresh___911003_93, '.'(_atom__fresh___911001_93, '.'(_atom__fresh___91999_93, '.'(_atom__fresh___91997_93, '[]'))))))))))).
':-'('<module>:emop.syntax@3:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.syntax@3:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.syntax@3:atom_fresh_[1000]'(__36s, __36Pb, __36Pe), '='(__36s, 'syntax'('.'('callable'('prefix', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('+', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('-', 'escaped', 'none', __36Pb, __36Pe), '[]'))), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@3:atom_fresh_[1002]'(__36s, __36Pb, __36Pe), '='(__36s, 'syntax'('.'('callable'('infix', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('right', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('associative', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('**', 'escaped', 'none', __36Pb, __36Pe), '[]')))), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@3:atom_fresh_[1004]'(__36s, __36Pb, __36Pe), '='(__36s, 'syntax'('.'('callable'('infix', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('left', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('associative', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('+', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('-', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('*', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('/', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('mod', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('quo', 'escaped', 'none', __36Pb, __36Pe), '[]'))))))))), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@3:atom_fresh_[996]'(__36s, __36Pb, __36Pe), '='(__36s, 'syntax'('.'('callable'('*', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('<', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('**', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('<', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('prefix', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('+', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('=', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('prefix', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('-', 'escaped', 'none', __36Pb, __36Pe), '[]'))))))))), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@3:atom_fresh_[998]'(__36s, __36Pb, __36Pe), '='(__36s, 'syntax'('.'('callable'('infix', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('+', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('=', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('infix', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('-', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('<', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('*', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('=', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('/', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('=', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('mod', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('=', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('quo', 'escaped', 'none', __36Pb, __36Pe), '[]'))))))))))))), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@4'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.syntax@4:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.syntax@4'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.syntax@4$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.syntax@4$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.syntax@4$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.syntax@4:$sgn'(__36sgn, 'env'(___39), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',1089,41,1078)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',1097,41,1078)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','(','(','(','(','(','(','(','(','('true', '<module>:emop.syntax@4:atom_fresh_[933]'(_atom__fresh___91934_93, __36Pb, __36Pe)), '<module>:emop.syntax@4:atom_fresh_[935]'(_atom__fresh___91936_93, __36Pb, __36Pe)), '<module>:emop.syntax@4:atom_fresh_[937]'(_atom__fresh___91938_93, __36Pb, __36Pe)), '<module>:emop.syntax@4:atom_fresh_[939]'(_atom__fresh___91940_93, __36Pb, __36Pe)), '<module>:emop.syntax@4:atom_fresh_[941]'(_atom__fresh___91942_93, __36Pb, __36Pe)), '<module>:emop.syntax@4:atom_fresh_[943]'(_atom__fresh___91944_93, __36Pb, __36Pe)), '<module>:emop.syntax@4:atom_fresh_[945]'(_atom__fresh___91946_93, __36Pb, __36Pe)), '<module>:emop.syntax@4:atom_fresh_[947]'(_atom__fresh___91948_93, __36Pb, __36Pe)), '<module>:emop.syntax@4:atom_fresh_[949]'(_atom__fresh___91950_93, __36Pb, __36Pe)), '<module>:emop.syntax@4:atom_fresh_[951]'(_atom__fresh___91952_93, __36Pb, __36Pe)), '<module>:emop.syntax@4:atom_fresh_[953]'(_atom__fresh___91954_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___91954_93, '.'(_atom__fresh___91952_93, '.'(_atom__fresh___91950_93, '.'(_atom__fresh___91948_93, '.'(_atom__fresh___91946_93, '.'(_atom__fresh___91944_93, '.'(_atom__fresh___91942_93, '.'(_atom__fresh___91940_93, '.'(_atom__fresh___91938_93, '.'(_atom__fresh___91936_93, '.'(_atom__fresh___91934_93, '[]'))))))))))))))))).
':-'('<module>:emop.syntax@4:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.syntax@4:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.syntax@4:atom_fresh_[933]'(__36s, __36Pb, __36Pe), '='(__36s, 'level'('.'('()'('callable'('$~$', 'operator', '.'('callable'('goal', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'(',', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('term', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('p', 'unescaped', '.'('callable'('$~$', 'operator', '.'('callable'('term', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('*', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]'), __36Pb, __36Pe), '[]')), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@4:atom_fresh_[935]'(__36s, __36Pb, __36Pe), '='(__36s, 'level'('.'('()'('callable'('term', 'unescaped', 'none', __36Pb, __36Pe), __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('goal', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('>>', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('term', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '[]')), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@4:atom_fresh_[937]'(__36s, __36Pb, __36Pe), '='(__36s, 'level'('.'('()'('callable'('term', 'unescaped', 'none', __36Pb, __36Pe), __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('goal', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('->', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('term', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '[]')), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@4:atom_fresh_[939]'(__36s, __36Pb, __36Pe), '='(__36s, 'level'('.'('()'('callable'('goal', 'unescaped', 'none', __36Pb, __36Pe), __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('\\+', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('goal', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '[]')), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@4:atom_fresh_[941]'(__36s, __36Pb, __36Pe), '='(__36s, 'level'('.'('()'('callable'('goal', 'unescaped', 'none', __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('call_det', 'escaped', '.'('callable'('goal', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('term', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@4:atom_fresh_[943]'(__36s, __36Pb, __36Pe), '='(__36s, 'level'('.'('()'('callable'('goal', 'unescaped', 'none', __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('catch', 'escaped', '.'('callable'('goal', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('term', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('goal', 'unescaped', 'none', __36Pb, __36Pe), '[]'))), __36Pb, __36Pe), '[]')), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@4:atom_fresh_[945]'(__36s, __36Pb, __36Pe), '='(__36s, 'level'('.'('()'('callable'('goal', 'unescaped', 'none', __36Pb, __36Pe), __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('term', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'(':', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('goal', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '[]')), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@4:atom_fresh_[947]'(__36s, __36Pb, __36Pe), '='(__36s, 'level'('.'('()'('callable'('goal', 'unescaped', 'none', __36Pb, __36Pe), __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('goal', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('>>', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('goal', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '[]')), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@4:atom_fresh_[949]'(__36s, __36Pb, __36Pe), '='(__36s, 'level'('.'('()'('callable'('goal', 'unescaped', 'none', __36Pb, __36Pe), __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('goal', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('->', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('goal', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '[]')), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@4:atom_fresh_[951]'(__36s, __36Pb, __36Pe), '='(__36s, 'level'('.'('()'('callable'('goal', 'unescaped', 'none', __36Pb, __36Pe), __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('goal', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'(';', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('goal', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '[]')), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@4:atom_fresh_[953]'(__36s, __36Pb, __36Pe), '='(__36s, 'level'('.'('()'('callable'('goal', 'unescaped', 'none', __36Pb, __36Pe), __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('goal', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'(',', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('goal', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '[]')), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@5'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.syntax@5:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.syntax@5'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.syntax@5$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.syntax@5$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.syntax@5$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.syntax@5:$sgn'(__36sgn, 'env'(___45), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',1532,57,1510)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',1540,57,1510)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','(','('true', '<module>:emop.syntax@5:atom_fresh_[883]'(_atom__fresh___91884_93, __36Pb, __36Pe)), '<module>:emop.syntax@5:atom_fresh_[885]'(_atom__fresh___91886_93, __36Pb, __36Pe)), '<module>:emop.syntax@5:atom_fresh_[887]'(_atom__fresh___91888_93, __36Pb, __36Pe)), '<module>:emop.syntax@5:atom_fresh_[889]'(_atom__fresh___91890_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___91890_93, '.'(_atom__fresh___91888_93, '.'(_atom__fresh___91886_93, '.'(_atom__fresh___91884_93, '[]')))))))))).
':-'('<module>:emop.syntax@5:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.syntax@5:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.syntax@5:atom_fresh_[883]'(__36s, __36Pb, __36Pe), '='(__36s, 'notation'('.'('()'('callable'('term', 'unescaped', 'none', __36Pb, __36Pe), __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('=', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('B', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('->', 'unescaped', 'none', __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('=', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'(',', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('=', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('B', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('>>', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '[]')))))), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@5:atom_fresh_[885]'(__36s, __36Pb, __36Pe), '='(__36s, 'notation'('.'('()'('callable'('term', 'unescaped', 'none', __36Pb, __36Pe), __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('P', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'(';', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('Q', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('->', 'unescaped', 'none', __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('=', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('P', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'(';', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('=', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('Q', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('>>', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '[]')))))), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@5:atom_fresh_[887]'(__36s, __36Pb, __36Pe), '='(__36s, 'notation'('.'('()'('callable'('term', 'unescaped', 'none', __36Pb, __36Pe), __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('P', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('->', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('Q', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'(';', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('R', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('->', 'unescaped', 'none', __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('P', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('->', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('=', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('Q', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'(';', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('=', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('R', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('>>', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '[]')))))), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@5:atom_fresh_[889]'(__36s, __36Pb, __36Pe), '='(__36s, 'notation'('.'('()'('callable'('term', 'unescaped', 'none', __36Pb, __36Pe), __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('P', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('->', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('Q', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('->', 'unescaped', 'none', __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('P', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('->', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('true', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('>>', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('Q', 'unescaped', 'none', __36Pb, __36Pe), '[]')))))), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@6'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.syntax@6:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.syntax@6'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.syntax@6$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.syntax@6$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.syntax@6$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.syntax@6:$sgn'(__36sgn, 'env'(___51), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',1790,64,1774)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',1798,64,1774)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','('true', '<module>:emop.syntax@6:atom_fresh_[682]'(_atom__fresh___91683_93, __36Pb, __36Pe)), '<module>:emop.syntax@6:atom_fresh_[684]'(_atom__fresh___91685_93, __36Pb, __36Pe)), '<module>:emop.syntax@6:atom_fresh_[686]'(_atom__fresh___91687_93, __36Pb, __36Pe)), '<module>:emop.syntax@6:atom_fresh_[688]'(_atom__fresh___91689_93, __36Pb, __36Pe)), '<module>:emop.syntax@6:atom_fresh_[690]'(_atom__fresh___91691_93, __36Pb, __36Pe)), '<module>:emop.syntax@6:atom_fresh_[692]'(_atom__fresh___91693_93, __36Pb, __36Pe)), '<module>:emop.syntax@6:atom_fresh_[694]'(_atom__fresh___91695_93, __36Pb, __36Pe)), '<module>:emop.syntax@6:atom_fresh_[696]'(_atom__fresh___91697_93, __36Pb, __36Pe)), '<module>:emop.syntax@6:atom_fresh_[698]'(_atom__fresh___91699_93, __36Pb, __36Pe)), '<module>:emop.syntax@6:atom_fresh_[700]'(_atom__fresh___91701_93, __36Pb, __36Pe)), '<module>:emop.syntax@6:atom_fresh_[702]'(_atom__fresh___91703_93, __36Pb, __36Pe)), '<module>:emop.syntax@6:atom_fresh_[704]'(_atom__fresh___91705_93, __36Pb, __36Pe)), '<module>:emop.syntax@6:atom_fresh_[706]'(_atom__fresh___91707_93, __36Pb, __36Pe)), '<module>:emop.syntax@6:atom_fresh_[708]'(_atom__fresh___91709_93, __36Pb, __36Pe)), '<module>:emop.syntax@6:atom_fresh_[710]'(_atom__fresh___91711_93, __36Pb, __36Pe)), '<module>:emop.syntax@6:atom_fresh_[712]'(_atom__fresh___91713_93, __36Pb, __36Pe)), '<module>:emop.syntax@6:atom_fresh_[714]'(_atom__fresh___91715_93, __36Pb, __36Pe)), '<module>:emop.syntax@6:atom_fresh_[716]'(_atom__fresh___91717_93, __36Pb, __36Pe)), '<module>:emop.syntax@6:atom_fresh_[718]'(_atom__fresh___91719_93, __36Pb, __36Pe)), '<module>:emop.syntax@6:atom_fresh_[720]'(_atom__fresh___91721_93, __36Pb, __36Pe)), '<module>:emop.syntax@6:atom_fresh_[722]'(_atom__fresh___91723_93, __36Pb, __36Pe)), '<module>:emop.syntax@6:atom_fresh_[724]'(_atom__fresh___91725_93, __36Pb, __36Pe)), '<module>:emop.syntax@6:atom_fresh_[726]'(_atom__fresh___91727_93, __36Pb, __36Pe)), '<module>:emop.syntax@6:atom_fresh_[728]'(_atom__fresh___91729_93, __36Pb, __36Pe)), '<module>:emop.syntax@6:atom_fresh_[730]'(_atom__fresh___91731_93, __36Pb, __36Pe)), '<module>:emop.syntax@6:atom_fresh_[732]'(_atom__fresh___91733_93, __36Pb, __36Pe)), '<module>:emop.syntax@6:atom_fresh_[734]'(_atom__fresh___91735_93, __36Pb, __36Pe)), '<module>:emop.syntax@6:atom_fresh_[736]'(_atom__fresh___91737_93, __36Pb, __36Pe)), '<module>:emop.syntax@6:atom_fresh_[738]'(_atom__fresh___91739_93, __36Pb, __36Pe)), '<module>:emop.syntax@6:atom_fresh_[740]'(_atom__fresh___91741_93, __36Pb, __36Pe)), '<module>:emop.syntax@6:atom_fresh_[742]'(_atom__fresh___91743_93, __36Pb, __36Pe)), '<module>:emop.syntax@6:atom_fresh_[744]'(_atom__fresh___91745_93, __36Pb, __36Pe)), '<module>:emop.syntax@6:atom_fresh_[746]'(_atom__fresh___91747_93, __36Pb, __36Pe)), '<module>:emop.syntax@6:atom_fresh_[748]'(_atom__fresh___91749_93, __36Pb, __36Pe)), '<module>:emop.syntax@6:atom_fresh_[750]'(_atom__fresh___91751_93, __36Pb, __36Pe)), '<module>:emop.syntax@6:atom_fresh_[752]'(_atom__fresh___91753_93, __36Pb, __36Pe)), '<module>:emop.syntax@6:atom_fresh_[754]'(_atom__fresh___91755_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___91755_93, '.'(_atom__fresh___91753_93, '.'(_atom__fresh___91751_93, '.'(_atom__fresh___91749_93, '.'(_atom__fresh___91747_93, '.'(_atom__fresh___91745_93, '.'(_atom__fresh___91743_93, '.'(_atom__fresh___91741_93, '.'(_atom__fresh___91739_93, '.'(_atom__fresh___91737_93, '.'(_atom__fresh___91735_93, '.'(_atom__fresh___91733_93, '.'(_atom__fresh___91731_93, '.'(_atom__fresh___91729_93, '.'(_atom__fresh___91727_93, '.'(_atom__fresh___91725_93, '.'(_atom__fresh___91723_93, '.'(_atom__fresh___91721_93, '.'(_atom__fresh___91719_93, '.'(_atom__fresh___91717_93, '.'(_atom__fresh___91715_93, '.'(_atom__fresh___91713_93, '.'(_atom__fresh___91711_93, '.'(_atom__fresh___91709_93, '.'(_atom__fresh___91707_93, '.'(_atom__fresh___91705_93, '.'(_atom__fresh___91703_93, '.'(_atom__fresh___91701_93, '.'(_atom__fresh___91699_93, '.'(_atom__fresh___91697_93, '.'(_atom__fresh___91695_93, '.'(_atom__fresh___91693_93, '.'(_atom__fresh___91691_93, '.'(_atom__fresh___91689_93, '.'(_atom__fresh___91687_93, '.'(_atom__fresh___91685_93, '.'(_atom__fresh___91683_93, '[]'))))))))))))))))))))))))))))))))))))))))))).
':-'('<module>:emop.syntax@6:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.syntax@6:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.syntax@6:atom_fresh_[682]'(__36s, __36Pb, __36Pe), '='(__36s, 'notation'('.'('()'('callable'('$~$', 'operator', '.'('callable'('goal', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'(',', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('term', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('|', 'unescaped', 'none', __36Pb, __36Pe), '.'(module(atom('M',unescaped,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4238,111,4197),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4239,111,4197)),[callable('A',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4241,111,4197),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4242,111,4197)),callable($~$,operator,[callable('Gamma',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4244,111,4197),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4249,111,4197)),callable(*,unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4249,111,4197),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4250,111,4197))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4249,111,4197),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4249,111,4197))],callable('B',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4254,111,4197),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4255,111,4197)),[symbol('B',0,predicate,[],file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4254,111,4197),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4255,111,4197)))],[clause('B',[],callable(true,unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4254,111,4197),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4255,111,4197)),nodoc,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4254,111,4197),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4255,111,4197))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4231,111,4197),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4253,111,4197)), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('->', 'unescaped', 'none', __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('=', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('>>', 'unescaped', 'none', __36Pb, __36Pe), '.'(module(atom('M',unescaped,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4280,111,4197),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4281,111,4197)),[callable('A',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4283,111,4197),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4284,111,4197)),callable('Gamma',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4286,111,4197),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4291,111,4197))],callable('B',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4295,111,4197),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4296,111,4197)),[symbol('B',0,predicate,[],file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4295,111,4197),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4296,111,4197)))],[clause('B',[],callable(true,unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4295,111,4197),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4296,111,4197)),nodoc,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4295,111,4197),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4296,111,4197))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4273,111,4197),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4294,111,4197)), '[]')))))), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@6:atom_fresh_[684]'(__36s, __36Pb, __36Pe), '='(__36s, 'notation'('.'('()'('callable'('term', 'unescaped', 'none', __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('match', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('p', 'unescaped', '.'('callable'('$~$', 'operator', '.'('callable'('B', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('*', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]'), __36Pb, __36Pe), '.'('callable'('->', 'unescaped', 'none', __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('=', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('p', 'unescaped', '.'('callable'('$~$', 'operator', '.'('callable'('C', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('*', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]'), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('>>', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('p', 'unescaped', '.'('callable'('$~$', 'operator', '.'('()'('callable'('$~$', 'operator', '.'('callable'('C', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('match', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('B', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('*', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]'), __36Pb, __36Pe), '[]')))))))), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@6:atom_fresh_[686]'(__36s, __36Pb, __36Pe), '='(__36s, 'notation'('.'('()'('callable'('term', 'unescaped', 'none', __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('match', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'(':', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('p', 'unescaped', '.'('callable'('$~$', 'operator', '.'('callable'('B', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('*', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]'), __36Pb, __36Pe), '.'('callable'('->', 'unescaped', 'none', __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('=', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'(':', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('p', 'unescaped', '.'('callable'('$~$', 'operator', '.'('callable'('C', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('*', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]'), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('>>', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'(':', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('p', 'unescaped', '.'('callable'('$~$', 'operator', '.'('()'('callable'('$~$', 'operator', '.'('callable'('C', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('match', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('B', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('*', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]'), __36Pb, __36Pe), '[]')))))))))))), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@6:atom_fresh_[688]'(__36s, __36Pb, __36Pe), '='(__36s, 'notation'('.'('()'('callable'('goal', 'unescaped', 'none', __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('match', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('p', 'unescaped', '.'('callable'('$~$', 'operator', '.'('callable'('B', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('*', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]'), __36Pb, __36Pe), '.'('callable'('->', 'unescaped', 'none', __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('=', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('p', 'unescaped', '.'('callable'('$~$', 'operator', '.'('callable'('C', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('*', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]'), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('>>', 'unescaped', 'none', __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('()'('callable'('$~$', 'operator', '.'('callable'('C', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('match', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('B', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('*', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '[]')))))))), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@6:atom_fresh_[690]'(__36s, __36Pb, __36Pe), '='(__36s, 'notation'('.'('()'('callable'('goal', 'unescaped', 'none', __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('match', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'(':', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('p', 'unescaped', '.'('callable'('$~$', 'operator', '.'('callable'('B', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('*', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]'), __36Pb, __36Pe), '.'('callable'('->', 'unescaped', 'none', __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('=', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'(':', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('p', 'unescaped', '.'('callable'('$~$', 'operator', '.'('callable'('C', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('*', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]'), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('>>', 'unescaped', 'none', __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('()'('callable'('$~$', 'operator', '.'('callable'('C', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('match', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('B', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('*', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '[]')))))))))), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@6:atom_fresh_[692]'(__36s, __36Pb, __36Pe), '='(__36s, 'notation'('.'('()'('callable'('$~$', 'operator', '.'('callable'('goal', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'(',', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('term', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('P', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('&', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('Q', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('match', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('->', 'unescaped', 'none', __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('=', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('>>', 'unescaped', 'none', __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('P', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('match', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('>>', 'unescaped', 'none', __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('Q', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('match', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '[]')))))))))), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@6:atom_fresh_[694]'(__36s, __36Pb, __36Pe), '='(__36s, 'notation'('.'('()'('callable'('$~$', 'operator', '.'('callable'('goal', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'(',', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('term', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('match', 'unescaped', 'none', __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('P', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('&', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('Q', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('->', 'unescaped', 'none', __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('=', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('>>', 'unescaped', 'none', __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('match', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('P', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('>>', 'unescaped', 'none', __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('match', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('Q', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '[]')))))))))), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@6:atom_fresh_[696]'(__36s, __36Pb, __36Pe), '='(__36s, 'notation'('.'('()'('callable'('$~$', 'operator', '.'('callable'('goal', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'(',', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('term', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('match', 'unescaped', 'none', __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('P', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'(';', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('Q', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('->', 'unescaped', 'none', __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('=', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('>>', 'unescaped', 'none', __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('match', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('P', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'(';', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('match', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('Q', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '[]')))))))), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@6:atom_fresh_[698]'(__36s, __36Pb, __36Pe), '='(__36s, 'notation'('.'('()'('callable'('$~$', 'operator', '.'('callable'('goal', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'(',', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('term', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('match', 'unescaped', 'none', __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('P', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('->', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('Q', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'(';', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('R', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('->', 'unescaped', 'none', __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('=', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('>>', 'unescaped', 'none', __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('match', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('P', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('->', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('Q', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'(';', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('match', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('R', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '[]')))))))), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@6:atom_fresh_[700]'(__36s, __36Pb, __36Pe), '='(__36s, 'notation'('.'('()'('callable'('$~$', 'operator', '.'('callable'('goal', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'(',', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('term', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('match', 'unescaped', 'none', __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('P', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('->', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('Q', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('->', 'unescaped', 'none', __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('=', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('>>', 'unescaped', 'none', __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('match', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('P', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('->', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('Q', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '[]')))))))), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@6:atom_fresh_[702]'(__36s, __36Pb, __36Pe), '='(__36s, 'notation'('.'('()'('callable'('$~$', 'operator', '.'('callable'('goal', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'(',', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('term', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('match', 'unescaped', 'none', __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('P', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('=>', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('Q', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('->', 'unescaped', 'none', __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('=', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('>>', 'unescaped', 'none', __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('match', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('P', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('>>', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('Q', 'unescaped', 'none', __36Pb, __36Pe), '[]')))))))))), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@6:atom_fresh_[704]'(__36s, __36Pb, __36Pe), '='(__36s, 'notation'('.'('()'('callable'('$~$', 'operator', '.'('callable'('goal', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'(',', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('term', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('match', 'unescaped', 'none', __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('P', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('>>', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('Q', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('->', 'unescaped', 'none', __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('=', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'(',', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('P', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('>>', 'unescaped', 'none', __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('match', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('Q', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '[]')))))))), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@6:atom_fresh_[706]'(__36s, __36Pb, __36Pe), '='(__36s, 'notation'('.'('()'('callable'('term', 'unescaped', 'none', __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('match', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('N', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('|', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('N', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'(':', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('number', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('->', 'unescaped', 'none', __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('=', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('N', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('>>', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('N', 'unescaped', 'none', __36Pb, __36Pe), '[]')))))))))))), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@6:atom_fresh_[708]'(__36s, __36Pb, __36Pe), '='(__36s, 'notation'('.'('()'('callable'('term', 'unescaped', 'none', __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('match', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('V', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('|', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('V', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'(':', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('var', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('->', 'unescaped', 'none', __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('=', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'(',', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('=', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('V', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('>>', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '[]')))))))))))), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@6:atom_fresh_[710]'(__36s, __36Pb, __36Pe), '='(__36s, 'notation'('.'('()'('callable'('goal', 'unescaped', 'none', __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('match', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('|', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'(':', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('var', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'(';', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'(':', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('number', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('->', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('=', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '[]')))))))))))))))), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@6:atom_fresh_[712]'(__36s, __36Pb, __36Pe), '='(__36s, 'notation'('.'('()'('callable'('$~$', 'operator', '.'('callable'('goal', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'(',', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('term', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('()'('callable'('$~$', 'operator', '.'('callable'('P', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('&', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('Q', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('|', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('->', 'unescaped', 'none', __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('=', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('>>', 'unescaped', 'none', __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('P', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('|', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('>>', 'unescaped', 'none', __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('Q', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('|', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '[]')))))))), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@6:atom_fresh_[714]'(__36s, __36Pb, __36Pe), '='(__36s, 'notation'('.'('()'('callable'('$~$', 'operator', '.'('callable'('goal', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'(',', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('term', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('|', 'unescaped', 'none', __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('P', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('&', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('Q', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('->', 'unescaped', 'none', __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('=', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('>>', 'unescaped', 'none', __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('|', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('P', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('>>', 'unescaped', 'none', __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('|', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('Q', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '[]')))))))), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@6:atom_fresh_[716]'(__36s, __36Pb, __36Pe), '='(__36s, 'notation'('.'('()'('callable'('$~$', 'operator', '.'('callable'('goal', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'(',', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('term', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('|', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('p', 'unescaped', '.'('callable'('$~$', 'operator', '.'('callable'('Gamma', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('*', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]'), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('->', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('p', 'unescaped', '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('Gamma', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')))), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@6:atom_fresh_[718]'(__36s, __36Pb, __36Pe), '='(__36s, 'notation'('.'('()'('callable'('$~$', 'operator', '.'('callable'('goal', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'(',', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('term', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('|', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'(':', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('p', 'unescaped', '.'('callable'('$~$', 'operator', '.'('callable'('Gamma', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('*', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]'), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('->', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'(':', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('p', 'unescaped', '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('Gamma', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')))))), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@6:atom_fresh_[720]'(__36s, __36Pb, __36Pe), '='(__36s, 'notation'('.'('()'('callable'('$~$', 'operator', '.'('callable'('goal', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'(',', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('term', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('|', 'unescaped', 'none', __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('P', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'(';', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('Q', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('->', 'unescaped', 'none', __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('=', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('>>', 'unescaped', 'none', __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('|', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('P', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'(';', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('|', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('Q', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '[]')))))), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@6:atom_fresh_[722]'(__36s, __36Pb, __36Pe), '='(__36s, 'notation'('.'('()'('callable'('$~$', 'operator', '.'('callable'('goal', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'(',', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('term', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('|', 'unescaped', 'none', __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('P', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('->', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('Q', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'(';', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('R', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('->', 'unescaped', 'none', __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('=', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('>>', 'unescaped', 'none', __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('P', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('->', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('|', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('Q', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'(';', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('|', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('R', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '[]')))))), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@6:atom_fresh_[724]'(__36s, __36Pb, __36Pe), '='(__36s, 'notation'('.'('()'('callable'('$~$', 'operator', '.'('callable'('goal', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'(',', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('term', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('|', 'unescaped', 'none', __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('P', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('->', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('Q', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('->', 'unescaped', 'none', __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('=', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('>>', 'unescaped', 'none', __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('P', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('->', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('|', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('Q', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '[]')))))), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@6:atom_fresh_[726]'(__36s, __36Pb, __36Pe), '='(__36s, 'notation'('.'('()'('callable'('$~$', 'operator', '.'('callable'('goal', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'(',', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('term', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('|', 'unescaped', 'none', __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('P', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('>>', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('Q', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('->', 'unescaped', 'none', __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('=', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('>>', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('P', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('>>', 'unescaped', 'none', __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('|', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('Q', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '[]')))))))), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@6:atom_fresh_[728]'(__36s, __36Pb, __36Pe), '='(__36s, 'notation'('.'('()'('callable'('term', 'unescaped', 'none', __36Pb, __36Pe), __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('|', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('N', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('|', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('N', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'(':', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('number', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('->', 'unescaped', 'none', __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('=', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('N', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('>>', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('N', 'unescaped', 'none', __36Pb, __36Pe), '[]')))))))))), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@6:atom_fresh_[730]'(__36s, __36Pb, __36Pe), '='(__36s, 'notation'('.'('()'('callable'('term', 'unescaped', 'none', __36Pb, __36Pe), __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('|', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('V', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('|', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('V', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'(':', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('var', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('->', 'unescaped', 'none', __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('=', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'(',', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('=', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('V', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('>>', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '[]')))))))))), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@6:atom_fresh_[732]'(__36s, __36Pb, __36Pe), '='(__36s, 'notation'('.'('()'('callable'('goal', 'unescaped', 'none', __36Pb, __36Pe), __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('|', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('|', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'(':', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('var', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'(';', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'(':', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('number', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('->', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('=', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '[]')))))))))))))), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@6:atom_fresh_[734]'(__36s, __36Pb, __36Pe), '='(__36s, 'syntax'('.'('callable'('=', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('<', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('infix', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('|', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('<', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('prefix', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('|', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('<', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('&', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('<', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('>>', 'escaped', 'none', __36Pb, __36Pe), '[]'))))))))))), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@6:atom_fresh_[736]'(__36s, __36Pb, __36Pe), '='(__36s, 'syntax'('.'('callable'('infix', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('left', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('associative', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('&', 'escaped', 'none', __36Pb, __36Pe), '[]')))), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@6:atom_fresh_[738]'(__36s, __36Pb, __36Pe), '='(__36s, 'notation'('.'('()'('callable'('$~$', 'operator', '.'('callable'('goal', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'(',', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('term', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('match', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('|', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('B', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('->', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('|', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('B', 'unescaped', 'none', __36Pb, __36Pe), '[]')))))), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@6:atom_fresh_[740]'(__36s, __36Pb, __36Pe), '='(__36s, 'notation'('.'('()'('callable'('$~$', 'operator', '.'('callable'('goal', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'(',', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('term', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('match', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('match', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('B', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('->', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('match', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('B', 'unescaped', 'none', __36Pb, __36Pe), '[]')))))), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@6:atom_fresh_[742]'(__36s, __36Pb, __36Pe), '='(__36s, 'notation'('.'('()'('callable'('$~$', 'operator', '.'('callable'('goal', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'(',', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('term', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('|', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('|', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('B', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('->', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('|', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('B', 'unescaped', 'none', __36Pb, __36Pe), '[]')))))), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@6:atom_fresh_[744]'(__36s, __36Pb, __36Pe), '='(__36s, 'notation'('.'('()'('callable'('$~$', 'operator', '.'('callable'('goal', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'(',', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('term', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('()'('callable'('$~$', 'operator', '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('|', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('match', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('B', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]')), __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('->', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('A', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('match', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('B', 'unescaped', 'none', __36Pb, __36Pe), '[]')))))), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@6:atom_fresh_[746]'(__36s, __36Pb, __36Pe), '='(__36s, 'syntax'('.'('callable'('=>', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('=', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('->', 'escaped', 'none', __36Pb, __36Pe), '[]'))), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@6:atom_fresh_[748]'(__36s, __36Pb, __36Pe), '='(__36s, 'syntax'('.'('callable'('=', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('<', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('infix', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('|', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('=', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('infix', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('match', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('<', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('prefix', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('|', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('=', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('prefix', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('match', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('<', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('>>', 'escaped', 'none', __36Pb, __36Pe), '[]'))))))))))))))), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@6:atom_fresh_[750]'(__36s, __36Pb, __36Pe), '='(__36s, 'syntax'('.'('callable'('prefix', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('|', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('match', 'escaped', 'none', __36Pb, __36Pe), '[]'))), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@6:atom_fresh_[752]'(__36s, __36Pb, __36Pe), '='(__36s, 'syntax'('.'('callable'('infix', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('right', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('associative', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('=>', 'escaped', 'none', __36Pb, __36Pe), '[]')))), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@6:atom_fresh_[754]'(__36s, __36Pb, __36Pe), '='(__36s, 'syntax'('.'('callable'('infix', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('left', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('associative', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('|', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('match', 'escaped', 'none', __36Pb, __36Pe), '[]'))))), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@7'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.syntax@7:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.syntax@7'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.syntax@7$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.syntax@7$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.syntax@7$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.syntax@7:$sgn'(__36sgn, 'env'(___57), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4324,114,4307)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4332,114,4307)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','(','(','(','('true', '<module>:emop.syntax@7:atom_fresh_[670]'(_atom__fresh___91671_93, __36Pb, __36Pe)), '<module>:emop.syntax@7:atom_fresh_[672]'(_atom__fresh___91673_93, __36Pb, __36Pe)), '<module>:emop.syntax@7:atom_fresh_[674]'(_atom__fresh___91675_93, __36Pb, __36Pe)), '<module>:emop.syntax@7:atom_fresh_[676]'(_atom__fresh___91677_93, __36Pb, __36Pe)), '<module>:emop.syntax@7:atom_fresh_[678]'(_atom__fresh___91679_93, __36Pb, __36Pe)), '<module>:emop.syntax@7:atom_fresh_[680]'(_atom__fresh___91681_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___91681_93, '.'(_atom__fresh___91679_93, '.'(_atom__fresh___91677_93, '.'(_atom__fresh___91675_93, '.'(_atom__fresh___91673_93, '.'(_atom__fresh___91671_93, '[]')))))))))))).
':-'('<module>:emop.syntax@7:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.syntax@7:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.syntax@7:atom_fresh_[670]'(__36s, __36Pb, __36Pe), '='(__36s, 'notation'('.'('()'('callable'('term', 'unescaped', 'none', __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('f', 'unescaped', '.'('callable'('$~$', 'operator', '.'('callable'('Gamma', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('*', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '.'('callable'('>', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('Delta', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('*', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '.'('callable'('<', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('Epsilon', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('*', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]'))))), __36Pb, __36Pe), '.'('callable'('->', 'unescaped', 'none', __36Pb, __36Pe), '.'(module(atom('_',unescaped,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5016,131,5007),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5022,131,5007)),none,callable(:-,operator,[callable(do,unescaped,[callable('A',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5028,131,5007),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5029,131,5007)),callable('B',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5031,131,5007),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5032,131,5007))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5025,131,5007),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5027,131,5007)),callable(f,unescaped,[callable($~$,operator,[callable('Gamma',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5039,131,5007),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5044,131,5007)),callable(*,unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5044,131,5007),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5045,131,5007))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5044,131,5007),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5046,131,5007)),callable('B',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5047,131,5007),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5048,131,5007)),callable($~$,operator,[callable('Delta',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5050,131,5007),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5055,131,5007)),callable(*,unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5055,131,5007),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5056,131,5007))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5055,131,5007),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5057,131,5007)),callable('A',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5058,131,5007),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5059,131,5007)),callable($~$,operator,[callable('Epsilon',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5061,131,5007),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5068,131,5007)),callable(*,unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5068,131,5007),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5069,131,5007))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5068,131,5007),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5068,131,5007))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5037,131,5007),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5038,131,5007))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5034,131,5007),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5036,131,5007)),[symbol(do,2,predicate,suspended([var('A'),var('B')],[call(scope,f,[none,var('B'),none,var('A'),none])]),file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5034,131,5007),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5036,131,5007)))],[clause(do,[callable('A',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5028,131,5007),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5029,131,5007)),callable('B',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5031,131,5007),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5032,131,5007))],callable(f,unescaped,[callable($~$,operator,[callable('Gamma',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5039,131,5007),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5044,131,5007)),callable(*,unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5044,131,5007),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5045,131,5007))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5044,131,5007),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5046,131,5007)),callable('B',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5047,131,5007),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5048,131,5007)),callable($~$,operator,[callable('Delta',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5050,131,5007),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5055,131,5007)),callable(*,unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5055,131,5007),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5056,131,5007))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5055,131,5007),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5057,131,5007)),callable('A',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5058,131,5007),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5059,131,5007)),callable($~$,operator,[callable('Epsilon',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5061,131,5007),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5068,131,5007)),callable(*,unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5068,131,5007),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5069,131,5007))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5068,131,5007),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5068,131,5007))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5037,131,5007),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5038,131,5007)),nodoc,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5034,131,5007),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5036,131,5007))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5016,131,5007),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',5024,131,5007)), '[]')))), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@7:atom_fresh_[672]'(__36s, __36Pb, __36Pe), '='(__36s, 'notation'('.'('()'('callable'('term', 'unescaped', 'none', __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'(':', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('f', 'unescaped', '.'('callable'('$~$', 'operator', '.'('callable'('Gamma', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('*', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '.'('callable'('>', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('Delta', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('*', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '.'('callable'('<', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('Epsilon', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('*', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]'))))), __36Pb, __36Pe), '.'('callable'('->', 'unescaped', 'none', __36Pb, __36Pe), '.'(module(atom('_',unescaped,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4882,128,4873),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4888,128,4873)),none,callable(:-,operator,[callable(do,unescaped,[callable('A',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4894,128,4873),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4895,128,4873)),callable('B',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4897,128,4873),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4898,128,4873))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4891,128,4873),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4893,128,4873)),callable(:,operator,[callable('X',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4903,128,4873),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4904,128,4873)),callable(f,unescaped,[callable($~$,operator,[callable('Gamma',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4907,128,4873),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4912,128,4873)),callable(*,unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4912,128,4873),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4913,128,4873))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4912,128,4873),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4914,128,4873)),callable('B',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4915,128,4873),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4916,128,4873)),callable($~$,operator,[callable('Delta',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4918,128,4873),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4923,128,4873)),callable(*,unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4923,128,4873),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4924,128,4873))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4923,128,4873),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4925,128,4873)),callable('A',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4926,128,4873),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4927,128,4873)),callable($~$,operator,[callable('Epsilon',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4929,128,4873),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4936,128,4873)),callable(*,unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4936,128,4873),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4937,128,4873))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4936,128,4873),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4936,128,4873))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4905,128,4873),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4906,128,4873))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4904,128,4873),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4905,128,4873))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4900,128,4873),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4902,128,4873)),[symbol(do,2,predicate,suspended([var('A'),var('B')],[call(var('X'),f,[none,var('B'),none,var('A'),none])]),file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4900,128,4873),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4902,128,4873)))],[clause(do,[callable('A',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4894,128,4873),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4895,128,4873)),callable('B',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4897,128,4873),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4898,128,4873))],callable(:,operator,[callable('X',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4903,128,4873),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4904,128,4873)),callable(f,unescaped,[callable($~$,operator,[callable('Gamma',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4907,128,4873),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4912,128,4873)),callable(*,unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4912,128,4873),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4913,128,4873))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4912,128,4873),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4914,128,4873)),callable('B',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4915,128,4873),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4916,128,4873)),callable($~$,operator,[callable('Delta',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4918,128,4873),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4923,128,4873)),callable(*,unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4923,128,4873),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4924,128,4873))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4923,128,4873),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4925,128,4873)),callable('A',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4926,128,4873),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4927,128,4873)),callable($~$,operator,[callable('Epsilon',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4929,128,4873),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4936,128,4873)),callable(*,unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4936,128,4873),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4937,128,4873))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4936,128,4873),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4936,128,4873))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4905,128,4873),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4906,128,4873))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4904,128,4873),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4905,128,4873)),nodoc,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4900,128,4873),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4902,128,4873))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4882,128,4873),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4890,128,4873)), '[]')))))), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@7:atom_fresh_[674]'(__36s, __36Pb, __36Pe), '='(__36s, 'notation'('.'('()'('callable'('term', 'unescaped', 'none', __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('f', 'unescaped', '.'('callable'('$~$', 'operator', '.'('callable'('Gamma', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('*', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '.'('callable'('<', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('Delta', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('*', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '.'('callable'('>', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('Epsilon', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('*', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]'))))), __36Pb, __36Pe), '.'('callable'('->', 'unescaped', 'none', __36Pb, __36Pe), '.'(module(atom('_',unescaped,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4748,125,4739),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4754,125,4739)),none,callable(:-,operator,[callable(do,unescaped,[callable('A',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4760,125,4739),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4761,125,4739)),callable('B',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4763,125,4739),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4764,125,4739))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4757,125,4739),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4759,125,4739)),callable(f,unescaped,[callable($~$,operator,[callable('Gamma',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4771,125,4739),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4776,125,4739)),callable(*,unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4776,125,4739),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4777,125,4739))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4776,125,4739),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4778,125,4739)),callable('A',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4779,125,4739),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4780,125,4739)),callable($~$,operator,[callable('Delta',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4782,125,4739),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4787,125,4739)),callable(*,unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4787,125,4739),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4788,125,4739))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4787,125,4739),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4789,125,4739)),callable('B',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4790,125,4739),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4791,125,4739)),callable($~$,operator,[callable('Epsilon',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4793,125,4739),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4800,125,4739)),callable(*,unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4800,125,4739),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4801,125,4739))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4800,125,4739),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4800,125,4739))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4769,125,4739),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4770,125,4739))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4766,125,4739),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4768,125,4739)),[symbol(do,2,predicate,suspended([var('A'),var('B')],[call(scope,f,[none,var('A'),none,var('B'),none])]),file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4766,125,4739),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4768,125,4739)))],[clause(do,[callable('A',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4760,125,4739),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4761,125,4739)),callable('B',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4763,125,4739),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4764,125,4739))],callable(f,unescaped,[callable($~$,operator,[callable('Gamma',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4771,125,4739),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4776,125,4739)),callable(*,unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4776,125,4739),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4777,125,4739))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4776,125,4739),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4778,125,4739)),callable('A',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4779,125,4739),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4780,125,4739)),callable($~$,operator,[callable('Delta',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4782,125,4739),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4787,125,4739)),callable(*,unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4787,125,4739),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4788,125,4739))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4787,125,4739),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4789,125,4739)),callable('B',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4790,125,4739),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4791,125,4739)),callable($~$,operator,[callable('Epsilon',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4793,125,4739),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4800,125,4739)),callable(*,unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4800,125,4739),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4801,125,4739))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4800,125,4739),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4800,125,4739))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4769,125,4739),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4770,125,4739)),nodoc,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4766,125,4739),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4768,125,4739))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4748,125,4739),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4756,125,4739)), '[]')))), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@7:atom_fresh_[676]'(__36s, __36Pb, __36Pe), '='(__36s, 'notation'('.'('()'('callable'('term', 'unescaped', 'none', __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'(':', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('f', 'unescaped', '.'('callable'('$~$', 'operator', '.'('callable'('Gamma', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('*', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '.'('callable'('<', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('Delta', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('*', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '.'('callable'('>', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('Epsilon', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('*', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]'))))), __36Pb, __36Pe), '.'('callable'('->', 'unescaped', 'none', __36Pb, __36Pe), '.'(module(atom('_',unescaped,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4614,122,4605),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4620,122,4605)),none,callable(:-,operator,[callable(do,unescaped,[callable('A',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4626,122,4605),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4627,122,4605)),callable('B',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4629,122,4605),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4630,122,4605))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4623,122,4605),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4625,122,4605)),callable(:,operator,[callable('X',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4635,122,4605),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4636,122,4605)),callable(f,unescaped,[callable($~$,operator,[callable('Gamma',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4639,122,4605),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4644,122,4605)),callable(*,unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4644,122,4605),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4645,122,4605))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4644,122,4605),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4646,122,4605)),callable('A',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4647,122,4605),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4648,122,4605)),callable($~$,operator,[callable('Delta',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4650,122,4605),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4655,122,4605)),callable(*,unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4655,122,4605),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4656,122,4605))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4655,122,4605),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4657,122,4605)),callable('B',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4658,122,4605),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4659,122,4605)),callable($~$,operator,[callable('Epsilon',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4661,122,4605),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4668,122,4605)),callable(*,unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4668,122,4605),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4669,122,4605))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4668,122,4605),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4668,122,4605))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4637,122,4605),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4638,122,4605))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4636,122,4605),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4637,122,4605))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4632,122,4605),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4634,122,4605)),[symbol(do,2,predicate,suspended([var('A'),var('B')],[call(var('X'),f,[none,var('A'),none,var('B'),none])]),file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4632,122,4605),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4634,122,4605)))],[clause(do,[callable('A',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4626,122,4605),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4627,122,4605)),callable('B',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4629,122,4605),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4630,122,4605))],callable(:,operator,[callable('X',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4635,122,4605),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4636,122,4605)),callable(f,unescaped,[callable($~$,operator,[callable('Gamma',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4639,122,4605),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4644,122,4605)),callable(*,unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4644,122,4605),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4645,122,4605))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4644,122,4605),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4646,122,4605)),callable('A',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4647,122,4605),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4648,122,4605)),callable($~$,operator,[callable('Delta',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4650,122,4605),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4655,122,4605)),callable(*,unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4655,122,4605),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4656,122,4605))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4655,122,4605),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4657,122,4605)),callable('B',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4658,122,4605),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4659,122,4605)),callable($~$,operator,[callable('Epsilon',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4661,122,4605),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4668,122,4605)),callable(*,unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4668,122,4605),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4669,122,4605))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4668,122,4605),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4668,122,4605))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4637,122,4605),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4638,122,4605))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4636,122,4605),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4637,122,4605)),nodoc,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4632,122,4605),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4634,122,4605))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4614,122,4605),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4622,122,4605)), '[]')))))), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@7:atom_fresh_[678]'(__36s, __36Pb, __36Pe), '='(__36s, 'notation'('.'('()'('callable'('term', 'unescaped', 'none', __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('f', 'unescaped', '.'('callable'('$~$', 'operator', '.'('callable'('Gamma', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('*', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '.'('callable'('*', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('Delta', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('*', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]'))), __36Pb, __36Pe), '.'('callable'('->', 'unescaped', 'none', __36Pb, __36Pe), '.'(module(atom('_',unescaped,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4496,119,4487),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4502,119,4487)),none,callable(:-,operator,[callable(do,unescaped,[callable('A',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4508,119,4487),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4509,119,4487))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4505,119,4487),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4507,119,4487)),callable(f,unescaped,[callable($~$,operator,[callable('Gamma',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4516,119,4487),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4521,119,4487)),callable(*,unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4521,119,4487),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4522,119,4487))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4521,119,4487),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4523,119,4487)),callable('A',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4524,119,4487),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4525,119,4487)),callable($~$,operator,[callable('Delta',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4527,119,4487),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4532,119,4487)),callable(*,unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4532,119,4487),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4533,119,4487))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4532,119,4487),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4532,119,4487))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4514,119,4487),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4515,119,4487))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4511,119,4487),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4513,119,4487)),[symbol(do,1,predicate,suspended([var('A')],[call(scope,f,[none,var('A'),none])]),file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4511,119,4487),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4513,119,4487)))],[clause(do,[callable('A',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4508,119,4487),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4509,119,4487))],callable(f,unescaped,[callable($~$,operator,[callable('Gamma',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4516,119,4487),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4521,119,4487)),callable(*,unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4521,119,4487),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4522,119,4487))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4521,119,4487),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4523,119,4487)),callable('A',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4524,119,4487),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4525,119,4487)),callable($~$,operator,[callable('Delta',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4527,119,4487),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4532,119,4487)),callable(*,unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4532,119,4487),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4533,119,4487))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4532,119,4487),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4532,119,4487))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4514,119,4487),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4515,119,4487)),nodoc,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4511,119,4487),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4513,119,4487))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4496,119,4487),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4504,119,4487)), '[]')))), __36Pb, __36Pe))).
':-'('<module>:emop.syntax@7:atom_fresh_[680]'(__36s, __36Pb, __36Pe), '='(__36s, 'notation'('.'('()'('callable'('term', 'unescaped', 'none', __36Pb, __36Pe), __36Pb, __36Pe), '.'('callable'('X', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'(':', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('f', 'unescaped', '.'('callable'('$~$', 'operator', '.'('callable'('Gamma', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('*', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '.'('callable'('*', 'escaped', 'none', __36Pb, __36Pe), '.'('callable'('$~$', 'operator', '.'('callable'('Delta', 'unescaped', 'none', __36Pb, __36Pe), '.'('callable'('*', 'unescaped', 'none', __36Pb, __36Pe), '[]')), __36Pb, __36Pe), '[]'))), __36Pb, __36Pe), '.'('callable'('->', 'unescaped', 'none', __36Pb, __36Pe), '.'(module(atom('_',unescaped,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4393,116,4384),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4399,116,4384)),none,callable(:-,operator,[callable(do,unescaped,[callable('A',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4405,116,4384),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4406,116,4384))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4402,116,4384),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4404,116,4384)),callable(:,operator,[callable('X',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4411,116,4384),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4412,116,4384)),callable(f,unescaped,[callable($~$,operator,[callable('Gamma',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4415,116,4384),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4420,116,4384)),callable(*,unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4420,116,4384),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4421,116,4384))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4420,116,4384),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4422,116,4384)),callable('A',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4423,116,4384),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4424,116,4384)),callable($~$,operator,[callable('Delta',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4426,116,4384),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4431,116,4384)),callable(*,unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4431,116,4384),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4432,116,4384))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4431,116,4384),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4431,116,4384))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4413,116,4384),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4414,116,4384))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4412,116,4384),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4413,116,4384))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4408,116,4384),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4410,116,4384)),[symbol(do,1,predicate,suspended([var('A')],[call(var('X'),f,[none,var('A'),none])]),file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4408,116,4384),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4410,116,4384)))],[clause(do,[callable('A',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4405,116,4384),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4406,116,4384))],callable(:,operator,[callable('X',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4411,116,4384),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4412,116,4384)),callable(f,unescaped,[callable($~$,operator,[callable('Gamma',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4415,116,4384),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4420,116,4384)),callable(*,unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4420,116,4384),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4421,116,4384))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4420,116,4384),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4422,116,4384)),callable('A',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4423,116,4384),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4424,116,4384)),callable($~$,operator,[callable('Delta',unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4426,116,4384),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4431,116,4384)),callable(*,unescaped,none,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4431,116,4384),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4432,116,4384))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4431,116,4384),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4431,116,4384))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4413,116,4384),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4414,116,4384))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4412,116,4384),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4413,116,4384)),nodoc,pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4408,116,4384),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4410,116,4384))],pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4393,116,4384),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/syntax.mpl',4401,116,4384)), '[]')))))), __36Pb, __36Pe))).
':-'('emop.syntax@init', ','('true', 'g_link'('emop.syntax', '<module>:emop.syntax'('env')))).
':-'('dynamic'('/'('<module>:emop.top$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.top@0$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.top@2$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.top@1$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.top@7$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.top@6$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.top@5$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.top@4$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.top@3$dynamic', 4))).
':-'('<module>:emop.top'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.top:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.top'('main', __36env, _, __36CutLevel), ','('!', '<module>:emop.top:main'(__36env, __36CutLevel))).
':-'('<module>:emop.top'('new'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.top:new'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.top'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.top$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.top$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.top$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.top$has_predicate'('main'), 'true').
':-'('<module>:emop.top$has_predicate'('new'(_____1)), 'true').
':-'('<module>:emop.top:$sgn'(__36sgn, 'env', __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/top.mpl',0,0,0)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/top.mpl',17,0,0)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','('true', '<module>:emop.top:atom_fresh_[4539]'(_atom__fresh___914540_93, __36Pb, __36Pe)), '<module>:emop.top:atom_fresh_[4541]'(_atom__fresh___914542_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___914542_93, '.'(_atom__fresh___914540_93, '[]')))))))).
':-'('<module>:emop.top:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.top:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.top:atom_fresh_[4539]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(new, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.top:atom_fresh_[4541]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(main, 0, predicate, [], __36pos))).
':-'('<module>:emop.top:main'('env', __36CutLevel), ','(','('g_read'('emop.top', '<module>:emop.top'(___5)), '<module>:emop.top:new$direct'(___4, ___5)), ','(','(','('g_read'('emop.syntax', '<module>:emop.syntax'(___8)), '<module>:emop.syntax:syntax$direct'(___7, ___8)), 'emop_call'(___4, 'import'(___7), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/top.mpl\", line 4, from character 9 to 15')), 'emop_call'(___4, 'loop', 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/top.mpl\", line 5, from character 9 to 13')))).
':-'('<module>:emop.top:main$direct'(__36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.top:main'(__36env, __36CutLevel))).
':-'('<module>:emop.top:new'(_Top, 'env', __36CutLevel), ','(','('='(_Scope, ___11), ','('g_read'('data.ref.backtrackable', '<module>:data.ref.backtrackable'(___12)), '<module>:data.ref.backtrackable:new$direct'('[]', ___11, ___12))), ','(','('='(_ParentVars, ___14), ','('g_read'('data.record', '<module>:data.record'(___15)), '<module>:data.record:{}$direct'(___14, ___15))), ','(','('='(_SgnVars, ___17), ','('g_read'('data.record', '<module>:data.record'(___18)), '<module>:data.record:{}$direct'(___17, ___18))), ','(','('='(_Prompt, ___21), ','('g_read'('data.ref.backtrackable', '<module>:data.ref.backtrackable'(___22)), '<module>:data.ref.backtrackable:new$direct'('(~d) ?- ', ___21, ___22))), ','('true', ','(';'('->'('var'(_Top), ','('g_inc'('$module_count', ___23), '='(_Top, '$module'(___23, '.'('<module>:emop.top@0'('env'(_Top, _ParentVars, _Prompt, _Scope, _SgnVars, _Top, ___34)), '[]'), '.'(_Top, '[]'))))), ','('='(_Top, '$module'(___23, ___24, _)), ','('='('.'(___25, ___26), ___24), ','('setarg'(1, ___24, '<module>:emop.top@0'('env'(_Top, _ParentVars, _Prompt, _Scope, _SgnVars, _Top, ___34))), 'setarg'(2, ___24, '.'(___25, ___26)))))), '<module>:emop.top@0:$init0'('env'(___27, _ParentVars, _Prompt, _Scope, _SgnVars, _Top, ___34), __36CutLevel)))))))).
':-'('<module>:emop.top:new$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.top:new'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.top@0'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.top@0:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.top@0'('import'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.top@0:import'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.top@0'('prompt'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.top@0:prompt'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.top@0'('loop', __36env, _, __36CutLevel), ','('!', '<module>:emop.top@0:loop'(__36env, __36CutLevel))).
':-'('<module>:emop.top@0'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.top@0$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.top@0$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.top@0$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.top@0$has_predicate'('import'(_____1)), 'true').
':-'('<module>:emop.top@0$has_predicate'('prompt'(_____1)), 'true').
':-'('<module>:emop.top@0$has_predicate'('loop'), 'true').
':-'('<module>:emop.top@0:$init0'('env'(___27, _ParentVars, _Prompt, _Scope, _SgnVars, _Top, ___34), __36CutLevel), ','(','('true', ','(';'('->'('var'(___28), ','('g_inc'('$module_count', ___29), '='(___28, '$module'(___29, '.'('<module>:emop.top@1'('env'(___28, _Prompt, ___27)), '[]'), '.'(___28, '[]'))))), ','('='(___28, '$module'(___29, ___30, _)), ','('='('.'(___31, ___32), ___30), ','('setarg'(1, ___30, '<module>:emop.top@1'('env'(___28, _Prompt, ___27))), 'setarg'(2, ___30, '.'(___31, ___32)))))), '<module>:emop.top@1:$init1'('env'(___33, _Prompt, ___27), __36CutLevel))), '='(___34, ___28))).
':-'('<module>:emop.top@0:$sgn'(__36sgn, 'env'(___27, _ParentVars, _Prompt, _Scope, _SgnVars, _Top, ___34), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/top.mpl',291,12,285)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/top.mpl',303,12,285)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','('true', '<module>:emop.top@0:atom_fresh_[4543]'(_atom__fresh___914544_93, __36Pb, __36Pe)), '<module>:emop.top@0:atom_fresh_[4545]'(_atom__fresh___914546_93, __36Pb, __36Pe)), '<module>:emop.top@0:atom_fresh_[4547]'(_atom__fresh___914548_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___914548_93, '.'(_atom__fresh___914546_93, '.'(_atom__fresh___914544_93, '[]'))))))))).
':-'('<module>:emop.top@0:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.top@0:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.top@0:atom_fresh_[4543]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(loop, 0, predicate, suspended([],[call(scope,catch,[none,none,none])]), __36pos))).
':-'('<module>:emop.top@0:atom_fresh_[4545]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(prompt, 1, predicate, suspended([var('Prompt')],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.top@0:atom_fresh_[4547]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(import, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.top@0:import'(_M, 'env'(___27, _ParentVars, _Prompt, _Scope, _SgnVars, _Top, ___34), __36CutLevel), ','(','('='(_SgnList, ___42), ','(','('true', ';'('->'('var'(___36), ','('g_inc'('$module_count', ___37), '='(___36, '$module'(___37, '.'('<module>:emop.top@2'('env'(___36, _ParentVars, _Prompt, _Scope, _SgnVars, _Top, _M, _Old, _Sgn, _SgnList, _V, _Var, ___27)), '[]'), '.'(___36, '[]'))))), ','('='(___36, '$module'(___37, ___38, _)), ','('='('.'(___39, ___40), ___38), ','('setarg'(1, ___38, '<module>:emop.top@2'('env'(___36, _ParentVars, _Prompt, _Scope, _SgnVars, _Top, _M, _Old, _Sgn, _SgnList, _V, _Var, ___27))), 'setarg'(2, ___38, '.'(___39, ___40))))))), ','('g_read'('control.iter', '<module>:control.iter'(___43)), '<module>:control.iter:findall$direct'(___36, ___42, ___43)))), ','(','('='(_Sgn, ___45), ','('g_read'('data.list', '<module>:data.list'(___46)), '<module>:data.list:flatten$direct'(_SgnList, ___45, ___46))), ','(','('='(_Var, ___48), ','('g_read'('emop.parser', '<module>:emop.parser'(___49)), '<module>:emop.parser:fresh_var$direct'(___48, ___49))), ','('='(_Var, 'var'(_V)), ','(','('='(___51, _M), 'emop_call'(_ParentVars, '{}'(_V, ___51), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/top.mpl\", line 228, from character 23 to 24')), ','(','('='(___52, _Sgn), 'emop_call'(_SgnVars, '{}'(_V, ___52), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/top.mpl\", line 229, from character 20 to 21')), ','(','('='(_Old, ___53), 'emop_call'(_Scope, 'get'(___53), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/top.mpl\", line 230, from character 24 to 27')), ','(','('g_read'('emop.expand', '<module>:emop.expand'(___56)), '<module>:emop.expand:make_scope$direct'(_Var, _Sgn, _Old, ___55, ___56)), 'emop_call'(_Scope, 'set'('.'(___55, _Old)), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/top.mpl\", line 231, from character 18 to 21')))))))))).
':-'('<module>:emop.top@0:import$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.top@0:import'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.top@0:loop'('env'(___27, _ParentVars, _Prompt, _Scope, _SgnVars, _Top, ___34), __36CutLevel), 'catch'('catch'(','('emop_call'(_Scope, 'get'(___58), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/top.mpl\", line 238, from character 53 to 56'), 'emop_call'(___34, 'loop'(0, _ParentVars, _SgnVars, ___58), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/top.mpl\", line 238, from character 18 to 22')), 'backtrack', 'true'), 'end_of_file', 'true')).
':-'('<module>:emop.top@0:loop$direct'(__36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.top@0:loop'(__36env, __36CutLevel))).
':-'('<module>:emop.top@0:prompt'(_Prompt, 'env'(___27, _ParentVars, _Prompt, _Scope, _SgnVars, _Top, ___34), __36CutLevel), 'true').
':-'('<module>:emop.top@0:prompt$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.top@0:prompt'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.top@1'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.top@1:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.top@1'('read_line'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.top@1:read_line'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.top@1'('read_line'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.top@1:read_line'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.top@1'('update'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.top@1:update'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.top@1'('prompt_goal'(_____7, _____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.top@1:prompt_goal'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.top@1'('execute_directive'(_____7, _____6, _____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.top@1:execute_directive'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.top@1'('print_store'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.top@1:print_store'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.top@1'('loop'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.top@1:loop'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.top@1'('init_vars'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.top@1:init_vars'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.top@1'('prompt_and_execute'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.top@1:prompt_and_execute'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.top@1'('loop_succ'(_____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.top@1:loop_succ'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.top@1'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.top@1$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.top@1$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.top@1$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.top@1$has_predicate'('read_line'(_____2, _____1)), 'true').
':-'('<module>:emop.top@1$has_predicate'('read_line'(_____1)), 'true').
':-'('<module>:emop.top@1$has_predicate'('update'(_____1)), 'true').
':-'('<module>:emop.top@1$has_predicate'('prompt_goal'(_____7, _____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.top@1$has_predicate'('execute_directive'(_____7, _____6, _____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.top@1$has_predicate'('print_store'(_____1)), 'true').
':-'('<module>:emop.top@1$has_predicate'('loop'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.top@1$has_predicate'('init_vars'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.top@1$has_predicate'('prompt_and_execute'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.top@1$has_predicate'('loop_succ'(_____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.top@1:$init1'('env'(___33, _Prompt, ___27), __36CutLevel), 'true').
':-'('<module>:emop.top@1:$sgn'(__36sgn, 'env'(___33, _Prompt, ___27), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/top.mpl',321,13,304)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/top.mpl',338,13,304)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','(','(','(','(','(','(','(','('true', '<module>:emop.top@1:atom_fresh_[4551]'(_atom__fresh___914552_93, __36Pb, __36Pe)), '<module>:emop.top@1:atom_fresh_[4553]'(_atom__fresh___914554_93, __36Pb, __36Pe)), '<module>:emop.top@1:atom_fresh_[4555]'(_atom__fresh___914556_93, __36Pb, __36Pe)), '<module>:emop.top@1:atom_fresh_[4557]'(_atom__fresh___914558_93, __36Pb, __36Pe)), '<module>:emop.top@1:atom_fresh_[4559]'(_atom__fresh___914560_93, __36Pb, __36Pe)), '<module>:emop.top@1:atom_fresh_[4561]'(_atom__fresh___914562_93, __36Pb, __36Pe)), '<module>:emop.top@1:atom_fresh_[4563]'(_atom__fresh___914564_93, __36Pb, __36Pe)), '<module>:emop.top@1:atom_fresh_[4565]'(_atom__fresh___914566_93, __36Pb, __36Pe)), '<module>:emop.top@1:atom_fresh_[4567]'(_atom__fresh___914568_93, __36Pb, __36Pe)), '<module>:emop.top@1:atom_fresh_[4569]'(_atom__fresh___914570_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___914570_93, '.'(_atom__fresh___914568_93, '.'(_atom__fresh___914566_93, '.'(_atom__fresh___914564_93, '.'(_atom__fresh___914562_93, '.'(_atom__fresh___914560_93, '.'(_atom__fresh___914558_93, '.'(_atom__fresh___914556_93, '.'(_atom__fresh___914554_93, '.'(_atom__fresh___914552_93, '[]')))))))))))))))).
':-'('<module>:emop.top@1:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.top@1:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.top@1:atom_fresh_[4551]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(loop_succ, 5, predicate, suspended([var('Det'),var('Level'),var('NewVars'),var('SgnVars'),var('Scope')],[call(scope,catch,[none,none,none])]), __36pos))).
':-'('<module>:emop.top@1:atom_fresh_[4553]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(prompt_and_execute, 4, predicate, suspended([var('Level'),var('ParentVars'),var('SgnVars'),var('Scope')],[call(scope,catch,[none,none,none]),call(scope,catch,[none,var('E'),none])]), __36pos))).
':-'('<module>:emop.top@1:atom_fresh_[4555]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(init_vars, 3, predicate, suspended([var('Vars'),var('NewVars'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.top@1:atom_fresh_[4557]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(loop, 4, predicate, '[]', __36pos))).
':-'('<module>:emop.top@1:atom_fresh_[4559]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(print_store, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.top@1:atom_fresh_[4561]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(execute_directive, 7, predicate, '[]', __36pos))).
':-'('<module>:emop.top@1:atom_fresh_[4563]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(prompt_goal, 7, predicate, '[]', __36pos))).
':-'('<module>:emop.top@1:atom_fresh_[4565]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(update, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.top@1:atom_fresh_[4567]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(read_line, 1, predicate, suspended([none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.top@1:atom_fresh_[4569]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(read_line, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.top@1:execute_directive'(_Directive, _ParentVars, _SgnVars, _Scope, _NewScope, _Vars, _M, 'env'(___33, _Prompt, ___27), __36CutLevel), ';'('->'('='(_Directive, 'special'('import', _S, _Pb, _Pe)), ','(','('emop_call'(___33, 'update'(___111), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/top.mpl\", line 94, from character 49 to 55'), 'emop_call'(_ParentVars, 'keys'(___112), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/top.mpl\", line 94, from character 68 to 72')), ','('g_read'('emop.compile', '<module>:emop.compile'(___113)), '<module>:emop.compile:import$direct'(_S, _Pb, _Pe, ___111, ___112, _SgnVars, _Scope, _NewScope, _Vars, _M, ___113)))), ';'('->'('='(_Directive, 'special'('abstract', _, _Pb, _Pe)), 'throw'('error'('Directive abstract cannot be used outside a module', 'file'(_Pb, _Pe)))), ','(','('g_read'('emop.sgn', '<module>:emop.sgn'(___120)), '<module>:emop.sgn:directive_sgn$direct'(_Directive, '[]', _Sgn, ___120)), ','(','('='(_NewScope, '.'(___123, _Scope)), ','('g_read'('emop.expand', '<module>:emop.expand'(___124)), '<module>:emop.expand:make_scope$direct'('', _Sgn, _Scope, ___123, ___124))), ','(','('='(_M, ___126), ','('true', ';'('->'('var'(___126), ','('g_inc'('$module_count', ___127), '='(___126, '$module'(___127, '.'('<module>:emop.top@4'('env'(___126, _Prompt, _Directive, _M, _NewScope, _ParentVars, _Pb, _Pe, _S, _Scope, _Sgn, _SgnVars, _Vars, ___33, ___27)), '[]'), '.'(___126, '[]'))))), ','('='(___126, '$module'(___127, ___128, _)), ','('='('.'(___129, ___130), ___128), ','('setarg'(1, ___128, '<module>:emop.top@4'('env'(___126, _Prompt, _Directive, _M, _NewScope, _ParentVars, _Pb, _Pe, _S, _Scope, _Sgn, _SgnVars, _Vars, ___33, ___27))), 'setarg'(2, ___128, '.'(___129, ___130)))))))), '='(_Vars, _ParentVars))))))).
':-'('<module>:emop.top@1:execute_directive$direct'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.top@1:execute_directive'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.top@1:init_vars'(_Vars, _NewVars, ___163, 'env'(___33, _Prompt, ___27), __36CutLevel), ','(','('true', ';'('->'('var'(___157), ','('g_inc'('$module_count', ___158), '='(___157, '$module'(___158, '.'('<module>:emop.top@7'('env'(___157, _Prompt, _NewVars, _Vars, ___33, ___27)), '[]'), '.'(___157, '[]'))))), ','('='(___157, '$module'(___158, ___159, _)), ','('='('.'(___160, ___161), ___159), ','('setarg'(1, ___159, '<module>:emop.top@7'('env'(___157, _Prompt, _NewVars, _Vars, ___33, ___27))), 'setarg'(2, ___159, '.'(___160, ___161))))))), ','('g_read'('data.list', '<module>:data.list'(___164)), '<module>:data.list:map$direct'(_Vars, ___157, ___163, ___164)))).
':-'('<module>:emop.top@1:init_vars$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.top@1:init_vars'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.top@1:loop'(_Level, _ParentVars, _SgnVars, _Scope, 'env'(___33, _Prompt, ___27), __36CutLevel), '->'(','('repeat', 'emop_call'(___33, 'prompt_and_execute'(_Level, _ParentVars, _SgnVars, _Scope), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/top.mpl\", line 143, from character 18 to 36')), 'true')).
':-'('<module>:emop.top@1:loop$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.top@1:loop'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.top@1:loop_succ'(_Det, _Level, _NewVars, _SgnVars, _Scope, 'env'(___33, _Prompt, ___27), __36CutLevel), 'catch'('emop_call'(___33, 'loop'(_Level, _NewVars, _SgnVars, _Scope), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/top.mpl\", line 208, from character 18 to 22'), 'other', ';'('->'('='(_Det, 'true'), ','(','('g_read'('io.std', '<module>:io.std'(___202)), '<module>:io.std:print_endline$direct'('There is no other solution.', ___202)), 'emop_call'(___33, 'loop_succ'(_Det, _Level, _NewVars, _SgnVars, _Scope), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/top.mpl\", line 214, from character 21 to 30'))), 'fail'))).
':-'('<module>:emop.top@1:loop_succ$direct'(_____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.top@1:loop_succ'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.top@1:print_store'(_Vars, 'env'(___33, _Prompt, ___27), __36CutLevel), ';'(','(','('='(_Names, ___135), ','('emop_call'(_Vars, 'keys'(___133), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/top.mpl\", line 108, from character 52 to 56'), ','('g_read'('data.list', '<module>:data.list'(___136)), '<module>:data.list:merge_sort$direct'(___133, 'data.term', ___135, ___136)))), ','(','(','(','('g_read'('data.list', '<module>:data.list'(___140)), '<module>:data.list:reverse$direct'(_Names, ___139, ___140)), ','('true', ';'('->'('var'(___141), ','('g_inc'('$module_count', ___142), '='(___141, '$module'(___142, '.'('<module>:emop.top@5'('env'(___141, _Prompt, _Names, _Vars, ___33, ___27)), '[]'), '.'(___141, '[]'))))), ','('='(___141, '$module'(___142, ___143, _)), ','('='('.'(___144, ___145), ___143), ','('setarg'(1, ___143, '<module>:emop.top@5'('env'(___141, _Prompt, _Names, _Vars, ___33, ___27))), 'setarg'(2, ___143, '.'(___144, ___145)))))))), ','('g_read'('data.list', '<module>:data.list'(___147)), '<module>:data.list:iter$direct'(___139, ___141, ___147))), ','(','(','('true', ';'('->'('var'(___149), ','('g_inc'('$module_count', ___150), '='(___149, '$module'(___150, '.'('<module>:emop.top@6'('env'(___149, _Prompt, _Names, _Vars, ___33, ___27)), '[]'), '.'(___149, '[]'))))), ','('='(___149, '$module'(___150, ___151, _)), ','('='('.'(___152, ___153), ___151), ','('setarg'(1, ___151, '<module>:emop.top@6'('env'(___149, _Prompt, _Names, _Vars, ___33, ___27))), 'setarg'(2, ___151, '.'(___152, ___153))))))), ','('g_read'('data.list', '<module>:data.list'(___155)), '<module>:data.list:iter$direct'(_Names, ___149, ___155))), 'fail'))), 'true')).
':-'('<module>:emop.top@1:print_store$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.top@1:print_store'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.top@1:prompt_and_execute'(_Level, _ParentVars, _SgnVars, _Scope, 'env'(___33, _Prompt, ___27), __36CutLevel), ','('catch'(','('='(_M, ___165), 'emop_call'(___33, 'prompt_goal'(_Level, _ParentVars, _SgnVars, _Scope, _NewScope, _Vars, ___165), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/top.mpl\", line 155, from character 22 to 33')), 'empty_line', ';'('->'(','('g_read'('data.number', '<module>:data.number'(___168)), '<module>:data.number:>$direct'(_Level, 0, ___168)), 'throw'('other')), ','(','('g_read'('io.std', '<module>:io.std'(___172)), '<module>:io.std:print_endline$direct'('No goal to enumerate.', ___172)), 'fail'))), 'catch'('catch'(';'(','(','('='(_NewVars, ___173), 'emop_call'(_ParentVars, 'copy'(___173), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/top.mpl\", line 171, from character 45 to 49')), ','('emop_call'(___33, 'init_vars'(_Vars, _NewVars, _Values), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/top.mpl\", line 172, from character 24 to 33'), ','('call_det'(','(','('g_read'('data.term', '<module>:data.term'(___177)), '<module>:data.term:make$direct'('vars', _Values, ___176, ___177)), 'emop_call'(_M, 'do'(___176), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/top.mpl\", line 173, from character 35 to 37')), _Det), ','(','('g_read'('io.std', '<module>:io.std'(___179)), '<module>:io.std:endline$direct'(___179)), ','(';'('->'('='(_Det, 'true'), 'true'), ','('g_read'('io.std', '<module>:io.std'(___183)), '<module>:io.std:print_endline$direct'('There may be more solutions.', ___183))), ','(','('g_read'('data.number', '<module>:data.number'(___186)), '<module>:data.number:succ$direct'(_Level, ___185, ___186)), 'emop_call'(___33, 'loop_succ'(_Det, ___185, _NewVars, _SgnVars, _NewScope), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/top.mpl\", line 182, from character 24 to 33'))))))), ','(','('g_read'('io.err', '<module>:io.err'(___189)), '<module>:io.err:print_endline$direct'('no', ___189)), 'fail')), 'backtrack', ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), 'fail')), _E, ';'('->'('='(_E, 'end_of_file'), 'throw'('end_of_file')), ','(','('g_read'('io.err', '<module>:io.err'(___197)), '<module>:io.err:format$direct'('Uncaught exception: ~q\n', '.'(_E, '[]'), ___197)), 'emop_call'(___33, 'loop'(_Level, _ParentVars, _SgnVars, _Scope), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/top.mpl\", line 201, from character 24 to 28')))))).
':-'('<module>:emop.top@1:prompt_and_execute$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.top@1:prompt_and_execute'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.top@1:prompt_goal'(_Level, _ParentVars, _SgnVars, _Scope, _NewScope, _Vars, _M, 'env'(___33, _Prompt, ___27), __36CutLevel), ','('emop_call'(___33, 'print_store'(_ParentVars), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/top.mpl\", line 64, from character 15 to 26'), ','(','('emop_call'(_Prompt, 'get'(___91), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/top.mpl\", line 65, from character 36 to 39'), ','('g_read'('io.std', '<module>:io.std'(___94)), '<module>:io.std:format$direct'(___91, '.'(_Level, '[]'), ___94))), ','(','('='(_Ast, ___95), 'emop_call'(___33, 'read_line'(___95), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/top.mpl\", line 66, from character 21 to 30')), ';'('->'('catch'(';'('->'(','('='(_Directive, ___97), ','('g_read'('emop.sgn', '<module>:emop.sgn'(___98)), '<module>:emop.sgn:directive_syntax$direct'(_Ast, ___97, ___98))), 'emop_call'(___33, 'execute_directive'(_Directive, _ParentVars, _SgnVars, _Scope, _NewScope, _Vars, _M), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/top.mpl\", line 72, from character 24 to 41')), ','(','(','('emop_call'(___33, 'update'(___100), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/top.mpl\", line 74, from character 51 to 57'), 'emop_call'(_ParentVars, 'keys'(___101), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/top.mpl\", line 74, from character 70 to 74')), ','('g_read'('emop.compile', '<module>:emop.compile'(___102)), '<module>:emop.compile:load_ast$direct'(_Ast, ___100, ___101, _SgnVars, _Scope, _Vars, _M, ___102))), '='(_NewScope, _Scope))), _E, ','(','('g_read'('emop.message', '<module>:emop.message'(___104)), '<module>:emop.message:error$direct'(_E, ___104)), 'emop_call'(___33, 'prompt_goal'(_Level, _ParentVars, _SgnVars, _Scope, _NewScope, _Vars, _M), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/top.mpl\", line 80, from character 24 to 35'))), 'true'), ','(','('g_read'('io.err', '<module>:io.err'(___107)), '<module>:io.err:print_endline$direct'('top-level bug', ___107)), 'fail')))))).
':-'('<module>:emop.top@1:prompt_goal$direct'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.top@1:prompt_goal'(_____7, _____6, _____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.top@1:read_line'(___83, 'env'(___33, _Prompt, ___27), __36CutLevel), 'emop_call'(___33, 'read_line'('', ___83), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/top.mpl\", line 40, from character 24 to 33')).
':-'('<module>:emop.top@1:read_line'(_Acc, _Ast, 'env'(___33, _Prompt, ___27), __36CutLevel), ','(','('='(_Line, ___67), ','(','('g_read'('io.std', '<module>:io.std'(___66)), '<module>:io.std:read_line$direct'(___65, ___66)), ','('g_read'('data.atom', '<module>:data.atom'(___68)), '<module>:data.atom:concat$direct'(_Acc, ___65, ___67, ___68)))), ','(';'('->'('='(_Line, ''), 'throw'('empty_line')), ';'('->'('='(_Line, 'backtrack'), 'throw'('backtrack')), 'true')), ';'('->'(','('='(_Ast, ___80), ','(','('g_read'('data.atom', '<module>:data.atom'(___78)), '<module>:data.atom:stream$direct'(_Line, ___77, ___78)), ','('g_read'('emop.parser', '<module>:emop.parser'(___81)), '<module>:emop.parser:parse_stream$direct'('', 'toplevel', ___77, 'emop.sgn', ___80, ___81)))), 'true'), 'emop_call'(___33, 'read_line'(_Line, _Ast), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/top.mpl\", line 37, from character 18 to 27'))))).
':-'('<module>:emop.top@1:read_line$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.top@1:read_line'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.top@1:read_line$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.top@1:read_line'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.top@1:update'(___84, 'env'(___33, _Prompt, ___27), __36CutLevel), ','('true', ';'('->'('var'(___84), ','('g_inc'('$module_count', ___85), '='(___84, '$module'(___85, '.'('<module>:emop.top@3'('env'(___84, _Prompt, ___33, ___27)), '[]'), '.'(___84, '[]'))))), ','('='(___84, '$module'(___85, ___86, _)), ','('='('.'(___87, ___88), ___86), ','('setarg'(1, ___86, '<module>:emop.top@3'('env'(___84, _Prompt, ___33, ___27))), 'setarg'(2, ___86, '.'(___87, ___88)))))))).
':-'('<module>:emop.top@1:update$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.top@1:update'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.top@2'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.top@2:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.top@2'('do'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.top@2:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.top@2'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.top@2$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.top@2$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.top@2$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.top@2$has_predicate'('do'(_____1)), 'true').
':-'('<module>:emop.top@2:$sgn'(__36sgn, 'env'(___41, _ParentVars, _Prompt, _Scope, _SgnVars, _Top, _M, _Old, _Sgn, _SgnList, _V, _Var, ___27), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/top.mpl',7487,221,7452)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/top.mpl',7498,221,7452)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.top@2:atom_fresh_[4549]'(_atom__fresh___914550_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___914550_93, '[]'))))))).
':-'('<module>:emop.top@2:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.top@2:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.top@2:atom_fresh_[4549]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 1, predicate, suspended([none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.top@2:do'(___61, 'env'(___41, _ParentVars, _Prompt, _Scope, _SgnVars, _Top, _M, _Old, _Sgn, _SgnList, _V, _Var, ___27), __36CutLevel), 'emop_call'(_M, '$sgn'(___61), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/top.mpl\", line 223, from character 22 to 28')).
':-'('<module>:emop.top@2:do$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.top@2:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.top@3'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.top@3:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.top@3'('update'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.top@3:update'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.top@3'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.top@3$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.top@3$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.top@3$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.top@3$has_predicate'('update'(_____1)), 'true').
':-'('<module>:emop.top@3:$sgn'(__36sgn, 'env'(___89, _Prompt, ___33, ___27), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/top.mpl',1106,41,1085)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/top.mpl',1114,41,1085)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.top@3:atom_fresh_[4579]'(_atom__fresh___914580_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___914580_93, '[]'))))))).
':-'('<module>:emop.top@3:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.top@3:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.top@3:atom_fresh_[4579]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(update, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.top@3:update'(_Filename, 'env'(___89, _Prompt, ___33, ___27), __36CutLevel), ','(','('g_read'('io.std', '<module>:io.std'(___222)), '<module>:io.std:format$direct'('The file \'~a\' has changed.  Reload? (y/n) ', '.'(_Filename, '[]'), ___222)), ','('repeat', ','(','('='(_Answer, ___224), ','('g_read'('io.std', '<module>:io.std'(___225)), '<module>:io.std:read_line$direct'(___224, ___225))), ';'('->'('='(_Answer, 'y'), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), 'true')), ';'('->'('='(_Answer, 'n'), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), 'fail')), ','(','('g_read'('io.std', '<module>:io.std'(___230)), '<module>:io.std:print$direct'('Please answer \"y\" or \"n\". ', ___230)), 'fail'))))))).
':-'('<module>:emop.top@3:update$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.top@3:update'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.top@4'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.top@4:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.top@4'('do'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.top@4:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.top@4'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.top@4$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.top@4$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.top@4$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.top@4$has_predicate'('do'(_____1)), 'true').
':-'('<module>:emop.top@4:$sgn'(__36sgn, 'env'(___131, _Prompt, _Directive, _M, _NewScope, _ParentVars, _Pb, _Pe, _S, _Scope, _Sgn, _SgnVars, _Vars, ___33, ___27), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/top.mpl',3434,101,3412)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/top.mpl',3442,101,3412)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.top@4:atom_fresh_[4577]'(_atom__fresh___914578_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___914578_93, '[]'))))))).
':-'('<module>:emop.top@4:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.top@4:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.top@4:atom_fresh_[4577]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.top@4:do'(_, 'env'(___131, _Prompt, _Directive, _M, _NewScope, _ParentVars, _Pb, _Pe, _S, _Scope, _Sgn, _SgnVars, _Vars, ___33, ___27), __36CutLevel), 'true').
':-'('<module>:emop.top@4:do$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.top@4:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.top@5'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.top@5:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.top@5'('do'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.top@5:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.top@5'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.top@5$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.top@5$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.top@5$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.top@5$has_predicate'('do'(_____1)), 'true').
':-'('<module>:emop.top@5:$sgn'(__36sgn, 'env'(___146, _Prompt, _Names, _Vars, ___33, ___27), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/top.mpl',3668,108,3640)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/top.mpl',3700,108,3640)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.top@5:atom_fresh_[4575]'(_atom__fresh___914576_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___914576_93, '[]'))))))).
':-'('<module>:emop.top@5:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.top@5:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.top@5:atom_fresh_[4575]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.top@5:do'(_Var, 'env'(___146, _Prompt, _Names, _Vars, ___33, ___27), __36CutLevel), ','(','('='(___216, 'var'(_Value)), 'emop_call'(_Vars, '{}'(_Var, ___216), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/top.mpl\", line 111, from character 29 to 30')), ';'('->'('='(_Value, _Var), 'true'), 'true'))).
':-'('<module>:emop.top@5:do$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.top@5:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.top@6'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.top@6:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.top@6'('do'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.top@6:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.top@6'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.top@6$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.top@6$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.top@6$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.top@6$has_predicate'('do'(_____1)), 'true').
':-'('<module>:emop.top@6:$sgn'(__36sgn, 'env'(___154, _Prompt, _Names, _Vars, ___33, ___27), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/top.mpl',4041,119,4013)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/top.mpl',4054,119,4013)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.top@6:atom_fresh_[4573]'(_atom__fresh___914574_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___914574_93, '[]'))))))).
':-'('<module>:emop.top@6:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.top@6:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.top@6:atom_fresh_[4573]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.top@6:do'(_Var, 'env'(___154, _Prompt, _Names, _Vars, ___33, ___27), __36CutLevel), ','(','('='(___205, 'var'(_Value)), 'emop_call'(_Vars, '{}'(_Var, ___205), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/top.mpl\", line 122, from character 29 to 30')), ';'('->'(';'('='(_Value, _Var), ','('g_read'('data.atom', '<module>:data.atom'(___209)), '<module>:data.atom:sub$direct'(_Var, 0, 1, _, '_', ___209))), 'true'), ','('g_read'('io.std', '<module>:io.std'(___215)), '<module>:io.std:format$direct'('~a = ~p\n', '.'(_Var, '.'(_Value, '[]')), ___215))))).
':-'('<module>:emop.top@6:do$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.top@6:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.top@7'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.top@7:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.top@7'('do'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.top@7:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.top@7'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.top@7$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.top@7$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.top@7$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.top@7$has_predicate'('do'(_____2, _____1)), 'true').
':-'('<module>:emop.top@7:$sgn'(__36sgn, 'env'(___162, _Prompt, _NewVars, _Vars, ___33, ___27), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/top.mpl',4942,147,4893)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/top.mpl',4953,147,4893)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.top@7:atom_fresh_[4571]'(_atom__fresh___914572_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___914572_93, '[]'))))))).
':-'('<module>:emop.top@7:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.top@7:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.top@7:atom_fresh_[4571]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.top@7:do'(_Var, _Value, 'env'(___162, _Prompt, _NewVars, _Vars, ___33, ___27), __36CutLevel), ','('='(___203, 'var'(_Value)), 'emop_call'(_NewVars, '{}'(_Var, ___203), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/top.mpl\", line 150, from character 26 to 27'))).
':-'('<module>:emop.top@7:do$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.top@7:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('emop.top@init', ','('true', 'g_link'('emop.top', '<module>:emop.top'('env')))).
':-'('dynamic'('/'('<module>:emop.unionfind$dynamic', 4))).
':-'('<module>:emop.unionfind'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.unionfind:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.unionfind'('get_root'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.unionfind:get_root'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.unionfind'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.unionfind$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.unionfind$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.unionfind$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.unionfind$has_predicate'('get_root'(_____2, _____1)), 'true').
':-'('<module>:emop.unionfind:$sgn'(__36sgn, 'env', __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/unionfind.mpl',0,0,0)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/unionfind.mpl',23,0,0)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.unionfind:atom_fresh_[4329]'(_atom__fresh___914330_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___914330_93, '[]'))))))).
':-'('<module>:emop.unionfind:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.unionfind:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.unionfind:atom_fresh_[4329]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(get_root, 2, predicate, suspended([var('Var'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.unionfind:get_root'(_Var, ___5, 'env', __36CutLevel), ','(','('='(___9, ___4), 'emop_call'(_Var, 'get'(___9), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/unionfind.mpl\", line 3, from character 10 to 13')), ';'('->'('='(___4, 'root'(___6)), '='(___5, _Var)), ','('='(___5, ___12), ','('='(___4, ___7), ','('->'(','('='(___8, _Parent), '='(___7, 'link'(___8))), 'true'), ','('g_read'('emop.unionfind', '<module>:emop.unionfind'(___13)), '<module>:emop.unionfind:get_root$direct'(_Parent, ___12, ___13)))))))).
':-'('<module>:emop.unionfind:get_root$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.unionfind:get_root'(_____2, _____1, __36env, __36CutLevel))).
':-'('emop.unionfind@init', ','('true', 'g_link'('emop.unionfind', '<module>:emop.unionfind'('env')))).
':-'('dynamic'('/'('<module>:emop.writer$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.writer@4$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.writer@3$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.writer@2$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.writer@1$dynamic', 4))).
':-'('dynamic'('/'('<module>:emop.writer@0$dynamic', 4))).
':-'('<module>:emop.writer'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.writer:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.writer'('number'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.writer:number'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.writer'('term'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.writer:term'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.writer'('args'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.writer:args'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.writer'('var'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.writer:var'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.writer'('callable'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.writer:callable'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.writer'('callable'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.writer:callable'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.writer'('condition'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.writer:condition'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.writer'('sequence'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.writer:sequence'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.writer'('write'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.writer:write'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.writer'('write_clauses'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.writer:write_clauses'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.writer'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.writer$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.writer$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.writer$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.writer$has_predicate'('number'(_____2, _____1)), 'true').
':-'('<module>:emop.writer$has_predicate'('term'(_____2, _____1)), 'true').
':-'('<module>:emop.writer$has_predicate'('args'(_____2, _____1)), 'true').
':-'('<module>:emop.writer$has_predicate'('var'(_____2, _____1)), 'true').
':-'('<module>:emop.writer$has_predicate'('callable'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.writer$has_predicate'('callable'(_____2, _____1)), 'true').
':-'('<module>:emop.writer$has_predicate'('condition'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:emop.writer$has_predicate'('sequence'(_____2, _____1)), 'true').
':-'('<module>:emop.writer$has_predicate'('write'(_____2, _____1)), 'true').
':-'('<module>:emop.writer$has_predicate'('write_clauses'(_____2, _____1)), 'true').
':-'('<module>:emop.writer:$sgn'(__36sgn, 'env', __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/writer.mpl',0,0,0)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/writer.mpl',22,0,0)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','(','(','(','(','(','(','(','('true', '<module>:emop.writer:atom_fresh_[4483]'(_atom__fresh___914484_93, __36Pb, __36Pe)), '<module>:emop.writer:atom_fresh_[4485]'(_atom__fresh___914486_93, __36Pb, __36Pe)), '<module>:emop.writer:atom_fresh_[4487]'(_atom__fresh___914488_93, __36Pb, __36Pe)), '<module>:emop.writer:atom_fresh_[4489]'(_atom__fresh___914490_93, __36Pb, __36Pe)), '<module>:emop.writer:atom_fresh_[4491]'(_atom__fresh___914492_93, __36Pb, __36Pe)), '<module>:emop.writer:atom_fresh_[4493]'(_atom__fresh___914494_93, __36Pb, __36Pe)), '<module>:emop.writer:atom_fresh_[4495]'(_atom__fresh___914496_93, __36Pb, __36Pe)), '<module>:emop.writer:atom_fresh_[4497]'(_atom__fresh___914498_93, __36Pb, __36Pe)), '<module>:emop.writer:atom_fresh_[4499]'(_atom__fresh___914500_93, __36Pb, __36Pe)), '<module>:emop.writer:atom_fresh_[4501]'(_atom__fresh___914502_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___914502_93, '.'(_atom__fresh___914500_93, '.'(_atom__fresh___914498_93, '.'(_atom__fresh___914496_93, '.'(_atom__fresh___914494_93, '.'(_atom__fresh___914492_93, '.'(_atom__fresh___914490_93, '.'(_atom__fresh___914488_93, '.'(_atom__fresh___914486_93, '.'(_atom__fresh___914484_93, '[]')))))))))))))))).
':-'('<module>:emop.writer:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.writer:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.writer:args'(___8, ___9, 'env', __36CutLevel), '=..'(___9, '.'('args', '.'(___8, '[]')))).
':-'('<module>:emop.writer:args$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.writer:args'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.writer:atom_fresh_[4483]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(write_clauses, 2, predicate, suspended([var('S'),var('C')],[module('Write_clause',[symbol(do,1,predicate,suspended([var('Clause')],[call(scope,catch,[none,var('E'),none]),call(var('S'),print_endline,[none])]),file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/writer.mpl',2473,91,2453),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/writer.mpl',2653,97,2620)))]),call(atom('data.list'),iter,[var('C'),var('Write_clause')])]), __36pos))).
':-'('<module>:emop.writer:atom_fresh_[4485]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(write, 2, predicate, suspended([var('S'),var('P')],[module('Writer',[symbol(write,1,predicate,[none],file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/writer.mpl',518,18,493),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/writer.mpl',1423,51,1409))),symbol(write_args,1,predicate,[none],file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/writer.mpl',1876,68,1852),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/writer.mpl',1881,68,1852)))]),module('Output_char',[symbol(do,1,predicate,suspended([var('Char')],[call(atom('data.char'),escape,[var('Char'),var('Escape')]),call(var('S'),print,[var('Escape')])]),file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/writer.mpl',2161,78,2143),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/writer.mpl',2236,80,2208)))]),module('Output_arg',[symbol(do,1,predicate,suspended([var('Arg')],[call(var('S'),print,[none]),call(var('Writer'),write,[var('Arg')])]),file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/writer.mpl',2301,83,2284),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/writer.mpl',2361,85,2331)))]),call(var('Writer'),write,[var('P')])]), __36pos))).
':-'('<module>:emop.writer:atom_fresh_[4487]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(sequence, 2, predicate, suspended([none,none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.writer:atom_fresh_[4489]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(condition, 4, predicate, suspended([var('Cond'),var('True'),var('False'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.writer:atom_fresh_[4491]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(callable, 2, predicate, '[]', __36pos))).
':-'('<module>:emop.writer:atom_fresh_[4493]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(callable, 3, constructor, none, __36pos))).
':-'('<module>:emop.writer:atom_fresh_[4495]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(var, 2, constructor, none, __36pos))).
':-'('<module>:emop.writer:atom_fresh_[4497]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(args, 2, constructor, none, __36pos))).
':-'('<module>:emop.writer:atom_fresh_[4499]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(term, 2, constructor, none, __36pos))).
':-'('<module>:emop.writer:atom_fresh_[4501]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(number, 2, constructor, none, __36pos))).
':-'('<module>:emop.writer:callable'(_Term, _P, 'env', __36CutLevel), ','(','('g_read'('data.term', '<module>:data.term'(___17)), '<module>:data.term:decomposition$direct'(_Term, '.'(_F, _Args), ___17)), '='(_P, 'callable'(_F, _Args)))).
':-'('<module>:emop.writer:callable'(___12, ___13, ___14, 'env', __36CutLevel), '=..'(___14, '.'('callable', '.'(___12, '.'(___13, '[]'))))).
':-'('<module>:emop.writer:callable$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.writer:callable'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.writer:callable$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.writer:callable'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.writer:condition'(_Cond, _True, _False, 'callable'(';', '.'('callable'('->', '.'(_Cond, '.'(_True, '[]'))), '.'(_False, '[]'))), 'env', __36CutLevel), 'true').
':-'('<module>:emop.writer:condition$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.writer:condition'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.writer:number'(___4, ___5, 'env', __36CutLevel), '=..'(___5, '.'('number', '.'(___4, '[]')))).
':-'('<module>:emop.writer:number$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.writer:number'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.writer:sequence'('[]', 'true', 'env', __36CutLevel), 'true').
':-'('<module>:emop.writer:sequence'('.'(_H, _T), ___39, 'env', __36CutLevel), ','(','('true', ';'('->'('var'(___33), ','('g_inc'('$module_count', ___34), '='(___33, '$module'(___34, '.'('<module>:emop.writer@0'('env'(___33)), '[]'), '.'(___33, '[]'))))), ','('='(___33, '$module'(___34, ___35, _)), ','('='('.'(___36, ___37), ___35), ','('setarg'(1, ___35, '<module>:emop.writer@0'('env'(___33))), 'setarg'(2, ___35, '.'(___36, ___37))))))), ','('g_read'('data.list', '<module>:data.list'(___40)), '<module>:data.list:fold_left$direct'(_T, _H, ___33, ___39, ___40)))).
':-'('<module>:emop.writer:sequence$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.writer:sequence'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.writer:term'(___6, ___7, 'env', __36CutLevel), '=..'(___7, '.'('term', '.'(___6, '[]')))).
':-'('<module>:emop.writer:term$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.writer:term'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.writer:var'(___10, ___11, 'env', __36CutLevel), '=..'(___11, '.'('var', '.'(___10, '[]')))).
':-'('<module>:emop.writer:var$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.writer:var'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.writer:write'(_S, _P, 'env', __36CutLevel), ','(','('true', ';'('->'('var'(_Writer), ','('g_inc'('$module_count', ___41), '='(_Writer, '$module'(___41, '.'('<module>:emop.writer@1'('env'(_Writer, _S, _Output__char, _Output__arg)), '[]'), '.'(_Writer, '[]'))))), ','('='(_Writer, '$module'(___41, ___42, _)), ','('='('.'(___43, ___44), ___42), ','('setarg'(1, ___42, '<module>:emop.writer@1'('env'(_Writer, _S, _Output__char, _Output__arg))), 'setarg'(2, ___42, '.'(___43, ___44))))))), ','(','('true', ';'('->'('var'(_Output__char), ','('g_inc'('$module_count', ___46), '='(_Output__char, '$module'(___46, '.'('<module>:emop.writer@2'('env'(_Output__char, _S)), '[]'), '.'(_Output__char, '[]'))))), ','('='(_Output__char, '$module'(___46, ___47, _)), ','('='('.'(___48, ___49), ___47), ','('setarg'(1, ___47, '<module>:emop.writer@2'('env'(_Output__char, _S))), 'setarg'(2, ___47, '.'(___48, ___49))))))), ','(','('true', ';'('->'('var'(_Output__arg), ','('g_inc'('$module_count', ___51), '='(_Output__arg, '$module'(___51, '.'('<module>:emop.writer@3'('env'(_Output__arg, _S, _Writer)), '[]'), '.'(_Output__arg, '[]'))))), ','('='(_Output__arg, '$module'(___51, ___52, _)), ','('='('.'(___53, ___54), ___52), ','('setarg'(1, ___52, '<module>:emop.writer@3'('env'(_Output__arg, _S, _Writer))), 'setarg'(2, ___52, '.'(___53, ___54))))))), 'emop_call'(_Writer, 'write'(_P), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/writer.mpl\", line 88, from character 13 to 18'))))).
':-'('<module>:emop.writer:write$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.writer:write'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.writer:write_clauses'(_S, _C, 'env', __36CutLevel), ','(','('true', ';'('->'('var'(_Write__clause), ','('g_inc'('$module_count', ___56), '='(_Write__clause, '$module'(___56, '.'('<module>:emop.writer@4'('env'(_Write__clause, _S)), '[]'), '.'(_Write__clause, '[]'))))), ','('='(_Write__clause, '$module'(___56, ___57, _)), ','('='('.'(___58, ___59), ___57), ','('setarg'(1, ___57, '<module>:emop.writer@4'('env'(_Write__clause, _S))), 'setarg'(2, ___57, '.'(___58, ___59))))))), ','('g_read'('data.list', '<module>:data.list'(___62)), '<module>:data.list:iter$direct'(_C, _Write__clause, ___62)))).
':-'('<module>:emop.writer:write_clauses$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.writer:write_clauses'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.writer@0'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.writer@0:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.writer@0'('do'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.writer@0:do'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.writer@0'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.writer@0$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.writer@0$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.writer@0$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.writer@0$has_predicate'('do'(_____3, _____2, _____1)), 'true').
':-'('<module>:emop.writer@0:$sgn'(__36sgn, 'env'(___38), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/writer.mpl',350,12,332)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/writer.mpl',370,12,332)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.writer@0:atom_fresh_[4513]'(_atom__fresh___914514_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___914514_93, '[]'))))))).
':-'('<module>:emop.writer@0:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.writer@0:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.writer@0:atom_fresh_[4513]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 3, predicate, suspended([var('I'),var('S'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:emop.writer@0:do'(_I, _S, 'callable'(',', '.'(_S, '.'(_I, '[]'))), 'env'(___38), __36CutLevel), 'true').
':-'('<module>:emop.writer@0:do$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.writer@0:do'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:emop.writer@1'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.writer@1:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.writer@1'('write'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.writer@1:write'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.writer@1'('write_args'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.writer@1:write_args'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.writer@1'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.writer@1$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.writer@1$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.writer@1$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.writer@1$has_predicate'('write'(_____1)), 'true').
':-'('<module>:emop.writer@1$has_predicate'('write_args'(_____1)), 'true').
':-'('<module>:emop.writer@1:$sgn'(__36sgn, 'env'(___45, _S, _Output__char, _Output__arg), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/writer.mpl',448,17,442)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/writer.mpl',492,17,442)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','('true', '<module>:emop.writer@1:atom_fresh_[4509]'(_atom__fresh___914510_93, __36Pb, __36Pe)), '<module>:emop.writer@1:atom_fresh_[4511]'(_atom__fresh___914512_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___914512_93, '.'(_atom__fresh___914510_93, '[]')))))))).
':-'('<module>:emop.writer@1:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.writer@1:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.writer@1:atom_fresh_[4509]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(write_args, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.writer@1:atom_fresh_[4511]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(write, 1, predicate, '[]', __36pos))).
':-'('<module>:emop.writer@1:write'('var'(_Var), 'env'(___45, _S, _Output__char, _Output__arg), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','('emop_call'(_S, 'print'('_'), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/writer.mpl\", line 21, from character 14 to 19'), ';'('->'('\\='(_Var, '_'), '->'(';'(','(','('g_read'('data.atom', '<module>:data.atom'(___74)), '<module>:data.atom:sub$direct'(_Var, _, 1, _, _C, ___74)), ','(';'('->'(';'(','(','('g_read'('data.term', '<module>:data.term'(___77)), '<module>:data.term:>=$direct'(_C, 'a', ___77)), ','('g_read'('data.term', '<module>:data.term'(___79)), '<module>:data.term:=<$direct'(_C, 'z', ___79))), ';'(','(','('g_read'('data.term', '<module>:data.term'(___81)), '<module>:data.term:>=$direct'(_C, 'A', ___81)), ','('g_read'('data.term', '<module>:data.term'(___83)), '<module>:data.term:=<$direct'(_C, 'Z', ___83))), ','(','('g_read'('data.term', '<module>:data.term'(___85)), '<module>:data.term:>=$direct'(_C, '0', ___85)), ','('g_read'('data.term', '<module>:data.term'(___87)), '<module>:data.term:=<$direct'(_C, '9', ___87))))), 'emop_call'(_S, 'print'(_C), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/writer.mpl\", line 34, from character 26 to 31')), ';'('->'('='(_C, '_'), 'emop_call'(_S, 'print'('__'), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/writer.mpl\", line 38, from character 26 to 31')), ','('emop_call'(_S, 'print'('_'), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/writer.mpl\", line 40, from character 26 to 31'), ','(','('g_read'('data.char', '<module>:data.char'(___93)), '<module>:data.char:code$direct'(_C, ___92, ___93)), 'emop_call'(_S, 'print'(___92), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/writer.mpl\", line 41, from character 26 to 31'))))), 'fail')), 'true'), 'true')), 'true')))).
':-'('<module>:emop.writer@1:write'('callable'(_F, _Args), 'env'(___45, _S, _Output__char, _Output__arg), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','('emop_call'(_S, 'print'('\''), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/writer.mpl\", line 55, from character 14 to 19'), ','(','('g_read'('data.atom', '<module>:data.atom'(___97)), '<module>:data.atom:string$direct'(_F, _Str, ___97)), ','(','('g_read'('data.list', '<module>:data.list'(___99)), '<module>:data.list:iter$direct'(_Str, _Output__char, ___99)), ','('emop_call'(_S, 'print'('\''), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/writer.mpl\", line 58, from character 14 to 19'), 'emop_call'(___45, 'write_args'(_Args), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/writer.mpl\", line 59, from character 12 to 22'))))))).
':-'('<module>:emop.writer@1:write'('number'(_N), 'env'(___45, _S, _Output__char, _Output__arg), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), 'emop_call'(_S, 'print'(_N), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/writer.mpl\", line 62, from character 14 to 19'))).
':-'('<module>:emop.writer@1:write'('term'(_T), 'env'(___45, _S, _Output__char, _Output__arg), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), 'emop_call'(_S, 'format'('~q', '.'(_T, '[]')), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/writer.mpl\", line 65, from character 14 to 20'))).
':-'('<module>:emop.writer@1:write'(_T, 'env'(___45, _S, _Output__char, _Output__arg), __36CutLevel), 'throw'('write_error'('term'(_T)))).
':-'('<module>:emop.writer@1:write$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.writer@1:write'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.writer@1:write_args'('[]', 'env'(___45, _S, _Output__char, _Output__arg), __36CutLevel), ','('true', ','('='(__36CutLevel, '$cut'), '!'))).
':-'('<module>:emop.writer@1:write_args'('.'(_H, _T), 'env'(___45, _S, _Output__char, _Output__arg), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','('emop_call'(_S, 'print'('('), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/writer.mpl\", line 71, from character 14 to 19'), ','('emop_call'(___45, 'write'(_H), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/writer.mpl\", line 72, from character 12 to 17'), ','(','('g_read'('data.list', '<module>:data.list'(___112)), '<module>:data.list:iter$direct'(_T, _Output__arg, ___112)), 'emop_call'(_S, 'print'(')'), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/writer.mpl\", line 74, from character 14 to 19')))))).
':-'('<module>:emop.writer@1:write_args'(_T, 'env'(___45, _S, _Output__char, _Output__arg), __36CutLevel), 'throw'('write_error'('args'(_T)))).
':-'('<module>:emop.writer@1:write_args$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.writer@1:write_args'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.writer@2'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.writer@2:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.writer@2'('do'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.writer@2:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.writer@2'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.writer@2$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.writer@2$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.writer@2$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.writer@2$has_predicate'('do'(_____1)), 'true').
':-'('<module>:emop.writer@2:$sgn'(__36sgn, 'env'(___50, _S), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/writer.mpl',2118,77,2112)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/writer.mpl',2142,77,2112)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.writer@2:atom_fresh_[4507]'(_atom__fresh___914508_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___914508_93, '[]'))))))).
':-'('<module>:emop.writer@2:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.writer@2:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.writer@2:atom_fresh_[4507]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 1, predicate, suspended([var('Char')],[call(atom('data.char'),escape,[var('Char'),var('Escape')]),call(var('S'),print,[var('Escape')])]), __36pos))).
':-'('<module>:emop.writer@2:do'(_Char, 'env'(___50, _S), __36CutLevel), ','(','('g_read'('data.char', '<module>:data.char'(___69)), '<module>:data.char:escape$direct'(_Char, _Escape, ___69)), 'emop_call'(_S, 'print'(_Escape), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/writer.mpl\", line 81, from character 14 to 19'))).
':-'('<module>:emop.writer@2:do$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.writer@2:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.writer@3'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.writer@3:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.writer@3'('do'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.writer@3:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.writer@3'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.writer@3$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.writer@3$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.writer@3$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.writer@3$has_predicate'('do'(_____1)), 'true').
':-'('<module>:emop.writer@3:$sgn'(__36sgn, 'env'(___55, _S, _Writer), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/writer.mpl',2252,82,2246)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/writer.mpl',2283,82,2246)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.writer@3:atom_fresh_[4505]'(_atom__fresh___914506_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___914506_93, '[]'))))))).
':-'('<module>:emop.writer@3:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.writer@3:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.writer@3:atom_fresh_[4505]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 1, predicate, suspended([var('Arg')],[call(var('S'),print,[none]),call(var('Writer'),write,[var('Arg')])]), __36pos))).
':-'('<module>:emop.writer@3:do'(_Arg, 'env'(___55, _S, _Writer), __36CutLevel), ','('emop_call'(_S, 'print'(', '), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/writer.mpl\", line 85, from character 14 to 19'), 'emop_call'(_Writer, 'write'(_Arg), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/writer.mpl\", line 86, from character 19 to 24'))).
':-'('<module>:emop.writer@3:do$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.writer@3:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.writer@4'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.writer@4:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.writer@4'('do'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:emop.writer@4:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.writer@4'(__36t, __36env, __36pos, __36CutLevel), '<module>:emop.writer@4$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:emop.writer@4$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:emop.writer@4$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:emop.writer@4$has_predicate'('do'(_____1)), 'true').
':-'('<module>:emop.writer@4:$sgn'(__36sgn, 'env'(___60, _S), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/writer.mpl',2427,90,2421)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/writer.mpl',2452,90,2421)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:emop.writer@4:atom_fresh_[4503]'(_atom__fresh___914504_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___914504_93, '[]'))))))).
':-'('<module>:emop.writer@4:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.writer@4:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:emop.writer@4:atom_fresh_[4503]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 1, predicate, suspended([var('Clause')],[call(scope,catch,[none,var('E'),none]),call(var('S'),print_endline,[none])]), __36pos))).
':-'('<module>:emop.writer@4:do'(_Clause, 'env'(___60, _S), __36CutLevel), ','('catch'(','('g_read'('emop.writer', '<module>:emop.writer'(___64)), '<module>:emop.writer:write$direct'(_S, _Clause, ___64)), _E, 'throw'('write_error'(_E, _Clause))), 'emop_call'(_S, 'print_endline'('.'), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/emop/writer.mpl\", line 98, from character 14 to 27'))).
':-'('<module>:emop.writer@4:do$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:emop.writer@4:do'(_____1, __36env, __36CutLevel))).
':-'('emop.writer@init', ','('true', 'g_link'('emop.writer', '<module>:emop.writer'('env')))).
':-'('dynamic'('/'('<module>:io.dir$dynamic', 4))).
':-'('dynamic'('/'('<module>:io.dir@2$dynamic', 4))).
':-'('dynamic'('/'('<module>:io.dir@1$dynamic', 4))).
':-'('dynamic'('/'('<module>:io.dir@0$dynamic', 4))).
':-'('<module>:io.dir'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:io.dir:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.dir'('check'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:io.dir:check'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.dir'('make'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:io.dir:make'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.dir'('delete'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:io.dir:delete'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.dir'('delete_tree'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:io.dir:delete_tree'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.dir'('change'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:io.dir:change'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.dir'('working'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:io.dir:working'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.dir'('current'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:io.dir:current'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.dir'('files'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:io.dir:files'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:io.dir'('temp'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:io.dir:temp'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.dir'('generate_temp'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:io.dir:generate_temp'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:io.dir'('mktemp'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:io.dir:mktemp'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:io.dir'('mktemp'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:io.dir:mktemp'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.dir'(__36t, __36env, __36pos, __36CutLevel), '<module>:io.dir$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:io.dir$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:io.dir$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:io.dir$has_predicate'('check'(_____1)), 'true').
':-'('<module>:io.dir$has_predicate'('make'(_____1)), 'true').
':-'('<module>:io.dir$has_predicate'('delete'(_____1)), 'true').
':-'('<module>:io.dir$has_predicate'('delete_tree'(_____1)), 'true').
':-'('<module>:io.dir$has_predicate'('change'(_____1)), 'true').
':-'('<module>:io.dir$has_predicate'('working'(_____1)), 'true').
':-'('<module>:io.dir$has_predicate'('current'(_____1)), 'true').
':-'('<module>:io.dir$has_predicate'('files'(_____2, _____1)), 'true').
':-'('<module>:io.dir$has_predicate'('temp'(_____1)), 'true').
':-'('<module>:io.dir$has_predicate'('generate_temp'(_____2, _____1)), 'true').
':-'('<module>:io.dir$has_predicate'('mktemp'(_____2, _____1)), 'true').
':-'('<module>:io.dir$has_predicate'('mktemp'(_____1)), 'true').
':-'('<module>:io.dir:$init0'('env', __36CutLevel), 'true').
':-'('<module>:io.dir:$sgn'(__36sgn, 'env', __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/dir.mpl',0,0,0)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/dir.mpl',15,0,0)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','(','(','(','(','(','(','(','(','(','('true', '<module>:io.dir:atom_fresh_[2789]'(_atom__fresh___912790_93, __36Pb, __36Pe)), '<module>:io.dir:atom_fresh_[2791]'(_atom__fresh___912792_93, __36Pb, __36Pe)), '<module>:io.dir:atom_fresh_[2793]'(_atom__fresh___912794_93, __36Pb, __36Pe)), '<module>:io.dir:atom_fresh_[2795]'(_atom__fresh___912796_93, __36Pb, __36Pe)), '<module>:io.dir:atom_fresh_[2797]'(_atom__fresh___912798_93, __36Pb, __36Pe)), '<module>:io.dir:atom_fresh_[2799]'(_atom__fresh___912800_93, __36Pb, __36Pe)), '<module>:io.dir:atom_fresh_[2801]'(_atom__fresh___912802_93, __36Pb, __36Pe)), '<module>:io.dir:atom_fresh_[2803]'(_atom__fresh___912804_93, __36Pb, __36Pe)), '<module>:io.dir:atom_fresh_[2805]'(_atom__fresh___912806_93, __36Pb, __36Pe)), '<module>:io.dir:atom_fresh_[2807]'(_atom__fresh___912808_93, __36Pb, __36Pe)), '<module>:io.dir:atom_fresh_[2809]'(_atom__fresh___912810_93, __36Pb, __36Pe)), '<module>:io.dir:atom_fresh_[2811]'(_atom__fresh___912812_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___912812_93, '.'(_atom__fresh___912810_93, '.'(_atom__fresh___912808_93, '.'(_atom__fresh___912806_93, '.'(_atom__fresh___912804_93, '.'(_atom__fresh___912802_93, '.'(_atom__fresh___912800_93, '.'(_atom__fresh___912798_93, '.'(_atom__fresh___912796_93, '.'(_atom__fresh___912794_93, '.'(_atom__fresh___912792_93, '.'(_atom__fresh___912790_93, '[]')))))))))))))))))).
':-'('<module>:io.dir:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.dir:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.dir:atom_fresh_[2789]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(mktemp, 1, predicate, suspended([none],[call(scope,true,[])]), __36pos))).
':-'('<module>:io.dir:atom_fresh_[2791]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(mktemp, 2, predicate, '[]', __36pos))).
':-'('<module>:io.dir:atom_fresh_[2793]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(generate_temp, 2, predicate, suspended([var('TemplateStr'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:io.dir:atom_fresh_[2795]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(temp, 1, predicate, '[]', __36pos))).
':-'('<module>:io.dir:atom_fresh_[2797]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(files, 2, predicate, suspended([var('Pathname'),var('Files')],[call(atom(kernel),dir_files,[var('Pathname'),var('Files')])]), __36pos))).
':-'('<module>:io.dir:atom_fresh_[2799]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(current, 1, predicate, '[]', __36pos))).
':-'('<module>:io.dir:atom_fresh_[2801]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(working, 1, predicate, suspended([var('Pathname')],[call(atom(kernel),dir_working,[var('Pathname')])]), __36pos))).
':-'('<module>:io.dir:atom_fresh_[2803]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(change, 1, predicate, suspended([var('Pathname')],[call(atom(kernel),dir_change,[var('Pathname')])]), __36pos))).
':-'('<module>:io.dir:atom_fresh_[2805]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(delete_tree, 1, predicate, '[]', __36pos))).
':-'('<module>:io.dir:atom_fresh_[2807]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(delete, 1, predicate, suspended([var('Pathname')],[call(atom(kernel),dir_delete,[var('Pathname')])]), __36pos))).
':-'('<module>:io.dir:atom_fresh_[2809]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(make, 1, predicate, suspended([var('Pathname')],[call(atom(kernel),dir_make,[var('Pathname')])]), __36pos))).
':-'('<module>:io.dir:atom_fresh_[2811]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(check, 1, predicate, '[]', __36pos))).
':-'('<module>:io.dir:change'(_Pathname, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___24)), '<module>:kernel:dir_change$direct'(_Pathname, ___24))).
':-'('<module>:io.dir:change$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.dir:change'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.dir:check'(_Pathname, 'env', __36CutLevel), ','('='(___5, 'directory'), ','('g_read'('io.file', '<module>:io.file'(___6)), '<module>:io.file:type$direct'(_Pathname, ___5, ___6)))).
':-'('<module>:io.dir:check$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.dir:check'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.dir:current'(___27, 'env', __36CutLevel), ','('true', ';'('->'('var'(___27), ','('g_inc'('$module_count', ___28), '='(___27, '$module'(___28, '.'('<module>:io.dir@1'('env'(___27)), '[]'), '.'(___27, '[]'))))), ','('='(___27, '$module'(___28, ___29, _)), ','('='('.'(___30, ___31), ___29), ','('setarg'(1, ___29, '<module>:io.dir@1'('env'(___27))), 'setarg'(2, ___29, '.'(___30, ___31)))))))).
':-'('<module>:io.dir:current$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.dir:current'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.dir:delete'(_Pathname, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___11)), '<module>:kernel:dir_delete$direct'(_Pathname, ___11))).
':-'('<module>:io.dir:delete$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.dir:delete'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.dir:delete_tree'(_Pathname, 'env', __36CutLevel), ','(','(','(','('g_read'('io.dir', '<module>:io.dir'(___14)), '<module>:io.dir:files$direct'(_Pathname, ___13, ___14)), ','('true', ';'('->'('var'(___15), ','('g_inc'('$module_count', ___16), '='(___15, '$module'(___16, '.'('<module>:io.dir@0'('env'(___15, _Pathname)), '[]'), '.'(___15, '[]'))))), ','('='(___15, '$module'(___16, ___17, _)), ','('='('.'(___18, ___19), ___17), ','('setarg'(1, ___17, '<module>:io.dir@0'('env'(___15, _Pathname))), 'setarg'(2, ___17, '.'(___18, ___19)))))))), ','('g_read'('data.list', '<module>:data.list'(___21)), '<module>:data.list:iter$direct'(___13, ___15, ___21))), ','('g_read'('io.dir', '<module>:io.dir'(___22)), '<module>:io.dir:delete$direct'(_Pathname, ___22)))).
':-'('<module>:io.dir:delete_tree$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.dir:delete_tree'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.dir:files'(_Pathname, _Files, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___34)), '<module>:kernel:dir_files$direct'(_Pathname, _Files, ___34))).
':-'('<module>:io.dir:files$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.dir:files'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:io.dir:generate_temp'(_TemplateStr, ___52, 'env', __36CutLevel), ','(','('true', ';'('->'('var'(___46), ','('g_inc'('$module_count', ___47), '='(___46, '$module'(___47, '.'('<module>:io.dir@2'('env'(___46, _TemplateStr)), '[]'), '.'(___46, '[]'))))), ','('='(___46, '$module'(___47, ___48, _)), ','('='('.'(___49, ___50), ___48), ','('setarg'(1, ___48, '<module>:io.dir@2'('env'(___46, _TemplateStr))), 'setarg'(2, ___48, '.'(___49, ___50))))))), ','('g_read'('data.list', '<module>:data.list'(___53)), '<module>:data.list:map$direct'(_TemplateStr, ___46, ___52, ___53)))).
':-'('<module>:io.dir:generate_temp$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.dir:generate_temp'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:io.dir:make'(_Pathname, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___9)), '<module>:kernel:dir_make$direct'(_Pathname, ___9))).
':-'('<module>:io.dir:make$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.dir:make'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.dir:mktemp'(___84, 'env', __36CutLevel), ','(','(','('g_read'('io.dir', '<module>:io.dir'(___80)), '<module>:io.dir:temp$direct'(___79, ___80)), ','('g_read'('data.path', '<module>:data.path'(___83)), '<module>:data.path:concat$direct'(___79, 'tmp.XXXXXXXXXX', ___82, ___83))), ','('g_read'('io.dir', '<module>:io.dir'(___85)), '<module>:io.dir:mktemp$direct'(___82, ___84, ___85)))).
':-'('<module>:io.dir:mktemp'(_Template, _Dir, 'env', __36CutLevel), ';'('->'(','('='(___55, 'windows'), ','('g_read'('sys.os', '<module>:sys.os'(___56)), '<module>:sys.os:type$direct'(___55, ___56))), ','(','('g_read'('data.atom', '<module>:data.atom'(___59)), '<module>:data.atom:string$direct'(_Template, _TemplateStr, ___59)), '->'(','('repeat', ','(','('g_read'('io.dir', '<module>:io.dir'(___60)), '<module>:io.dir:generate_temp$direct'(_TemplateStr, _DirStr, ___60)), ','(','('='(_Dir, ___62), ','('g_read'('data.string', '<module>:data.string'(___63)), '<module>:data.string:atom$direct'(_DirStr, ___62, ___63))), 'catch'(','('g_read'('io.dir', '<module>:io.dir'(___64)), '<module>:io.dir:make$direct'(_Dir, ___64)), _E, ';'('->'(','('='(_E, 'error'('system_error'(_), _)), ','('g_read'('sys.file', '<module>:sys.file'(___68)), '<module>:sys.file:exists$direct'(_Dir, ___68))), 'fail'), 'throw'(_E)))))), 'true'))), ','('='(_Dir, ___76), ','(','('g_read'('data.atom', '<module>:data.atom'(___75)), '<module>:data.atom:format$direct'('mktemp -d ~a', '.'(_Template, '[]'), ___74, ___75)), ','('g_read'('sys.process', '<module>:sys.process'(___77)), '<module>:sys.process:call$direct'(___74, ___76, ___77)))))).
':-'('<module>:io.dir:mktemp$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.dir:mktemp'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.dir:mktemp$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.dir:mktemp'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:io.dir:temp'(_Temp, 'env', __36CutLevel), ';'('->'(','('='(___37, _Temp), ','('g_read'('sys.env', '<module>:sys.env'(___38)), '<module>:sys.env:{}$direct'('TMPDIR', ___37, ___38))), 'true'), ';'('->'(','('='(___41, _Temp), ','('g_read'('sys.env', '<module>:sys.env'(___42)), '<module>:sys.env:{}$direct'('TEMP', ___41, ___42))), 'true'), '='(_Temp, '/tmp')))).
':-'('<module>:io.dir:temp$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.dir:temp'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.dir:working'(_Pathname, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___26)), '<module>:kernel:dir_working$direct'(_Pathname, ___26))).
':-'('<module>:io.dir:working$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.dir:working'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.dir@0'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:io.dir@0:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.dir@0'('do'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:io.dir@0:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.dir@0'(__36t, __36env, __36pos, __36CutLevel), '<module>:io.dir@0$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:io.dir@0$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:io.dir@0$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:io.dir@0$has_predicate'('do'(_____1)), 'true').
':-'('<module>:io.dir@0:$sgn'(__36sgn, 'env'(___20, _Pathname), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/dir.mpl',241,11,225)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/dir.mpl',264,11,225)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:io.dir@0:atom_fresh_[2819]'(_atom__fresh___912820_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___912820_93, '[]'))))))).
':-'('<module>:io.dir@0:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.dir@0:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.dir@0:atom_fresh_[2819]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 1, predicate, '[]', __36pos))).
':-'('<module>:io.dir@0:do'('.', 'env'(___20, _Pathname), __36CutLevel), ','('true', ','('='(__36CutLevel, '$cut'), '!'))).
':-'('<module>:io.dir@0:do'('..', 'env'(___20, _Pathname), __36CutLevel), ','('true', ','('='(__36CutLevel, '$cut'), '!'))).
':-'('<module>:io.dir@0:do'(_Filename, 'env'(___20, _Pathname), __36CutLevel), ','(','('='(_FullFilename, ___115), ','('g_read'('data.path', '<module>:data.path'(___116)), '<module>:data.path:concat$direct'(_Pathname, _Filename, ___115, ___116))), ';'('->'(','('g_read'('io.dir', '<module>:io.dir'(___117)), '<module>:io.dir:check$direct'(_FullFilename, ___117)), ','('g_read'('io.dir', '<module>:io.dir'(___118)), '<module>:io.dir:delete_tree$direct'(_FullFilename, ___118))), ','('g_read'('io.file', '<module>:io.file'(___120)), '<module>:io.file:delete$direct'(_FullFilename, ___120))))).
':-'('<module>:io.dir@0:do$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.dir@0:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.dir@1'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:io.dir@1:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.dir@1'('get'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:io.dir@1:get'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.dir@1'('set'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:io.dir@1:set'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.dir@1'(__36t, __36env, __36pos, __36CutLevel), '<module>:io.dir@1$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:io.dir@1$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:io.dir@1$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:io.dir@1$has_predicate'('get'(_____1)), 'true').
':-'('<module>:io.dir@1$has_predicate'('set'(_____1)), 'true').
':-'('<module>:io.dir@1:$sgn'(__36sgn, 'env'(___32), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/dir.mpl',771,34,758)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/dir.mpl',779,34,758)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','('true', '<module>:io.dir@1:atom_fresh_[2815]'(_atom__fresh___912816_93, __36Pb, __36Pe)), '<module>:io.dir@1:atom_fresh_[2817]'(_atom__fresh___912818_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___912818_93, '.'(_atom__fresh___912816_93, '[]')))))))).
':-'('<module>:io.dir@1:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.dir@1:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.dir@1:atom_fresh_[2815]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(set, 1, predicate, suspended([none],[call(scope,true,[])]), __36pos))).
':-'('<module>:io.dir@1:atom_fresh_[2817]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(get, 1, predicate, suspended([none],[call(scope,true,[])]), __36pos))).
':-'('<module>:io.dir@1:get'(___108, 'env'(___32), __36CutLevel), ','('g_read'('io.dir', '<module>:io.dir'(___109)), '<module>:io.dir:working$direct'(___108, ___109))).
':-'('<module>:io.dir@1:get$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.dir@1:get'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.dir@1:set'(___110, 'env'(___32), __36CutLevel), ','('g_read'('io.dir', '<module>:io.dir'(___111)), '<module>:io.dir:change$direct'(___110, ___111))).
':-'('<module>:io.dir@1:set$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.dir@1:set'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.dir@2'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:io.dir@2:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.dir@2'('do'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:io.dir@2:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:io.dir@2'(__36t, __36env, __36pos, __36CutLevel), '<module>:io.dir@2$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:io.dir@2$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:io.dir@2$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:io.dir@2$has_predicate'('do'(_____2, _____1)), 'true').
':-'('<module>:io.dir@2:$sgn'(__36sgn, 'env'(___51, _TemplateStr), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/dir.mpl',1155,58,1113)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/dir.mpl',1173,58,1113)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:io.dir@2:atom_fresh_[2813]'(_atom__fresh___912814_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___912814_93, '[]'))))))).
':-'('<module>:io.dir@2:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.dir@2:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.dir@2:atom_fresh_[2813]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 2, predicate, suspended([none,none],[call(scope,true,[])]), __36pos))).
':-'('<module>:io.dir@2:do'('X', ___106, 'env'(___51, _TemplateStr), __36CutLevel), ','(','('true', ','('='(__36CutLevel, '$cut'), '!')), ','(','(','(','('g_read'('data.char', '<module>:data.char'(___93)), '<module>:data.char:..$direct'('0', '9', ___92, ___93)), ','(','(','('g_read'('data.char', '<module>:data.char'(___97)), '<module>:data.char:..$direct'('A', 'Z', ___96, ___97)), ','('g_read'('data.char', '<module>:data.char'(___101)), '<module>:data.char:..$direct'('a', 'z', ___100, ___101))), ','('g_read'('data.list', '<module>:data.list'(___103)), '<module>:data.list:++$direct'(___96, ___100, ___102, ___103)))), ','('g_read'('data.list', '<module>:data.list'(___105)), '<module>:data.list:++$direct'(___92, ___102, ___104, ___105))), ','('g_read'('data.list', '<module>:data.list'(___107)), '<module>:data.list:random_item$direct'('data.random', ___104, ___106, ___107))))).
':-'('<module>:io.dir@2:do'(_C, _C, 'env'(___51, _TemplateStr), __36CutLevel), 'true').
':-'('<module>:io.dir@2:do$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.dir@2:do'(_____2, _____1, __36env, __36CutLevel))).
':-'('io.dir@init', ','('true', ','('g_link'('io.dir', '<module>:io.dir'('env')), '<module>:io.dir:$init0'('env', __36CutLevel)))).
':-'('dynamic'('/'('<module>:io.err$dynamic', 4))).
':-'('<module>:io.err'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:io.err:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.err'('endline', __36env, _, __36CutLevel), ','('!', '<module>:io.err:endline'(__36env, __36CutLevel))).
':-'('<module>:io.err'('flush', __36env, _, __36CutLevel), ','('!', '<module>:io.err:flush'(__36env, __36CutLevel))).
':-'('<module>:io.err'('format'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:io.err:format'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:io.err'('print'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:io.err:print'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.err'('print_endline'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:io.err:print_endline'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.err'('close', __36env, _, __36CutLevel), ','('!', '<module>:io.err:close'(__36env, __36CutLevel))).
':-'('<module>:io.err'(__36t, __36env, __36pos, __36CutLevel), '<module>:io.err$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:io.err$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:io.err$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:io.err$has_predicate'('endline'), 'true').
':-'('<module>:io.err$has_predicate'('flush'), 'true').
':-'('<module>:io.err$has_predicate'('format'(_____2, _____1)), 'true').
':-'('<module>:io.err$has_predicate'('print'(_____1)), 'true').
':-'('<module>:io.err$has_predicate'('print_endline'(_____1)), 'true').
':-'('<module>:io.err$has_predicate'('close'), 'true').
':-'('<module>:io.err:$sgn'(__36sgn, 'env', __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/err.mpl',0,0,0)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/err.mpl',17,0,0)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','(','(','(','('true', '<module>:io.err:atom_fresh_[1806]'(_atom__fresh___911807_93, __36Pb, __36Pe)), '<module>:io.err:atom_fresh_[1808]'(_atom__fresh___911809_93, __36Pb, __36Pe)), '<module>:io.err:atom_fresh_[1810]'(_atom__fresh___911811_93, __36Pb, __36Pe)), '<module>:io.err:atom_fresh_[1812]'(_atom__fresh___911813_93, __36Pb, __36Pe)), '<module>:io.err:atom_fresh_[1814]'(_atom__fresh___911815_93, __36Pb, __36Pe)), '<module>:io.err:atom_fresh_[1816]'(_atom__fresh___911817_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___911817_93, '.'(_atom__fresh___911815_93, '.'(_atom__fresh___911813_93, '.'(_atom__fresh___911811_93, '.'(_atom__fresh___911809_93, '.'(_atom__fresh___911807_93, '[]')))))))))))).
':-'('<module>:io.err:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.err:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.err:atom_fresh_[1806]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(close, 0, predicate, [], __36pos))).
':-'('<module>:io.err:atom_fresh_[1808]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(print_endline, 1, predicate, suspended([var('Term')],[call(atom(kernel),stderr_print_endline,[var('Term')])]), __36pos))).
':-'('<module>:io.err:atom_fresh_[1810]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(print, 1, predicate, suspended([var('Term')],[call(atom(kernel),stderr_print,[var('Term')])]), __36pos))).
':-'('<module>:io.err:atom_fresh_[1812]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(format, 2, predicate, suspended([var('Format'),var('Args')],[call(atom(kernel),stderr_format,[var('Format'),var('Args')])]), __36pos))).
':-'('<module>:io.err:atom_fresh_[1814]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(flush, 0, predicate, [], __36pos))).
':-'('<module>:io.err:atom_fresh_[1816]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(endline, 0, predicate, [], __36pos))).
':-'('<module>:io.err:close'('env', __36CutLevel), 'true').
':-'('<module>:io.err:close$direct'(__36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.err:close'(__36env, __36CutLevel))).
':-'('<module>:io.err:endline'('env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___5)), '<module>:kernel:stderr_endline$direct'(___5))).
':-'('<module>:io.err:endline$direct'(__36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.err:endline'(__36env, __36CutLevel))).
':-'('<module>:io.err:flush'('env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___7)), '<module>:kernel:stderr_flush$direct'(___7))).
':-'('<module>:io.err:flush$direct'(__36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.err:flush'(__36env, __36CutLevel))).
':-'('<module>:io.err:format'(_Format, _Args, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___9)), '<module>:kernel:stderr_format$direct'(_Format, _Args, ___9))).
':-'('<module>:io.err:format$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.err:format'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:io.err:print'(_Term, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___11)), '<module>:kernel:stderr_print$direct'(_Term, ___11))).
':-'('<module>:io.err:print$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.err:print'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.err:print_endline'(_Term, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___13)), '<module>:kernel:stderr_print_endline$direct'(_Term, ___13))).
':-'('<module>:io.err:print_endline$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.err:print_endline'(_____1, __36env, __36CutLevel))).
':-'('io.err@init', ','('true', 'g_link'('io.err', '<module>:io.err'('env')))).
':-'('dynamic'('/'('<module>:io.file$dynamic', 4))).
':-'('<module>:io.file'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:io.file:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.file'('type'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:io.file:type'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:io.file'('open_read'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:io.file:open_read'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:io.file'('open_write'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:io.file:open_write'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:io.file'('delete'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:io.file:delete'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.file'(__36t, __36env, __36pos, __36CutLevel), '<module>:io.file$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:io.file$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:io.file$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:io.file$has_predicate'('type'(_____2, _____1)), 'true').
':-'('<module>:io.file$has_predicate'('open_read'(_____2, _____1)), 'true').
':-'('<module>:io.file$has_predicate'('open_write'(_____2, _____1)), 'true').
':-'('<module>:io.file$has_predicate'('delete'(_____1)), 'true').
':-'('<module>:io.file:$sgn'(__36sgn, 'env', __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/file.mpl',0,0,0)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/file.mpl',16,0,0)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','(','('true', '<module>:io.file:atom_fresh_[2821]'(_atom__fresh___912822_93, __36Pb, __36Pe)), '<module>:io.file:atom_fresh_[2823]'(_atom__fresh___912824_93, __36Pb, __36Pe)), '<module>:io.file:atom_fresh_[2825]'(_atom__fresh___912826_93, __36Pb, __36Pe)), '<module>:io.file:atom_fresh_[2827]'(_atom__fresh___912828_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___912828_93, '.'(_atom__fresh___912826_93, '.'(_atom__fresh___912824_93, '.'(_atom__fresh___912822_93, '[]')))))))))).
':-'('<module>:io.file:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.file:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.file:atom_fresh_[2821]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(delete, 1, predicate, suspended([var('Filename')],[call(atom(kernel),file_delete,[var('Filename')])]), __36pos))).
':-'('<module>:io.file:atom_fresh_[2823]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(open_write, 2, predicate, suspended([var('Filename'),var('Stream')],[call(atom(kernel),io_open_write,[var('Filename'),var('X')]),call(atom('io.stream'),of_kernel_out,[var('X'),var('Stream')])]), __36pos))).
':-'('<module>:io.file:atom_fresh_[2825]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(open_read, 2, predicate, suspended([var('Filename'),var('Stream')],[call(atom(kernel),io_open_read,[var('Filename'),var('X')]),call(atom('io.stream'),of_kernel_in,[var('X'),var('Stream')])]), __36pos))).
':-'('<module>:io.file:atom_fresh_[2827]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(type, 2, predicate, suspended([var('Filename'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:io.file:delete'(_Filename, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___16)), '<module>:kernel:file_delete$direct'(_Filename, ___16))).
':-'('<module>:io.file:delete$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.file:delete'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.file:open_read'(_Filename, _Stream, 'env', __36CutLevel), ','(','('g_read'('kernel', '<module>:kernel'(___8)), '<module>:kernel:io_open_read$direct'(_Filename, _X, ___8)), ','('g_read'('io.stream', '<module>:io.stream'(___10)), '<module>:io.stream:of_kernel_in$direct'(_X, _Stream, ___10)))).
':-'('<module>:io.file:open_read$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.file:open_read'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:io.file:open_write'(_Filename, _Stream, 'env', __36CutLevel), ','(','('g_read'('kernel', '<module>:kernel'(___12)), '<module>:kernel:io_open_write$direct'(_Filename, _X, ___12)), ','('g_read'('io.stream', '<module>:io.stream'(___14)), '<module>:io.stream:of_kernel_out$direct'(_X, _Stream, ___14)))).
':-'('<module>:io.file:open_write$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.file:open_write'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:io.file:type'(_Filename, ___5, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___6)), '<module>:kernel:file_type$direct'(_Filename, ___5, ___6))).
':-'('<module>:io.file:type$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.file:type'(_____2, _____1, __36env, __36CutLevel))).
':-'('io.file@init', ','('true', 'g_link'('io.file', '<module>:io.file'('env')))).
':-'('dynamic'('/'('<module>:io.null$dynamic', 4))).
':-'('<module>:io.null'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:io.null:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.null'('print'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:io.null:print'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.null'('print_endline'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:io.null:print_endline'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.null'('format'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:io.null:format'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:io.null'('endline', __36env, _, __36CutLevel), ','('!', '<module>:io.null:endline'(__36env, __36CutLevel))).
':-'('<module>:io.null'(__36t, __36env, __36pos, __36CutLevel), '<module>:io.null$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:io.null$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:io.null$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:io.null$has_predicate'('print'(_____1)), 'true').
':-'('<module>:io.null$has_predicate'('print_endline'(_____1)), 'true').
':-'('<module>:io.null$has_predicate'('format'(_____2, _____1)), 'true').
':-'('<module>:io.null$has_predicate'('endline'), 'true').
':-'('<module>:io.null:$sgn'(__36sgn, 'env', __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/null.mpl',0,0,0)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/null.mpl',18,0,0)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','(','('true', '<module>:io.null:atom_fresh_[2883]'(_atom__fresh___912884_93, __36Pb, __36Pe)), '<module>:io.null:atom_fresh_[2885]'(_atom__fresh___912886_93, __36Pb, __36Pe)), '<module>:io.null:atom_fresh_[2887]'(_atom__fresh___912888_93, __36Pb, __36Pe)), '<module>:io.null:atom_fresh_[2889]'(_atom__fresh___912890_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___912890_93, '.'(_atom__fresh___912888_93, '.'(_atom__fresh___912886_93, '.'(_atom__fresh___912884_93, '[]')))))))))).
':-'('<module>:io.null:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.null:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.null:atom_fresh_[2883]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(endline, 0, predicate, [], __36pos))).
':-'('<module>:io.null:atom_fresh_[2885]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(format, 2, predicate, '[]', __36pos))).
':-'('<module>:io.null:atom_fresh_[2887]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(print_endline, 1, predicate, '[]', __36pos))).
':-'('<module>:io.null:atom_fresh_[2889]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(print, 1, predicate, '[]', __36pos))).
':-'('<module>:io.null:endline'('env', __36CutLevel), 'true').
':-'('<module>:io.null:endline$direct'(__36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.null:endline'(__36env, __36CutLevel))).
':-'('<module>:io.null:format'(_, _, 'env', __36CutLevel), 'true').
':-'('<module>:io.null:format$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.null:format'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:io.null:print'(_, 'env', __36CutLevel), 'true').
':-'('<module>:io.null:print$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.null:print'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.null:print_endline'(_, 'env', __36CutLevel), 'true').
':-'('<module>:io.null:print_endline$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.null:print_endline'(_____1, __36env, __36CutLevel))).
':-'('io.null@init', ','('true', 'g_link'('io.null', '<module>:io.null'('env')))).
':-'('dynamic'('/'('<module>:io.std$dynamic', 4))).
':-'('dynamic'('/'('<module>:io.std@0$dynamic', 4))).
':-'('<module>:io.std'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:io.std:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.std'('read'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:io.std:read'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.std'('read_line'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:io.std:read_line'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.std'('read_term'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:io.std:read_term'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.std'('read_term'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:io.std:read_term'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:io.std'('write'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:io.std:write'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.std'('endline', __36env, _, __36CutLevel), ','('!', '<module>:io.std:endline'(__36env, __36CutLevel))).
':-'('<module>:io.std'('flush', __36env, _, __36CutLevel), ','('!', '<module>:io.std:flush'(__36env, __36CutLevel))).
':-'('<module>:io.std'('format'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:io.std:format'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:io.std'('print'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:io.std:print'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.std'('print_endline'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:io.std:print_endline'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.std'('close', __36env, _, __36CutLevel), ','('!', '<module>:io.std:close'(__36env, __36CutLevel))).
':-'('<module>:io.std'(__36t, __36env, __36pos, __36CutLevel), '<module>:io.std$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:io.std$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:io.std$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:io.std$has_predicate'('read'(_____1)), 'true').
':-'('<module>:io.std$has_predicate'('read_line'(_____1)), 'true').
':-'('<module>:io.std$has_predicate'('read_term'(_____1)), 'true').
':-'('<module>:io.std$has_predicate'('read_term'(_____2, _____1)), 'true').
':-'('<module>:io.std$has_predicate'('write'(_____1)), 'true').
':-'('<module>:io.std$has_predicate'('endline'), 'true').
':-'('<module>:io.std$has_predicate'('flush'), 'true').
':-'('<module>:io.std$has_predicate'('format'(_____2, _____1)), 'true').
':-'('<module>:io.std$has_predicate'('print'(_____1)), 'true').
':-'('<module>:io.std$has_predicate'('print_endline'(_____1)), 'true').
':-'('<module>:io.std$has_predicate'('close'), 'true').
':-'('<module>:io.std:$sgn'(__36sgn, 'env', __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/std.mpl',0,0,0)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/std.mpl',15,0,0)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','(','(','(','(','(','(','(','(','('true', '<module>:io.std:atom_fresh_[4515]'(_atom__fresh___914516_93, __36Pb, __36Pe)), '<module>:io.std:atom_fresh_[4517]'(_atom__fresh___914518_93, __36Pb, __36Pe)), '<module>:io.std:atom_fresh_[4519]'(_atom__fresh___914520_93, __36Pb, __36Pe)), '<module>:io.std:atom_fresh_[4521]'(_atom__fresh___914522_93, __36Pb, __36Pe)), '<module>:io.std:atom_fresh_[4523]'(_atom__fresh___914524_93, __36Pb, __36Pe)), '<module>:io.std:atom_fresh_[4525]'(_atom__fresh___914526_93, __36Pb, __36Pe)), '<module>:io.std:atom_fresh_[4527]'(_atom__fresh___914528_93, __36Pb, __36Pe)), '<module>:io.std:atom_fresh_[4529]'(_atom__fresh___914530_93, __36Pb, __36Pe)), '<module>:io.std:atom_fresh_[4531]'(_atom__fresh___914532_93, __36Pb, __36Pe)), '<module>:io.std:atom_fresh_[4533]'(_atom__fresh___914534_93, __36Pb, __36Pe)), '<module>:io.std:atom_fresh_[4535]'(_atom__fresh___914536_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___914536_93, '.'(_atom__fresh___914534_93, '.'(_atom__fresh___914532_93, '.'(_atom__fresh___914530_93, '.'(_atom__fresh___914528_93, '.'(_atom__fresh___914526_93, '.'(_atom__fresh___914524_93, '.'(_atom__fresh___914522_93, '.'(_atom__fresh___914520_93, '.'(_atom__fresh___914518_93, '.'(_atom__fresh___914516_93, '[]'))))))))))))))))).
':-'('<module>:io.std:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.std:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.std:atom_fresh_[4515]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(close, 0, predicate, [], __36pos))).
':-'('<module>:io.std:atom_fresh_[4517]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(print_endline, 1, predicate, suspended([var('Term')],[call(atom(kernel),stdio_print_endline,[var('Term')])]), __36pos))).
':-'('<module>:io.std:atom_fresh_[4519]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(print, 1, predicate, suspended([var('Term')],[call(atom(kernel),stdio_print,[var('Term')])]), __36pos))).
':-'('<module>:io.std:atom_fresh_[4521]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(format, 2, predicate, suspended([var('Format'),var('Args')],[call(atom(kernel),stdio_format,[var('Format'),var('Args')])]), __36pos))).
':-'('<module>:io.std:atom_fresh_[4523]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(flush, 0, predicate, [], __36pos))).
':-'('<module>:io.std:atom_fresh_[4525]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(endline, 0, predicate, [], __36pos))).
':-'('<module>:io.std:atom_fresh_[4527]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(write, 1, predicate, suspended([var('C')],[call(atom(kernel),stdio_write,[var('C')])]), __36pos))).
':-'('<module>:io.std:atom_fresh_[4529]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(read_term, 2, predicate, suspended([var('C'),var('Options')],[call(atom(kernel),stdio_read_term,[var('C'),var('Options')])]), __36pos))).
':-'('<module>:io.std:atom_fresh_[4531]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(read_term, 1, predicate, suspended([var('C')],[call(atom(kernel),stdio_read_term,[var('C')])]), __36pos))).
':-'('<module>:io.std:atom_fresh_[4533]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(read_line, 1, predicate, '[]', __36pos))).
':-'('<module>:io.std:atom_fresh_[4535]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(read, 1, predicate, suspended([var('C')],[call(atom(kernel),stdio_read,[var('C')])]), __36pos))).
':-'('<module>:io.std:close'('env', __36CutLevel), 'true').
':-'('<module>:io.std:close$direct'(__36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.std:close'(__36env, __36CutLevel))).
':-'('<module>:io.std:endline'('env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___25)), '<module>:kernel:stdio_endline$direct'(___25))).
':-'('<module>:io.std:endline$direct'(__36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.std:endline'(__36env, __36CutLevel))).
':-'('<module>:io.std:flush'('env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___27)), '<module>:kernel:stdio_flush$direct'(___27))).
':-'('<module>:io.std:flush$direct'(__36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.std:flush'(__36env, __36CutLevel))).
':-'('<module>:io.std:format'(_Format, _Args, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___29)), '<module>:kernel:stdio_format$direct'(_Format, _Args, ___29))).
':-'('<module>:io.std:format$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.std:format'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:io.std:print'(_Term, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___31)), '<module>:kernel:stdio_print$direct'(_Term, ___31))).
':-'('<module>:io.std:print$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.std:print'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.std:print_endline'(_Term, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___33)), '<module>:kernel:stdio_print_endline$direct'(_Term, ___33))).
':-'('<module>:io.std:print_endline$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.std:print_endline'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.std:read'(_C, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___5)), '<module>:kernel:stdio_read$direct'(_C, ___5))).
':-'('<module>:io.std:read$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.std:read'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.std:read_line'(_Line, 'env', __36CutLevel), ','(','('='(_String, ___13), ','(','('true', ';'('->'('var'(___7), ','('g_inc'('$module_count', ___8), '='(___7, '$module'(___8, '.'('<module>:io.std@0'('env'(___7, _Line, _String)), '[]'), '.'(___7, '[]'))))), ','('='(___7, '$module'(___8, ___9, _)), ','('='('.'(___10, ___11), ___9), ','('setarg'(1, ___9, '<module>:io.std@0'('env'(___7, _Line, _String))), 'setarg'(2, ___9, '.'(___10, ___11))))))), ','('g_read'('data.list', '<module>:data.list'(___14)), '<module>:data.list:accumulate$direct'(___7, ___13, ___14)))), ','('='(_Line, ___16), ','('g_read'('data.string', '<module>:data.string'(___17)), '<module>:data.string:atom$direct'(_String, ___16, ___17))))).
':-'('<module>:io.std:read_line$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.std:read_line'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.std:read_term'(_C, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___19)), '<module>:kernel:stdio_read_term$direct'(_C, ___19))).
':-'('<module>:io.std:read_term'(_C, _Options, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___21)), '<module>:kernel:stdio_read_term$direct'(_C, _Options, ___21))).
':-'('<module>:io.std:read_term$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.std:read_term'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.std:read_term$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.std:read_term'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:io.std:write'(_C, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___23)), '<module>:kernel:stdio_write$direct'(_C, ___23))).
':-'('<module>:io.std:write$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.std:write'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.std@0'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:io.std@0:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.std@0'('get'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:io.std@0:get'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.std@0'(__36t, __36env, __36pos, __36CutLevel), '<module>:io.std@0$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:io.std@0$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:io.std@0$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:io.std@0$has_predicate'('get'(_____1)), 'true').
':-'('<module>:io.std@0:$sgn'(__36sgn, 'env'(___12, _Line, _String), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/std.mpl',106,5,81)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/std.mpl',120,5,81)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:io.std@0:atom_fresh_[4537]'(_atom__fresh___914538_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___914538_93, '[]'))))))).
':-'('<module>:io.std@0:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.std@0:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.std@0:atom_fresh_[4537]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(get, 1, predicate, '[]', __36pos))).
':-'('<module>:io.std@0:get'(_C, 'env'(___12, _Line, _String), __36CutLevel), ','(','('g_read'('io.std', '<module>:io.std'(___37)), '<module>:io.std:read$direct'(_C, ___37)), ','('='(_C, ___34), ';'('->'('='(___34, '\n'), 'fail'), ','('='(___34, ___35), ';'('->'('='(___35, 'end_of_file'), 'throw'('end_of_file')), ','('='(___35, ___36), '->'('true', 'true')))))))).
':-'('<module>:io.std@0:get$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.std@0:get'(_____1, __36env, __36CutLevel))).
':-'('io.std@init', ','('true', 'g_link'('io.std', '<module>:io.std'('env')))).
':-'('dynamic'('/'('<module>:io.stream@0$dynamic', 4))).
':-'('dynamic'('/'('<module>:io.stream@3$dynamic', 4))).
':-'('dynamic'('/'('<module>:io.stream@2$dynamic', 4))).
':-'('dynamic'('/'('<module>:io.stream@1$dynamic', 4))).
':-'('dynamic'('/'('<module>:io.stream$dynamic', 4))).
':-'('dynamic'('/'('<module>:io.stream@5$dynamic', 4))).
':-'('dynamic'('/'('<module>:io.stream@4$dynamic', 4))).
':-'('<module>:io.stream'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:io.stream:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.stream'('backtrackable'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:io.stream:backtrackable'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:io.stream'('text_position'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:io.stream:text_position'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:io.stream'('text_position_utf8'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:io.stream:text_position_utf8'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:io.stream'('list'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:io.stream:list'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:io.stream'('of_kernel_in'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:io.stream:of_kernel_in'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:io.stream'('of_kernel_out'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:io.stream:of_kernel_out'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:io.stream'(__36t, __36env, __36pos, __36CutLevel), '<module>:io.stream$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:io.stream$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:io.stream$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:io.stream$has_predicate'('backtrackable'(_____2, _____1)), 'true').
':-'('<module>:io.stream$has_predicate'('text_position'(_____3, _____2, _____1)), 'true').
':-'('<module>:io.stream$has_predicate'('text_position_utf8'(_____3, _____2, _____1)), 'true').
':-'('<module>:io.stream$has_predicate'('list'(_____2, _____1)), 'true').
':-'('<module>:io.stream$has_predicate'('of_kernel_in'(_____2, _____1)), 'true').
':-'('<module>:io.stream$has_predicate'('of_kernel_out'(_____2, _____1)), 'true').
':-'('<module>:io.stream:$sgn'(__36sgn, 'env'(_Impl), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/stream.mpl',0,0,0)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/stream.mpl',25,0,0)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','(','(','(','('true', '<module>:io.stream:atom_fresh_[1896]'(_atom__fresh___911897_93, __36Pb, __36Pe)), '<module>:io.stream:atom_fresh_[1898]'(_atom__fresh___911899_93, __36Pb, __36Pe)), '<module>:io.stream:atom_fresh_[1900]'(_atom__fresh___911901_93, __36Pb, __36Pe)), '<module>:io.stream:atom_fresh_[1902]'(_atom__fresh___911903_93, __36Pb, __36Pe)), '<module>:io.stream:atom_fresh_[1904]'(_atom__fresh___911905_93, __36Pb, __36Pe)), '<module>:io.stream:atom_fresh_[1906]'(_atom__fresh___911907_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___911907_93, '.'(_atom__fresh___911905_93, '.'(_atom__fresh___911903_93, '.'(_atom__fresh___911901_93, '.'(_atom__fresh___911899_93, '.'(_atom__fresh___911897_93, '[]')))))))))))).
':-'('<module>:io.stream:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.stream:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.stream:atom_fresh_[1896]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(of_kernel_out, 2, predicate, suspended([var('X'),var('Stream')],[module('Stream',[symbol(write,1,predicate,suspended([var('C')],[call(atom(kernel),io_write,[var('X'),var('C')])]),file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/stream.mpl',881,34,863),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/stream.mpl',918,35,884))),symbol(flush,0,predicate,suspended([],[call(atom(kernel),io_flush,[var('X')])]),file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/stream.mpl',935,37,920),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/stream.mpl',969,38,938))),symbol(print,1,predicate,suspended([var('Term')],[call(atom(kernel),io_print,[var('X'),var('Term')])]),file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/stream.mpl',992,40,971),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/stream.mpl',1032,41,995))),symbol(print_endline,1,predicate,suspended([var('Term')],[call(atom(kernel),io_print_endline,[var('X'),var('Term')])]),file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/stream.mpl',1063,43,1034),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/stream.mpl',1111,44,1066))),symbol(endline,0,predicate,suspended([],[call(atom(kernel),io_endline,[var('X')])]),file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/stream.mpl',1130,46,1113),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/stream.mpl',1166,47,1133))),symbol(format,2,predicate,suspended([var('Format'),var('Args')],[call(atom(kernel),io_format,[var('X'),var('Format'),var('Args')])]),file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/stream.mpl',1198,49,1168),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/stream.mpl',1247,50,1201))),symbol(close,0,predicate,suspended([],[call(atom(kernel),io_close,[var('X')])]),file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/stream.mpl',1264,52,1249),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/stream.mpl',1298,53,1267)))])]), __36pos))).
':-'('<module>:io.stream:atom_fresh_[1898]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(of_kernel_in, 2, predicate, suspended([var('X'),var('Stream')],[module('Stream',[symbol(read,1,predicate,suspended([var('C')],[call(atom(kernel),io_read,[var('X'),var('C')])]),file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/stream.mpl',441,15,424),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/stream.mpl',477,16,444))),symbol(read_term,1,predicate,suspended([var('T')],[call(atom(kernel),io_read_term,[var('X'),var('T')])]),file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/stream.mpl',501,18,479),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/stream.mpl',542,19,504))),symbol(read_term,2,predicate,suspended([var('T'),var('Options')],[call(atom(kernel),io_read_term,[var('X'),var('T'),var('Options')])]),file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/stream.mpl',575,21,544),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/stream.mpl',625,22,578))),symbol(seek,2,predicate,suspended([var('Method'),var('Count')],[call(atom(kernel),io_seek,[var('X'),var('Method'),var('Count')])]),file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/stream.mpl',656,24,627),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/stream.mpl',704,25,659))),symbol(close,0,predicate,suspended([],[call(atom(kernel),io_close,[var('X')])]),file(pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/stream.mpl',721,27,706),pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/stream.mpl',755,28,724)))]),call(atom('data.stream'),input_stream,[var('Stream')])]), __36pos))).
':-'('<module>:io.stream:atom_fresh_[1900]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(list, 2, predicate, suspended([var('Stream'),var('List')],[call(var('Impl'),list,[var('Stream'),var('List')])]), __36pos))).
':-'('<module>:io.stream:atom_fresh_[1902]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(text_position_utf8, 3, predicate, suspended([var('Stream'),var('File'),var('Position')],[call(var('Impl'),text_position_utf8,[var('Stream'),var('File'),var('Position')])]), __36pos))).
':-'('<module>:io.stream:atom_fresh_[1904]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(text_position, 3, predicate, suspended([var('Stream'),var('File'),var('Position')],[call(var('Impl'),text_position,[var('Stream'),var('File'),var('Position')])]), __36pos))).
':-'('<module>:io.stream:atom_fresh_[1906]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(backtrackable, 2, predicate, suspended([var('Stream_nb'),var('Stream_b')],[call(var('Impl'),backtrackable,[var('Stream_nb'),var('Stream_b')])]), __36pos))).
':-'('<module>:io.stream:backtrackable'(_Stream__nb, _Stream__b, 'env'(_Impl), __36CutLevel), 'emop_call'(_Impl, 'backtrackable'(_Stream__nb, _Stream__b), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/stream.mpl\", line 3, from character 11 to 24')).
':-'('<module>:io.stream:backtrackable$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.stream:backtrackable'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:io.stream:list'(_Stream, _List, 'env'(_Impl), __36CutLevel), 'emop_call'(_Impl, 'list'(_Stream, _List), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/stream.mpl\", line 12, from character 11 to 15')).
':-'('<module>:io.stream:list$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.stream:list'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:io.stream:of_kernel_in'(_X, _Stream, 'env'(_Impl), __36CutLevel), ','(','('true', ';'('->'('var'(_Stream), ','('g_inc'('$module_count', ___66), '='(_Stream, '$module'(___66, '.'('<module>:io.stream@4'('env'(_Stream, _Impl, _Stream, _X)), '[]'), '.'(_Stream, '[]'))))), ','('='(_Stream, '$module'(___66, ___67, _)), ','('='('.'(___68, ___69), ___67), ','('setarg'(1, ___67, '<module>:io.stream@4'('env'(_Stream, _Impl, _Stream, _X))), 'setarg'(2, ___67, '.'(___68, ___69))))))), ','('g_read'('data.stream', '<module>:data.stream'(___72)), '<module>:data.stream:input_stream$direct'(_Stream, ___72)))).
':-'('<module>:io.stream:of_kernel_in$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.stream:of_kernel_in'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:io.stream:of_kernel_out'(_X, _Stream, 'env'(_Impl), __36CutLevel), ','('true', ';'('->'('var'(_Stream), ','('g_inc'('$module_count', ___73), '='(_Stream, '$module'(___73, '.'('<module>:io.stream@5'('env'(_Stream, _X)), '[]'), '.'(_Stream, '[]'))))), ','('='(_Stream, '$module'(___73, ___74, _)), ','('='('.'(___75, ___76), ___74), ','('setarg'(1, ___74, '<module>:io.stream@5'('env'(_Stream, _X))), 'setarg'(2, ___74, '.'(___75, ___76)))))))).
':-'('<module>:io.stream:of_kernel_out$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.stream:of_kernel_out'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:io.stream:text_position'(_Stream, _File, _Position, 'env'(_Impl), __36CutLevel), 'emop_call'(_Impl, 'text_position'(_Stream, _File, _Position), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/stream.mpl\", line 6, from character 11 to 24')).
':-'('<module>:io.stream:text_position$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.stream:text_position'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:io.stream:text_position_utf8'(_Stream, _File, _Position, 'env'(_Impl), __36CutLevel), 'emop_call'(_Impl, 'text_position_utf8'(_Stream, _File, _Position), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/stream.mpl\", line 9, from character 11 to 29')).
':-'('<module>:io.stream:text_position_utf8$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.stream:text_position_utf8'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:io.stream@0'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:io.stream@0:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.stream@0'('pos'(_____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:io.stream@0:pos'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:io.stream@0'('end_of_file'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:io.stream@0:end_of_file'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.stream@0'('backtrackable'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:io.stream@0:backtrackable'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:io.stream@0'('text_position'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:io.stream@0:text_position'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:io.stream@0'('text_position_utf8'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:io.stream@0:text_position_utf8'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:io.stream@0'('list'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:io.stream@0:list'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:io.stream@0'(__36t, __36env, __36pos, __36CutLevel), '<module>:io.stream@0$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:io.stream@0$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:io.stream@0$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:io.stream@0$has_predicate'('pos'(_____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:io.stream@0$has_predicate'('end_of_file'(_____1)), 'true').
':-'('<module>:io.stream@0$has_predicate'('backtrackable'(_____2, _____1)), 'true').
':-'('<module>:io.stream@0$has_predicate'('text_position'(_____3, _____2, _____1)), 'true').
':-'('<module>:io.stream@0$has_predicate'('text_position_utf8'(_____3, _____2, _____1)), 'true').
':-'('<module>:io.stream@0$has_predicate'('list'(_____2, _____1)), 'true').
':-'('<module>:io.stream@0:$sgn'(__36sgn, 'env'(___8, _Impl), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/stream.mpl',1312,57,1312)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/stream.mpl',1325,57,1312)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','(','(','(','('true', '<module>:io.stream@0:atom_fresh_[1874]'(_atom__fresh___911875_93, __36Pb, __36Pe)), '<module>:io.stream@0:atom_fresh_[1876]'(_atom__fresh___911877_93, __36Pb, __36Pe)), '<module>:io.stream@0:atom_fresh_[1878]'(_atom__fresh___911879_93, __36Pb, __36Pe)), '<module>:io.stream@0:atom_fresh_[1880]'(_atom__fresh___911881_93, __36Pb, __36Pe)), '<module>:io.stream@0:atom_fresh_[1882]'(_atom__fresh___911883_93, __36Pb, __36Pe)), '<module>:io.stream@0:atom_fresh_[1884]'(_atom__fresh___911885_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___911885_93, '.'(_atom__fresh___911883_93, '.'(_atom__fresh___911881_93, '.'(_atom__fresh___911879_93, '.'(_atom__fresh___911877_93, '.'(_atom__fresh___911875_93, '[]')))))))))))).
':-'('<module>:io.stream@0:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.stream@0:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.stream@0:atom_fresh_[1874]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(list, 2, predicate, suspended([var('Stream'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:io.stream@0:atom_fresh_[1876]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(text_position_utf8, 3, predicate, '[]', __36pos))).
':-'('<module>:io.stream@0:atom_fresh_[1878]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(text_position, 3, predicate, '[]', __36pos))).
':-'('<module>:io.stream@0:atom_fresh_[1880]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(backtrackable, 2, predicate, suspended([var('Stream'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:io.stream@0:atom_fresh_[1882]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(end_of_file, 1, constructor, none, __36pos))).
':-'('<module>:io.stream@0:atom_fresh_[1884]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(pos, 5, constructor, none, __36pos))).
':-'('<module>:io.stream@0:backtrackable'(_Stream, ___17, 'env'(___8, _Impl), __36CutLevel), ','('emop_call'(___8, 'list'(_Stream, ___16), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/stream.mpl\", line 61, from character 44 to 48'), ','('g_read'('data.list', '<module>:data.list'(___18)), '<module>:data.list:stream$direct'(___16, ___17, ___18)))).
':-'('<module>:io.stream@0:backtrackable$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.stream@0:backtrackable'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:io.stream@0:end_of_file'(___14, 'env'(___8, _Impl), __36CutLevel), '=..'(___14, '.'('end_of_file', '[]'))).
':-'('<module>:io.stream@0:end_of_file$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.stream@0:end_of_file'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.stream@0:list'(_Stream, ___44, 'env'(___8, _Impl), __36CutLevel), ','(','('true', ';'('->'('var'(___38), ','('g_inc'('$module_count', ___39), '='(___38, '$module'(___39, '.'('<module>:io.stream@3'('env'(___38, _Impl, _Stream, ___8)), '[]'), '.'(___38, '[]'))))), ','('='(___38, '$module'(___39, ___40, _)), ','('='('.'(___41, ___42), ___40), ','('setarg'(1, ___40, '<module>:io.stream@3'('env'(___38, _Impl, _Stream, ___8))), 'setarg'(2, ___40, '.'(___41, ___42))))))), ','('g_read'('data.list', '<module>:data.list'(___45)), '<module>:data.list:accumulate$direct'(___38, ___44, ___45)))).
':-'('<module>:io.stream@0:list$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.stream@0:list'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:io.stream@0:pos'(___9, ___10, ___11, ___12, ___13, 'env'(___8, _Impl), __36CutLevel), '=..'(___13, '.'('pos', '.'(___9, '.'(___10, '.'(___11, '.'(___12, '[]'))))))).
':-'('<module>:io.stream@0:pos$direct'(_____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.stream@0:pos'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:io.stream@0:text_position'(_Stream, _File, _Position, 'env'(___8, _Impl), __36CutLevel), ','(','(','('g_read'('data.ref.backtrackable', '<module>:data.ref.backtrackable'(___20)), '<module>:data.ref.backtrackable:new$direct'(0, _Offset, ___20)), ','(','('g_read'('data.ref.backtrackable', '<module>:data.ref.backtrackable'(___21)), '<module>:data.ref.backtrackable:new$direct'(0, _Line, ___21)), ','('g_read'('data.ref.backtrackable', '<module>:data.ref.backtrackable'(___22)), '<module>:data.ref.backtrackable:new$direct'(0, _BOL, ___22)))), ','('true', ';'('->'('var'(_Position), ','('g_inc'('$module_count', ___23), '='(_Position, '$module'(___23, '.'('<module>:io.stream@1'('env'(_Position, _Stream, _File, _Offset, _Line, _BOL, ___8)), '[]'), '.'(_Position, '[]'))))), ','('='(_Position, '$module'(___23, ___24, _)), ','('='('.'(___25, ___26), ___24), ','('setarg'(1, ___24, '<module>:io.stream@1'('env'(_Position, _Stream, _File, _Offset, _Line, _BOL, ___8))), 'setarg'(2, ___24, '.'(___25, ___26))))))))).
':-'('<module>:io.stream@0:text_position$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.stream@0:text_position'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:io.stream@0:text_position_utf8'(_Stream, _File, _Position, 'env'(___8, _Impl), __36CutLevel), ','(','(','('g_read'('data.ref.backtrackable', '<module>:data.ref.backtrackable'(___29)), '<module>:data.ref.backtrackable:new$direct'(0, _Offset, ___29)), ','(','('g_read'('data.ref.backtrackable', '<module>:data.ref.backtrackable'(___30)), '<module>:data.ref.backtrackable:new$direct'(0, _Line, ___30)), ','('g_read'('data.ref.backtrackable', '<module>:data.ref.backtrackable'(___31)), '<module>:data.ref.backtrackable:new$direct'(0, _BOL, ___31)))), ','('true', ';'('->'('var'(_Position), ','('g_inc'('$module_count', ___32), '='(_Position, '$module'(___32, '.'('<module>:io.stream@2'('env'(_Position, _Stream, _File, _Offset, _Line, _BOL, ___8)), '[]'), '.'(_Position, '[]'))))), ','('='(_Position, '$module'(___32, ___33, _)), ','('='('.'(___34, ___35), ___33), ','('setarg'(1, ___33, '<module>:io.stream@2'('env'(_Position, _Stream, _File, _Offset, _Line, _BOL, ___8))), 'setarg'(2, ___33, '.'(___34, ___35))))))))).
':-'('<module>:io.stream@0:text_position_utf8$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.stream@0:text_position_utf8'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:io.stream@1'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:io.stream@1:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.stream@1'('position'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:io.stream@1:position'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.stream@1'('read'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:io.stream@1:read'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.stream@1'(__36t, __36env, __36pos, __36CutLevel), '<module>:io.stream@1$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:io.stream@1$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:io.stream@1$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:io.stream@1$has_predicate'('position'(_____1)), 'true').
':-'('<module>:io.stream@1$has_predicate'('read'(_____1)), 'true').
':-'('<module>:io.stream@1:$sgn'(__36sgn, 'env'(___27, _Stream, _File, _Offset, _Line, _BOL, ___8), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/stream.mpl',1586,68,1580)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/stream.mpl',1637,68,1580)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','('true', '<module>:io.stream@1:atom_fresh_[1892]'(_atom__fresh___911893_93, __36Pb, __36Pe)), '<module>:io.stream@1:atom_fresh_[1894]'(_atom__fresh___911895_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___911895_93, '.'(_atom__fresh___911893_93, '[]')))))))).
':-'('<module>:io.stream@1:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.stream@1:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.stream@1:atom_fresh_[1892]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(read, 1, predicate, '[]', __36pos))).
':-'('<module>:io.stream@1:atom_fresh_[1894]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(position, 1, predicate, suspended([none],[call(var('Offset'),get,[var('O')]),call(var('Line'),get,[var('L')]),call(var('BOL'),get,[var('B')])]), __36pos))).
':-'('<module>:io.stream@1:position'('pos'(_File, _O, _L, _B), 'env'(___27, _Stream, _File, _Offset, _Line, _BOL, ___8), __36CutLevel), ','('emop_call'(_Offset, 'get'(_O), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/stream.mpl\", line 71, from character 19 to 22'), ','('emop_call'(_Line, 'get'(_L), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/stream.mpl\", line 72, from character 17 to 20'), 'emop_call'(_BOL, 'get'(_B), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/stream.mpl\", line 73, from character 16 to 19')))).
':-'('<module>:io.stream@1:position$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.stream@1:position'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.stream@1:read'(_C, 'env'(___27, _Stream, _File, _Offset, _Line, _BOL, ___8), __36CutLevel), ','('emop_call'(_Stream, 'read'(_C), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/stream.mpl\", line 76, from character 19 to 23'), ','(','('g_read'('data.number', '<module>:data.number'(___62)), '<module>:data.number:|++$direct'(_Offset, ___62)), ';'('->'('='(_C, '\n'), ','('emop_call'(_Offset, 'get'(_O), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/stream.mpl\", line 81, from character 22 to 25'), ','('emop_call'(_BOL, 'set'(_O), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/stream.mpl\", line 82, from character 19 to 22'), ','('g_read'('data.number', '<module>:data.number'(___65)), '<module>:data.number:|++$direct'(_Line, ___65))))), 'true')))).
':-'('<module>:io.stream@1:read$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.stream@1:read'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.stream@2'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:io.stream@2:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.stream@2'('position'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:io.stream@2:position'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.stream@2'('read'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:io.stream@2:read'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.stream@2'(__36t, __36env, __36pos, __36CutLevel), '<module>:io.stream@2$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:io.stream@2$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:io.stream@2$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:io.stream@2$has_predicate'('position'(_____1)), 'true').
':-'('<module>:io.stream@2$has_predicate'('read'(_____1)), 'true').
':-'('<module>:io.stream@2:$sgn'(__36sgn, 'env'(___36, _Stream, _File, _Offset, _Line, _BOL, ___8), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/stream.mpl',2211,94,2205)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/stream.mpl',2262,94,2205)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','('true', '<module>:io.stream@2:atom_fresh_[1888]'(_atom__fresh___911889_93, __36Pb, __36Pe)), '<module>:io.stream@2:atom_fresh_[1890]'(_atom__fresh___911891_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___911891_93, '.'(_atom__fresh___911889_93, '[]')))))))).
':-'('<module>:io.stream@2:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.stream@2:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.stream@2:atom_fresh_[1888]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(read, 1, predicate, '[]', __36pos))).
':-'('<module>:io.stream@2:atom_fresh_[1890]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(position, 1, predicate, suspended([none],[call(var('Offset'),get,[var('O')]),call(var('Line'),get,[var('L')]),call(var('BOL'),get,[var('B')])]), __36pos))).
':-'('<module>:io.stream@2:position'('pos'(_File, _O, _L, _B), 'env'(___36, _Stream, _File, _Offset, _Line, _BOL, ___8), __36CutLevel), ','('emop_call'(_Offset, 'get'(_O), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/stream.mpl\", line 97, from character 19 to 22'), ','('emop_call'(_Line, 'get'(_L), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/stream.mpl\", line 98, from character 17 to 20'), 'emop_call'(_BOL, 'get'(_B), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/stream.mpl\", line 99, from character 16 to 19')))).
':-'('<module>:io.stream@2:position$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.stream@2:position'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.stream@2:read'(_C, 'env'(___36, _Stream, _File, _Offset, _Line, _BOL, ___8), __36CutLevel), ','('emop_call'(_Stream, 'read'(_C), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/stream.mpl\", line 102, from character 19 to 23'), ';'('->'(','('\\='(_C, 'end_of_file'), ','(','('='(_Code, ___50), ','('g_read'('data.char', '<module>:data.char'(___51)), '<module>:data.char:code$direct'(_C, ___50, ___51))), ';'(','('g_read'('data.number', '<module>:data.number'(___53)), '<module>:data.number:<$direct'(_Code, 128, ___53)), ','('g_read'('data.number', '<module>:data.number'(___54)), '<module>:data.number:>$direct'(_Code, 192, ___54))))), ','(','('g_read'('data.number', '<module>:data.number'(___56)), '<module>:data.number:|++$direct'(_Offset, ___56)), ';'('->'('='(_C, '\n'), ','('emop_call'(_Offset, 'get'(_O), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/stream.mpl\", line 116, from character 25 to 28'), ','('emop_call'(_BOL, 'set'(_O), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/stream.mpl\", line 117, from character 22 to 25'), ','('g_read'('data.number', '<module>:data.number'(___59)), '<module>:data.number:|++$direct'(_Line, ___59))))), 'true'))), 'true'))).
':-'('<module>:io.stream@2:read$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.stream@2:read'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.stream@3'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:io.stream@3:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.stream@3'('get'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:io.stream@3:get'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.stream@3'(__36t, __36env, __36pos, __36CutLevel), '<module>:io.stream@3$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:io.stream@3$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:io.stream@3$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:io.stream@3$has_predicate'('get'(_____1)), 'true').
':-'('<module>:io.stream@3:$sgn'(__36sgn, 'env'(___43, _Impl, _Stream, ___8), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/stream.mpl',3010,127,2994)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/stream.mpl',3024,127,2994)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:io.stream@3:atom_fresh_[1886]'(_atom__fresh___911887_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___911887_93, '[]'))))))).
':-'('<module>:io.stream@3:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.stream@3:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.stream@3:atom_fresh_[1886]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(get, 1, predicate, '[]', __36pos))).
':-'('<module>:io.stream@3:get'(_Char, 'env'(___43, _Impl, _Stream, ___8), __36CutLevel), ','('emop_call'(_Stream, 'read'(_Char), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/stream.mpl\", line 130, from character 19 to 23'), '\\='(_Char, 'end_of_file'))).
':-'('<module>:io.stream@3:get$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.stream@3:get'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.stream@4'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:io.stream@4:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.stream@4'('read'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:io.stream@4:read'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.stream@4'('read_term'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:io.stream@4:read_term'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.stream@4'('read_term'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:io.stream@4:read_term'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:io.stream@4'('seek'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:io.stream@4:seek'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:io.stream@4'('close', __36env, _, __36CutLevel), ','('!', '<module>:io.stream@4:close'(__36env, __36CutLevel))).
':-'('<module>:io.stream@4'(__36t, __36env, __36pos, __36CutLevel), '<module>:io.stream@4$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:io.stream@4$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:io.stream@4$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:io.stream@4$has_predicate'('read'(_____1)), 'true').
':-'('<module>:io.stream@4$has_predicate'('read_term'(_____1)), 'true').
':-'('<module>:io.stream@4$has_predicate'('read_term'(_____2, _____1)), 'true').
':-'('<module>:io.stream@4$has_predicate'('seek'(_____2, _____1)), 'true').
':-'('<module>:io.stream@4$has_predicate'('close'), 'true').
':-'('<module>:io.stream@4:$sgn'(__36sgn, 'env'(___70, _Impl, _Stream, _X), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/stream.mpl',408,14,402)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/stream.mpl',423,14,402)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','(','(','('true', '<module>:io.stream@4:atom_fresh_[1922]'(_atom__fresh___911923_93, __36Pb, __36Pe)), '<module>:io.stream@4:atom_fresh_[1924]'(_atom__fresh___911925_93, __36Pb, __36Pe)), '<module>:io.stream@4:atom_fresh_[1926]'(_atom__fresh___911927_93, __36Pb, __36Pe)), '<module>:io.stream@4:atom_fresh_[1928]'(_atom__fresh___911929_93, __36Pb, __36Pe)), '<module>:io.stream@4:atom_fresh_[1930]'(_atom__fresh___911931_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___911931_93, '.'(_atom__fresh___911929_93, '.'(_atom__fresh___911927_93, '.'(_atom__fresh___911925_93, '.'(_atom__fresh___911923_93, '[]'))))))))))).
':-'('<module>:io.stream@4:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.stream@4:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.stream@4:atom_fresh_[1922]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(close, 0, predicate, suspended([],[call(atom(kernel),io_close,[var('X')])]), __36pos))).
':-'('<module>:io.stream@4:atom_fresh_[1924]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(seek, 2, predicate, suspended([var('Method'),var('Count')],[call(atom(kernel),io_seek,[var('X'),var('Method'),var('Count')])]), __36pos))).
':-'('<module>:io.stream@4:atom_fresh_[1926]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(read_term, 2, predicate, suspended([var('T'),var('Options')],[call(atom(kernel),io_read_term,[var('X'),var('T'),var('Options')])]), __36pos))).
':-'('<module>:io.stream@4:atom_fresh_[1928]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(read_term, 1, predicate, suspended([var('T')],[call(atom(kernel),io_read_term,[var('X'),var('T')])]), __36pos))).
':-'('<module>:io.stream@4:atom_fresh_[1930]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(read, 1, predicate, suspended([var('C')],[call(atom(kernel),io_read,[var('X'),var('C')])]), __36pos))).
':-'('<module>:io.stream@4:close'('env'(___70, _Impl, _Stream, _X), __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___101)), '<module>:kernel:io_close$direct'(_X, ___101))).
':-'('<module>:io.stream@4:close$direct'(__36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.stream@4:close'(__36env, __36CutLevel))).
':-'('<module>:io.stream@4:read'(_C, 'env'(___70, _Impl, _Stream, _X), __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___93)), '<module>:kernel:io_read$direct'(_X, _C, ___93))).
':-'('<module>:io.stream@4:read$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.stream@4:read'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.stream@4:read_term'(_T, 'env'(___70, _Impl, _Stream, _X), __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___95)), '<module>:kernel:io_read_term$direct'(_X, _T, ___95))).
':-'('<module>:io.stream@4:read_term'(_T, _Options, 'env'(___70, _Impl, _Stream, _X), __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___97)), '<module>:kernel:io_read_term$direct'(_X, _T, _Options, ___97))).
':-'('<module>:io.stream@4:read_term$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.stream@4:read_term'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.stream@4:read_term$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.stream@4:read_term'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:io.stream@4:seek'(_Method, _Count, 'env'(___70, _Impl, _Stream, _X), __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___99)), '<module>:kernel:io_seek$direct'(_X, _Method, _Count, ___99))).
':-'('<module>:io.stream@4:seek$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.stream@4:seek'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:io.stream@5'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:io.stream@5:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.stream@5'('write'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:io.stream@5:write'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.stream@5'('flush', __36env, _, __36CutLevel), ','('!', '<module>:io.stream@5:flush'(__36env, __36CutLevel))).
':-'('<module>:io.stream@5'('print'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:io.stream@5:print'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.stream@5'('print_endline'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:io.stream@5:print_endline'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.stream@5'('endline', __36env, _, __36CutLevel), ','('!', '<module>:io.stream@5:endline'(__36env, __36CutLevel))).
':-'('<module>:io.stream@5'('format'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:io.stream@5:format'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:io.stream@5'('close', __36env, _, __36CutLevel), ','('!', '<module>:io.stream@5:close'(__36env, __36CutLevel))).
':-'('<module>:io.stream@5'(__36t, __36env, __36pos, __36CutLevel), '<module>:io.stream@5$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:io.stream@5$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:io.stream@5$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:io.stream@5$has_predicate'('write'(_____1)), 'true').
':-'('<module>:io.stream@5$has_predicate'('flush'), 'true').
':-'('<module>:io.stream@5$has_predicate'('print'(_____1)), 'true').
':-'('<module>:io.stream@5$has_predicate'('print_endline'(_____1)), 'true').
':-'('<module>:io.stream@5$has_predicate'('endline'), 'true').
':-'('<module>:io.stream@5$has_predicate'('format'(_____2, _____1)), 'true').
':-'('<module>:io.stream@5$has_predicate'('close'), 'true').
':-'('<module>:io.stream@5:$sgn'(__36sgn, 'env'(___77, _X), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/stream.mpl',843,33,837)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/io/stream.mpl',862,33,837)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','(','(','(','(','('true', '<module>:io.stream@5:atom_fresh_[1908]'(_atom__fresh___911909_93, __36Pb, __36Pe)), '<module>:io.stream@5:atom_fresh_[1910]'(_atom__fresh___911911_93, __36Pb, __36Pe)), '<module>:io.stream@5:atom_fresh_[1912]'(_atom__fresh___911913_93, __36Pb, __36Pe)), '<module>:io.stream@5:atom_fresh_[1914]'(_atom__fresh___911915_93, __36Pb, __36Pe)), '<module>:io.stream@5:atom_fresh_[1916]'(_atom__fresh___911917_93, __36Pb, __36Pe)), '<module>:io.stream@5:atom_fresh_[1918]'(_atom__fresh___911919_93, __36Pb, __36Pe)), '<module>:io.stream@5:atom_fresh_[1920]'(_atom__fresh___911921_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___911921_93, '.'(_atom__fresh___911919_93, '.'(_atom__fresh___911917_93, '.'(_atom__fresh___911915_93, '.'(_atom__fresh___911913_93, '.'(_atom__fresh___911911_93, '.'(_atom__fresh___911909_93, '[]'))))))))))))).
':-'('<module>:io.stream@5:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.stream@5:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.stream@5:atom_fresh_[1908]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(close, 0, predicate, suspended([],[call(atom(kernel),io_close,[var('X')])]), __36pos))).
':-'('<module>:io.stream@5:atom_fresh_[1910]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(format, 2, predicate, suspended([var('Format'),var('Args')],[call(atom(kernel),io_format,[var('X'),var('Format'),var('Args')])]), __36pos))).
':-'('<module>:io.stream@5:atom_fresh_[1912]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(endline, 0, predicate, suspended([],[call(atom(kernel),io_endline,[var('X')])]), __36pos))).
':-'('<module>:io.stream@5:atom_fresh_[1914]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(print_endline, 1, predicate, suspended([var('Term')],[call(atom(kernel),io_print_endline,[var('X'),var('Term')])]), __36pos))).
':-'('<module>:io.stream@5:atom_fresh_[1916]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(print, 1, predicate, suspended([var('Term')],[call(atom(kernel),io_print,[var('X'),var('Term')])]), __36pos))).
':-'('<module>:io.stream@5:atom_fresh_[1918]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(flush, 0, predicate, suspended([],[call(atom(kernel),io_flush,[var('X')])]), __36pos))).
':-'('<module>:io.stream@5:atom_fresh_[1920]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(write, 1, predicate, suspended([var('C')],[call(atom(kernel),io_write,[var('X'),var('C')])]), __36pos))).
':-'('<module>:io.stream@5:close'('env'(___77, _X), __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___91)), '<module>:kernel:io_close$direct'(_X, ___91))).
':-'('<module>:io.stream@5:close$direct'(__36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.stream@5:close'(__36env, __36CutLevel))).
':-'('<module>:io.stream@5:endline'('env'(___77, _X), __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___87)), '<module>:kernel:io_endline$direct'(_X, ___87))).
':-'('<module>:io.stream@5:endline$direct'(__36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.stream@5:endline'(__36env, __36CutLevel))).
':-'('<module>:io.stream@5:flush'('env'(___77, _X), __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___81)), '<module>:kernel:io_flush$direct'(_X, ___81))).
':-'('<module>:io.stream@5:flush$direct'(__36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.stream@5:flush'(__36env, __36CutLevel))).
':-'('<module>:io.stream@5:format'(_Format, _Args, 'env'(___77, _X), __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___89)), '<module>:kernel:io_format$direct'(_X, _Format, _Args, ___89))).
':-'('<module>:io.stream@5:format$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.stream@5:format'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:io.stream@5:print'(_Term, 'env'(___77, _X), __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___83)), '<module>:kernel:io_print$direct'(_X, _Term, ___83))).
':-'('<module>:io.stream@5:print$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.stream@5:print'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.stream@5:print_endline'(_Term, 'env'(___77, _X), __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___85)), '<module>:kernel:io_print_endline$direct'(_X, _Term, ___85))).
':-'('<module>:io.stream@5:print_endline$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.stream@5:print_endline'(_____1, __36env, __36CutLevel))).
':-'('<module>:io.stream@5:write'(_C, 'env'(___77, _X), __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___79)), '<module>:kernel:io_write$direct'(_X, _C, ___79))).
':-'('<module>:io.stream@5:write$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:io.stream@5:write'(_____1, __36env, __36CutLevel))).
':-'('io.stream@init', ','(','('true', 'g_link'('io.stream', '<module>:io.stream'('env'(_Impl)))), ','('true', ';'('->'('var'(_Impl), ','('g_inc'('$module_count', ___4), '='(_Impl, '$module'(___4, '.'('<module>:io.stream@0'('env'(_Impl, _Impl)), '[]'), '.'(_Impl, '[]'))))), ','('='(_Impl, '$module'(___4, ___5, _)), ','('='('.'(___6, ___7), ___5), ','('setarg'(1, ___5, '<module>:io.stream@0'('env'(_Impl, _Impl))), 'setarg'(2, ___5, '.'(___6, ___7))))))))).
':-'('dynamic'('/'('<module>:kernel$dynamic', 4))).
':-'('<module>:kernel'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('=>'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:=>'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('g_array'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:g_array'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('+'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:+'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('some'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:some'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('absolute_file_name'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:absolute_file_name'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('real_file_name'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:real_file_name'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('stderr'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:stderr'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('dec'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:dec'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('write'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:write'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('read'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:read'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('emop_call'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:emop_call'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('objective'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:objective'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('backtrackable_atoms'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:backtrackable_atoms'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('inc'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:inc'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('backtrackable_atom_capacity'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:backtrackable_atom_capacity'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('backtrackable_atom_count'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:backtrackable_atom_count'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('array_spec'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:array_spec'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('array_backtrackable_new'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:array_backtrackable_new'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('array_backtrackable_get'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:array_backtrackable_get'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('array_backtrackable_set'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:array_backtrackable_set'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('array_non_backtrackable_new'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:array_non_backtrackable_new'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('array_non_backtrackable_get'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:array_non_backtrackable_get'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('array_non_backtrackable_set'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:array_non_backtrackable_set'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('atom_check'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:atom_check'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('atom_length'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:atom_length'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('atom_new'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:atom_new'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('atom_new_backtrackable'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:atom_new_backtrackable'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('atom_concat'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:atom_concat'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('atom_format'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:atom_format'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('atom_sub'(_____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:atom_sub'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('atom_to_string'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:atom_to_string'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('atom_to_number'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:atom_to_number'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('char_to_code'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:char_to_code'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('cmdline_count'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:cmdline_count'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('cmdline_get'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:cmdline_get'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('cmdline_list'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:cmdline_list'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('dir_make'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:dir_make'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('dir_delete'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:dir_delete'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('dir_change'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:dir_change'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('dir_working'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:dir_working'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('dir_files'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:dir_files'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('env_get'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:env_get'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('fd_check'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:fd_check'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('fd_set_domain'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:fd_set_domain'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('fd_set_domain'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:fd_set_domain'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('fd_min'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:fd_min'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('fd_max'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:fd_max'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('fd_size'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:fd_size'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('fd_dom'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:fd_dom'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('fd_or'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:fd_or'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('fd_and'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:fd_and'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('fd_equiv'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:fd_equiv'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('fd_equiv'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:fd_equiv'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('fd_impl'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:fd_impl'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('fd_impl'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:fd_impl'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('fd_cardinality'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:fd_cardinality'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('fd_all_different'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:fd_all_different'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('fd_element'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:fd_element'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('fd_element_var'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:fd_element_var'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('fd_relation'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:fd_relation'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('fd_labeling'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:fd_labeling'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('fd_labeling'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:fd_labeling'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('fd_minimize'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:fd_minimize'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('fd_maximize'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:fd_maximize'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('fd_pac_opp'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:fd_pac_opp'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('fd_pac_add'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:fd_pac_add'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('fd_pac_sub'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:fd_pac_sub'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('fd_pac_mul'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:fd_pac_mul'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('fd_pac_div'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:fd_pac_div'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('fd_pac_eq'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:fd_pac_eq'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('fd_pac_eq'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:fd_pac_eq'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('fd_pac_neq'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:fd_pac_neq'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('fd_pac_neq'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:fd_pac_neq'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('fd_pac_lt'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:fd_pac_lt'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('fd_pac_lt'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:fd_pac_lt'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('fd_pac_le'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:fd_pac_le'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('fd_pac_le'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:fd_pac_le'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('fd_pac_gt'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:fd_pac_gt'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('fd_pac_gt'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:fd_pac_gt'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('fd_pac_ge'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:fd_pac_ge'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('fd_pac_ge'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:fd_pac_ge'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('fd_fac_opp'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:fd_fac_opp'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('fd_fac_add'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:fd_fac_add'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('fd_fac_sub'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:fd_fac_sub'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('fd_fac_mul'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:fd_fac_mul'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('fd_fac_div'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:fd_fac_div'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('fd_fac_eq'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:fd_fac_eq'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('fd_fac_eq'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:fd_fac_eq'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('fd_fac_neq'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:fd_fac_neq'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('fd_fac_neq'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:fd_fac_neq'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('fd_fac_lt'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:fd_fac_lt'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('fd_fac_lt'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:fd_fac_lt'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('fd_fac_le'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:fd_fac_le'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('fd_fac_le'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:fd_fac_le'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('fd_fac_gt'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:fd_fac_gt'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('fd_fac_gt'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:fd_fac_gt'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('fd_fac_ge'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:fd_fac_ge'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('fd_fac_ge'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:fd_fac_ge'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('file_delete'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:file_delete'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('file_exists'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:file_exists'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('file_type'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:file_type'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('io_open_read'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:io_open_read'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('io_open_write'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:io_open_write'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('io_read'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:io_read'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('io_read_term'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:io_read_term'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('io_read_term'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:io_read_term'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('io_seek'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:io_seek'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('io_write'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:io_write'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('io_flush'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:io_flush'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('io_print'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:io_print'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('io_print_endline'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:io_print_endline'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('io_endline'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:io_endline'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('io_format'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:io_format'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('io_close'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:io_close'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('iter_findall'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:iter_findall'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('list_length'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:list_length'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('list_nth1'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:list_nth1'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('number_check'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:number_check'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('number_char'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:number_char'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('number_ge'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:number_ge'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('number_gt'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:number_gt'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('number_le'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:number_le'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('number_lt'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:number_lt'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('number_pred'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:number_pred'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('number_succ'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:number_succ'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('number_opp'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:number_opp'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('number_add'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:number_add'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('number_sub'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:number_sub'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('number_mul'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:number_mul'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('number_div'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:number_div'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('number_quo'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:number_quo'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('number_mod'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:number_mod'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('number_to_atom'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:number_to_atom'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('os_architecture'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:os_architecture'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('os_version'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:os_version'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('ref_backtrackable_new'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:ref_backtrackable_new'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('ref_backtrackable_get'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:ref_backtrackable_get'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('ref_backtrackable_set'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:ref_backtrackable_set'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('ref_non_backtrackable_new'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:ref_non_backtrackable_new'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('ref_non_backtrackable_get'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:ref_non_backtrackable_get'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('ref_non_backtrackable_set'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:ref_non_backtrackable_set'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('socket'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:socket'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('socket_bind'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:socket_bind'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('socket_listen'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:socket_listen'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('socket_accept'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:socket_accept'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('stderr_endline', __36env, _, __36CutLevel), ','('!', '<module>:kernel:stderr_endline'(__36env, __36CutLevel))).
':-'('<module>:kernel'('stderr_flush', __36env, _, __36CutLevel), ','('!', '<module>:kernel:stderr_flush'(__36env, __36CutLevel))).
':-'('<module>:kernel'('stderr_format'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:stderr_format'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('stderr_print'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:stderr_print'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('stderr_print_endline'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:stderr_print_endline'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('stdio_read'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:stdio_read'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('stdio_read_term'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:stdio_read_term'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('stdio_read_term'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:stdio_read_term'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('stdio_write'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:stdio_write'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('stdio_endline', __36env, _, __36CutLevel), ','('!', '<module>:kernel:stdio_endline'(__36env, __36CutLevel))).
':-'('<module>:kernel'('stdio_flush', __36env, _, __36CutLevel), ','('!', '<module>:kernel:stdio_flush'(__36env, __36CutLevel))).
':-'('<module>:kernel'('stdio_format'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:stdio_format'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('stdio_print'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:stdio_print'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('stdio_print_endline'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:stdio_print_endline'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('string_to_atom'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:string_to_atom'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('string_to_number'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:string_to_number'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('string_print'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:string_print'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('string_format'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:string_format'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('sys_abort', __36env, _, __36CutLevel), ','('!', '<module>:kernel:sys_abort'(__36env, __36CutLevel))).
':-'('<module>:kernel'('sys_exit'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:sys_exit'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('sys_halt', __36env, _, __36CutLevel), ','('!', '<module>:kernel:sys_halt'(__36env, __36CutLevel))).
':-'('<module>:kernel'('sys_exec'(_____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:sys_exec'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('sys_exec'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:sys_exec'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('sys_spawn'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:sys_spawn'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('sys_file_real'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:sys_file_real'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('sys_file_absolute'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:sys_file_absolute'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('sys_file_last_modification'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:sys_file_last_modification'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('sys_wait'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:sys_wait'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('random_randomize', __36env, _, __36CutLevel), ','('!', '<module>:kernel:random_randomize'(__36env, __36CutLevel))).
':-'('<module>:kernel'('random_get_seed'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:random_get_seed'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('random_set_seed'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:random_set_seed'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('random_random'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:random_random'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('random_random'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:random_random'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('record_new'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:record_new'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('record_get'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:record_get'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('record_keys'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:record_keys'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('var_check'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:var_check'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('var_pure'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:var_pure'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('var_name_query_vars'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:var_name_query_vars'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('term_check'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:term_check'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('term_compare'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:term_compare'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('term_ge'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:term_ge'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('term_gt'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:term_gt'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('term_le'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:term_le'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('term_lt'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:term_lt'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('term_decomposition'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:term_decomposition'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('term_functor'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:term_functor'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('term_arg0'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:term_arg0'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('term_arg1'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:term_arg1'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('term_setarg0'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:term_setarg0'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('term_setarg1'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:term_setarg1'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'('term_copy'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:kernel:term_copy'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel'(__36t, __36env, __36pos, __36CutLevel), '<module>:kernel$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:kernel$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:kernel$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:kernel$has_predicate'('=>'(_____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('g_array'(_____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('+'(_____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('some'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('absolute_file_name'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('real_file_name'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('stderr'(_____1)), 'true').
':-'('<module>:kernel$has_predicate'('dec'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('write'(_____1)), 'true').
':-'('<module>:kernel$has_predicate'('read'(_____1)), 'true').
':-'('<module>:kernel$has_predicate'('emop_call'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('objective'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('backtrackable_atoms'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('inc'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('backtrackable_atom_capacity'(_____1)), 'true').
':-'('<module>:kernel$has_predicate'('backtrackable_atom_count'(_____1)), 'true').
':-'('<module>:kernel$has_predicate'('array_spec'(_____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('array_backtrackable_new'(_____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('array_backtrackable_get'(_____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('array_backtrackable_set'(_____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('array_non_backtrackable_new'(_____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('array_non_backtrackable_get'(_____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('array_non_backtrackable_set'(_____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('atom_check'(_____1)), 'true').
':-'('<module>:kernel$has_predicate'('atom_length'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('atom_new'(_____1)), 'true').
':-'('<module>:kernel$has_predicate'('atom_new_backtrackable'(_____1)), 'true').
':-'('<module>:kernel$has_predicate'('atom_concat'(_____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('atom_format'(_____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('atom_sub'(_____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('atom_to_string'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('atom_to_number'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('char_to_code'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('cmdline_count'(_____1)), 'true').
':-'('<module>:kernel$has_predicate'('cmdline_get'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('cmdline_list'(_____1)), 'true').
':-'('<module>:kernel$has_predicate'('dir_make'(_____1)), 'true').
':-'('<module>:kernel$has_predicate'('dir_delete'(_____1)), 'true').
':-'('<module>:kernel$has_predicate'('dir_change'(_____1)), 'true').
':-'('<module>:kernel$has_predicate'('dir_working'(_____1)), 'true').
':-'('<module>:kernel$has_predicate'('dir_files'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('env_get'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('fd_check'(_____1)), 'true').
':-'('<module>:kernel$has_predicate'('fd_set_domain'(_____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('fd_set_domain'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('fd_min'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('fd_max'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('fd_size'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('fd_dom'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('fd_or'(_____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('fd_and'(_____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('fd_equiv'(_____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('fd_equiv'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('fd_impl'(_____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('fd_impl'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('fd_cardinality'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('fd_all_different'(_____1)), 'true').
':-'('<module>:kernel$has_predicate'('fd_element'(_____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('fd_element_var'(_____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('fd_relation'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('fd_labeling'(_____1)), 'true').
':-'('<module>:kernel$has_predicate'('fd_labeling'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('fd_minimize'(_____1)), 'true').
':-'('<module>:kernel$has_predicate'('fd_maximize'(_____1)), 'true').
':-'('<module>:kernel$has_predicate'('fd_pac_opp'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('fd_pac_add'(_____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('fd_pac_sub'(_____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('fd_pac_mul'(_____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('fd_pac_div'(_____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('fd_pac_eq'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('fd_pac_eq'(_____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('fd_pac_neq'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('fd_pac_neq'(_____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('fd_pac_lt'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('fd_pac_lt'(_____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('fd_pac_le'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('fd_pac_le'(_____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('fd_pac_gt'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('fd_pac_gt'(_____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('fd_pac_ge'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('fd_pac_ge'(_____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('fd_fac_opp'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('fd_fac_add'(_____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('fd_fac_sub'(_____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('fd_fac_mul'(_____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('fd_fac_div'(_____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('fd_fac_eq'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('fd_fac_eq'(_____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('fd_fac_neq'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('fd_fac_neq'(_____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('fd_fac_lt'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('fd_fac_lt'(_____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('fd_fac_le'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('fd_fac_le'(_____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('fd_fac_gt'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('fd_fac_gt'(_____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('fd_fac_ge'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('fd_fac_ge'(_____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('file_delete'(_____1)), 'true').
':-'('<module>:kernel$has_predicate'('file_exists'(_____1)), 'true').
':-'('<module>:kernel$has_predicate'('file_type'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('io_open_read'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('io_open_write'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('io_read'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('io_read_term'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('io_read_term'(_____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('io_seek'(_____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('io_write'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('io_flush'(_____1)), 'true').
':-'('<module>:kernel$has_predicate'('io_print'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('io_print_endline'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('io_endline'(_____1)), 'true').
':-'('<module>:kernel$has_predicate'('io_format'(_____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('io_close'(_____1)), 'true').
':-'('<module>:kernel$has_predicate'('iter_findall'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('list_length'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('list_nth1'(_____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('number_check'(_____1)), 'true').
':-'('<module>:kernel$has_predicate'('number_char'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('number_ge'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('number_gt'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('number_le'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('number_lt'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('number_pred'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('number_succ'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('number_opp'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('number_add'(_____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('number_sub'(_____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('number_mul'(_____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('number_div'(_____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('number_quo'(_____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('number_mod'(_____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('number_to_atom'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('os_architecture'(_____1)), 'true').
':-'('<module>:kernel$has_predicate'('os_version'(_____1)), 'true').
':-'('<module>:kernel$has_predicate'('ref_backtrackable_new'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('ref_backtrackable_get'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('ref_backtrackable_set'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('ref_non_backtrackable_new'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('ref_non_backtrackable_get'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('ref_non_backtrackable_set'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('socket'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('socket_bind'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('socket_listen'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('socket_accept'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('stderr_endline'), 'true').
':-'('<module>:kernel$has_predicate'('stderr_flush'), 'true').
':-'('<module>:kernel$has_predicate'('stderr_format'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('stderr_print'(_____1)), 'true').
':-'('<module>:kernel$has_predicate'('stderr_print_endline'(_____1)), 'true').
':-'('<module>:kernel$has_predicate'('stdio_read'(_____1)), 'true').
':-'('<module>:kernel$has_predicate'('stdio_read_term'(_____1)), 'true').
':-'('<module>:kernel$has_predicate'('stdio_read_term'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('stdio_write'(_____1)), 'true').
':-'('<module>:kernel$has_predicate'('stdio_endline'), 'true').
':-'('<module>:kernel$has_predicate'('stdio_flush'), 'true').
':-'('<module>:kernel$has_predicate'('stdio_format'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('stdio_print'(_____1)), 'true').
':-'('<module>:kernel$has_predicate'('stdio_print_endline'(_____1)), 'true').
':-'('<module>:kernel$has_predicate'('string_to_atom'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('string_to_number'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('string_print'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('string_format'(_____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('sys_abort'), 'true').
':-'('<module>:kernel$has_predicate'('sys_exit'(_____1)), 'true').
':-'('<module>:kernel$has_predicate'('sys_halt'), 'true').
':-'('<module>:kernel$has_predicate'('sys_exec'(_____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('sys_exec'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('sys_spawn'(_____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('sys_file_real'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('sys_file_absolute'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('sys_file_last_modification'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('sys_wait'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('random_randomize'), 'true').
':-'('<module>:kernel$has_predicate'('random_get_seed'(_____1)), 'true').
':-'('<module>:kernel$has_predicate'('random_set_seed'(_____1)), 'true').
':-'('<module>:kernel$has_predicate'('random_random'(_____1)), 'true').
':-'('<module>:kernel$has_predicate'('random_random'(_____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('record_new'(_____1)), 'true').
':-'('<module>:kernel$has_predicate'('record_get'(_____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('record_keys'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('var_check'(_____1)), 'true').
':-'('<module>:kernel$has_predicate'('var_pure'(_____1)), 'true').
':-'('<module>:kernel$has_predicate'('var_name_query_vars'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('term_check'(_____1)), 'true').
':-'('<module>:kernel$has_predicate'('term_compare'(_____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('term_ge'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('term_gt'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('term_le'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('term_lt'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('term_decomposition'(_____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('term_functor'(_____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('term_arg0'(_____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('term_arg1'(_____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('term_setarg0'(_____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('term_setarg1'(_____3, _____2, _____1)), 'true').
':-'('<module>:kernel$has_predicate'('term_copy'(_____2, _____1)), 'true').
':-'('<module>:kernel:$sgn'(__36sgn, 'env', __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/kernel.mpl',0,0,0)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/kernel.mpl',20,0,0)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','(','('true', '<module>:kernel:atom_fresh_[1086]'(_atom__fresh___911087_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1088]'(_atom__fresh___911089_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1090]'(_atom__fresh___911091_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1092]'(_atom__fresh___911093_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1094]'(_atom__fresh___911095_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1096]'(_atom__fresh___911097_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1098]'(_atom__fresh___911099_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1100]'(_atom__fresh___911101_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1102]'(_atom__fresh___911103_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1104]'(_atom__fresh___911105_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1106]'(_atom__fresh___911107_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1108]'(_atom__fresh___911109_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1110]'(_atom__fresh___911111_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1112]'(_atom__fresh___911113_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1114]'(_atom__fresh___911115_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1116]'(_atom__fresh___911117_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1118]'(_atom__fresh___911119_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1120]'(_atom__fresh___911121_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1122]'(_atom__fresh___911123_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1124]'(_atom__fresh___911125_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1126]'(_atom__fresh___911127_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1128]'(_atom__fresh___911129_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1130]'(_atom__fresh___911131_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1132]'(_atom__fresh___911133_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1134]'(_atom__fresh___911135_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1136]'(_atom__fresh___911137_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1138]'(_atom__fresh___911139_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1140]'(_atom__fresh___911141_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1142]'(_atom__fresh___911143_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1144]'(_atom__fresh___911145_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1146]'(_atom__fresh___911147_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1148]'(_atom__fresh___911149_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1150]'(_atom__fresh___911151_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1152]'(_atom__fresh___911153_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1154]'(_atom__fresh___911155_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1156]'(_atom__fresh___911157_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1158]'(_atom__fresh___911159_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1160]'(_atom__fresh___911161_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1162]'(_atom__fresh___911163_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1164]'(_atom__fresh___911165_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1166]'(_atom__fresh___911167_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1168]'(_atom__fresh___911169_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1170]'(_atom__fresh___911171_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1172]'(_atom__fresh___911173_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1174]'(_atom__fresh___911175_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1176]'(_atom__fresh___911177_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1178]'(_atom__fresh___911179_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1180]'(_atom__fresh___911181_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1182]'(_atom__fresh___911183_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1184]'(_atom__fresh___911185_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1186]'(_atom__fresh___911187_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1188]'(_atom__fresh___911189_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1190]'(_atom__fresh___911191_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1192]'(_atom__fresh___911193_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1194]'(_atom__fresh___911195_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1196]'(_atom__fresh___911197_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1198]'(_atom__fresh___911199_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1200]'(_atom__fresh___911201_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1202]'(_atom__fresh___911203_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1204]'(_atom__fresh___911205_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1206]'(_atom__fresh___911207_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1208]'(_atom__fresh___911209_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1210]'(_atom__fresh___911211_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1212]'(_atom__fresh___911213_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1214]'(_atom__fresh___911215_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1216]'(_atom__fresh___911217_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1218]'(_atom__fresh___911219_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1220]'(_atom__fresh___911221_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1222]'(_atom__fresh___911223_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1224]'(_atom__fresh___911225_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1226]'(_atom__fresh___911227_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1228]'(_atom__fresh___911229_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1230]'(_atom__fresh___911231_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1232]'(_atom__fresh___911233_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1234]'(_atom__fresh___911235_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1236]'(_atom__fresh___911237_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1238]'(_atom__fresh___911239_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1240]'(_atom__fresh___911241_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1242]'(_atom__fresh___911243_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1244]'(_atom__fresh___911245_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1246]'(_atom__fresh___911247_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1248]'(_atom__fresh___911249_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1250]'(_atom__fresh___911251_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1252]'(_atom__fresh___911253_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1254]'(_atom__fresh___911255_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1256]'(_atom__fresh___911257_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1258]'(_atom__fresh___911259_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1260]'(_atom__fresh___911261_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1262]'(_atom__fresh___911263_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1264]'(_atom__fresh___911265_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1266]'(_atom__fresh___911267_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1268]'(_atom__fresh___911269_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1270]'(_atom__fresh___911271_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1272]'(_atom__fresh___911273_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1274]'(_atom__fresh___911275_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1276]'(_atom__fresh___911277_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1278]'(_atom__fresh___911279_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1280]'(_atom__fresh___911281_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1282]'(_atom__fresh___911283_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1284]'(_atom__fresh___911285_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1286]'(_atom__fresh___911287_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1288]'(_atom__fresh___911289_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1290]'(_atom__fresh___911291_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1292]'(_atom__fresh___911293_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1294]'(_atom__fresh___911295_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1296]'(_atom__fresh___911297_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1298]'(_atom__fresh___911299_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1300]'(_atom__fresh___911301_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1302]'(_atom__fresh___911303_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1304]'(_atom__fresh___911305_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1306]'(_atom__fresh___911307_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1308]'(_atom__fresh___911309_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1310]'(_atom__fresh___911311_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1312]'(_atom__fresh___911313_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1314]'(_atom__fresh___911315_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1316]'(_atom__fresh___911317_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1318]'(_atom__fresh___911319_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1320]'(_atom__fresh___911321_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1322]'(_atom__fresh___911323_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1324]'(_atom__fresh___911325_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1326]'(_atom__fresh___911327_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1328]'(_atom__fresh___911329_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1330]'(_atom__fresh___911331_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1332]'(_atom__fresh___911333_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1334]'(_atom__fresh___911335_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1336]'(_atom__fresh___911337_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1338]'(_atom__fresh___911339_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1340]'(_atom__fresh___911341_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1342]'(_atom__fresh___911343_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1344]'(_atom__fresh___911345_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1346]'(_atom__fresh___911347_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1348]'(_atom__fresh___911349_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1350]'(_atom__fresh___911351_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1352]'(_atom__fresh___911353_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1354]'(_atom__fresh___911355_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1356]'(_atom__fresh___911357_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1358]'(_atom__fresh___911359_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1360]'(_atom__fresh___911361_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1362]'(_atom__fresh___911363_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1364]'(_atom__fresh___911365_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1366]'(_atom__fresh___911367_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1368]'(_atom__fresh___911369_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1370]'(_atom__fresh___911371_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1372]'(_atom__fresh___911373_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1374]'(_atom__fresh___911375_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1376]'(_atom__fresh___911377_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1378]'(_atom__fresh___911379_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1380]'(_atom__fresh___911381_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1382]'(_atom__fresh___911383_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1384]'(_atom__fresh___911385_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1386]'(_atom__fresh___911387_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1388]'(_atom__fresh___911389_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1390]'(_atom__fresh___911391_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1392]'(_atom__fresh___911393_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1394]'(_atom__fresh___911395_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1396]'(_atom__fresh___911397_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1398]'(_atom__fresh___911399_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1400]'(_atom__fresh___911401_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1402]'(_atom__fresh___911403_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1404]'(_atom__fresh___911405_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1406]'(_atom__fresh___911407_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1408]'(_atom__fresh___911409_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1410]'(_atom__fresh___911411_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1412]'(_atom__fresh___911413_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1414]'(_atom__fresh___911415_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1416]'(_atom__fresh___911417_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1418]'(_atom__fresh___911419_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1420]'(_atom__fresh___911421_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1422]'(_atom__fresh___911423_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1424]'(_atom__fresh___911425_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1426]'(_atom__fresh___911427_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1428]'(_atom__fresh___911429_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1430]'(_atom__fresh___911431_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1432]'(_atom__fresh___911433_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1434]'(_atom__fresh___911435_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1436]'(_atom__fresh___911437_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1438]'(_atom__fresh___911439_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1440]'(_atom__fresh___911441_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1442]'(_atom__fresh___911443_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1444]'(_atom__fresh___911445_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1446]'(_atom__fresh___911447_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1448]'(_atom__fresh___911449_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1450]'(_atom__fresh___911451_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1452]'(_atom__fresh___911453_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1454]'(_atom__fresh___911455_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1456]'(_atom__fresh___911457_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1458]'(_atom__fresh___911459_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1460]'(_atom__fresh___911461_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1462]'(_atom__fresh___911463_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1464]'(_atom__fresh___911465_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1466]'(_atom__fresh___911467_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1468]'(_atom__fresh___911469_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1470]'(_atom__fresh___911471_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1472]'(_atom__fresh___911473_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1474]'(_atom__fresh___911475_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1476]'(_atom__fresh___911477_93, __36Pb, __36Pe)), '<module>:kernel:atom_fresh_[1478]'(_atom__fresh___911479_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___911479_93, '.'(_atom__fresh___911477_93, '.'(_atom__fresh___911475_93, '.'(_atom__fresh___911473_93, '.'(_atom__fresh___911471_93, '.'(_atom__fresh___911469_93, '.'(_atom__fresh___911467_93, '.'(_atom__fresh___911465_93, '.'(_atom__fresh___911463_93, '.'(_atom__fresh___911461_93, '.'(_atom__fresh___911459_93, '.'(_atom__fresh___911457_93, '.'(_atom__fresh___911455_93, '.'(_atom__fresh___911453_93, '.'(_atom__fresh___911451_93, '.'(_atom__fresh___911449_93, '.'(_atom__fresh___911447_93, '.'(_atom__fresh___911445_93, '.'(_atom__fresh___911443_93, '.'(_atom__fresh___911441_93, '.'(_atom__fresh___911439_93, '.'(_atom__fresh___911437_93, '.'(_atom__fresh___911435_93, '.'(_atom__fresh___911433_93, '.'(_atom__fresh___911431_93, '.'(_atom__fresh___911429_93, '.'(_atom__fresh___911427_93, '.'(_atom__fresh___911425_93, '.'(_atom__fresh___911423_93, '.'(_atom__fresh___911421_93, '.'(_atom__fresh___911419_93, '.'(_atom__fresh___911417_93, '.'(_atom__fresh___911415_93, '.'(_atom__fresh___911413_93, '.'(_atom__fresh___911411_93, '.'(_atom__fresh___911409_93, '.'(_atom__fresh___911407_93, '.'(_atom__fresh___911405_93, '.'(_atom__fresh___911403_93, '.'(_atom__fresh___911401_93, '.'(_atom__fresh___911399_93, '.'(_atom__fresh___911397_93, '.'(_atom__fresh___911395_93, '.'(_atom__fresh___911393_93, '.'(_atom__fresh___911391_93, '.'(_atom__fresh___911389_93, '.'(_atom__fresh___911387_93, '.'(_atom__fresh___911385_93, '.'(_atom__fresh___911383_93, '.'(_atom__fresh___911381_93, '.'(_atom__fresh___911379_93, '.'(_atom__fresh___911377_93, '.'(_atom__fresh___911375_93, '.'(_atom__fresh___911373_93, '.'(_atom__fresh___911371_93, '.'(_atom__fresh___911369_93, '.'(_atom__fresh___911367_93, '.'(_atom__fresh___911365_93, '.'(_atom__fresh___911363_93, '.'(_atom__fresh___911361_93, '.'(_atom__fresh___911359_93, '.'(_atom__fresh___911357_93, '.'(_atom__fresh___911355_93, '.'(_atom__fresh___911353_93, '.'(_atom__fresh___911351_93, '.'(_atom__fresh___911349_93, '.'(_atom__fresh___911347_93, '.'(_atom__fresh___911345_93, '.'(_atom__fresh___911343_93, '.'(_atom__fresh___911341_93, '.'(_atom__fresh___911339_93, '.'(_atom__fresh___911337_93, '.'(_atom__fresh___911335_93, '.'(_atom__fresh___911333_93, '.'(_atom__fresh___911331_93, '.'(_atom__fresh___911329_93, '.'(_atom__fresh___911327_93, '.'(_atom__fresh___911325_93, '.'(_atom__fresh___911323_93, '.'(_atom__fresh___911321_93, '.'(_atom__fresh___911319_93, '.'(_atom__fresh___911317_93, '.'(_atom__fresh___911315_93, '.'(_atom__fresh___911313_93, '.'(_atom__fresh___911311_93, '.'(_atom__fresh___911309_93, '.'(_atom__fresh___911307_93, '.'(_atom__fresh___911305_93, '.'(_atom__fresh___911303_93, '.'(_atom__fresh___911301_93, '.'(_atom__fresh___911299_93, '.'(_atom__fresh___911297_93, '.'(_atom__fresh___911295_93, '.'(_atom__fresh___911293_93, '.'(_atom__fresh___911291_93, '.'(_atom__fresh___911289_93, '.'(_atom__fresh___911287_93, '.'(_atom__fresh___911285_93, '.'(_atom__fresh___911283_93, '.'(_atom__fresh___911281_93, '.'(_atom__fresh___911279_93, '.'(_atom__fresh___911277_93, '.'(_atom__fresh___911275_93, '.'(_atom__fresh___911273_93, '.'(_atom__fresh___911271_93, '.'(_atom__fresh___911269_93, '.'(_atom__fresh___911267_93, '.'(_atom__fresh___911265_93, '.'(_atom__fresh___911263_93, '.'(_atom__fresh___911261_93, '.'(_atom__fresh___911259_93, '.'(_atom__fresh___911257_93, '.'(_atom__fresh___911255_93, '.'(_atom__fresh___911253_93, '.'(_atom__fresh___911251_93, '.'(_atom__fresh___911249_93, '.'(_atom__fresh___911247_93, '.'(_atom__fresh___911245_93, '.'(_atom__fresh___911243_93, '.'(_atom__fresh___911241_93, '.'(_atom__fresh___911239_93, '.'(_atom__fresh___911237_93, '.'(_atom__fresh___911235_93, '.'(_atom__fresh___911233_93, '.'(_atom__fresh___911231_93, '.'(_atom__fresh___911229_93, '.'(_atom__fresh___911227_93, '.'(_atom__fresh___911225_93, '.'(_atom__fresh___911223_93, '.'(_atom__fresh___911221_93, '.'(_atom__fresh___911219_93, '.'(_atom__fresh___911217_93, '.'(_atom__fresh___911215_93, '.'(_atom__fresh___911213_93, '.'(_atom__fresh___911211_93, '.'(_atom__fresh___911209_93, '.'(_atom__fresh___911207_93, '.'(_atom__fresh___911205_93, '.'(_atom__fresh___911203_93, '.'(_atom__fresh___911201_93, '.'(_atom__fresh___911199_93, '.'(_atom__fresh___911197_93, '.'(_atom__fresh___911195_93, '.'(_atom__fresh___911193_93, '.'(_atom__fresh___911191_93, '.'(_atom__fresh___911189_93, '.'(_atom__fresh___911187_93, '.'(_atom__fresh___911185_93, '.'(_atom__fresh___911183_93, '.'(_atom__fresh___911181_93, '.'(_atom__fresh___911179_93, '.'(_atom__fresh___911177_93, '.'(_atom__fresh___911175_93, '.'(_atom__fresh___911173_93, '.'(_atom__fresh___911171_93, '.'(_atom__fresh___911169_93, '.'(_atom__fresh___911167_93, '.'(_atom__fresh___911165_93, '.'(_atom__fresh___911163_93, '.'(_atom__fresh___911161_93, '.'(_atom__fresh___911159_93, '.'(_atom__fresh___911157_93, '.'(_atom__fresh___911155_93, '.'(_atom__fresh___911153_93, '.'(_atom__fresh___911151_93, '.'(_atom__fresh___911149_93, '.'(_atom__fresh___911147_93, '.'(_atom__fresh___911145_93, '.'(_atom__fresh___911143_93, '.'(_atom__fresh___911141_93, '.'(_atom__fresh___911139_93, '.'(_atom__fresh___911137_93, '.'(_atom__fresh___911135_93, '.'(_atom__fresh___911133_93, '.'(_atom__fresh___911131_93, '.'(_atom__fresh___911129_93, '.'(_atom__fresh___911127_93, '.'(_atom__fresh___911125_93, '.'(_atom__fresh___911123_93, '.'(_atom__fresh___911121_93, '.'(_atom__fresh___911119_93, '.'(_atom__fresh___911117_93, '.'(_atom__fresh___911115_93, '.'(_atom__fresh___911113_93, '.'(_atom__fresh___911111_93, '.'(_atom__fresh___911109_93, '.'(_atom__fresh___911107_93, '.'(_atom__fresh___911105_93, '.'(_atom__fresh___911103_93, '.'(_atom__fresh___911101_93, '.'(_atom__fresh___911099_93, '.'(_atom__fresh___911097_93, '.'(_atom__fresh___911095_93, '.'(_atom__fresh___911093_93, '.'(_atom__fresh___911091_93, '.'(_atom__fresh___911089_93, '.'(_atom__fresh___911087_93, '[]'))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))).
':-'('<module>:kernel:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel:+'(___17, ___18, ___19, 'env', __36CutLevel), '=..'(___19, '.'('+', '.'(___17, '.'(___18, '[]'))))).
':-'('<module>:kernel:+$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:+'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:=>'(___11, ___12, ___13, 'env', __36CutLevel), '=..'(___13, '.'('=>', '.'(___11, '.'(___12, '[]'))))).
':-'('<module>:kernel:=>$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:=>'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:absolute_file_name'(___22, ___23, 'env', __36CutLevel), '=..'(___23, '.'('absolute_file_name', '.'(___22, '[]')))).
':-'('<module>:kernel:absolute_file_name$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:absolute_file_name'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:array_backtrackable_get'(_Array, _Indexes, _Value, 'env', __36CutLevel), ','('=..'(_Term, '.'(_Array, _Indexes)), 'g_read'(_Term, _Value))).
':-'('<module>:kernel:array_backtrackable_get$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:array_backtrackable_get'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:array_backtrackable_new'(_Sizes, _InitialValue, _Array, 'env', __36CutLevel), ','(','('g_read'('kernel', '<module>:kernel'(___47)), '<module>:kernel:array_spec$direct'(_Sizes, _InitialValue, _Spec, ___47)), ','(','('g_read'('kernel', '<module>:kernel'(___48)), '<module>:kernel:atom_new_backtrackable$direct'(_Array, ___48)), 'g_link'(_Array, _Spec)))).
':-'('<module>:kernel:array_backtrackable_new$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:array_backtrackable_new'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:array_backtrackable_set'(_Array, _Indexes, _Value, 'env', __36CutLevel), ','('=..'(_Term, '.'(_Array, _Indexes)), 'g_link'(_Term, _Value))).
':-'('<module>:kernel:array_backtrackable_set$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:array_backtrackable_set'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:array_non_backtrackable_get'(_Array, _Indexes, _Value, 'env', __36CutLevel), ','('=..'(_Term, '.'(_Array, _Indexes)), 'g_read'(_Term, _Value))).
':-'('<module>:kernel:array_non_backtrackable_get$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:array_non_backtrackable_get'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:array_non_backtrackable_new'(_Sizes, _InitialValue, _Array, 'env', __36CutLevel), ','(','('g_read'('kernel', '<module>:kernel'(___54)), '<module>:kernel:array_spec$direct'(_Sizes, _InitialValue, _Spec, ___54)), ','(','('g_read'('kernel', '<module>:kernel'(___55)), '<module>:kernel:atom_new_backtrackable$direct'(_Array, ___55)), 'g_assign'(_Array, _Spec)))).
':-'('<module>:kernel:array_non_backtrackable_new$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:array_non_backtrackable_new'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:array_non_backtrackable_set'(_Array, _Indexes, _Value, 'env', __36CutLevel), ','('=..'(_Term, '.'(_Array, _Indexes)), 'g_assign'(_Term, _Value))).
':-'('<module>:kernel:array_non_backtrackable_set$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:array_non_backtrackable_set'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:array_spec'('[]', _InitialValue, _InitialValue, 'env', __36CutLevel), 'true').
':-'('<module>:kernel:array_spec'('.'(_H, _T), _InitialValue, 'g_array'(_H, _A), 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___46)), '<module>:kernel:array_spec$direct'(_T, _InitialValue, _A, ___46))).
':-'('<module>:kernel:array_spec$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:array_spec'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:atom_check'(_Atom, 'env', __36CutLevel), 'atom'(_Atom)).
':-'('<module>:kernel:atom_check$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:atom_check'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel:atom_concat'(_A, _B, _R, 'env', __36CutLevel), 'atom_concat'(_A, _B, _R)).
':-'('<module>:kernel:atom_concat$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:atom_concat'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:atom_format'(_Format, _Args, _Atom, 'env', __36CutLevel), 'format_to_atom'(_Atom, _Format, _Args)).
':-'('<module>:kernel:atom_format$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:atom_format'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:atom_fresh_[1086]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(term_copy, 2, predicate, suspended([var('Term0'),var('Term1')],[call(atom(top),copy_term,[var('Term0'),var('Term1')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1088]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(term_setarg1, 3, predicate, suspended([var('I'),var('Term'),var('Arg')],[call(atom(top),setarg,[var('I'),var('Term'),var('Arg')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1090]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(term_setarg0, 3, predicate, suspended([var('I'),var('Term'),var('Arg')],[call(atom(top),is,[var('J'),none]),call(atom(top),setarg,[var('J'),var('Term'),var('Arg')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1092]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(term_arg1, 3, predicate, suspended([var('I'),var('Term'),var('Arg')],[call(atom(top),arg,[var('I'),var('Term'),var('Arg')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1094]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(term_arg0, 3, predicate, suspended([var('I'),var('Term'),var('Arg')],[call(atom(top),is,[var('J'),none]),call(atom(top),arg,[var('J'),var('Term'),var('Arg')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1096]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(term_functor, 3, predicate, suspended([var('Term'),var('F'),var('N')],[call(atom(top),functor,[var('Term'),var('F'),var('N')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1098]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(term_decomposition, 2, predicate, suspended([var('Term'),var('List')],[call(atom(top),=..,[var('Term'),var('List')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1100]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(term_lt, 2, predicate, suspended([var('A'),var('B')],[call(atom(top),@<,[var('A'),var('B')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1102]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(term_le, 2, predicate, suspended([var('A'),var('B')],[call(atom(top),@=<,[var('A'),var('B')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1104]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(term_gt, 2, predicate, suspended([var('A'),var('B')],[call(atom(top),@>,[var('A'),var('B')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1106]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(term_ge, 2, predicate, suspended([var('A'),var('B')],[call(atom(top),@>=,[var('A'),var('B')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1108]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(term_compare, 3, predicate, suspended([var('A'),var('B'),var('R')],[call(atom(top),compare,[var('R'),var('A'),var('B')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1110]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(term_check, 1, predicate, suspended([var('X')],[call(atom(top),callable,[var('X')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1112]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(var_name_query_vars, 2, predicate, suspended([var('List'),var('Rest')],[call(atom(top),name_query_vars,[var('List'),var('Rest')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1114]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(var_pure, 1, predicate, suspended([var('Var')],[call(atom(top),var,[var('Var')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1116]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(var_check, 1, predicate, suspended([var('Var')],[call(atom(top),generic_var,[var('Var')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1118]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(record_keys, 2, predicate, suspended([var('X'),var('List')],[call(atom(top),g_read,[var('X'),var('List')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1120]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(record_get, 3, predicate, '[]', __36pos))).
':-'('<module>:kernel:atom_fresh_[1122]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(record_new, 1, predicate, suspended([var('X')],[call(scope,atom_new_backtrackable,[var('X')]),call(atom(top),g_link,[var('X'),none])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1124]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(random_random, 3, predicate, suspended([var('Base'),var('Max'),var('Int')],[call(atom(top),random,[var('Base'),var('Max'),var('Int')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1126]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(random_random, 1, predicate, suspended([var('Float')],[call(atom(top),random,[var('Float')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1128]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(random_set_seed, 1, predicate, suspended([var('Seed')],[call(atom(top),set_seed,[var('Seed')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1130]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(random_get_seed, 1, predicate, suspended([var('Seed')],[call(atom(top),get_seed,[var('Seed')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1132]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(random_randomize, 0, predicate, [], __36pos))).
':-'('<module>:kernel:atom_fresh_[1134]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(sys_wait, 2, predicate, suspended([var('Pid'),var('Status')],[call(atom(top),wait,[var('Pid'),var('Status')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1136]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(sys_file_last_modification, 2, predicate, suspended([var('File'),var('Date')],[call(atom(top),file_property,[var('File'),none])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1138]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(sys_file_absolute, 2, predicate, suspended([var('File'),var('Absolute')],[call(atom(top),file_property,[var('File'),none])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1140]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(sys_file_real, 2, predicate, suspended([var('File'),var('Real')],[call(atom(top),file_property,[var('File'),none])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1142]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(sys_spawn, 3, predicate, suspended([var('Command'),var('Arguments'),var('Error_code')],[call(atom(top),spawn,[var('Command'),var('Arguments'),var('Error_code')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1144]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(sys_exec, 4, predicate, suspended([var('Command'),var('In'),var('Out'),var('Err')],[call(atom(top),exec,[var('Command'),var('In'),var('Out'),var('Err')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1146]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(sys_exec, 5, predicate, suspended([var('Command'),var('In'),var('Out'),var('Err'),var('Error_code')],[call(atom(top),exec,[var('Command'),var('In'),var('Out'),var('Err'),var('Error_code')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1148]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(sys_halt, 0, predicate, [], __36pos))).
':-'('<module>:kernel:atom_fresh_[1150]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(sys_exit, 1, predicate, suspended([var('Error_code')],[call(atom(top),halt,[var('Error_code')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1152]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(sys_abort, 0, predicate, [], __36pos))).
':-'('<module>:kernel:atom_fresh_[1154]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(string_format, 3, predicate, suspended([var('Format'),var('Args'),var('String')],[call(atom(top),format_to_chars,[var('String'),var('Format'),var('Args')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1156]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(string_print, 2, predicate, suspended([var('Term'),var('String')],[call(atom(top),print_to_chars,[var('String'),var('Term')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1158]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(string_to_number, 2, predicate, suspended([var('String'),var('Number')],[call(atom(top),number_chars,[var('Number'),var('String')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1160]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(string_to_atom, 2, predicate, suspended([var('String'),var('Atom')],[call(atom(top),atom_chars,[var('Atom'),var('String')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1162]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(stdio_print_endline, 1, predicate, '[]', __36pos))).
':-'('<module>:kernel:atom_fresh_[1164]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(stdio_print, 1, predicate, suspended([var('Term')],[call(atom(top),print,[var('Term')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1166]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(stdio_format, 2, predicate, suspended([var('Format'),var('Args')],[call(atom(top),format,[var('Format'),var('Args')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1168]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(stdio_flush, 0, predicate, [], __36pos))).
':-'('<module>:kernel:atom_fresh_[1170]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(stdio_endline, 0, predicate, [], __36pos))).
':-'('<module>:kernel:atom_fresh_[1172]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(stdio_write, 1, predicate, suspended([var('C')],[call(atom(top),put_char,[var('C')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1174]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(stdio_read_term, 2, predicate, suspended([var('C'),var('Options')],[call(atom(top),read_term,[var('C'),var('Options')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1176]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(stdio_read_term, 1, predicate, suspended([var('C')],[call(atom(top),read,[var('C')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1178]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(stdio_read, 1, predicate, suspended([var('C')],[call(atom(top),get_char,[var('C')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1180]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(stderr_print_endline, 1, predicate, '[]', __36pos))).
':-'('<module>:kernel:atom_fresh_[1182]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(stderr_print, 1, predicate, suspended([var('Term')],[call(atom(top),print,[none,var('Term')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1184]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(stderr_format, 2, predicate, suspended([var('Format'),var('Args')],[call(atom(top),format,[none,var('Format'),var('Args')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1186]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(stderr_flush, 0, predicate, suspended([],[call(atom(top),flush_output,[none])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1188]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(stderr_endline, 0, predicate, suspended([],[call(atom(top),nl,[none])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1190]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(socket_accept, 4, predicate, suspended([var('Socket'),var('Client'),var('In'),var('Out')],[call(atom(top),socket_accept,[var('Socket'),var('Client'),var('In'),var('Out')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1192]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(socket_listen, 2, predicate, suspended([var('Socket'),var('Length')],[call(atom(top),socket_listen,[var('Socket'),var('Length')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1194]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(socket_bind, 2, predicate, suspended([var('Socket'),var('Address')],[call(atom(top),socket_bind,[var('Socket'),var('Address')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1196]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(socket, 2, predicate, suspended([var('Domain'),var('Socket')],[call(atom(top),socket,[var('Domain'),var('Socket')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1198]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(ref_non_backtrackable_set, 2, predicate, suspended([var('Ref'),var('Value')],[call(atom(top),g_assign,[var('Ref'),var('Value')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1200]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(ref_non_backtrackable_get, 2, predicate, suspended([var('Ref'),var('Value')],[call(atom(top),g_read,[var('Ref'),var('Value')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1202]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(ref_non_backtrackable_new, 2, predicate, suspended([var('Initial'),var('Ref')],[call(scope,atom_new_backtrackable,[var('Ref')]),call(atom(top),g_assign,[var('Ref'),var('Initial')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1204]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(ref_backtrackable_set, 2, predicate, suspended([var('Ref'),var('Value')],[call(atom(top),g_link,[var('Ref'),var('Value')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1206]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(ref_backtrackable_get, 2, predicate, suspended([var('Ref'),var('Value')],[call(atom(top),g_read,[var('Ref'),var('Value')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1208]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(ref_backtrackable_new, 2, predicate, suspended([var('Initial'),var('Ref')],[call(scope,atom_new_backtrackable,[var('Ref')]),call(atom(top),g_link,[var('Ref'),var('Initial')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1210]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(os_version, 1, predicate, suspended([var('Version')],[call(atom(top),os_version,[var('Version')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1212]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(os_architecture, 1, predicate, suspended([var('Arch')],[call(atom(top),architecture,[var('Arch')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1214]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(number_to_atom, 2, predicate, suspended([var('N'),var('A')],[call(atom(top),number_atom,[var('N'),var('A')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1216]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(number_mod, 3, predicate, suspended([var('X'),var('Y'),var('R')],[call(atom(top),is,[var('R'),none])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1218]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(number_quo, 3, predicate, suspended([var('X'),var('Y'),var('R')],[call(atom(top),is,[var('R'),none])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1220]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(number_div, 3, predicate, suspended([var('X'),var('Y'),var('R')],[call(atom(top),is,[var('R'),none])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1222]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(number_mul, 3, predicate, suspended([var('X'),var('Y'),var('R')],[call(atom(top),is,[var('R'),none])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1224]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(number_sub, 3, predicate, suspended([var('X'),var('Y'),var('R')],[call(atom(top),is,[var('R'),none])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1226]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(number_add, 3, predicate, suspended([var('X'),var('Y'),var('R')],[call(atom(top),is,[var('R'),none])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1228]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(number_opp, 2, predicate, suspended([var('X'),var('R')],[call(atom(top),is,[var('R'),none])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1230]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(number_succ, 2, predicate, suspended([var('X'),var('Y')],[call(atom(top),is,[var('Y'),none])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1232]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(number_pred, 2, predicate, suspended([var('X'),var('Y')],[call(atom(top),is,[var('Y'),none])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1234]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(number_lt, 2, predicate, suspended([var('A'),var('B')],[call(atom(top),<,[var('A'),var('B')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1236]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(number_le, 2, predicate, suspended([var('A'),var('B')],[call(atom(top),=<,[var('A'),var('B')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1238]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(number_gt, 2, predicate, suspended([var('A'),var('B')],[call(atom(top),>,[var('A'),var('B')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1240]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(number_ge, 2, predicate, suspended([var('A'),var('B')],[call(atom(top),>=,[var('A'),var('B')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1242]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(number_char, 2, predicate, suspended([var('Code'),var('Char')],[call(atom(top),char_code,[var('Char'),var('Code')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1244]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(number_check, 1, predicate, suspended([var('X')],[call(atom(top),number,[var('X')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1246]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(list_nth1, 3, predicate, suspended([var('N'),var('L'),var('X')],[call(atom(top),nth,[var('N'),var('L'),var('X')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1248]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(list_length, 2, predicate, suspended([var('L'),var('N')],[call(atom(top),length,[var('L'),var('N')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1250]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(iter_findall, 2, predicate, suspended([var('M'),var('L')],[call(atom(top),findall,[var('X'),none,var('L')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1252]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(io_close, 1, predicate, suspended([var('Stream')],[call(atom(top),close,[var('Stream')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1254]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(io_format, 3, predicate, suspended([var('Stream'),var('Format'),var('Args')],[call(atom(top),format,[var('Stream'),var('Format'),var('Args')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1256]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(io_endline, 1, predicate, suspended([var('Stream')],[call(atom(top),nl,[var('Stream')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1258]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(io_print_endline, 2, predicate, '[]', __36pos))).
':-'('<module>:kernel:atom_fresh_[1260]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(io_print, 2, predicate, suspended([var('Stream'),var('Term')],[call(atom(top),print,[var('Stream'),var('Term')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1262]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(io_flush, 1, predicate, suspended([var('Stream')],[call(atom(top),flush_output,[var('Stream')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1264]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(io_write, 2, predicate, suspended([var('Stream'),var('Char')],[call(atom(top),put_char,[var('Stream'),var('Char')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1266]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(io_seek, 3, predicate, suspended([var('Stream'),var('Method'),var('Count')],[call(atom(top),seek,[var('Stream'),var('Method'),var('Count'),var('_')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1268]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(io_read_term, 3, predicate, suspended([var('Stream'),var('Term'),var('Options')],[call(atom(top),read_term,[var('Stream'),var('Term'),var('Options')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1270]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(io_read_term, 2, predicate, suspended([var('Stream'),var('Term')],[call(atom(top),read,[var('Stream'),var('Term')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1272]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(io_read, 2, predicate, suspended([var('Stream'),var('Char')],[call(atom(top),get_char,[var('Stream'),var('Char')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1274]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(io_open_write, 2, predicate, suspended([var('Filename'),var('Stream')],[call(atom(top),open,[var('Filename'),none,var('Stream')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1276]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(io_open_read, 2, predicate, suspended([var('Filename'),var('Stream')],[call(atom(top),open,[var('Filename'),none,var('Stream')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1278]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(file_type, 2, predicate, suspended([var('Filename'),var('Type')],[call(atom(top),file_property,[var('Filename'),none])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1280]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(file_exists, 1, predicate, suspended([var('Filename')],[call(atom(top),file_exists,[var('Filename')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1282]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(file_delete, 1, predicate, suspended([var('Filename')],[call(atom(top),delete_file,[var('Filename')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1284]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fd_fac_ge, 3, predicate, suspended([var('A'),var('B'),var('R')],[call(atom(top),#<=>,[var('R'),none])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1286]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fd_fac_ge, 2, predicate, suspended([var('A'),var('B')],[call(atom(top),#>=#,[var('A'),var('B')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1288]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fd_fac_gt, 3, predicate, suspended([var('A'),var('B'),var('R')],[call(atom(top),#<=>,[var('R'),none])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1290]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fd_fac_gt, 2, predicate, suspended([var('A'),var('B')],[call(atom(top),#>#,[var('A'),var('B')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1292]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fd_fac_le, 3, predicate, suspended([var('A'),var('B'),var('R')],[call(atom(top),#<=>,[var('R'),none])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1294]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fd_fac_le, 2, predicate, suspended([var('A'),var('B')],[call(atom(top),#=<#,[var('A'),var('B')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1296]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fd_fac_lt, 3, predicate, suspended([var('A'),var('B'),var('R')],[call(atom(top),#<=>,[var('R'),none])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1298]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fd_fac_lt, 2, predicate, suspended([var('A'),var('B')],[call(atom(top),#<#,[var('A'),var('B')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1300]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fd_fac_neq, 3, predicate, suspended([var('A'),var('B'),var('R')],[call(atom(top),#<=>,[var('R'),none])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1302]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fd_fac_neq, 2, predicate, suspended([var('A'),var('B')],[call(atom(top),#\=#,[var('A'),var('B')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1304]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fd_fac_eq, 3, predicate, suspended([var('A'),var('B'),var('R')],[call(atom(top),#<=>,[var('R'),none])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1306]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fd_fac_eq, 2, predicate, suspended([var('A'),var('B')],[call(atom(top),#=#,[var('A'),var('B')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1308]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fd_fac_div, 3, predicate, suspended([var('X'),var('Y'),var('R')],[call(atom(top),#=#,[var('R'),none])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1310]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fd_fac_mul, 3, predicate, suspended([var('X'),var('Y'),var('R')],[call(atom(top),#=#,[var('R'),none])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1312]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fd_fac_sub, 3, predicate, suspended([var('X'),var('Y'),var('R')],[call(atom(top),#=#,[var('R'),none])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1314]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fd_fac_add, 3, predicate, suspended([var('X'),var('Y'),var('R')],[call(atom(top),#=#,[var('R'),none])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1316]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fd_fac_opp, 2, predicate, suspended([var('X'),var('R')],[call(atom(top),#=#,[var('R'),none])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1318]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fd_pac_ge, 3, predicate, suspended([var('A'),var('B'),var('R')],[call(atom(top),#<=>,[var('R'),none])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1320]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fd_pac_ge, 2, predicate, suspended([var('A'),var('B')],[call(atom(top),#>=,[var('A'),var('B')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1322]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fd_pac_gt, 3, predicate, suspended([var('A'),var('B'),var('R')],[call(atom(top),#<=>,[var('R'),none])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1324]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fd_pac_gt, 2, predicate, suspended([var('A'),var('B')],[call(atom(top),#>,[var('A'),var('B')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1326]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fd_pac_le, 3, predicate, suspended([var('A'),var('B'),var('R')],[call(atom(top),#<=>,[var('R'),none])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1328]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fd_pac_le, 2, predicate, suspended([var('A'),var('B')],[call(atom(top),#=<,[var('A'),var('B')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1330]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fd_pac_lt, 3, predicate, suspended([var('A'),var('B'),var('R')],[call(atom(top),#<=>,[var('R'),none])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1332]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fd_pac_lt, 2, predicate, suspended([var('A'),var('B')],[call(atom(top),#<,[var('A'),var('B')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1334]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fd_pac_neq, 3, predicate, suspended([var('A'),var('B'),var('R')],[call(atom(top),#<=>,[var('R'),none])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1336]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fd_pac_neq, 2, predicate, suspended([var('A'),var('B')],[call(atom(top),#\=,[var('A'),var('B')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1338]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fd_pac_eq, 3, predicate, suspended([var('A'),var('B'),var('R')],[call(atom(top),#<=>,[var('R'),none])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1340]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fd_pac_eq, 2, predicate, suspended([var('A'),var('B')],[call(atom(top),#=,[var('A'),var('B')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1342]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fd_pac_div, 3, predicate, suspended([var('X'),var('Y'),var('R')],[call(atom(top),#=,[var('R'),none])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1344]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fd_pac_mul, 3, predicate, suspended([var('X'),var('Y'),var('R')],[call(atom(top),#=,[var('R'),none])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1346]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fd_pac_sub, 3, predicate, suspended([var('X'),var('Y'),var('R')],[call(atom(top),#=,[var('R'),none])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1348]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fd_pac_add, 3, predicate, suspended([var('X'),var('Y'),var('R')],[call(atom(top),#=,[var('R'),none])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1350]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fd_pac_opp, 2, predicate, suspended([var('X'),var('R')],[call(atom(top),#=,[var('R'),none])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1352]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fd_maximize, 1, predicate, suspended([var('M')],[call(atom(top),fd_maximize,[none,var('X')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1354]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fd_minimize, 1, predicate, suspended([var('M')],[call(atom(top),fd_minimize,[none,var('X')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1356]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fd_labeling, 2, predicate, suspended([var('X'),var('Opts')],[call(atom(top),fd_labeling,[var('X'),var('Opts')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1358]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fd_labeling, 1, predicate, suspended([var('X')],[call(atom(top),fd_labeling,[var('X')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1360]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fd_relation, 2, predicate, suspended([var('R'),var('List')],[call(atom(top),fd_relation,[var('R'),var('List')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1362]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fd_element_var, 3, predicate, suspended([var('I'),var('List'),var('X')],[call(atom(top),fd_element_var,[var('I'),var('List'),var('X')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1364]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fd_element, 3, predicate, suspended([var('I'),var('List'),var('X')],[call(atom(top),fd_element,[var('I'),var('List'),var('X')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1366]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fd_all_different, 1, predicate, suspended([var('List')],[call(atom(top),fd_all_different,[var('List')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1368]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fd_cardinality, 2, predicate, suspended([var('List'),var('N')],[call(atom(top),fd_cardinality,[var('List'),var('N')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1370]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fd_impl, 2, predicate, suspended([var('A'),var('B')],[call(atom(top),#==>,[var('A'),var('B')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1372]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fd_impl, 3, predicate, suspended([var('A'),var('B'),var('R')],[call(atom(top),#==>,[var('R'),none])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1374]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fd_equiv, 2, predicate, suspended([var('A'),var('B')],[call(atom(top),#<=>,[var('A'),var('B')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1376]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fd_equiv, 3, predicate, suspended([var('A'),var('B'),var('R')],[call(atom(top),#<=>,[var('R'),none])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1378]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fd_and, 3, predicate, suspended([var('A'),var('B'),var('R')],[call(atom(top),#<=>,[var('R'),none])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1380]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fd_or, 3, predicate, suspended([var('A'),var('B'),var('R')],[call(atom(top),#<=>,[var('R'),none])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1382]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fd_dom, 2, predicate, suspended([var('X'),var('Dom')],[call(atom(top),fd_dom,[var('X'),var('Dom')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1384]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fd_size, 2, predicate, suspended([var('X'),var('Size')],[call(atom(top),fd_size,[var('X'),var('Size')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1386]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fd_max, 2, predicate, suspended([var('X'),var('Max')],[call(atom(top),fd_max,[var('X'),var('Max')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1388]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fd_min, 2, predicate, suspended([var('X'),var('Min')],[call(atom(top),fd_min,[var('X'),var('Min')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1390]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fd_set_domain, 2, predicate, suspended([var('X'),var('List')],[call(atom(top),fd_domain,[var('X'),var('List')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1392]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fd_set_domain, 3, predicate, suspended([var('X'),var('Lower'),var('Upper')],[call(atom(top),fd_domain,[var('X'),var('Lower'),var('Upper')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1394]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(fd_check, 1, predicate, suspended([var('X')],[call(atom(top),fd_var,[var('X')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1396]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(env_get, 2, predicate, suspended([var('Key'),var('Value')],[call(atom(top),environ,[var('Key'),var('Value')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1398]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(dir_files, 2, predicate, suspended([var('Pathname'),var('Files')],[call(atom(top),directory_files,[var('Pathname'),var('Files')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1400]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(dir_working, 1, predicate, suspended([var('Pathname')],[call(atom(top),working_directory,[var('Pathname')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1402]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(dir_change, 1, predicate, suspended([var('Pathname')],[call(atom(top),change_directory,[var('Pathname')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1404]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(dir_delete, 1, predicate, suspended([var('Pathname')],[call(atom(top),delete_directory,[var('Pathname')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1406]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(dir_make, 1, predicate, suspended([var('Pathname')],[call(atom(top),make_directory,[var('Pathname')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1408]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(cmdline_list, 1, predicate, suspended([var('List')],[call(atom(top),argument_list,[var('List')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1410]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(cmdline_get, 2, predicate, suspended([var('Index'),var('Argument')],[call(atom(top),argument_value,[var('Index'),var('Argument')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1412]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(cmdline_count, 1, predicate, suspended([var('Count')],[call(atom(top),argument_counter,[var('Count')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1414]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(char_to_code, 2, predicate, suspended([var('Char'),var('Code')],[call(atom(top),char_code,[var('Char'),var('Code')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1416]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(atom_to_number, 2, predicate, suspended([var('Atom'),var('Number')],[call(atom(top),number_atom,[var('Number'),var('Atom')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1418]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(atom_to_string, 2, predicate, suspended([var('Atom'),var('String')],[call(atom(top),atom_chars,[var('Atom'),var('String')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1420]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(atom_sub, 5, predicate, suspended([var('Atom'),var('Before'),var('Length'),var('After'),var('SubAtom')],[call(atom(top),sub_atom,[var('Atom'),var('Before'),var('Length'),var('After'),var('SubAtom')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1422]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(atom_format, 3, predicate, suspended([var('Format'),var('Args'),var('Atom')],[call(atom(top),format_to_atom,[var('Atom'),var('Format'),var('Args')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1424]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(atom_concat, 3, predicate, suspended([var('A'),var('B'),var('R')],[call(atom(top),atom_concat,[var('A'),var('B'),var('R')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1426]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(atom_new_backtrackable, 1, predicate, '[]', __36pos))).
':-'('<module>:kernel:atom_fresh_[1428]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(atom_new, 1, predicate, '[]', __36pos))).
':-'('<module>:kernel:atom_fresh_[1430]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(atom_length, 2, predicate, suspended([var('Atom'),var('Length')],[call(atom(top),atom_length,[var('Atom'),var('Length')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1432]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(atom_check, 1, predicate, suspended([var('Atom')],[call(atom(top),atom,[var('Atom')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1434]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(array_non_backtrackable_set, 3, predicate, '[]', __36pos))).
':-'('<module>:kernel:atom_fresh_[1436]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(array_non_backtrackable_get, 3, predicate, '[]', __36pos))).
':-'('<module>:kernel:atom_fresh_[1438]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(array_non_backtrackable_new, 3, predicate, suspended([var('Sizes'),var('InitialValue'),var('Array')],[call(scope,array_spec,[var('Sizes'),var('InitialValue'),var('Spec')]),call(scope,atom_new_backtrackable,[var('Array')]),call(atom(top),g_assign,[var('Array'),var('Spec')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1440]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(array_backtrackable_set, 3, predicate, '[]', __36pos))).
':-'('<module>:kernel:atom_fresh_[1442]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(array_backtrackable_get, 3, predicate, '[]', __36pos))).
':-'('<module>:kernel:atom_fresh_[1444]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(array_backtrackable_new, 3, predicate, suspended([var('Sizes'),var('InitialValue'),var('Array')],[call(scope,array_spec,[var('Sizes'),var('InitialValue'),var('Spec')]),call(scope,atom_new_backtrackable,[var('Array')]),call(atom(top),g_link,[var('Array'),var('Spec')])]), __36pos))).
':-'('<module>:kernel:atom_fresh_[1446]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(array_spec, 3, predicate, '[]', __36pos))).
':-'('<module>:kernel:atom_fresh_[1448]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(backtrackable_atom_count, 1, constructor, none, __36pos))).
':-'('<module>:kernel:atom_fresh_[1450]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(backtrackable_atom_capacity, 1, constructor, none, __36pos))).
':-'('<module>:kernel:atom_fresh_[1452]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(inc, 2, constructor, none, __36pos))).
':-'('<module>:kernel:atom_fresh_[1454]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(backtrackable_atoms, 2, constructor, none, __36pos))).
':-'('<module>:kernel:atom_fresh_[1456]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(objective, 2, constructor, none, __36pos))).
':-'('<module>:kernel:atom_fresh_[1458]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(emop_call, 4, constructor, none, __36pos))).
':-'('<module>:kernel:atom_fresh_[1460]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(read, 1, constructor, none, __36pos))).
':-'('<module>:kernel:atom_fresh_[1462]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(write, 1, constructor, none, __36pos))).
':-'('<module>:kernel:atom_fresh_[1464]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(dec, 2, constructor, none, __36pos))).
':-'('<module>:kernel:atom_fresh_[1466]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(stderr, 1, constructor, none, __36pos))).
':-'('<module>:kernel:atom_fresh_[1468]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(real_file_name, 2, constructor, none, __36pos))).
':-'('<module>:kernel:atom_fresh_[1470]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(absolute_file_name, 2, constructor, none, __36pos))).
':-'('<module>:kernel:atom_fresh_[1472]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(some, 2, constructor, none, __36pos))).
':-'('<module>:kernel:atom_fresh_[1474]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(+, 3, constructor, none, __36pos))).
':-'('<module>:kernel:atom_fresh_[1476]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(g_array, 3, constructor, none, __36pos))).
':-'('<module>:kernel:atom_fresh_[1478]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(=>, 3, constructor, none, __36pos))).
':-'('<module>:kernel:atom_length'(_Atom, _Length, 'env', __36CutLevel), 'atom_length'(_Atom, _Length)).
':-'('<module>:kernel:atom_length$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:atom_length'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:atom_new'(_Atom, 'env', __36CutLevel), ','('g_inc'('atom_counter', _AtomCount), 'format_to_atom'(_Atom, 'atom_fresh_[~d]', '.'(_AtomCount, '[]')))).
':-'('<module>:kernel:atom_new$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:atom_new'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel:atom_new_backtrackable'(_Atom, 'env', __36CutLevel), ','('g_read'('backtrackable_atom_count', _AtomCount), ','('g_read'('backtrackable_atom_capacity', _AtomCapacity), ','('is'(_NewAtomCount, 'inc'(_AtomCount)), ','(';'('->'('>'(_NewAtomCount, _AtomCapacity), ','('is'(_NewAtomCapacity, 'inc'(_AtomCapacity)), ','(','('g_read'('kernel', '<module>:kernel'(___74)), '<module>:kernel:atom_new$direct'(_Atom, ___74)), ','('g_assign'('backtrackable_atoms'(_AtomCount), _Atom), 'g_assign'('backtrackable_atom_capacity', _NewAtomCapacity))))), 'g_read'('backtrackable_atoms'(_AtomCount), _Atom)), 'g_link'('backtrackable_atom_count', _NewAtomCount)))))).
':-'('<module>:kernel:atom_new_backtrackable$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:atom_new_backtrackable'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel:atom_sub'(_Atom, _Before, _Length, _After, _SubAtom, 'env', __36CutLevel), 'sub_atom'(_Atom, _Before, _Length, _After, _SubAtom)).
':-'('<module>:kernel:atom_sub$direct'(_____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:atom_sub'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:atom_to_number'(_Atom, _Number, 'env', __36CutLevel), 'number_atom'(_Number, _Atom)).
':-'('<module>:kernel:atom_to_number$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:atom_to_number'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:atom_to_string'(_Atom, _String, 'env', __36CutLevel), 'atom_chars'(_Atom, _String)).
':-'('<module>:kernel:atom_to_string$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:atom_to_string'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:backtrackable_atom_capacity'(___41, 'env', __36CutLevel), '=..'(___41, '.'('backtrackable_atom_capacity', '[]'))).
':-'('<module>:kernel:backtrackable_atom_capacity$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:backtrackable_atom_capacity'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel:backtrackable_atom_count'(___42, 'env', __36CutLevel), '=..'(___42, '.'('backtrackable_atom_count', '[]'))).
':-'('<module>:kernel:backtrackable_atom_count$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:backtrackable_atom_count'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel:backtrackable_atoms'(___37, ___38, 'env', __36CutLevel), '=..'(___38, '.'('backtrackable_atoms', '.'(___37, '[]')))).
':-'('<module>:kernel:backtrackable_atoms$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:backtrackable_atoms'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:char_to_code'(_Char, _Code, 'env', __36CutLevel), 'char_code'(_Char, _Code)).
':-'('<module>:kernel:char_to_code$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:char_to_code'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:cmdline_count'(_Count, 'env', __36CutLevel), 'argument_counter'(_Count)).
':-'('<module>:kernel:cmdline_count$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:cmdline_count'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel:cmdline_get'(_Index, _Argument, 'env', __36CutLevel), 'argument_value'(_Index, _Argument)).
':-'('<module>:kernel:cmdline_get$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:cmdline_get'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:cmdline_list'(_List, 'env', __36CutLevel), 'argument_list'(_List)).
':-'('<module>:kernel:cmdline_list$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:cmdline_list'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel:dec'(___27, ___28, 'env', __36CutLevel), '=..'(___28, '.'('dec', '.'(___27, '[]')))).
':-'('<module>:kernel:dec$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:dec'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:dir_change'(_Pathname, 'env', __36CutLevel), 'change_directory'(_Pathname)).
':-'('<module>:kernel:dir_change$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:dir_change'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel:dir_delete'(_Pathname, 'env', __36CutLevel), 'delete_directory'(_Pathname)).
':-'('<module>:kernel:dir_delete$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:dir_delete'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel:dir_files'(_Pathname, _Files, 'env', __36CutLevel), 'directory_files'(_Pathname, _Files)).
':-'('<module>:kernel:dir_files$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:dir_files'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:dir_make'(_Pathname, 'env', __36CutLevel), 'make_directory'(_Pathname)).
':-'('<module>:kernel:dir_make$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:dir_make'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel:dir_working'(_Pathname, 'env', __36CutLevel), 'working_directory'(_Pathname)).
':-'('<module>:kernel:dir_working$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:dir_working'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel:emop_call'(___31, ___32, ___33, ___34, 'env', __36CutLevel), '=..'(___34, '.'('emop_call', '.'(___31, '.'(___32, '.'(___33, '[]')))))).
':-'('<module>:kernel:emop_call$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:emop_call'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:env_get'(_Key, _Value, 'env', __36CutLevel), 'environ'(_Key, _Value)).
':-'('<module>:kernel:env_get$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:env_get'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:fd_all_different'(_List, 'env', __36CutLevel), 'fd_all_different'(_List)).
':-'('<module>:kernel:fd_all_different$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:fd_all_different'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel:fd_and'(_A, _B, _R, 'env', __36CutLevel), '#<=>'(_R, '#/\\'(_A, _B))).
':-'('<module>:kernel:fd_and$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:fd_and'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:fd_cardinality'(_List, _N, 'env', __36CutLevel), 'fd_cardinality'(_List, _N)).
':-'('<module>:kernel:fd_cardinality$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:fd_cardinality'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:fd_check'(_X, 'env', __36CutLevel), 'fd_var'(_X)).
':-'('<module>:kernel:fd_check$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:fd_check'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel:fd_dom'(_X, _Dom, 'env', __36CutLevel), 'fd_dom'(_X, _Dom)).
':-'('<module>:kernel:fd_dom$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:fd_dom'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:fd_element'(_I, _List, _X, 'env', __36CutLevel), 'fd_element'(_I, _List, _X)).
':-'('<module>:kernel:fd_element$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:fd_element'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:fd_element_var'(_I, _List, _X, 'env', __36CutLevel), 'fd_element_var'(_I, _List, _X)).
':-'('<module>:kernel:fd_element_var$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:fd_element_var'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:fd_equiv'(_A, _B, 'env', __36CutLevel), '#<=>'(_A, _B)).
':-'('<module>:kernel:fd_equiv'(_A, _B, _R, 'env', __36CutLevel), '#<=>'(_R, '#<=>'(_A, _B))).
':-'('<module>:kernel:fd_equiv$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:fd_equiv'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:fd_equiv$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:fd_equiv'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:fd_fac_add'(_X, _Y, _R, 'env', __36CutLevel), '#=#'(_R, '+'(_X, _Y))).
':-'('<module>:kernel:fd_fac_add$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:fd_fac_add'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:fd_fac_div'(_X, _Y, _R, 'env', __36CutLevel), '#=#'(_R, '/'(_X, _Y))).
':-'('<module>:kernel:fd_fac_div$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:fd_fac_div'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:fd_fac_eq'(_A, _B, 'env', __36CutLevel), '#=#'(_A, _B)).
':-'('<module>:kernel:fd_fac_eq'(_A, _B, _R, 'env', __36CutLevel), '#<=>'(_R, '#=#'(_A, _B))).
':-'('<module>:kernel:fd_fac_eq$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:fd_fac_eq'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:fd_fac_eq$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:fd_fac_eq'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:fd_fac_ge'(_A, _B, 'env', __36CutLevel), '#>=#'(_A, _B)).
':-'('<module>:kernel:fd_fac_ge'(_A, _B, _R, 'env', __36CutLevel), '#<=>'(_R, '#>=#'(_A, _B))).
':-'('<module>:kernel:fd_fac_ge$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:fd_fac_ge'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:fd_fac_ge$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:fd_fac_ge'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:fd_fac_gt'(_A, _B, 'env', __36CutLevel), '#>#'(_A, _B)).
':-'('<module>:kernel:fd_fac_gt'(_A, _B, _R, 'env', __36CutLevel), '#<=>'(_R, '#>#'(_A, _B))).
':-'('<module>:kernel:fd_fac_gt$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:fd_fac_gt'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:fd_fac_gt$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:fd_fac_gt'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:fd_fac_le'(_A, _B, 'env', __36CutLevel), '#=<#'(_A, _B)).
':-'('<module>:kernel:fd_fac_le'(_A, _B, _R, 'env', __36CutLevel), '#<=>'(_R, '#=<#'(_A, _B))).
':-'('<module>:kernel:fd_fac_le$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:fd_fac_le'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:fd_fac_le$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:fd_fac_le'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:fd_fac_lt'(_A, _B, 'env', __36CutLevel), '#<#'(_A, _B)).
':-'('<module>:kernel:fd_fac_lt'(_A, _B, _R, 'env', __36CutLevel), '#<=>'(_R, '#<#'(_A, _B))).
':-'('<module>:kernel:fd_fac_lt$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:fd_fac_lt'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:fd_fac_lt$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:fd_fac_lt'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:fd_fac_mul'(_X, _Y, _R, 'env', __36CutLevel), '#=#'(_R, '*'(_X, _Y))).
':-'('<module>:kernel:fd_fac_mul$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:fd_fac_mul'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:fd_fac_neq'(_A, _B, 'env', __36CutLevel), '#\\=#'(_A, _B)).
':-'('<module>:kernel:fd_fac_neq'(_A, _B, _R, 'env', __36CutLevel), '#<=>'(_R, '#\\=#'(_A, _B))).
':-'('<module>:kernel:fd_fac_neq$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:fd_fac_neq'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:fd_fac_neq$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:fd_fac_neq'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:fd_fac_opp'(_X, _R, 'env', __36CutLevel), '#=#'(_R, '-'(_X))).
':-'('<module>:kernel:fd_fac_opp$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:fd_fac_opp'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:fd_fac_sub'(_X, _Y, _R, 'env', __36CutLevel), '#=#'(_R, '-'(_X, _Y))).
':-'('<module>:kernel:fd_fac_sub$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:fd_fac_sub'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:fd_impl'(_A, _B, 'env', __36CutLevel), '#==>'(_A, _B)).
':-'('<module>:kernel:fd_impl'(_A, _B, _R, 'env', __36CutLevel), '#==>'(_R, '#==>'(_A, _B))).
':-'('<module>:kernel:fd_impl$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:fd_impl'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:fd_impl$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:fd_impl'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:fd_labeling'(_X, 'env', __36CutLevel), 'fd_labeling'(_X)).
':-'('<module>:kernel:fd_labeling'(_X, _Opts, 'env', __36CutLevel), 'fd_labeling'(_X, _Opts)).
':-'('<module>:kernel:fd_labeling$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:fd_labeling'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel:fd_labeling$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:fd_labeling'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:fd_max'(_X, _Max, 'env', __36CutLevel), 'fd_max'(_X, _Max)).
':-'('<module>:kernel:fd_max$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:fd_max'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:fd_maximize'(_M, 'env', __36CutLevel), 'fd_maximize'('emop_call'(_M, 'objective'(_X), 'fd_maximize'), _X)).
':-'('<module>:kernel:fd_maximize$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:fd_maximize'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel:fd_min'(_X, _Min, 'env', __36CutLevel), 'fd_min'(_X, _Min)).
':-'('<module>:kernel:fd_min$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:fd_min'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:fd_minimize'(_M, 'env', __36CutLevel), 'fd_minimize'('emop_call'(_M, 'objective'(_X), 'fd_minimize'), _X)).
':-'('<module>:kernel:fd_minimize$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:fd_minimize'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel:fd_or'(_A, _B, _R, 'env', __36CutLevel), '#<=>'(_R, '#\\/'(_A, _B))).
':-'('<module>:kernel:fd_or$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:fd_or'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:fd_pac_add'(_X, _Y, _R, 'env', __36CutLevel), '#='(_R, '+'(_X, _Y))).
':-'('<module>:kernel:fd_pac_add$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:fd_pac_add'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:fd_pac_div'(_X, _Y, _R, 'env', __36CutLevel), '#='(_R, '/'(_X, _Y))).
':-'('<module>:kernel:fd_pac_div$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:fd_pac_div'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:fd_pac_eq'(_A, _B, 'env', __36CutLevel), '#='(_A, _B)).
':-'('<module>:kernel:fd_pac_eq'(_A, _B, _R, 'env', __36CutLevel), '#<=>'(_R, '#='(_A, _B))).
':-'('<module>:kernel:fd_pac_eq$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:fd_pac_eq'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:fd_pac_eq$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:fd_pac_eq'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:fd_pac_ge'(_A, _B, 'env', __36CutLevel), '#>='(_A, _B)).
':-'('<module>:kernel:fd_pac_ge'(_A, _B, _R, 'env', __36CutLevel), '#<=>'(_R, '#>='(_A, _B))).
':-'('<module>:kernel:fd_pac_ge$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:fd_pac_ge'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:fd_pac_ge$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:fd_pac_ge'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:fd_pac_gt'(_A, _B, 'env', __36CutLevel), '#>'(_A, _B)).
':-'('<module>:kernel:fd_pac_gt'(_A, _B, _R, 'env', __36CutLevel), '#<=>'(_R, '#>'(_A, _B))).
':-'('<module>:kernel:fd_pac_gt$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:fd_pac_gt'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:fd_pac_gt$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:fd_pac_gt'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:fd_pac_le'(_A, _B, 'env', __36CutLevel), '#=<'(_A, _B)).
':-'('<module>:kernel:fd_pac_le'(_A, _B, _R, 'env', __36CutLevel), '#<=>'(_R, '#=<'(_A, _B))).
':-'('<module>:kernel:fd_pac_le$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:fd_pac_le'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:fd_pac_le$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:fd_pac_le'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:fd_pac_lt'(_A, _B, 'env', __36CutLevel), '#<'(_A, _B)).
':-'('<module>:kernel:fd_pac_lt'(_A, _B, _R, 'env', __36CutLevel), '#<=>'(_R, '#<'(_A, _B))).
':-'('<module>:kernel:fd_pac_lt$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:fd_pac_lt'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:fd_pac_lt$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:fd_pac_lt'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:fd_pac_mul'(_X, _Y, _R, 'env', __36CutLevel), '#='(_R, '*'(_X, _Y))).
':-'('<module>:kernel:fd_pac_mul$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:fd_pac_mul'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:fd_pac_neq'(_A, _B, 'env', __36CutLevel), '#\\='(_A, _B)).
':-'('<module>:kernel:fd_pac_neq'(_A, _B, _R, 'env', __36CutLevel), '#<=>'(_R, '#\\='(_A, _B))).
':-'('<module>:kernel:fd_pac_neq$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:fd_pac_neq'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:fd_pac_neq$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:fd_pac_neq'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:fd_pac_opp'(_X, _R, 'env', __36CutLevel), '#='(_R, '-'(_X))).
':-'('<module>:kernel:fd_pac_opp$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:fd_pac_opp'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:fd_pac_sub'(_X, _Y, _R, 'env', __36CutLevel), '#='(_R, '-'(_X, _Y))).
':-'('<module>:kernel:fd_pac_sub$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:fd_pac_sub'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:fd_relation'(_R, _List, 'env', __36CutLevel), 'fd_relation'(_R, _List)).
':-'('<module>:kernel:fd_relation$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:fd_relation'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:fd_set_domain'(_X, _List, 'env', __36CutLevel), 'fd_domain'(_X, _List)).
':-'('<module>:kernel:fd_set_domain'(_X, _Lower, _Upper, 'env', __36CutLevel), 'fd_domain'(_X, _Lower, _Upper)).
':-'('<module>:kernel:fd_set_domain$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:fd_set_domain'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:fd_set_domain$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:fd_set_domain'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:fd_size'(_X, _Size, 'env', __36CutLevel), 'fd_size'(_X, _Size)).
':-'('<module>:kernel:fd_size$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:fd_size'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:file_delete'(_Filename, 'env', __36CutLevel), 'delete_file'(_Filename)).
':-'('<module>:kernel:file_delete$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:file_delete'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel:file_exists'(_Filename, 'env', __36CutLevel), 'file_exists'(_Filename)).
':-'('<module>:kernel:file_exists$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:file_exists'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel:file_type'(_Filename, _Type, 'env', __36CutLevel), 'file_property'(_Filename, 'type'(_Type))).
':-'('<module>:kernel:file_type$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:file_type'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:g_array'(___14, ___15, ___16, 'env', __36CutLevel), '=..'(___16, '.'('g_array', '.'(___14, '.'(___15, '[]'))))).
':-'('<module>:kernel:g_array$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:g_array'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:inc'(___39, ___40, 'env', __36CutLevel), '=..'(___40, '.'('inc', '.'(___39, '[]')))).
':-'('<module>:kernel:inc$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:inc'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:io_close'(_Stream, 'env', __36CutLevel), 'close'(_Stream)).
':-'('<module>:kernel:io_close$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:io_close'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel:io_endline'(_Stream, 'env', __36CutLevel), 'nl'(_Stream)).
':-'('<module>:kernel:io_endline$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:io_endline'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel:io_flush'(_Stream, 'env', __36CutLevel), 'flush_output'(_Stream)).
':-'('<module>:kernel:io_flush$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:io_flush'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel:io_format'(_Stream, _Format, _Args, 'env', __36CutLevel), 'format'(_Stream, _Format, _Args)).
':-'('<module>:kernel:io_format$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:io_format'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:io_open_read'(_Filename, _Stream, 'env', __36CutLevel), 'open'(_Filename, 'read', _Stream)).
':-'('<module>:kernel:io_open_read$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:io_open_read'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:io_open_write'(_Filename, _Stream, 'env', __36CutLevel), 'open'(_Filename, 'write', _Stream)).
':-'('<module>:kernel:io_open_write$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:io_open_write'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:io_print'(_Stream, _Term, 'env', __36CutLevel), 'print'(_Stream, _Term)).
':-'('<module>:kernel:io_print$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:io_print'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:io_print_endline'(_Stream, _Term, 'env', __36CutLevel), ','('print'(_Stream, _Term), 'nl'(_Stream))).
':-'('<module>:kernel:io_print_endline$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:io_print_endline'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:io_read'(_Stream, _Char, 'env', __36CutLevel), 'get_char'(_Stream, _Char)).
':-'('<module>:kernel:io_read$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:io_read'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:io_read_term'(_Stream, _Term, 'env', __36CutLevel), 'read'(_Stream, _Term)).
':-'('<module>:kernel:io_read_term'(_Stream, _Term, _Options, 'env', __36CutLevel), 'read_term'(_Stream, _Term, _Options)).
':-'('<module>:kernel:io_read_term$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:io_read_term'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:io_read_term$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:io_read_term'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:io_seek'(_Stream, _Method, _Count, 'env', __36CutLevel), 'seek'(_Stream, _Method, _Count, _)).
':-'('<module>:kernel:io_seek$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:io_seek'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:io_write'(_Stream, _Char, 'env', __36CutLevel), 'put_char'(_Stream, _Char)).
':-'('<module>:kernel:io_write$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:io_write'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:iter_findall'(_M, _L, 'env', __36CutLevel), 'findall'(_X, 'emop_call'(_M, 'do'(_X), 'findall'), _L)).
':-'('<module>:kernel:iter_findall$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:iter_findall'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:list_length'(_L, _N, 'env', __36CutLevel), 'length'(_L, _N)).
':-'('<module>:kernel:list_length$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:list_length'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:list_nth1'(_N, _L, _X, 'env', __36CutLevel), 'nth'(_N, _L, _X)).
':-'('<module>:kernel:list_nth1$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:list_nth1'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:number_add'(_X, _Y, _R, 'env', __36CutLevel), 'is'(_R, '+'(_X, _Y))).
':-'('<module>:kernel:number_add$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:number_add'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:number_char'(_Code, _Char, 'env', __36CutLevel), 'char_code'(_Char, _Code)).
':-'('<module>:kernel:number_char$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:number_char'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:number_check'(_X, 'env', __36CutLevel), 'number'(_X)).
':-'('<module>:kernel:number_check$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:number_check'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel:number_div'(_X, _Y, _R, 'env', __36CutLevel), 'is'(_R, '/'(_X, _Y))).
':-'('<module>:kernel:number_div$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:number_div'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:number_ge'(_A, _B, 'env', __36CutLevel), '>='(_A, _B)).
':-'('<module>:kernel:number_ge$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:number_ge'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:number_gt'(_A, _B, 'env', __36CutLevel), '>'(_A, _B)).
':-'('<module>:kernel:number_gt$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:number_gt'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:number_le'(_A, _B, 'env', __36CutLevel), '=<'(_A, _B)).
':-'('<module>:kernel:number_le$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:number_le'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:number_lt'(_A, _B, 'env', __36CutLevel), '<'(_A, _B)).
':-'('<module>:kernel:number_lt$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:number_lt'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:number_mod'(_X, _Y, _R, 'env', __36CutLevel), 'is'(_R, 'mod'(_X, _Y))).
':-'('<module>:kernel:number_mod$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:number_mod'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:number_mul'(_X, _Y, _R, 'env', __36CutLevel), 'is'(_R, '*'(_X, _Y))).
':-'('<module>:kernel:number_mul$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:number_mul'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:number_opp'(_X, _R, 'env', __36CutLevel), 'is'(_R, '-'(_X))).
':-'('<module>:kernel:number_opp$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:number_opp'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:number_pred'(_X, _Y, 'env', __36CutLevel), 'is'(_Y, 'dec'(_X))).
':-'('<module>:kernel:number_pred$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:number_pred'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:number_quo'(_X, _Y, _R, 'env', __36CutLevel), 'is'(_R, '//'(_X, _Y))).
':-'('<module>:kernel:number_quo$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:number_quo'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:number_sub'(_X, _Y, _R, 'env', __36CutLevel), 'is'(_R, '-'(_X, _Y))).
':-'('<module>:kernel:number_sub$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:number_sub'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:number_succ'(_X, _Y, 'env', __36CutLevel), 'is'(_Y, 'inc'(_X))).
':-'('<module>:kernel:number_succ$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:number_succ'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:number_to_atom'(_N, _A, 'env', __36CutLevel), 'number_atom'(_N, _A)).
':-'('<module>:kernel:number_to_atom$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:number_to_atom'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:objective'(___35, ___36, 'env', __36CutLevel), '=..'(___36, '.'('objective', '.'(___35, '[]')))).
':-'('<module>:kernel:objective$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:objective'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:os_architecture'(_Arch, 'env', __36CutLevel), 'architecture'(_Arch)).
':-'('<module>:kernel:os_architecture$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:os_architecture'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel:os_version'(_Version, 'env', __36CutLevel), 'os_version'(_Version)).
':-'('<module>:kernel:os_version$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:os_version'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel:random_get_seed'(_Seed, 'env', __36CutLevel), 'get_seed'(_Seed)).
':-'('<module>:kernel:random_get_seed$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:random_get_seed'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel:random_random'(_Float, 'env', __36CutLevel), 'random'(_Float)).
':-'('<module>:kernel:random_random'(_Base, _Max, _Int, 'env', __36CutLevel), 'random'(_Base, _Max, _Int)).
':-'('<module>:kernel:random_random$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:random_random'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel:random_random$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:random_random'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:random_randomize'('env', __36CutLevel), 'randomize').
':-'('<module>:kernel:random_randomize$direct'(__36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:random_randomize'(__36env, __36CutLevel))).
':-'('<module>:kernel:random_set_seed'(_Seed, 'env', __36CutLevel), 'set_seed'(_Seed)).
':-'('<module>:kernel:random_set_seed$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:random_set_seed'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel:read'(___30, 'env', __36CutLevel), '=..'(___30, '.'('read', '[]'))).
':-'('<module>:kernel:read$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:read'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel:real_file_name'(___24, ___25, 'env', __36CutLevel), '=..'(___25, '.'('real_file_name', '.'(___24, '[]')))).
':-'('<module>:kernel:real_file_name$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:real_file_name'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:record_get'(_X, _Key, _Value, 'env', __36CutLevel), ','('atom_concat'(_X, _Key, _Var), ';'('->'('g_read'(_Var, 'some'(_Value)), 'true'), ','('g_link'(_Var, 'some'(_Value)), ','('g_read'(_X, _Keys), 'g_link'(_X, '.'(_Key, _Keys))))))).
':-'('<module>:kernel:record_get$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:record_get'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:record_keys'(_X, _List, 'env', __36CutLevel), 'g_read'(_X, _List)).
':-'('<module>:kernel:record_keys$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:record_keys'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:record_new'(_X, 'env', __36CutLevel), ','(','('g_read'('kernel', '<module>:kernel'(___288)), '<module>:kernel:atom_new_backtrackable$direct'(_X, ___288)), 'g_link'(_X, '[]'))).
':-'('<module>:kernel:record_new$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:record_new'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel:ref_backtrackable_get'(_Ref, _Value, 'env', __36CutLevel), 'g_read'(_Ref, _Value)).
':-'('<module>:kernel:ref_backtrackable_get$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:ref_backtrackable_get'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:ref_backtrackable_new'(_Initial, _Ref, 'env', __36CutLevel), ','(','('g_read'('kernel', '<module>:kernel'(___234)), '<module>:kernel:atom_new_backtrackable$direct'(_Ref, ___234)), 'g_link'(_Ref, _Initial))).
':-'('<module>:kernel:ref_backtrackable_new$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:ref_backtrackable_new'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:ref_backtrackable_set'(_Ref, _Value, 'env', __36CutLevel), 'g_link'(_Ref, _Value)).
':-'('<module>:kernel:ref_backtrackable_set$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:ref_backtrackable_set'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:ref_non_backtrackable_get'(_Ref, _Value, 'env', __36CutLevel), 'g_read'(_Ref, _Value)).
':-'('<module>:kernel:ref_non_backtrackable_get$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:ref_non_backtrackable_get'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:ref_non_backtrackable_new'(_Initial, _Ref, 'env', __36CutLevel), ','(','('g_read'('kernel', '<module>:kernel'(___238)), '<module>:kernel:atom_new_backtrackable$direct'(_Ref, ___238)), 'g_assign'(_Ref, _Initial))).
':-'('<module>:kernel:ref_non_backtrackable_new$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:ref_non_backtrackable_new'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:ref_non_backtrackable_set'(_Ref, _Value, 'env', __36CutLevel), 'g_assign'(_Ref, _Value)).
':-'('<module>:kernel:ref_non_backtrackable_set$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:ref_non_backtrackable_set'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:socket'(_Domain, _Socket, 'env', __36CutLevel), 'socket'(_Domain, _Socket)).
':-'('<module>:kernel:socket$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:socket'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:socket_accept'(_Socket, _Client, _In, _Out, 'env', __36CutLevel), 'socket_accept'(_Socket, _Client, _In, _Out)).
':-'('<module>:kernel:socket_accept$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:socket_accept'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:socket_bind'(_Socket, _Address, 'env', __36CutLevel), 'socket_bind'(_Socket, _Address)).
':-'('<module>:kernel:socket_bind$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:socket_bind'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:socket_listen'(_Socket, _Length, 'env', __36CutLevel), 'socket_listen'(_Socket, _Length)).
':-'('<module>:kernel:socket_listen$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:socket_listen'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:some'(___20, ___21, 'env', __36CutLevel), '=..'(___21, '.'('some', '.'(___20, '[]')))).
':-'('<module>:kernel:some$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:some'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:stderr'(___26, 'env', __36CutLevel), '=..'(___26, '.'('stderr', '[]'))).
':-'('<module>:kernel:stderr$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:stderr'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel:stderr_endline'('env', __36CutLevel), 'nl'('stderr')).
':-'('<module>:kernel:stderr_endline$direct'(__36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:stderr_endline'(__36env, __36CutLevel))).
':-'('<module>:kernel:stderr_flush'('env', __36CutLevel), 'flush_output'('stderr')).
':-'('<module>:kernel:stderr_flush$direct'(__36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:stderr_flush'(__36env, __36CutLevel))).
':-'('<module>:kernel:stderr_format'(_Format, _Args, 'env', __36CutLevel), 'format'('stderr', _Format, _Args)).
':-'('<module>:kernel:stderr_format$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:stderr_format'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:stderr_print'(_Term, 'env', __36CutLevel), 'print'('stderr', _Term)).
':-'('<module>:kernel:stderr_print$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:stderr_print'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel:stderr_print_endline'(_Term, 'env', __36CutLevel), ','('print'('stderr', _Term), 'nl'('stderr'))).
':-'('<module>:kernel:stderr_print_endline$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:stderr_print_endline'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel:stdio_endline'('env', __36CutLevel), 'nl').
':-'('<module>:kernel:stdio_endline$direct'(__36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:stdio_endline'(__36env, __36CutLevel))).
':-'('<module>:kernel:stdio_flush'('env', __36CutLevel), 'flush_output').
':-'('<module>:kernel:stdio_flush$direct'(__36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:stdio_flush'(__36env, __36CutLevel))).
':-'('<module>:kernel:stdio_format'(_Format, _Args, 'env', __36CutLevel), 'format'(_Format, _Args)).
':-'('<module>:kernel:stdio_format$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:stdio_format'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:stdio_print'(_Term, 'env', __36CutLevel), 'print'(_Term)).
':-'('<module>:kernel:stdio_print$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:stdio_print'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel:stdio_print_endline'(_Term, 'env', __36CutLevel), ','('print'(_Term), 'nl')).
':-'('<module>:kernel:stdio_print_endline$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:stdio_print_endline'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel:stdio_read'(_C, 'env', __36CutLevel), 'get_char'(_C)).
':-'('<module>:kernel:stdio_read$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:stdio_read'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel:stdio_read_term'(_C, 'env', __36CutLevel), 'read'(_C)).
':-'('<module>:kernel:stdio_read_term'(_C, _Options, 'env', __36CutLevel), 'read_term'(_C, _Options)).
':-'('<module>:kernel:stdio_read_term$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:stdio_read_term'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel:stdio_read_term$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:stdio_read_term'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:stdio_write'(_C, 'env', __36CutLevel), 'put_char'(_C)).
':-'('<module>:kernel:stdio_write$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:stdio_write'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel:string_format'(_Format, _Args, _String, 'env', __36CutLevel), 'format_to_chars'(_String, _Format, _Args)).
':-'('<module>:kernel:string_format$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:string_format'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:string_print'(_Term, _String, 'env', __36CutLevel), 'print_to_chars'(_String, _Term)).
':-'('<module>:kernel:string_print$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:string_print'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:string_to_atom'(_String, _Atom, 'env', __36CutLevel), 'atom_chars'(_Atom, _String)).
':-'('<module>:kernel:string_to_atom$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:string_to_atom'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:string_to_number'(_String, _Number, 'env', __36CutLevel), 'number_chars'(_Number, _String)).
':-'('<module>:kernel:string_to_number$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:string_to_number'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:sys_abort'('env', __36CutLevel), 'abort').
':-'('<module>:kernel:sys_abort$direct'(__36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:sys_abort'(__36env, __36CutLevel))).
':-'('<module>:kernel:sys_exec'(_Command, _In, _Out, _Err, 'env', __36CutLevel), 'exec'(_Command, _In, _Out, _Err)).
':-'('<module>:kernel:sys_exec'(_Command, _In, _Out, _Err, _Error__code, 'env', __36CutLevel), 'exec'(_Command, _In, _Out, _Err, _Error__code)).
':-'('<module>:kernel:sys_exec$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:sys_exec'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:sys_exec$direct'(_____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:sys_exec'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:sys_exit'(_Error__code, 'env', __36CutLevel), 'halt'(_Error__code)).
':-'('<module>:kernel:sys_exit$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:sys_exit'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel:sys_file_absolute'(_File, _Absolute, 'env', __36CutLevel), 'file_property'(_File, 'absolute_file_name'(_Absolute))).
':-'('<module>:kernel:sys_file_absolute$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:sys_file_absolute'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:sys_file_last_modification'(_File, _Date, 'env', __36CutLevel), 'file_property'(_File, 'last_modification'(_Date))).
':-'('<module>:kernel:sys_file_last_modification$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:sys_file_last_modification'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:sys_file_real'(_File, _Real, 'env', __36CutLevel), 'file_property'(_File, 'real_file_name'(_Real))).
':-'('<module>:kernel:sys_file_real$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:sys_file_real'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:sys_halt'('env', __36CutLevel), 'halt').
':-'('<module>:kernel:sys_halt$direct'(__36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:sys_halt'(__36env, __36CutLevel))).
':-'('<module>:kernel:sys_spawn'(_Command, _Arguments, _Error__code, 'env', __36CutLevel), 'spawn'(_Command, _Arguments, _Error__code)).
':-'('<module>:kernel:sys_spawn$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:sys_spawn'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:sys_wait'(_Pid, _Status, 'env', __36CutLevel), 'wait'(_Pid, _Status)).
':-'('<module>:kernel:sys_wait$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:sys_wait'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:term_arg0'(_I, _Term, _Arg, 'env', __36CutLevel), ','('is'(_J, '+'(_I, 1)), 'arg'(_J, _Term, _Arg))).
':-'('<module>:kernel:term_arg0$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:term_arg0'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:term_arg1'(_I, _Term, _Arg, 'env', __36CutLevel), 'arg'(_I, _Term, _Arg)).
':-'('<module>:kernel:term_arg1$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:term_arg1'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:term_check'(_X, 'env', __36CutLevel), 'callable'(_X)).
':-'('<module>:kernel:term_check$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:term_check'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel:term_compare'(_A, _B, _R, 'env', __36CutLevel), 'compare'(_R, _A, _B)).
':-'('<module>:kernel:term_compare$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:term_compare'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:term_copy'(_Term0, _Term1, 'env', __36CutLevel), 'copy_term'(_Term0, _Term1)).
':-'('<module>:kernel:term_copy$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:term_copy'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:term_decomposition'(_Term, _List, 'env', __36CutLevel), '=..'(_Term, _List)).
':-'('<module>:kernel:term_decomposition$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:term_decomposition'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:term_functor'(_Term, _F, _N, 'env', __36CutLevel), 'functor'(_Term, _F, _N)).
':-'('<module>:kernel:term_functor$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:term_functor'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:term_ge'(_A, _B, 'env', __36CutLevel), '@>='(_A, _B)).
':-'('<module>:kernel:term_ge$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:term_ge'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:term_gt'(_A, _B, 'env', __36CutLevel), '@>'(_A, _B)).
':-'('<module>:kernel:term_gt$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:term_gt'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:term_le'(_A, _B, 'env', __36CutLevel), '@=<'(_A, _B)).
':-'('<module>:kernel:term_le$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:term_le'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:term_lt'(_A, _B, 'env', __36CutLevel), '@<'(_A, _B)).
':-'('<module>:kernel:term_lt$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:term_lt'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:term_setarg0'(_I, _Term, _Arg, 'env', __36CutLevel), ','('is'(_J, '+'(_I, 1)), 'setarg'(_J, _Term, _Arg))).
':-'('<module>:kernel:term_setarg0$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:term_setarg0'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:term_setarg1'(_I, _Term, _Arg, 'env', __36CutLevel), 'setarg'(_I, _Term, _Arg)).
':-'('<module>:kernel:term_setarg1$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:term_setarg1'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:var_check'(_Var, 'env', __36CutLevel), 'generic_var'(_Var)).
':-'('<module>:kernel:var_check$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:var_check'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel:var_name_query_vars'(_List, _Rest, 'env', __36CutLevel), 'name_query_vars'(_List, _Rest)).
':-'('<module>:kernel:var_name_query_vars$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:var_name_query_vars'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:kernel:var_pure'(_Var, 'env', __36CutLevel), 'var'(_Var)).
':-'('<module>:kernel:var_pure$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:var_pure'(_____1, __36env, __36CutLevel))).
':-'('<module>:kernel:write'(___29, 'env', __36CutLevel), '=..'(___29, '.'('write', '[]'))).
':-'('<module>:kernel:write$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:kernel:write'(_____1, __36env, __36CutLevel))).
':-'('kernel@init', ','(','('true', 'g_link'('kernel', '<module>:kernel'('env'))), ','('='(_Stderr, 'user_error'), ','('add_stream_alias'(_Stderr, 'stderr'), ','('g_assign'('backtrackable_atoms', 'g_array_auto'(7, 0)), ','('g_assign'('backtrackable_atom_capacity', 0), 'g_link'('backtrackable_atom_count', 0))))))).
':-'('dynamic'('/'('<module>:sys.cmdline$dynamic', 4))).
':-'('dynamic'('/'('<module>:sys.cmdline@1$dynamic', 4))).
':-'('dynamic'('/'('<module>:sys.cmdline@4$dynamic', 4))).
':-'('dynamic'('/'('<module>:sys.cmdline@5$dynamic', 4))).
':-'('dynamic'('/'('<module>:sys.cmdline@3$dynamic', 4))).
':-'('dynamic'('/'('<module>:sys.cmdline@2$dynamic', 4))).
':-'('dynamic'('/'('<module>:sys.cmdline@0$dynamic', 4))).
':-'('<module>:sys.cmdline'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:sys.cmdline:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:sys.cmdline'('+'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:sys.cmdline:+'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:sys.cmdline'('count'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:sys.cmdline:count'(_____1, __36env, __36CutLevel))).
':-'('<module>:sys.cmdline'('{}'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:sys.cmdline:{}'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:sys.cmdline'('list'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:sys.cmdline:list'(_____1, __36env, __36CutLevel))).
':-'('<module>:sys.cmdline'('parse'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:sys.cmdline:parse'(_____1, __36env, __36CutLevel))).
':-'('<module>:sys.cmdline'(__36t, __36env, __36pos, __36CutLevel), '<module>:sys.cmdline$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:sys.cmdline$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:sys.cmdline$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:sys.cmdline$has_predicate'('+'(_____3, _____2, _____1)), 'true').
':-'('<module>:sys.cmdline$has_predicate'('count'(_____1)), 'true').
':-'('<module>:sys.cmdline$has_predicate'('{}'(_____2, _____1)), 'true').
':-'('<module>:sys.cmdline$has_predicate'('list'(_____1)), 'true').
':-'('<module>:sys.cmdline$has_predicate'('parse'(_____1)), 'true').
':-'('<module>:sys.cmdline:$sgn'(__36sgn, 'env', __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/cmdline.mpl',0,0,0)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/cmdline.mpl',23,0,0)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','(','(','('true', '<module>:sys.cmdline:atom_fresh_[1848]'(_atom__fresh___911849_93, __36Pb, __36Pe)), '<module>:sys.cmdline:atom_fresh_[1850]'(_atom__fresh___911851_93, __36Pb, __36Pe)), '<module>:sys.cmdline:atom_fresh_[1852]'(_atom__fresh___911853_93, __36Pb, __36Pe)), '<module>:sys.cmdline:atom_fresh_[1854]'(_atom__fresh___911855_93, __36Pb, __36Pe)), '<module>:sys.cmdline:atom_fresh_[1856]'(_atom__fresh___911857_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___911857_93, '.'(_atom__fresh___911855_93, '.'(_atom__fresh___911853_93, '.'(_atom__fresh___911851_93, '.'(_atom__fresh___911849_93, '[]'))))))))))).
':-'('<module>:sys.cmdline:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:sys.cmdline:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:sys.cmdline:+'(___4, ___5, ___6, 'env', __36CutLevel), '=..'(___6, '.'('+', '.'(___4, '.'(___5, '[]'))))).
':-'('<module>:sys.cmdline:+$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:sys.cmdline:+'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:sys.cmdline:atom_fresh_[1848]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(parse, 1, predicate, '[]', __36pos))).
':-'('<module>:sys.cmdline:atom_fresh_[1850]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(list, 1, predicate, suspended([none],[call(scope,true,[])]), __36pos))).
':-'('<module>:sys.cmdline:atom_fresh_[1852]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'({}, 2, predicate, suspended([var('Index'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:sys.cmdline:atom_fresh_[1854]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(count, 1, predicate, suspended([none],[call(scope,true,[])]), __36pos))).
':-'('<module>:sys.cmdline:atom_fresh_[1856]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(+, 3, constructor, none, __36pos))).
':-'('<module>:sys.cmdline:count'(___8, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___9)), '<module>:kernel:cmdline_count$direct'(___8, ___9))).
':-'('<module>:sys.cmdline:count$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:sys.cmdline:count'(_____1, __36env, __36CutLevel))).
':-'('<module>:sys.cmdline:list'(___14, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___15)), '<module>:kernel:cmdline_list$direct'(___14, ___15))).
':-'('<module>:sys.cmdline:list$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:sys.cmdline:list'(_____1, __36env, __36CutLevel))).
':-'('<module>:sys.cmdline:parse'(_M, 'env', __36CutLevel), ','(','('='(_IndexRef, ___17), ','('g_read'('data.ref.backtrackable', '<module>:data.ref.backtrackable'(___18)), '<module>:data.ref.backtrackable:new$direct'(1, ___17, ___18))), ','(','('true', ';'('->'('var'(_SimpleNext), ','('g_inc'('$module_count', ___19), '='(_SimpleNext, '$module'(___19, '.'('<module>:sys.cmdline@0'('env'(_SimpleNext, _IndexRef)), '[]'), '.'(_SimpleNext, '[]'))))), ','('='(_SimpleNext, '$module'(___19, ___20, _)), ','('='('.'(___21, ___22), ___20), ','('setarg'(1, ___20, '<module>:sys.cmdline@0'('env'(_SimpleNext, _IndexRef))), 'setarg'(2, ___20, '.'(___21, ___22))))))), ','(','('true', ';'('->'('var'(___24), ','('g_inc'('$module_count', ___25), '='(___24, '$module'(___25, '.'('<module>:sys.cmdline@1'('env'(___24, _M, _IndexRef, _SimpleNext)), '[]'), '.'(___24, '[]'))))), ','('='(___24, '$module'(___25, ___26, _)), ','('='('.'(___27, ___28), ___26), ','('setarg'(1, ___26, '<module>:sys.cmdline@1'('env'(___24, _M, _IndexRef, _SimpleNext))), 'setarg'(2, ___26, '.'(___27, ___28))))))), 'emop_call'(___24, 'do', 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/cmdline.mpl\", line 195, from character 8 to 10'))))).
':-'('<module>:sys.cmdline:parse$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:sys.cmdline:parse'(_____1, __36env, __36CutLevel))).
':-'('<module>:sys.cmdline:{}'(_Index, ___11, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___12)), '<module>:kernel:cmdline_get$direct'(_Index, ___11, ___12))).
':-'('<module>:sys.cmdline:{}$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:sys.cmdline:{}'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:sys.cmdline@0'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:sys.cmdline@0:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:sys.cmdline@0'('get'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:sys.cmdline@0:get'(_____1, __36env, __36CutLevel))).
':-'('<module>:sys.cmdline@0'(__36t, __36env, __36pos, __36CutLevel), '<module>:sys.cmdline@0$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:sys.cmdline@0$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:sys.cmdline@0$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:sys.cmdline@0$has_predicate'('get'(_____1)), 'true').
':-'('<module>:sys.cmdline@0:$sgn'(__36sgn, 'env'(___23, _IndexRef), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/cmdline.mpl',224,11,218)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/cmdline.mpl',254,11,218)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:sys.cmdline@0:atom_fresh_[1872]'(_atom__fresh___911873_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___911873_93, '[]'))))))).
':-'('<module>:sys.cmdline@0:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:sys.cmdline@0:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:sys.cmdline@0:atom_fresh_[1872]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(get, 1, predicate, '[]', __36pos))).
':-'('<module>:sys.cmdline@0:get'(_Arg, 'env'(___23, _IndexRef), __36CutLevel), ','(','('='(_Index, ___146), 'emop_call'(_IndexRef, 'get'(___146), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/cmdline.mpl\", line 14, from character 29 to 32')), ';'('->'(','(','('g_read'('kernel', '<module>:kernel'(___150)), '<module>:kernel:cmdline_count$direct'(___149, ___150)), ','('g_read'('data.number', '<module>:data.number'(___151)), '<module>:data.number:<$direct'(_Index, ___149, ___151))), ','(','('='(_Arg, ___153), ','('g_read'('kernel', '<module>:kernel'(___154)), '<module>:kernel:cmdline_get$direct'(_Index, ___153, ___154))), ','(','('g_read'('data.number', '<module>:data.number'(___157)), '<module>:data.number:succ$direct'(_Index, ___156, ___157)), 'emop_call'(_IndexRef, 'set'(___156), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/cmdline.mpl\", line 19, from character 24 to 27')))), 'fail'))).
':-'('<module>:sys.cmdline@0:get$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:sys.cmdline@0:get'(_____1, __36env, __36CutLevel))).
':-'('<module>:sys.cmdline@1'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:sys.cmdline@1:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:sys.cmdline@1'('argument_next'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:sys.cmdline@1:argument_next'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:sys.cmdline@1'('do_files', __36env, _, __36CutLevel), ','('!', '<module>:sys.cmdline@1:do_files'(__36env, __36CutLevel))).
':-'('<module>:sys.cmdline@1'('do', __36env, _, __36CutLevel), ','('!', '<module>:sys.cmdline@1:do'(__36env, __36CutLevel))).
':-'('<module>:sys.cmdline@1'(__36t, __36env, __36pos, __36CutLevel), '<module>:sys.cmdline@1$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:sys.cmdline@1$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:sys.cmdline@1$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:sys.cmdline@1$has_predicate'('argument_next'(_____3, _____2, _____1)), 'true').
':-'('<module>:sys.cmdline@1$has_predicate'('do_files'), 'true').
':-'('<module>:sys.cmdline@1$has_predicate'('do'), 'true').
':-'('<module>:sys.cmdline@1:$sgn'(__36sgn, 'env'(___29, _M, _IndexRef, _SimpleNext), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/cmdline.mpl',562,23,556)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/cmdline.mpl',596,23,556)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','('true', '<module>:sys.cmdline@1:atom_fresh_[1858]'(_atom__fresh___911859_93, __36Pb, __36Pe)), '<module>:sys.cmdline@1:atom_fresh_[1860]'(_atom__fresh___911861_93, __36Pb, __36Pe)), '<module>:sys.cmdline@1:atom_fresh_[1862]'(_atom__fresh___911863_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___911863_93, '.'(_atom__fresh___911861_93, '.'(_atom__fresh___911859_93, '[]'))))))))).
':-'('<module>:sys.cmdline@1:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:sys.cmdline@1:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:sys.cmdline@1:argument_next'(_Used, _FirstArgument, ___30, 'env'(___29, _M, _IndexRef, _SimpleNext), __36CutLevel), ','('true', ';'('->'('var'(___30), ','('g_inc'('$module_count', ___31), '='(___30, '$module'(___31, '.'('<module>:sys.cmdline@2'('env'(___30, _SimpleNext, _Used, _FirstArgument, ___29)), '[]'), '.'(___30, '[]'))))), ','('='(___30, '$module'(___31, ___32, _)), ','('='('.'(___33, ___34), ___32), ','('setarg'(1, ___32, '<module>:sys.cmdline@2'('env'(___30, _SimpleNext, _Used, _FirstArgument, ___29))), 'setarg'(2, ___32, '.'(___33, ___34)))))))).
':-'('<module>:sys.cmdline@1:argument_next$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:sys.cmdline@1:argument_next'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:sys.cmdline@1:atom_fresh_[1858]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 0, predicate, [], __36pos))).
':-'('<module>:sys.cmdline@1:atom_fresh_[1860]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do_files, 0, predicate, [], __36pos))).
':-'('<module>:sys.cmdline@1:atom_fresh_[1862]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(argument_next, 3, predicate, '[]', __36pos))).
':-'('<module>:sys.cmdline@1:do'('env'(___29, _M, _IndexRef, _SimpleNext), __36CutLevel), ','(','('='(_Index, ___51), 'emop_call'(_IndexRef, 'get'(___51), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/cmdline.mpl\", line 57, from character 29 to 32')), ';'('->'(','(','('g_read'('sys.cmdline', '<module>:sys.cmdline'(___55)), '<module>:sys.cmdline:count$direct'(___54, ___55)), ','('g_read'('data.number', '<module>:data.number'(___56)), '<module>:data.number:<$direct'(_Index, ___54, ___56))), ','(','('='(_Arg, ___58), ','('g_read'('sys.cmdline', '<module>:sys.cmdline'(___59)), '<module>:sys.cmdline:{}$direct'(_Index, ___58, ___59))), ','(','(','('g_read'('data.number', '<module>:data.number'(___62)), '<module>:data.number:succ$direct'(_Index, ___61, ___62)), 'emop_call'(_IndexRef, 'set'(___61), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/cmdline.mpl\", line 62, from character 24 to 27')), ';'('->'('='(_Arg, '--'), 'emop_call'(___29, 'do_files', 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/cmdline.mpl\", line 66, from character 18 to 26')), ';'('->'(','('g_read'('data.atom', '<module>:data.atom'(___66)), '<module>:data.atom:concat$direct'('--', _FullLongOption, _Arg, ___66)), ';'('->'(','('g_read'('data.atom', '<module>:data.atom'(___69)), '<module>:data.atom:split_at_delim_left$direct'(_FullLongOption, '=', _LongOption, _FirstArgument, ___69)), ';'('->'(','(','(','('true', ';'('->'('var'(___70), ','('g_inc'('$module_count', ___71), '='(___70, '$module'(___71, '.'('<module>:sys.cmdline@3'('env'(___70, _FirstArgument, ___29)), '[]'), '.'(___70, '[]'))))), ','('='(___70, '$module'(___71, ___72, _)), ','('='('.'(___73, ___74), ___72), ','('setarg'(1, ___72, '<module>:sys.cmdline@3'('env'(___70, _FirstArgument, ___29))), 'setarg'(2, ___72, '.'(___73, ___74))))))), 'emop_call'(___29, 'argument_next'(_Used, ___70, ___76), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/cmdline.mpl\", line 78, from character 32 to 45')), 'emop_call'(_M, 'long'(_LongOption, ___76), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/cmdline.mpl\", line 76, from character 26 to 30')), ';'('->'('='(_Used, 'false'), ','(','('g_read'('data.atom', '<module>:data.atom'(___81)), '<module>:data.atom:concat$direct'('--', _LongOption, ___80, ___81)), 'throw'('error'('cmdline'('option_without_argument'(___80)))))), 'emop_call'(___29, 'do', 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/cmdline.mpl\", line 96, from character 32 to 34'))), ','(','('g_read'('data.atom', '<module>:data.atom'(___88)), '<module>:data.atom:concat$direct'('--', _LongOption, ___87, ___88)), 'throw'('error'('cmdline'('invalid_option'(___87))))))), ';'('->'('emop_call'(_M, 'long'(_FullLongOption, _SimpleNext), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/cmdline.mpl\", line 111, from character 26 to 30'), 'emop_call'(___29, 'do', 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/cmdline.mpl\", line 113, from character 24 to 26')), 'throw'('error'('cmdline'('invalid_option'(_Arg))))))), ';'('->'(','(','('g_read'('data.atom', '<module>:data.atom'(___97)), '<module>:data.atom:sub$direct'(_Arg, 0, 1, _Count, '-', ___97)), ','('g_read'('data.number', '<module>:data.number'(___99)), '<module>:data.number:>$direct'(_Count, 0, ___99))), ','('='(_Parent, ___29), ','(','(','('true', ';'('->'('var'(___100), ','('g_inc'('$module_count', ___101), '='(___100, '$module'(___101, '.'('<module>:sys.cmdline@4'('env'(___100, _M, _Arg, _Count, _Parent, _SimpleNext, ___29)), '[]'), '.'(___100, '[]'))))), ','('='(___100, '$module'(___101, ___102, _)), ','('='('.'(___103, ___104), ___102), ','('setarg'(1, ___102, '<module>:sys.cmdline@4'('env'(___100, _M, _Arg, _Count, _Parent, _SimpleNext, ___29))), 'setarg'(2, ___102, '.'(___103, ___104))))))), 'emop_call'(___100, 'do'(1), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/cmdline.mpl\", line 177, from character 20 to 22')), 'emop_call'(___29, 'do', 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/cmdline.mpl\", line 178, from character 18 to 20')))), ';'('->'(';'('emop_call'(_M, 'default'(_Arg), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/cmdline.mpl\", line 182, from character 26 to 33'), 'emop_call'(_M, 'file'(_Arg), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/cmdline.mpl\", line 184, from character 26 to 30')), 'emop_call'(___29, 'do', 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/cmdline.mpl\", line 187, from character 21 to 23')), 'throw'('error'('cmdline'('invalid_file'(_Arg))))))))))), 'true'))).
':-'('<module>:sys.cmdline@1:do$direct'(__36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:sys.cmdline@1:do'(__36env, __36CutLevel))).
':-'('<module>:sys.cmdline@1:do_files'('env'(___29, _M, _IndexRef, _SimpleNext), __36CutLevel), ','(','('='(_Index, ___36), 'emop_call'(_IndexRef, 'get'(___36), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/cmdline.mpl\", line 39, from character 29 to 32')), ';'('->'(','(','('g_read'('sys.cmdline', '<module>:sys.cmdline'(___40)), '<module>:sys.cmdline:count$direct'(___39, ___40)), ','('g_read'('data.number', '<module>:data.number'(___41)), '<module>:data.number:<$direct'(_Index, ___39, ___41))), ','(','('='(_Arg, ___43), ','('g_read'('sys.cmdline', '<module>:sys.cmdline'(___44)), '<module>:sys.cmdline:{}$direct'(_Index, ___43, ___44))), ','(','(','('g_read'('data.number', '<module>:data.number'(___47)), '<module>:data.number:succ$direct'(_Index, ___46, ___47)), 'emop_call'(_IndexRef, 'set'(___46), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/cmdline.mpl\", line 44, from character 24 to 27')), ';'('->'('emop_call'(_M, 'file'(_Arg), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/cmdline.mpl\", line 46, from character 20 to 24'), 'emop_call'(___29, 'do_files', 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/cmdline.mpl\", line 48, from character 18 to 26')), 'throw'('error'('cmdline'('invalid_file'(_Arg)))))))), 'true'))).
':-'('<module>:sys.cmdline@1:do_files$direct'(__36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:sys.cmdline@1:do_files'(__36env, __36CutLevel))).
':-'('<module>:sys.cmdline@2'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:sys.cmdline@2:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:sys.cmdline@2'('get'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:sys.cmdline@2:get'(_____1, __36env, __36CutLevel))).
':-'('<module>:sys.cmdline@2'(__36t, __36env, __36pos, __36CutLevel), '<module>:sys.cmdline@2$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:sys.cmdline@2$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:sys.cmdline@2$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:sys.cmdline@2$has_predicate'('get'(_____1)), 'true').
':-'('<module>:sys.cmdline@2:$sgn'(__36sgn, 'env'(___35, _SimpleNext, _Used, _FirstArgument, ___29), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/cmdline.mpl',655,25,643)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/cmdline.mpl',697,25,643)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:sys.cmdline@2:atom_fresh_[1870]'(_atom__fresh___911871_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___911871_93, '[]'))))))).
':-'('<module>:sys.cmdline@2:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:sys.cmdline@2:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:sys.cmdline@2:atom_fresh_[1870]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(get, 1, predicate, '[]', __36pos))).
':-'('<module>:sys.cmdline@2:get'(_Arg, 'env'(___35, _SimpleNext, _Used, _FirstArgument, ___29), __36CutLevel), ';'('->'('=='(_Used, 'true'), ','('='(_Arg, ___143), 'emop_call'(_SimpleNext, 'get'(___143), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/cmdline.mpl\", line 31, from character 38 to 41'))), ','('='(_Used, 'true'), ','('='(_Arg, ___145), 'emop_call'(_FirstArgument, 'get'(___145), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/cmdline.mpl\", line 34, from character 41 to 44'))))).
':-'('<module>:sys.cmdline@2:get$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:sys.cmdline@2:get'(_____1, __36env, __36CutLevel))).
':-'('<module>:sys.cmdline@3'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:sys.cmdline@3:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:sys.cmdline@3'('get'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:sys.cmdline@3:get'(_____1, __36env, __36CutLevel))).
':-'('<module>:sys.cmdline@3'(__36t, __36env, __36pos, __36CutLevel), '<module>:sys.cmdline@3$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:sys.cmdline@3$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:sys.cmdline@3$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:sys.cmdline@3$has_predicate'('get'(_____1)), 'true').
':-'('<module>:sys.cmdline@3:$sgn'(__36sgn, 'env'(___75, _FirstArgument, ___29), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/cmdline.mpl',2212,77,2160)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/cmdline.mpl',2236,77,2160)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:sys.cmdline@3:atom_fresh_[1868]'(_atom__fresh___911869_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___911869_93, '[]'))))))).
':-'('<module>:sys.cmdline@3:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:sys.cmdline@3:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:sys.cmdline@3:atom_fresh_[1868]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(get, 1, predicate, suspended([var('FirstArgument')],[call(scope,true,[])]), __36pos))).
':-'('<module>:sys.cmdline@3:get'(_FirstArgument, 'env'(___75, _FirstArgument, ___29), __36CutLevel), 'true').
':-'('<module>:sys.cmdline@3:get$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:sys.cmdline@3:get'(_____1, __36env, __36CutLevel))).
':-'('<module>:sys.cmdline@4'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:sys.cmdline@4:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:sys.cmdline@4'('do'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:sys.cmdline@4:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:sys.cmdline@4'(__36t, __36env, __36pos, __36CutLevel), '<module>:sys.cmdline@4$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:sys.cmdline@4$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:sys.cmdline@4$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:sys.cmdline@4$has_predicate'('do'(_____1)), 'true').
':-'('<module>:sys.cmdline@4:$sgn'(__36sgn, 'env'(___105, _M, _Arg, _Count, _Parent, _SimpleNext, ___29), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/cmdline.mpl',3988,128,3970)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/cmdline.mpl',4032,128,3970)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:sys.cmdline@4:atom_fresh_[1864]'(_atom__fresh___911865_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___911865_93, '[]'))))))).
':-'('<module>:sys.cmdline@4:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:sys.cmdline@4:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:sys.cmdline@4:atom_fresh_[1864]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 1, predicate, '[]', __36pos))).
':-'('<module>:sys.cmdline@4:do'(_Index, 'env'(___105, _M, _Arg, _Count, _Parent, _SimpleNext, ___29), __36CutLevel), ';'('->'(','('g_read'('data.number', '<module>:data.number'(___110)), '<module>:data.number:=<$direct'(_Index, _Count, ___110)), ','(','('='(_Opt, ___112), ','('g_read'('data.atom', '<module>:data.atom'(___113)), '<module>:data.atom:sub$direct'(_Arg, _Index, 1, _, ___112, ___113))), ';'('->'(';'('->'(','('g_read'('data.number', '<module>:data.number'(___116)), '<module>:data.number:=<$direct'('+'(_Index, 1), _Count, ___116)), ','(','(','('true', ';'('->'('var'(___117), ','('g_inc'('$module_count', ___118), '='(___117, '$module'(___118, '.'('<module>:sys.cmdline@5'('env'(___117, _Arg, _Index, ___105, ___29)), '[]'), '.'(___117, '[]'))))), ','('='(___117, '$module'(___118, ___119, _)), ','('='('.'(___120, ___121), ___119), ','('setarg'(1, ___119, '<module>:sys.cmdline@5'('env'(___117, _Arg, _Index, ___105, ___29))), 'setarg'(2, ___119, '.'(___120, ___121))))))), 'emop_call'(_Parent, 'argument_next'(_Used, ___117, ___123), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/cmdline.mpl\", line 141, from character 43 to 56')), 'emop_call'(_M, 'short'(_Opt, ___123), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/cmdline.mpl\", line 139, from character 35 to 40'))), ','('='(_Used, 'true'), 'emop_call'(_M, 'short'(_Opt, _SimpleNext), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/cmdline.mpl\", line 150, from character 35 to 40'))), ';'('->'('='(_Used, 'false'), ','(','('g_read'('data.number', '<module>:data.number'(___128)), '<module>:data.number:succ$direct'(_Index, ___127, ___128)), 'emop_call'(___105, 'do'(___127), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/cmdline.mpl\", line 159, from character 33 to 35'))), 'true')), ','(','('g_read'('data.atom', '<module>:data.atom'(___132)), '<module>:data.atom:concat$direct'('-', _Opt, ___131, ___132)), 'throw'('error'('cmdline'('invalid_option'(___131)))))))), 'true')).
':-'('<module>:sys.cmdline@4:do$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:sys.cmdline@4:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:sys.cmdline@5'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:sys.cmdline@5:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:sys.cmdline@5'('get'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:sys.cmdline@5:get'(_____1, __36env, __36CutLevel))).
':-'('<module>:sys.cmdline@5'(__36t, __36env, __36pos, __36CutLevel), '<module>:sys.cmdline@5$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:sys.cmdline@5$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:sys.cmdline@5$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:sys.cmdline@5$has_predicate'('get'(_____1)), 'true').
':-'('<module>:sys.cmdline@5:$sgn'(__36sgn, 'env'(___122, _Arg, _Index, ___105, ___29), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/cmdline.mpl',4548,140,4485)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/cmdline.mpl',4569,140,4485)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:sys.cmdline@5:atom_fresh_[1866]'(_atom__fresh___911867_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___911867_93, '[]'))))))).
':-'('<module>:sys.cmdline@5:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:sys.cmdline@5:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:sys.cmdline@5:atom_fresh_[1866]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(get, 1, predicate, suspended([none],[call(scope,true,[])]), __36pos))).
':-'('<module>:sys.cmdline@5:get'(___140, 'env'(___122, _Arg, _Index, ___105, ___29), __36CutLevel), ','(','('g_read'('data.number', '<module>:data.number'(___139)), '<module>:data.number:+$direct'(_Index, 1, ___138, ___139)), ','('g_read'('data.atom', '<module>:data.atom'(___141)), '<module>:data.atom:sub$direct'(_Arg, ___138, _, 0, ___140, ___141)))).
':-'('<module>:sys.cmdline@5:get$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:sys.cmdline@5:get'(_____1, __36env, __36CutLevel))).
':-'('sys.cmdline@init', ','('true', 'g_link'('sys.cmdline', '<module>:sys.cmdline'('env')))).
':-'('dynamic'('/'('<module>:sys.env$dynamic', 4))).
':-'('<module>:sys.env'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:sys.env:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:sys.env'('{}'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:sys.env:{}'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:sys.env'(__36t, __36env, __36pos, __36CutLevel), '<module>:sys.env$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:sys.env$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:sys.env$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:sys.env$has_predicate'('{}'(_____2, _____1)), 'true').
':-'('<module>:sys.env:$sgn'(__36sgn, 'env', __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/env.mpl',0,0,0)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/env.mpl',18,0,0)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:sys.env:atom_fresh_[1846]'(_atom__fresh___911847_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___911847_93, '[]'))))))).
':-'('<module>:sys.env:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:sys.env:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:sys.env:atom_fresh_[1846]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'({}, 2, predicate, suspended([var('Key'),none],[call(scope,true,[])]), __36pos))).
':-'('<module>:sys.env:{}'(_Key, ___5, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___6)), '<module>:kernel:env_get$direct'(_Key, ___5, ___6))).
':-'('<module>:sys.env:{}$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:sys.env:{}'(_____2, _____1, __36env, __36CutLevel))).
':-'('sys.env@init', ','('true', 'g_link'('sys.env', '<module>:sys.env'('env')))).
':-'('dynamic'('/'('<module>:sys.file$dynamic', 4))).
':-'('<module>:sys.file'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:sys.file:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:sys.file'('real'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:sys.file:real'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:sys.file'('absolute'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:sys.file:absolute'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:sys.file'('last_modification'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:sys.file:last_modification'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:sys.file'('exists'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:sys.file:exists'(_____1, __36env, __36CutLevel))).
':-'('<module>:sys.file'(__36t, __36env, __36pos, __36CutLevel), '<module>:sys.file$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:sys.file$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:sys.file$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:sys.file$has_predicate'('real'(_____2, _____1)), 'true').
':-'('<module>:sys.file$has_predicate'('absolute'(_____2, _____1)), 'true').
':-'('<module>:sys.file$has_predicate'('last_modification'(_____2, _____1)), 'true').
':-'('<module>:sys.file$has_predicate'('exists'(_____1)), 'true').
':-'('<module>:sys.file:$sgn'(__36sgn, 'env', __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/file.mpl',0,0,0)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/file.mpl',17,0,0)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','(','('true', '<module>:sys.file:atom_fresh_[2839]'(_atom__fresh___912840_93, __36Pb, __36Pe)), '<module>:sys.file:atom_fresh_[2841]'(_atom__fresh___912842_93, __36Pb, __36Pe)), '<module>:sys.file:atom_fresh_[2843]'(_atom__fresh___912844_93, __36Pb, __36Pe)), '<module>:sys.file:atom_fresh_[2845]'(_atom__fresh___912846_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___912846_93, '.'(_atom__fresh___912844_93, '.'(_atom__fresh___912842_93, '.'(_atom__fresh___912840_93, '[]')))))))))).
':-'('<module>:sys.file:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:sys.file:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:sys.file:absolute'(_File, _Absolute, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___7)), '<module>:kernel:sys_file_absolute$direct'(_File, _Absolute, ___7))).
':-'('<module>:sys.file:absolute$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:sys.file:absolute'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:sys.file:atom_fresh_[2839]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(exists, 1, predicate, suspended([var('Filename')],[call(atom(kernel),file_exists,[var('Filename')])]), __36pos))).
':-'('<module>:sys.file:atom_fresh_[2841]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(last_modification, 2, predicate, suspended([var('File'),var('Date')],[call(atom(kernel),sys_file_last_modification,[var('File'),var('Date')])]), __36pos))).
':-'('<module>:sys.file:atom_fresh_[2843]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(absolute, 2, predicate, suspended([var('File'),var('Absolute')],[call(atom(kernel),sys_file_absolute,[var('File'),var('Absolute')])]), __36pos))).
':-'('<module>:sys.file:atom_fresh_[2845]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(real, 2, predicate, suspended([var('File'),var('Real')],[call(atom(kernel),sys_file_real,[var('File'),var('Real')])]), __36pos))).
':-'('<module>:sys.file:exists'(_Filename, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___11)), '<module>:kernel:file_exists$direct'(_Filename, ___11))).
':-'('<module>:sys.file:exists$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:sys.file:exists'(_____1, __36env, __36CutLevel))).
':-'('<module>:sys.file:last_modification'(_File, _Date, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___9)), '<module>:kernel:sys_file_last_modification$direct'(_File, _Date, ___9))).
':-'('<module>:sys.file:last_modification$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:sys.file:last_modification'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:sys.file:real'(_File, _Real, 'env', __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___5)), '<module>:kernel:sys_file_real$direct'(_File, _Real, ___5))).
':-'('<module>:sys.file:real$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:sys.file:real'(_____2, _____1, __36env, __36CutLevel))).
':-'('sys.file@init', ','('true', 'g_link'('sys.file', '<module>:sys.file'('env')))).
':-'('dynamic'('/'('<module>:sys.os$dynamic', 4))).
':-'('<module>:sys.os'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:sys.os:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:sys.os'('architecture'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:sys.os:architecture'(_____1, __36env, __36CutLevel))).
':-'('<module>:sys.os'('version'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:sys.os:version'(_____1, __36env, __36CutLevel))).
':-'('<module>:sys.os'('type'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:sys.os:type'(_____1, __36env, __36CutLevel))).
':-'('<module>:sys.os'('path_delimiter'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:sys.os:path_delimiter'(_____1, __36env, __36CutLevel))).
':-'('<module>:sys.os'('path_separator'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:sys.os:path_separator'(_____1, __36env, __36CutLevel))).
':-'('<module>:sys.os'(__36t, __36env, __36pos, __36CutLevel), '<module>:sys.os$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:sys.os$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:sys.os$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:sys.os$has_predicate'('architecture'(_____1)), 'true').
':-'('<module>:sys.os$has_predicate'('version'(_____1)), 'true').
':-'('<module>:sys.os$has_predicate'('type'(_____1)), 'true').
':-'('<module>:sys.os$has_predicate'('path_delimiter'(_____1)), 'true').
':-'('<module>:sys.os$has_predicate'('path_separator'(_____1)), 'true').
':-'('<module>:sys.os:$sgn'(__36sgn, 'env'(_Type), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/os.mpl',0,0,0)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/os.mpl',22,0,0)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','(','(','('true', '<module>:sys.os:atom_fresh_[1988]'(_atom__fresh___911989_93, __36Pb, __36Pe)), '<module>:sys.os:atom_fresh_[1990]'(_atom__fresh___911991_93, __36Pb, __36Pe)), '<module>:sys.os:atom_fresh_[1992]'(_atom__fresh___911993_93, __36Pb, __36Pe)), '<module>:sys.os:atom_fresh_[1994]'(_atom__fresh___911995_93, __36Pb, __36Pe)), '<module>:sys.os:atom_fresh_[1996]'(_atom__fresh___911997_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___911997_93, '.'(_atom__fresh___911995_93, '.'(_atom__fresh___911993_93, '.'(_atom__fresh___911991_93, '.'(_atom__fresh___911989_93, '[]'))))))))))).
':-'('<module>:sys.os:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:sys.os:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:sys.os:architecture'(___5, 'env'(_Type), __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___6)), '<module>:kernel:os_architecture$direct'(___5, ___6))).
':-'('<module>:sys.os:architecture$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:sys.os:architecture'(_____1, __36env, __36CutLevel))).
':-'('<module>:sys.os:atom_fresh_[1988]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(path_separator, 1, predicate, suspended([none],[call(scope,true,[])]), __36pos))).
':-'('<module>:sys.os:atom_fresh_[1990]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(path_delimiter, 1, predicate, suspended([none],[call(scope,true,[])]), __36pos))).
':-'('<module>:sys.os:atom_fresh_[1992]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(type, 1, predicate, '[]', __36pos))).
':-'('<module>:sys.os:atom_fresh_[1994]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(version, 1, predicate, suspended([none],[call(scope,true,[])]), __36pos))).
':-'('<module>:sys.os:atom_fresh_[1996]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(architecture, 1, predicate, suspended([none],[call(scope,true,[])]), __36pos))).
':-'('<module>:sys.os:path_delimiter'(___40, 'env'(_Type), __36CutLevel), ','(','('='(___42, ___39), ','('g_read'('sys.os', '<module>:sys.os'(___43)), '<module>:sys.os:type$direct'(___42, ___43))), ';'('->'('='(___39, 'windows'), '='(___40, '\\')), ','('='(___40, '/'), ','('='(___39, ___41), '->'('true', 'true')))))).
':-'('<module>:sys.os:path_delimiter$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:sys.os:path_delimiter'(_____1, __36env, __36CutLevel))).
':-'('<module>:sys.os:path_separator'(___48, 'env'(_Type), __36CutLevel), ','(','('='(___50, ___47), ','('g_read'('sys.os', '<module>:sys.os'(___51)), '<module>:sys.os:type$direct'(___50, ___51))), ';'('->'('='(___47, 'windows'), '='(___48, ';')), ','('='(___48, ':'), ','('='(___47, ___49), '->'('true', 'true')))))).
':-'('<module>:sys.os:path_separator$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:sys.os:path_separator'(_____1, __36env, __36CutLevel))).
':-'('<module>:sys.os:type'(_Type, 'env'(_Type), __36CutLevel), ';'('->'(','('g_read'('data.var', '<module>:data.var'(___20)), '<module>:data.var:check$direct'(_Type, ___20)), ','('='(_Type, ___11), ','(','('='(___21, ___10), ','('g_read'('sys.os', '<module>:sys.os'(___22)), '<module>:sys.os:version$direct'(___21, ___22))), ';'('->'(','('='(___12, 'Linux '), ','('='(___10, ___24), ','('g_read'('data.atom', '<module>:data.atom'(___25)), '<module>:data.atom:concat$direct'(___12, ___13, ___24, ___25)))), '='(___11, 'linux')), ','('='(___11, ___15), ','('='(___10, ___14), ';'('->'(','('='(___16, 'Home '), ','('='(___14, ___29), ','('g_read'('data.atom', '<module>:data.atom'(___30)), '<module>:data.atom:concat$direct'(___16, ___17, ___29, ___30)))), '='(___15, 'windows')), ','('='(___15, 'linux'), ','('='(___14, ___18), ','('->'('='(___18, _Unknown), 'true'), ','('g_read'('io.err', '<module>:io.err'(___37)), '<module>:io.err:format$direct'('Warning! Unknown OS \'~a\'.\nPlease define it in sys/os.mpl. Assuming linux.', '.'(_Unknown, '[]'), ___37)))))))))))), 'true')).
':-'('<module>:sys.os:type$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:sys.os:type'(_____1, __36env, __36CutLevel))).
':-'('<module>:sys.os:version'(___8, 'env'(_Type), __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___9)), '<module>:kernel:os_version$direct'(___8, ___9))).
':-'('<module>:sys.os:version$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:sys.os:version'(_____1, __36env, __36CutLevel))).
':-'('sys.os@init', ','('true', 'g_link'('sys.os', '<module>:sys.os'('env'(_Type))))).
':-'('dynamic'('/'('<module>:sys.process$dynamic', 4))).
':-'('dynamic'('/'('<module>:sys.process@0$dynamic', 4))).
':-'('dynamic'('/'('<module>:sys.process@1$dynamic', 4))).
':-'('<module>:sys.process'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:sys.process:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:sys.process'('exec_filename'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:sys.process:exec_filename'(_____1, __36env, __36CutLevel))).
':-'('<module>:sys.process'('at_exit'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:sys.process:at_exit'(_____1, __36env, __36CutLevel))).
':-'('<module>:sys.process'('exit'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:sys.process:exit'(_____1, __36env, __36CutLevel))).
':-'('<module>:sys.process'('halt', __36env, _, __36CutLevel), ','('!', '<module>:sys.process:halt'(__36env, __36CutLevel))).
':-'('<module>:sys.process'('abort', __36env, _, __36CutLevel), ','('!', '<module>:sys.process:abort'(__36env, __36CutLevel))).
':-'('<module>:sys.process'('spawn'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:sys.process:spawn'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:sys.process'('spawn'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:sys.process:spawn'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:sys.process'('exec'(_____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:sys.process:exec'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:sys.process'('exec'(_____5, _____4, _____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:sys.process:exec'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:sys.process'('wait'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:sys.process:wait'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:sys.process'('call'(_____3, _____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:sys.process:call'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:sys.process'('call'(_____2, _____1), __36env, _, __36CutLevel), ','('!', '<module>:sys.process:call'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:sys.process'(__36t, __36env, __36pos, __36CutLevel), '<module>:sys.process$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:sys.process$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:sys.process$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:sys.process$has_predicate'('exec_filename'(_____1)), 'true').
':-'('<module>:sys.process$has_predicate'('at_exit'(_____1)), 'true').
':-'('<module>:sys.process$has_predicate'('exit'(_____1)), 'true').
':-'('<module>:sys.process$has_predicate'('halt'), 'true').
':-'('<module>:sys.process$has_predicate'('abort'), 'true').
':-'('<module>:sys.process$has_predicate'('spawn'(_____3, _____2, _____1)), 'true').
':-'('<module>:sys.process$has_predicate'('spawn'(_____2, _____1)), 'true').
':-'('<module>:sys.process$has_predicate'('exec'(_____4, _____3, _____2, _____1)), 'true').
':-'('<module>:sys.process$has_predicate'('exec'(_____5, _____4, _____3, _____2, _____1)), 'true').
':-'('<module>:sys.process$has_predicate'('wait'(_____2, _____1)), 'true').
':-'('<module>:sys.process$has_predicate'('call'(_____3, _____2, _____1)), 'true').
':-'('<module>:sys.process$has_predicate'('call'(_____2, _____1)), 'true').
':-'('<module>:sys.process:$init0'('env'(_AtExit, ___25), __36CutLevel), ','(','('true', ';'('->'('var'(___19), ','('g_inc'('$module_count', ___20), '='(___19, '$module'(___20, '.'('<module>:sys.process@0'('env'(___19, _AtExit)), '[]'), '.'(___19, '[]'))))), ','('='(___19, '$module'(___20, ___21, _)), ','('='('.'(___22, ___23), ___21), ','('setarg'(1, ___21, '<module>:sys.process@0'('env'(___19, _AtExit))), 'setarg'(2, ___21, '.'(___22, ___23))))))), '='(___25, ___19))).
':-'('<module>:sys.process:$sgn'(__36sgn, 'env'(_AtExit, ___25), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/process.mpl',0,0,0)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/process.mpl',31,0,0)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','(','(','(','(','(','(','(','(','(','(','(','('true', '<module>:sys.process:atom_fresh_[1818]'(_atom__fresh___911819_93, __36Pb, __36Pe)), '<module>:sys.process:atom_fresh_[1820]'(_atom__fresh___911821_93, __36Pb, __36Pe)), '<module>:sys.process:atom_fresh_[1822]'(_atom__fresh___911823_93, __36Pb, __36Pe)), '<module>:sys.process:atom_fresh_[1824]'(_atom__fresh___911825_93, __36Pb, __36Pe)), '<module>:sys.process:atom_fresh_[1826]'(_atom__fresh___911827_93, __36Pb, __36Pe)), '<module>:sys.process:atom_fresh_[1828]'(_atom__fresh___911829_93, __36Pb, __36Pe)), '<module>:sys.process:atom_fresh_[1830]'(_atom__fresh___911831_93, __36Pb, __36Pe)), '<module>:sys.process:atom_fresh_[1832]'(_atom__fresh___911833_93, __36Pb, __36Pe)), '<module>:sys.process:atom_fresh_[1834]'(_atom__fresh___911835_93, __36Pb, __36Pe)), '<module>:sys.process:atom_fresh_[1836]'(_atom__fresh___911837_93, __36Pb, __36Pe)), '<module>:sys.process:atom_fresh_[1838]'(_atom__fresh___911839_93, __36Pb, __36Pe)), '<module>:sys.process:atom_fresh_[1840]'(_atom__fresh___911841_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___911841_93, '.'(_atom__fresh___911839_93, '.'(_atom__fresh___911837_93, '.'(_atom__fresh___911835_93, '.'(_atom__fresh___911833_93, '.'(_atom__fresh___911831_93, '.'(_atom__fresh___911829_93, '.'(_atom__fresh___911827_93, '.'(_atom__fresh___911825_93, '.'(_atom__fresh___911823_93, '.'(_atom__fresh___911821_93, '.'(_atom__fresh___911819_93, '[]')))))))))))))))))).
':-'('<module>:sys.process:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:sys.process:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:sys.process:abort'('env'(_AtExit, ___25), __36CutLevel), ','('emop_call'(___25, 'flush_exit', 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/process.mpl\", line 56, from character 6 to 16'), ','('g_read'('kernel', '<module>:kernel'(___31)), '<module>:kernel:sys_abort$direct'(___31)))).
':-'('<module>:sys.process:abort$direct'(__36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:sys.process:abort'(__36env, __36CutLevel))).
':-'('<module>:sys.process:at_exit'(_M, 'env'(_AtExit, ___25), __36CutLevel), ','(';'('->'(','('g_read'('data.var', '<module>:data.var'(___12)), '<module>:data.var:check$direct'(_AtExit, ___12)), ','('='(_AtExit, ___15), ','('g_read'('data.ref.backtrackable', '<module>:data.ref.backtrackable'(___16)), '<module>:data.ref.backtrackable:new$direct'('[]', ___15, ___16)))), 'true'), ','('emop_call'(_AtExit, 'get'(___17), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/process.mpl\", line 19, from character 29 to 32'), 'emop_call'(_AtExit, 'set'('.'(_M, ___17)), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/process.mpl\", line 19, from character 13 to 16')))).
':-'('<module>:sys.process:at_exit$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:sys.process:at_exit'(_____1, __36env, __36CutLevel))).
':-'('<module>:sys.process:atom_fresh_[1818]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(call, 2, predicate, suspended([var('Command'),var('Out')],[call(scope,call,[var('Command'),none,var('Out')])]), __36pos))).
':-'('<module>:sys.process:atom_fresh_[1820]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(call, 3, predicate, '[]', __36pos))).
':-'('<module>:sys.process:atom_fresh_[1822]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(wait, 2, predicate, suspended([var('Pid'),var('Status')],[call(atom(kernel),sys_wait,[var('Pid'),var('Status')])]), __36pos))).
':-'('<module>:sys.process:atom_fresh_[1824]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(exec, 5, predicate, '[]', __36pos))).
':-'('<module>:sys.process:atom_fresh_[1826]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(exec, 4, predicate, '[]', __36pos))).
':-'('<module>:sys.process:atom_fresh_[1828]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(spawn, 2, predicate, suspended([var('Command'),var('Arguments')],[call(atom('sys.process'),spawn,[var('Command'),var('Arguments'),none])]), __36pos))).
':-'('<module>:sys.process:atom_fresh_[1830]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(spawn, 3, predicate, suspended([var('Command'),var('Arguments'),var('Error_code')],[call(atom(kernel),sys_spawn,[var('Command'),var('Arguments'),var('Error_code')])]), __36pos))).
':-'('<module>:sys.process:atom_fresh_[1832]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(abort, 0, predicate, [], __36pos))).
':-'('<module>:sys.process:atom_fresh_[1834]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(halt, 0, predicate, [], __36pos))).
':-'('<module>:sys.process:atom_fresh_[1836]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(exit, 1, predicate, '[]', __36pos))).
':-'('<module>:sys.process:atom_fresh_[1838]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(at_exit, 1, predicate, '[]', __36pos))).
':-'('<module>:sys.process:atom_fresh_[1840]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(exec_filename, 1, predicate, '[]', __36pos))).
':-'('<module>:sys.process:call'(_Command, _Out, 'env'(_AtExit, ___25), __36CutLevel), ','('g_read'('sys.process', '<module>:sys.process'(___78)), '<module>:sys.process:call$direct'(_Command, '', _Out, ___78))).
':-'('<module>:sys.process:call'(_Command, _In, _Out, 'env'(_AtExit, ___25), __36CutLevel), ','(','('g_read'('sys.process', '<module>:sys.process'(___56)), '<module>:sys.process:exec$direct'(_Command, _InStream, _OutStream, _ErrStream, _Pid, ___56)), ','('emop_call'(_InStream, 'print'(_In), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/process.mpl\", line 86, from character 15 to 20'), ','(','('='(_Out, ___60), ','('emop_call'(_OutStream, 'atom'(___58), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/process.mpl\", line 87, from character 46 to 50'), ','('g_read'('data.atom', '<module>:data.atom'(___61)), '<module>:data.atom:remove_suffix$direct'(___58, '\n', ___60, ___61)))), ','(';'('->'(','('='(___63, 'windows'), ','('g_read'('sys.os', '<module>:sys.os'(___64)), '<module>:sys.os:type$direct'(___63, ___64))), '='(_Status, 0)), ','('g_read'('sys.process', '<module>:sys.process'(___66)), '<module>:sys.process:wait$direct'(_Pid, _Status, ___66))), ','('emop_call'(_InStream, 'close', 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/process.mpl\", line 95, from character 15 to 20'), ','('emop_call'(_OutStream, 'close', 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/process.mpl\", line 96, from character 16 to 21'), ';'('->'('='(_Status, 0), 'emop_call'(_ErrStream, 'close', 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/process.mpl\", line 100, from character 19 to 24')), ','(','('='(_ErrMsg, ___70), ','('emop_call'(_ErrStream, 'atom'(___68), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/process.mpl\", line 102, from character 52 to 56'), ','('g_read'('data.atom', '<module>:data.atom'(___71)), '<module>:data.atom:remove_suffix$direct'(___68, '\n', ___70, ___71)))), ','('emop_call'(_ErrStream, 'close', 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/process.mpl\", line 103, from character 19 to 24'), 'throw'('error'('exec'(_Command, _ErrMsg, _Status), '::'('sys.process', 'call/3'))))))))))))).
':-'('<module>:sys.process:call$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:sys.process:call'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:sys.process:call$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:sys.process:call'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:sys.process:exec'(_Command, _In, _Out, _Err, 'env'(_AtExit, ___25), __36CutLevel), ','(','('g_read'('kernel', '<module>:kernel'(___37)), '<module>:kernel:sys_exec$direct'(_Command, _InFd, _OutFd, _ErrFd, ___37)), ','(','('='(_In, ___39), ','('g_read'('io.stream', '<module>:io.stream'(___40)), '<module>:io.stream:of_kernel_out$direct'(_InFd, ___39, ___40))), ','(','('='(_Out, ___41), ','('g_read'('io.stream', '<module>:io.stream'(___42)), '<module>:io.stream:of_kernel_in$direct'(_OutFd, ___41, ___42))), ','('='(_Err, ___43), ','('g_read'('io.stream', '<module>:io.stream'(___44)), '<module>:io.stream:of_kernel_in$direct'(_ErrFd, ___43, ___44))))))).
':-'('<module>:sys.process:exec'(_Command, _In, _Out, _Err, _Pid, 'env'(_AtExit, ___25), __36CutLevel), ','(','('g_read'('kernel', '<module>:kernel'(___46)), '<module>:kernel:sys_exec$direct'(_Command, _InFd, _OutFd, _ErrFd, _Pid, ___46)), ','(','('='(_In, ___48), ','('g_read'('io.stream', '<module>:io.stream'(___49)), '<module>:io.stream:of_kernel_out$direct'(_InFd, ___48, ___49))), ','(','('='(_Out, ___50), ','('g_read'('io.stream', '<module>:io.stream'(___51)), '<module>:io.stream:of_kernel_in$direct'(_OutFd, ___50, ___51))), ','('='(_Err, ___52), ','('g_read'('io.stream', '<module>:io.stream'(___53)), '<module>:io.stream:of_kernel_in$direct'(_ErrFd, ___52, ___53))))))).
':-'('<module>:sys.process:exec$direct'(_____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:sys.process:exec'(_____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:sys.process:exec$direct'(_____5, _____4, _____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:sys.process:exec'(_____5, _____4, _____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:sys.process:exec_filename'(_Filename, 'env'(_AtExit, ___25), __36CutLevel), ';'('->'(','('='(_Filename, ___6), ','('g_read'('sys.env', '<module>:sys.env'(___7)), '<module>:sys.env:{}$direct'('_', ___6, ___7))), 'true'), ','('='(_Filename, ___9), ','('g_read'('sys.cmdline', '<module>:sys.cmdline'(___10)), '<module>:sys.cmdline:{}$direct'(0, ___9, ___10))))).
':-'('<module>:sys.process:exec_filename$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:sys.process:exec_filename'(_____1, __36env, __36CutLevel))).
':-'('<module>:sys.process:exit'(_Error__code, 'env'(_AtExit, ___25), __36CutLevel), ','('emop_call'(___25, 'flush_exit', 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/process.mpl\", line 48, from character 6 to 16'), ','('g_read'('kernel', '<module>:kernel'(___27)), '<module>:kernel:sys_exit$direct'(_Error__code, ___27)))).
':-'('<module>:sys.process:exit$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:sys.process:exit'(_____1, __36env, __36CutLevel))).
':-'('<module>:sys.process:halt'('env'(_AtExit, ___25), __36CutLevel), ','('emop_call'(___25, 'flush_exit', 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/process.mpl\", line 52, from character 6 to 16'), ','('g_read'('kernel', '<module>:kernel'(___29)), '<module>:kernel:sys_halt$direct'(___29)))).
':-'('<module>:sys.process:halt$direct'(__36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:sys.process:halt'(__36env, __36CutLevel))).
':-'('<module>:sys.process:spawn'(_Command, _Arguments, 'env'(_AtExit, ___25), __36CutLevel), ','('g_read'('sys.process', '<module>:sys.process'(___35)), '<module>:sys.process:spawn$direct'(_Command, _Arguments, 0, ___35))).
':-'('<module>:sys.process:spawn'(_Command, _Arguments, _Error__code, 'env'(_AtExit, ___25), __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___33)), '<module>:kernel:sys_spawn$direct'(_Command, _Arguments, _Error__code, ___33))).
':-'('<module>:sys.process:spawn$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:sys.process:spawn'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:sys.process:spawn$direct'(_____3, _____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:sys.process:spawn'(_____3, _____2, _____1, __36env, __36CutLevel))).
':-'('<module>:sys.process:wait'(_Pid, _Status, 'env'(_AtExit, ___25), __36CutLevel), ','('g_read'('kernel', '<module>:kernel'(___55)), '<module>:kernel:sys_wait$direct'(_Pid, _Status, ___55))).
':-'('<module>:sys.process:wait$direct'(_____2, _____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:sys.process:wait'(_____2, _____1, __36env, __36CutLevel))).
':-'('<module>:sys.process@0'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:sys.process@0:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:sys.process@0'('flush_exit', __36env, _, __36CutLevel), ','('!', '<module>:sys.process@0:flush_exit'(__36env, __36CutLevel))).
':-'('<module>:sys.process@0'(__36t, __36env, __36pos, __36CutLevel), '<module>:sys.process@0$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:sys.process@0$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:sys.process@0$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:sys.process@0$has_predicate'('flush_exit'), 'true').
':-'('<module>:sys.process@0:$sgn'(__36sgn, 'env'(___24, _AtExit), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/process.mpl',377,20,366)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/process.mpl',385,20,366)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:sys.process@0:atom_fresh_[1842]'(_atom__fresh___911843_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___911843_93, '[]'))))))).
':-'('<module>:sys.process@0:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:sys.process@0:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:sys.process@0:atom_fresh_[1842]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(flush_exit, 0, predicate, suspended([],[call(scope,catch,[none,var('E'),none])]), __36pos))).
':-'('<module>:sys.process@0:flush_exit'('env'(___24, _AtExit), __36CutLevel), 'catch'(';'('->'(','('g_read'('data.var', '<module>:data.var'(___80)), '<module>:data.var:check$direct'(_AtExit, ___80)), 'true'), ';'('->'(','(','('emop_call'(_AtExit, 'get'(___82), 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/process.mpl\", line 29, from character 37 to 40'), ','('true', ';'('->'('var'(___83), ','('g_inc'('$module_count', ___84), '='(___83, '$module'(___84, '.'('<module>:sys.process@1'('env'(___83, _AtExit, _E, ___24)), '[]'), '.'(___83, '[]'))))), ','('='(___83, '$module'(___84, ___85, _)), ','('='('.'(___86, ___87), ___85), ','('setarg'(1, ___85, '<module>:sys.process@1'('env'(___83, _AtExit, _E, ___24))), 'setarg'(2, ___85, '.'(___86, ___87)))))))), ','('g_read'('data.list', '<module>:data.list'(___89)), '<module>:data.list:iter$direct'(___82, ___83, ___89))), 'true'), ','(','('g_read'('io.err', '<module>:io.err'(___92)), '<module>:io.err:print_endline$direct'('[Error] Failure on exit', ___92)), ','('g_read'('kernel', '<module>:kernel'(___94)), '<module>:kernel:sys_exit$direct'(1, ___94))))), _E, ','(','('g_read'('io.err', '<module>:io.err'(___99)), '<module>:io.err:format$direct'('[Error] Uncaught exception on exit: ~p\n', '.'(_E, '[]'), ___99)), ','('g_read'('kernel', '<module>:kernel'(___101)), '<module>:kernel:sys_exit$direct'(1, ___101))))).
':-'('<module>:sys.process@0:flush_exit$direct'(__36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:sys.process@0:flush_exit'(__36env, __36CutLevel))).
':-'('<module>:sys.process@1'('$sgn'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:sys.process@1:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:sys.process@1'('do'(_____1), __36env, _, __36CutLevel), ','('!', '<module>:sys.process@1:do'(_____1, __36env, __36CutLevel))).
':-'('<module>:sys.process@1'(__36t, __36env, __36pos, __36CutLevel), '<module>:sys.process@1$dynamic'(__36t, __36env, __36pos, __36CutLevel)).
':-'('<module>:sys.process@1$dynamic'(__36t, _, __36pos, __36CutLevel), ','('functor'(__36t, __36f, __36n), 'throw'('error'('unknown_predicate'('/'(__36f, __36n)), __36pos)))).
':-'('<module>:sys.process@1$has_predicate'('$sgn'(_____1)), 'true').
':-'('<module>:sys.process@1$has_predicate'('do'(_____1)), 'true').
':-'('<module>:sys.process@1:$sgn'(__36sgn, 'env'(___88, _AtExit, _E, ___24), __36CutLevel), ','('='(__36Pb, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/process.mpl',548,28,523)), ','('='(__36Pe, pos('/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/process.mpl',566,28,523)), ','('='(__36pos, 'file'(__36Pb, __36Pe)), ','(','('true', '<module>:sys.process@1:atom_fresh_[1844]'(_atom__fresh___911845_93, __36Pb, __36Pe)), '='(__36sgn, '.'(_atom__fresh___911845_93, '[]'))))))).
':-'('<module>:sys.process@1:$sgn$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:sys.process@1:$sgn'(_____1, __36env, __36CutLevel))).
':-'('<module>:sys.process@1:atom_fresh_[1844]'(__36s, __36Pb, __36Pe), '='(__36s, 'symbol'(do, 1, predicate, '[]', __36pos))).
':-'('<module>:sys.process@1:do'(_M, 'env'(___88, _AtExit, _E, ___24), __36CutLevel), 'emop_call'(_M, 'do', 'File \"/afs/inria.fr/rocq/home/heberges/tmartine/.public/www/emop/svn/trunk/lib/sys/process.mpl\", line 31, from character 23 to 25')).
':-'('<module>:sys.process@1:do$direct'(_____1, __36env), ','(','('!', '='(__36CutLevel, '$cut')), '<module>:sys.process@1:do'(_____1, __36env, __36CutLevel))).
':-'('sys.process@init', ','('true', ','('g_link'('sys.process', '<module>:sys.process'('env'(_AtExit, ___25))), '<module>:sys.process:$init0'('env'(_AtExit, ___25), __36CutLevel)))).
